#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 2228
#define SYMBOL_COUNT 156
#define ALIAS_COUNT 1
#define TOKEN_COUNT 97
#define EXTERNAL_TOKEN_COUNT 15
#define MAX_ALIAS_SEQUENCE_LENGTH 10

enum {
  sym_word = 1,
  anon_sym_LF = 2,
  anon_sym_for = 3,
  anon_sym_in = 4,
  anon_sym_LPAREN_LPAREN = 5,
  anon_sym_RPAREN_RPAREN = 6,
  anon_sym_SEMI = 7,
  anon_sym_while = 8,
  anon_sym_do = 9,
  anon_sym_done = 10,
  anon_sym_if = 11,
  anon_sym_then = 12,
  anon_sym_fi = 13,
  anon_sym_elif = 14,
  anon_sym_else = 15,
  anon_sym_case = 16,
  anon_sym_esac = 17,
  anon_sym_PIPE = 18,
  anon_sym_RPAREN = 19,
  anon_sym_SEMI_SEMI = 20,
  anon_sym_function = 21,
  anon_sym_LPAREN = 22,
  anon_sym_LBRACE = 23,
  anon_sym_RBRACE = 24,
  anon_sym_PIPE_AMP = 25,
  anon_sym_AMP_AMP = 26,
  anon_sym_PIPE_PIPE = 27,
  anon_sym_BANG = 28,
  anon_sym_LBRACK = 29,
  anon_sym_RBRACK = 30,
  anon_sym_LBRACK_LBRACK = 31,
  anon_sym_RBRACK_RBRACK = 32,
  anon_sym_declare = 33,
  anon_sym_typeset = 34,
  anon_sym_export = 35,
  anon_sym_readonly = 36,
  anon_sym_local = 37,
  anon_sym_unset = 38,
  anon_sym_unsetenv = 39,
  anon_sym_EQ_TILDE = 40,
  anon_sym_EQ_EQ = 41,
  anon_sym_EQ = 42,
  anon_sym_PLUS_EQ = 43,
  anon_sym_LT = 44,
  anon_sym_GT = 45,
  anon_sym_GT_GT = 46,
  anon_sym_AMP_GT = 47,
  anon_sym_AMP_GT_GT = 48,
  anon_sym_LT_AMP = 49,
  anon_sym_GT_AMP = 50,
  anon_sym_LT_LT = 51,
  anon_sym_LT_LT_DASH = 52,
  anon_sym_LT_LT_LT = 53,
  anon_sym_BANG_EQ = 54,
  anon_sym_PLUS = 55,
  anon_sym_DASH = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_LT_EQ = 58,
  anon_sym_GT_EQ = 59,
  anon_sym_PLUS_PLUS = 60,
  anon_sym_DASH_DASH = 61,
  anon_sym_DOLLAR = 62,
  sym__special_character = 63,
  anon_sym_DQUOTE = 64,
  sym__string_content = 65,
  sym_raw_string = 66,
  anon_sym_POUND = 67,
  anon_sym_DOLLAR_LBRACE = 68,
  anon_sym_SLASH = 69,
  anon_sym_COLON = 70,
  anon_sym_COLON_QMARK = 71,
  anon_sym_COLON_DASH = 72,
  anon_sym_PERCENT = 73,
  anon_sym_DOLLAR_LPAREN = 74,
  anon_sym_BQUOTE = 75,
  anon_sym_LT_LPAREN = 76,
  anon_sym_GT_LPAREN = 77,
  sym_comment = 78,
  aux_sym__simple_variable_name_token1 = 79,
  anon_sym_STAR = 80,
  anon_sym_AT = 81,
  anon_sym_QMARK = 82,
  anon_sym_0 = 83,
  anon_sym__ = 84,
  sym_test_operator = 85,
  anon_sym_AMP = 86,
  sym_heredoc_start = 87,
  sym__simple_heredoc_body = 88,
  sym__heredoc_body_beginning = 89,
  sym__heredoc_body_middle = 90,
  sym__heredoc_body_end = 91,
  sym_file_descriptor = 92,
  sym__empty_value = 93,
  sym__concat = 94,
  sym_variable_name = 95,
  sym_regex = 96,
  sym_program = 97,
  sym__statements = 98,
  sym__terminated_statement = 99,
  sym_redirected_statement = 100,
  sym_for_statement = 101,
  sym_c_style_for_statement = 102,
  sym_while_statement = 103,
  sym_do_group = 104,
  sym_if_statement = 105,
  sym_elif_clause = 106,
  sym_else_clause = 107,
  sym_case_statement = 108,
  sym_case_item = 109,
  sym_last_case_item = 110,
  sym_function_definition = 111,
  sym_compound_statement = 112,
  sym_subshell = 113,
  sym_pipeline = 114,
  sym_list = 115,
  sym_negated_command = 116,
  sym_test_command = 117,
  sym_declaration_command = 118,
  sym_unset_command = 119,
  sym_command = 120,
  sym_command_name = 121,
  sym_variable_assignment = 122,
  sym_subscript = 123,
  sym_file_redirect = 124,
  sym_heredoc_redirect = 125,
  sym_heredoc_body = 126,
  sym_herestring_redirect = 127,
  sym__expression = 128,
  sym_binary_expression = 129,
  sym_unary_expression = 130,
  sym_postfix_expression = 131,
  sym_parenthesized_expression = 132,
  sym_concatenation = 133,
  sym_string = 134,
  sym_array = 135,
  sym_simple_expansion = 136,
  sym_string_expansion = 137,
  sym_expansion = 138,
  sym_command_substitution = 139,
  sym_process_substitution = 140,
  aux_sym__statements_repeat1 = 141,
  aux_sym_redirected_statement_repeat1 = 142,
  aux_sym_for_statement_repeat1 = 143,
  aux_sym_if_statement_repeat1 = 144,
  aux_sym_case_statement_repeat1 = 145,
  aux_sym_case_item_repeat1 = 146,
  aux_sym_declaration_command_repeat1 = 147,
  aux_sym_unset_command_repeat1 = 148,
  aux_sym_command_repeat1 = 149,
  aux_sym_command_repeat2 = 150,
  aux_sym_heredoc_body_repeat1 = 151,
  aux_sym__literal_repeat1 = 152,
  aux_sym_concatenation_repeat1 = 153,
  aux_sym_string_repeat1 = 154,
  aux_sym_expansion_repeat1 = 155,
  alias_sym_special_variable_name = 156,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_word] = "word",
  [anon_sym_LF] = "\n",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_LPAREN_LPAREN] = "((",
  [anon_sym_RPAREN_RPAREN] = "))",
  [anon_sym_SEMI] = ";",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DOLLAR] = "$",
  [sym__special_character] = "_special_character",
  [anon_sym_DQUOTE] = "\"",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym__simple_variable_name_token1] = "variable_name",
  [anon_sym_STAR] = "special_variable_name",
  [anon_sym_AT] = "special_variable_name",
  [anon_sym_QMARK] = "special_variable_name",
  [anon_sym_0] = "special_variable_name",
  [anon_sym__] = "special_variable_name",
  [sym_test_operator] = "test_operator",
  [anon_sym_AMP] = "&",
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [sym_regex] = "regex",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_redirected_statement] = "redirected_statement",
  [sym_for_statement] = "for_statement",
  [sym_c_style_for_statement] = "c_style_for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_negated_command] = "negated_command",
  [sym_test_command] = "test_command",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_postfix_expression] = "postfix_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_redirected_statement_repeat1] = "redirected_statement_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym__literal_repeat1] = "_literal_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_special_variable_name] = "special_variable_name",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__special_character] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__simple_variable_name_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = true,
  },
  [sym_test_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_redirected_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_c_style_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_command] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_redirected_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[8][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = sym_word,
  },
  [2] = {
    [1] = sym_word,
  },
  [3] = {
    [1] = alias_sym_special_variable_name,
  },
  [4] = {
    [2] = sym_word,
  },
  [5] = {
    [2] = alias_sym_special_variable_name,
  },
  [6] = {
    [3] = sym_word,
  },
  [7] = {
    [4] = sym_word,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(24);
      if (lookahead == ']')
        ADVANCE(25);
      if (lookahead == '_')
        ADVANCE(26);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == 'i')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(34);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(36);
      if (lookahead == '{')
        ADVANCE(37);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(38);
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 8:
      if (lookahead == '\'')
        ADVANCE(40);
      if (lookahead != 0)
        ADVANCE(8);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '(')
        ADVANCE(41);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      if (lookahead == ')')
        ADVANCE(42);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(43);
      if (lookahead == '=')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(45);
      if (lookahead == '=')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(48);
      if (lookahead == '?')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(50);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '(')
        ADVANCE(52);
      if (lookahead == '<')
        ADVANCE(53);
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(57);
      if (lookahead == '(')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(60);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(61);
      END_STATE();
    case 24:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(62);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(63);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 's')
        ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'n')
        ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(66);
      if (lookahead == '|')
        ADVANCE(67);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 35:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(33);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(68);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LPAREN_LPAREN);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_RPAREN_RPAREN);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(69);
      if (lookahead == '<')
        ADVANCE(70);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 62:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(24);
      if (lookahead == ']')
        ADVANCE(25);
      if (lookahead == '_')
        ADVANCE(26);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == 'i')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(62);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'a')
        ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 73:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(78);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(81);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(73);
      if (lookahead != 0 &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(75);
      END_STATE();
    case 76:
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 78:
      if (lookahead == ';')
        ADVANCE(50);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '(')
        ADVANCE(52);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(57);
      if (lookahead == '(')
        ADVANCE(58);
      if (lookahead == '>')
        ADVANCE(60);
      END_STATE();
    case 81:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(83);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym__special_character);
      END_STATE();
    case 83:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(78);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(81);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(83);
      if (lookahead != 0 &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 84:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(84);
      if (lookahead != 0 &&
          lookahead != ';')
        ADVANCE(33);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 86:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(84);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 88:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(89);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(91);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(89);
      if (lookahead == '\\')
        ADVANCE(91);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '(')
        ADVANCE(52);
      if (lookahead == '<')
        ADVANCE(53);
      END_STATE();
    case 91:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(93);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 93:
      if (lookahead == '\n')
        ADVANCE(89);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(91);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 94:
      if (lookahead == '!')
        ADVANCE(95);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(107);
      if (lookahead == ']')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '|')
        ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(94);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(112);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 97:
      if (lookahead == '&')
        ADVANCE(38);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(113);
      if (lookahead == '=')
        ADVANCE(114);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(116);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(117);
      if (lookahead == '~')
        ADVANCE(118);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(59);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 107:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(94);
      END_STATE();
    case 108:
      if (lookahead == ']')
        ADVANCE(63);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(67);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 119:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(120);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(122);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(119);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(120);
      if (lookahead == '\\')
        ADVANCE(122);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 122:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 123:
      if (lookahead == '\n')
        ADVANCE(120);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(122);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 124:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(125);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(124);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 125:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(124);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 126:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ')')
        ADVANCE(127);
      if (lookahead == '-')
        ADVANCE(128);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(131);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(126);
      if (lookahead != 0 &&
          lookahead != '&' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 127:
      if (lookahead == ')')
        ADVANCE(42);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 129:
      if (lookahead == '(')
        ADVANCE(52);
      END_STATE();
    case 130:
      if (lookahead == '(')
        ADVANCE(58);
      END_STATE();
    case 131:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(126);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 132:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(133);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 133:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 134:
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '+')
        ADVANCE(135);
      if (lookahead == '=')
        ADVANCE(136);
      if (lookahead == '[')
        ADVANCE(137);
      if (lookahead == '\\')
        SKIP(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      END_STATE();
    case 135:
      if (lookahead == '=')
        ADVANCE(114);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 138:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      END_STATE();
    case 139:
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '(')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(143);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 140:
      if (lookahead == '(')
        ADVANCE(41);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(60);
      END_STATE();
    case 143:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(139);
      END_STATE();
    case 144:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(145);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(146);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(147);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(148);
      if (lookahead == '\\')
        ADVANCE(149);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(145);
      END_STATE();
    case 146:
      if (lookahead == '\n')
        ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(147);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(145);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(146);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(147);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(150);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(148);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n')
        ADVANCE(148);
      if (lookahead != 0)
        ADVANCE(145);
      END_STATE();
    case 150:
      if (lookahead == '\n')
        ADVANCE(148);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 151:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(154);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(53);
      END_STATE();
    case 154:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(151);
      END_STATE();
    case 155:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(156);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(155);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(156);
      if (lookahead == '\\')
        ADVANCE(157);
      END_STATE();
    case 157:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(158);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 158:
      if (lookahead == '\n')
        ADVANCE(156);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(158);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 159:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(162);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(159);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 162:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(159);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 163:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(127);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(165);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(166);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(163);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 164:
      if (lookahead == '=')
        ADVANCE(112);
      END_STATE();
    case 165:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(163);
      END_STATE();
    case 166:
      if (lookahead == '|')
        ADVANCE(67);
      END_STATE();
    case 167:
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ';')
        ADVANCE(78);
      if (lookahead == '\\')
        SKIP(168);
      if (lookahead == 'e')
        ADVANCE(169);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(167);
      END_STATE();
    case 168:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(167);
      END_STATE();
    case 169:
      if (lookahead == 's')
        ADVANCE(170);
      END_STATE();
    case 170:
      if (lookahead == 'a')
        ADVANCE(171);
      END_STATE();
    case 171:
      if (lookahead == 'c')
        ADVANCE(172);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 173:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(174);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(169);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      END_STATE();
    case 174:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      END_STATE();
    case 175:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(176);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(177);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == 'i')
        ADVANCE(178);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 177:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      END_STATE();
    case 178:
      if (lookahead == 'n')
        ADVANCE(179);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 180:
      if (lookahead == '!')
        ADVANCE(181);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(182);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        ADVANCE(183);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(184);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '`')
        ADVANCE(148);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 183:
      if (lookahead == '\n')
        ADVANCE(184);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(184);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '!')
        ADVANCE(181);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(182);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        ADVANCE(183);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(184);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '`')
        ADVANCE(148);
      END_STATE();
    case 185:
      if (lookahead == '\n')
        ADVANCE(186);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(176);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == '-')
        ADVANCE(128);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(187);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(185);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(186);
      if (lookahead == '-')
        ADVANCE(128);
      if (lookahead == '\\')
        ADVANCE(187);
      END_STATE();
    case 187:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(185);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 188:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(189);
      if (lookahead == ']')
        ADVANCE(190);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(166);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(188);
      END_STATE();
    case 189:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(188);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 191:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(192);
      if (lookahead == ']')
        ADVANCE(193);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(166);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(191);
      END_STATE();
    case 192:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(191);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym__special_character);
      if (lookahead == ']')
        ADVANCE(63);
      END_STATE();
    case 194:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(195);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(194);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 195:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(194);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 196:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(197);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(196);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 197:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(196);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 198:
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '\\')
        SKIP(199);
      if (lookahead == 'i')
        ADVANCE(178);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(198);
      END_STATE();
    case 199:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(198);
      END_STATE();
    case 200:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(201);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(166);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(200);
      END_STATE();
    case 201:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(200);
      END_STATE();
    case 202:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(203);
      if (lookahead == ']')
        ADVANCE(193);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(110);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(202);
      END_STATE();
    case 203:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(202);
      END_STATE();
    case 204:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '\\')
        SKIP(205);
      if (lookahead == ']')
        ADVANCE(108);
      if (lookahead == '|')
        ADVANCE(166);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(204);
      END_STATE();
    case 205:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(204);
      END_STATE();
    case 206:
      if (lookahead == '\n')
        ADVANCE(207);
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(208);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(209);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(166);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(206);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(207);
      if (lookahead == '-')
        ADVANCE(100);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(38);
      END_STATE();
    case 209:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(206);
      END_STATE();
    case 210:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(176);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(211);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      END_STATE();
    case 211:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(210);
      END_STATE();
    case 212:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(213);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(176);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(214);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(213);
      if (lookahead == '\\')
        ADVANCE(214);
      END_STATE();
    case 214:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 215:
      if (lookahead == '\n')
        ADVANCE(213);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(176);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(214);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 216:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(217);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(219);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(220);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(217);
      if (lookahead == '\\')
        ADVANCE(219);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 219:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 221:
      if (lookahead == '\n')
        ADVANCE(217);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(219);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(220);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 222:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(223);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(222);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 223:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(222);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 224:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(225);
      if (lookahead == ']')
        ADVANCE(190);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 225:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 226:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(227);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(220);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 227:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 228:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(229);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(230);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(220);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(229);
      if (lookahead == '\\')
        ADVANCE(230);
      END_STATE();
    case 230:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 231:
      if (lookahead == '\n')
        ADVANCE(229);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(230);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(220);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 232:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '!')
        ADVANCE(181);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(176);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(182);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(233);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == 'i')
        ADVANCE(234);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(232);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 233:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(232);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'n')
        ADVANCE(235);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_in);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 236:
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == ';')
        ADVANCE(237);
      if (lookahead == '\\')
        ADVANCE(238);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '|' &&
          lookahead != '}')
        ADVANCE(33);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 238:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(236);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 239:
      if (lookahead == '!')
        ADVANCE(95);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(240);
      if (lookahead == ']')
        ADVANCE(190);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '|')
        ADVANCE(166);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 240:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      END_STATE();
    case 241:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(242);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(220);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 242:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 243:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(78);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(244);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(243);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 244:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(243);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 245:
      if (lookahead == '\n')
        ADVANCE(207);
      if (lookahead == '!')
        ADVANCE(95);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(208);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(246);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '|')
        ADVANCE(166);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(245);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 246:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(245);
      END_STATE();
    case 247:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '!')
        ADVANCE(181);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(182);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(248);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 248:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      END_STATE();
    case 249:
      if (lookahead == '!')
        ADVANCE(181);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(182);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(250);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 250:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      END_STATE();
    case 251:
      if (lookahead == '\n')
        ADVANCE(252);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(253);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(254);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(33);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(252);
      if (lookahead == '\\')
        ADVANCE(253);
      END_STATE();
    case 253:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 's')
        ADVANCE(255);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'a')
        ADVANCE(256);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(257);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 258:
      if (lookahead == '\n')
        ADVANCE(259);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(260);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      if (lookahead != 0 &&
          lookahead != ')')
        ADVANCE(33);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(259);
      if (lookahead == '\\')
        ADVANCE(260);
      END_STATE();
    case 260:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 261:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(262);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == 'e')
        ADVANCE(169);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      END_STATE();
    case 262:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      END_STATE();
    case 263:
      if (lookahead == '\n')
        ADVANCE(264);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(265);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(263);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(33);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(264);
      if (lookahead == '\\')
        ADVANCE(265);
      END_STATE();
    case 265:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(263);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 266:
      if (lookahead == '\n')
        ADVANCE(267);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(176);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(268);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(220);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(267);
      if (lookahead == '\\')
        ADVANCE(268);
      END_STATE();
    case 268:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 269:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(176);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(270);
      if (lookahead == 'e')
        ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(269);
      END_STATE();
    case 270:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(269);
      END_STATE();
    case 271:
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(273);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(220);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(254);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(271);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(33);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '\\')
        ADVANCE(273);
      END_STATE();
    case 273:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(271);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 274:
      if (lookahead == '\n')
        ADVANCE(275);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(276);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '_')
        ADVANCE(220);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(254);
      if (lookahead == '{')
        ADVANCE(82);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(274);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(33);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(275);
      if (lookahead == '\\')
        ADVANCE(276);
      END_STATE();
    case 276:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(274);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 277:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '!')
        ADVANCE(181);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(182);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(278);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == 'e')
        ADVANCE(279);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(277);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 278:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(277);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 's')
        ADVANCE(280);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'a')
        ADVANCE(281);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'c')
        ADVANCE(282);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_esac);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == '\\')
        SKIP(1);
      if (lookahead == 'c')
        ADVANCE(2);
      if (lookahead == 'd')
        ADVANCE(3);
      if (lookahead == 'e')
        ADVANCE(4);
      if (lookahead == 'f')
        ADVANCE(5);
      if (lookahead == 'i')
        ADVANCE(6);
      if (lookahead == 'l')
        ADVANCE(7);
      if (lookahead == 'r')
        ADVANCE(8);
      if (lookahead == 't')
        ADVANCE(9);
      if (lookahead == 'u')
        ADVANCE(10);
      if (lookahead == 'w')
        ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      END_STATE();
    case 2:
      if (lookahead == 'a')
        ADVANCE(12);
      END_STATE();
    case 3:
      if (lookahead == 'e')
        ADVANCE(13);
      if (lookahead == 'o')
        ADVANCE(14);
      END_STATE();
    case 4:
      if (lookahead == 'l')
        ADVANCE(15);
      if (lookahead == 'x')
        ADVANCE(16);
      END_STATE();
    case 5:
      if (lookahead == 'i')
        ADVANCE(17);
      if (lookahead == 'o')
        ADVANCE(18);
      if (lookahead == 'u')
        ADVANCE(19);
      END_STATE();
    case 6:
      if (lookahead == 'f')
        ADVANCE(20);
      END_STATE();
    case 7:
      if (lookahead == 'o')
        ADVANCE(21);
      END_STATE();
    case 8:
      if (lookahead == 'e')
        ADVANCE(22);
      END_STATE();
    case 9:
      if (lookahead == 'h')
        ADVANCE(23);
      if (lookahead == 'y')
        ADVANCE(24);
      END_STATE();
    case 10:
      if (lookahead == 'n')
        ADVANCE(25);
      END_STATE();
    case 11:
      if (lookahead == 'h')
        ADVANCE(26);
      END_STATE();
    case 12:
      if (lookahead == 's')
        ADVANCE(27);
      END_STATE();
    case 13:
      if (lookahead == 'c')
        ADVANCE(28);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(29);
      END_STATE();
    case 15:
      if (lookahead == 'i')
        ADVANCE(30);
      if (lookahead == 's')
        ADVANCE(31);
      END_STATE();
    case 16:
      if (lookahead == 'p')
        ADVANCE(32);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 18:
      if (lookahead == 'r')
        ADVANCE(33);
      END_STATE();
    case 19:
      if (lookahead == 'n')
        ADVANCE(34);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 21:
      if (lookahead == 'c')
        ADVANCE(35);
      END_STATE();
    case 22:
      if (lookahead == 'a')
        ADVANCE(36);
      END_STATE();
    case 23:
      if (lookahead == 'e')
        ADVANCE(37);
      END_STATE();
    case 24:
      if (lookahead == 'p')
        ADVANCE(38);
      END_STATE();
    case 25:
      if (lookahead == 's')
        ADVANCE(39);
      END_STATE();
    case 26:
      if (lookahead == 'i')
        ADVANCE(40);
      END_STATE();
    case 27:
      if (lookahead == 'e')
        ADVANCE(41);
      END_STATE();
    case 28:
      if (lookahead == 'l')
        ADVANCE(42);
      END_STATE();
    case 29:
      if (lookahead == 'e')
        ADVANCE(43);
      END_STATE();
    case 30:
      if (lookahead == 'f')
        ADVANCE(44);
      END_STATE();
    case 31:
      if (lookahead == 'e')
        ADVANCE(45);
      END_STATE();
    case 32:
      if (lookahead == 'o')
        ADVANCE(46);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 34:
      if (lookahead == 'c')
        ADVANCE(47);
      END_STATE();
    case 35:
      if (lookahead == 'a')
        ADVANCE(48);
      END_STATE();
    case 36:
      if (lookahead == 'd')
        ADVANCE(49);
      END_STATE();
    case 37:
      if (lookahead == 'n')
        ADVANCE(50);
      END_STATE();
    case 38:
      if (lookahead == 'e')
        ADVANCE(51);
      END_STATE();
    case 39:
      if (lookahead == 'e')
        ADVANCE(52);
      END_STATE();
    case 40:
      if (lookahead == 'l')
        ADVANCE(53);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 42:
      if (lookahead == 'a')
        ADVANCE(54);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 46:
      if (lookahead == 'r')
        ADVANCE(55);
      END_STATE();
    case 47:
      if (lookahead == 't')
        ADVANCE(56);
      END_STATE();
    case 48:
      if (lookahead == 'l')
        ADVANCE(57);
      END_STATE();
    case 49:
      if (lookahead == 'o')
        ADVANCE(58);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 51:
      if (lookahead == 's')
        ADVANCE(59);
      END_STATE();
    case 52:
      if (lookahead == 't')
        ADVANCE(60);
      END_STATE();
    case 53:
      if (lookahead == 'e')
        ADVANCE(61);
      END_STATE();
    case 54:
      if (lookahead == 'r')
        ADVANCE(62);
      END_STATE();
    case 55:
      if (lookahead == 't')
        ADVANCE(63);
      END_STATE();
    case 56:
      if (lookahead == 'i')
        ADVANCE(64);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 58:
      if (lookahead == 'n')
        ADVANCE(65);
      END_STATE();
    case 59:
      if (lookahead == 'e')
        ADVANCE(66);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(67);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 62:
      if (lookahead == 'e')
        ADVANCE(68);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 64:
      if (lookahead == 'o')
        ADVANCE(69);
      END_STATE();
    case 65:
      if (lookahead == 'l')
        ADVANCE(70);
      END_STATE();
    case 66:
      if (lookahead == 't')
        ADVANCE(71);
      END_STATE();
    case 67:
      if (lookahead == 'n')
        ADVANCE(72);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 69:
      if (lookahead == 'n')
        ADVANCE(73);
      END_STATE();
    case 70:
      if (lookahead == 'y')
        ADVANCE(74);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_typeset);
      END_STATE();
    case 72:
      if (lookahead == 'v')
        ADVANCE(75);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 73, .external_lex_state = 2},
  [2] = {.lex_state = 73, .external_lex_state = 2},
  [3] = {.lex_state = 84},
  [4] = {.lex_state = 88, .external_lex_state = 3},
  [5] = {.lex_state = 88, .external_lex_state = 4},
  [6] = {.lex_state = 94},
  [7] = {.lex_state = 73, .external_lex_state = 2},
  [8] = {.lex_state = 73, .external_lex_state = 2},
  [9] = {.lex_state = 94, .external_lex_state = 5},
  [10] = {.lex_state = 84},
  [11] = {.lex_state = 119, .external_lex_state = 6},
  [12] = {.lex_state = 124, .external_lex_state = 7},
  [13] = {.lex_state = 119, .external_lex_state = 6},
  [14] = {.lex_state = 73, .external_lex_state = 2},
  [15] = {.lex_state = 84},
  [16] = {.lex_state = 126},
  [17] = {.lex_state = 119, .external_lex_state = 6},
  [18] = {.lex_state = 73, .external_lex_state = 2},
  [19] = {.lex_state = 132, .external_lex_state = 2},
  [20] = {.lex_state = 134},
  [21] = {.lex_state = 139},
  [22] = {.lex_state = 144},
  [23] = {.lex_state = 139},
  [24] = {.lex_state = 73, .external_lex_state = 2},
  [25] = {.lex_state = 126},
  [26] = {.lex_state = 126},
  [27] = {.lex_state = 119, .external_lex_state = 4},
  [28] = {.lex_state = 151, .external_lex_state = 4},
  [29] = {.lex_state = 155, .external_lex_state = 3},
  [30] = {.lex_state = 134},
  [31] = {.lex_state = 119, .external_lex_state = 4},
  [32] = {.lex_state = 73, .external_lex_state = 2},
  [33] = {.lex_state = 73},
  [34] = {.lex_state = 84, .external_lex_state = 2},
  [35] = {.lex_state = 73},
  [36] = {.lex_state = 119, .external_lex_state = 4},
  [37] = {.lex_state = 88, .external_lex_state = 3},
  [38] = {.lex_state = 88, .external_lex_state = 4},
  [39] = {.lex_state = 119, .external_lex_state = 6},
  [40] = {.lex_state = 119, .external_lex_state = 6},
  [41] = {.lex_state = 119, .external_lex_state = 6},
  [42] = {.lex_state = 132, .external_lex_state = 2},
  [43] = {.lex_state = 134},
  [44] = {.lex_state = 119, .external_lex_state = 4},
  [45] = {.lex_state = 151, .external_lex_state = 4},
  [46] = {.lex_state = 155, .external_lex_state = 3},
  [47] = {.lex_state = 134},
  [48] = {.lex_state = 73, .external_lex_state = 2},
  [49] = {.lex_state = 84, .external_lex_state = 2},
  [50] = {.lex_state = 73},
  [51] = {.lex_state = 119, .external_lex_state = 4},
  [52] = {.lex_state = 73, .external_lex_state = 2},
  [53] = {.lex_state = 144},
  [54] = {.lex_state = 84, .external_lex_state = 8},
  [55] = {.lex_state = 73, .external_lex_state = 2},
  [56] = {.lex_state = 94},
  [57] = {.lex_state = 73, .external_lex_state = 2},
  [58] = {.lex_state = 84, .external_lex_state = 8},
  [59] = {.lex_state = 94, .external_lex_state = 5},
  [60] = {.lex_state = 84, .external_lex_state = 2},
  [61] = {.lex_state = 84, .external_lex_state = 2},
  [62] = {.lex_state = 73, .external_lex_state = 2},
  [63] = {.lex_state = 144},
  [64] = {.lex_state = 88, .external_lex_state = 9},
  [65] = {.lex_state = 73, .external_lex_state = 2},
  [66] = {.lex_state = 134},
  [67] = {.lex_state = 94},
  [68] = {.lex_state = 73, .external_lex_state = 2},
  [69] = {.lex_state = 88, .external_lex_state = 9},
  [70] = {.lex_state = 94, .external_lex_state = 5},
  [71] = {.lex_state = 88, .external_lex_state = 3},
  [72] = {.lex_state = 88, .external_lex_state = 3},
  [73] = {.lex_state = 134},
  [74] = {.lex_state = 73, .external_lex_state = 2},
  [75] = {.lex_state = 144},
  [76] = {.lex_state = 88, .external_lex_state = 6},
  [77] = {.lex_state = 73, .external_lex_state = 2},
  [78] = {.lex_state = 94},
  [79] = {.lex_state = 73, .external_lex_state = 2},
  [80] = {.lex_state = 88, .external_lex_state = 6},
  [81] = {.lex_state = 94, .external_lex_state = 5},
  [82] = {.lex_state = 88, .external_lex_state = 4},
  [83] = {.lex_state = 88, .external_lex_state = 4},
  [84] = {.lex_state = 119, .external_lex_state = 6},
  [85] = {.lex_state = 119, .external_lex_state = 6},
  [86] = {.lex_state = 119, .external_lex_state = 6},
  [87] = {.lex_state = 73},
  [88] = {.lex_state = 84},
  [89] = {.lex_state = 139},
  [90] = {.lex_state = 84, .external_lex_state = 2},
  [91] = {.lex_state = 73},
  [92] = {.lex_state = 159, .external_lex_state = 10},
  [93] = {.lex_state = 163, .external_lex_state = 5},
  [94] = {.lex_state = 134},
  [95] = {.lex_state = 159, .external_lex_state = 10},
  [96] = {.lex_state = 167},
  [97] = {.lex_state = 73},
  [98] = {.lex_state = 84},
  [99] = {.lex_state = 119, .external_lex_state = 6},
  [100] = {.lex_state = 88, .external_lex_state = 3},
  [101] = {.lex_state = 88, .external_lex_state = 4},
  [102] = {.lex_state = 119, .external_lex_state = 6},
  [103] = {.lex_state = 119, .external_lex_state = 6},
  [104] = {.lex_state = 119, .external_lex_state = 6},
  [105] = {.lex_state = 132, .external_lex_state = 2},
  [106] = {.lex_state = 134},
  [107] = {.lex_state = 173, .external_lex_state = 4},
  [108] = {.lex_state = 119, .external_lex_state = 4},
  [109] = {.lex_state = 151, .external_lex_state = 4},
  [110] = {.lex_state = 155, .external_lex_state = 3},
  [111] = {.lex_state = 134},
  [112] = {.lex_state = 124, .external_lex_state = 7},
  [113] = {.lex_state = 84, .external_lex_state = 2},
  [114] = {.lex_state = 119, .external_lex_state = 4},
  [115] = {.lex_state = 84},
  [116] = {.lex_state = 151, .external_lex_state = 4},
  [117] = {.lex_state = 155, .external_lex_state = 3},
  [118] = {.lex_state = 73, .external_lex_state = 2},
  [119] = {.lex_state = 144},
  [120] = {.lex_state = 175, .external_lex_state = 11},
  [121] = {.lex_state = 73, .external_lex_state = 2},
  [122] = {.lex_state = 94},
  [123] = {.lex_state = 73, .external_lex_state = 2},
  [124] = {.lex_state = 175, .external_lex_state = 11},
  [125] = {.lex_state = 94, .external_lex_state = 5},
  [126] = {.lex_state = 175, .external_lex_state = 12},
  [127] = {.lex_state = 175, .external_lex_state = 12},
  [128] = {.lex_state = 126},
  [129] = {.lex_state = 126},
  [130] = {.lex_state = 144},
  [131] = {.lex_state = 163, .external_lex_state = 13},
  [132] = {.lex_state = 73, .external_lex_state = 2},
  [133] = {.lex_state = 73, .external_lex_state = 2},
  [134] = {.lex_state = 94},
  [135] = {.lex_state = 73, .external_lex_state = 2},
  [136] = {.lex_state = 163, .external_lex_state = 13},
  [137] = {.lex_state = 94, .external_lex_state = 5},
  [138] = {.lex_state = 163},
  [139] = {.lex_state = 163},
  [140] = {.lex_state = 88, .external_lex_state = 3},
  [141] = {.lex_state = 88, .external_lex_state = 4},
  [142] = {.lex_state = 132, .external_lex_state = 2},
  [143] = {.lex_state = 151, .external_lex_state = 4},
  [144] = {.lex_state = 155, .external_lex_state = 3},
  [145] = {.lex_state = 73, .external_lex_state = 2},
  [146] = {.lex_state = 84, .external_lex_state = 2},
  [147] = {.lex_state = 73},
  [148] = {.lex_state = 119, .external_lex_state = 4},
  [149] = {.lex_state = 134},
  [150] = {.lex_state = 173, .external_lex_state = 4},
  [151] = {.lex_state = 134},
  [152] = {.lex_state = 84, .external_lex_state = 14},
  [153] = {.lex_state = 84},
  [154] = {.lex_state = 84},
  [155] = {.lex_state = 180},
  [156] = {.lex_state = 73, .external_lex_state = 2},
  [157] = {.lex_state = 119, .external_lex_state = 6},
  [158] = {.lex_state = 73, .external_lex_state = 2},
  [159] = {.lex_state = 94, .external_lex_state = 5},
  [160] = {.lex_state = 144, .external_lex_state = 13},
  [161] = {.lex_state = 144},
  [162] = {.lex_state = 175, .external_lex_state = 12},
  [163] = {.lex_state = 185, .external_lex_state = 12},
  [164] = {.lex_state = 84},
  [165] = {.lex_state = 126},
  [166] = {.lex_state = 126},
  [167] = {.lex_state = 144},
  [168] = {.lex_state = 188, .external_lex_state = 15},
  [169] = {.lex_state = 73, .external_lex_state = 2},
  [170] = {.lex_state = 73, .external_lex_state = 2},
  [171] = {.lex_state = 94},
  [172] = {.lex_state = 73, .external_lex_state = 2},
  [173] = {.lex_state = 188, .external_lex_state = 15},
  [174] = {.lex_state = 94, .external_lex_state = 5},
  [175] = {.lex_state = 188, .external_lex_state = 16},
  [176] = {.lex_state = 188, .external_lex_state = 16},
  [177] = {.lex_state = 126},
  [178] = {.lex_state = 191, .external_lex_state = 13},
  [179] = {.lex_state = 191, .external_lex_state = 13},
  [180] = {.lex_state = 191},
  [181] = {.lex_state = 191},
  [182] = {.lex_state = 119, .external_lex_state = 4},
  [183] = {.lex_state = 119, .external_lex_state = 4},
  [184] = {.lex_state = 73, .external_lex_state = 2},
  [185] = {.lex_state = 84},
  [186] = {.lex_state = 73, .external_lex_state = 17},
  [187] = {.lex_state = 73, .external_lex_state = 2},
  [188] = {.lex_state = 139},
  [189] = {.lex_state = 73, .external_lex_state = 18},
  [190] = {.lex_state = 73, .external_lex_state = 2},
  [191] = {.lex_state = 84},
  [192] = {.lex_state = 151, .external_lex_state = 4},
  [193] = {.lex_state = 151, .external_lex_state = 4},
  [194] = {.lex_state = 155, .external_lex_state = 3},
  [195] = {.lex_state = 73, .external_lex_state = 2},
  [196] = {.lex_state = 119, .external_lex_state = 4},
  [197] = {.lex_state = 84, .external_lex_state = 2},
  [198] = {.lex_state = 119, .external_lex_state = 6},
  [199] = {.lex_state = 84, .external_lex_state = 19},
  [200] = {.lex_state = 119, .external_lex_state = 4},
  [201] = {.lex_state = 119, .external_lex_state = 4},
  [202] = {.lex_state = 88, .external_lex_state = 9},
  [203] = {.lex_state = 134},
  [204] = {.lex_state = 88, .external_lex_state = 9},
  [205] = {.lex_state = 88, .external_lex_state = 3},
  [206] = {.lex_state = 88, .external_lex_state = 3},
  [207] = {.lex_state = 134},
  [208] = {.lex_state = 88, .external_lex_state = 6},
  [209] = {.lex_state = 88, .external_lex_state = 6},
  [210] = {.lex_state = 88, .external_lex_state = 4},
  [211] = {.lex_state = 88, .external_lex_state = 4},
  [212] = {.lex_state = 119, .external_lex_state = 6},
  [213] = {.lex_state = 84, .external_lex_state = 14},
  [214] = {.lex_state = 119, .external_lex_state = 4},
  [215] = {.lex_state = 73, .external_lex_state = 2},
  [216] = {.lex_state = 84},
  [217] = {.lex_state = 139},
  [218] = {.lex_state = 73, .external_lex_state = 2},
  [219] = {.lex_state = 84},
  [220] = {.lex_state = 151, .external_lex_state = 4},
  [221] = {.lex_state = 151, .external_lex_state = 4},
  [222] = {.lex_state = 155, .external_lex_state = 3},
  [223] = {.lex_state = 119, .external_lex_state = 4},
  [224] = {.lex_state = 173, .external_lex_state = 4},
  [225] = {.lex_state = 119, .external_lex_state = 6},
  [226] = {.lex_state = 84, .external_lex_state = 19},
  [227] = {.lex_state = 119, .external_lex_state = 4},
  [228] = {.lex_state = 119, .external_lex_state = 4},
  [229] = {.lex_state = 73},
  [230] = {.lex_state = 180},
  [231] = {.lex_state = 84, .external_lex_state = 8},
  [232] = {.lex_state = 144},
  [233] = {.lex_state = 84},
  [234] = {.lex_state = 84, .external_lex_state = 8},
  [235] = {.lex_state = 73},
  [236] = {.lex_state = 84, .external_lex_state = 8},
  [237] = {.lex_state = 84, .external_lex_state = 8},
  [238] = {.lex_state = 84, .external_lex_state = 8},
  [239] = {.lex_state = 84, .external_lex_state = 2},
  [240] = {.lex_state = 73},
  [241] = {.lex_state = 159, .external_lex_state = 10},
  [242] = {.lex_state = 163, .external_lex_state = 5},
  [243] = {.lex_state = 134},
  [244] = {.lex_state = 159, .external_lex_state = 10},
  [245] = {.lex_state = 84, .external_lex_state = 2},
  [246] = {.lex_state = 84, .external_lex_state = 2},
  [247] = {.lex_state = 73},
  [248] = {.lex_state = 180},
  [249] = {.lex_state = 88, .external_lex_state = 9},
  [250] = {.lex_state = 144},
  [251] = {.lex_state = 84},
  [252] = {.lex_state = 88, .external_lex_state = 9},
  [253] = {.lex_state = 73},
  [254] = {.lex_state = 84, .external_lex_state = 14},
  [255] = {.lex_state = 88, .external_lex_state = 9},
  [256] = {.lex_state = 88, .external_lex_state = 9},
  [257] = {.lex_state = 88, .external_lex_state = 9},
  [258] = {.lex_state = 84, .external_lex_state = 2},
  [259] = {.lex_state = 73},
  [260] = {.lex_state = 159, .external_lex_state = 10},
  [261] = {.lex_state = 163, .external_lex_state = 5},
  [262] = {.lex_state = 134},
  [263] = {.lex_state = 159, .external_lex_state = 10},
  [264] = {.lex_state = 88, .external_lex_state = 3},
  [265] = {.lex_state = 88, .external_lex_state = 3},
  [266] = {.lex_state = 88, .external_lex_state = 3},
  [267] = {.lex_state = 73},
  [268] = {.lex_state = 180},
  [269] = {.lex_state = 88, .external_lex_state = 6},
  [270] = {.lex_state = 144},
  [271] = {.lex_state = 84},
  [272] = {.lex_state = 88, .external_lex_state = 6},
  [273] = {.lex_state = 73},
  [274] = {.lex_state = 88, .external_lex_state = 6},
  [275] = {.lex_state = 88, .external_lex_state = 6},
  [276] = {.lex_state = 88, .external_lex_state = 6},
  [277] = {.lex_state = 84, .external_lex_state = 2},
  [278] = {.lex_state = 73},
  [279] = {.lex_state = 159, .external_lex_state = 10},
  [280] = {.lex_state = 163, .external_lex_state = 5},
  [281] = {.lex_state = 134},
  [282] = {.lex_state = 159, .external_lex_state = 10},
  [283] = {.lex_state = 88, .external_lex_state = 4},
  [284] = {.lex_state = 88, .external_lex_state = 4},
  [285] = {.lex_state = 88, .external_lex_state = 4},
  [286] = {.lex_state = 119, .external_lex_state = 6},
  [287] = {.lex_state = 84, .external_lex_state = 8},
  [288] = {.lex_state = 84, .external_lex_state = 8},
  [289] = {.lex_state = 84, .external_lex_state = 2},
  [290] = {.lex_state = 84},
  [291] = {.lex_state = 119, .external_lex_state = 6},
  [292] = {.lex_state = 73, .external_lex_state = 2},
  [293] = {.lex_state = 194, .external_lex_state = 20},
  [294] = {.lex_state = 194, .external_lex_state = 21},
  [295] = {.lex_state = 94},
  [296] = {.lex_state = 73, .external_lex_state = 2},
  [297] = {.lex_state = 73, .external_lex_state = 2},
  [298] = {.lex_state = 94, .external_lex_state = 5},
  [299] = {.lex_state = 119, .external_lex_state = 6},
  [300] = {.lex_state = 144},
  [301] = {.lex_state = 194, .external_lex_state = 21},
  [302] = {.lex_state = 194, .external_lex_state = 10},
  [303] = {.lex_state = 194, .external_lex_state = 10},
  [304] = {.lex_state = 159, .external_lex_state = 10},
  [305] = {.lex_state = 134},
  [306] = {.lex_state = 159, .external_lex_state = 10},
  [307] = {.lex_state = 196, .external_lex_state = 10},
  [308] = {.lex_state = 84},
  [309] = {.lex_state = 194, .external_lex_state = 20},
  [310] = {.lex_state = 119, .external_lex_state = 6},
  [311] = {.lex_state = 194, .external_lex_state = 10},
  [312] = {.lex_state = 73},
  [313] = {.lex_state = 173, .external_lex_state = 4},
  [314] = {.lex_state = 73},
  [315] = {.lex_state = 119, .external_lex_state = 6},
  [316] = {.lex_state = 84},
  [317] = {.lex_state = 119, .external_lex_state = 6},
  [318] = {.lex_state = 88, .external_lex_state = 9},
  [319] = {.lex_state = 134},
  [320] = {.lex_state = 88, .external_lex_state = 9},
  [321] = {.lex_state = 88, .external_lex_state = 3},
  [322] = {.lex_state = 88, .external_lex_state = 3},
  [323] = {.lex_state = 134},
  [324] = {.lex_state = 88, .external_lex_state = 6},
  [325] = {.lex_state = 88, .external_lex_state = 6},
  [326] = {.lex_state = 88, .external_lex_state = 4},
  [327] = {.lex_state = 88, .external_lex_state = 4},
  [328] = {.lex_state = 119, .external_lex_state = 6},
  [329] = {.lex_state = 84, .external_lex_state = 14},
  [330] = {.lex_state = 119, .external_lex_state = 4},
  [331] = {.lex_state = 124, .external_lex_state = 7},
  [332] = {.lex_state = 84},
  [333] = {.lex_state = 124, .external_lex_state = 22},
  [334] = {.lex_state = 139},
  [335] = {.lex_state = 73, .external_lex_state = 2},
  [336] = {.lex_state = 84},
  [337] = {.lex_state = 73, .external_lex_state = 2},
  [338] = {.lex_state = 151, .external_lex_state = 4},
  [339] = {.lex_state = 173, .external_lex_state = 4},
  [340] = {.lex_state = 124, .external_lex_state = 7},
  [341] = {.lex_state = 119, .external_lex_state = 4},
  [342] = {.lex_state = 119, .external_lex_state = 6},
  [343] = {.lex_state = 84, .external_lex_state = 19},
  [344] = {.lex_state = 119, .external_lex_state = 4},
  [345] = {.lex_state = 119, .external_lex_state = 4},
  [346] = {.lex_state = 73, .external_lex_state = 2},
  [347] = {.lex_state = 84},
  [348] = {.lex_state = 73},
  [349] = {.lex_state = 180},
  [350] = {.lex_state = 175, .external_lex_state = 11},
  [351] = {.lex_state = 144},
  [352] = {.lex_state = 198},
  [353] = {.lex_state = 84},
  [354] = {.lex_state = 175, .external_lex_state = 12},
  [355] = {.lex_state = 175, .external_lex_state = 11},
  [356] = {.lex_state = 73},
  [357] = {.lex_state = 175, .external_lex_state = 11},
  [358] = {.lex_state = 175, .external_lex_state = 11},
  [359] = {.lex_state = 175, .external_lex_state = 11},
  [360] = {.lex_state = 84, .external_lex_state = 2},
  [361] = {.lex_state = 73},
  [362] = {.lex_state = 159, .external_lex_state = 10},
  [363] = {.lex_state = 163, .external_lex_state = 5},
  [364] = {.lex_state = 134},
  [365] = {.lex_state = 159, .external_lex_state = 10},
  [366] = {.lex_state = 198},
  [367] = {.lex_state = 175, .external_lex_state = 12},
  [368] = {.lex_state = 175, .external_lex_state = 12},
  [369] = {.lex_state = 175, .external_lex_state = 12},
  [370] = {.lex_state = 163},
  [371] = {.lex_state = 126},
  [372] = {.lex_state = 200, .external_lex_state = 13},
  [373] = {.lex_state = 200, .external_lex_state = 13},
  [374] = {.lex_state = 200},
  [375] = {.lex_state = 200},
  [376] = {.lex_state = 180},
  [377] = {.lex_state = 202, .external_lex_state = 13},
  [378] = {.lex_state = 144},
  [379] = {.lex_state = 84},
  [380] = {.lex_state = 163, .external_lex_state = 13},
  [381] = {.lex_state = 73},
  [382] = {.lex_state = 73},
  [383] = {.lex_state = 202, .external_lex_state = 13},
  [384] = {.lex_state = 202, .external_lex_state = 13},
  [385] = {.lex_state = 202, .external_lex_state = 13},
  [386] = {.lex_state = 84, .external_lex_state = 2},
  [387] = {.lex_state = 73},
  [388] = {.lex_state = 159, .external_lex_state = 10},
  [389] = {.lex_state = 163, .external_lex_state = 5},
  [390] = {.lex_state = 134},
  [391] = {.lex_state = 159, .external_lex_state = 10},
  [392] = {.lex_state = 202},
  [393] = {.lex_state = 163},
  [394] = {.lex_state = 126},
  [395] = {.lex_state = 204},
  [396] = {.lex_state = 126, .external_lex_state = 19},
  [397] = {.lex_state = 173, .external_lex_state = 4},
  [398] = {.lex_state = 88, .external_lex_state = 3},
  [399] = {.lex_state = 88, .external_lex_state = 4},
  [400] = {.lex_state = 73, .external_lex_state = 2},
  [401] = {.lex_state = 84},
  [402] = {.lex_state = 73, .external_lex_state = 17},
  [403] = {.lex_state = 73, .external_lex_state = 2},
  [404] = {.lex_state = 139},
  [405] = {.lex_state = 73, .external_lex_state = 2},
  [406] = {.lex_state = 84},
  [407] = {.lex_state = 151, .external_lex_state = 4},
  [408] = {.lex_state = 151, .external_lex_state = 4},
  [409] = {.lex_state = 155, .external_lex_state = 3},
  [410] = {.lex_state = 119, .external_lex_state = 4},
  [411] = {.lex_state = 119, .external_lex_state = 4},
  [412] = {.lex_state = 84, .external_lex_state = 14},
  [413] = {.lex_state = 84},
  [414] = {.lex_state = 73, .external_lex_state = 2},
  [415] = {.lex_state = 144},
  [416] = {.lex_state = 155, .external_lex_state = 9},
  [417] = {.lex_state = 73, .external_lex_state = 2},
  [418] = {.lex_state = 94},
  [419] = {.lex_state = 73, .external_lex_state = 2},
  [420] = {.lex_state = 155, .external_lex_state = 9},
  [421] = {.lex_state = 94, .external_lex_state = 5},
  [422] = {.lex_state = 155, .external_lex_state = 3},
  [423] = {.lex_state = 155, .external_lex_state = 3},
  [424] = {.lex_state = 188, .external_lex_state = 15},
  [425] = {.lex_state = 188, .external_lex_state = 15},
  [426] = {.lex_state = 188, .external_lex_state = 15},
  [427] = {.lex_state = 188, .external_lex_state = 15},
  [428] = {.lex_state = 84, .external_lex_state = 8},
  [429] = {.lex_state = 84, .external_lex_state = 2},
  [430] = {.lex_state = 84, .external_lex_state = 2},
  [431] = {.lex_state = 144, .external_lex_state = 13},
  [432] = {.lex_state = 119, .external_lex_state = 6},
  [433] = {.lex_state = 144, .external_lex_state = 13},
  [434] = {.lex_state = 144, .external_lex_state = 13},
  [435] = {.lex_state = 73},
  [436] = {.lex_state = 84, .external_lex_state = 2},
  [437] = {.lex_state = 73},
  [438] = {.lex_state = 159, .external_lex_state = 10},
  [439] = {.lex_state = 163, .external_lex_state = 5},
  [440] = {.lex_state = 134},
  [441] = {.lex_state = 159, .external_lex_state = 10},
  [442] = {.lex_state = 144},
  [443] = {.lex_state = 180},
  [444] = {.lex_state = 144},
  [445] = {.lex_state = 84},
  [446] = {.lex_state = 84},
  [447] = {.lex_state = 126},
  [448] = {.lex_state = 126},
  [449] = {.lex_state = 73, .external_lex_state = 2},
  [450] = {.lex_state = 206, .external_lex_state = 11},
  [451] = {.lex_state = 185, .external_lex_state = 12},
  [452] = {.lex_state = 94},
  [453] = {.lex_state = 73, .external_lex_state = 2},
  [454] = {.lex_state = 73, .external_lex_state = 2},
  [455] = {.lex_state = 94, .external_lex_state = 5},
  [456] = {.lex_state = 144},
  [457] = {.lex_state = 206, .external_lex_state = 11},
  [458] = {.lex_state = 206, .external_lex_state = 12},
  [459] = {.lex_state = 206, .external_lex_state = 12},
  [460] = {.lex_state = 73, .external_lex_state = 2},
  [461] = {.lex_state = 173, .external_lex_state = 4},
  [462] = {.lex_state = 188, .external_lex_state = 16},
  [463] = {.lex_state = 200},
  [464] = {.lex_state = 180},
  [465] = {.lex_state = 188, .external_lex_state = 15},
  [466] = {.lex_state = 144},
  [467] = {.lex_state = 84},
  [468] = {.lex_state = 188, .external_lex_state = 15},
  [469] = {.lex_state = 73},
  [470] = {.lex_state = 73},
  [471] = {.lex_state = 188, .external_lex_state = 15},
  [472] = {.lex_state = 188, .external_lex_state = 15},
  [473] = {.lex_state = 188, .external_lex_state = 15},
  [474] = {.lex_state = 84, .external_lex_state = 2},
  [475] = {.lex_state = 73},
  [476] = {.lex_state = 159, .external_lex_state = 10},
  [477] = {.lex_state = 163, .external_lex_state = 5},
  [478] = {.lex_state = 134},
  [479] = {.lex_state = 159, .external_lex_state = 10},
  [480] = {.lex_state = 188, .external_lex_state = 16},
  [481] = {.lex_state = 188, .external_lex_state = 16},
  [482] = {.lex_state = 126},
  [483] = {.lex_state = 188, .external_lex_state = 16},
  [484] = {.lex_state = 126, .external_lex_state = 19},
  [485] = {.lex_state = 191},
  [486] = {.lex_state = 191, .external_lex_state = 13},
  [487] = {.lex_state = 191},
  [488] = {.lex_state = 126},
  [489] = {.lex_state = 126, .external_lex_state = 19},
  [490] = {.lex_state = 151, .external_lex_state = 4},
  [491] = {.lex_state = 155, .external_lex_state = 3},
  [492] = {.lex_state = 73, .external_lex_state = 2},
  [493] = {.lex_state = 144},
  [494] = {.lex_state = 151, .external_lex_state = 6},
  [495] = {.lex_state = 73, .external_lex_state = 2},
  [496] = {.lex_state = 94},
  [497] = {.lex_state = 73, .external_lex_state = 2},
  [498] = {.lex_state = 151, .external_lex_state = 6},
  [499] = {.lex_state = 94, .external_lex_state = 5},
  [500] = {.lex_state = 151, .external_lex_state = 4},
  [501] = {.lex_state = 173, .external_lex_state = 4},
  [502] = {.lex_state = 210, .external_lex_state = 12},
  [503] = {.lex_state = 73, .external_lex_state = 23},
  [504] = {.lex_state = 212, .external_lex_state = 12},
  [505] = {.lex_state = 84},
  [506] = {.lex_state = 173, .external_lex_state = 4},
  [507] = {.lex_state = 151, .external_lex_state = 4},
  [508] = {.lex_state = 155, .external_lex_state = 3},
  [509] = {.lex_state = 151, .external_lex_state = 6},
  [510] = {.lex_state = 151, .external_lex_state = 4},
  [511] = {.lex_state = 173, .external_lex_state = 4},
  [512] = {.lex_state = 151, .external_lex_state = 4},
  [513] = {.lex_state = 73, .external_lex_state = 2},
  [514] = {.lex_state = 73, .external_lex_state = 17},
  [515] = {.lex_state = 151, .external_lex_state = 4},
  [516] = {.lex_state = 155, .external_lex_state = 3},
  [517] = {.lex_state = 119, .external_lex_state = 4},
  [518] = {.lex_state = 119, .external_lex_state = 6},
  [519] = {.lex_state = 119, .external_lex_state = 4},
  [520] = {.lex_state = 119, .external_lex_state = 4},
  [521] = {.lex_state = 119, .external_lex_state = 4},
  [522] = {.lex_state = 88, .external_lex_state = 9},
  [523] = {.lex_state = 84, .external_lex_state = 14},
  [524] = {.lex_state = 88, .external_lex_state = 3},
  [525] = {.lex_state = 88, .external_lex_state = 3},
  [526] = {.lex_state = 88, .external_lex_state = 6},
  [527] = {.lex_state = 88, .external_lex_state = 4},
  [528] = {.lex_state = 88, .external_lex_state = 4},
  [529] = {.lex_state = 119, .external_lex_state = 6},
  [530] = {.lex_state = 155, .external_lex_state = 9},
  [531] = {.lex_state = 155, .external_lex_state = 9},
  [532] = {.lex_state = 155, .external_lex_state = 3},
  [533] = {.lex_state = 151, .external_lex_state = 4},
  [534] = {.lex_state = 155, .external_lex_state = 3},
  [535] = {.lex_state = 151, .external_lex_state = 6},
  [536] = {.lex_state = 151, .external_lex_state = 6},
  [537] = {.lex_state = 151, .external_lex_state = 4},
  [538] = {.lex_state = 84},
  [539] = {.lex_state = 151, .external_lex_state = 4},
  [540] = {.lex_state = 155, .external_lex_state = 3},
  [541] = {.lex_state = 151, .external_lex_state = 6},
  [542] = {.lex_state = 151, .external_lex_state = 4},
  [543] = {.lex_state = 151, .external_lex_state = 4},
  [544] = {.lex_state = 119, .external_lex_state = 4},
  [545] = {.lex_state = 119, .external_lex_state = 6},
  [546] = {.lex_state = 119, .external_lex_state = 4},
  [547] = {.lex_state = 119, .external_lex_state = 4},
  [548] = {.lex_state = 84, .external_lex_state = 8},
  [549] = {.lex_state = 84, .external_lex_state = 8},
  [550] = {.lex_state = 180},
  [551] = {.lex_state = 84, .external_lex_state = 8},
  [552] = {.lex_state = 84},
  [553] = {.lex_state = 84, .external_lex_state = 8},
  [554] = {.lex_state = 84, .external_lex_state = 8},
  [555] = {.lex_state = 194, .external_lex_state = 20},
  [556] = {.lex_state = 84, .external_lex_state = 8},
  [557] = {.lex_state = 194, .external_lex_state = 10},
  [558] = {.lex_state = 159, .external_lex_state = 10},
  [559] = {.lex_state = 134},
  [560] = {.lex_state = 159, .external_lex_state = 10},
  [561] = {.lex_state = 196, .external_lex_state = 10},
  [562] = {.lex_state = 194, .external_lex_state = 20},
  [563] = {.lex_state = 84, .external_lex_state = 8},
  [564] = {.lex_state = 194, .external_lex_state = 10},
  [565] = {.lex_state = 88, .external_lex_state = 9},
  [566] = {.lex_state = 88, .external_lex_state = 9},
  [567] = {.lex_state = 180},
  [568] = {.lex_state = 88, .external_lex_state = 9},
  [569] = {.lex_state = 84},
  [570] = {.lex_state = 88, .external_lex_state = 9},
  [571] = {.lex_state = 88, .external_lex_state = 9},
  [572] = {.lex_state = 84},
  [573] = {.lex_state = 88, .external_lex_state = 9},
  [574] = {.lex_state = 88, .external_lex_state = 3},
  [575] = {.lex_state = 88, .external_lex_state = 3},
  [576] = {.lex_state = 194, .external_lex_state = 20},
  [577] = {.lex_state = 88, .external_lex_state = 9},
  [578] = {.lex_state = 194, .external_lex_state = 10},
  [579] = {.lex_state = 159, .external_lex_state = 10},
  [580] = {.lex_state = 134},
  [581] = {.lex_state = 159, .external_lex_state = 10},
  [582] = {.lex_state = 196, .external_lex_state = 10},
  [583] = {.lex_state = 194, .external_lex_state = 20},
  [584] = {.lex_state = 88, .external_lex_state = 9},
  [585] = {.lex_state = 194, .external_lex_state = 10},
  [586] = {.lex_state = 88, .external_lex_state = 6},
  [587] = {.lex_state = 88, .external_lex_state = 6},
  [588] = {.lex_state = 180},
  [589] = {.lex_state = 88, .external_lex_state = 6},
  [590] = {.lex_state = 84},
  [591] = {.lex_state = 88, .external_lex_state = 6},
  [592] = {.lex_state = 88, .external_lex_state = 6},
  [593] = {.lex_state = 194, .external_lex_state = 20},
  [594] = {.lex_state = 88, .external_lex_state = 6},
  [595] = {.lex_state = 194, .external_lex_state = 10},
  [596] = {.lex_state = 159, .external_lex_state = 10},
  [597] = {.lex_state = 134},
  [598] = {.lex_state = 159, .external_lex_state = 10},
  [599] = {.lex_state = 196, .external_lex_state = 10},
  [600] = {.lex_state = 194, .external_lex_state = 20},
  [601] = {.lex_state = 88, .external_lex_state = 6},
  [602] = {.lex_state = 194, .external_lex_state = 10},
  [603] = {.lex_state = 84, .external_lex_state = 8},
  [604] = {.lex_state = 84, .external_lex_state = 2},
  [605] = {.lex_state = 84, .external_lex_state = 8},
  [606] = {.lex_state = 84, .external_lex_state = 2},
  [607] = {.lex_state = 73},
  [608] = {.lex_state = 119, .external_lex_state = 6},
  [609] = {.lex_state = 194, .external_lex_state = 10},
  [610] = {.lex_state = 194, .external_lex_state = 10},
  [611] = {.lex_state = 84},
  [612] = {.lex_state = 194, .external_lex_state = 21},
  [613] = {.lex_state = 194, .external_lex_state = 21},
  [614] = {.lex_state = 194, .external_lex_state = 21},
  [615] = {.lex_state = 194, .external_lex_state = 21},
  [616] = {.lex_state = 73},
  [617] = {.lex_state = 84, .external_lex_state = 2},
  [618] = {.lex_state = 73},
  [619] = {.lex_state = 159, .external_lex_state = 10},
  [620] = {.lex_state = 163, .external_lex_state = 5},
  [621] = {.lex_state = 134},
  [622] = {.lex_state = 159, .external_lex_state = 10},
  [623] = {.lex_state = 180},
  [624] = {.lex_state = 194, .external_lex_state = 21},
  [625] = {.lex_state = 144},
  [626] = {.lex_state = 194, .external_lex_state = 10},
  [627] = {.lex_state = 194, .external_lex_state = 10},
  [628] = {.lex_state = 194, .external_lex_state = 10},
  [629] = {.lex_state = 194, .external_lex_state = 20},
  [630] = {.lex_state = 196, .external_lex_state = 10},
  [631] = {.lex_state = 194, .external_lex_state = 20},
  [632] = {.lex_state = 119, .external_lex_state = 6},
  [633] = {.lex_state = 194, .external_lex_state = 10},
  [634] = {.lex_state = 73, .external_lex_state = 2},
  [635] = {.lex_state = 144},
  [636] = {.lex_state = 124, .external_lex_state = 21},
  [637] = {.lex_state = 73, .external_lex_state = 2},
  [638] = {.lex_state = 94},
  [639] = {.lex_state = 73, .external_lex_state = 2},
  [640] = {.lex_state = 139, .external_lex_state = 21},
  [641] = {.lex_state = 94, .external_lex_state = 5},
  [642] = {.lex_state = 139, .external_lex_state = 10},
  [643] = {.lex_state = 124, .external_lex_state = 10},
  [644] = {.lex_state = 188, .external_lex_state = 15},
  [645] = {.lex_state = 188, .external_lex_state = 15},
  [646] = {.lex_state = 188, .external_lex_state = 15},
  [647] = {.lex_state = 119, .external_lex_state = 6},
  [648] = {.lex_state = 194, .external_lex_state = 10},
  [649] = {.lex_state = 194, .external_lex_state = 10},
  [650] = {.lex_state = 73},
  [651] = {.lex_state = 173, .external_lex_state = 4},
  [652] = {.lex_state = 216, .external_lex_state = 4},
  [653] = {.lex_state = 88, .external_lex_state = 9},
  [654] = {.lex_state = 84, .external_lex_state = 14},
  [655] = {.lex_state = 88, .external_lex_state = 3},
  [656] = {.lex_state = 88, .external_lex_state = 3},
  [657] = {.lex_state = 88, .external_lex_state = 6},
  [658] = {.lex_state = 88, .external_lex_state = 4},
  [659] = {.lex_state = 88, .external_lex_state = 4},
  [660] = {.lex_state = 119, .external_lex_state = 6},
  [661] = {.lex_state = 155, .external_lex_state = 9},
  [662] = {.lex_state = 155, .external_lex_state = 9},
  [663] = {.lex_state = 155, .external_lex_state = 3},
  [664] = {.lex_state = 151, .external_lex_state = 6},
  [665] = {.lex_state = 151, .external_lex_state = 6},
  [666] = {.lex_state = 151, .external_lex_state = 4},
  [667] = {.lex_state = 175, .external_lex_state = 12},
  [668] = {.lex_state = 84},
  [669] = {.lex_state = 151, .external_lex_state = 4},
  [670] = {.lex_state = 155, .external_lex_state = 3},
  [671] = {.lex_state = 151, .external_lex_state = 6},
  [672] = {.lex_state = 151, .external_lex_state = 4},
  [673] = {.lex_state = 151, .external_lex_state = 4},
  [674] = {.lex_state = 155, .external_lex_state = 3},
  [675] = {.lex_state = 151, .external_lex_state = 4},
  [676] = {.lex_state = 119, .external_lex_state = 4},
  [677] = {.lex_state = 119, .external_lex_state = 6},
  [678] = {.lex_state = 119, .external_lex_state = 4},
  [679] = {.lex_state = 119, .external_lex_state = 4},
  [680] = {.lex_state = 73, .external_lex_state = 2},
  [681] = {.lex_state = 173, .external_lex_state = 4},
  [682] = {.lex_state = 73, .external_lex_state = 2},
  [683] = {.lex_state = 73, .external_lex_state = 2},
  [684] = {.lex_state = 84},
  [685] = {.lex_state = 84},
  [686] = {.lex_state = 175, .external_lex_state = 11},
  [687] = {.lex_state = 175, .external_lex_state = 11},
  [688] = {.lex_state = 180},
  [689] = {.lex_state = 175, .external_lex_state = 12},
  [690] = {.lex_state = 175, .external_lex_state = 11},
  [691] = {.lex_state = 222},
  [692] = {.lex_state = 84},
  [693] = {.lex_state = 175, .external_lex_state = 11},
  [694] = {.lex_state = 175, .external_lex_state = 11},
  [695] = {.lex_state = 194, .external_lex_state = 20},
  [696] = {.lex_state = 175, .external_lex_state = 11},
  [697] = {.lex_state = 194, .external_lex_state = 10},
  [698] = {.lex_state = 159, .external_lex_state = 10},
  [699] = {.lex_state = 134},
  [700] = {.lex_state = 159, .external_lex_state = 10},
  [701] = {.lex_state = 196, .external_lex_state = 10},
  [702] = {.lex_state = 194, .external_lex_state = 20},
  [703] = {.lex_state = 175, .external_lex_state = 11},
  [704] = {.lex_state = 194, .external_lex_state = 10},
  [705] = {.lex_state = 175, .external_lex_state = 12},
  [706] = {.lex_state = 222},
  [707] = {.lex_state = 200},
  [708] = {.lex_state = 200, .external_lex_state = 13},
  [709] = {.lex_state = 200},
  [710] = {.lex_state = 126},
  [711] = {.lex_state = 204},
  [712] = {.lex_state = 126, .external_lex_state = 19},
  [713] = {.lex_state = 202, .external_lex_state = 13},
  [714] = {.lex_state = 180},
  [715] = {.lex_state = 202, .external_lex_state = 13},
  [716] = {.lex_state = 84},
  [717] = {.lex_state = 163, .external_lex_state = 13},
  [718] = {.lex_state = 202, .external_lex_state = 13},
  [719] = {.lex_state = 202, .external_lex_state = 13},
  [720] = {.lex_state = 194, .external_lex_state = 20},
  [721] = {.lex_state = 202, .external_lex_state = 13},
  [722] = {.lex_state = 194, .external_lex_state = 10},
  [723] = {.lex_state = 159, .external_lex_state = 10},
  [724] = {.lex_state = 134},
  [725] = {.lex_state = 159, .external_lex_state = 10},
  [726] = {.lex_state = 196, .external_lex_state = 10},
  [727] = {.lex_state = 194, .external_lex_state = 20},
  [728] = {.lex_state = 202, .external_lex_state = 13},
  [729] = {.lex_state = 194, .external_lex_state = 10},
  [730] = {.lex_state = 204},
  [731] = {.lex_state = 204},
  [732] = {.lex_state = 151, .external_lex_state = 4},
  [733] = {.lex_state = 155, .external_lex_state = 3},
  [734] = {.lex_state = 151, .external_lex_state = 6},
  [735] = {.lex_state = 151, .external_lex_state = 6},
  [736] = {.lex_state = 151, .external_lex_state = 4},
  [737] = {.lex_state = 210, .external_lex_state = 12},
  [738] = {.lex_state = 84},
  [739] = {.lex_state = 151, .external_lex_state = 4},
  [740] = {.lex_state = 155, .external_lex_state = 3},
  [741] = {.lex_state = 151, .external_lex_state = 6},
  [742] = {.lex_state = 151, .external_lex_state = 4},
  [743] = {.lex_state = 151, .external_lex_state = 4},
  [744] = {.lex_state = 73, .external_lex_state = 2},
  [745] = {.lex_state = 73, .external_lex_state = 17},
  [746] = {.lex_state = 119, .external_lex_state = 4},
  [747] = {.lex_state = 84},
  [748] = {.lex_state = 84, .external_lex_state = 8},
  [749] = {.lex_state = 84, .external_lex_state = 2},
  [750] = {.lex_state = 84, .external_lex_state = 2},
  [751] = {.lex_state = 73, .external_lex_state = 2},
  [752] = {.lex_state = 144},
  [753] = {.lex_state = 84, .external_lex_state = 13},
  [754] = {.lex_state = 73, .external_lex_state = 2},
  [755] = {.lex_state = 94},
  [756] = {.lex_state = 155, .external_lex_state = 3},
  [757] = {.lex_state = 73, .external_lex_state = 2},
  [758] = {.lex_state = 84, .external_lex_state = 13},
  [759] = {.lex_state = 94, .external_lex_state = 5},
  [760] = {.lex_state = 84},
  [761] = {.lex_state = 84},
  [762] = {.lex_state = 73},
  [763] = {.lex_state = 180},
  [764] = {.lex_state = 155, .external_lex_state = 9},
  [765] = {.lex_state = 144},
  [766] = {.lex_state = 84},
  [767] = {.lex_state = 155, .external_lex_state = 9},
  [768] = {.lex_state = 73},
  [769] = {.lex_state = 155, .external_lex_state = 9},
  [770] = {.lex_state = 155, .external_lex_state = 9},
  [771] = {.lex_state = 155, .external_lex_state = 9},
  [772] = {.lex_state = 84, .external_lex_state = 2},
  [773] = {.lex_state = 73},
  [774] = {.lex_state = 159, .external_lex_state = 10},
  [775] = {.lex_state = 163, .external_lex_state = 5},
  [776] = {.lex_state = 134},
  [777] = {.lex_state = 159, .external_lex_state = 10},
  [778] = {.lex_state = 155, .external_lex_state = 3},
  [779] = {.lex_state = 155, .external_lex_state = 3},
  [780] = {.lex_state = 134, .external_lex_state = 13},
  [781] = {.lex_state = 224, .external_lex_state = 16},
  [782] = {.lex_state = 188, .external_lex_state = 15},
  [783] = {.lex_state = 134, .external_lex_state = 13},
  [784] = {.lex_state = 188, .external_lex_state = 15},
  [785] = {.lex_state = 188, .external_lex_state = 16},
  [786] = {.lex_state = 188, .external_lex_state = 15},
  [787] = {.lex_state = 188, .external_lex_state = 16},
  [788] = {.lex_state = 144},
  [789] = {.lex_state = 144, .external_lex_state = 13},
  [790] = {.lex_state = 194, .external_lex_state = 20},
  [791] = {.lex_state = 144, .external_lex_state = 13},
  [792] = {.lex_state = 194, .external_lex_state = 10},
  [793] = {.lex_state = 159, .external_lex_state = 10},
  [794] = {.lex_state = 134},
  [795] = {.lex_state = 159, .external_lex_state = 10},
  [796] = {.lex_state = 196, .external_lex_state = 10},
  [797] = {.lex_state = 194, .external_lex_state = 20},
  [798] = {.lex_state = 144, .external_lex_state = 13},
  [799] = {.lex_state = 194, .external_lex_state = 10},
  [800] = {.lex_state = 119, .external_lex_state = 6},
  [801] = {.lex_state = 180},
  [802] = {.lex_state = 73, .external_lex_state = 2},
  [803] = {.lex_state = 144},
  [804] = {.lex_state = 212, .external_lex_state = 11},
  [805] = {.lex_state = 73, .external_lex_state = 2},
  [806] = {.lex_state = 94},
  [807] = {.lex_state = 73, .external_lex_state = 2},
  [808] = {.lex_state = 212, .external_lex_state = 11},
  [809] = {.lex_state = 94, .external_lex_state = 5},
  [810] = {.lex_state = 212, .external_lex_state = 12},
  [811] = {.lex_state = 212, .external_lex_state = 12},
  [812] = {.lex_state = 173, .external_lex_state = 4},
  [813] = {.lex_state = 206, .external_lex_state = 12},
  [814] = {.lex_state = 200},
  [815] = {.lex_state = 73},
  [816] = {.lex_state = 84},
  [817] = {.lex_state = 206, .external_lex_state = 11},
  [818] = {.lex_state = 126},
  [819] = {.lex_state = 206, .external_lex_state = 12},
  [820] = {.lex_state = 206, .external_lex_state = 11},
  [821] = {.lex_state = 206, .external_lex_state = 11},
  [822] = {.lex_state = 206, .external_lex_state = 11},
  [823] = {.lex_state = 73},
  [824] = {.lex_state = 84, .external_lex_state = 2},
  [825] = {.lex_state = 73},
  [826] = {.lex_state = 159, .external_lex_state = 10},
  [827] = {.lex_state = 163, .external_lex_state = 5},
  [828] = {.lex_state = 134},
  [829] = {.lex_state = 159, .external_lex_state = 10},
  [830] = {.lex_state = 180},
  [831] = {.lex_state = 206, .external_lex_state = 11},
  [832] = {.lex_state = 144},
  [833] = {.lex_state = 206, .external_lex_state = 12},
  [834] = {.lex_state = 206, .external_lex_state = 12},
  [835] = {.lex_state = 126},
  [836] = {.lex_state = 185, .external_lex_state = 12},
  [837] = {.lex_state = 206, .external_lex_state = 12},
  [838] = {.lex_state = 126, .external_lex_state = 19},
  [839] = {.lex_state = 173, .external_lex_state = 4},
  [840] = {.lex_state = 73, .external_lex_state = 2},
  [841] = {.lex_state = 188, .external_lex_state = 16},
  [842] = {.lex_state = 188, .external_lex_state = 15},
  [843] = {.lex_state = 180},
  [844] = {.lex_state = 188, .external_lex_state = 15},
  [845] = {.lex_state = 84},
  [846] = {.lex_state = 188, .external_lex_state = 15},
  [847] = {.lex_state = 188, .external_lex_state = 15},
  [848] = {.lex_state = 188, .external_lex_state = 15},
  [849] = {.lex_state = 194, .external_lex_state = 20},
  [850] = {.lex_state = 188, .external_lex_state = 15},
  [851] = {.lex_state = 194, .external_lex_state = 10},
  [852] = {.lex_state = 159, .external_lex_state = 10},
  [853] = {.lex_state = 134},
  [854] = {.lex_state = 159, .external_lex_state = 10},
  [855] = {.lex_state = 196, .external_lex_state = 10},
  [856] = {.lex_state = 194, .external_lex_state = 20},
  [857] = {.lex_state = 188, .external_lex_state = 15},
  [858] = {.lex_state = 194, .external_lex_state = 10},
  [859] = {.lex_state = 188, .external_lex_state = 16},
  [860] = {.lex_state = 188, .external_lex_state = 16},
  [861] = {.lex_state = 191, .external_lex_state = 13},
  [862] = {.lex_state = 73},
  [863] = {.lex_state = 180},
  [864] = {.lex_state = 173, .external_lex_state = 6},
  [865] = {.lex_state = 144},
  [866] = {.lex_state = 84},
  [867] = {.lex_state = 151, .external_lex_state = 6},
  [868] = {.lex_state = 73},
  [869] = {.lex_state = 173, .external_lex_state = 6},
  [870] = {.lex_state = 173, .external_lex_state = 6},
  [871] = {.lex_state = 173, .external_lex_state = 6},
  [872] = {.lex_state = 84, .external_lex_state = 2},
  [873] = {.lex_state = 73},
  [874] = {.lex_state = 159, .external_lex_state = 10},
  [875] = {.lex_state = 163, .external_lex_state = 5},
  [876] = {.lex_state = 134},
  [877] = {.lex_state = 159, .external_lex_state = 10},
  [878] = {.lex_state = 173, .external_lex_state = 4},
  [879] = {.lex_state = 151, .external_lex_state = 4},
  [880] = {.lex_state = 94},
  [881] = {.lex_state = 73, .external_lex_state = 2},
  [882] = {.lex_state = 73, .external_lex_state = 2},
  [883] = {.lex_state = 210, .external_lex_state = 12},
  [884] = {.lex_state = 94, .external_lex_state = 5},
  [885] = {.lex_state = 73, .external_lex_state = 23},
  [886] = {.lex_state = 73, .external_lex_state = 2},
  [887] = {.lex_state = 151, .external_lex_state = 6},
  [888] = {.lex_state = 151, .external_lex_state = 4},
  [889] = {.lex_state = 173, .external_lex_state = 4},
  [890] = {.lex_state = 212, .external_lex_state = 12},
  [891] = {.lex_state = 73, .external_lex_state = 2},
  [892] = {.lex_state = 73, .external_lex_state = 17},
  [893] = {.lex_state = 88, .external_lex_state = 9},
  [894] = {.lex_state = 88, .external_lex_state = 9},
  [895] = {.lex_state = 88, .external_lex_state = 3},
  [896] = {.lex_state = 88, .external_lex_state = 6},
  [897] = {.lex_state = 155, .external_lex_state = 9},
  [898] = {.lex_state = 155, .external_lex_state = 3},
  [899] = {.lex_state = 151, .external_lex_state = 6},
  [900] = {.lex_state = 151, .external_lex_state = 4},
  [901] = {.lex_state = 151, .external_lex_state = 6},
  [902] = {.lex_state = 151, .external_lex_state = 4},
  [903] = {.lex_state = 84, .external_lex_state = 8},
  [904] = {.lex_state = 226, .external_lex_state = 2},
  [905] = {.lex_state = 84, .external_lex_state = 8},
  [906] = {.lex_state = 194, .external_lex_state = 10},
  [907] = {.lex_state = 194, .external_lex_state = 10},
  [908] = {.lex_state = 194, .external_lex_state = 20},
  [909] = {.lex_state = 196, .external_lex_state = 10},
  [910] = {.lex_state = 194, .external_lex_state = 20},
  [911] = {.lex_state = 84, .external_lex_state = 8},
  [912] = {.lex_state = 194, .external_lex_state = 10},
  [913] = {.lex_state = 124, .external_lex_state = 21},
  [914] = {.lex_state = 139, .external_lex_state = 10},
  [915] = {.lex_state = 124, .external_lex_state = 10},
  [916] = {.lex_state = 84, .external_lex_state = 8},
  [917] = {.lex_state = 194, .external_lex_state = 10},
  [918] = {.lex_state = 194, .external_lex_state = 10},
  [919] = {.lex_state = 88, .external_lex_state = 9},
  [920] = {.lex_state = 228, .external_lex_state = 3},
  [921] = {.lex_state = 88, .external_lex_state = 3},
  [922] = {.lex_state = 84},
  [923] = {.lex_state = 88, .external_lex_state = 9},
  [924] = {.lex_state = 194, .external_lex_state = 10},
  [925] = {.lex_state = 194, .external_lex_state = 10},
  [926] = {.lex_state = 194, .external_lex_state = 20},
  [927] = {.lex_state = 196, .external_lex_state = 10},
  [928] = {.lex_state = 194, .external_lex_state = 20},
  [929] = {.lex_state = 88, .external_lex_state = 9},
  [930] = {.lex_state = 194, .external_lex_state = 10},
  [931] = {.lex_state = 124, .external_lex_state = 21},
  [932] = {.lex_state = 139, .external_lex_state = 10},
  [933] = {.lex_state = 124, .external_lex_state = 10},
  [934] = {.lex_state = 88, .external_lex_state = 9},
  [935] = {.lex_state = 194, .external_lex_state = 10},
  [936] = {.lex_state = 194, .external_lex_state = 10},
  [937] = {.lex_state = 88, .external_lex_state = 6},
  [938] = {.lex_state = 228, .external_lex_state = 4},
  [939] = {.lex_state = 88, .external_lex_state = 6},
  [940] = {.lex_state = 194, .external_lex_state = 10},
  [941] = {.lex_state = 194, .external_lex_state = 10},
  [942] = {.lex_state = 194, .external_lex_state = 20},
  [943] = {.lex_state = 196, .external_lex_state = 10},
  [944] = {.lex_state = 194, .external_lex_state = 20},
  [945] = {.lex_state = 88, .external_lex_state = 6},
  [946] = {.lex_state = 194, .external_lex_state = 10},
  [947] = {.lex_state = 124, .external_lex_state = 21},
  [948] = {.lex_state = 139, .external_lex_state = 10},
  [949] = {.lex_state = 124, .external_lex_state = 10},
  [950] = {.lex_state = 88, .external_lex_state = 6},
  [951] = {.lex_state = 194, .external_lex_state = 10},
  [952] = {.lex_state = 194, .external_lex_state = 10},
  [953] = {.lex_state = 84, .external_lex_state = 8},
  [954] = {.lex_state = 194, .external_lex_state = 21},
  [955] = {.lex_state = 119, .external_lex_state = 6},
  [956] = {.lex_state = 194, .external_lex_state = 10},
  [957] = {.lex_state = 194, .external_lex_state = 21},
  [958] = {.lex_state = 84},
  [959] = {.lex_state = 194, .external_lex_state = 21},
  [960] = {.lex_state = 194, .external_lex_state = 21},
  [961] = {.lex_state = 194, .external_lex_state = 20},
  [962] = {.lex_state = 194, .external_lex_state = 21},
  [963] = {.lex_state = 194, .external_lex_state = 10},
  [964] = {.lex_state = 159, .external_lex_state = 10},
  [965] = {.lex_state = 134},
  [966] = {.lex_state = 159, .external_lex_state = 10},
  [967] = {.lex_state = 196, .external_lex_state = 10},
  [968] = {.lex_state = 194, .external_lex_state = 20},
  [969] = {.lex_state = 194, .external_lex_state = 21},
  [970] = {.lex_state = 194, .external_lex_state = 10},
  [971] = {.lex_state = 194, .external_lex_state = 21},
  [972] = {.lex_state = 180},
  [973] = {.lex_state = 194, .external_lex_state = 10},
  [974] = {.lex_state = 124, .external_lex_state = 21},
  [975] = {.lex_state = 139, .external_lex_state = 10},
  [976] = {.lex_state = 124, .external_lex_state = 10},
  [977] = {.lex_state = 119, .external_lex_state = 6},
  [978] = {.lex_state = 194, .external_lex_state = 10},
  [979] = {.lex_state = 194, .external_lex_state = 10},
  [980] = {.lex_state = 73},
  [981] = {.lex_state = 180},
  [982] = {.lex_state = 124, .external_lex_state = 21},
  [983] = {.lex_state = 144},
  [984] = {.lex_state = 84},
  [985] = {.lex_state = 124, .external_lex_state = 21},
  [986] = {.lex_state = 73},
  [987] = {.lex_state = 124, .external_lex_state = 21},
  [988] = {.lex_state = 124, .external_lex_state = 21},
  [989] = {.lex_state = 124, .external_lex_state = 21},
  [990] = {.lex_state = 84, .external_lex_state = 2},
  [991] = {.lex_state = 73},
  [992] = {.lex_state = 159, .external_lex_state = 10},
  [993] = {.lex_state = 163, .external_lex_state = 5},
  [994] = {.lex_state = 134},
  [995] = {.lex_state = 159, .external_lex_state = 10},
  [996] = {.lex_state = 139, .external_lex_state = 10},
  [997] = {.lex_state = 119, .external_lex_state = 6},
  [998] = {.lex_state = 139, .external_lex_state = 10},
  [999] = {.lex_state = 159, .external_lex_state = 21},
  [1000] = {.lex_state = 224, .external_lex_state = 16},
  [1001] = {.lex_state = 159, .external_lex_state = 21},
  [1002] = {.lex_state = 188, .external_lex_state = 16},
  [1003] = {.lex_state = 188, .external_lex_state = 16},
  [1004] = {.lex_state = 119, .external_lex_state = 6},
  [1005] = {.lex_state = 194, .external_lex_state = 10},
  [1006] = {.lex_state = 173, .external_lex_state = 4},
  [1007] = {.lex_state = 88, .external_lex_state = 9},
  [1008] = {.lex_state = 88, .external_lex_state = 9},
  [1009] = {.lex_state = 88, .external_lex_state = 3},
  [1010] = {.lex_state = 88, .external_lex_state = 6},
  [1011] = {.lex_state = 155, .external_lex_state = 9},
  [1012] = {.lex_state = 155, .external_lex_state = 3},
  [1013] = {.lex_state = 151, .external_lex_state = 6},
  [1014] = {.lex_state = 151, .external_lex_state = 4},
  [1015] = {.lex_state = 124, .external_lex_state = 7},
  [1016] = {.lex_state = 151, .external_lex_state = 6},
  [1017] = {.lex_state = 151, .external_lex_state = 4},
  [1018] = {.lex_state = 73, .external_lex_state = 2},
  [1019] = {.lex_state = 84},
  [1020] = {.lex_state = 173, .external_lex_state = 4},
  [1021] = {.lex_state = 73, .external_lex_state = 2},
  [1022] = {.lex_state = 84},
  [1023] = {.lex_state = 84},
  [1024] = {.lex_state = 84},
  [1025] = {.lex_state = 175, .external_lex_state = 11},
  [1026] = {.lex_state = 222},
  [1027] = {.lex_state = 84, .external_lex_state = 13},
  [1028] = {.lex_state = 173, .external_lex_state = 4},
  [1029] = {.lex_state = 84, .external_lex_state = 13},
  [1030] = {.lex_state = 84},
  [1031] = {.lex_state = 167},
  [1032] = {.lex_state = 84},
  [1033] = {.lex_state = 84},
  [1034] = {.lex_state = 232, .external_lex_state = 12},
  [1035] = {.lex_state = 175, .external_lex_state = 11},
  [1036] = {.lex_state = 194, .external_lex_state = 10},
  [1037] = {.lex_state = 194, .external_lex_state = 10},
  [1038] = {.lex_state = 194, .external_lex_state = 20},
  [1039] = {.lex_state = 196, .external_lex_state = 10},
  [1040] = {.lex_state = 194, .external_lex_state = 20},
  [1041] = {.lex_state = 175, .external_lex_state = 11},
  [1042] = {.lex_state = 194, .external_lex_state = 10},
  [1043] = {.lex_state = 124, .external_lex_state = 21},
  [1044] = {.lex_state = 139, .external_lex_state = 10},
  [1045] = {.lex_state = 124, .external_lex_state = 10},
  [1046] = {.lex_state = 175, .external_lex_state = 11},
  [1047] = {.lex_state = 194, .external_lex_state = 10},
  [1048] = {.lex_state = 194, .external_lex_state = 10},
  [1049] = {.lex_state = 222},
  [1050] = {.lex_state = 173, .external_lex_state = 4},
  [1051] = {.lex_state = 167},
  [1052] = {.lex_state = 84},
  [1053] = {.lex_state = 200, .external_lex_state = 13},
  [1054] = {.lex_state = 202, .external_lex_state = 13},
  [1055] = {.lex_state = 94},
  [1056] = {.lex_state = 202, .external_lex_state = 13},
  [1057] = {.lex_state = 194, .external_lex_state = 10},
  [1058] = {.lex_state = 194, .external_lex_state = 10},
  [1059] = {.lex_state = 194, .external_lex_state = 20},
  [1060] = {.lex_state = 196, .external_lex_state = 10},
  [1061] = {.lex_state = 194, .external_lex_state = 20},
  [1062] = {.lex_state = 202, .external_lex_state = 13},
  [1063] = {.lex_state = 194, .external_lex_state = 10},
  [1064] = {.lex_state = 124, .external_lex_state = 21},
  [1065] = {.lex_state = 139, .external_lex_state = 10},
  [1066] = {.lex_state = 124, .external_lex_state = 10},
  [1067] = {.lex_state = 202, .external_lex_state = 13},
  [1068] = {.lex_state = 194, .external_lex_state = 10},
  [1069] = {.lex_state = 194, .external_lex_state = 10},
  [1070] = {.lex_state = 151, .external_lex_state = 6},
  [1071] = {.lex_state = 151, .external_lex_state = 4},
  [1072] = {.lex_state = 73, .external_lex_state = 2},
  [1073] = {.lex_state = 151, .external_lex_state = 6},
  [1074] = {.lex_state = 151, .external_lex_state = 4},
  [1075] = {.lex_state = 210, .external_lex_state = 12},
  [1076] = {.lex_state = 84, .external_lex_state = 2},
  [1077] = {.lex_state = 84},
  [1078] = {.lex_state = 73},
  [1079] = {.lex_state = 180},
  [1080] = {.lex_state = 84, .external_lex_state = 13},
  [1081] = {.lex_state = 144},
  [1082] = {.lex_state = 84},
  [1083] = {.lex_state = 84, .external_lex_state = 13},
  [1084] = {.lex_state = 73},
  [1085] = {.lex_state = 84, .external_lex_state = 13},
  [1086] = {.lex_state = 84, .external_lex_state = 13},
  [1087] = {.lex_state = 84, .external_lex_state = 13},
  [1088] = {.lex_state = 84, .external_lex_state = 2},
  [1089] = {.lex_state = 73},
  [1090] = {.lex_state = 159, .external_lex_state = 10},
  [1091] = {.lex_state = 163, .external_lex_state = 5},
  [1092] = {.lex_state = 134},
  [1093] = {.lex_state = 159, .external_lex_state = 10},
  [1094] = {.lex_state = 84},
  [1095] = {.lex_state = 84},
  [1096] = {.lex_state = 155, .external_lex_state = 3},
  [1097] = {.lex_state = 84},
  [1098] = {.lex_state = 155, .external_lex_state = 9},
  [1099] = {.lex_state = 155, .external_lex_state = 9},
  [1100] = {.lex_state = 180},
  [1101] = {.lex_state = 155, .external_lex_state = 9},
  [1102] = {.lex_state = 84},
  [1103] = {.lex_state = 155, .external_lex_state = 9},
  [1104] = {.lex_state = 155, .external_lex_state = 9},
  [1105] = {.lex_state = 194, .external_lex_state = 20},
  [1106] = {.lex_state = 155, .external_lex_state = 9},
  [1107] = {.lex_state = 194, .external_lex_state = 10},
  [1108] = {.lex_state = 159, .external_lex_state = 10},
  [1109] = {.lex_state = 134},
  [1110] = {.lex_state = 159, .external_lex_state = 10},
  [1111] = {.lex_state = 196, .external_lex_state = 10},
  [1112] = {.lex_state = 194, .external_lex_state = 20},
  [1113] = {.lex_state = 155, .external_lex_state = 9},
  [1114] = {.lex_state = 194, .external_lex_state = 10},
  [1115] = {.lex_state = 134},
  [1116] = {.lex_state = 134, .external_lex_state = 13},
  [1117] = {.lex_state = 84},
  [1118] = {.lex_state = 188, .external_lex_state = 15},
  [1119] = {.lex_state = 134},
  [1120] = {.lex_state = 134, .external_lex_state = 13},
  [1121] = {.lex_state = 144, .external_lex_state = 13},
  [1122] = {.lex_state = 194, .external_lex_state = 10},
  [1123] = {.lex_state = 194, .external_lex_state = 10},
  [1124] = {.lex_state = 194, .external_lex_state = 20},
  [1125] = {.lex_state = 196, .external_lex_state = 10},
  [1126] = {.lex_state = 194, .external_lex_state = 20},
  [1127] = {.lex_state = 144, .external_lex_state = 13},
  [1128] = {.lex_state = 194, .external_lex_state = 10},
  [1129] = {.lex_state = 124, .external_lex_state = 21},
  [1130] = {.lex_state = 139, .external_lex_state = 10},
  [1131] = {.lex_state = 124, .external_lex_state = 10},
  [1132] = {.lex_state = 144, .external_lex_state = 13},
  [1133] = {.lex_state = 194, .external_lex_state = 10},
  [1134] = {.lex_state = 194, .external_lex_state = 10},
  [1135] = {.lex_state = 73},
  [1136] = {.lex_state = 180},
  [1137] = {.lex_state = 212, .external_lex_state = 11},
  [1138] = {.lex_state = 144},
  [1139] = {.lex_state = 84},
  [1140] = {.lex_state = 212, .external_lex_state = 11},
  [1141] = {.lex_state = 73},
  [1142] = {.lex_state = 212, .external_lex_state = 11},
  [1143] = {.lex_state = 212, .external_lex_state = 11},
  [1144] = {.lex_state = 212, .external_lex_state = 11},
  [1145] = {.lex_state = 84, .external_lex_state = 2},
  [1146] = {.lex_state = 73},
  [1147] = {.lex_state = 159, .external_lex_state = 10},
  [1148] = {.lex_state = 163, .external_lex_state = 5},
  [1149] = {.lex_state = 134},
  [1150] = {.lex_state = 159, .external_lex_state = 10},
  [1151] = {.lex_state = 212, .external_lex_state = 12},
  [1152] = {.lex_state = 212, .external_lex_state = 12},
  [1153] = {.lex_state = 84},
  [1154] = {.lex_state = 212, .external_lex_state = 12},
  [1155] = {.lex_state = 206, .external_lex_state = 12},
  [1156] = {.lex_state = 206, .external_lex_state = 11},
  [1157] = {.lex_state = 206, .external_lex_state = 11},
  [1158] = {.lex_state = 84},
  [1159] = {.lex_state = 206, .external_lex_state = 11},
  [1160] = {.lex_state = 236},
  [1161] = {.lex_state = 163},
  [1162] = {.lex_state = 126},
  [1163] = {.lex_state = 206, .external_lex_state = 11},
  [1164] = {.lex_state = 194, .external_lex_state = 20},
  [1165] = {.lex_state = 206, .external_lex_state = 11},
  [1166] = {.lex_state = 194, .external_lex_state = 10},
  [1167] = {.lex_state = 159, .external_lex_state = 10},
  [1168] = {.lex_state = 134},
  [1169] = {.lex_state = 159, .external_lex_state = 10},
  [1170] = {.lex_state = 196, .external_lex_state = 10},
  [1171] = {.lex_state = 194, .external_lex_state = 20},
  [1172] = {.lex_state = 206, .external_lex_state = 11},
  [1173] = {.lex_state = 194, .external_lex_state = 10},
  [1174] = {.lex_state = 206, .external_lex_state = 11},
  [1175] = {.lex_state = 180},
  [1176] = {.lex_state = 206, .external_lex_state = 12},
  [1177] = {.lex_state = 206, .external_lex_state = 12},
  [1178] = {.lex_state = 206, .external_lex_state = 12},
  [1179] = {.lex_state = 173, .external_lex_state = 4},
  [1180] = {.lex_state = 73, .external_lex_state = 2},
  [1181] = {.lex_state = 188, .external_lex_state = 15},
  [1182] = {.lex_state = 239, .external_lex_state = 16},
  [1183] = {.lex_state = 188, .external_lex_state = 15},
  [1184] = {.lex_state = 194, .external_lex_state = 10},
  [1185] = {.lex_state = 194, .external_lex_state = 10},
  [1186] = {.lex_state = 194, .external_lex_state = 20},
  [1187] = {.lex_state = 196, .external_lex_state = 10},
  [1188] = {.lex_state = 194, .external_lex_state = 20},
  [1189] = {.lex_state = 188, .external_lex_state = 15},
  [1190] = {.lex_state = 194, .external_lex_state = 10},
  [1191] = {.lex_state = 124, .external_lex_state = 21},
  [1192] = {.lex_state = 139, .external_lex_state = 10},
  [1193] = {.lex_state = 124, .external_lex_state = 10},
  [1194] = {.lex_state = 188, .external_lex_state = 15},
  [1195] = {.lex_state = 194, .external_lex_state = 10},
  [1196] = {.lex_state = 194, .external_lex_state = 10},
  [1197] = {.lex_state = 173, .external_lex_state = 6},
  [1198] = {.lex_state = 173, .external_lex_state = 6},
  [1199] = {.lex_state = 180},
  [1200] = {.lex_state = 173, .external_lex_state = 6},
  [1201] = {.lex_state = 84},
  [1202] = {.lex_state = 151, .external_lex_state = 6},
  [1203] = {.lex_state = 173, .external_lex_state = 6},
  [1204] = {.lex_state = 194, .external_lex_state = 20},
  [1205] = {.lex_state = 173, .external_lex_state = 6},
  [1206] = {.lex_state = 194, .external_lex_state = 10},
  [1207] = {.lex_state = 159, .external_lex_state = 10},
  [1208] = {.lex_state = 134},
  [1209] = {.lex_state = 159, .external_lex_state = 10},
  [1210] = {.lex_state = 196, .external_lex_state = 10},
  [1211] = {.lex_state = 194, .external_lex_state = 20},
  [1212] = {.lex_state = 173, .external_lex_state = 6},
  [1213] = {.lex_state = 194, .external_lex_state = 10},
  [1214] = {.lex_state = 73, .external_lex_state = 23},
  [1215] = {.lex_state = 73, .external_lex_state = 23},
  [1216] = {.lex_state = 73},
  [1217] = {.lex_state = 84, .external_lex_state = 2},
  [1218] = {.lex_state = 73},
  [1219] = {.lex_state = 159, .external_lex_state = 10},
  [1220] = {.lex_state = 163, .external_lex_state = 5},
  [1221] = {.lex_state = 134},
  [1222] = {.lex_state = 159, .external_lex_state = 10},
  [1223] = {.lex_state = 210, .external_lex_state = 12},
  [1224] = {.lex_state = 73, .external_lex_state = 23},
  [1225] = {.lex_state = 73, .external_lex_state = 2},
  [1226] = {.lex_state = 175, .external_lex_state = 12},
  [1227] = {.lex_state = 155, .external_lex_state = 9},
  [1228] = {.lex_state = 151, .external_lex_state = 6},
  [1229] = {.lex_state = 84, .external_lex_state = 8},
  [1230] = {.lex_state = 194, .external_lex_state = 10},
  [1231] = {.lex_state = 194, .external_lex_state = 10},
  [1232] = {.lex_state = 124, .external_lex_state = 21},
  [1233] = {.lex_state = 139, .external_lex_state = 10},
  [1234] = {.lex_state = 124, .external_lex_state = 10},
  [1235] = {.lex_state = 84, .external_lex_state = 8},
  [1236] = {.lex_state = 194, .external_lex_state = 10},
  [1237] = {.lex_state = 194, .external_lex_state = 10},
  [1238] = {.lex_state = 84, .external_lex_state = 8},
  [1239] = {.lex_state = 84, .external_lex_state = 8},
  [1240] = {.lex_state = 194, .external_lex_state = 10},
  [1241] = {.lex_state = 88, .external_lex_state = 3},
  [1242] = {.lex_state = 88, .external_lex_state = 9},
  [1243] = {.lex_state = 194, .external_lex_state = 10},
  [1244] = {.lex_state = 194, .external_lex_state = 10},
  [1245] = {.lex_state = 124, .external_lex_state = 21},
  [1246] = {.lex_state = 139, .external_lex_state = 10},
  [1247] = {.lex_state = 124, .external_lex_state = 10},
  [1248] = {.lex_state = 88, .external_lex_state = 9},
  [1249] = {.lex_state = 194, .external_lex_state = 10},
  [1250] = {.lex_state = 194, .external_lex_state = 10},
  [1251] = {.lex_state = 88, .external_lex_state = 9},
  [1252] = {.lex_state = 88, .external_lex_state = 9},
  [1253] = {.lex_state = 194, .external_lex_state = 10},
  [1254] = {.lex_state = 88, .external_lex_state = 6},
  [1255] = {.lex_state = 194, .external_lex_state = 10},
  [1256] = {.lex_state = 194, .external_lex_state = 10},
  [1257] = {.lex_state = 124, .external_lex_state = 21},
  [1258] = {.lex_state = 139, .external_lex_state = 10},
  [1259] = {.lex_state = 124, .external_lex_state = 10},
  [1260] = {.lex_state = 88, .external_lex_state = 6},
  [1261] = {.lex_state = 194, .external_lex_state = 10},
  [1262] = {.lex_state = 194, .external_lex_state = 10},
  [1263] = {.lex_state = 88, .external_lex_state = 6},
  [1264] = {.lex_state = 88, .external_lex_state = 6},
  [1265] = {.lex_state = 194, .external_lex_state = 10},
  [1266] = {.lex_state = 119, .external_lex_state = 6},
  [1267] = {.lex_state = 241, .external_lex_state = 10},
  [1268] = {.lex_state = 194, .external_lex_state = 21},
  [1269] = {.lex_state = 194, .external_lex_state = 10},
  [1270] = {.lex_state = 194, .external_lex_state = 10},
  [1271] = {.lex_state = 194, .external_lex_state = 20},
  [1272] = {.lex_state = 196, .external_lex_state = 10},
  [1273] = {.lex_state = 194, .external_lex_state = 20},
  [1274] = {.lex_state = 194, .external_lex_state = 21},
  [1275] = {.lex_state = 194, .external_lex_state = 10},
  [1276] = {.lex_state = 124, .external_lex_state = 21},
  [1277] = {.lex_state = 139, .external_lex_state = 10},
  [1278] = {.lex_state = 124, .external_lex_state = 10},
  [1279] = {.lex_state = 194, .external_lex_state = 21},
  [1280] = {.lex_state = 194, .external_lex_state = 10},
  [1281] = {.lex_state = 194, .external_lex_state = 10},
  [1282] = {.lex_state = 194, .external_lex_state = 21},
  [1283] = {.lex_state = 194, .external_lex_state = 10},
  [1284] = {.lex_state = 119, .external_lex_state = 6},
  [1285] = {.lex_state = 119, .external_lex_state = 6},
  [1286] = {.lex_state = 194, .external_lex_state = 10},
  [1287] = {.lex_state = 124, .external_lex_state = 21},
  [1288] = {.lex_state = 124, .external_lex_state = 21},
  [1289] = {.lex_state = 180},
  [1290] = {.lex_state = 124, .external_lex_state = 21},
  [1291] = {.lex_state = 84},
  [1292] = {.lex_state = 124, .external_lex_state = 21},
  [1293] = {.lex_state = 124, .external_lex_state = 21},
  [1294] = {.lex_state = 194, .external_lex_state = 20},
  [1295] = {.lex_state = 124, .external_lex_state = 21},
  [1296] = {.lex_state = 194, .external_lex_state = 10},
  [1297] = {.lex_state = 159, .external_lex_state = 10},
  [1298] = {.lex_state = 134},
  [1299] = {.lex_state = 159, .external_lex_state = 10},
  [1300] = {.lex_state = 196, .external_lex_state = 10},
  [1301] = {.lex_state = 194, .external_lex_state = 20},
  [1302] = {.lex_state = 124, .external_lex_state = 21},
  [1303] = {.lex_state = 194, .external_lex_state = 10},
  [1304] = {.lex_state = 159, .external_lex_state = 10},
  [1305] = {.lex_state = 159, .external_lex_state = 21},
  [1306] = {.lex_state = 159, .external_lex_state = 10},
  [1307] = {.lex_state = 159, .external_lex_state = 21},
  [1308] = {.lex_state = 119, .external_lex_state = 6},
  [1309] = {.lex_state = 155, .external_lex_state = 9},
  [1310] = {.lex_state = 151, .external_lex_state = 6},
  [1311] = {.lex_state = 73, .external_lex_state = 2},
  [1312] = {.lex_state = 73, .external_lex_state = 2},
  [1313] = {.lex_state = 173, .external_lex_state = 4},
  [1314] = {.lex_state = 84},
  [1315] = {.lex_state = 173, .external_lex_state = 4},
  [1316] = {.lex_state = 167},
  [1317] = {.lex_state = 84},
  [1318] = {.lex_state = 84},
  [1319] = {.lex_state = 243, .external_lex_state = 2},
  [1320] = {.lex_state = 84, .external_lex_state = 13},
  [1321] = {.lex_state = 84},
  [1322] = {.lex_state = 243, .external_lex_state = 2},
  [1323] = {.lex_state = 84},
  [1324] = {.lex_state = 84},
  [1325] = {.lex_state = 84},
  [1326] = {.lex_state = 175, .external_lex_state = 11},
  [1327] = {.lex_state = 194, .external_lex_state = 10},
  [1328] = {.lex_state = 194, .external_lex_state = 10},
  [1329] = {.lex_state = 124, .external_lex_state = 21},
  [1330] = {.lex_state = 139, .external_lex_state = 10},
  [1331] = {.lex_state = 124, .external_lex_state = 10},
  [1332] = {.lex_state = 175, .external_lex_state = 11},
  [1333] = {.lex_state = 194, .external_lex_state = 10},
  [1334] = {.lex_state = 194, .external_lex_state = 10},
  [1335] = {.lex_state = 175, .external_lex_state = 11},
  [1336] = {.lex_state = 175, .external_lex_state = 11},
  [1337] = {.lex_state = 194, .external_lex_state = 10},
  [1338] = {.lex_state = 173, .external_lex_state = 4},
  [1339] = {.lex_state = 167},
  [1340] = {.lex_state = 84},
  [1341] = {.lex_state = 202, .external_lex_state = 13},
  [1342] = {.lex_state = 194, .external_lex_state = 10},
  [1343] = {.lex_state = 194, .external_lex_state = 10},
  [1344] = {.lex_state = 124, .external_lex_state = 21},
  [1345] = {.lex_state = 139, .external_lex_state = 10},
  [1346] = {.lex_state = 124, .external_lex_state = 10},
  [1347] = {.lex_state = 202, .external_lex_state = 13},
  [1348] = {.lex_state = 194, .external_lex_state = 10},
  [1349] = {.lex_state = 194, .external_lex_state = 10},
  [1350] = {.lex_state = 202, .external_lex_state = 13},
  [1351] = {.lex_state = 202, .external_lex_state = 13},
  [1352] = {.lex_state = 194, .external_lex_state = 10},
  [1353] = {.lex_state = 151, .external_lex_state = 6},
  [1354] = {.lex_state = 73, .external_lex_state = 2},
  [1355] = {.lex_state = 84, .external_lex_state = 2},
  [1356] = {.lex_state = 84, .external_lex_state = 13},
  [1357] = {.lex_state = 84, .external_lex_state = 13},
  [1358] = {.lex_state = 180},
  [1359] = {.lex_state = 84, .external_lex_state = 13},
  [1360] = {.lex_state = 84},
  [1361] = {.lex_state = 84, .external_lex_state = 13},
  [1362] = {.lex_state = 84, .external_lex_state = 13},
  [1363] = {.lex_state = 194, .external_lex_state = 20},
  [1364] = {.lex_state = 84, .external_lex_state = 13},
  [1365] = {.lex_state = 194, .external_lex_state = 10},
  [1366] = {.lex_state = 159, .external_lex_state = 10},
  [1367] = {.lex_state = 134},
  [1368] = {.lex_state = 159, .external_lex_state = 10},
  [1369] = {.lex_state = 196, .external_lex_state = 10},
  [1370] = {.lex_state = 194, .external_lex_state = 20},
  [1371] = {.lex_state = 84, .external_lex_state = 13},
  [1372] = {.lex_state = 194, .external_lex_state = 10},
  [1373] = {.lex_state = 155, .external_lex_state = 9},
  [1374] = {.lex_state = 228, .external_lex_state = 3},
  [1375] = {.lex_state = 155, .external_lex_state = 9},
  [1376] = {.lex_state = 194, .external_lex_state = 10},
  [1377] = {.lex_state = 194, .external_lex_state = 10},
  [1378] = {.lex_state = 194, .external_lex_state = 20},
  [1379] = {.lex_state = 196, .external_lex_state = 10},
  [1380] = {.lex_state = 194, .external_lex_state = 20},
  [1381] = {.lex_state = 155, .external_lex_state = 9},
  [1382] = {.lex_state = 194, .external_lex_state = 10},
  [1383] = {.lex_state = 124, .external_lex_state = 21},
  [1384] = {.lex_state = 139, .external_lex_state = 10},
  [1385] = {.lex_state = 124, .external_lex_state = 10},
  [1386] = {.lex_state = 155, .external_lex_state = 9},
  [1387] = {.lex_state = 194, .external_lex_state = 10},
  [1388] = {.lex_state = 194, .external_lex_state = 10},
  [1389] = {.lex_state = 134},
  [1390] = {.lex_state = 239, .external_lex_state = 15},
  [1391] = {.lex_state = 134},
  [1392] = {.lex_state = 144, .external_lex_state = 13},
  [1393] = {.lex_state = 194, .external_lex_state = 10},
  [1394] = {.lex_state = 194, .external_lex_state = 10},
  [1395] = {.lex_state = 124, .external_lex_state = 21},
  [1396] = {.lex_state = 139, .external_lex_state = 10},
  [1397] = {.lex_state = 124, .external_lex_state = 10},
  [1398] = {.lex_state = 144, .external_lex_state = 13},
  [1399] = {.lex_state = 194, .external_lex_state = 10},
  [1400] = {.lex_state = 194, .external_lex_state = 10},
  [1401] = {.lex_state = 144, .external_lex_state = 13},
  [1402] = {.lex_state = 144, .external_lex_state = 13},
  [1403] = {.lex_state = 194, .external_lex_state = 10},
  [1404] = {.lex_state = 212, .external_lex_state = 11},
  [1405] = {.lex_state = 212, .external_lex_state = 11},
  [1406] = {.lex_state = 180},
  [1407] = {.lex_state = 212, .external_lex_state = 11},
  [1408] = {.lex_state = 84},
  [1409] = {.lex_state = 212, .external_lex_state = 11},
  [1410] = {.lex_state = 212, .external_lex_state = 11},
  [1411] = {.lex_state = 194, .external_lex_state = 20},
  [1412] = {.lex_state = 212, .external_lex_state = 11},
  [1413] = {.lex_state = 194, .external_lex_state = 10},
  [1414] = {.lex_state = 159, .external_lex_state = 10},
  [1415] = {.lex_state = 134},
  [1416] = {.lex_state = 159, .external_lex_state = 10},
  [1417] = {.lex_state = 196, .external_lex_state = 10},
  [1418] = {.lex_state = 194, .external_lex_state = 20},
  [1419] = {.lex_state = 212, .external_lex_state = 11},
  [1420] = {.lex_state = 194, .external_lex_state = 10},
  [1421] = {.lex_state = 173, .external_lex_state = 4},
  [1422] = {.lex_state = 245, .external_lex_state = 12},
  [1423] = {.lex_state = 236},
  [1424] = {.lex_state = 173, .external_lex_state = 4},
  [1425] = {.lex_state = 236},
  [1426] = {.lex_state = 163},
  [1427] = {.lex_state = 206, .external_lex_state = 11},
  [1428] = {.lex_state = 194, .external_lex_state = 10},
  [1429] = {.lex_state = 194, .external_lex_state = 10},
  [1430] = {.lex_state = 194, .external_lex_state = 20},
  [1431] = {.lex_state = 196, .external_lex_state = 10},
  [1432] = {.lex_state = 194, .external_lex_state = 20},
  [1433] = {.lex_state = 206, .external_lex_state = 11},
  [1434] = {.lex_state = 194, .external_lex_state = 10},
  [1435] = {.lex_state = 124, .external_lex_state = 21},
  [1436] = {.lex_state = 139, .external_lex_state = 10},
  [1437] = {.lex_state = 124, .external_lex_state = 10},
  [1438] = {.lex_state = 206, .external_lex_state = 11},
  [1439] = {.lex_state = 194, .external_lex_state = 10},
  [1440] = {.lex_state = 194, .external_lex_state = 10},
  [1441] = {.lex_state = 206, .external_lex_state = 11},
  [1442] = {.lex_state = 126},
  [1443] = {.lex_state = 188, .external_lex_state = 15},
  [1444] = {.lex_state = 194, .external_lex_state = 10},
  [1445] = {.lex_state = 194, .external_lex_state = 10},
  [1446] = {.lex_state = 124, .external_lex_state = 21},
  [1447] = {.lex_state = 139, .external_lex_state = 10},
  [1448] = {.lex_state = 124, .external_lex_state = 10},
  [1449] = {.lex_state = 188, .external_lex_state = 15},
  [1450] = {.lex_state = 194, .external_lex_state = 10},
  [1451] = {.lex_state = 194, .external_lex_state = 10},
  [1452] = {.lex_state = 188, .external_lex_state = 15},
  [1453] = {.lex_state = 188, .external_lex_state = 15},
  [1454] = {.lex_state = 194, .external_lex_state = 10},
  [1455] = {.lex_state = 173, .external_lex_state = 6},
  [1456] = {.lex_state = 247, .external_lex_state = 4},
  [1457] = {.lex_state = 173, .external_lex_state = 6},
  [1458] = {.lex_state = 194, .external_lex_state = 10},
  [1459] = {.lex_state = 194, .external_lex_state = 10},
  [1460] = {.lex_state = 194, .external_lex_state = 20},
  [1461] = {.lex_state = 196, .external_lex_state = 10},
  [1462] = {.lex_state = 194, .external_lex_state = 20},
  [1463] = {.lex_state = 173, .external_lex_state = 6},
  [1464] = {.lex_state = 194, .external_lex_state = 10},
  [1465] = {.lex_state = 124, .external_lex_state = 21},
  [1466] = {.lex_state = 139, .external_lex_state = 10},
  [1467] = {.lex_state = 124, .external_lex_state = 10},
  [1468] = {.lex_state = 173, .external_lex_state = 6},
  [1469] = {.lex_state = 194, .external_lex_state = 10},
  [1470] = {.lex_state = 194, .external_lex_state = 10},
  [1471] = {.lex_state = 73, .external_lex_state = 23},
  [1472] = {.lex_state = 194, .external_lex_state = 20},
  [1473] = {.lex_state = 73, .external_lex_state = 23},
  [1474] = {.lex_state = 194, .external_lex_state = 10},
  [1475] = {.lex_state = 159, .external_lex_state = 10},
  [1476] = {.lex_state = 134},
  [1477] = {.lex_state = 159, .external_lex_state = 10},
  [1478] = {.lex_state = 196, .external_lex_state = 10},
  [1479] = {.lex_state = 194, .external_lex_state = 20},
  [1480] = {.lex_state = 73, .external_lex_state = 23},
  [1481] = {.lex_state = 194, .external_lex_state = 10},
  [1482] = {.lex_state = 73, .external_lex_state = 2},
  [1483] = {.lex_state = 84, .external_lex_state = 8},
  [1484] = {.lex_state = 194, .external_lex_state = 10},
  [1485] = {.lex_state = 84, .external_lex_state = 8},
  [1486] = {.lex_state = 84, .external_lex_state = 8},
  [1487] = {.lex_state = 194, .external_lex_state = 10},
  [1488] = {.lex_state = 84, .external_lex_state = 8},
  [1489] = {.lex_state = 88, .external_lex_state = 9},
  [1490] = {.lex_state = 194, .external_lex_state = 10},
  [1491] = {.lex_state = 88, .external_lex_state = 9},
  [1492] = {.lex_state = 88, .external_lex_state = 9},
  [1493] = {.lex_state = 194, .external_lex_state = 10},
  [1494] = {.lex_state = 88, .external_lex_state = 9},
  [1495] = {.lex_state = 88, .external_lex_state = 6},
  [1496] = {.lex_state = 194, .external_lex_state = 10},
  [1497] = {.lex_state = 88, .external_lex_state = 6},
  [1498] = {.lex_state = 88, .external_lex_state = 6},
  [1499] = {.lex_state = 194, .external_lex_state = 10},
  [1500] = {.lex_state = 88, .external_lex_state = 6},
  [1501] = {.lex_state = 194, .external_lex_state = 21},
  [1502] = {.lex_state = 194, .external_lex_state = 10},
  [1503] = {.lex_state = 194, .external_lex_state = 10},
  [1504] = {.lex_state = 124, .external_lex_state = 21},
  [1505] = {.lex_state = 139, .external_lex_state = 10},
  [1506] = {.lex_state = 124, .external_lex_state = 10},
  [1507] = {.lex_state = 194, .external_lex_state = 21},
  [1508] = {.lex_state = 194, .external_lex_state = 10},
  [1509] = {.lex_state = 194, .external_lex_state = 10},
  [1510] = {.lex_state = 194, .external_lex_state = 21},
  [1511] = {.lex_state = 194, .external_lex_state = 21},
  [1512] = {.lex_state = 194, .external_lex_state = 10},
  [1513] = {.lex_state = 119, .external_lex_state = 6},
  [1514] = {.lex_state = 119, .external_lex_state = 6},
  [1515] = {.lex_state = 124, .external_lex_state = 21},
  [1516] = {.lex_state = 249, .external_lex_state = 10},
  [1517] = {.lex_state = 124, .external_lex_state = 21},
  [1518] = {.lex_state = 194, .external_lex_state = 10},
  [1519] = {.lex_state = 194, .external_lex_state = 10},
  [1520] = {.lex_state = 194, .external_lex_state = 20},
  [1521] = {.lex_state = 196, .external_lex_state = 10},
  [1522] = {.lex_state = 194, .external_lex_state = 20},
  [1523] = {.lex_state = 124, .external_lex_state = 21},
  [1524] = {.lex_state = 194, .external_lex_state = 10},
  [1525] = {.lex_state = 124, .external_lex_state = 21},
  [1526] = {.lex_state = 139, .external_lex_state = 10},
  [1527] = {.lex_state = 124, .external_lex_state = 10},
  [1528] = {.lex_state = 124, .external_lex_state = 21},
  [1529] = {.lex_state = 194, .external_lex_state = 10},
  [1530] = {.lex_state = 194, .external_lex_state = 10},
  [1531] = {.lex_state = 159, .external_lex_state = 10},
  [1532] = {.lex_state = 159, .external_lex_state = 10},
  [1533] = {.lex_state = 73, .external_lex_state = 2},
  [1534] = {.lex_state = 173, .external_lex_state = 4},
  [1535] = {.lex_state = 173, .external_lex_state = 4},
  [1536] = {.lex_state = 167},
  [1537] = {.lex_state = 84, .external_lex_state = 13},
  [1538] = {.lex_state = 84},
  [1539] = {.lex_state = 84},
  [1540] = {.lex_state = 251, .external_lex_state = 3},
  [1541] = {.lex_state = 251, .external_lex_state = 4},
  [1542] = {.lex_state = 94},
  [1543] = {.lex_state = 73, .external_lex_state = 2},
  [1544] = {.lex_state = 73, .external_lex_state = 2},
  [1545] = {.lex_state = 94, .external_lex_state = 5},
  [1546] = {.lex_state = 258, .external_lex_state = 6},
  [1547] = {.lex_state = 258, .external_lex_state = 6},
  [1548] = {.lex_state = 258, .external_lex_state = 6},
  [1549] = {.lex_state = 73, .external_lex_state = 2},
  [1550] = {.lex_state = 132, .external_lex_state = 2},
  [1551] = {.lex_state = 134},
  [1552] = {.lex_state = 144},
  [1553] = {.lex_state = 222},
  [1554] = {.lex_state = 258, .external_lex_state = 4},
  [1555] = {.lex_state = 261, .external_lex_state = 4},
  [1556] = {.lex_state = 263, .external_lex_state = 3},
  [1557] = {.lex_state = 134},
  [1558] = {.lex_state = 258, .external_lex_state = 4},
  [1559] = {.lex_state = 73, .external_lex_state = 2},
  [1560] = {.lex_state = 84, .external_lex_state = 2},
  [1561] = {.lex_state = 167},
  [1562] = {.lex_state = 258, .external_lex_state = 4},
  [1563] = {.lex_state = 84, .external_lex_state = 13},
  [1564] = {.lex_state = 243, .external_lex_state = 2},
  [1565] = {.lex_state = 84},
  [1566] = {.lex_state = 222},
  [1567] = {.lex_state = 167},
  [1568] = {.lex_state = 243, .external_lex_state = 2},
  [1569] = {.lex_state = 84, .external_lex_state = 13},
  [1570] = {.lex_state = 84},
  [1571] = {.lex_state = 84},
  [1572] = {.lex_state = 175, .external_lex_state = 11},
  [1573] = {.lex_state = 194, .external_lex_state = 10},
  [1574] = {.lex_state = 175, .external_lex_state = 11},
  [1575] = {.lex_state = 175, .external_lex_state = 11},
  [1576] = {.lex_state = 194, .external_lex_state = 10},
  [1577] = {.lex_state = 175, .external_lex_state = 11},
  [1578] = {.lex_state = 173, .external_lex_state = 4},
  [1579] = {.lex_state = 167},
  [1580] = {.lex_state = 202, .external_lex_state = 13},
  [1581] = {.lex_state = 194, .external_lex_state = 10},
  [1582] = {.lex_state = 202, .external_lex_state = 13},
  [1583] = {.lex_state = 202, .external_lex_state = 13},
  [1584] = {.lex_state = 194, .external_lex_state = 10},
  [1585] = {.lex_state = 202, .external_lex_state = 13},
  [1586] = {.lex_state = 84, .external_lex_state = 13},
  [1587] = {.lex_state = 226},
  [1588] = {.lex_state = 84, .external_lex_state = 13},
  [1589] = {.lex_state = 194, .external_lex_state = 10},
  [1590] = {.lex_state = 194, .external_lex_state = 10},
  [1591] = {.lex_state = 194, .external_lex_state = 20},
  [1592] = {.lex_state = 196, .external_lex_state = 10},
  [1593] = {.lex_state = 194, .external_lex_state = 20},
  [1594] = {.lex_state = 84, .external_lex_state = 13},
  [1595] = {.lex_state = 194, .external_lex_state = 10},
  [1596] = {.lex_state = 124, .external_lex_state = 21},
  [1597] = {.lex_state = 139, .external_lex_state = 10},
  [1598] = {.lex_state = 124, .external_lex_state = 10},
  [1599] = {.lex_state = 84, .external_lex_state = 13},
  [1600] = {.lex_state = 194, .external_lex_state = 10},
  [1601] = {.lex_state = 194, .external_lex_state = 10},
  [1602] = {.lex_state = 155, .external_lex_state = 9},
  [1603] = {.lex_state = 194, .external_lex_state = 10},
  [1604] = {.lex_state = 194, .external_lex_state = 10},
  [1605] = {.lex_state = 124, .external_lex_state = 21},
  [1606] = {.lex_state = 139, .external_lex_state = 10},
  [1607] = {.lex_state = 124, .external_lex_state = 10},
  [1608] = {.lex_state = 155, .external_lex_state = 9},
  [1609] = {.lex_state = 194, .external_lex_state = 10},
  [1610] = {.lex_state = 194, .external_lex_state = 10},
  [1611] = {.lex_state = 155, .external_lex_state = 9},
  [1612] = {.lex_state = 155, .external_lex_state = 9},
  [1613] = {.lex_state = 194, .external_lex_state = 10},
  [1614] = {.lex_state = 144, .external_lex_state = 13},
  [1615] = {.lex_state = 194, .external_lex_state = 10},
  [1616] = {.lex_state = 144, .external_lex_state = 13},
  [1617] = {.lex_state = 144, .external_lex_state = 13},
  [1618] = {.lex_state = 194, .external_lex_state = 10},
  [1619] = {.lex_state = 144, .external_lex_state = 13},
  [1620] = {.lex_state = 212, .external_lex_state = 11},
  [1621] = {.lex_state = 266, .external_lex_state = 12},
  [1622] = {.lex_state = 212, .external_lex_state = 11},
  [1623] = {.lex_state = 194, .external_lex_state = 10},
  [1624] = {.lex_state = 194, .external_lex_state = 10},
  [1625] = {.lex_state = 194, .external_lex_state = 20},
  [1626] = {.lex_state = 196, .external_lex_state = 10},
  [1627] = {.lex_state = 194, .external_lex_state = 20},
  [1628] = {.lex_state = 212, .external_lex_state = 11},
  [1629] = {.lex_state = 194, .external_lex_state = 10},
  [1630] = {.lex_state = 124, .external_lex_state = 21},
  [1631] = {.lex_state = 139, .external_lex_state = 10},
  [1632] = {.lex_state = 124, .external_lex_state = 10},
  [1633] = {.lex_state = 212, .external_lex_state = 11},
  [1634] = {.lex_state = 194, .external_lex_state = 10},
  [1635] = {.lex_state = 194, .external_lex_state = 10},
  [1636] = {.lex_state = 173, .external_lex_state = 4},
  [1637] = {.lex_state = 236},
  [1638] = {.lex_state = 236},
  [1639] = {.lex_state = 206, .external_lex_state = 11},
  [1640] = {.lex_state = 194, .external_lex_state = 10},
  [1641] = {.lex_state = 194, .external_lex_state = 10},
  [1642] = {.lex_state = 124, .external_lex_state = 21},
  [1643] = {.lex_state = 139, .external_lex_state = 10},
  [1644] = {.lex_state = 124, .external_lex_state = 10},
  [1645] = {.lex_state = 206, .external_lex_state = 11},
  [1646] = {.lex_state = 194, .external_lex_state = 10},
  [1647] = {.lex_state = 194, .external_lex_state = 10},
  [1648] = {.lex_state = 206, .external_lex_state = 11},
  [1649] = {.lex_state = 206, .external_lex_state = 11},
  [1650] = {.lex_state = 194, .external_lex_state = 10},
  [1651] = {.lex_state = 163},
  [1652] = {.lex_state = 188, .external_lex_state = 15},
  [1653] = {.lex_state = 194, .external_lex_state = 10},
  [1654] = {.lex_state = 188, .external_lex_state = 15},
  [1655] = {.lex_state = 188, .external_lex_state = 15},
  [1656] = {.lex_state = 194, .external_lex_state = 10},
  [1657] = {.lex_state = 188, .external_lex_state = 15},
  [1658] = {.lex_state = 173, .external_lex_state = 6},
  [1659] = {.lex_state = 194, .external_lex_state = 10},
  [1660] = {.lex_state = 194, .external_lex_state = 10},
  [1661] = {.lex_state = 124, .external_lex_state = 21},
  [1662] = {.lex_state = 139, .external_lex_state = 10},
  [1663] = {.lex_state = 124, .external_lex_state = 10},
  [1664] = {.lex_state = 173, .external_lex_state = 6},
  [1665] = {.lex_state = 194, .external_lex_state = 10},
  [1666] = {.lex_state = 194, .external_lex_state = 10},
  [1667] = {.lex_state = 173, .external_lex_state = 6},
  [1668] = {.lex_state = 173, .external_lex_state = 6},
  [1669] = {.lex_state = 194, .external_lex_state = 10},
  [1670] = {.lex_state = 73, .external_lex_state = 23},
  [1671] = {.lex_state = 194, .external_lex_state = 10},
  [1672] = {.lex_state = 194, .external_lex_state = 10},
  [1673] = {.lex_state = 194, .external_lex_state = 20},
  [1674] = {.lex_state = 196, .external_lex_state = 10},
  [1675] = {.lex_state = 194, .external_lex_state = 20},
  [1676] = {.lex_state = 73, .external_lex_state = 23},
  [1677] = {.lex_state = 194, .external_lex_state = 10},
  [1678] = {.lex_state = 124, .external_lex_state = 21},
  [1679] = {.lex_state = 139, .external_lex_state = 10},
  [1680] = {.lex_state = 124, .external_lex_state = 10},
  [1681] = {.lex_state = 73, .external_lex_state = 23},
  [1682] = {.lex_state = 194, .external_lex_state = 10},
  [1683] = {.lex_state = 194, .external_lex_state = 10},
  [1684] = {.lex_state = 84, .external_lex_state = 8},
  [1685] = {.lex_state = 84, .external_lex_state = 8},
  [1686] = {.lex_state = 88, .external_lex_state = 9},
  [1687] = {.lex_state = 88, .external_lex_state = 9},
  [1688] = {.lex_state = 88, .external_lex_state = 6},
  [1689] = {.lex_state = 88, .external_lex_state = 6},
  [1690] = {.lex_state = 194, .external_lex_state = 21},
  [1691] = {.lex_state = 194, .external_lex_state = 10},
  [1692] = {.lex_state = 194, .external_lex_state = 21},
  [1693] = {.lex_state = 194, .external_lex_state = 21},
  [1694] = {.lex_state = 194, .external_lex_state = 10},
  [1695] = {.lex_state = 194, .external_lex_state = 21},
  [1696] = {.lex_state = 124, .external_lex_state = 21},
  [1697] = {.lex_state = 194, .external_lex_state = 10},
  [1698] = {.lex_state = 194, .external_lex_state = 10},
  [1699] = {.lex_state = 124, .external_lex_state = 21},
  [1700] = {.lex_state = 139, .external_lex_state = 10},
  [1701] = {.lex_state = 124, .external_lex_state = 10},
  [1702] = {.lex_state = 124, .external_lex_state = 21},
  [1703] = {.lex_state = 194, .external_lex_state = 10},
  [1704] = {.lex_state = 194, .external_lex_state = 10},
  [1705] = {.lex_state = 124, .external_lex_state = 21},
  [1706] = {.lex_state = 124, .external_lex_state = 21},
  [1707] = {.lex_state = 194, .external_lex_state = 10},
  [1708] = {.lex_state = 173, .external_lex_state = 4},
  [1709] = {.lex_state = 73, .external_lex_state = 2},
  [1710] = {.lex_state = 144},
  [1711] = {.lex_state = 251, .external_lex_state = 9},
  [1712] = {.lex_state = 73, .external_lex_state = 2},
  [1713] = {.lex_state = 134},
  [1714] = {.lex_state = 94},
  [1715] = {.lex_state = 73, .external_lex_state = 2},
  [1716] = {.lex_state = 251, .external_lex_state = 9},
  [1717] = {.lex_state = 94, .external_lex_state = 5},
  [1718] = {.lex_state = 251, .external_lex_state = 3},
  [1719] = {.lex_state = 251, .external_lex_state = 3},
  [1720] = {.lex_state = 134},
  [1721] = {.lex_state = 73, .external_lex_state = 2},
  [1722] = {.lex_state = 144},
  [1723] = {.lex_state = 251, .external_lex_state = 6},
  [1724] = {.lex_state = 73, .external_lex_state = 2},
  [1725] = {.lex_state = 94},
  [1726] = {.lex_state = 73, .external_lex_state = 2},
  [1727] = {.lex_state = 251, .external_lex_state = 6},
  [1728] = {.lex_state = 94, .external_lex_state = 5},
  [1729] = {.lex_state = 251, .external_lex_state = 4},
  [1730] = {.lex_state = 251, .external_lex_state = 4},
  [1731] = {.lex_state = 258, .external_lex_state = 6},
  [1732] = {.lex_state = 258, .external_lex_state = 6},
  [1733] = {.lex_state = 258, .external_lex_state = 6},
  [1734] = {.lex_state = 73},
  [1735] = {.lex_state = 84, .external_lex_state = 2},
  [1736] = {.lex_state = 73},
  [1737] = {.lex_state = 159, .external_lex_state = 10},
  [1738] = {.lex_state = 163, .external_lex_state = 5},
  [1739] = {.lex_state = 134},
  [1740] = {.lex_state = 159, .external_lex_state = 10},
  [1741] = {.lex_state = 84},
  [1742] = {.lex_state = 258, .external_lex_state = 6},
  [1743] = {.lex_state = 73},
  [1744] = {.lex_state = 84, .external_lex_state = 14},
  [1745] = {.lex_state = 180},
  [1746] = {.lex_state = 258, .external_lex_state = 6},
  [1747] = {.lex_state = 144},
  [1748] = {.lex_state = 258, .external_lex_state = 4},
  [1749] = {.lex_state = 258, .external_lex_state = 4},
  [1750] = {.lex_state = 73, .external_lex_state = 2},
  [1751] = {.lex_state = 84},
  [1752] = {.lex_state = 243, .external_lex_state = 17},
  [1753] = {.lex_state = 243, .external_lex_state = 2},
  [1754] = {.lex_state = 139},
  [1755] = {.lex_state = 73, .external_lex_state = 2},
  [1756] = {.lex_state = 84},
  [1757] = {.lex_state = 261, .external_lex_state = 4},
  [1758] = {.lex_state = 261, .external_lex_state = 4},
  [1759] = {.lex_state = 263, .external_lex_state = 3},
  [1760] = {.lex_state = 258, .external_lex_state = 4},
  [1761] = {.lex_state = 222},
  [1762] = {.lex_state = 258, .external_lex_state = 6},
  [1763] = {.lex_state = 84, .external_lex_state = 19},
  [1764] = {.lex_state = 258, .external_lex_state = 4},
  [1765] = {.lex_state = 258, .external_lex_state = 4},
  [1766] = {.lex_state = 167},
  [1767] = {.lex_state = 222},
  [1768] = {.lex_state = 167},
  [1769] = {.lex_state = 73, .external_lex_state = 2},
  [1770] = {.lex_state = 84},
  [1771] = {.lex_state = 73, .external_lex_state = 2},
  [1772] = {.lex_state = 84},
  [1773] = {.lex_state = 175, .external_lex_state = 11},
  [1774] = {.lex_state = 175, .external_lex_state = 11},
  [1775] = {.lex_state = 173, .external_lex_state = 4},
  [1776] = {.lex_state = 202, .external_lex_state = 13},
  [1777] = {.lex_state = 202, .external_lex_state = 13},
  [1778] = {.lex_state = 84, .external_lex_state = 13},
  [1779] = {.lex_state = 194, .external_lex_state = 10},
  [1780] = {.lex_state = 194, .external_lex_state = 10},
  [1781] = {.lex_state = 124, .external_lex_state = 21},
  [1782] = {.lex_state = 139, .external_lex_state = 10},
  [1783] = {.lex_state = 124, .external_lex_state = 10},
  [1784] = {.lex_state = 84, .external_lex_state = 13},
  [1785] = {.lex_state = 194, .external_lex_state = 10},
  [1786] = {.lex_state = 194, .external_lex_state = 10},
  [1787] = {.lex_state = 84, .external_lex_state = 13},
  [1788] = {.lex_state = 84, .external_lex_state = 13},
  [1789] = {.lex_state = 194, .external_lex_state = 10},
  [1790] = {.lex_state = 155, .external_lex_state = 9},
  [1791] = {.lex_state = 194, .external_lex_state = 10},
  [1792] = {.lex_state = 155, .external_lex_state = 9},
  [1793] = {.lex_state = 155, .external_lex_state = 9},
  [1794] = {.lex_state = 194, .external_lex_state = 10},
  [1795] = {.lex_state = 155, .external_lex_state = 9},
  [1796] = {.lex_state = 144, .external_lex_state = 13},
  [1797] = {.lex_state = 144, .external_lex_state = 13},
  [1798] = {.lex_state = 212, .external_lex_state = 11},
  [1799] = {.lex_state = 194, .external_lex_state = 10},
  [1800] = {.lex_state = 194, .external_lex_state = 10},
  [1801] = {.lex_state = 124, .external_lex_state = 21},
  [1802] = {.lex_state = 139, .external_lex_state = 10},
  [1803] = {.lex_state = 124, .external_lex_state = 10},
  [1804] = {.lex_state = 212, .external_lex_state = 11},
  [1805] = {.lex_state = 194, .external_lex_state = 10},
  [1806] = {.lex_state = 194, .external_lex_state = 10},
  [1807] = {.lex_state = 212, .external_lex_state = 11},
  [1808] = {.lex_state = 212, .external_lex_state = 11},
  [1809] = {.lex_state = 194, .external_lex_state = 10},
  [1810] = {.lex_state = 173, .external_lex_state = 4},
  [1811] = {.lex_state = 236},
  [1812] = {.lex_state = 206, .external_lex_state = 11},
  [1813] = {.lex_state = 194, .external_lex_state = 10},
  [1814] = {.lex_state = 206, .external_lex_state = 11},
  [1815] = {.lex_state = 206, .external_lex_state = 11},
  [1816] = {.lex_state = 194, .external_lex_state = 10},
  [1817] = {.lex_state = 206, .external_lex_state = 11},
  [1818] = {.lex_state = 236},
  [1819] = {.lex_state = 188, .external_lex_state = 15},
  [1820] = {.lex_state = 188, .external_lex_state = 15},
  [1821] = {.lex_state = 173, .external_lex_state = 6},
  [1822] = {.lex_state = 194, .external_lex_state = 10},
  [1823] = {.lex_state = 173, .external_lex_state = 6},
  [1824] = {.lex_state = 173, .external_lex_state = 6},
  [1825] = {.lex_state = 194, .external_lex_state = 10},
  [1826] = {.lex_state = 173, .external_lex_state = 6},
  [1827] = {.lex_state = 73, .external_lex_state = 23},
  [1828] = {.lex_state = 194, .external_lex_state = 10},
  [1829] = {.lex_state = 194, .external_lex_state = 10},
  [1830] = {.lex_state = 124, .external_lex_state = 21},
  [1831] = {.lex_state = 139, .external_lex_state = 10},
  [1832] = {.lex_state = 124, .external_lex_state = 10},
  [1833] = {.lex_state = 73, .external_lex_state = 23},
  [1834] = {.lex_state = 194, .external_lex_state = 10},
  [1835] = {.lex_state = 194, .external_lex_state = 10},
  [1836] = {.lex_state = 73, .external_lex_state = 23},
  [1837] = {.lex_state = 73, .external_lex_state = 23},
  [1838] = {.lex_state = 194, .external_lex_state = 10},
  [1839] = {.lex_state = 194, .external_lex_state = 21},
  [1840] = {.lex_state = 194, .external_lex_state = 21},
  [1841] = {.lex_state = 124, .external_lex_state = 21},
  [1842] = {.lex_state = 194, .external_lex_state = 10},
  [1843] = {.lex_state = 124, .external_lex_state = 21},
  [1844] = {.lex_state = 124, .external_lex_state = 21},
  [1845] = {.lex_state = 194, .external_lex_state = 10},
  [1846] = {.lex_state = 124, .external_lex_state = 21},
  [1847] = {.lex_state = 73},
  [1848] = {.lex_state = 180},
  [1849] = {.lex_state = 251, .external_lex_state = 9},
  [1850] = {.lex_state = 144},
  [1851] = {.lex_state = 84},
  [1852] = {.lex_state = 251, .external_lex_state = 9},
  [1853] = {.lex_state = 73},
  [1854] = {.lex_state = 84, .external_lex_state = 14},
  [1855] = {.lex_state = 251, .external_lex_state = 9},
  [1856] = {.lex_state = 251, .external_lex_state = 9},
  [1857] = {.lex_state = 251, .external_lex_state = 9},
  [1858] = {.lex_state = 84, .external_lex_state = 2},
  [1859] = {.lex_state = 73},
  [1860] = {.lex_state = 159, .external_lex_state = 10},
  [1861] = {.lex_state = 163, .external_lex_state = 5},
  [1862] = {.lex_state = 134},
  [1863] = {.lex_state = 159, .external_lex_state = 10},
  [1864] = {.lex_state = 251, .external_lex_state = 3},
  [1865] = {.lex_state = 251, .external_lex_state = 3},
  [1866] = {.lex_state = 251, .external_lex_state = 3},
  [1867] = {.lex_state = 73},
  [1868] = {.lex_state = 180},
  [1869] = {.lex_state = 251, .external_lex_state = 6},
  [1870] = {.lex_state = 144},
  [1871] = {.lex_state = 84},
  [1872] = {.lex_state = 251, .external_lex_state = 6},
  [1873] = {.lex_state = 73},
  [1874] = {.lex_state = 251, .external_lex_state = 6},
  [1875] = {.lex_state = 251, .external_lex_state = 6},
  [1876] = {.lex_state = 251, .external_lex_state = 6},
  [1877] = {.lex_state = 84, .external_lex_state = 2},
  [1878] = {.lex_state = 73},
  [1879] = {.lex_state = 159, .external_lex_state = 10},
  [1880] = {.lex_state = 163, .external_lex_state = 5},
  [1881] = {.lex_state = 134},
  [1882] = {.lex_state = 159, .external_lex_state = 10},
  [1883] = {.lex_state = 251, .external_lex_state = 4},
  [1884] = {.lex_state = 251, .external_lex_state = 4},
  [1885] = {.lex_state = 251, .external_lex_state = 4},
  [1886] = {.lex_state = 258, .external_lex_state = 6},
  [1887] = {.lex_state = 258, .external_lex_state = 6},
  [1888] = {.lex_state = 194, .external_lex_state = 20},
  [1889] = {.lex_state = 258, .external_lex_state = 6},
  [1890] = {.lex_state = 194, .external_lex_state = 10},
  [1891] = {.lex_state = 159, .external_lex_state = 10},
  [1892] = {.lex_state = 134},
  [1893] = {.lex_state = 159, .external_lex_state = 10},
  [1894] = {.lex_state = 196, .external_lex_state = 10},
  [1895] = {.lex_state = 194, .external_lex_state = 20},
  [1896] = {.lex_state = 258, .external_lex_state = 6},
  [1897] = {.lex_state = 194, .external_lex_state = 10},
  [1898] = {.lex_state = 258, .external_lex_state = 6},
  [1899] = {.lex_state = 84},
  [1900] = {.lex_state = 258, .external_lex_state = 6},
  [1901] = {.lex_state = 84},
  [1902] = {.lex_state = 73, .external_lex_state = 2},
  [1903] = {.lex_state = 144},
  [1904] = {.lex_state = 263, .external_lex_state = 9},
  [1905] = {.lex_state = 73, .external_lex_state = 2},
  [1906] = {.lex_state = 94},
  [1907] = {.lex_state = 73, .external_lex_state = 2},
  [1908] = {.lex_state = 263, .external_lex_state = 9},
  [1909] = {.lex_state = 94, .external_lex_state = 5},
  [1910] = {.lex_state = 263, .external_lex_state = 3},
  [1911] = {.lex_state = 263, .external_lex_state = 3},
  [1912] = {.lex_state = 258, .external_lex_state = 6},
  [1913] = {.lex_state = 180},
  [1914] = {.lex_state = 261, .external_lex_state = 4},
  [1915] = {.lex_state = 263, .external_lex_state = 3},
  [1916] = {.lex_state = 261, .external_lex_state = 6},
  [1917] = {.lex_state = 261, .external_lex_state = 6},
  [1918] = {.lex_state = 261, .external_lex_state = 4},
  [1919] = {.lex_state = 269, .external_lex_state = 12},
  [1920] = {.lex_state = 84},
  [1921] = {.lex_state = 261, .external_lex_state = 4},
  [1922] = {.lex_state = 263, .external_lex_state = 3},
  [1923] = {.lex_state = 261, .external_lex_state = 6},
  [1924] = {.lex_state = 261, .external_lex_state = 4},
  [1925] = {.lex_state = 261, .external_lex_state = 4},
  [1926] = {.lex_state = 243, .external_lex_state = 2},
  [1927] = {.lex_state = 243, .external_lex_state = 17},
  [1928] = {.lex_state = 258, .external_lex_state = 4},
  [1929] = {.lex_state = 258, .external_lex_state = 6},
  [1930] = {.lex_state = 258, .external_lex_state = 4},
  [1931] = {.lex_state = 258, .external_lex_state = 4},
  [1932] = {.lex_state = 258, .external_lex_state = 4},
  [1933] = {.lex_state = 222},
  [1934] = {.lex_state = 222},
  [1935] = {.lex_state = 84},
  [1936] = {.lex_state = 151, .external_lex_state = 4},
  [1937] = {.lex_state = 155, .external_lex_state = 3},
  [1938] = {.lex_state = 73, .external_lex_state = 2},
  [1939] = {.lex_state = 73},
  [1940] = {.lex_state = 73, .external_lex_state = 2},
  [1941] = {.lex_state = 84},
  [1942] = {.lex_state = 73},
  [1943] = {.lex_state = 73, .external_lex_state = 2},
  [1944] = {.lex_state = 84, .external_lex_state = 13},
  [1945] = {.lex_state = 194, .external_lex_state = 10},
  [1946] = {.lex_state = 84, .external_lex_state = 13},
  [1947] = {.lex_state = 84, .external_lex_state = 13},
  [1948] = {.lex_state = 194, .external_lex_state = 10},
  [1949] = {.lex_state = 84, .external_lex_state = 13},
  [1950] = {.lex_state = 155, .external_lex_state = 9},
  [1951] = {.lex_state = 155, .external_lex_state = 9},
  [1952] = {.lex_state = 212, .external_lex_state = 11},
  [1953] = {.lex_state = 194, .external_lex_state = 10},
  [1954] = {.lex_state = 212, .external_lex_state = 11},
  [1955] = {.lex_state = 212, .external_lex_state = 11},
  [1956] = {.lex_state = 194, .external_lex_state = 10},
  [1957] = {.lex_state = 212, .external_lex_state = 11},
  [1958] = {.lex_state = 173, .external_lex_state = 4},
  [1959] = {.lex_state = 206, .external_lex_state = 11},
  [1960] = {.lex_state = 206, .external_lex_state = 11},
  [1961] = {.lex_state = 236},
  [1962] = {.lex_state = 173, .external_lex_state = 6},
  [1963] = {.lex_state = 173, .external_lex_state = 6},
  [1964] = {.lex_state = 73, .external_lex_state = 23},
  [1965] = {.lex_state = 194, .external_lex_state = 10},
  [1966] = {.lex_state = 73, .external_lex_state = 23},
  [1967] = {.lex_state = 73, .external_lex_state = 23},
  [1968] = {.lex_state = 194, .external_lex_state = 10},
  [1969] = {.lex_state = 73, .external_lex_state = 23},
  [1970] = {.lex_state = 124, .external_lex_state = 21},
  [1971] = {.lex_state = 124, .external_lex_state = 21},
  [1972] = {.lex_state = 251, .external_lex_state = 9},
  [1973] = {.lex_state = 251, .external_lex_state = 9},
  [1974] = {.lex_state = 180},
  [1975] = {.lex_state = 251, .external_lex_state = 9},
  [1976] = {.lex_state = 84},
  [1977] = {.lex_state = 251, .external_lex_state = 9},
  [1978] = {.lex_state = 251, .external_lex_state = 9},
  [1979] = {.lex_state = 84},
  [1980] = {.lex_state = 251, .external_lex_state = 9},
  [1981] = {.lex_state = 251, .external_lex_state = 3},
  [1982] = {.lex_state = 251, .external_lex_state = 3},
  [1983] = {.lex_state = 194, .external_lex_state = 20},
  [1984] = {.lex_state = 251, .external_lex_state = 9},
  [1985] = {.lex_state = 194, .external_lex_state = 10},
  [1986] = {.lex_state = 159, .external_lex_state = 10},
  [1987] = {.lex_state = 134},
  [1988] = {.lex_state = 159, .external_lex_state = 10},
  [1989] = {.lex_state = 196, .external_lex_state = 10},
  [1990] = {.lex_state = 194, .external_lex_state = 20},
  [1991] = {.lex_state = 251, .external_lex_state = 9},
  [1992] = {.lex_state = 194, .external_lex_state = 10},
  [1993] = {.lex_state = 251, .external_lex_state = 6},
  [1994] = {.lex_state = 251, .external_lex_state = 6},
  [1995] = {.lex_state = 180},
  [1996] = {.lex_state = 251, .external_lex_state = 6},
  [1997] = {.lex_state = 84},
  [1998] = {.lex_state = 251, .external_lex_state = 6},
  [1999] = {.lex_state = 251, .external_lex_state = 6},
  [2000] = {.lex_state = 194, .external_lex_state = 20},
  [2001] = {.lex_state = 251, .external_lex_state = 6},
  [2002] = {.lex_state = 194, .external_lex_state = 10},
  [2003] = {.lex_state = 159, .external_lex_state = 10},
  [2004] = {.lex_state = 134},
  [2005] = {.lex_state = 159, .external_lex_state = 10},
  [2006] = {.lex_state = 196, .external_lex_state = 10},
  [2007] = {.lex_state = 194, .external_lex_state = 20},
  [2008] = {.lex_state = 251, .external_lex_state = 6},
  [2009] = {.lex_state = 194, .external_lex_state = 10},
  [2010] = {.lex_state = 258, .external_lex_state = 6},
  [2011] = {.lex_state = 194, .external_lex_state = 10},
  [2012] = {.lex_state = 194, .external_lex_state = 10},
  [2013] = {.lex_state = 194, .external_lex_state = 20},
  [2014] = {.lex_state = 196, .external_lex_state = 10},
  [2015] = {.lex_state = 194, .external_lex_state = 20},
  [2016] = {.lex_state = 258, .external_lex_state = 6},
  [2017] = {.lex_state = 194, .external_lex_state = 10},
  [2018] = {.lex_state = 124, .external_lex_state = 21},
  [2019] = {.lex_state = 139, .external_lex_state = 10},
  [2020] = {.lex_state = 124, .external_lex_state = 10},
  [2021] = {.lex_state = 258, .external_lex_state = 6},
  [2022] = {.lex_state = 194, .external_lex_state = 10},
  [2023] = {.lex_state = 194, .external_lex_state = 10},
  [2024] = {.lex_state = 271, .external_lex_state = 4},
  [2025] = {.lex_state = 263, .external_lex_state = 3},
  [2026] = {.lex_state = 84},
  [2027] = {.lex_state = 73},
  [2028] = {.lex_state = 180},
  [2029] = {.lex_state = 263, .external_lex_state = 9},
  [2030] = {.lex_state = 144},
  [2031] = {.lex_state = 84},
  [2032] = {.lex_state = 263, .external_lex_state = 9},
  [2033] = {.lex_state = 73},
  [2034] = {.lex_state = 263, .external_lex_state = 9},
  [2035] = {.lex_state = 263, .external_lex_state = 9},
  [2036] = {.lex_state = 263, .external_lex_state = 9},
  [2037] = {.lex_state = 84, .external_lex_state = 2},
  [2038] = {.lex_state = 73},
  [2039] = {.lex_state = 159, .external_lex_state = 10},
  [2040] = {.lex_state = 163, .external_lex_state = 5},
  [2041] = {.lex_state = 134},
  [2042] = {.lex_state = 159, .external_lex_state = 10},
  [2043] = {.lex_state = 263, .external_lex_state = 3},
  [2044] = {.lex_state = 263, .external_lex_state = 3},
  [2045] = {.lex_state = 258, .external_lex_state = 6},
  [2046] = {.lex_state = 261, .external_lex_state = 6},
  [2047] = {.lex_state = 261, .external_lex_state = 4},
  [2048] = {.lex_state = 243, .external_lex_state = 2},
  [2049] = {.lex_state = 261, .external_lex_state = 6},
  [2050] = {.lex_state = 261, .external_lex_state = 4},
  [2051] = {.lex_state = 269, .external_lex_state = 12},
  [2052] = {.lex_state = 73, .external_lex_state = 17},
  [2053] = {.lex_state = 73, .external_lex_state = 2},
  [2054] = {.lex_state = 151, .external_lex_state = 4},
  [2055] = {.lex_state = 155, .external_lex_state = 3},
  [2056] = {.lex_state = 84},
  [2057] = {.lex_state = 73},
  [2058] = {.lex_state = 84},
  [2059] = {.lex_state = 73},
  [2060] = {.lex_state = 84, .external_lex_state = 13},
  [2061] = {.lex_state = 84, .external_lex_state = 13},
  [2062] = {.lex_state = 212, .external_lex_state = 11},
  [2063] = {.lex_state = 212, .external_lex_state = 11},
  [2064] = {.lex_state = 173, .external_lex_state = 4},
  [2065] = {.lex_state = 73, .external_lex_state = 23},
  [2066] = {.lex_state = 73, .external_lex_state = 23},
  [2067] = {.lex_state = 251, .external_lex_state = 9},
  [2068] = {.lex_state = 274, .external_lex_state = 3},
  [2069] = {.lex_state = 251, .external_lex_state = 3},
  [2070] = {.lex_state = 84},
  [2071] = {.lex_state = 251, .external_lex_state = 9},
  [2072] = {.lex_state = 194, .external_lex_state = 10},
  [2073] = {.lex_state = 194, .external_lex_state = 10},
  [2074] = {.lex_state = 194, .external_lex_state = 20},
  [2075] = {.lex_state = 196, .external_lex_state = 10},
  [2076] = {.lex_state = 194, .external_lex_state = 20},
  [2077] = {.lex_state = 251, .external_lex_state = 9},
  [2078] = {.lex_state = 194, .external_lex_state = 10},
  [2079] = {.lex_state = 124, .external_lex_state = 21},
  [2080] = {.lex_state = 139, .external_lex_state = 10},
  [2081] = {.lex_state = 124, .external_lex_state = 10},
  [2082] = {.lex_state = 251, .external_lex_state = 9},
  [2083] = {.lex_state = 194, .external_lex_state = 10},
  [2084] = {.lex_state = 194, .external_lex_state = 10},
  [2085] = {.lex_state = 251, .external_lex_state = 6},
  [2086] = {.lex_state = 274, .external_lex_state = 4},
  [2087] = {.lex_state = 251, .external_lex_state = 6},
  [2088] = {.lex_state = 194, .external_lex_state = 10},
  [2089] = {.lex_state = 194, .external_lex_state = 10},
  [2090] = {.lex_state = 194, .external_lex_state = 20},
  [2091] = {.lex_state = 196, .external_lex_state = 10},
  [2092] = {.lex_state = 194, .external_lex_state = 20},
  [2093] = {.lex_state = 251, .external_lex_state = 6},
  [2094] = {.lex_state = 194, .external_lex_state = 10},
  [2095] = {.lex_state = 124, .external_lex_state = 21},
  [2096] = {.lex_state = 139, .external_lex_state = 10},
  [2097] = {.lex_state = 124, .external_lex_state = 10},
  [2098] = {.lex_state = 251, .external_lex_state = 6},
  [2099] = {.lex_state = 194, .external_lex_state = 10},
  [2100] = {.lex_state = 194, .external_lex_state = 10},
  [2101] = {.lex_state = 258, .external_lex_state = 6},
  [2102] = {.lex_state = 194, .external_lex_state = 10},
  [2103] = {.lex_state = 194, .external_lex_state = 10},
  [2104] = {.lex_state = 124, .external_lex_state = 21},
  [2105] = {.lex_state = 139, .external_lex_state = 10},
  [2106] = {.lex_state = 124, .external_lex_state = 10},
  [2107] = {.lex_state = 258, .external_lex_state = 6},
  [2108] = {.lex_state = 194, .external_lex_state = 10},
  [2109] = {.lex_state = 194, .external_lex_state = 10},
  [2110] = {.lex_state = 258, .external_lex_state = 6},
  [2111] = {.lex_state = 258, .external_lex_state = 6},
  [2112] = {.lex_state = 194, .external_lex_state = 10},
  [2113] = {.lex_state = 263, .external_lex_state = 3},
  [2114] = {.lex_state = 263, .external_lex_state = 9},
  [2115] = {.lex_state = 263, .external_lex_state = 9},
  [2116] = {.lex_state = 180},
  [2117] = {.lex_state = 263, .external_lex_state = 9},
  [2118] = {.lex_state = 84},
  [2119] = {.lex_state = 263, .external_lex_state = 9},
  [2120] = {.lex_state = 263, .external_lex_state = 9},
  [2121] = {.lex_state = 194, .external_lex_state = 20},
  [2122] = {.lex_state = 263, .external_lex_state = 9},
  [2123] = {.lex_state = 194, .external_lex_state = 10},
  [2124] = {.lex_state = 159, .external_lex_state = 10},
  [2125] = {.lex_state = 134},
  [2126] = {.lex_state = 159, .external_lex_state = 10},
  [2127] = {.lex_state = 196, .external_lex_state = 10},
  [2128] = {.lex_state = 194, .external_lex_state = 20},
  [2129] = {.lex_state = 263, .external_lex_state = 9},
  [2130] = {.lex_state = 194, .external_lex_state = 10},
  [2131] = {.lex_state = 84},
  [2132] = {.lex_state = 261, .external_lex_state = 6},
  [2133] = {.lex_state = 243, .external_lex_state = 2},
  [2134] = {.lex_state = 175, .external_lex_state = 12},
  [2135] = {.lex_state = 73, .external_lex_state = 2},
  [2136] = {.lex_state = 73, .external_lex_state = 17},
  [2137] = {.lex_state = 84},
  [2138] = {.lex_state = 84},
  [2139] = {.lex_state = 251, .external_lex_state = 3},
  [2140] = {.lex_state = 251, .external_lex_state = 9},
  [2141] = {.lex_state = 194, .external_lex_state = 10},
  [2142] = {.lex_state = 194, .external_lex_state = 10},
  [2143] = {.lex_state = 124, .external_lex_state = 21},
  [2144] = {.lex_state = 139, .external_lex_state = 10},
  [2145] = {.lex_state = 124, .external_lex_state = 10},
  [2146] = {.lex_state = 251, .external_lex_state = 9},
  [2147] = {.lex_state = 194, .external_lex_state = 10},
  [2148] = {.lex_state = 194, .external_lex_state = 10},
  [2149] = {.lex_state = 251, .external_lex_state = 9},
  [2150] = {.lex_state = 251, .external_lex_state = 9},
  [2151] = {.lex_state = 194, .external_lex_state = 10},
  [2152] = {.lex_state = 251, .external_lex_state = 6},
  [2153] = {.lex_state = 194, .external_lex_state = 10},
  [2154] = {.lex_state = 194, .external_lex_state = 10},
  [2155] = {.lex_state = 124, .external_lex_state = 21},
  [2156] = {.lex_state = 139, .external_lex_state = 10},
  [2157] = {.lex_state = 124, .external_lex_state = 10},
  [2158] = {.lex_state = 251, .external_lex_state = 6},
  [2159] = {.lex_state = 194, .external_lex_state = 10},
  [2160] = {.lex_state = 194, .external_lex_state = 10},
  [2161] = {.lex_state = 251, .external_lex_state = 6},
  [2162] = {.lex_state = 251, .external_lex_state = 6},
  [2163] = {.lex_state = 194, .external_lex_state = 10},
  [2164] = {.lex_state = 258, .external_lex_state = 6},
  [2165] = {.lex_state = 194, .external_lex_state = 10},
  [2166] = {.lex_state = 258, .external_lex_state = 6},
  [2167] = {.lex_state = 258, .external_lex_state = 6},
  [2168] = {.lex_state = 194, .external_lex_state = 10},
  [2169] = {.lex_state = 258, .external_lex_state = 6},
  [2170] = {.lex_state = 263, .external_lex_state = 9},
  [2171] = {.lex_state = 274, .external_lex_state = 3},
  [2172] = {.lex_state = 263, .external_lex_state = 9},
  [2173] = {.lex_state = 194, .external_lex_state = 10},
  [2174] = {.lex_state = 194, .external_lex_state = 10},
  [2175] = {.lex_state = 194, .external_lex_state = 20},
  [2176] = {.lex_state = 196, .external_lex_state = 10},
  [2177] = {.lex_state = 194, .external_lex_state = 20},
  [2178] = {.lex_state = 263, .external_lex_state = 9},
  [2179] = {.lex_state = 194, .external_lex_state = 10},
  [2180] = {.lex_state = 124, .external_lex_state = 21},
  [2181] = {.lex_state = 139, .external_lex_state = 10},
  [2182] = {.lex_state = 124, .external_lex_state = 10},
  [2183] = {.lex_state = 263, .external_lex_state = 9},
  [2184] = {.lex_state = 194, .external_lex_state = 10},
  [2185] = {.lex_state = 194, .external_lex_state = 10},
  [2186] = {.lex_state = 277, .external_lex_state = 4},
  [2187] = {.lex_state = 73, .external_lex_state = 2},
  [2188] = {.lex_state = 175, .external_lex_state = 12},
  [2189] = {.lex_state = 251, .external_lex_state = 9},
  [2190] = {.lex_state = 194, .external_lex_state = 10},
  [2191] = {.lex_state = 251, .external_lex_state = 9},
  [2192] = {.lex_state = 251, .external_lex_state = 9},
  [2193] = {.lex_state = 194, .external_lex_state = 10},
  [2194] = {.lex_state = 251, .external_lex_state = 9},
  [2195] = {.lex_state = 251, .external_lex_state = 6},
  [2196] = {.lex_state = 194, .external_lex_state = 10},
  [2197] = {.lex_state = 251, .external_lex_state = 6},
  [2198] = {.lex_state = 251, .external_lex_state = 6},
  [2199] = {.lex_state = 194, .external_lex_state = 10},
  [2200] = {.lex_state = 251, .external_lex_state = 6},
  [2201] = {.lex_state = 258, .external_lex_state = 6},
  [2202] = {.lex_state = 258, .external_lex_state = 6},
  [2203] = {.lex_state = 263, .external_lex_state = 9},
  [2204] = {.lex_state = 194, .external_lex_state = 10},
  [2205] = {.lex_state = 194, .external_lex_state = 10},
  [2206] = {.lex_state = 124, .external_lex_state = 21},
  [2207] = {.lex_state = 139, .external_lex_state = 10},
  [2208] = {.lex_state = 124, .external_lex_state = 10},
  [2209] = {.lex_state = 263, .external_lex_state = 9},
  [2210] = {.lex_state = 194, .external_lex_state = 10},
  [2211] = {.lex_state = 194, .external_lex_state = 10},
  [2212] = {.lex_state = 263, .external_lex_state = 9},
  [2213] = {.lex_state = 263, .external_lex_state = 9},
  [2214] = {.lex_state = 194, .external_lex_state = 10},
  [2215] = {.lex_state = 73, .external_lex_state = 2},
  [2216] = {.lex_state = 251, .external_lex_state = 9},
  [2217] = {.lex_state = 251, .external_lex_state = 9},
  [2218] = {.lex_state = 251, .external_lex_state = 6},
  [2219] = {.lex_state = 251, .external_lex_state = 6},
  [2220] = {.lex_state = 263, .external_lex_state = 9},
  [2221] = {.lex_state = 194, .external_lex_state = 10},
  [2222] = {.lex_state = 263, .external_lex_state = 9},
  [2223] = {.lex_state = 263, .external_lex_state = 9},
  [2224] = {.lex_state = 194, .external_lex_state = 10},
  [2225] = {.lex_state = 263, .external_lex_state = 9},
  [2226] = {.lex_state = 263, .external_lex_state = 9},
  [2227] = {.lex_state = 263, .external_lex_state = 9},
};

enum {
  ts_external_token_heredoc_start = 0,
  ts_external_token__simple_heredoc_body = 1,
  ts_external_token__heredoc_body_beginning = 2,
  ts_external_token__heredoc_body_middle = 3,
  ts_external_token__heredoc_body_end = 4,
  ts_external_token_file_descriptor = 5,
  ts_external_token__empty_value = 6,
  ts_external_token__concat = 7,
  ts_external_token_variable_name = 8,
  ts_external_token_regex = 9,
  ts_external_token_RBRACE = 10,
  ts_external_token_RBRACK = 11,
  ts_external_token_LT_LT = 12,
  ts_external_token_LT_LT_DASH = 13,
  ts_external_token_LF = 14,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_regex] = sym_regex,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LT_LT] = anon_sym_LT_LT,
  [ts_external_token_LT_LT_DASH] = anon_sym_LT_LT_DASH,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[24][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token__concat] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_regex] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__heredoc_body_middle] = true,
  },
  [2] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
  },
  [3] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token_variable_name] = true,
  },
  [6] = {
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_RBRACE] = true,
  },
  [8] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [9] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [10] = {
    [ts_external_token_RBRACE] = true,
  },
  [11] = {
    [ts_external_token_LF] = true,
    [ts_external_token__concat] = true,
  },
  [12] = {
    [ts_external_token_LF] = true,
  },
  [13] = {
    [ts_external_token__concat] = true,
  },
  [14] = {
    [ts_external_token__empty_value] = true,
  },
  [15] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [16] = {
    [ts_external_token_RBRACK] = true,
  },
  [17] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__simple_heredoc_body] = true,
  },
  [18] = {
    [ts_external_token_heredoc_start] = true,
  },
  [19] = {
    [ts_external_token_regex] = true,
  },
  [20] = {
    [ts_external_token_regex] = true,
    [ts_external_token_RBRACE] = true,
  },
  [21] = {
    [ts_external_token_RBRACE] = true,
    [ts_external_token__concat] = true,
  },
  [22] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__simple_heredoc_body] = true,
  },
  [23] = {
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token__heredoc_body_middle] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_test_operator] = ACTIONS(1),
    [sym_heredoc_start] = ACTIONS(1),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [anon_sym_typeset] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [anon_sym_done] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [sym_word] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym__special_character] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [sym_regex] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_unsetenv] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_fi] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_esac] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
  },
  [1] = {
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_if_statement] = STATE(28),
    [sym_function_definition] = STATE(28),
    [sym_negated_command] = STATE(28),
    [sym_test_command] = STATE(28),
    [sym_variable_assignment] = STATE(29),
    [sym_subscript] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [aux_sym__statements_repeat1] = STATE(32),
    [sym_program] = STATE(33),
    [sym_redirected_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_compound_statement] = STATE(28),
    [sym_subshell] = STATE(28),
    [sym_declaration_command] = STATE(28),
    [sym_unset_command] = STATE(28),
    [sym_file_redirect] = STATE(34),
    [sym_string] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(34),
    [sym__statements] = STATE(35),
    [sym_c_style_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_case_statement] = STATE(28),
    [sym_pipeline] = STATE(28),
    [sym_list] = STATE(28),
    [sym_command] = STATE(28),
    [sym_command_name] = STATE(36),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [ts_builtin_sym_end] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(50),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [3] = {
    [sym_command_substitution] = STATE(54),
    [aux_sym__literal_repeat1] = STATE(60),
    [sym_string] = STATE(54),
    [sym_process_substitution] = STATE(54),
    [sym_simple_expansion] = STATE(54),
    [sym_string_expansion] = STATE(54),
    [sym_concatenation] = STATE(61),
    [sym_expansion] = STATE(54),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(79),
    [sym_raw_string] = ACTIONS(79),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [4] = {
    [sym_command_substitution] = STATE(64),
    [aux_sym__literal_repeat1] = STATE(71),
    [sym_string] = STATE(64),
    [aux_sym_declaration_command_repeat1] = STATE(72),
    [sym_process_substitution] = STATE(64),
    [sym_simple_expansion] = STATE(64),
    [sym_subscript] = STATE(73),
    [sym_string_expansion] = STATE(64),
    [sym_variable_assignment] = STATE(72),
    [sym_concatenation] = STATE(72),
    [sym_expansion] = STATE(64),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(99),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(103),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(105),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(103),
    [sym_variable_name] = ACTIONS(111),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [ts_builtin_sym_end] = ACTIONS(109),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [5] = {
    [sym_command_substitution] = STATE(76),
    [aux_sym__literal_repeat1] = STATE(82),
    [sym_string] = STATE(76),
    [aux_sym_unset_command_repeat1] = STATE(83),
    [sym_process_substitution] = STATE(76),
    [sym_simple_expansion] = STATE(76),
    [sym_string_expansion] = STATE(76),
    [sym_concatenation] = STATE(83),
    [sym_expansion] = STATE(76),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(127),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [ts_builtin_sym_end] = ACTIONS(133),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [6] = {
    [sym_string] = STATE(85),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(137),
    [sym_raw_string] = ACTIONS(139),
    [anon_sym_BANG] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(137),
    [anon_sym_DOLLAR] = ACTIONS(141),
    [anon_sym_POUND] = ACTIONS(141),
    [anon_sym_DASH] = ACTIONS(141),
    [anon_sym_0] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(143),
    [anon_sym__] = ACTIONS(143),
  },
  [7] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(87),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [8] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(90),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(91),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [9] = {
    [sym_subscript] = STATE(92),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(151),
    [sym_variable_name] = ACTIONS(155),
    [anon_sym_DOLLAR] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_0] = ACTIONS(159),
    [anon_sym_POUND] = ACTIONS(153),
    [aux_sym__simple_variable_name_token1] = ACTIONS(159),
    [anon_sym__] = ACTIONS(159),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_comment] = ACTIONS(51),
    [sym_word] = ACTIONS(161),
  },
  [11] = {
    [aux_sym_concatenation_repeat1] = STATE(99),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [ts_builtin_sym_end] = ACTIONS(169),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [12] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(109),
    [sym_function_definition] = STATE(109),
    [sym_negated_command] = STATE(109),
    [sym_test_command] = STATE(109),
    [sym_variable_assignment] = STATE(110),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(112),
    [sym_redirected_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_compound_statement] = STATE(109),
    [sym_subshell] = STATE(109),
    [sym_declaration_command] = STATE(109),
    [sym_unset_command] = STATE(109),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_case_statement] = STATE(109),
    [sym_pipeline] = STATE(109),
    [sym_list] = STATE(109),
    [sym_command] = STATE(109),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [13] = {
    [aux_sym_concatenation_repeat1] = STATE(99),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [ts_builtin_sym_end] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [14] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym__terminated_statement] = STATE(115),
    [sym_if_statement] = STATE(116),
    [sym_function_definition] = STATE(116),
    [sym_negated_command] = STATE(116),
    [sym_test_command] = STATE(116),
    [sym_variable_assignment] = STATE(117),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_redirected_statement] = STATE(116),
    [sym_for_statement] = STATE(116),
    [sym_compound_statement] = STATE(116),
    [sym_subshell] = STATE(116),
    [sym_declaration_command] = STATE(116),
    [sym_unset_command] = STATE(116),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(116),
    [sym_while_statement] = STATE(116),
    [sym_case_statement] = STATE(116),
    [sym_pipeline] = STATE(116),
    [sym_list] = STATE(116),
    [sym_command] = STATE(116),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [15] = {
    [sym_command_substitution] = STATE(120),
    [aux_sym__literal_repeat1] = STATE(126),
    [sym_string] = STATE(120),
    [sym_process_substitution] = STATE(120),
    [sym_simple_expansion] = STATE(120),
    [sym_string_expansion] = STATE(120),
    [sym_concatenation] = STATE(127),
    [sym_expansion] = STATE(120),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(193),
    [sym_word] = ACTIONS(195),
    [sym_raw_string] = ACTIONS(195),
    [anon_sym_LT_LPAREN] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(201),
    [sym__special_character] = ACTIONS(203),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(205),
  },
  [16] = {
    [sym_command_substitution] = STATE(131),
    [sym_unary_expression] = STATE(139),
    [sym_postfix_expression] = STATE(139),
    [sym_string] = STATE(131),
    [aux_sym__literal_repeat1] = STATE(138),
    [sym_process_substitution] = STATE(131),
    [sym_parenthesized_expression] = STATE(139),
    [sym_simple_expansion] = STATE(131),
    [sym_string_expansion] = STATE(131),
    [sym__expression] = STATE(139),
    [sym_binary_expression] = STATE(139),
    [sym_concatenation] = STATE(139),
    [sym_expansion] = STATE(131),
    [sym_test_operator] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(213),
    [sym_raw_string] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [17] = {
    [aux_sym_concatenation_repeat1] = STATE(99),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [ts_builtin_sym_end] = ACTIONS(169),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [18] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(147),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [19] = {
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_string] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [sym_test_command] = STATE(150),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_subscript] = STATE(151),
    [sym_variable_assignment] = STATE(34),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_command] = STATE(150),
    [sym_command_name] = STATE(36),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [sym_subshell] = STATE(150),
    [sym_file_redirect] = STATE(34),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [sym_variable_name] = ACTIONS(237),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(37),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(29),
  },
  [20] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(239),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_EQ] = ACTIONS(239),
  },
  [21] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(243),
    [anon_sym_GT_AMP] = ACTIONS(243),
    [anon_sym_LT] = ACTIONS(245),
    [anon_sym_LT_AMP] = ACTIONS(243),
    [anon_sym_GT_GT] = ACTIONS(243),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(245),
    [anon_sym_AMP_GT] = ACTIONS(245),
  },
  [22] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(247),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [23] = {
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(259),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(261),
  },
  [24] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym__terminated_statement] = STATE(164),
    [sym_if_statement] = STATE(116),
    [sym_function_definition] = STATE(116),
    [sym_negated_command] = STATE(116),
    [sym_test_command] = STATE(116),
    [sym_variable_assignment] = STATE(117),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_redirected_statement] = STATE(116),
    [sym_for_statement] = STATE(116),
    [sym_compound_statement] = STATE(116),
    [sym_subshell] = STATE(116),
    [sym_declaration_command] = STATE(116),
    [sym_unset_command] = STATE(116),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(116),
    [sym_while_statement] = STATE(116),
    [sym_case_statement] = STATE(116),
    [sym_pipeline] = STATE(116),
    [sym_list] = STATE(116),
    [sym_command] = STATE(116),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [25] = {
    [sym_command_substitution] = STATE(168),
    [sym_unary_expression] = STATE(176),
    [sym_postfix_expression] = STATE(176),
    [sym_string] = STATE(168),
    [aux_sym__literal_repeat1] = STATE(175),
    [sym_process_substitution] = STATE(168),
    [sym_parenthesized_expression] = STATE(176),
    [sym_simple_expansion] = STATE(168),
    [sym_string_expansion] = STATE(168),
    [sym__expression] = STATE(176),
    [sym_binary_expression] = STATE(176),
    [sym_concatenation] = STATE(176),
    [sym_expansion] = STATE(168),
    [sym_test_operator] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym_word] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR] = ACTIONS(279),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [sym__special_character] = ACTIONS(283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(285),
  },
  [26] = {
    [sym_command_substitution] = STATE(178),
    [sym_unary_expression] = STATE(181),
    [sym_postfix_expression] = STATE(181),
    [sym_string] = STATE(178),
    [aux_sym__literal_repeat1] = STATE(180),
    [sym_process_substitution] = STATE(178),
    [sym_parenthesized_expression] = STATE(181),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym__expression] = STATE(181),
    [sym_binary_expression] = STATE(181),
    [sym_concatenation] = STATE(181),
    [sym_expansion] = STATE(178),
    [sym_test_operator] = ACTIONS(287),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [27] = {
    [aux_sym__literal_repeat1] = STATE(183),
    [anon_sym_AMP_GT_GT] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [sym_word] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_LT_AMP] = ACTIONS(297),
    [anon_sym_GT_GT] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [sym__special_character] = ACTIONS(299),
    [anon_sym_LT_LT_DASH] = ACTIONS(297),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LF] = ACTIONS(301),
    [anon_sym_SEMI] = ACTIONS(297),
    [sym_raw_string] = ACTIONS(297),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_AMP_GT] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_DQUOTE] = ACTIONS(297),
    [anon_sym_LT_LT_LT] = ACTIONS(297),
    [anon_sym_GT_AMP] = ACTIONS(297),
    [ts_builtin_sym_end] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_SEMI_SEMI] = ACTIONS(297),
    [anon_sym_PIPE_AMP] = ACTIONS(297),
  },
  [28] = {
    [sym_heredoc_redirect] = STATE(192),
    [aux_sym_redirected_statement_repeat1] = STATE(192),
    [sym_herestring_redirect] = STATE(192),
    [sym_file_redirect] = STATE(192),
    [anon_sym_SEMI_SEMI] = ACTIONS(303),
    [anon_sym_AMP_GT_GT] = ACTIONS(305),
    [anon_sym_LF] = ACTIONS(307),
    [anon_sym_SEMI] = ACTIONS(303),
    [sym_file_descriptor] = ACTIONS(309),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(305),
    [anon_sym_AMP_GT] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(313),
    [ts_builtin_sym_end] = ACTIONS(315),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [anon_sym_GT_AMP] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_LT_AMP] = ACTIONS(305),
    [anon_sym_GT_GT] = ACTIONS(305),
    [anon_sym_PIPE] = ACTIONS(319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(313),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_PIPE_AMP] = ACTIONS(319),
  },
  [29] = {
    [sym_heredoc_redirect] = STATE(192),
    [aux_sym_redirected_statement_repeat1] = STATE(192),
    [sym_herestring_redirect] = STATE(192),
    [sym_file_redirect] = STATE(192),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(313),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(319),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(307),
    [anon_sym_SEMI] = ACTIONS(303),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [ts_builtin_sym_end] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(313),
    [anon_sym_SEMI_SEMI] = ACTIONS(303),
    [anon_sym_PIPE_AMP] = ACTIONS(319),
  },
  [30] = {
    [anon_sym_EQ] = ACTIONS(239),
    [anon_sym_PLUS_EQ] = ACTIONS(239),
    [sym_comment] = ACTIONS(51),
  },
  [31] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_RPAREN] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [ts_builtin_sym_end] = ACTIONS(169),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [32] = {
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_if_statement] = STATE(193),
    [sym_function_definition] = STATE(193),
    [sym_negated_command] = STATE(193),
    [sym_test_command] = STATE(193),
    [sym_variable_assignment] = STATE(194),
    [sym_subscript] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [aux_sym__statements_repeat1] = STATE(195),
    [sym_redirected_statement] = STATE(193),
    [sym_for_statement] = STATE(193),
    [sym_compound_statement] = STATE(193),
    [sym_subshell] = STATE(193),
    [sym_declaration_command] = STATE(193),
    [sym_unset_command] = STATE(193),
    [sym_file_redirect] = STATE(34),
    [sym_string] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_c_style_for_statement] = STATE(193),
    [sym_while_statement] = STATE(193),
    [sym_case_statement] = STATE(193),
    [sym_pipeline] = STATE(193),
    [sym_list] = STATE(193),
    [sym_command] = STATE(193),
    [sym_command_name] = STATE(36),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [33] = {
    [sym_comment] = ACTIONS(51),
    [ts_builtin_sym_end] = ACTIONS(325),
  },
  [34] = {
    [sym_command_substitution] = STATE(17),
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_expansion] = STATE(17),
    [sym_string] = STATE(17),
    [sym_command_name] = STATE(196),
    [sym_process_substitution] = STATE(17),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [sym_subscript] = STATE(151),
    [sym_variable_assignment] = STATE(197),
    [aux_sym_command_repeat1] = STATE(197),
    [sym_concatenation] = STATE(31),
    [sym_file_redirect] = STATE(197),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(37),
    [sym_variable_name] = ACTIONS(237),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(37),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(327),
  },
  [35] = {
    [sym_comment] = ACTIONS(51),
    [ts_builtin_sym_end] = ACTIONS(329),
  },
  [36] = {
    [sym_command_substitution] = STATE(198),
    [aux_sym__literal_repeat1] = STATE(200),
    [sym_string] = STATE(198),
    [sym_process_substitution] = STATE(198),
    [sym_simple_expansion] = STATE(198),
    [sym_string_expansion] = STATE(198),
    [aux_sym_command_repeat2] = STATE(201),
    [sym_concatenation] = STATE(201),
    [sym_expansion] = STATE(198),
    [anon_sym_AMP_GT_GT] = ACTIONS(331),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(331),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(331),
    [sym_word] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(331),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(331),
    [anon_sym_LT_AMP] = ACTIONS(331),
    [anon_sym_GT_GT] = ACTIONS(331),
    [anon_sym_EQ_TILDE] = ACTIONS(341),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(331),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(345),
    [anon_sym_SEMI] = ACTIONS(331),
    [sym_raw_string] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(331),
    [anon_sym_AMP_GT] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(341),
    [ts_builtin_sym_end] = ACTIONS(345),
    [anon_sym_LT_LT_LT] = ACTIONS(331),
    [anon_sym_GT_AMP] = ACTIONS(331),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(331),
    [anon_sym_SEMI_SEMI] = ACTIONS(331),
    [anon_sym_PIPE_AMP] = ACTIONS(331),
  },
  [37] = {
    [sym_command_substitution] = STATE(202),
    [aux_sym__literal_repeat1] = STATE(205),
    [sym_string] = STATE(202),
    [aux_sym_declaration_command_repeat1] = STATE(206),
    [sym_process_substitution] = STATE(202),
    [sym_simple_expansion] = STATE(202),
    [sym_subscript] = STATE(207),
    [sym_string_expansion] = STATE(202),
    [sym_variable_assignment] = STATE(206),
    [sym_concatenation] = STATE(206),
    [sym_expansion] = STATE(202),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(351),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(351),
    [sym_variable_name] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(91),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [38] = {
    [sym_command_substitution] = STATE(208),
    [aux_sym__literal_repeat1] = STATE(210),
    [sym_string] = STATE(208),
    [aux_sym_unset_command_repeat1] = STATE(211),
    [sym_process_substitution] = STATE(208),
    [sym_simple_expansion] = STATE(208),
    [sym_string_expansion] = STATE(208),
    [sym_concatenation] = STATE(211),
    [sym_expansion] = STATE(208),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(361),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(359),
    [anon_sym_RPAREN] = ACTIONS(115),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [39] = {
    [aux_sym_concatenation_repeat1] = STATE(212),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [anon_sym_RPAREN] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [40] = {
    [aux_sym_concatenation_repeat1] = STATE(212),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [anon_sym_RPAREN] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [41] = {
    [aux_sym_concatenation_repeat1] = STATE(212),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [anon_sym_RPAREN] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [42] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [sym_test_command] = STATE(150),
    [aux_sym_command_repeat1] = STATE(49),
    [sym_subscript] = STATE(151),
    [sym_variable_assignment] = STATE(49),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_command] = STATE(150),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [sym_subshell] = STATE(150),
    [sym_file_redirect] = STATE(49),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [sym_variable_name] = ACTIONS(237),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(69),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(67),
  },
  [43] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_EQ] = ACTIONS(363),
  },
  [44] = {
    [aux_sym__literal_repeat1] = STATE(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [sym_word] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_LT_AMP] = ACTIONS(297),
    [anon_sym_GT_GT] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [sym__special_character] = ACTIONS(299),
    [anon_sym_LT_LT_DASH] = ACTIONS(297),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LF] = ACTIONS(301),
    [anon_sym_SEMI] = ACTIONS(297),
    [sym_raw_string] = ACTIONS(297),
    [anon_sym_RPAREN] = ACTIONS(297),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_AMP_GT] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_DQUOTE] = ACTIONS(297),
    [anon_sym_LT_LT_LT] = ACTIONS(297),
    [anon_sym_GT_AMP] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_SEMI_SEMI] = ACTIONS(297),
    [anon_sym_PIPE_AMP] = ACTIONS(297),
  },
  [45] = {
    [sym_heredoc_redirect] = STATE(220),
    [aux_sym_redirected_statement_repeat1] = STATE(220),
    [sym_herestring_redirect] = STATE(220),
    [sym_file_redirect] = STATE(220),
    [anon_sym_SEMI_SEMI] = ACTIONS(303),
    [anon_sym_AMP_GT_GT] = ACTIONS(365),
    [anon_sym_LF] = ACTIONS(307),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_RPAREN] = ACTIONS(367),
    [sym_file_descriptor] = ACTIONS(369),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_AMP_GT] = ACTIONS(365),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_LT_LT_LT] = ACTIONS(373),
    [anon_sym_GT_AMP] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_LT_AMP] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_PIPE_AMP] = ACTIONS(375),
  },
  [46] = {
    [sym_heredoc_redirect] = STATE(220),
    [aux_sym_redirected_statement_repeat1] = STATE(220),
    [sym_herestring_redirect] = STATE(220),
    [sym_file_redirect] = STATE(220),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(307),
    [anon_sym_SEMI] = ACTIONS(303),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(367),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(373),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_SEMI_SEMI] = ACTIONS(303),
    [anon_sym_PIPE_AMP] = ACTIONS(375),
  },
  [47] = {
    [anon_sym_EQ] = ACTIONS(363),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [sym_comment] = ACTIONS(51),
  },
  [48] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(221),
    [sym_function_definition] = STATE(221),
    [sym_negated_command] = STATE(221),
    [sym_test_command] = STATE(221),
    [sym_variable_assignment] = STATE(222),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(195),
    [sym_redirected_statement] = STATE(221),
    [sym_for_statement] = STATE(221),
    [sym_compound_statement] = STATE(221),
    [sym_subshell] = STATE(221),
    [sym_declaration_command] = STATE(221),
    [sym_unset_command] = STATE(221),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym_c_style_for_statement] = STATE(221),
    [sym_while_statement] = STATE(221),
    [sym_case_statement] = STATE(221),
    [sym_pipeline] = STATE(221),
    [sym_list] = STATE(221),
    [sym_command] = STATE(221),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [49] = {
    [sym_command_substitution] = STATE(41),
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_expansion] = STATE(41),
    [sym_string] = STATE(41),
    [sym_command_name] = STATE(223),
    [sym_process_substitution] = STATE(41),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [sym_subscript] = STATE(151),
    [sym_variable_assignment] = STATE(197),
    [aux_sym_command_repeat1] = STATE(197),
    [sym_concatenation] = STATE(31),
    [sym_file_redirect] = STATE(197),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(69),
    [sym_variable_name] = ACTIONS(237),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(69),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(377),
  },
  [50] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(379),
  },
  [51] = {
    [sym_command_substitution] = STATE(225),
    [aux_sym__literal_repeat1] = STATE(227),
    [sym_string] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [aux_sym_command_repeat2] = STATE(228),
    [sym_concatenation] = STATE(228),
    [sym_expansion] = STATE(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(331),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(331),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(331),
    [sym_word] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(331),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(331),
    [anon_sym_LT_AMP] = ACTIONS(331),
    [anon_sym_GT_GT] = ACTIONS(331),
    [anon_sym_EQ_TILDE] = ACTIONS(383),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_LT_LT_DASH] = ACTIONS(331),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(345),
    [anon_sym_SEMI] = ACTIONS(331),
    [sym_raw_string] = ACTIONS(381),
    [anon_sym_RPAREN] = ACTIONS(331),
    [sym_file_descriptor] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(331),
    [anon_sym_AMP_GT] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(331),
    [anon_sym_GT_AMP] = ACTIONS(331),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(331),
    [anon_sym_SEMI_SEMI] = ACTIONS(331),
    [anon_sym_PIPE_AMP] = ACTIONS(331),
  },
  [52] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(229),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [53] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(232),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(385),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [54] = {
    [aux_sym_concatenation_repeat1] = STATE(234),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(391),
    [sym_file_descriptor] = ACTIONS(389),
    [sym_variable_name] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [sym__concat] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(389),
  },
  [55] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(235),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [56] = {
    [sym_string] = STATE(237),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(395),
    [anon_sym_QMARK] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_AT] = ACTIONS(395),
    [anon_sym_DOLLAR] = ACTIONS(399),
    [anon_sym_POUND] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [anon_sym_0] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(401),
    [anon_sym__] = ACTIONS(401),
  },
  [57] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(239),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(240),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [58] = {
    [aux_sym_concatenation_repeat1] = STATE(234),
    [anon_sym_BQUOTE] = ACTIONS(189),
    [anon_sym_AMP_GT_GT] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [sym_variable_name] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(189),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(189),
    [anon_sym_GT_LPAREN] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [sym_word] = ACTIONS(189),
    [anon_sym_GT_AMP] = ACTIONS(189),
    [sym__concat] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(189),
    [anon_sym_GT_GT] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(189),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(189),
  },
  [59] = {
    [sym_subscript] = STATE(241),
    [anon_sym_STAR] = ACTIONS(403),
    [anon_sym_QMARK] = ACTIONS(403),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_AT] = ACTIONS(403),
    [sym_variable_name] = ACTIONS(407),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_0] = ACTIONS(411),
    [anon_sym_POUND] = ACTIONS(405),
    [aux_sym__simple_variable_name_token1] = ACTIONS(411),
    [anon_sym__] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [aux_sym__literal_repeat1] = STATE(246),
    [anon_sym_BQUOTE] = ACTIONS(413),
    [anon_sym_AMP_GT_GT] = ACTIONS(413),
    [sym_raw_string] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [sym_file_descriptor] = ACTIONS(413),
    [sym_variable_name] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(415),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(413),
    [anon_sym_GT_LPAREN] = ACTIONS(413),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [sym_word] = ACTIONS(413),
    [anon_sym_GT_AMP] = ACTIONS(413),
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_LT_AMP] = ACTIONS(413),
    [anon_sym_GT_GT] = ACTIONS(413),
    [anon_sym_LT_LPAREN] = ACTIONS(413),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(417),
  },
  [61] = {
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(391),
    [sym_file_descriptor] = ACTIONS(389),
    [sym_variable_name] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(389),
  },
  [62] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(247),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [63] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(250),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(419),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [64] = {
    [aux_sym_concatenation_repeat1] = STATE(252),
    [anon_sym_AMP_GT_GT] = ACTIONS(423),
    [anon_sym_DOLLAR] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_LPAREN] = ACTIONS(423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(423),
    [aux_sym__simple_variable_name_token1] = ACTIONS(423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [sym_word] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_LT_AMP] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [sym__concat] = ACTIONS(425),
    [sym__special_character] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(423),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LF] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(423),
    [sym_raw_string] = ACTIONS(423),
    [sym_variable_name] = ACTIONS(427),
    [sym_file_descriptor] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [anon_sym_LT_LT_LT] = ACTIONS(423),
    [anon_sym_GT_AMP] = ACTIONS(423),
    [ts_builtin_sym_end] = ACTIONS(427),
    [anon_sym_LT_LPAREN] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(423),
    [anon_sym_PIPE_AMP] = ACTIONS(423),
  },
  [65] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(253),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [66] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(429),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_EQ] = ACTIONS(429),
  },
  [67] = {
    [sym_string] = STATE(256),
    [anon_sym_DQUOTE] = ACTIONS(431),
    [anon_sym_STAR] = ACTIONS(433),
    [anon_sym_QMARK] = ACTIONS(433),
    [sym_raw_string] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_AT] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(437),
    [anon_sym_POUND] = ACTIONS(437),
    [anon_sym_DASH] = ACTIONS(437),
    [anon_sym_0] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(439),
    [anon_sym__] = ACTIONS(439),
  },
  [68] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(258),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(259),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [69] = {
    [aux_sym_concatenation_repeat1] = STATE(252),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(425),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [ts_builtin_sym_end] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [70] = {
    [sym_subscript] = STATE(260),
    [anon_sym_STAR] = ACTIONS(441),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_AT] = ACTIONS(441),
    [sym_variable_name] = ACTIONS(445),
    [anon_sym_DOLLAR] = ACTIONS(447),
    [anon_sym_DASH] = ACTIONS(447),
    [anon_sym_0] = ACTIONS(449),
    [anon_sym_POUND] = ACTIONS(443),
    [aux_sym__simple_variable_name_token1] = ACTIONS(449),
    [anon_sym__] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [aux_sym__literal_repeat1] = STATE(265),
    [anon_sym_AMP_GT_GT] = ACTIONS(451),
    [anon_sym_DOLLAR] = ACTIONS(451),
    [anon_sym_LT_LT] = ACTIONS(451),
    [anon_sym_GT_LPAREN] = ACTIONS(451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_word] = ACTIONS(451),
    [anon_sym_PIPE] = ACTIONS(451),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(451),
    [anon_sym_LT_AMP] = ACTIONS(451),
    [anon_sym_GT_GT] = ACTIONS(451),
    [sym__special_character] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(451),
    [anon_sym_BQUOTE] = ACTIONS(451),
    [anon_sym_LF] = ACTIONS(455),
    [anon_sym_SEMI] = ACTIONS(451),
    [sym_raw_string] = ACTIONS(451),
    [sym_variable_name] = ACTIONS(455),
    [sym_file_descriptor] = ACTIONS(455),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_AMP_GT] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(451),
    [anon_sym_LT_LT_LT] = ACTIONS(451),
    [anon_sym_GT_AMP] = ACTIONS(451),
    [ts_builtin_sym_end] = ACTIONS(455),
    [anon_sym_LT_LPAREN] = ACTIONS(451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_SEMI_SEMI] = ACTIONS(451),
    [anon_sym_PIPE_AMP] = ACTIONS(451),
  },
  [72] = {
    [sym_command_substitution] = STATE(64),
    [aux_sym__literal_repeat1] = STATE(71),
    [sym_string] = STATE(64),
    [aux_sym_declaration_command_repeat1] = STATE(266),
    [sym_process_substitution] = STATE(64),
    [sym_simple_expansion] = STATE(64),
    [sym_subscript] = STATE(73),
    [sym_string_expansion] = STATE(64),
    [sym_variable_assignment] = STATE(266),
    [sym_concatenation] = STATE(266),
    [sym_expansion] = STATE(64),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [sym_word] = ACTIONS(103),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [sym__special_character] = ACTIONS(105),
    [anon_sym_LT_LT_DASH] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_SEMI] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(103),
    [sym_variable_name] = ACTIONS(111),
    [sym_file_descriptor] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [ts_builtin_sym_end] = ACTIONS(461),
    [anon_sym_LT_LT_LT] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
  },
  [73] = {
    [anon_sym_EQ] = ACTIONS(429),
    [anon_sym_PLUS_EQ] = ACTIONS(429),
    [sym_comment] = ACTIONS(51),
  },
  [74] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(267),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [75] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(270),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [76] = {
    [aux_sym_concatenation_repeat1] = STATE(272),
    [anon_sym_AMP_GT_GT] = ACTIONS(467),
    [anon_sym_DOLLAR] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(467),
    [aux_sym__simple_variable_name_token1] = ACTIONS(467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(467),
    [sym_word] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(467),
    [anon_sym_LT_AMP] = ACTIONS(467),
    [anon_sym_GT_GT] = ACTIONS(467),
    [sym__concat] = ACTIONS(469),
    [sym__special_character] = ACTIONS(467),
    [anon_sym_LT_LT_DASH] = ACTIONS(467),
    [anon_sym_BQUOTE] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(467),
    [sym_raw_string] = ACTIONS(467),
    [sym_file_descriptor] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(467),
    [anon_sym_AMP_GT] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(467),
    [anon_sym_LT_LT_LT] = ACTIONS(467),
    [anon_sym_GT_AMP] = ACTIONS(467),
    [ts_builtin_sym_end] = ACTIONS(471),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(467),
    [anon_sym_SEMI_SEMI] = ACTIONS(467),
    [anon_sym_PIPE_AMP] = ACTIONS(467),
  },
  [77] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(273),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [78] = {
    [sym_string] = STATE(275),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_QMARK] = ACTIONS(475),
    [sym_raw_string] = ACTIONS(477),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(475),
    [anon_sym_DOLLAR] = ACTIONS(479),
    [anon_sym_POUND] = ACTIONS(479),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_0] = ACTIONS(481),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(481),
    [anon_sym__] = ACTIONS(481),
  },
  [79] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(277),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(278),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [80] = {
    [aux_sym_concatenation_repeat1] = STATE(272),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(469),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [ts_builtin_sym_end] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [81] = {
    [sym_subscript] = STATE(279),
    [anon_sym_STAR] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(483),
    [sym_variable_name] = ACTIONS(487),
    [anon_sym_DOLLAR] = ACTIONS(489),
    [anon_sym_DASH] = ACTIONS(489),
    [anon_sym_0] = ACTIONS(491),
    [anon_sym_POUND] = ACTIONS(485),
    [aux_sym__simple_variable_name_token1] = ACTIONS(491),
    [anon_sym__] = ACTIONS(491),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [aux_sym__literal_repeat1] = STATE(284),
    [anon_sym_AMP_GT_GT] = ACTIONS(493),
    [anon_sym_DOLLAR] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_GT_LPAREN] = ACTIONS(493),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(493),
    [aux_sym__simple_variable_name_token1] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(493),
    [anon_sym_PIPE_PIPE] = ACTIONS(493),
    [sym_word] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_LT_AMP] = ACTIONS(493),
    [anon_sym_GT_GT] = ACTIONS(493),
    [sym__special_character] = ACTIONS(495),
    [anon_sym_LT_LT_DASH] = ACTIONS(493),
    [anon_sym_BQUOTE] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(497),
    [anon_sym_SEMI] = ACTIONS(493),
    [sym_raw_string] = ACTIONS(493),
    [sym_file_descriptor] = ACTIONS(497),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_AMP_GT] = ACTIONS(493),
    [anon_sym_DQUOTE] = ACTIONS(493),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(493),
    [ts_builtin_sym_end] = ACTIONS(497),
    [anon_sym_LT_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(493),
    [anon_sym_SEMI_SEMI] = ACTIONS(493),
    [anon_sym_PIPE_AMP] = ACTIONS(493),
  },
  [83] = {
    [sym_command_substitution] = STATE(76),
    [aux_sym__literal_repeat1] = STATE(82),
    [sym_string] = STATE(76),
    [aux_sym_unset_command_repeat1] = STATE(285),
    [sym_process_substitution] = STATE(76),
    [sym_simple_expansion] = STATE(76),
    [sym_string_expansion] = STATE(76),
    [sym_concatenation] = STATE(285),
    [sym_expansion] = STATE(76),
    [anon_sym_AMP_GT_GT] = ACTIONS(499),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(499),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(501),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [sym_word] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_AMP] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(499),
    [anon_sym_LT_AMP] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(499),
    [sym__special_character] = ACTIONS(129),
    [anon_sym_LT_LT_DASH] = ACTIONS(499),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(503),
    [anon_sym_SEMI] = ACTIONS(499),
    [sym_raw_string] = ACTIONS(127),
    [sym_file_descriptor] = ACTIONS(503),
    [anon_sym_GT] = ACTIONS(499),
    [anon_sym_AMP_GT] = ACTIONS(499),
    [ts_builtin_sym_end] = ACTIONS(503),
    [anon_sym_LT_LT_LT] = ACTIONS(499),
    [anon_sym_GT_AMP] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(499),
    [anon_sym_PIPE_AMP] = ACTIONS(499),
  },
  [84] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_LT_LT] = ACTIONS(505),
    [anon_sym_GT_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [sym_word] = ACTIONS(505),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_AMP] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_LT_AMP] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [anon_sym_EQ_TILDE] = ACTIONS(505),
    [sym__special_character] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [sym_raw_string] = ACTIONS(505),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(505),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_EQ_EQ] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(505),
    [anon_sym_LT_LT_LT] = ACTIONS(505),
    [anon_sym_GT_AMP] = ACTIONS(505),
    [ts_builtin_sym_end] = ACTIONS(507),
    [anon_sym_LT_LPAREN] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
    [anon_sym_PIPE_AMP] = ACTIONS(505),
  },
  [85] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(509),
    [anon_sym_GT_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(509),
    [anon_sym_PIPE_PIPE] = ACTIONS(509),
    [sym_word] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_GT] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [anon_sym_EQ_TILDE] = ACTIONS(509),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_LT_LT_DASH] = ACTIONS(509),
    [anon_sym_BQUOTE] = ACTIONS(509),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(509),
    [sym_file_descriptor] = ACTIONS(511),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(509),
    [anon_sym_EQ_EQ] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_LT_LT_LT] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [ts_builtin_sym_end] = ACTIONS(511),
    [anon_sym_LT_LPAREN] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
    [anon_sym_PIPE_AMP] = ACTIONS(509),
  },
  [86] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [anon_sym_EQ_TILDE] = ACTIONS(513),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(515),
    [anon_sym_RPAREN] = ACTIONS(513),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [ts_builtin_sym_end] = ACTIONS(515),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [87] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(517),
  },
  [88] = {
    [sym_command_substitution] = STATE(287),
    [aux_sym__literal_repeat1] = STATE(289),
    [sym_string] = STATE(287),
    [sym_process_substitution] = STATE(287),
    [sym_simple_expansion] = STATE(287),
    [sym_string_expansion] = STATE(287),
    [sym_concatenation] = STATE(61),
    [sym_expansion] = STATE(287),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(519),
    [sym_raw_string] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [89] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(523),
    [anon_sym_GT_AMP] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(525),
    [anon_sym_LT_AMP] = ACTIONS(523),
    [anon_sym_GT_GT] = ACTIONS(523),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(525),
    [anon_sym_AMP_GT] = ACTIONS(525),
  },
  [90] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(527),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [91] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(527),
  },
  [92] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(303),
    [sym_concatenation] = STATE(303),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(531),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(535),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(535),
    [anon_sym_PERCENT] = ACTIONS(535),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(551),
    [anon_sym_COLON_DASH] = ACTIONS(535),
    [sym__special_character] = ACTIONS(553),
  },
  [93] = {
    [sym_subscript] = STATE(304),
    [anon_sym_STAR] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(555),
    [anon_sym_AT] = ACTIONS(555),
    [sym_variable_name] = ACTIONS(557),
    [anon_sym_DOLLAR] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_0] = ACTIONS(561),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(561),
    [anon_sym__] = ACTIONS(561),
  },
  [94] = {
    [anon_sym_EQ] = ACTIONS(563),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [95] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(311),
    [sym_concatenation] = STATE(311),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(567),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(569),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(569),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(569),
    [anon_sym_PERCENT] = ACTIONS(569),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(573),
    [anon_sym_COLON_DASH] = ACTIONS(569),
    [sym__special_character] = ACTIONS(553),
  },
  [96] = {
    [sym_compound_statement] = STATE(313),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(51),
  },
  [97] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(577),
  },
  [98] = {
    [sym_command_substitution] = STATE(315),
    [sym_simple_expansion] = STATE(315),
    [sym_string_expansion] = STATE(315),
    [sym_string] = STATE(315),
    [sym_process_substitution] = STATE(315),
    [sym_expansion] = STATE(315),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(579),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(579),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
  },
  [99] = {
    [aux_sym_concatenation_repeat1] = STATE(317),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(583),
    [anon_sym_EQ_TILDE] = ACTIONS(581),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [ts_builtin_sym_end] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [100] = {
    [sym_command_substitution] = STATE(318),
    [aux_sym__literal_repeat1] = STATE(321),
    [sym_string] = STATE(318),
    [aux_sym_declaration_command_repeat1] = STATE(322),
    [sym_process_substitution] = STATE(318),
    [sym_simple_expansion] = STATE(318),
    [sym_subscript] = STATE(323),
    [sym_string_expansion] = STATE(318),
    [sym_variable_assignment] = STATE(322),
    [sym_concatenation] = STATE(322),
    [sym_expansion] = STATE(318),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(589),
    [sym_variable_name] = ACTIONS(593),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [101] = {
    [sym_command_substitution] = STATE(324),
    [aux_sym__literal_repeat1] = STATE(326),
    [sym_string] = STATE(324),
    [aux_sym_unset_command_repeat1] = STATE(327),
    [sym_process_substitution] = STATE(324),
    [sym_simple_expansion] = STATE(324),
    [sym_string_expansion] = STATE(324),
    [sym_concatenation] = STATE(327),
    [sym_expansion] = STATE(324),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(599),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(597),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [102] = {
    [aux_sym_concatenation_repeat1] = STATE(328),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [103] = {
    [aux_sym_concatenation_repeat1] = STATE(328),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [104] = {
    [aux_sym_concatenation_repeat1] = STATE(328),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [105] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [sym_test_command] = STATE(150),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_subscript] = STATE(151),
    [sym_variable_assignment] = STATE(113),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_command] = STATE(150),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [sym_subshell] = STATE(150),
    [sym_file_redirect] = STATE(113),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [sym_variable_name] = ACTIONS(237),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(179),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(177),
  },
  [106] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(601),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_EQ] = ACTIONS(601),
  },
  [107] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(603),
    [anon_sym_BQUOTE] = ACTIONS(603),
    [anon_sym_AMP_GT_GT] = ACTIONS(603),
    [anon_sym_LF] = ACTIONS(605),
    [anon_sym_SEMI] = ACTIONS(603),
    [anon_sym_LT_LT] = ACTIONS(603),
    [sym_file_descriptor] = ACTIONS(605),
    [anon_sym_GT] = ACTIONS(603),
    [anon_sym_RPAREN] = ACTIONS(603),
    [anon_sym_AMP_GT] = ACTIONS(603),
    [anon_sym_PIPE_PIPE] = ACTIONS(603),
    [ts_builtin_sym_end] = ACTIONS(605),
    [anon_sym_LT_LT_LT] = ACTIONS(603),
    [anon_sym_PIPE] = ACTIONS(603),
    [anon_sym_GT_AMP] = ACTIONS(603),
    [anon_sym_LT] = ACTIONS(603),
    [anon_sym_LT_AMP] = ACTIONS(603),
    [anon_sym_GT_GT] = ACTIONS(603),
    [anon_sym_AMP] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(603),
    [anon_sym_AMP_AMP] = ACTIONS(603),
    [anon_sym_SEMI_SEMI] = ACTIONS(603),
    [anon_sym_PIPE_AMP] = ACTIONS(603),
  },
  [108] = {
    [aux_sym__literal_repeat1] = STATE(330),
    [anon_sym_AMP_GT_GT] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [sym_word] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_LT_AMP] = ACTIONS(297),
    [anon_sym_GT_GT] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [sym__special_character] = ACTIONS(299),
    [anon_sym_LT_LT_DASH] = ACTIONS(297),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LF] = ACTIONS(301),
    [anon_sym_SEMI] = ACTIONS(297),
    [sym_raw_string] = ACTIONS(297),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_AMP_GT] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_DQUOTE] = ACTIONS(297),
    [anon_sym_LT_LT_LT] = ACTIONS(297),
    [anon_sym_GT_AMP] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_SEMI_SEMI] = ACTIONS(297),
    [anon_sym_PIPE_AMP] = ACTIONS(297),
  },
  [109] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
    [anon_sym_AMP_GT_GT] = ACTIONS(609),
    [anon_sym_LF] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(613),
    [sym_file_descriptor] = ACTIONS(615),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_AMP_GT] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_LT_LT_LT] = ACTIONS(619),
    [anon_sym_GT_AMP] = ACTIONS(609),
    [anon_sym_PIPE] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_AMP] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(613),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
  },
  [110] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(613),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(613),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(619),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(613),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
  },
  [111] = {
    [anon_sym_EQ] = ACTIONS(601),
    [anon_sym_PLUS_EQ] = ACTIONS(601),
    [sym_comment] = ACTIONS(51),
  },
  [112] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(109),
    [sym_function_definition] = STATE(109),
    [sym_negated_command] = STATE(109),
    [sym_test_command] = STATE(109),
    [sym_variable_assignment] = STATE(110),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(340),
    [sym_redirected_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_compound_statement] = STATE(109),
    [sym_subshell] = STATE(109),
    [sym_declaration_command] = STATE(109),
    [sym_unset_command] = STATE(109),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_case_statement] = STATE(109),
    [sym_pipeline] = STATE(109),
    [sym_list] = STATE(109),
    [sym_command] = STATE(109),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [113] = {
    [sym_command_substitution] = STATE(104),
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_expansion] = STATE(104),
    [sym_string] = STATE(104),
    [sym_command_name] = STATE(341),
    [sym_process_substitution] = STATE(104),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [sym_subscript] = STATE(151),
    [sym_variable_assignment] = STATE(197),
    [aux_sym_command_repeat1] = STATE(197),
    [sym_concatenation] = STATE(31),
    [sym_file_redirect] = STATE(197),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(179),
    [sym_variable_name] = ACTIONS(237),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(179),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(623),
  },
  [114] = {
    [sym_command_substitution] = STATE(342),
    [aux_sym__literal_repeat1] = STATE(344),
    [sym_string] = STATE(342),
    [sym_process_substitution] = STATE(342),
    [sym_simple_expansion] = STATE(342),
    [sym_string_expansion] = STATE(342),
    [aux_sym_command_repeat2] = STATE(345),
    [sym_concatenation] = STATE(345),
    [sym_expansion] = STATE(342),
    [anon_sym_AMP_GT_GT] = ACTIONS(331),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(331),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(331),
    [sym_word] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(331),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(331),
    [anon_sym_LT_AMP] = ACTIONS(331),
    [anon_sym_GT_GT] = ACTIONS(331),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_LT_LT_DASH] = ACTIONS(331),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(345),
    [anon_sym_SEMI] = ACTIONS(331),
    [sym_raw_string] = ACTIONS(625),
    [sym_file_descriptor] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(331),
    [anon_sym_AMP_GT] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(331),
    [anon_sym_GT_AMP] = ACTIONS(331),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(331),
    [anon_sym_SEMI_SEMI] = ACTIONS(331),
    [anon_sym_PIPE_AMP] = ACTIONS(331),
  },
  [115] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_then] = ACTIONS(629),
  },
  [116] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_SEMI_SEMI] = ACTIONS(631),
    [anon_sym_AMP_GT_GT] = ACTIONS(609),
    [anon_sym_LF] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(631),
    [sym_file_descriptor] = ACTIONS(615),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_AMP_GT] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_LT_LT_LT] = ACTIONS(619),
    [anon_sym_GT_AMP] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(631),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_AMP] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_PIPE] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
  },
  [117] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(631),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(633),
    [anon_sym_SEMI] = ACTIONS(631),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(619),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(631),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
  },
  [118] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(348),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [119] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(351),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [120] = {
    [aux_sym_concatenation_repeat1] = STATE(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(641),
    [anon_sym_LF] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_in] = ACTIONS(645),
  },
  [121] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(356),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [122] = {
    [sym_string] = STATE(358),
    [anon_sym_DQUOTE] = ACTIONS(193),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(647),
    [sym_raw_string] = ACTIONS(649),
    [anon_sym_BANG] = ACTIONS(651),
    [anon_sym_AT] = ACTIONS(647),
    [anon_sym_DOLLAR] = ACTIONS(651),
    [anon_sym_POUND] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_0] = ACTIONS(653),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(653),
    [anon_sym__] = ACTIONS(653),
  },
  [123] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(360),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(361),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [124] = {
    [aux_sym_concatenation_repeat1] = STATE(355),
    [sym__concat] = ACTIONS(641),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
  },
  [125] = {
    [sym_subscript] = STATE(362),
    [anon_sym_STAR] = ACTIONS(655),
    [anon_sym_QMARK] = ACTIONS(655),
    [anon_sym_BANG] = ACTIONS(657),
    [anon_sym_AT] = ACTIONS(655),
    [sym_variable_name] = ACTIONS(659),
    [anon_sym_DOLLAR] = ACTIONS(661),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_0] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(657),
    [aux_sym__simple_variable_name_token1] = ACTIONS(663),
    [anon_sym__] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [aux_sym__literal_repeat1] = STATE(369),
    [anon_sym_in] = ACTIONS(665),
    [anon_sym_SEMI] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(667),
    [anon_sym_SEMI_SEMI] = ACTIONS(667),
    [sym__special_character] = ACTIONS(671),
  },
  [127] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(643),
    [anon_sym_AMP] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_in] = ACTIONS(645),
  },
  [128] = {
    [sym_command_substitution] = STATE(131),
    [sym_unary_expression] = STATE(370),
    [sym_postfix_expression] = STATE(370),
    [sym_string] = STATE(131),
    [aux_sym__literal_repeat1] = STATE(138),
    [sym_process_substitution] = STATE(131),
    [sym_parenthesized_expression] = STATE(370),
    [sym_simple_expansion] = STATE(131),
    [sym_string_expansion] = STATE(131),
    [sym__expression] = STATE(370),
    [sym_binary_expression] = STATE(370),
    [sym_concatenation] = STATE(370),
    [sym_expansion] = STATE(131),
    [sym_test_operator] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(213),
    [sym_raw_string] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [129] = {
    [sym_command_substitution] = STATE(372),
    [sym_unary_expression] = STATE(375),
    [sym_postfix_expression] = STATE(375),
    [sym_string] = STATE(372),
    [aux_sym__literal_repeat1] = STATE(374),
    [sym_process_substitution] = STATE(372),
    [sym_parenthesized_expression] = STATE(375),
    [sym_simple_expansion] = STATE(372),
    [sym_string_expansion] = STATE(372),
    [sym__expression] = STATE(375),
    [sym_binary_expression] = STATE(375),
    [sym_concatenation] = STATE(375),
    [sym_expansion] = STATE(372),
    [sym_test_operator] = ACTIONS(673),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_BANG] = ACTIONS(679),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [130] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(378),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [131] = {
    [aux_sym_concatenation_repeat1] = STATE(380),
    [anon_sym_BANG_EQ] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(687),
    [sym_test_operator] = ACTIONS(687),
    [anon_sym_PLUS_PLUS] = ACTIONS(687),
    [anon_sym_DASH] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_EQ_EQ] = ACTIONS(687),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(687),
    [sym__concat] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(689),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(687),
    [anon_sym_DASH_DASH] = ACTIONS(687),
    [anon_sym_LT_EQ] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_DASH_EQ] = ACTIONS(687),
  },
  [132] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(381),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [133] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(382),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [134] = {
    [sym_string] = STATE(384),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [anon_sym_STAR] = ACTIONS(693),
    [anon_sym_QMARK] = ACTIONS(693),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_BANG] = ACTIONS(697),
    [anon_sym_AT] = ACTIONS(693),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [anon_sym_POUND] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(697),
    [anon_sym_0] = ACTIONS(699),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(699),
    [anon_sym__] = ACTIONS(699),
  },
  [135] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(386),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(387),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [136] = {
    [aux_sym_concatenation_repeat1] = STATE(380),
    [anon_sym_BANG_EQ] = ACTIONS(189),
    [anon_sym_PLUS_EQ] = ACTIONS(189),
    [sym_test_operator] = ACTIONS(189),
    [anon_sym_PLUS_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_EQ] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(189),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(189),
    [anon_sym_PIPE_PIPE] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(189),
    [sym__concat] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(189),
    [anon_sym_DASH_DASH] = ACTIONS(189),
    [anon_sym_LT_EQ] = ACTIONS(189),
    [anon_sym_AMP_AMP] = ACTIONS(189),
    [sym__special_character] = ACTIONS(189),
    [anon_sym_DASH_EQ] = ACTIONS(189),
  },
  [137] = {
    [sym_subscript] = STATE(388),
    [anon_sym_STAR] = ACTIONS(701),
    [anon_sym_QMARK] = ACTIONS(701),
    [anon_sym_BANG] = ACTIONS(703),
    [anon_sym_AT] = ACTIONS(701),
    [sym_variable_name] = ACTIONS(705),
    [anon_sym_DOLLAR] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(707),
    [anon_sym_0] = ACTIONS(709),
    [anon_sym_POUND] = ACTIONS(703),
    [aux_sym__simple_variable_name_token1] = ACTIONS(709),
    [anon_sym__] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [aux_sym__literal_repeat1] = STATE(393),
    [anon_sym_BANG_EQ] = ACTIONS(711),
    [anon_sym_PLUS_EQ] = ACTIONS(711),
    [sym_test_operator] = ACTIONS(711),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(711),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(711),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(711),
    [anon_sym_PLUS] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(713),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [sym__special_character] = ACTIONS(715),
    [anon_sym_DASH_EQ] = ACTIONS(711),
  },
  [139] = {
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_PLUS_EQ] = ACTIONS(717),
    [sym_test_operator] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(721),
    [anon_sym_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ] = ACTIONS(723),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(721),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_DASH_EQ] = ACTIONS(717),
  },
  [140] = {
    [sym_command_substitution] = STATE(318),
    [aux_sym__literal_repeat1] = STATE(321),
    [sym_string] = STATE(318),
    [aux_sym_declaration_command_repeat1] = STATE(398),
    [sym_process_substitution] = STATE(318),
    [sym_simple_expansion] = STATE(318),
    [sym_subscript] = STATE(323),
    [sym_string_expansion] = STATE(318),
    [sym_variable_assignment] = STATE(398),
    [sym_concatenation] = STATE(398),
    [sym_expansion] = STATE(318),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(589),
    [sym_variable_name] = ACTIONS(593),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [141] = {
    [sym_command_substitution] = STATE(324),
    [aux_sym__literal_repeat1] = STATE(326),
    [sym_string] = STATE(324),
    [aux_sym_unset_command_repeat1] = STATE(399),
    [sym_process_substitution] = STATE(324),
    [sym_simple_expansion] = STATE(324),
    [sym_string_expansion] = STATE(324),
    [sym_concatenation] = STATE(399),
    [sym_expansion] = STATE(324),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(599),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(115),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(597),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [142] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [sym_test_command] = STATE(150),
    [aux_sym_command_repeat1] = STATE(146),
    [sym_subscript] = STATE(151),
    [sym_variable_assignment] = STATE(146),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_command] = STATE(150),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [sym_subshell] = STATE(150),
    [sym_file_redirect] = STATE(146),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [sym_variable_name] = ACTIONS(237),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(179),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(177),
  },
  [143] = {
    [sym_heredoc_redirect] = STATE(407),
    [aux_sym_redirected_statement_repeat1] = STATE(407),
    [sym_herestring_redirect] = STATE(407),
    [sym_file_redirect] = STATE(407),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(731),
    [sym_file_descriptor] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT_LT_LT] = ACTIONS(741),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_PIPE_AMP] = ACTIONS(743),
  },
  [144] = {
    [sym_heredoc_redirect] = STATE(407),
    [aux_sym_redirected_statement_repeat1] = STATE(407),
    [sym_herestring_redirect] = STATE(407),
    [sym_file_redirect] = STATE(407),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(367),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(735),
    [anon_sym_SEMI] = ACTIONS(731),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(741),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(731),
    [anon_sym_PIPE_AMP] = ACTIONS(743),
  },
  [145] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(408),
    [sym_function_definition] = STATE(408),
    [sym_negated_command] = STATE(408),
    [sym_test_command] = STATE(408),
    [sym_variable_assignment] = STATE(409),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(195),
    [sym_redirected_statement] = STATE(408),
    [sym_for_statement] = STATE(408),
    [sym_compound_statement] = STATE(408),
    [sym_subshell] = STATE(408),
    [sym_declaration_command] = STATE(408),
    [sym_unset_command] = STATE(408),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym_c_style_for_statement] = STATE(408),
    [sym_while_statement] = STATE(408),
    [sym_case_statement] = STATE(408),
    [sym_pipeline] = STATE(408),
    [sym_list] = STATE(408),
    [sym_command] = STATE(408),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [146] = {
    [sym_command_substitution] = STATE(104),
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_expansion] = STATE(104),
    [sym_string] = STATE(104),
    [sym_command_name] = STATE(410),
    [sym_process_substitution] = STATE(104),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [sym_subscript] = STATE(151),
    [sym_variable_assignment] = STATE(197),
    [aux_sym_command_repeat1] = STATE(197),
    [sym_concatenation] = STATE(31),
    [sym_file_redirect] = STATE(197),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(179),
    [sym_variable_name] = ACTIONS(237),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(179),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(623),
  },
  [147] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(527),
  },
  [148] = {
    [sym_command_substitution] = STATE(342),
    [aux_sym__literal_repeat1] = STATE(344),
    [sym_string] = STATE(342),
    [sym_process_substitution] = STATE(342),
    [sym_simple_expansion] = STATE(342),
    [sym_string_expansion] = STATE(342),
    [aux_sym_command_repeat2] = STATE(411),
    [sym_concatenation] = STATE(411),
    [sym_expansion] = STATE(342),
    [anon_sym_AMP_GT_GT] = ACTIONS(331),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(331),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(331),
    [sym_word] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(331),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(331),
    [anon_sym_LT_AMP] = ACTIONS(331),
    [anon_sym_GT_GT] = ACTIONS(331),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_LT_LT_DASH] = ACTIONS(331),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_LF] = ACTIONS(345),
    [anon_sym_SEMI] = ACTIONS(331),
    [sym_raw_string] = ACTIONS(625),
    [sym_file_descriptor] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(331),
    [anon_sym_AMP_GT] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(331),
    [anon_sym_GT_AMP] = ACTIONS(331),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(331),
    [anon_sym_SEMI_SEMI] = ACTIONS(331),
    [anon_sym_PIPE_AMP] = ACTIONS(331),
  },
  [149] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_EQ] = ACTIONS(745),
  },
  [150] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(747),
    [anon_sym_BQUOTE] = ACTIONS(747),
    [anon_sym_AMP_GT_GT] = ACTIONS(747),
    [anon_sym_LF] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(747),
    [anon_sym_LT_LT] = ACTIONS(747),
    [sym_file_descriptor] = ACTIONS(749),
    [anon_sym_GT] = ACTIONS(747),
    [anon_sym_RPAREN] = ACTIONS(747),
    [anon_sym_AMP_GT] = ACTIONS(747),
    [anon_sym_PIPE_PIPE] = ACTIONS(747),
    [ts_builtin_sym_end] = ACTIONS(749),
    [anon_sym_LT_LT_LT] = ACTIONS(747),
    [anon_sym_PIPE] = ACTIONS(747),
    [anon_sym_GT_AMP] = ACTIONS(747),
    [anon_sym_LT] = ACTIONS(747),
    [anon_sym_LT_AMP] = ACTIONS(747),
    [anon_sym_GT_GT] = ACTIONS(747),
    [anon_sym_AMP] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(747),
    [anon_sym_AMP_AMP] = ACTIONS(747),
    [anon_sym_SEMI_SEMI] = ACTIONS(747),
    [anon_sym_PIPE_AMP] = ACTIONS(747),
  },
  [151] = {
    [anon_sym_EQ] = ACTIONS(745),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [sym_comment] = ACTIONS(51),
  },
  [152] = {
    [sym_command_substitution] = STATE(416),
    [aux_sym__literal_repeat1] = STATE(423),
    [sym_string] = STATE(416),
    [sym_array] = STATE(422),
    [sym_process_substitution] = STATE(416),
    [sym_simple_expansion] = STATE(416),
    [sym_string_expansion] = STATE(416),
    [sym_concatenation] = STATE(422),
    [sym_expansion] = STATE(416),
    [anon_sym_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [sym_word] = ACTIONS(757),
    [sym_raw_string] = ACTIONS(757),
    [anon_sym_LT_LPAREN] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(761),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(763),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(767),
    [sym__empty_value] = ACTIONS(769),
  },
  [153] = {
    [sym_command_substitution] = STATE(424),
    [aux_sym__literal_repeat1] = STATE(426),
    [sym_string] = STATE(424),
    [sym_process_substitution] = STATE(424),
    [sym_simple_expansion] = STATE(424),
    [sym_string_expansion] = STATE(424),
    [sym_concatenation] = STATE(427),
    [sym_expansion] = STATE(424),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym_word] = ACTIONS(771),
    [sym_raw_string] = ACTIONS(771),
    [anon_sym_LT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR] = ACTIONS(279),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [sym__special_character] = ACTIONS(773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(285),
  },
  [154] = {
    [sym_command_substitution] = STATE(428),
    [aux_sym__literal_repeat1] = STATE(429),
    [sym_string] = STATE(428),
    [sym_process_substitution] = STATE(428),
    [sym_simple_expansion] = STATE(428),
    [sym_string_expansion] = STATE(428),
    [sym_concatenation] = STATE(430),
    [sym_expansion] = STATE(428),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(775),
    [sym_raw_string] = ACTIONS(775),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [155] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(435),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [157] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(787),
    [anon_sym_GT_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [sym_word] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_LT_AMP] = ACTIONS(787),
    [anon_sym_GT_GT] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [anon_sym_EQ_TILDE] = ACTIONS(787),
    [sym__special_character] = ACTIONS(787),
    [anon_sym_LT_LT_DASH] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(787),
    [anon_sym_LF] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [sym_raw_string] = ACTIONS(787),
    [sym_file_descriptor] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_AMP_GT] = ACTIONS(787),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_LT_LT_LT] = ACTIONS(787),
    [anon_sym_GT_AMP] = ACTIONS(787),
    [ts_builtin_sym_end] = ACTIONS(789),
    [anon_sym_LT_LPAREN] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
    [anon_sym_PIPE_AMP] = ACTIONS(787),
  },
  [158] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(436),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(437),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [159] = {
    [sym_subscript] = STATE(438),
    [anon_sym_STAR] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(791),
    [anon_sym_BANG] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(791),
    [sym_variable_name] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(797),
    [anon_sym_0] = ACTIONS(799),
    [anon_sym_POUND] = ACTIONS(793),
    [aux_sym__simple_variable_name_token1] = ACTIONS(799),
    [anon_sym__] = ACTIONS(799),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(801),
    [sym__concat] = ACTIONS(803),
    [sym__string_content] = ACTIONS(805),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(801),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(801),
  },
  [161] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [162] = {
    [anon_sym_AMP] = ACTIONS(809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_in] = ACTIONS(813),
    [anon_sym_SEMI_SEMI] = ACTIONS(809),
  },
  [163] = {
    [sym_command_substitution] = STATE(450),
    [sym_unary_expression] = STATE(459),
    [sym_postfix_expression] = STATE(459),
    [sym_string] = STATE(450),
    [aux_sym__literal_repeat1] = STATE(458),
    [sym_process_substitution] = STATE(450),
    [sym_parenthesized_expression] = STATE(459),
    [sym_simple_expansion] = STATE(450),
    [sym_string_expansion] = STATE(450),
    [sym__expression] = STATE(459),
    [sym_binary_expression] = STATE(459),
    [sym_concatenation] = STATE(459),
    [sym_expansion] = STATE(450),
    [sym_test_operator] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_LF] = ACTIONS(823),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(823),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [anon_sym_GT_LPAREN] = ACTIONS(829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(835),
    [sym_word] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_LT_LPAREN] = ACTIONS(829),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(823),
  },
  [164] = {
    [sym_do_group] = STATE(461),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(839),
  },
  [165] = {
    [sym_command_substitution] = STATE(168),
    [sym_unary_expression] = STATE(462),
    [sym_postfix_expression] = STATE(462),
    [sym_string] = STATE(168),
    [aux_sym__literal_repeat1] = STATE(175),
    [sym_process_substitution] = STATE(168),
    [sym_parenthesized_expression] = STATE(462),
    [sym_simple_expansion] = STATE(168),
    [sym_string_expansion] = STATE(168),
    [sym__expression] = STATE(462),
    [sym_binary_expression] = STATE(462),
    [sym_concatenation] = STATE(462),
    [sym_expansion] = STATE(168),
    [sym_test_operator] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym_word] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR] = ACTIONS(279),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [sym__special_character] = ACTIONS(283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(285),
  },
  [166] = {
    [sym_command_substitution] = STATE(372),
    [sym_unary_expression] = STATE(463),
    [sym_postfix_expression] = STATE(463),
    [sym_string] = STATE(372),
    [aux_sym__literal_repeat1] = STATE(374),
    [sym_process_substitution] = STATE(372),
    [sym_parenthesized_expression] = STATE(463),
    [sym_simple_expansion] = STATE(372),
    [sym_string_expansion] = STATE(372),
    [sym__expression] = STATE(463),
    [sym_binary_expression] = STATE(463),
    [sym_concatenation] = STATE(463),
    [sym_expansion] = STATE(372),
    [sym_test_operator] = ACTIONS(673),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_BANG] = ACTIONS(679),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [167] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(466),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [168] = {
    [aux_sym_concatenation_repeat1] = STATE(468),
    [anon_sym_BANG_EQ] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(687),
    [sym_test_operator] = ACTIONS(687),
    [anon_sym_PLUS_PLUS] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(687),
    [anon_sym_DASH] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_EQ_EQ] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(687),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(689),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(687),
    [anon_sym_DASH_DASH] = ACTIONS(687),
    [anon_sym_LT_EQ] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_DASH_EQ] = ACTIONS(687),
  },
  [169] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(469),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [170] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(470),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [171] = {
    [sym_string] = STATE(472),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_STAR] = ACTIONS(847),
    [anon_sym_QMARK] = ACTIONS(847),
    [sym_raw_string] = ACTIONS(849),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(851),
    [anon_sym_POUND] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_0] = ACTIONS(853),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(853),
    [anon_sym__] = ACTIONS(853),
  },
  [172] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(474),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(475),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [173] = {
    [aux_sym_concatenation_repeat1] = STATE(468),
    [anon_sym_BANG_EQ] = ACTIONS(189),
    [anon_sym_PLUS_EQ] = ACTIONS(189),
    [sym_test_operator] = ACTIONS(189),
    [anon_sym_PLUS_PLUS] = ACTIONS(189),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_EQ] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(189),
    [anon_sym_PIPE_PIPE] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(189),
    [sym__concat] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(189),
    [anon_sym_DASH_DASH] = ACTIONS(189),
    [anon_sym_LT_EQ] = ACTIONS(189),
    [anon_sym_AMP_AMP] = ACTIONS(189),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_DASH_EQ] = ACTIONS(189),
  },
  [174] = {
    [sym_subscript] = STATE(476),
    [anon_sym_STAR] = ACTIONS(855),
    [anon_sym_QMARK] = ACTIONS(855),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_AT] = ACTIONS(855),
    [sym_variable_name] = ACTIONS(859),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_0] = ACTIONS(863),
    [anon_sym_POUND] = ACTIONS(857),
    [aux_sym__simple_variable_name_token1] = ACTIONS(863),
    [anon_sym__] = ACTIONS(863),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [aux_sym__literal_repeat1] = STATE(481),
    [anon_sym_BANG_EQ] = ACTIONS(711),
    [anon_sym_PLUS_EQ] = ACTIONS(711),
    [sym_test_operator] = ACTIONS(711),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_RBRACK] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(711),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(711),
    [anon_sym_PLUS] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(713),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [sym__special_character] = ACTIONS(865),
    [anon_sym_DASH_EQ] = ACTIONS(711),
  },
  [176] = {
    [anon_sym_BANG_EQ] = ACTIONS(867),
    [anon_sym_PLUS_EQ] = ACTIONS(867),
    [sym_test_operator] = ACTIONS(867),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_EQ_EQ] = ACTIONS(873),
    [anon_sym_PIPE_PIPE] = ACTIONS(867),
    [anon_sym_GT_EQ] = ACTIONS(867),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(871),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(873),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_LT_EQ] = ACTIONS(867),
    [anon_sym_AMP_AMP] = ACTIONS(867),
    [anon_sym_DASH_EQ] = ACTIONS(867),
  },
  [177] = {
    [sym_command_substitution] = STATE(178),
    [sym_unary_expression] = STATE(485),
    [sym_postfix_expression] = STATE(485),
    [sym_string] = STATE(178),
    [aux_sym__literal_repeat1] = STATE(180),
    [sym_process_substitution] = STATE(178),
    [sym_parenthesized_expression] = STATE(485),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym__expression] = STATE(485),
    [sym_binary_expression] = STATE(485),
    [sym_concatenation] = STATE(485),
    [sym_expansion] = STATE(178),
    [sym_test_operator] = ACTIONS(287),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [178] = {
    [aux_sym_concatenation_repeat1] = STATE(486),
    [anon_sym_BANG_EQ] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(687),
    [sym_test_operator] = ACTIONS(687),
    [anon_sym_PLUS_PLUS] = ACTIONS(687),
    [anon_sym_DASH] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_EQ_EQ] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(687),
    [sym__concat] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(689),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(687),
    [anon_sym_DASH_DASH] = ACTIONS(687),
    [anon_sym_LT_EQ] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_DASH_EQ] = ACTIONS(687),
  },
  [179] = {
    [aux_sym_concatenation_repeat1] = STATE(486),
    [anon_sym_BANG_EQ] = ACTIONS(189),
    [anon_sym_PLUS_EQ] = ACTIONS(189),
    [sym_test_operator] = ACTIONS(189),
    [anon_sym_PLUS_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_EQ] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(189),
    [anon_sym_PIPE_PIPE] = ACTIONS(189),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(189),
    [sym__concat] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(189),
    [anon_sym_DASH_DASH] = ACTIONS(189),
    [anon_sym_LT_EQ] = ACTIONS(189),
    [anon_sym_AMP_AMP] = ACTIONS(189),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_DASH_EQ] = ACTIONS(189),
  },
  [180] = {
    [aux_sym__literal_repeat1] = STATE(487),
    [anon_sym_BANG_EQ] = ACTIONS(711),
    [anon_sym_PLUS_EQ] = ACTIONS(711),
    [sym_test_operator] = ACTIONS(711),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(711),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(711),
    [anon_sym_PLUS] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(713),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [sym__special_character] = ACTIONS(875),
    [anon_sym_DASH_EQ] = ACTIONS(711),
  },
  [181] = {
    [anon_sym_BANG_EQ] = ACTIONS(877),
    [anon_sym_PLUS_EQ] = ACTIONS(877),
    [sym_test_operator] = ACTIONS(877),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_EQ] = ACTIONS(879),
    [anon_sym_EQ_EQ] = ACTIONS(881),
    [anon_sym_PIPE_PIPE] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(877),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(877),
    [anon_sym_DASH_EQ] = ACTIONS(877),
  },
  [182] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [anon_sym_EQ_TILDE] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [ts_builtin_sym_end] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [183] = {
    [aux_sym__literal_repeat1] = STATE(183),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [sym__special_character] = ACTIONS(885),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [ts_builtin_sym_end] = ACTIONS(888),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [184] = {
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_if_statement] = STATE(490),
    [sym_function_definition] = STATE(490),
    [sym_negated_command] = STATE(490),
    [sym_test_command] = STATE(490),
    [sym_variable_assignment] = STATE(491),
    [sym_subscript] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_redirected_statement] = STATE(490),
    [sym_for_statement] = STATE(490),
    [sym_compound_statement] = STATE(490),
    [sym_subshell] = STATE(490),
    [sym_declaration_command] = STATE(490),
    [sym_unset_command] = STATE(490),
    [sym_file_redirect] = STATE(34),
    [sym_string] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_c_style_for_statement] = STATE(490),
    [sym_while_statement] = STATE(490),
    [sym_case_statement] = STATE(490),
    [sym_pipeline] = STATE(490),
    [sym_list] = STATE(490),
    [sym_command] = STATE(490),
    [sym_command_name] = STATE(36),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [185] = {
    [sym_command_substitution] = STATE(494),
    [aux_sym__literal_repeat1] = STATE(500),
    [sym_string] = STATE(494),
    [sym_process_substitution] = STATE(494),
    [sym_simple_expansion] = STATE(494),
    [sym_string_expansion] = STATE(494),
    [sym_concatenation] = STATE(501),
    [sym_expansion] = STATE(494),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(894),
    [sym_raw_string] = ACTIONS(894),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [186] = {
    [sym_heredoc_body] = STATE(504),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__simple_heredoc_body] = ACTIONS(910),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [sym__heredoc_body_beginning] = ACTIONS(912),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_RPAREN] = ACTIONS(914),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [ts_builtin_sym_end] = ACTIONS(914),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [187] = {
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [anon_sym_RPAREN] = ACTIONS(914),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [ts_builtin_sym_end] = ACTIONS(914),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [188] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(916),
    [anon_sym_GT_AMP] = ACTIONS(916),
    [anon_sym_LT] = ACTIONS(918),
    [anon_sym_LT_AMP] = ACTIONS(916),
    [anon_sym_GT_GT] = ACTIONS(916),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(918),
    [anon_sym_AMP_GT] = ACTIONS(918),
  },
  [189] = {
    [sym_heredoc_start] = ACTIONS(920),
    [sym_comment] = ACTIONS(51),
  },
  [190] = {
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_if_statement] = STATE(507),
    [sym_function_definition] = STATE(507),
    [sym_negated_command] = STATE(507),
    [sym_test_command] = STATE(507),
    [sym_variable_assignment] = STATE(508),
    [sym_subscript] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_redirected_statement] = STATE(507),
    [sym_for_statement] = STATE(507),
    [sym_compound_statement] = STATE(507),
    [sym_subshell] = STATE(507),
    [sym_declaration_command] = STATE(507),
    [sym_unset_command] = STATE(507),
    [sym_file_redirect] = STATE(34),
    [sym_string] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_c_style_for_statement] = STATE(507),
    [sym_while_statement] = STATE(507),
    [sym_case_statement] = STATE(507),
    [sym_pipeline] = STATE(507),
    [sym_list] = STATE(507),
    [sym_command] = STATE(507),
    [sym_command_name] = STATE(36),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [191] = {
    [sym_command_substitution] = STATE(509),
    [aux_sym__literal_repeat1] = STATE(510),
    [sym_string] = STATE(509),
    [sym_process_substitution] = STATE(509),
    [sym_simple_expansion] = STATE(509),
    [sym_string_expansion] = STATE(509),
    [sym_concatenation] = STATE(511),
    [sym_expansion] = STATE(509),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(922),
    [sym_raw_string] = ACTIONS(922),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [192] = {
    [sym_heredoc_redirect] = STATE(512),
    [aux_sym_redirected_statement_repeat1] = STATE(512),
    [sym_herestring_redirect] = STATE(512),
    [sym_file_redirect] = STATE(512),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_AMP_GT_GT] = ACTIONS(305),
    [anon_sym_LF] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(926),
    [anon_sym_LT_LT] = ACTIONS(311),
    [sym_file_descriptor] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(305),
    [anon_sym_AMP_GT] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [ts_builtin_sym_end] = ACTIONS(924),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [anon_sym_PIPE] = ACTIONS(926),
    [anon_sym_GT_AMP] = ACTIONS(305),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_LT_AMP] = ACTIONS(305),
    [anon_sym_GT_GT] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_SEMI_SEMI] = ACTIONS(926),
    [anon_sym_PIPE_AMP] = ACTIONS(926),
  },
  [193] = {
    [sym_heredoc_redirect] = STATE(192),
    [aux_sym_redirected_statement_repeat1] = STATE(192),
    [sym_herestring_redirect] = STATE(192),
    [sym_file_redirect] = STATE(192),
    [anon_sym_PIPE_AMP] = ACTIONS(319),
    [anon_sym_AMP_GT_GT] = ACTIONS(305),
    [anon_sym_LF] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(930),
    [sym_file_descriptor] = ACTIONS(309),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(305),
    [anon_sym_AMP_GT] = ACTIONS(305),
    [anon_sym_PIPE_PIPE] = ACTIONS(313),
    [ts_builtin_sym_end] = ACTIONS(914),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [anon_sym_GT_AMP] = ACTIONS(305),
    [anon_sym_PIPE] = ACTIONS(319),
    [anon_sym_LT] = ACTIONS(305),
    [anon_sym_LT_AMP] = ACTIONS(305),
    [anon_sym_GT_GT] = ACTIONS(305),
    [anon_sym_AMP] = ACTIONS(930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(313),
    [anon_sym_SEMI_SEMI] = ACTIONS(930),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
  },
  [194] = {
    [sym_heredoc_redirect] = STATE(192),
    [aux_sym_redirected_statement_repeat1] = STATE(192),
    [sym_herestring_redirect] = STATE(192),
    [sym_file_redirect] = STATE(192),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(313),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(319),
    [anon_sym_AMP] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(930),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [ts_builtin_sym_end] = ACTIONS(914),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(317),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(313),
    [anon_sym_SEMI_SEMI] = ACTIONS(930),
    [anon_sym_PIPE_AMP] = ACTIONS(319),
  },
  [195] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(195),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_local] = ACTIONS(938),
    [anon_sym_typeset] = ACTIONS(938),
    [anon_sym_unsetenv] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [anon_sym_GT_LPAREN] = ACTIONS(947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(956),
    [sym_word] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(938),
    [sym__special_character] = ACTIONS(968),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(974),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(980),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_declare] = ACTIONS(938),
    [sym_variable_name] = ACTIONS(989),
    [sym_file_descriptor] = ACTIONS(992),
    [anon_sym_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(965),
    [anon_sym_readonly] = ACTIONS(938),
    [anon_sym_unset] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LPAREN] = ACTIONS(947),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(1004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1007),
  },
  [196] = {
    [sym_command_substitution] = STATE(198),
    [aux_sym__literal_repeat1] = STATE(200),
    [sym_string] = STATE(198),
    [sym_process_substitution] = STATE(198),
    [sym_simple_expansion] = STATE(198),
    [sym_string_expansion] = STATE(198),
    [aux_sym_command_repeat2] = STATE(517),
    [sym_concatenation] = STATE(517),
    [sym_expansion] = STATE(198),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [anon_sym_EQ_TILDE] = ACTIONS(341),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(341),
    [ts_builtin_sym_end] = ACTIONS(1012),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [197] = {
    [sym_variable_assignment] = STATE(197),
    [sym_subscript] = STATE(151),
    [aux_sym_command_repeat1] = STATE(197),
    [sym_file_redirect] = STATE(197),
    [anon_sym_BQUOTE] = ACTIONS(1014),
    [anon_sym_AMP_GT_GT] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1014),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym_variable_name] = ACTIONS(1024),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1014),
    [anon_sym_AMP_GT] = ACTIONS(1027),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1014),
    [anon_sym_GT_LPAREN] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_word] = ACTIONS(1014),
    [anon_sym_GT_AMP] = ACTIONS(1016),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_LT_AMP] = ACTIONS(1016),
    [anon_sym_GT_GT] = ACTIONS(1016),
    [anon_sym_LT_LPAREN] = ACTIONS(1014),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1014),
  },
  [198] = {
    [aux_sym_concatenation_repeat1] = STATE(99),
    [anon_sym_AMP_GT_GT] = ACTIONS(1030),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_LPAREN] = ACTIONS(1030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1030),
    [anon_sym_PIPE_PIPE] = ACTIONS(1030),
    [sym_word] = ACTIONS(1030),
    [anon_sym_PIPE] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_LT_AMP] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(1030),
    [sym__special_character] = ACTIONS(1030),
    [anon_sym_LT_LT_DASH] = ACTIONS(1030),
    [anon_sym_BQUOTE] = ACTIONS(1030),
    [anon_sym_LF] = ACTIONS(1032),
    [anon_sym_SEMI] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1030),
    [sym_file_descriptor] = ACTIONS(1032),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_AMP_GT] = ACTIONS(1030),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_LT_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_AMP] = ACTIONS(1030),
    [ts_builtin_sym_end] = ACTIONS(1032),
    [anon_sym_LT_LPAREN] = ACTIONS(1030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1030),
    [anon_sym_SEMI_SEMI] = ACTIONS(1030),
    [anon_sym_PIPE_AMP] = ACTIONS(1030),
  },
  [199] = {
    [sym_command_substitution] = STATE(518),
    [aux_sym__literal_repeat1] = STATE(520),
    [sym_string] = STATE(518),
    [sym_process_substitution] = STATE(518),
    [sym_simple_expansion] = STATE(518),
    [sym_string_expansion] = STATE(518),
    [sym_concatenation] = STATE(519),
    [sym_expansion] = STATE(518),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(1034),
    [sym_raw_string] = ACTIONS(1034),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [sym_regex] = ACTIONS(1036),
  },
  [200] = {
    [aux_sym__literal_repeat1] = STATE(183),
    [anon_sym_AMP_GT_GT] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_GT_LPAREN] = ACTIONS(1038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1038),
    [anon_sym_PIPE_PIPE] = ACTIONS(1038),
    [sym_word] = ACTIONS(1038),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_LT_AMP] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_EQ_TILDE] = ACTIONS(1038),
    [sym__special_character] = ACTIONS(299),
    [anon_sym_LT_LT_DASH] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [anon_sym_LF] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1038),
    [sym_raw_string] = ACTIONS(1038),
    [sym_file_descriptor] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_EQ_EQ] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [anon_sym_LT_LT_LT] = ACTIONS(1038),
    [anon_sym_GT_AMP] = ACTIONS(1038),
    [ts_builtin_sym_end] = ACTIONS(1040),
    [anon_sym_LT_LPAREN] = ACTIONS(1038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1038),
    [anon_sym_SEMI_SEMI] = ACTIONS(1038),
    [anon_sym_PIPE_AMP] = ACTIONS(1038),
  },
  [201] = {
    [sym_command_substitution] = STATE(198),
    [aux_sym__literal_repeat1] = STATE(200),
    [sym_string] = STATE(198),
    [sym_process_substitution] = STATE(198),
    [sym_simple_expansion] = STATE(198),
    [sym_string_expansion] = STATE(198),
    [aux_sym_command_repeat2] = STATE(521),
    [sym_concatenation] = STATE(521),
    [sym_expansion] = STATE(198),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [anon_sym_EQ_TILDE] = ACTIONS(341),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(341),
    [ts_builtin_sym_end] = ACTIONS(1012),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [202] = {
    [aux_sym_concatenation_repeat1] = STATE(522),
    [anon_sym_AMP_GT_GT] = ACTIONS(423),
    [anon_sym_DOLLAR] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_LPAREN] = ACTIONS(423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(423),
    [aux_sym__simple_variable_name_token1] = ACTIONS(423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [sym_word] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_LT_AMP] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [sym__concat] = ACTIONS(425),
    [sym__special_character] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(423),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LF] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(423),
    [sym_raw_string] = ACTIONS(423),
    [sym_variable_name] = ACTIONS(427),
    [anon_sym_RPAREN] = ACTIONS(423),
    [sym_file_descriptor] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [anon_sym_LT_LT_LT] = ACTIONS(423),
    [anon_sym_GT_AMP] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(423),
    [anon_sym_PIPE_AMP] = ACTIONS(423),
  },
  [203] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_EQ] = ACTIONS(1042),
  },
  [204] = {
    [aux_sym_concatenation_repeat1] = STATE(522),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(425),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [205] = {
    [aux_sym__literal_repeat1] = STATE(524),
    [anon_sym_AMP_GT_GT] = ACTIONS(451),
    [anon_sym_DOLLAR] = ACTIONS(451),
    [anon_sym_LT_LT] = ACTIONS(451),
    [anon_sym_GT_LPAREN] = ACTIONS(451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_word] = ACTIONS(451),
    [anon_sym_PIPE] = ACTIONS(451),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(451),
    [anon_sym_LT_AMP] = ACTIONS(451),
    [anon_sym_GT_GT] = ACTIONS(451),
    [sym__special_character] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(451),
    [anon_sym_BQUOTE] = ACTIONS(451),
    [anon_sym_LF] = ACTIONS(455),
    [anon_sym_SEMI] = ACTIONS(451),
    [sym_raw_string] = ACTIONS(451),
    [sym_variable_name] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(451),
    [sym_file_descriptor] = ACTIONS(455),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_AMP_GT] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(451),
    [anon_sym_LT_LT_LT] = ACTIONS(451),
    [anon_sym_GT_AMP] = ACTIONS(451),
    [anon_sym_LT_LPAREN] = ACTIONS(451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_SEMI_SEMI] = ACTIONS(451),
    [anon_sym_PIPE_AMP] = ACTIONS(451),
  },
  [206] = {
    [sym_command_substitution] = STATE(202),
    [aux_sym__literal_repeat1] = STATE(205),
    [sym_string] = STATE(202),
    [aux_sym_declaration_command_repeat1] = STATE(525),
    [sym_process_substitution] = STATE(202),
    [sym_simple_expansion] = STATE(202),
    [sym_subscript] = STATE(207),
    [sym_string_expansion] = STATE(202),
    [sym_variable_assignment] = STATE(525),
    [sym_concatenation] = STATE(525),
    [sym_expansion] = STATE(202),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [sym_word] = ACTIONS(351),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_LT_LT_DASH] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_SEMI] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(351),
    [sym_variable_name] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(457),
    [sym_file_descriptor] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
  },
  [207] = {
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_PLUS_EQ] = ACTIONS(1042),
    [sym_comment] = ACTIONS(51),
  },
  [208] = {
    [aux_sym_concatenation_repeat1] = STATE(526),
    [anon_sym_AMP_GT_GT] = ACTIONS(467),
    [anon_sym_DOLLAR] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(467),
    [aux_sym__simple_variable_name_token1] = ACTIONS(467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(467),
    [sym_word] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(467),
    [anon_sym_LT_AMP] = ACTIONS(467),
    [anon_sym_GT_GT] = ACTIONS(467),
    [sym__concat] = ACTIONS(469),
    [sym__special_character] = ACTIONS(467),
    [anon_sym_LT_LT_DASH] = ACTIONS(467),
    [anon_sym_BQUOTE] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(467),
    [sym_raw_string] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(467),
    [sym_file_descriptor] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(467),
    [anon_sym_AMP_GT] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(467),
    [anon_sym_LT_LT_LT] = ACTIONS(467),
    [anon_sym_GT_AMP] = ACTIONS(467),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(467),
    [anon_sym_SEMI_SEMI] = ACTIONS(467),
    [anon_sym_PIPE_AMP] = ACTIONS(467),
  },
  [209] = {
    [aux_sym_concatenation_repeat1] = STATE(526),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(469),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [anon_sym_RPAREN] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [210] = {
    [aux_sym__literal_repeat1] = STATE(527),
    [anon_sym_AMP_GT_GT] = ACTIONS(493),
    [anon_sym_DOLLAR] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_GT_LPAREN] = ACTIONS(493),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(493),
    [aux_sym__simple_variable_name_token1] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(493),
    [anon_sym_PIPE_PIPE] = ACTIONS(493),
    [sym_word] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_LT_AMP] = ACTIONS(493),
    [anon_sym_GT_GT] = ACTIONS(493),
    [sym__special_character] = ACTIONS(495),
    [anon_sym_LT_LT_DASH] = ACTIONS(493),
    [anon_sym_BQUOTE] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(497),
    [anon_sym_SEMI] = ACTIONS(493),
    [sym_raw_string] = ACTIONS(493),
    [anon_sym_RPAREN] = ACTIONS(493),
    [sym_file_descriptor] = ACTIONS(497),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_AMP_GT] = ACTIONS(493),
    [anon_sym_DQUOTE] = ACTIONS(493),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(493),
    [anon_sym_LT_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(493),
    [anon_sym_SEMI_SEMI] = ACTIONS(493),
    [anon_sym_PIPE_AMP] = ACTIONS(493),
  },
  [211] = {
    [sym_command_substitution] = STATE(208),
    [aux_sym__literal_repeat1] = STATE(210),
    [sym_string] = STATE(208),
    [aux_sym_unset_command_repeat1] = STATE(528),
    [sym_process_substitution] = STATE(208),
    [sym_simple_expansion] = STATE(208),
    [sym_string_expansion] = STATE(208),
    [sym_concatenation] = STATE(528),
    [sym_expansion] = STATE(208),
    [anon_sym_AMP_GT_GT] = ACTIONS(499),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(499),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [sym_word] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_AMP] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(499),
    [anon_sym_LT_AMP] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(499),
    [sym__special_character] = ACTIONS(361),
    [anon_sym_LT_LT_DASH] = ACTIONS(499),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(503),
    [anon_sym_SEMI] = ACTIONS(499),
    [sym_raw_string] = ACTIONS(359),
    [anon_sym_RPAREN] = ACTIONS(499),
    [sym_file_descriptor] = ACTIONS(503),
    [anon_sym_GT] = ACTIONS(499),
    [anon_sym_AMP_GT] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(499),
    [anon_sym_GT_AMP] = ACTIONS(499),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(499),
    [anon_sym_PIPE_AMP] = ACTIONS(499),
  },
  [212] = {
    [aux_sym_concatenation_repeat1] = STATE(529),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(583),
    [anon_sym_EQ_TILDE] = ACTIONS(581),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [anon_sym_RPAREN] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [213] = {
    [sym_command_substitution] = STATE(530),
    [aux_sym__literal_repeat1] = STATE(532),
    [sym_string] = STATE(530),
    [sym_array] = STATE(422),
    [sym_process_substitution] = STATE(530),
    [sym_simple_expansion] = STATE(530),
    [sym_string_expansion] = STATE(530),
    [sym_concatenation] = STATE(422),
    [sym_expansion] = STATE(530),
    [anon_sym_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [sym_word] = ACTIONS(1048),
    [sym_raw_string] = ACTIONS(1048),
    [anon_sym_LT_LPAREN] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(761),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(763),
    [sym__special_character] = ACTIONS(1050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(767),
    [sym__empty_value] = ACTIONS(769),
  },
  [214] = {
    [aux_sym__literal_repeat1] = STATE(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [sym__special_character] = ACTIONS(885),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [215] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(533),
    [sym_function_definition] = STATE(533),
    [sym_negated_command] = STATE(533),
    [sym_test_command] = STATE(533),
    [sym_variable_assignment] = STATE(534),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_redirected_statement] = STATE(533),
    [sym_for_statement] = STATE(533),
    [sym_compound_statement] = STATE(533),
    [sym_subshell] = STATE(533),
    [sym_declaration_command] = STATE(533),
    [sym_unset_command] = STATE(533),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym_c_style_for_statement] = STATE(533),
    [sym_while_statement] = STATE(533),
    [sym_case_statement] = STATE(533),
    [sym_pipeline] = STATE(533),
    [sym_list] = STATE(533),
    [sym_command] = STATE(533),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [216] = {
    [sym_command_substitution] = STATE(535),
    [aux_sym__literal_repeat1] = STATE(537),
    [sym_string] = STATE(535),
    [sym_process_substitution] = STATE(535),
    [sym_simple_expansion] = STATE(535),
    [sym_string_expansion] = STATE(535),
    [sym_concatenation] = STATE(501),
    [sym_expansion] = STATE(535),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(1052),
    [sym_raw_string] = ACTIONS(1052),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(1054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [217] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1056),
    [anon_sym_GT_AMP] = ACTIONS(1056),
    [anon_sym_LT] = ACTIONS(1058),
    [anon_sym_LT_AMP] = ACTIONS(1056),
    [anon_sym_GT_GT] = ACTIONS(1056),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1058),
    [anon_sym_AMP_GT] = ACTIONS(1058),
  },
  [218] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_negated_command] = STATE(539),
    [sym_test_command] = STATE(539),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [sym_redirected_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_compound_statement] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_declaration_command] = STATE(539),
    [sym_unset_command] = STATE(539),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym_c_style_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [219] = {
    [sym_command_substitution] = STATE(541),
    [aux_sym__literal_repeat1] = STATE(542),
    [sym_string] = STATE(541),
    [sym_process_substitution] = STATE(541),
    [sym_simple_expansion] = STATE(541),
    [sym_string_expansion] = STATE(541),
    [sym_concatenation] = STATE(511),
    [sym_expansion] = STATE(541),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(1060),
    [sym_raw_string] = ACTIONS(1060),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(1054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [220] = {
    [sym_heredoc_redirect] = STATE(543),
    [aux_sym_redirected_statement_repeat1] = STATE(543),
    [sym_herestring_redirect] = STATE(543),
    [sym_file_redirect] = STATE(543),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_AMP_GT_GT] = ACTIONS(365),
    [anon_sym_LF] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(926),
    [anon_sym_RPAREN] = ACTIONS(926),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(365),
    [sym_file_descriptor] = ACTIONS(369),
    [anon_sym_AMP_GT] = ACTIONS(365),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT_LT_LT] = ACTIONS(373),
    [anon_sym_PIPE] = ACTIONS(926),
    [anon_sym_GT_AMP] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_LT_AMP] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_SEMI_SEMI] = ACTIONS(926),
    [anon_sym_PIPE_AMP] = ACTIONS(926),
  },
  [221] = {
    [sym_heredoc_redirect] = STATE(220),
    [aux_sym_redirected_statement_repeat1] = STATE(220),
    [sym_herestring_redirect] = STATE(220),
    [sym_file_redirect] = STATE(220),
    [anon_sym_PIPE_AMP] = ACTIONS(375),
    [anon_sym_AMP_GT_GT] = ACTIONS(365),
    [anon_sym_LF] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(930),
    [anon_sym_RPAREN] = ACTIONS(1062),
    [sym_file_descriptor] = ACTIONS(369),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_AMP_GT] = ACTIONS(365),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [anon_sym_LT_LT_LT] = ACTIONS(373),
    [anon_sym_GT_AMP] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_LT_AMP] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_SEMI_SEMI] = ACTIONS(930),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
  },
  [222] = {
    [sym_heredoc_redirect] = STATE(220),
    [aux_sym_redirected_statement_repeat1] = STATE(220),
    [sym_herestring_redirect] = STATE(220),
    [sym_file_redirect] = STATE(220),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(930),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(1062),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(373),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_SEMI_SEMI] = ACTIONS(930),
    [anon_sym_PIPE_AMP] = ACTIONS(375),
  },
  [223] = {
    [sym_command_substitution] = STATE(225),
    [aux_sym__literal_repeat1] = STATE(227),
    [sym_string] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [aux_sym_command_repeat2] = STATE(544),
    [sym_concatenation] = STATE(544),
    [sym_expansion] = STATE(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [anon_sym_EQ_TILDE] = ACTIONS(383),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(381),
    [anon_sym_RPAREN] = ACTIONS(1010),
    [sym_file_descriptor] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [224] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1064),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_AMP_GT_GT] = ACTIONS(1064),
    [anon_sym_LF] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1064),
    [anon_sym_LT_LT] = ACTIONS(1064),
    [sym_file_descriptor] = ACTIONS(1066),
    [anon_sym_GT] = ACTIONS(1064),
    [anon_sym_RPAREN] = ACTIONS(1064),
    [anon_sym_AMP_GT] = ACTIONS(1064),
    [anon_sym_PIPE_PIPE] = ACTIONS(1064),
    [ts_builtin_sym_end] = ACTIONS(1066),
    [anon_sym_LT_LT_LT] = ACTIONS(1064),
    [anon_sym_PIPE] = ACTIONS(1064),
    [anon_sym_GT_AMP] = ACTIONS(1064),
    [anon_sym_LT] = ACTIONS(1064),
    [anon_sym_LT_AMP] = ACTIONS(1064),
    [anon_sym_GT_GT] = ACTIONS(1064),
    [anon_sym_AMP] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(1064),
    [anon_sym_AMP_AMP] = ACTIONS(1064),
    [anon_sym_SEMI_SEMI] = ACTIONS(1064),
    [anon_sym_PIPE_AMP] = ACTIONS(1064),
  },
  [225] = {
    [aux_sym_concatenation_repeat1] = STATE(212),
    [anon_sym_AMP_GT_GT] = ACTIONS(1030),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_LPAREN] = ACTIONS(1030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1030),
    [anon_sym_PIPE_PIPE] = ACTIONS(1030),
    [sym_word] = ACTIONS(1030),
    [anon_sym_PIPE] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_LT_AMP] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(1030),
    [sym__special_character] = ACTIONS(1030),
    [anon_sym_LT_LT_DASH] = ACTIONS(1030),
    [anon_sym_BQUOTE] = ACTIONS(1030),
    [anon_sym_LF] = ACTIONS(1032),
    [anon_sym_SEMI] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1030),
    [anon_sym_RPAREN] = ACTIONS(1030),
    [sym_file_descriptor] = ACTIONS(1032),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_AMP_GT] = ACTIONS(1030),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_LT_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_AMP] = ACTIONS(1030),
    [anon_sym_LT_LPAREN] = ACTIONS(1030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1030),
    [anon_sym_SEMI_SEMI] = ACTIONS(1030),
    [anon_sym_PIPE_AMP] = ACTIONS(1030),
  },
  [226] = {
    [sym_command_substitution] = STATE(545),
    [aux_sym__literal_repeat1] = STATE(546),
    [sym_string] = STATE(545),
    [sym_process_substitution] = STATE(545),
    [sym_simple_expansion] = STATE(545),
    [sym_string_expansion] = STATE(545),
    [sym_concatenation] = STATE(519),
    [sym_expansion] = STATE(545),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(1068),
    [sym_raw_string] = ACTIONS(1068),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [sym_regex] = ACTIONS(1036),
  },
  [227] = {
    [aux_sym__literal_repeat1] = STATE(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_GT_LPAREN] = ACTIONS(1038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1038),
    [anon_sym_PIPE_PIPE] = ACTIONS(1038),
    [sym_word] = ACTIONS(1038),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_LT_AMP] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_EQ_TILDE] = ACTIONS(1038),
    [sym__special_character] = ACTIONS(299),
    [anon_sym_LT_LT_DASH] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [anon_sym_LF] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1038),
    [sym_raw_string] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1038),
    [sym_file_descriptor] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_EQ_EQ] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [anon_sym_LT_LT_LT] = ACTIONS(1038),
    [anon_sym_GT_AMP] = ACTIONS(1038),
    [anon_sym_LT_LPAREN] = ACTIONS(1038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1038),
    [anon_sym_SEMI_SEMI] = ACTIONS(1038),
    [anon_sym_PIPE_AMP] = ACTIONS(1038),
  },
  [228] = {
    [sym_command_substitution] = STATE(225),
    [aux_sym__literal_repeat1] = STATE(227),
    [sym_string] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [aux_sym_command_repeat2] = STATE(547),
    [sym_concatenation] = STATE(547),
    [sym_expansion] = STATE(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [anon_sym_EQ_TILDE] = ACTIONS(383),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(381),
    [anon_sym_RPAREN] = ACTIONS(1010),
    [sym_file_descriptor] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [229] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1070),
  },
  [230] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [anon_sym_BQUOTE] = ACTIONS(789),
    [anon_sym_AMP_GT_GT] = ACTIONS(789),
    [sym_raw_string] = ACTIONS(789),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [sym_file_descriptor] = ACTIONS(789),
    [sym_variable_name] = ACTIONS(789),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(789),
    [anon_sym_AMP_GT] = ACTIONS(787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(789),
    [anon_sym_GT_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(789),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [sym_word] = ACTIONS(789),
    [anon_sym_GT_AMP] = ACTIONS(789),
    [sym__concat] = ACTIONS(789),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_LT_AMP] = ACTIONS(789),
    [anon_sym_GT_GT] = ACTIONS(789),
    [anon_sym_LT_LPAREN] = ACTIONS(789),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(789),
  },
  [232] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [233] = {
    [sym_command_substitution] = STATE(551),
    [sym_simple_expansion] = STATE(551),
    [sym_string_expansion] = STATE(551),
    [sym_string] = STATE(551),
    [sym_process_substitution] = STATE(551),
    [sym_expansion] = STATE(551),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(1076),
    [sym_raw_string] = ACTIONS(1076),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(1076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [234] = {
    [aux_sym_concatenation_repeat1] = STATE(553),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_AMP_GT_GT] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [sym_variable_name] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [anon_sym_GT_AMP] = ACTIONS(585),
    [sym__concat] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(585),
    [anon_sym_GT_GT] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(585),
  },
  [235] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1080),
  },
  [236] = {
    [anon_sym_BQUOTE] = ACTIONS(507),
    [anon_sym_AMP_GT_GT] = ACTIONS(507),
    [sym_raw_string] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [sym_file_descriptor] = ACTIONS(507),
    [sym_variable_name] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(507),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(507),
    [anon_sym_GT_LPAREN] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(507),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [sym_word] = ACTIONS(507),
    [anon_sym_GT_AMP] = ACTIONS(507),
    [sym__concat] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_LT_AMP] = ACTIONS(507),
    [anon_sym_GT_GT] = ACTIONS(507),
    [anon_sym_LT_LPAREN] = ACTIONS(507),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(507),
  },
  [237] = {
    [anon_sym_BQUOTE] = ACTIONS(511),
    [anon_sym_AMP_GT_GT] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(511),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [sym_file_descriptor] = ACTIONS(511),
    [sym_variable_name] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(511),
    [anon_sym_AMP_GT] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(511),
    [anon_sym_GT_LPAREN] = ACTIONS(511),
    [anon_sym_RPAREN] = ACTIONS(511),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_word] = ACTIONS(511),
    [anon_sym_GT_AMP] = ACTIONS(511),
    [sym__concat] = ACTIONS(511),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(511),
    [anon_sym_GT_GT] = ACTIONS(511),
    [anon_sym_LT_LPAREN] = ACTIONS(511),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(511),
  },
  [238] = {
    [anon_sym_BQUOTE] = ACTIONS(515),
    [anon_sym_AMP_GT_GT] = ACTIONS(515),
    [sym_raw_string] = ACTIONS(515),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(515),
    [sym_variable_name] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_GT_LPAREN] = ACTIONS(515),
    [anon_sym_RPAREN] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(515),
    [sym_word] = ACTIONS(515),
    [anon_sym_GT_AMP] = ACTIONS(515),
    [sym__concat] = ACTIONS(515),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(515),
    [anon_sym_GT_GT] = ACTIONS(515),
    [anon_sym_LT_LPAREN] = ACTIONS(515),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(515),
  },
  [239] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [240] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1070),
  },
  [241] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(557),
    [sym_concatenation] = STATE(557),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1082),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1084),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1084),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1088),
    [anon_sym_COLON_DASH] = ACTIONS(1084),
    [sym__special_character] = ACTIONS(553),
  },
  [242] = {
    [sym_subscript] = STATE(558),
    [anon_sym_STAR] = ACTIONS(1090),
    [anon_sym_QMARK] = ACTIONS(1090),
    [anon_sym_AT] = ACTIONS(1090),
    [sym_variable_name] = ACTIONS(1092),
    [anon_sym_DOLLAR] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_0] = ACTIONS(1096),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1096),
    [anon_sym__] = ACTIONS(1096),
  },
  [243] = {
    [anon_sym_EQ] = ACTIONS(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [244] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(564),
    [sym_concatenation] = STATE(564),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1100),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1102),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1102),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1102),
    [anon_sym_PERCENT] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1106),
    [anon_sym_COLON_DASH] = ACTIONS(1102),
    [sym__special_character] = ACTIONS(553),
  },
  [245] = {
    [anon_sym_BQUOTE] = ACTIONS(189),
    [anon_sym_AMP_GT_GT] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [sym_variable_name] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(189),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(189),
    [anon_sym_GT_LPAREN] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [sym_word] = ACTIONS(189),
    [anon_sym_GT_AMP] = ACTIONS(189),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(189),
    [anon_sym_GT_GT] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(189),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(189),
  },
  [246] = {
    [aux_sym__literal_repeat1] = STATE(246),
    [anon_sym_BQUOTE] = ACTIONS(888),
    [anon_sym_AMP_GT_GT] = ACTIONS(888),
    [sym_raw_string] = ACTIONS(888),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [sym_variable_name] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(888),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(888),
    [anon_sym_GT_LPAREN] = ACTIONS(888),
    [anon_sym_DQUOTE] = ACTIONS(888),
    [sym_word] = ACTIONS(888),
    [anon_sym_GT_AMP] = ACTIONS(888),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(888),
    [anon_sym_LT_LPAREN] = ACTIONS(888),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1108),
  },
  [247] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1111),
  },
  [248] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(787),
    [anon_sym_GT_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(787),
    [aux_sym__simple_variable_name_token1] = ACTIONS(787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [sym_word] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_LT_AMP] = ACTIONS(787),
    [anon_sym_GT_GT] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [sym__special_character] = ACTIONS(787),
    [anon_sym_LT_LT_DASH] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(787),
    [anon_sym_LF] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [sym_raw_string] = ACTIONS(787),
    [sym_variable_name] = ACTIONS(789),
    [sym_file_descriptor] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_AMP_GT] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_LT_LT_LT] = ACTIONS(787),
    [anon_sym_GT_AMP] = ACTIONS(787),
    [ts_builtin_sym_end] = ACTIONS(789),
    [anon_sym_LT_LPAREN] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
    [anon_sym_PIPE_AMP] = ACTIONS(787),
  },
  [250] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(1115),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [251] = {
    [sym_command_substitution] = STATE(568),
    [sym_simple_expansion] = STATE(568),
    [sym_string_expansion] = STATE(568),
    [sym_string] = STATE(568),
    [sym_process_substitution] = STATE(568),
    [sym_expansion] = STATE(568),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [anon_sym_DQUOTE] = ACTIONS(431),
    [sym_word] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_LT_LPAREN] = ACTIONS(1121),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [sym__special_character] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
  },
  [252] = {
    [aux_sym_concatenation_repeat1] = STATE(570),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [ts_builtin_sym_end] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [253] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1129),
  },
  [254] = {
    [sym_command_substitution] = STATE(573),
    [aux_sym__literal_repeat1] = STATE(575),
    [sym_string] = STATE(573),
    [sym_array] = STATE(574),
    [sym_process_substitution] = STATE(573),
    [sym_simple_expansion] = STATE(573),
    [sym_string_expansion] = STATE(573),
    [sym_concatenation] = STATE(574),
    [sym_expansion] = STATE(573),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [anon_sym_DQUOTE] = ACTIONS(431),
    [sym_word] = ACTIONS(1133),
    [sym_raw_string] = ACTIONS(1133),
    [anon_sym_LT_LPAREN] = ACTIONS(1121),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [sym__special_character] = ACTIONS(1135),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [sym__empty_value] = ACTIONS(1137),
  },
  [255] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_LT_LT] = ACTIONS(505),
    [anon_sym_GT_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(505),
    [aux_sym__simple_variable_name_token1] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [sym_word] = ACTIONS(505),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_AMP] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_LT_AMP] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [sym__special_character] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [sym_raw_string] = ACTIONS(505),
    [sym_variable_name] = ACTIONS(507),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(505),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(505),
    [anon_sym_LT_LT_LT] = ACTIONS(505),
    [anon_sym_GT_AMP] = ACTIONS(505),
    [ts_builtin_sym_end] = ACTIONS(507),
    [anon_sym_LT_LPAREN] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
    [anon_sym_PIPE_AMP] = ACTIONS(505),
  },
  [256] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(509),
    [anon_sym_GT_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(509),
    [aux_sym__simple_variable_name_token1] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(509),
    [anon_sym_PIPE_PIPE] = ACTIONS(509),
    [sym_word] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_GT] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_LT_LT_DASH] = ACTIONS(509),
    [anon_sym_BQUOTE] = ACTIONS(509),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(509),
    [sym_variable_name] = ACTIONS(511),
    [sym_file_descriptor] = ACTIONS(511),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_LT_LT_LT] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [ts_builtin_sym_end] = ACTIONS(511),
    [anon_sym_LT_LPAREN] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
    [anon_sym_PIPE_AMP] = ACTIONS(509),
  },
  [257] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_variable_name] = ACTIONS(515),
    [sym_file_descriptor] = ACTIONS(515),
    [anon_sym_RPAREN] = ACTIONS(513),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [ts_builtin_sym_end] = ACTIONS(515),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [258] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [259] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1111),
  },
  [260] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(578),
    [sym_concatenation] = STATE(578),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1139),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1141),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1141),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_PERCENT] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1145),
    [anon_sym_COLON_DASH] = ACTIONS(1141),
    [sym__special_character] = ACTIONS(553),
  },
  [261] = {
    [sym_subscript] = STATE(579),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1147),
    [sym_variable_name] = ACTIONS(1149),
    [anon_sym_DOLLAR] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_0] = ACTIONS(1153),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1153),
    [anon_sym__] = ACTIONS(1153),
  },
  [262] = {
    [anon_sym_EQ] = ACTIONS(1155),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [263] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(585),
    [sym_concatenation] = STATE(585),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1157),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1159),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1161),
    [anon_sym_DASH] = ACTIONS(1159),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1163),
    [anon_sym_COLON_DASH] = ACTIONS(1159),
    [sym__special_character] = ACTIONS(553),
  },
  [264] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [ts_builtin_sym_end] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [265] = {
    [aux_sym__literal_repeat1] = STATE(265),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [aux_sym__simple_variable_name_token1] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(1165),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_variable_name] = ACTIONS(888),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [ts_builtin_sym_end] = ACTIONS(888),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [266] = {
    [sym_command_substitution] = STATE(64),
    [aux_sym__literal_repeat1] = STATE(71),
    [sym_string] = STATE(64),
    [aux_sym_declaration_command_repeat1] = STATE(266),
    [sym_process_substitution] = STATE(64),
    [sym_simple_expansion] = STATE(64),
    [sym_subscript] = STATE(73),
    [sym_string_expansion] = STATE(64),
    [sym_variable_assignment] = STATE(266),
    [sym_concatenation] = STATE(266),
    [sym_expansion] = STATE(64),
    [anon_sym_AMP_GT_GT] = ACTIONS(1168),
    [anon_sym_DOLLAR] = ACTIONS(1170),
    [anon_sym_LT_LT] = ACTIONS(1168),
    [anon_sym_GT_LPAREN] = ACTIONS(1173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1176),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1182),
    [anon_sym_PIPE_PIPE] = ACTIONS(1168),
    [sym_word] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1168),
    [anon_sym_AMP] = ACTIONS(1168),
    [anon_sym_LT] = ACTIONS(1168),
    [anon_sym_LT_AMP] = ACTIONS(1168),
    [anon_sym_GT_GT] = ACTIONS(1168),
    [sym__special_character] = ACTIONS(1188),
    [anon_sym_LT_LT_DASH] = ACTIONS(1168),
    [anon_sym_BQUOTE] = ACTIONS(1191),
    [anon_sym_LF] = ACTIONS(1194),
    [anon_sym_SEMI] = ACTIONS(1168),
    [sym_raw_string] = ACTIONS(1185),
    [sym_variable_name] = ACTIONS(1196),
    [sym_file_descriptor] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1168),
    [anon_sym_AMP_GT] = ACTIONS(1168),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_LT_LT_LT] = ACTIONS(1168),
    [anon_sym_GT_AMP] = ACTIONS(1168),
    [ts_builtin_sym_end] = ACTIONS(1194),
    [anon_sym_LT_LPAREN] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_SEMI_SEMI] = ACTIONS(1168),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
  },
  [267] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1202),
  },
  [268] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(787),
    [anon_sym_GT_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(787),
    [aux_sym__simple_variable_name_token1] = ACTIONS(787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [sym_word] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_LT_AMP] = ACTIONS(787),
    [anon_sym_GT_GT] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [sym__special_character] = ACTIONS(787),
    [anon_sym_LT_LT_DASH] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(787),
    [anon_sym_LF] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [sym_raw_string] = ACTIONS(787),
    [sym_file_descriptor] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_AMP_GT] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_LT_LT_LT] = ACTIONS(787),
    [anon_sym_GT_AMP] = ACTIONS(787),
    [ts_builtin_sym_end] = ACTIONS(789),
    [anon_sym_LT_LPAREN] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
    [anon_sym_PIPE_AMP] = ACTIONS(787),
  },
  [270] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(1206),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [271] = {
    [sym_command_substitution] = STATE(589),
    [sym_simple_expansion] = STATE(589),
    [sym_string_expansion] = STATE(589),
    [sym_string] = STATE(589),
    [sym_process_substitution] = STATE(589),
    [sym_expansion] = STATE(589),
    [anon_sym_BQUOTE] = ACTIONS(1208),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [sym_word] = ACTIONS(1210),
    [sym_raw_string] = ACTIONS(1210),
    [anon_sym_LT_LPAREN] = ACTIONS(1212),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1214),
    [sym__special_character] = ACTIONS(1210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1216),
  },
  [272] = {
    [aux_sym_concatenation_repeat1] = STATE(591),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(1218),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [ts_builtin_sym_end] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [273] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1220),
  },
  [274] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_LT_LT] = ACTIONS(505),
    [anon_sym_GT_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(505),
    [aux_sym__simple_variable_name_token1] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [sym_word] = ACTIONS(505),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_AMP] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_LT_AMP] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [sym__special_character] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [sym_raw_string] = ACTIONS(505),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(505),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(505),
    [anon_sym_LT_LT_LT] = ACTIONS(505),
    [anon_sym_GT_AMP] = ACTIONS(505),
    [ts_builtin_sym_end] = ACTIONS(507),
    [anon_sym_LT_LPAREN] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
    [anon_sym_PIPE_AMP] = ACTIONS(505),
  },
  [275] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(509),
    [anon_sym_GT_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(509),
    [aux_sym__simple_variable_name_token1] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(509),
    [anon_sym_PIPE_PIPE] = ACTIONS(509),
    [sym_word] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_GT] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_LT_LT_DASH] = ACTIONS(509),
    [anon_sym_BQUOTE] = ACTIONS(509),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(509),
    [sym_file_descriptor] = ACTIONS(511),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_LT_LT_LT] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [ts_builtin_sym_end] = ACTIONS(511),
    [anon_sym_LT_LPAREN] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
    [anon_sym_PIPE_AMP] = ACTIONS(509),
  },
  [276] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(515),
    [anon_sym_RPAREN] = ACTIONS(513),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [ts_builtin_sym_end] = ACTIONS(515),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [277] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(1202),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [278] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1202),
  },
  [279] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(595),
    [sym_concatenation] = STATE(595),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1222),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1224),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1226),
    [anon_sym_DASH] = ACTIONS(1224),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1224),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1224),
    [anon_sym_PERCENT] = ACTIONS(1224),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1228),
    [anon_sym_COLON_DASH] = ACTIONS(1224),
    [sym__special_character] = ACTIONS(553),
  },
  [280] = {
    [sym_subscript] = STATE(596),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1230),
    [sym_variable_name] = ACTIONS(1232),
    [anon_sym_DOLLAR] = ACTIONS(1234),
    [anon_sym_DASH] = ACTIONS(1234),
    [anon_sym_0] = ACTIONS(1236),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1236),
    [anon_sym__] = ACTIONS(1236),
  },
  [281] = {
    [anon_sym_EQ] = ACTIONS(1238),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [282] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(602),
    [sym_concatenation] = STATE(602),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1240),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1242),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1246),
    [anon_sym_COLON_DASH] = ACTIONS(1242),
    [sym__special_character] = ACTIONS(553),
  },
  [283] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [ts_builtin_sym_end] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [284] = {
    [aux_sym__literal_repeat1] = STATE(284),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [aux_sym__simple_variable_name_token1] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(1248),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [ts_builtin_sym_end] = ACTIONS(888),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [285] = {
    [sym_command_substitution] = STATE(76),
    [aux_sym__literal_repeat1] = STATE(82),
    [sym_string] = STATE(76),
    [aux_sym_unset_command_repeat1] = STATE(285),
    [sym_process_substitution] = STATE(76),
    [sym_simple_expansion] = STATE(76),
    [sym_string_expansion] = STATE(76),
    [sym_concatenation] = STATE(285),
    [sym_expansion] = STATE(76),
    [anon_sym_AMP_GT_GT] = ACTIONS(1251),
    [anon_sym_DOLLAR] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_GT_LPAREN] = ACTIONS(1256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1259),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1251),
    [sym_word] = ACTIONS(1268),
    [anon_sym_PIPE] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1251),
    [anon_sym_LT_AMP] = ACTIONS(1251),
    [anon_sym_GT_GT] = ACTIONS(1251),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1251),
    [anon_sym_BQUOTE] = ACTIONS(1274),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1251),
    [sym_raw_string] = ACTIONS(1268),
    [sym_file_descriptor] = ACTIONS(1277),
    [anon_sym_GT] = ACTIONS(1251),
    [anon_sym_AMP_GT] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [anon_sym_LT_LT_LT] = ACTIONS(1251),
    [anon_sym_GT_AMP] = ACTIONS(1251),
    [ts_builtin_sym_end] = ACTIONS(1277),
    [anon_sym_LT_LPAREN] = ACTIONS(1256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1251),
    [anon_sym_SEMI_SEMI] = ACTIONS(1251),
    [anon_sym_PIPE_AMP] = ACTIONS(1251),
  },
  [286] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [sym_word] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_LT_AMP] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [anon_sym_EQ_TILDE] = ACTIONS(1282),
    [sym__special_character] = ACTIONS(1282),
    [anon_sym_LT_LT_DASH] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_LF] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [sym_raw_string] = ACTIONS(1282),
    [sym_file_descriptor] = ACTIONS(1284),
    [anon_sym_RPAREN] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_AMP_GT] = ACTIONS(1282),
    [anon_sym_EQ_EQ] = ACTIONS(1282),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_LT_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_AMP] = ACTIONS(1282),
    [ts_builtin_sym_end] = ACTIONS(1284),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
    [anon_sym_PIPE_AMP] = ACTIONS(1282),
  },
  [287] = {
    [aux_sym_concatenation_repeat1] = STATE(603),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [sym_variable_name] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [sym__concat] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(389),
  },
  [288] = {
    [aux_sym_concatenation_repeat1] = STATE(603),
    [anon_sym_BQUOTE] = ACTIONS(189),
    [anon_sym_AMP_GT_GT] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_RPAREN] = ACTIONS(189),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(189),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(189),
    [anon_sym_GT_LPAREN] = ACTIONS(189),
    [sym_variable_name] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [sym_word] = ACTIONS(189),
    [anon_sym_GT_AMP] = ACTIONS(189),
    [sym__concat] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(189),
    [anon_sym_GT_GT] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(189),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(189),
  },
  [289] = {
    [aux_sym__literal_repeat1] = STATE(604),
    [anon_sym_BQUOTE] = ACTIONS(413),
    [anon_sym_AMP_GT_GT] = ACTIONS(413),
    [sym_raw_string] = ACTIONS(413),
    [anon_sym_DOLLAR] = ACTIONS(415),
    [anon_sym_RPAREN] = ACTIONS(413),
    [sym_file_descriptor] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(415),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(413),
    [anon_sym_GT_LPAREN] = ACTIONS(413),
    [sym_variable_name] = ACTIONS(413),
    [anon_sym_DQUOTE] = ACTIONS(413),
    [sym_word] = ACTIONS(413),
    [anon_sym_GT_AMP] = ACTIONS(413),
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_LT_AMP] = ACTIONS(413),
    [anon_sym_GT_GT] = ACTIONS(413),
    [anon_sym_LT_LPAREN] = ACTIONS(413),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(417),
  },
  [290] = {
    [sym_command_substitution] = STATE(605),
    [aux_sym__literal_repeat1] = STATE(606),
    [sym_string] = STATE(605),
    [sym_process_substitution] = STATE(605),
    [sym_simple_expansion] = STATE(605),
    [sym_string_expansion] = STATE(605),
    [sym_concatenation] = STATE(430),
    [sym_expansion] = STATE(605),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(1286),
    [sym_raw_string] = ACTIONS(1286),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [291] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE_PIPE] = ACTIONS(1288),
    [sym_word] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_LT_AMP] = ACTIONS(1288),
    [anon_sym_GT_GT] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [anon_sym_EQ_TILDE] = ACTIONS(1288),
    [sym__special_character] = ACTIONS(1288),
    [anon_sym_LT_LT_DASH] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LF] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1288),
    [sym_raw_string] = ACTIONS(1288),
    [sym_file_descriptor] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_AMP_GT] = ACTIONS(1288),
    [anon_sym_EQ_EQ] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_LT_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_AMP] = ACTIONS(1288),
    [ts_builtin_sym_end] = ACTIONS(1290),
    [anon_sym_LT_LPAREN] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
    [anon_sym_PIPE_AMP] = ACTIONS(1288),
  },
  [292] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(607),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [293] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(610),
    [sym_concatenation] = STATE(610),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1292),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1292),
    [anon_sym_PERCENT] = ACTIONS(1292),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_COLON_DASH] = ACTIONS(1292),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(1298),
  },
  [294] = {
    [aux_sym_concatenation_repeat1] = STATE(612),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [sym_raw_string] = ACTIONS(1300),
    [anon_sym_COLON_QMARK] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1300),
    [anon_sym_EQ] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1300),
    [anon_sym_PERCENT] = ACTIONS(1302),
    [anon_sym_COLON] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [sym_word] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1300),
    [anon_sym_COLON_DASH] = ACTIONS(1302),
    [sym__special_character] = ACTIONS(1302),
  },
  [295] = {
    [sym_string] = STATE(614),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [anon_sym_STAR] = ACTIONS(1306),
    [anon_sym_QMARK] = ACTIONS(1306),
    [sym_raw_string] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(1306),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [anon_sym_POUND] = ACTIONS(1310),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_0] = ACTIONS(1312),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1312),
    [anon_sym__] = ACTIONS(1312),
  },
  [296] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(616),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [297] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(617),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(618),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [298] = {
    [sym_subscript] = STATE(619),
    [anon_sym_STAR] = ACTIONS(1314),
    [anon_sym_QMARK] = ACTIONS(1314),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1314),
    [sym_variable_name] = ACTIONS(1318),
    [anon_sym_DOLLAR] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1320),
    [anon_sym_0] = ACTIONS(1322),
    [anon_sym_POUND] = ACTIONS(1316),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1322),
    [anon_sym__] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [sym_word] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_LT_AMP] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [anon_sym_EQ_TILDE] = ACTIONS(1324),
    [sym__special_character] = ACTIONS(1324),
    [anon_sym_LT_LT_DASH] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [anon_sym_LF] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_raw_string] = ACTIONS(1324),
    [sym_file_descriptor] = ACTIONS(1326),
    [anon_sym_RPAREN] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_AMP_GT] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_LT_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_AMP] = ACTIONS(1324),
    [ts_builtin_sym_end] = ACTIONS(1326),
    [anon_sym_LT_LPAREN] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
    [anon_sym_PIPE_AMP] = ACTIONS(1324),
  },
  [300] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(625),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [301] = {
    [aux_sym_concatenation_repeat1] = STATE(612),
    [anon_sym_BQUOTE] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(189),
    [anon_sym_COLON_QMARK] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(189),
    [anon_sym_PERCENT] = ACTIONS(187),
    [anon_sym_COLON] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [sym_word] = ACTIONS(187),
    [sym__concat] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(189),
    [anon_sym_COLON_DASH] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
  },
  [302] = {
    [aux_sym__literal_repeat1] = STATE(627),
    [anon_sym_BQUOTE] = ACTIONS(1332),
    [sym_raw_string] = ACTIONS(1332),
    [anon_sym_COLON_QMARK] = ACTIONS(1334),
    [anon_sym_DOLLAR] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1332),
    [anon_sym_EQ] = ACTIONS(1334),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1332),
    [anon_sym_PERCENT] = ACTIONS(1334),
    [anon_sym_COLON] = ACTIONS(1334),
    [anon_sym_GT_LPAREN] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [sym_word] = ACTIONS(1334),
    [anon_sym_LT_LPAREN] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1332),
    [anon_sym_COLON_DASH] = ACTIONS(1334),
    [sym__special_character] = ACTIONS(1336),
  },
  [303] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [304] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(610),
    [sym_concatenation] = STATE(610),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1342),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1292),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1292),
    [anon_sym_PERCENT] = ACTIONS(1292),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1296),
    [anon_sym_COLON_DASH] = ACTIONS(1292),
    [sym__special_character] = ACTIONS(553),
  },
  [305] = {
    [anon_sym_EQ] = ACTIONS(1344),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [306] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(633),
    [sym_concatenation] = STATE(633),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1346),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1348),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1348),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1348),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1348),
    [anon_sym_PERCENT] = ACTIONS(1348),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1352),
    [anon_sym_COLON_DASH] = ACTIONS(1348),
    [sym__special_character] = ACTIONS(553),
  },
  [307] = {
    [sym_command_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [sym_string] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_concatenation] = STATE(643),
    [sym_expansion] = STATE(636),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(1358),
    [sym_raw_string] = ACTIONS(1358),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [308] = {
    [sym_command_substitution] = STATE(644),
    [aux_sym__literal_repeat1] = STATE(645),
    [sym_string] = STATE(644),
    [sym_process_substitution] = STATE(644),
    [sym_simple_expansion] = STATE(644),
    [sym_string_expansion] = STATE(644),
    [sym_concatenation] = STATE(646),
    [sym_expansion] = STATE(644),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym_word] = ACTIONS(1370),
    [sym_raw_string] = ACTIONS(1370),
    [anon_sym_LT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR] = ACTIONS(279),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [sym__special_character] = ACTIONS(773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(285),
  },
  [309] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(649),
    [sym_concatenation] = STATE(649),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1372),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1372),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1376),
    [anon_sym_COLON_DASH] = ACTIONS(1372),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(1378),
  },
  [310] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym_word] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [anon_sym_EQ_TILDE] = ACTIONS(1380),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_EQ_EQ] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [ts_builtin_sym_end] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
  },
  [311] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [312] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1384),
  },
  [313] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1386),
    [anon_sym_BQUOTE] = ACTIONS(1386),
    [anon_sym_AMP_GT_GT] = ACTIONS(1386),
    [anon_sym_LF] = ACTIONS(1388),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [sym_file_descriptor] = ACTIONS(1388),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_RPAREN] = ACTIONS(1386),
    [anon_sym_AMP_GT] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1386),
    [ts_builtin_sym_end] = ACTIONS(1388),
    [anon_sym_LT_LT_LT] = ACTIONS(1386),
    [anon_sym_PIPE] = ACTIONS(1386),
    [anon_sym_GT_AMP] = ACTIONS(1386),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_LT_AMP] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1386),
    [anon_sym_AMP] = ACTIONS(1386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(1386),
    [anon_sym_AMP_AMP] = ACTIONS(1386),
    [anon_sym_SEMI_SEMI] = ACTIONS(1386),
    [anon_sym_PIPE_AMP] = ACTIONS(1386),
  },
  [314] = {
    [sym_compound_statement] = STATE(651),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
  },
  [315] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [anon_sym_EQ_TILDE] = ACTIONS(1390),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [ts_builtin_sym_end] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [316] = {
    [sym_command_substitution] = STATE(315),
    [sym_simple_expansion] = STATE(315),
    [sym_string_expansion] = STATE(315),
    [sym_string] = STATE(315),
    [sym_process_substitution] = STATE(315),
    [sym_expansion] = STATE(315),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(579),
    [sym_raw_string] = ACTIONS(579),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(1394),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(579),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
  },
  [317] = {
    [aux_sym_concatenation_repeat1] = STATE(317),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1396),
    [anon_sym_EQ_TILDE] = ACTIONS(1390),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [ts_builtin_sym_end] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [318] = {
    [aux_sym_concatenation_repeat1] = STATE(653),
    [anon_sym_AMP_GT_GT] = ACTIONS(423),
    [anon_sym_DOLLAR] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_LPAREN] = ACTIONS(423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(423),
    [aux_sym__simple_variable_name_token1] = ACTIONS(423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [sym_word] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_LT_AMP] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [sym__concat] = ACTIONS(425),
    [sym__special_character] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(423),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LF] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(423),
    [sym_raw_string] = ACTIONS(423),
    [sym_variable_name] = ACTIONS(427),
    [sym_file_descriptor] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [anon_sym_LT_LT_LT] = ACTIONS(423),
    [anon_sym_GT_AMP] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(423),
    [anon_sym_PIPE_AMP] = ACTIONS(423),
  },
  [319] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_EQ] = ACTIONS(1399),
  },
  [320] = {
    [aux_sym_concatenation_repeat1] = STATE(653),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(425),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [321] = {
    [aux_sym__literal_repeat1] = STATE(655),
    [anon_sym_AMP_GT_GT] = ACTIONS(451),
    [anon_sym_DOLLAR] = ACTIONS(451),
    [anon_sym_LT_LT] = ACTIONS(451),
    [anon_sym_GT_LPAREN] = ACTIONS(451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_word] = ACTIONS(451),
    [anon_sym_PIPE] = ACTIONS(451),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(451),
    [anon_sym_LT_AMP] = ACTIONS(451),
    [anon_sym_GT_GT] = ACTIONS(451),
    [sym__special_character] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(451),
    [anon_sym_BQUOTE] = ACTIONS(451),
    [anon_sym_LF] = ACTIONS(455),
    [anon_sym_SEMI] = ACTIONS(451),
    [sym_raw_string] = ACTIONS(451),
    [sym_variable_name] = ACTIONS(455),
    [sym_file_descriptor] = ACTIONS(455),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_AMP_GT] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(451),
    [anon_sym_LT_LT_LT] = ACTIONS(451),
    [anon_sym_GT_AMP] = ACTIONS(451),
    [anon_sym_LT_LPAREN] = ACTIONS(451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_SEMI_SEMI] = ACTIONS(451),
    [anon_sym_PIPE_AMP] = ACTIONS(451),
  },
  [322] = {
    [sym_command_substitution] = STATE(318),
    [aux_sym__literal_repeat1] = STATE(321),
    [sym_string] = STATE(318),
    [aux_sym_declaration_command_repeat1] = STATE(656),
    [sym_process_substitution] = STATE(318),
    [sym_simple_expansion] = STATE(318),
    [sym_subscript] = STATE(323),
    [sym_string_expansion] = STATE(318),
    [sym_variable_assignment] = STATE(656),
    [sym_concatenation] = STATE(656),
    [sym_expansion] = STATE(318),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [sym_word] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [sym__special_character] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_SEMI] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(589),
    [sym_variable_name] = ACTIONS(593),
    [sym_file_descriptor] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
  },
  [323] = {
    [anon_sym_EQ] = ACTIONS(1399),
    [anon_sym_PLUS_EQ] = ACTIONS(1399),
    [sym_comment] = ACTIONS(51),
  },
  [324] = {
    [aux_sym_concatenation_repeat1] = STATE(657),
    [anon_sym_AMP_GT_GT] = ACTIONS(467),
    [anon_sym_DOLLAR] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(467),
    [aux_sym__simple_variable_name_token1] = ACTIONS(467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(467),
    [sym_word] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(467),
    [anon_sym_LT_AMP] = ACTIONS(467),
    [anon_sym_GT_GT] = ACTIONS(467),
    [sym__concat] = ACTIONS(469),
    [sym__special_character] = ACTIONS(467),
    [anon_sym_LT_LT_DASH] = ACTIONS(467),
    [anon_sym_BQUOTE] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(467),
    [sym_raw_string] = ACTIONS(467),
    [sym_file_descriptor] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(467),
    [anon_sym_AMP_GT] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(467),
    [anon_sym_LT_LT_LT] = ACTIONS(467),
    [anon_sym_GT_AMP] = ACTIONS(467),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(467),
    [anon_sym_SEMI_SEMI] = ACTIONS(467),
    [anon_sym_PIPE_AMP] = ACTIONS(467),
  },
  [325] = {
    [aux_sym_concatenation_repeat1] = STATE(657),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(469),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [326] = {
    [aux_sym__literal_repeat1] = STATE(658),
    [anon_sym_AMP_GT_GT] = ACTIONS(493),
    [anon_sym_DOLLAR] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_GT_LPAREN] = ACTIONS(493),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(493),
    [aux_sym__simple_variable_name_token1] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(493),
    [anon_sym_PIPE_PIPE] = ACTIONS(493),
    [sym_word] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_LT_AMP] = ACTIONS(493),
    [anon_sym_GT_GT] = ACTIONS(493),
    [sym__special_character] = ACTIONS(495),
    [anon_sym_LT_LT_DASH] = ACTIONS(493),
    [anon_sym_BQUOTE] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(497),
    [anon_sym_SEMI] = ACTIONS(493),
    [sym_raw_string] = ACTIONS(493),
    [sym_file_descriptor] = ACTIONS(497),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_AMP_GT] = ACTIONS(493),
    [anon_sym_DQUOTE] = ACTIONS(493),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(493),
    [anon_sym_LT_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(493),
    [anon_sym_SEMI_SEMI] = ACTIONS(493),
    [anon_sym_PIPE_AMP] = ACTIONS(493),
  },
  [327] = {
    [sym_command_substitution] = STATE(324),
    [aux_sym__literal_repeat1] = STATE(326),
    [sym_string] = STATE(324),
    [aux_sym_unset_command_repeat1] = STATE(659),
    [sym_process_substitution] = STATE(324),
    [sym_simple_expansion] = STATE(324),
    [sym_string_expansion] = STATE(324),
    [sym_concatenation] = STATE(659),
    [sym_expansion] = STATE(324),
    [anon_sym_AMP_GT_GT] = ACTIONS(499),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(499),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [sym_word] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_AMP] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(499),
    [anon_sym_LT_AMP] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(499),
    [sym__special_character] = ACTIONS(599),
    [anon_sym_LT_LT_DASH] = ACTIONS(499),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_LF] = ACTIONS(503),
    [anon_sym_SEMI] = ACTIONS(499),
    [sym_raw_string] = ACTIONS(597),
    [sym_file_descriptor] = ACTIONS(503),
    [anon_sym_GT] = ACTIONS(499),
    [anon_sym_AMP_GT] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(499),
    [anon_sym_GT_AMP] = ACTIONS(499),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(499),
    [anon_sym_PIPE_AMP] = ACTIONS(499),
  },
  [328] = {
    [aux_sym_concatenation_repeat1] = STATE(660),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(583),
    [anon_sym_EQ_TILDE] = ACTIONS(581),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [329] = {
    [sym_command_substitution] = STATE(661),
    [aux_sym__literal_repeat1] = STATE(663),
    [sym_string] = STATE(661),
    [sym_array] = STATE(422),
    [sym_process_substitution] = STATE(661),
    [sym_simple_expansion] = STATE(661),
    [sym_string_expansion] = STATE(661),
    [sym_concatenation] = STATE(422),
    [sym_expansion] = STATE(661),
    [anon_sym_LPAREN] = ACTIONS(751),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [sym_word] = ACTIONS(1405),
    [sym_raw_string] = ACTIONS(1405),
    [anon_sym_LT_LPAREN] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(761),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(763),
    [sym__special_character] = ACTIONS(1407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(767),
    [sym__empty_value] = ACTIONS(769),
  },
  [330] = {
    [aux_sym__literal_repeat1] = STATE(330),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [sym__special_character] = ACTIONS(885),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [331] = {
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [anon_sym_RBRACE] = ACTIONS(908),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [332] = {
    [sym_command_substitution] = STATE(664),
    [aux_sym__literal_repeat1] = STATE(666),
    [sym_string] = STATE(664),
    [sym_process_substitution] = STATE(664),
    [sym_simple_expansion] = STATE(664),
    [sym_string_expansion] = STATE(664),
    [sym_concatenation] = STATE(501),
    [sym_expansion] = STATE(664),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(1409),
    [sym_raw_string] = ACTIONS(1409),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(1411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [333] = {
    [sym_heredoc_body] = STATE(667),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__simple_heredoc_body] = ACTIONS(910),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [anon_sym_RBRACE] = ACTIONS(908),
    [anon_sym_GT] = ACTIONS(906),
    [sym__heredoc_body_beginning] = ACTIONS(912),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [334] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1413),
    [anon_sym_GT_AMP] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_LT_AMP] = ACTIONS(1413),
    [anon_sym_GT_GT] = ACTIONS(1413),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_AMP_GT] = ACTIONS(1415),
  },
  [335] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(669),
    [sym_function_definition] = STATE(669),
    [sym_negated_command] = STATE(669),
    [sym_test_command] = STATE(669),
    [sym_variable_assignment] = STATE(670),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_redirected_statement] = STATE(669),
    [sym_for_statement] = STATE(669),
    [sym_compound_statement] = STATE(669),
    [sym_subshell] = STATE(669),
    [sym_declaration_command] = STATE(669),
    [sym_unset_command] = STATE(669),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(669),
    [sym_while_statement] = STATE(669),
    [sym_case_statement] = STATE(669),
    [sym_pipeline] = STATE(669),
    [sym_list] = STATE(669),
    [sym_command] = STATE(669),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [336] = {
    [sym_command_substitution] = STATE(671),
    [aux_sym__literal_repeat1] = STATE(672),
    [sym_string] = STATE(671),
    [sym_process_substitution] = STATE(671),
    [sym_simple_expansion] = STATE(671),
    [sym_string_expansion] = STATE(671),
    [sym_concatenation] = STATE(511),
    [sym_expansion] = STATE(671),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(1417),
    [sym_raw_string] = ACTIONS(1417),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(1411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [337] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(673),
    [sym_function_definition] = STATE(673),
    [sym_negated_command] = STATE(673),
    [sym_test_command] = STATE(673),
    [sym_variable_assignment] = STATE(674),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_redirected_statement] = STATE(673),
    [sym_for_statement] = STATE(673),
    [sym_compound_statement] = STATE(673),
    [sym_subshell] = STATE(673),
    [sym_declaration_command] = STATE(673),
    [sym_unset_command] = STATE(673),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(673),
    [sym_while_statement] = STATE(673),
    [sym_case_statement] = STATE(673),
    [sym_pipeline] = STATE(673),
    [sym_list] = STATE(673),
    [sym_command] = STATE(673),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [338] = {
    [sym_heredoc_redirect] = STATE(675),
    [aux_sym_redirected_statement_repeat1] = STATE(675),
    [sym_herestring_redirect] = STATE(675),
    [sym_file_redirect] = STATE(675),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_AMP_GT_GT] = ACTIONS(609),
    [anon_sym_LF] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(926),
    [anon_sym_LT_LT] = ACTIONS(311),
    [sym_file_descriptor] = ACTIONS(615),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_AMP_GT] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT_LT_LT] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(926),
    [anon_sym_GT_AMP] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_AMP] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_SEMI_SEMI] = ACTIONS(926),
    [anon_sym_PIPE_AMP] = ACTIONS(926),
  },
  [339] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1419),
    [anon_sym_BQUOTE] = ACTIONS(1419),
    [anon_sym_AMP_GT_GT] = ACTIONS(1419),
    [anon_sym_LF] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1419),
    [anon_sym_LT_LT] = ACTIONS(1419),
    [sym_file_descriptor] = ACTIONS(1421),
    [anon_sym_GT] = ACTIONS(1419),
    [anon_sym_RPAREN] = ACTIONS(1419),
    [anon_sym_AMP_GT] = ACTIONS(1419),
    [anon_sym_PIPE_PIPE] = ACTIONS(1419),
    [ts_builtin_sym_end] = ACTIONS(1421),
    [anon_sym_LT_LT_LT] = ACTIONS(1419),
    [anon_sym_PIPE] = ACTIONS(1419),
    [anon_sym_GT_AMP] = ACTIONS(1419),
    [anon_sym_LT] = ACTIONS(1419),
    [anon_sym_LT_AMP] = ACTIONS(1419),
    [anon_sym_GT_GT] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(1419),
    [anon_sym_AMP_AMP] = ACTIONS(1419),
    [anon_sym_SEMI_SEMI] = ACTIONS(1419),
    [anon_sym_PIPE_AMP] = ACTIONS(1419),
  },
  [340] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(109),
    [sym_function_definition] = STATE(109),
    [sym_negated_command] = STATE(109),
    [sym_test_command] = STATE(109),
    [sym_variable_assignment] = STATE(110),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(340),
    [sym_redirected_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_compound_statement] = STATE(109),
    [sym_subshell] = STATE(109),
    [sym_declaration_command] = STATE(109),
    [sym_unset_command] = STATE(109),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_case_statement] = STATE(109),
    [sym_pipeline] = STATE(109),
    [sym_list] = STATE(109),
    [sym_command] = STATE(109),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_local] = ACTIONS(938),
    [anon_sym_typeset] = ACTIONS(938),
    [anon_sym_unsetenv] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [anon_sym_GT_LPAREN] = ACTIONS(947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(956),
    [sym_word] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(938),
    [sym__special_character] = ACTIONS(968),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(974),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(980),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_declare] = ACTIONS(938),
    [sym_variable_name] = ACTIONS(989),
    [sym_file_descriptor] = ACTIONS(992),
    [anon_sym_RBRACE] = ACTIONS(908),
    [anon_sym_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(965),
    [anon_sym_readonly] = ACTIONS(938),
    [anon_sym_unset] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LPAREN] = ACTIONS(947),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(1004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1007),
  },
  [341] = {
    [sym_command_substitution] = STATE(342),
    [aux_sym__literal_repeat1] = STATE(344),
    [sym_string] = STATE(342),
    [sym_process_substitution] = STATE(342),
    [sym_simple_expansion] = STATE(342),
    [sym_string_expansion] = STATE(342),
    [aux_sym_command_repeat2] = STATE(676),
    [sym_concatenation] = STATE(676),
    [sym_expansion] = STATE(342),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(625),
    [sym_file_descriptor] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [342] = {
    [aux_sym_concatenation_repeat1] = STATE(328),
    [anon_sym_AMP_GT_GT] = ACTIONS(1030),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_LPAREN] = ACTIONS(1030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1030),
    [anon_sym_PIPE_PIPE] = ACTIONS(1030),
    [sym_word] = ACTIONS(1030),
    [anon_sym_PIPE] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_LT_AMP] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(1030),
    [sym__special_character] = ACTIONS(1030),
    [anon_sym_LT_LT_DASH] = ACTIONS(1030),
    [anon_sym_BQUOTE] = ACTIONS(1030),
    [anon_sym_LF] = ACTIONS(1032),
    [anon_sym_SEMI] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1030),
    [sym_file_descriptor] = ACTIONS(1032),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_AMP_GT] = ACTIONS(1030),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_LT_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_AMP] = ACTIONS(1030),
    [anon_sym_LT_LPAREN] = ACTIONS(1030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1030),
    [anon_sym_SEMI_SEMI] = ACTIONS(1030),
    [anon_sym_PIPE_AMP] = ACTIONS(1030),
  },
  [343] = {
    [sym_command_substitution] = STATE(677),
    [aux_sym__literal_repeat1] = STATE(678),
    [sym_string] = STATE(677),
    [sym_process_substitution] = STATE(677),
    [sym_simple_expansion] = STATE(677),
    [sym_string_expansion] = STATE(677),
    [sym_concatenation] = STATE(519),
    [sym_expansion] = STATE(677),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(1423),
    [sym_raw_string] = ACTIONS(1423),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [sym_regex] = ACTIONS(1036),
  },
  [344] = {
    [aux_sym__literal_repeat1] = STATE(330),
    [anon_sym_AMP_GT_GT] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_GT_LPAREN] = ACTIONS(1038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1038),
    [anon_sym_PIPE_PIPE] = ACTIONS(1038),
    [sym_word] = ACTIONS(1038),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_LT_AMP] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_EQ_TILDE] = ACTIONS(1038),
    [sym__special_character] = ACTIONS(299),
    [anon_sym_LT_LT_DASH] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [anon_sym_LF] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1038),
    [sym_raw_string] = ACTIONS(1038),
    [sym_file_descriptor] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_EQ_EQ] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [anon_sym_LT_LT_LT] = ACTIONS(1038),
    [anon_sym_GT_AMP] = ACTIONS(1038),
    [anon_sym_LT_LPAREN] = ACTIONS(1038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1038),
    [anon_sym_SEMI_SEMI] = ACTIONS(1038),
    [anon_sym_PIPE_AMP] = ACTIONS(1038),
  },
  [345] = {
    [sym_command_substitution] = STATE(342),
    [aux_sym__literal_repeat1] = STATE(344),
    [sym_string] = STATE(342),
    [sym_process_substitution] = STATE(342),
    [sym_simple_expansion] = STATE(342),
    [sym_string_expansion] = STATE(342),
    [aux_sym_command_repeat2] = STATE(679),
    [sym_concatenation] = STATE(679),
    [sym_expansion] = STATE(342),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(625),
    [sym_file_descriptor] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [346] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(683),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_elif_clause] = STATE(685),
    [sym_else_clause] = STATE(684),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_if_statement_repeat1] = STATE(685),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_else] = ACTIONS(1425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_fi] = ACTIONS(1427),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_elif] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [347] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_then] = ACTIONS(1431),
    [anon_sym_do] = ACTIONS(1431),
  },
  [348] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1433),
  },
  [349] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [anon_sym_AMP] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(789),
    [anon_sym_LF] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
  },
  [351] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [352] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_in] = ACTIONS(1439),
  },
  [353] = {
    [sym_command_substitution] = STATE(690),
    [sym_simple_expansion] = STATE(690),
    [sym_string_expansion] = STATE(690),
    [sym_string] = STATE(690),
    [sym_process_substitution] = STATE(690),
    [sym_expansion] = STATE(690),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(193),
    [sym_word] = ACTIONS(1441),
    [sym_raw_string] = ACTIONS(1441),
    [anon_sym_LT_LPAREN] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(201),
    [sym__special_character] = ACTIONS(1441),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(205),
  },
  [354] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1443),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_SEMI_SEMI] = ACTIONS(1445),
    [anon_sym_AMP] = ACTIONS(1445),
  },
  [355] = {
    [aux_sym_concatenation_repeat1] = STATE(693),
    [anon_sym_AMP] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1447),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [anon_sym_in] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
  },
  [356] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1449),
  },
  [357] = {
    [anon_sym_AMP] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(507),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
  },
  [358] = {
    [anon_sym_AMP] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(511),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
  },
  [359] = {
    [anon_sym_AMP] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(515),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(513),
    [anon_sym_in] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
  },
  [360] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [361] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1433),
  },
  [362] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(697),
    [sym_concatenation] = STATE(697),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1451),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1453),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1453),
    [anon_sym_PERCENT] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1457),
    [anon_sym_COLON_DASH] = ACTIONS(1453),
    [sym__special_character] = ACTIONS(553),
  },
  [363] = {
    [sym_subscript] = STATE(698),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_QMARK] = ACTIONS(1459),
    [anon_sym_AT] = ACTIONS(1459),
    [sym_variable_name] = ACTIONS(1461),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_DASH] = ACTIONS(1463),
    [anon_sym_0] = ACTIONS(1465),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1465),
    [anon_sym__] = ACTIONS(1465),
  },
  [364] = {
    [anon_sym_EQ] = ACTIONS(1467),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [365] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(704),
    [sym_concatenation] = STATE(704),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1469),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1471),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1471),
    [anon_sym_PERCENT] = ACTIONS(1471),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1475),
    [anon_sym_COLON_DASH] = ACTIONS(1471),
    [sym__special_character] = ACTIONS(553),
  },
  [366] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_in] = ACTIONS(1477),
  },
  [367] = {
    [sym__special_character] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
  },
  [368] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1479),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_SEMI_SEMI] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
  },
  [369] = {
    [aux_sym__literal_repeat1] = STATE(369),
    [sym__special_character] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [anon_sym_in] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
  },
  [370] = {
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_PLUS_EQ] = ACTIONS(717),
    [sym_test_operator] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(721),
    [anon_sym_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ] = ACTIONS(723),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(721),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_DASH_EQ] = ACTIONS(717),
  },
  [371] = {
    [sym_command_substitution] = STATE(372),
    [sym_unary_expression] = STATE(707),
    [sym_postfix_expression] = STATE(707),
    [sym_string] = STATE(372),
    [aux_sym__literal_repeat1] = STATE(374),
    [sym_process_substitution] = STATE(372),
    [sym_parenthesized_expression] = STATE(707),
    [sym_simple_expansion] = STATE(372),
    [sym_string_expansion] = STATE(372),
    [sym__expression] = STATE(707),
    [sym_binary_expression] = STATE(707),
    [sym_concatenation] = STATE(707),
    [sym_expansion] = STATE(372),
    [sym_test_operator] = ACTIONS(673),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_BANG] = ACTIONS(679),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [372] = {
    [aux_sym_concatenation_repeat1] = STATE(708),
    [anon_sym_BANG_EQ] = ACTIONS(687),
    [anon_sym_PLUS_EQ] = ACTIONS(687),
    [sym_test_operator] = ACTIONS(687),
    [anon_sym_PLUS_PLUS] = ACTIONS(687),
    [anon_sym_RPAREN] = ACTIONS(687),
    [anon_sym_DASH] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_EQ_EQ] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(687),
    [sym__concat] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(689),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(687),
    [anon_sym_DASH_DASH] = ACTIONS(687),
    [anon_sym_LT_EQ] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_DASH_EQ] = ACTIONS(687),
  },
  [373] = {
    [aux_sym_concatenation_repeat1] = STATE(708),
    [anon_sym_BANG_EQ] = ACTIONS(189),
    [anon_sym_PLUS_EQ] = ACTIONS(189),
    [sym_test_operator] = ACTIONS(189),
    [anon_sym_PLUS_PLUS] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_EQ] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(189),
    [anon_sym_PIPE_PIPE] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(189),
    [sym__concat] = ACTIONS(691),
    [anon_sym_PLUS] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(189),
    [anon_sym_DASH_DASH] = ACTIONS(189),
    [anon_sym_LT_EQ] = ACTIONS(189),
    [anon_sym_AMP_AMP] = ACTIONS(189),
    [sym__special_character] = ACTIONS(189),
    [anon_sym_DASH_EQ] = ACTIONS(189),
  },
  [374] = {
    [aux_sym__literal_repeat1] = STATE(709),
    [anon_sym_BANG_EQ] = ACTIONS(711),
    [anon_sym_PLUS_EQ] = ACTIONS(711),
    [sym_test_operator] = ACTIONS(711),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(711),
    [anon_sym_PIPE_PIPE] = ACTIONS(711),
    [anon_sym_GT_EQ] = ACTIONS(711),
    [anon_sym_PLUS] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(713),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_LT_EQ] = ACTIONS(711),
    [anon_sym_AMP_AMP] = ACTIONS(711),
    [sym__special_character] = ACTIONS(715),
    [anon_sym_DASH_EQ] = ACTIONS(711),
  },
  [375] = {
    [anon_sym_BANG_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1488),
    [sym_test_operator] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_PIPE_PIPE] = ACTIONS(1488),
    [anon_sym_GT_EQ] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1492),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(1488),
    [anon_sym_AMP_AMP] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1488),
  },
  [376] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(1496),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [377] = {
    [anon_sym_BANG_EQ] = ACTIONS(789),
    [anon_sym_PLUS_EQ] = ACTIONS(789),
    [sym_test_operator] = ACTIONS(789),
    [anon_sym_PLUS_PLUS] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ] = ACTIONS(789),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(789),
    [anon_sym_PIPE_PIPE] = ACTIONS(789),
    [anon_sym_GT_EQ] = ACTIONS(789),
    [sym__concat] = ACTIONS(789),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(789),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(789),
    [anon_sym_DASH_DASH] = ACTIONS(789),
    [anon_sym_LT_EQ] = ACTIONS(789),
    [anon_sym_AMP_AMP] = ACTIONS(789),
    [anon_sym_DASH_EQ] = ACTIONS(789),
  },
  [378] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(1496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [379] = {
    [sym_command_substitution] = STATE(715),
    [sym_simple_expansion] = STATE(715),
    [sym_string_expansion] = STATE(715),
    [sym_string] = STATE(715),
    [sym_process_substitution] = STATE(715),
    [sym_expansion] = STATE(715),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(1500),
    [sym_raw_string] = ACTIONS(1500),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [380] = {
    [aux_sym_concatenation_repeat1] = STATE(717),
    [anon_sym_BANG_EQ] = ACTIONS(585),
    [anon_sym_PLUS_EQ] = ACTIONS(585),
    [sym_test_operator] = ACTIONS(585),
    [anon_sym_PLUS_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(585),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_GT_EQ] = ACTIONS(585),
    [sym__concat] = ACTIONS(1502),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(585),
    [anon_sym_DASH_DASH] = ACTIONS(585),
    [anon_sym_LT_EQ] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_DASH_EQ] = ACTIONS(585),
  },
  [381] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1504),
  },
  [382] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1506),
  },
  [383] = {
    [anon_sym_BANG_EQ] = ACTIONS(507),
    [anon_sym_PLUS_EQ] = ACTIONS(507),
    [sym_test_operator] = ACTIONS(507),
    [anon_sym_PLUS_PLUS] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(505),
    [anon_sym_DASH] = ACTIONS(505),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_EQ] = ACTIONS(505),
    [anon_sym_EQ_EQ] = ACTIONS(507),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(507),
    [anon_sym_PIPE_PIPE] = ACTIONS(507),
    [anon_sym_GT_EQ] = ACTIONS(507),
    [sym__concat] = ACTIONS(507),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_PIPE] = ACTIONS(505),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(507),
    [anon_sym_LT_EQ] = ACTIONS(507),
    [anon_sym_AMP_AMP] = ACTIONS(507),
    [anon_sym_DASH_EQ] = ACTIONS(507),
  },
  [384] = {
    [anon_sym_BANG_EQ] = ACTIONS(511),
    [anon_sym_PLUS_EQ] = ACTIONS(511),
    [sym_test_operator] = ACTIONS(511),
    [anon_sym_PLUS_PLUS] = ACTIONS(511),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_DASH] = ACTIONS(509),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_EQ] = ACTIONS(509),
    [anon_sym_EQ_EQ] = ACTIONS(511),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(511),
    [anon_sym_PIPE_PIPE] = ACTIONS(511),
    [anon_sym_GT_EQ] = ACTIONS(511),
    [sym__concat] = ACTIONS(511),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(509),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(511),
    [anon_sym_DASH_DASH] = ACTIONS(511),
    [anon_sym_LT_EQ] = ACTIONS(511),
    [anon_sym_AMP_AMP] = ACTIONS(511),
    [anon_sym_DASH_EQ] = ACTIONS(511),
  },
  [385] = {
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [anon_sym_PLUS_EQ] = ACTIONS(515),
    [sym_test_operator] = ACTIONS(515),
    [anon_sym_PLUS_PLUS] = ACTIONS(515),
    [anon_sym_RPAREN] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_GT_EQ] = ACTIONS(515),
    [sym__concat] = ACTIONS(515),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(515),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(515),
    [anon_sym_DASH_DASH] = ACTIONS(515),
    [anon_sym_LT_EQ] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_DASH_EQ] = ACTIONS(515),
  },
  [386] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [387] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1504),
  },
  [388] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(722),
    [sym_concatenation] = STATE(722),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1508),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1510),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1510),
    [anon_sym_PERCENT] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1514),
    [anon_sym_COLON_DASH] = ACTIONS(1510),
    [sym__special_character] = ACTIONS(553),
  },
  [389] = {
    [sym_subscript] = STATE(723),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1516),
    [anon_sym_AT] = ACTIONS(1516),
    [sym_variable_name] = ACTIONS(1518),
    [anon_sym_DOLLAR] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1520),
    [anon_sym_0] = ACTIONS(1522),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1522),
    [anon_sym__] = ACTIONS(1522),
  },
  [390] = {
    [anon_sym_EQ] = ACTIONS(1524),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [391] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(729),
    [sym_concatenation] = STATE(729),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1526),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1528),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1530),
    [anon_sym_DASH] = ACTIONS(1528),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1528),
    [anon_sym_PERCENT] = ACTIONS(1528),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1532),
    [anon_sym_COLON_DASH] = ACTIONS(1528),
    [sym__special_character] = ACTIONS(553),
  },
  [392] = {
    [anon_sym_BANG_EQ] = ACTIONS(189),
    [anon_sym_PLUS_EQ] = ACTIONS(189),
    [sym_test_operator] = ACTIONS(189),
    [anon_sym_PLUS_PLUS] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(187),
    [anon_sym_DASH] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_EQ] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(189),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(189),
    [anon_sym_PIPE_PIPE] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(189),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(189),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_PLUS] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(189),
    [anon_sym_DASH_DASH] = ACTIONS(189),
    [anon_sym_LT_EQ] = ACTIONS(189),
    [anon_sym_AMP_AMP] = ACTIONS(189),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_DASH_EQ] = ACTIONS(189),
  },
  [393] = {
    [aux_sym__literal_repeat1] = STATE(393),
    [anon_sym_BANG_EQ] = ACTIONS(888),
    [anon_sym_PLUS_EQ] = ACTIONS(888),
    [sym_test_operator] = ACTIONS(888),
    [anon_sym_PLUS_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(888),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(888),
    [anon_sym_PIPE_PIPE] = ACTIONS(888),
    [anon_sym_GT_EQ] = ACTIONS(888),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(888),
    [sym__special_character] = ACTIONS(1534),
    [anon_sym_DASH_EQ] = ACTIONS(888),
  },
  [394] = {
    [sym_command_substitution] = STATE(131),
    [sym_unary_expression] = STATE(730),
    [sym_postfix_expression] = STATE(730),
    [sym_string] = STATE(131),
    [aux_sym__literal_repeat1] = STATE(138),
    [sym_process_substitution] = STATE(131),
    [sym_parenthesized_expression] = STATE(730),
    [sym_simple_expansion] = STATE(131),
    [sym_string_expansion] = STATE(131),
    [sym__expression] = STATE(730),
    [sym_binary_expression] = STATE(730),
    [sym_concatenation] = STATE(730),
    [sym_expansion] = STATE(131),
    [sym_test_operator] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(213),
    [sym_raw_string] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [395] = {
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_PLUS_EQ] = ACTIONS(1537),
    [sym_test_operator] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1537),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1537),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1537),
    [anon_sym_PLUS] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1539),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1537),
    [anon_sym_DASH_DASH] = ACTIONS(1537),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_DASH_EQ] = ACTIONS(1537),
  },
  [396] = {
    [sym_command_substitution] = STATE(131),
    [sym_unary_expression] = STATE(730),
    [sym_postfix_expression] = STATE(730),
    [sym_string] = STATE(131),
    [aux_sym__literal_repeat1] = STATE(138),
    [sym_process_substitution] = STATE(131),
    [sym_parenthesized_expression] = STATE(730),
    [sym_simple_expansion] = STATE(131),
    [sym_string_expansion] = STATE(131),
    [sym__expression] = STATE(730),
    [sym_binary_expression] = STATE(730),
    [sym_concatenation] = STATE(730),
    [sym_expansion] = STATE(131),
    [sym_test_operator] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [sym_raw_string] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(213),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(227),
    [sym_regex] = ACTIONS(1541),
  },
  [397] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [anon_sym_AMP_GT_GT] = ACTIONS(1543),
    [anon_sym_LF] = ACTIONS(1545),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym_LT_LT] = ACTIONS(1543),
    [sym_file_descriptor] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1543),
    [anon_sym_RPAREN] = ACTIONS(1543),
    [anon_sym_AMP_GT] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1543),
    [ts_builtin_sym_end] = ACTIONS(1545),
    [anon_sym_LT_LT_LT] = ACTIONS(1543),
    [anon_sym_PIPE] = ACTIONS(1543),
    [anon_sym_GT_AMP] = ACTIONS(1543),
    [anon_sym_LT] = ACTIONS(1543),
    [anon_sym_LT_AMP] = ACTIONS(1543),
    [anon_sym_GT_GT] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(1543),
    [anon_sym_AMP_AMP] = ACTIONS(1543),
    [anon_sym_SEMI_SEMI] = ACTIONS(1543),
    [anon_sym_PIPE_AMP] = ACTIONS(1543),
  },
  [398] = {
    [sym_command_substitution] = STATE(318),
    [aux_sym__literal_repeat1] = STATE(321),
    [sym_string] = STATE(318),
    [aux_sym_declaration_command_repeat1] = STATE(656),
    [sym_process_substitution] = STATE(318),
    [sym_simple_expansion] = STATE(318),
    [sym_subscript] = STATE(323),
    [sym_string_expansion] = STATE(318),
    [sym_variable_assignment] = STATE(656),
    [sym_concatenation] = STATE(656),
    [sym_expansion] = STATE(318),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(95),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(97),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [sym_word] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [sym__special_character] = ACTIONS(591),
    [anon_sym_LT_LT_DASH] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(457),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_SEMI] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(589),
    [sym_variable_name] = ACTIONS(593),
    [sym_file_descriptor] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_LT_LPAREN] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
  },
  [399] = {
    [sym_command_substitution] = STATE(324),
    [aux_sym__literal_repeat1] = STATE(326),
    [sym_string] = STATE(324),
    [aux_sym_unset_command_repeat1] = STATE(659),
    [sym_process_substitution] = STATE(324),
    [sym_simple_expansion] = STATE(324),
    [sym_string_expansion] = STATE(324),
    [sym_concatenation] = STATE(659),
    [sym_expansion] = STATE(324),
    [anon_sym_AMP_GT_GT] = ACTIONS(499),
    [anon_sym_DOLLAR] = ACTIONS(117),
    [anon_sym_LT_LT] = ACTIONS(499),
    [anon_sym_GT_LPAREN] = ACTIONS(119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(121),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [sym_word] = ACTIONS(597),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_AMP] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(499),
    [anon_sym_LT_AMP] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(499),
    [sym__special_character] = ACTIONS(599),
    [anon_sym_LT_LT_DASH] = ACTIONS(499),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [anon_sym_LF] = ACTIONS(503),
    [anon_sym_SEMI] = ACTIONS(499),
    [sym_raw_string] = ACTIONS(597),
    [sym_file_descriptor] = ACTIONS(503),
    [anon_sym_GT] = ACTIONS(499),
    [anon_sym_AMP_GT] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(499),
    [anon_sym_GT_AMP] = ACTIONS(499),
    [anon_sym_LT_LPAREN] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(499),
    [anon_sym_PIPE_AMP] = ACTIONS(499),
  },
  [400] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(732),
    [sym_function_definition] = STATE(732),
    [sym_negated_command] = STATE(732),
    [sym_test_command] = STATE(732),
    [sym_variable_assignment] = STATE(733),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_redirected_statement] = STATE(732),
    [sym_for_statement] = STATE(732),
    [sym_compound_statement] = STATE(732),
    [sym_subshell] = STATE(732),
    [sym_declaration_command] = STATE(732),
    [sym_unset_command] = STATE(732),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym_c_style_for_statement] = STATE(732),
    [sym_while_statement] = STATE(732),
    [sym_case_statement] = STATE(732),
    [sym_pipeline] = STATE(732),
    [sym_list] = STATE(732),
    [sym_command] = STATE(732),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [401] = {
    [sym_command_substitution] = STATE(734),
    [aux_sym__literal_repeat1] = STATE(736),
    [sym_string] = STATE(734),
    [sym_process_substitution] = STATE(734),
    [sym_simple_expansion] = STATE(734),
    [sym_string_expansion] = STATE(734),
    [sym_concatenation] = STATE(501),
    [sym_expansion] = STATE(734),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(1547),
    [sym_raw_string] = ACTIONS(1547),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(1549),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [402] = {
    [sym_heredoc_body] = STATE(737),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__simple_heredoc_body] = ACTIONS(910),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_BQUOTE] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [anon_sym_case] = ACTIONS(906),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [sym__heredoc_body_beginning] = ACTIONS(912),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [403] = {
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_BQUOTE] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [anon_sym_case] = ACTIONS(906),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [404] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1551),
    [anon_sym_GT_AMP] = ACTIONS(1551),
    [anon_sym_LT] = ACTIONS(1553),
    [anon_sym_LT_AMP] = ACTIONS(1551),
    [anon_sym_GT_GT] = ACTIONS(1551),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1553),
    [anon_sym_AMP_GT] = ACTIONS(1553),
  },
  [405] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(739),
    [sym_function_definition] = STATE(739),
    [sym_negated_command] = STATE(739),
    [sym_test_command] = STATE(739),
    [sym_variable_assignment] = STATE(740),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_redirected_statement] = STATE(739),
    [sym_for_statement] = STATE(739),
    [sym_compound_statement] = STATE(739),
    [sym_subshell] = STATE(739),
    [sym_declaration_command] = STATE(739),
    [sym_unset_command] = STATE(739),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym_c_style_for_statement] = STATE(739),
    [sym_while_statement] = STATE(739),
    [sym_case_statement] = STATE(739),
    [sym_pipeline] = STATE(739),
    [sym_list] = STATE(739),
    [sym_command] = STATE(739),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [406] = {
    [sym_command_substitution] = STATE(741),
    [aux_sym__literal_repeat1] = STATE(742),
    [sym_string] = STATE(741),
    [sym_process_substitution] = STATE(741),
    [sym_simple_expansion] = STATE(741),
    [sym_string_expansion] = STATE(741),
    [sym_concatenation] = STATE(511),
    [sym_expansion] = STATE(741),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(1555),
    [sym_raw_string] = ACTIONS(1555),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(1549),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [407] = {
    [sym_heredoc_redirect] = STATE(743),
    [aux_sym_redirected_statement_repeat1] = STATE(743),
    [sym_herestring_redirect] = STATE(743),
    [sym_file_redirect] = STATE(743),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(926),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(926),
    [anon_sym_LT_LT] = ACTIONS(311),
    [sym_file_descriptor] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT_LT_LT] = ACTIONS(741),
    [anon_sym_PIPE] = ACTIONS(926),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_SEMI_SEMI] = ACTIONS(926),
    [anon_sym_PIPE_AMP] = ACTIONS(926),
  },
  [408] = {
    [sym_heredoc_redirect] = STATE(407),
    [aux_sym_redirected_statement_repeat1] = STATE(407),
    [sym_herestring_redirect] = STATE(407),
    [sym_file_redirect] = STATE(407),
    [anon_sym_PIPE_AMP] = ACTIONS(743),
    [anon_sym_BQUOTE] = ACTIONS(1062),
    [anon_sym_AMP_GT_GT] = ACTIONS(733),
    [anon_sym_LF] = ACTIONS(1557),
    [anon_sym_SEMI] = ACTIONS(1559),
    [sym_file_descriptor] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(733),
    [anon_sym_AMP_GT] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_LT_LT_LT] = ACTIONS(741),
    [anon_sym_GT_AMP] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(743),
    [anon_sym_LT] = ACTIONS(733),
    [anon_sym_LT_AMP] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(1559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(1559),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
  },
  [409] = {
    [sym_heredoc_redirect] = STATE(407),
    [aux_sym_redirected_statement_repeat1] = STATE(407),
    [sym_herestring_redirect] = STATE(407),
    [sym_file_redirect] = STATE(407),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(1062),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1557),
    [anon_sym_SEMI] = ACTIONS(1559),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(741),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_SEMI_SEMI] = ACTIONS(1559),
    [anon_sym_PIPE_AMP] = ACTIONS(743),
  },
  [410] = {
    [sym_command_substitution] = STATE(342),
    [aux_sym__literal_repeat1] = STATE(344),
    [sym_string] = STATE(342),
    [sym_process_substitution] = STATE(342),
    [sym_simple_expansion] = STATE(342),
    [sym_string_expansion] = STATE(342),
    [aux_sym_command_repeat2] = STATE(746),
    [sym_concatenation] = STATE(746),
    [sym_expansion] = STATE(342),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(625),
    [sym_file_descriptor] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [411] = {
    [sym_command_substitution] = STATE(342),
    [aux_sym__literal_repeat1] = STATE(344),
    [sym_string] = STATE(342),
    [sym_process_substitution] = STATE(342),
    [sym_simple_expansion] = STATE(342),
    [sym_string_expansion] = STATE(342),
    [aux_sym_command_repeat2] = STATE(679),
    [sym_concatenation] = STATE(679),
    [sym_expansion] = STATE(342),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(625),
    [sym_file_descriptor] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [412] = {
    [sym_command_substitution] = STATE(748),
    [aux_sym__literal_repeat1] = STATE(750),
    [sym_string] = STATE(748),
    [sym_array] = STATE(749),
    [sym_process_substitution] = STATE(748),
    [sym_simple_expansion] = STATE(748),
    [sym_string_expansion] = STATE(748),
    [sym_concatenation] = STATE(749),
    [sym_expansion] = STATE(748),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(1563),
    [sym_raw_string] = ACTIONS(1563),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(83),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(87),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
    [sym__empty_value] = ACTIONS(1565),
  },
  [413] = {
    [sym_command_substitution] = STATE(753),
    [aux_sym__literal_repeat1] = STATE(760),
    [sym_string] = STATE(753),
    [sym_process_substitution] = STATE(753),
    [aux_sym_for_statement_repeat1] = STATE(761),
    [sym_simple_expansion] = STATE(753),
    [sym_string_expansion] = STATE(753),
    [sym_concatenation] = STATE(761),
    [sym_expansion] = STATE(753),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(1571),
    [sym_raw_string] = ACTIONS(1571),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(1577),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [414] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(762),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [415] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(765),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(1585),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [416] = {
    [aux_sym_concatenation_repeat1] = STATE(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__concat] = ACTIONS(1591),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [ts_builtin_sym_end] = ACTIONS(1593),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [417] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(768),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [418] = {
    [sym_string] = STATE(770),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_STAR] = ACTIONS(1595),
    [anon_sym_QMARK] = ACTIONS(1595),
    [sym_raw_string] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_AT] = ACTIONS(1595),
    [anon_sym_DOLLAR] = ACTIONS(1599),
    [anon_sym_POUND] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1599),
    [anon_sym_0] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1601),
    [anon_sym__] = ACTIONS(1601),
  },
  [419] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(772),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(773),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [420] = {
    [aux_sym_concatenation_repeat1] = STATE(767),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(1591),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [ts_builtin_sym_end] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [421] = {
    [sym_subscript] = STATE(774),
    [anon_sym_STAR] = ACTIONS(1603),
    [anon_sym_QMARK] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_AT] = ACTIONS(1603),
    [sym_variable_name] = ACTIONS(1607),
    [anon_sym_DOLLAR] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_0] = ACTIONS(1611),
    [anon_sym_POUND] = ACTIONS(1605),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1611),
    [anon_sym__] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
  },
  [422] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_RPAREN] = ACTIONS(1589),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [ts_builtin_sym_end] = ACTIONS(1593),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [423] = {
    [aux_sym__literal_repeat1] = STATE(779),
    [anon_sym_AMP_GT_GT] = ACTIONS(1613),
    [anon_sym_DOLLAR] = ACTIONS(1613),
    [anon_sym_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1613),
    [anon_sym_PIPE_PIPE] = ACTIONS(1613),
    [sym_word] = ACTIONS(1613),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_LT_AMP] = ACTIONS(1613),
    [anon_sym_GT_GT] = ACTIONS(1613),
    [sym__special_character] = ACTIONS(1615),
    [anon_sym_LT_LT_DASH] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1613),
    [anon_sym_LF] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1613),
    [sym_raw_string] = ACTIONS(1613),
    [sym_variable_name] = ACTIONS(1617),
    [sym_file_descriptor] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1613),
    [anon_sym_AMP_GT] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_LT_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_AMP] = ACTIONS(1613),
    [ts_builtin_sym_end] = ACTIONS(1617),
    [anon_sym_LT_LPAREN] = ACTIONS(1613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1613),
    [anon_sym_SEMI_SEMI] = ACTIONS(1613),
    [anon_sym_PIPE_AMP] = ACTIONS(1613),
  },
  [424] = {
    [aux_sym_concatenation_repeat1] = STATE(782),
    [anon_sym_RBRACK] = ACTIONS(1619),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(1621),
  },
  [425] = {
    [aux_sym_concatenation_repeat1] = STATE(782),
    [anon_sym_RBRACK] = ACTIONS(189),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(189),
    [sym__special_character] = ACTIONS(187),
  },
  [426] = {
    [aux_sym__literal_repeat1] = STATE(786),
    [anon_sym_RBRACK] = ACTIONS(1623),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(1625),
    [sym__special_character] = ACTIONS(1627),
  },
  [427] = {
    [anon_sym_RBRACK] = ACTIONS(1619),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(1629),
  },
  [428] = {
    [aux_sym_concatenation_repeat1] = STATE(234),
    [anon_sym_BQUOTE] = ACTIONS(1631),
    [anon_sym_AMP_GT_GT] = ACTIONS(1631),
    [sym_raw_string] = ACTIONS(1631),
    [anon_sym_DOLLAR] = ACTIONS(1633),
    [sym_file_descriptor] = ACTIONS(1631),
    [sym_variable_name] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1631),
    [anon_sym_AMP_GT] = ACTIONS(1633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1631),
    [anon_sym_GT_LPAREN] = ACTIONS(1631),
    [anon_sym_DQUOTE] = ACTIONS(1631),
    [sym_word] = ACTIONS(1631),
    [anon_sym_GT_AMP] = ACTIONS(1631),
    [sym__concat] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_LT_AMP] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_LT_LPAREN] = ACTIONS(1631),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1631),
  },
  [429] = {
    [aux_sym__literal_repeat1] = STATE(246),
    [anon_sym_BQUOTE] = ACTIONS(1635),
    [anon_sym_AMP_GT_GT] = ACTIONS(1635),
    [sym_raw_string] = ACTIONS(1635),
    [anon_sym_DOLLAR] = ACTIONS(1637),
    [sym_file_descriptor] = ACTIONS(1635),
    [sym_variable_name] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1635),
    [anon_sym_AMP_GT] = ACTIONS(1637),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1635),
    [anon_sym_GT_LPAREN] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [sym_word] = ACTIONS(1635),
    [anon_sym_GT_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_LT_AMP] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_LT_LPAREN] = ACTIONS(1635),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(417),
  },
  [430] = {
    [anon_sym_BQUOTE] = ACTIONS(1631),
    [anon_sym_AMP_GT_GT] = ACTIONS(1631),
    [sym_raw_string] = ACTIONS(1631),
    [anon_sym_DOLLAR] = ACTIONS(1633),
    [sym_file_descriptor] = ACTIONS(1631),
    [sym_variable_name] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1631),
    [anon_sym_AMP_GT] = ACTIONS(1633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1631),
    [anon_sym_GT_LPAREN] = ACTIONS(1631),
    [anon_sym_RPAREN] = ACTIONS(1631),
    [anon_sym_DQUOTE] = ACTIONS(1631),
    [sym_word] = ACTIONS(1631),
    [anon_sym_GT_AMP] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_LT_AMP] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_LT_LPAREN] = ACTIONS(1631),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1631),
  },
  [431] = {
    [anon_sym_BQUOTE] = ACTIONS(507),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [sym__concat] = ACTIONS(507),
    [sym__string_content] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(507),
  },
  [432] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1639),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [sym_word] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_LT_AMP] = ACTIONS(1639),
    [anon_sym_GT_GT] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [anon_sym_EQ_TILDE] = ACTIONS(1639),
    [sym__special_character] = ACTIONS(1639),
    [anon_sym_LT_LT_DASH] = ACTIONS(1639),
    [anon_sym_BQUOTE] = ACTIONS(1639),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1639),
    [sym_raw_string] = ACTIONS(1639),
    [sym_file_descriptor] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_AMP_GT] = ACTIONS(1639),
    [anon_sym_EQ_EQ] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_LT_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_AMP] = ACTIONS(1639),
    [ts_builtin_sym_end] = ACTIONS(1641),
    [anon_sym_LT_LPAREN] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [anon_sym_PIPE_AMP] = ACTIONS(1639),
  },
  [433] = {
    [anon_sym_BQUOTE] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(515),
    [sym__concat] = ACTIONS(515),
    [sym__string_content] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
  },
  [434] = {
    [anon_sym_BQUOTE] = ACTIONS(1643),
    [anon_sym_DQUOTE] = ACTIONS(1643),
    [sym__concat] = ACTIONS(1645),
    [sym__string_content] = ACTIONS(1647),
    [anon_sym_DOLLAR] = ACTIONS(1647),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1643),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1643),
  },
  [435] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1649),
  },
  [436] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(1649),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [437] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1649),
  },
  [438] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(792),
    [sym_concatenation] = STATE(792),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1651),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1653),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1655),
    [anon_sym_DASH] = ACTIONS(1653),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1653),
    [anon_sym_PERCENT] = ACTIONS(1653),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1657),
    [anon_sym_COLON_DASH] = ACTIONS(1653),
    [sym__special_character] = ACTIONS(553),
  },
  [439] = {
    [sym_subscript] = STATE(793),
    [anon_sym_STAR] = ACTIONS(1659),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_AT] = ACTIONS(1659),
    [sym_variable_name] = ACTIONS(1661),
    [anon_sym_DOLLAR] = ACTIONS(1663),
    [anon_sym_DASH] = ACTIONS(1663),
    [anon_sym_0] = ACTIONS(1665),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1665),
    [anon_sym__] = ACTIONS(1665),
  },
  [440] = {
    [anon_sym_EQ] = ACTIONS(1667),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [441] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(799),
    [sym_concatenation] = STATE(799),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1669),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_PERCENT] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1675),
    [anon_sym_COLON_DASH] = ACTIONS(1671),
    [sym__special_character] = ACTIONS(553),
  },
  [442] = {
    [anon_sym_DOLLAR] = ACTIONS(1647),
    [anon_sym_BQUOTE] = ACTIONS(1643),
    [anon_sym_DQUOTE] = ACTIONS(1643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1643),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1643),
    [sym__string_content] = ACTIONS(1647),
  },
  [443] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [444] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(1679),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_DQUOTE] = ACTIONS(1643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1685),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1688),
    [sym__string_content] = ACTIONS(1691),
  },
  [445] = {
    [sym_command_substitution] = STATE(804),
    [aux_sym__literal_repeat1] = STATE(810),
    [sym_string] = STATE(804),
    [sym_process_substitution] = STATE(804),
    [aux_sym_for_statement_repeat1] = STATE(811),
    [sym_simple_expansion] = STATE(804),
    [sym_string_expansion] = STATE(804),
    [sym_concatenation] = STATE(811),
    [sym_expansion] = STATE(804),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1696),
    [sym_word] = ACTIONS(1698),
    [sym_raw_string] = ACTIONS(1698),
    [anon_sym_LT_LPAREN] = ACTIONS(1700),
    [anon_sym_DOLLAR] = ACTIONS(1702),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1704),
    [sym__special_character] = ACTIONS(1706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1708),
  },
  [446] = {
    [sym_do_group] = STATE(812),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(839),
  },
  [447] = {
    [sym_command_substitution] = STATE(450),
    [sym_unary_expression] = STATE(813),
    [sym_postfix_expression] = STATE(813),
    [sym_string] = STATE(450),
    [aux_sym__literal_repeat1] = STATE(458),
    [sym_process_substitution] = STATE(450),
    [sym_parenthesized_expression] = STATE(813),
    [sym_simple_expansion] = STATE(450),
    [sym_string_expansion] = STATE(450),
    [sym__expression] = STATE(813),
    [sym_binary_expression] = STATE(813),
    [sym_concatenation] = STATE(813),
    [sym_expansion] = STATE(450),
    [sym_test_operator] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(1712),
    [sym_word] = ACTIONS(821),
    [sym_raw_string] = ACTIONS(1714),
    [anon_sym_BQUOTE] = ACTIONS(1716),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1720),
    [sym__special_character] = ACTIONS(1722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
  },
  [448] = {
    [sym_command_substitution] = STATE(372),
    [sym_unary_expression] = STATE(814),
    [sym_postfix_expression] = STATE(814),
    [sym_string] = STATE(372),
    [aux_sym__literal_repeat1] = STATE(374),
    [sym_process_substitution] = STATE(372),
    [sym_parenthesized_expression] = STATE(814),
    [sym_simple_expansion] = STATE(372),
    [sym_string_expansion] = STATE(372),
    [sym__expression] = STATE(814),
    [sym_binary_expression] = STATE(814),
    [sym_concatenation] = STATE(814),
    [sym_expansion] = STATE(372),
    [sym_test_operator] = ACTIONS(673),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_BANG] = ACTIONS(679),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [449] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(815),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [450] = {
    [aux_sym_concatenation_repeat1] = STATE(817),
    [anon_sym_BANG_EQ] = ACTIONS(689),
    [anon_sym_PLUS_EQ] = ACTIONS(689),
    [sym_test_operator] = ACTIONS(687),
    [anon_sym_LF] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH] = ACTIONS(689),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_EQ] = ACTIONS(689),
    [anon_sym_EQ_EQ] = ACTIONS(689),
    [anon_sym_PIPE_PIPE] = ACTIONS(689),
    [anon_sym_GT_EQ] = ACTIONS(689),
    [sym__concat] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_LT] = ACTIONS(689),
    [anon_sym_AMP] = ACTIONS(689),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_AMP_AMP] = ACTIONS(689),
    [anon_sym_LT_EQ] = ACTIONS(689),
    [anon_sym_SEMI_SEMI] = ACTIONS(689),
    [anon_sym_DASH_EQ] = ACTIONS(689),
  },
  [451] = {
    [sym_command_substitution] = STATE(450),
    [sym_unary_expression] = STATE(819),
    [sym_postfix_expression] = STATE(819),
    [sym_string] = STATE(450),
    [aux_sym__literal_repeat1] = STATE(458),
    [sym_process_substitution] = STATE(450),
    [sym_parenthesized_expression] = STATE(819),
    [sym_simple_expansion] = STATE(450),
    [sym_string_expansion] = STATE(450),
    [sym__expression] = STATE(819),
    [sym_binary_expression] = STATE(819),
    [sym_concatenation] = STATE(819),
    [sym_expansion] = STATE(450),
    [sym_test_operator] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_LF] = ACTIONS(1728),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(1728),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [anon_sym_GT_LPAREN] = ACTIONS(829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(835),
    [sym_word] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_LT_LPAREN] = ACTIONS(829),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(1728),
  },
  [452] = {
    [sym_string] = STATE(821),
    [anon_sym_DQUOTE] = ACTIONS(1712),
    [anon_sym_STAR] = ACTIONS(1730),
    [anon_sym_QMARK] = ACTIONS(1730),
    [sym_raw_string] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1734),
    [anon_sym_AT] = ACTIONS(1730),
    [anon_sym_DOLLAR] = ACTIONS(1734),
    [anon_sym_POUND] = ACTIONS(1734),
    [anon_sym_DASH] = ACTIONS(1734),
    [anon_sym_0] = ACTIONS(1736),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1736),
    [anon_sym__] = ACTIONS(1736),
  },
  [453] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(823),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [454] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(824),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(825),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [455] = {
    [sym_subscript] = STATE(826),
    [anon_sym_STAR] = ACTIONS(1738),
    [anon_sym_QMARK] = ACTIONS(1738),
    [anon_sym_BANG] = ACTIONS(1740),
    [anon_sym_AT] = ACTIONS(1738),
    [sym_variable_name] = ACTIONS(1742),
    [anon_sym_DOLLAR] = ACTIONS(1744),
    [anon_sym_DASH] = ACTIONS(1744),
    [anon_sym_0] = ACTIONS(1746),
    [anon_sym_POUND] = ACTIONS(1740),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1746),
    [anon_sym__] = ACTIONS(1746),
    [sym_comment] = ACTIONS(3),
  },
  [456] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(832),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(1748),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(1750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [457] = {
    [aux_sym_concatenation_repeat1] = STATE(817),
    [anon_sym_BANG_EQ] = ACTIONS(187),
    [anon_sym_PLUS_EQ] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [sym_test_operator] = ACTIONS(189),
    [anon_sym_LF] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_PLUS_PLUS] = ACTIONS(187),
    [anon_sym_DASH] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_EQ] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [anon_sym_GT_EQ] = ACTIONS(187),
    [sym__concat] = ACTIONS(1726),
    [anon_sym_PLUS] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(187),
    [anon_sym_DASH_DASH] = ACTIONS(187),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_LT_EQ] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_DASH_EQ] = ACTIONS(187),
  },
  [458] = {
    [aux_sym__literal_repeat1] = STATE(834),
    [anon_sym_BANG_EQ] = ACTIONS(713),
    [anon_sym_PLUS_EQ] = ACTIONS(713),
    [sym_test_operator] = ACTIONS(711),
    [sym__special_character] = ACTIONS(1752),
    [anon_sym_LF] = ACTIONS(713),
    [anon_sym_SEMI] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_EQ] = ACTIONS(713),
    [anon_sym_EQ_EQ] = ACTIONS(713),
    [anon_sym_PIPE_PIPE] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_AMP] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(713),
    [anon_sym_DASH_DASH] = ACTIONS(713),
    [anon_sym_AMP_AMP] = ACTIONS(713),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_SEMI_SEMI] = ACTIONS(713),
    [anon_sym_DASH_EQ] = ACTIONS(713),
  },
  [459] = {
    [anon_sym_BANG_EQ] = ACTIONS(1754),
    [anon_sym_PLUS_EQ] = ACTIONS(1754),
    [sym_test_operator] = ACTIONS(1756),
    [anon_sym_LF] = ACTIONS(1758),
    [anon_sym_SEMI] = ACTIONS(1758),
    [anon_sym_PLUS_PLUS] = ACTIONS(1760),
    [anon_sym_DASH] = ACTIONS(1754),
    [anon_sym_GT] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(1754),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_GT_EQ] = ACTIONS(1754),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_LT] = ACTIONS(1754),
    [anon_sym_AMP] = ACTIONS(1758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1762),
    [anon_sym_DASH_DASH] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1754),
    [anon_sym_SEMI_SEMI] = ACTIONS(1758),
    [anon_sym_DASH_EQ] = ACTIONS(1754),
  },
  [460] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(840),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_done] = ACTIONS(1764),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [461] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1766),
    [anon_sym_BQUOTE] = ACTIONS(1766),
    [anon_sym_AMP_GT_GT] = ACTIONS(1766),
    [anon_sym_LF] = ACTIONS(1768),
    [anon_sym_SEMI] = ACTIONS(1766),
    [anon_sym_LT_LT] = ACTIONS(1766),
    [sym_file_descriptor] = ACTIONS(1768),
    [anon_sym_GT] = ACTIONS(1766),
    [anon_sym_RPAREN] = ACTIONS(1766),
    [anon_sym_AMP_GT] = ACTIONS(1766),
    [anon_sym_PIPE_PIPE] = ACTIONS(1766),
    [ts_builtin_sym_end] = ACTIONS(1768),
    [anon_sym_LT_LT_LT] = ACTIONS(1766),
    [anon_sym_PIPE] = ACTIONS(1766),
    [anon_sym_GT_AMP] = ACTIONS(1766),
    [anon_sym_LT] = ACTIONS(1766),
    [anon_sym_LT_AMP] = ACTIONS(1766),
    [anon_sym_GT_GT] = ACTIONS(1766),
    [anon_sym_AMP] = ACTIONS(1766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(1766),
    [anon_sym_AMP_AMP] = ACTIONS(1766),
    [anon_sym_SEMI_SEMI] = ACTIONS(1766),
    [anon_sym_PIPE_AMP] = ACTIONS(1766),
  },
  [462] = {
    [anon_sym_BANG_EQ] = ACTIONS(867),
    [anon_sym_PLUS_EQ] = ACTIONS(867),
    [sym_test_operator] = ACTIONS(867),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_EQ] = ACTIONS(871),
    [anon_sym_EQ_EQ] = ACTIONS(873),
    [anon_sym_PIPE_PIPE] = ACTIONS(867),
    [anon_sym_GT_EQ] = ACTIONS(867),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(871),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(873),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_LT_EQ] = ACTIONS(867),
    [anon_sym_AMP_AMP] = ACTIONS(867),
    [anon_sym_DASH_EQ] = ACTIONS(867),
  },
  [463] = {
    [anon_sym_BANG_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1488),
    [sym_test_operator] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(1770),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_PIPE_PIPE] = ACTIONS(1488),
    [anon_sym_GT_EQ] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1492),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(1488),
    [anon_sym_AMP_AMP] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1488),
  },
  [464] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(1772),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [465] = {
    [anon_sym_BANG_EQ] = ACTIONS(789),
    [anon_sym_PLUS_EQ] = ACTIONS(789),
    [sym_test_operator] = ACTIONS(789),
    [anon_sym_PLUS_PLUS] = ACTIONS(789),
    [anon_sym_RBRACK] = ACTIONS(789),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ] = ACTIONS(789),
    [anon_sym_PIPE_PIPE] = ACTIONS(789),
    [anon_sym_GT_EQ] = ACTIONS(789),
    [sym__concat] = ACTIONS(789),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(789),
    [anon_sym_DASH_DASH] = ACTIONS(789),
    [anon_sym_LT_EQ] = ACTIONS(789),
    [anon_sym_AMP_AMP] = ACTIONS(789),
    [anon_sym_DASH_EQ] = ACTIONS(789),
  },
  [466] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(1774),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(1772),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [467] = {
    [sym_command_substitution] = STATE(844),
    [sym_simple_expansion] = STATE(844),
    [sym_string_expansion] = STATE(844),
    [sym_string] = STATE(844),
    [sym_process_substitution] = STATE(844),
    [sym_expansion] = STATE(844),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym_word] = ACTIONS(1776),
    [sym_raw_string] = ACTIONS(1776),
    [anon_sym_LT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR] = ACTIONS(279),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [sym__special_character] = ACTIONS(1776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(285),
  },
  [468] = {
    [aux_sym_concatenation_repeat1] = STATE(846),
    [anon_sym_BANG_EQ] = ACTIONS(585),
    [anon_sym_PLUS_EQ] = ACTIONS(585),
    [sym_test_operator] = ACTIONS(585),
    [anon_sym_PLUS_PLUS] = ACTIONS(585),
    [anon_sym_RBRACK] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_GT_EQ] = ACTIONS(585),
    [sym__concat] = ACTIONS(1778),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(585),
    [anon_sym_DASH_DASH] = ACTIONS(585),
    [anon_sym_LT_EQ] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_DASH_EQ] = ACTIONS(585),
  },
  [469] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1780),
  },
  [470] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1782),
  },
  [471] = {
    [anon_sym_BANG_EQ] = ACTIONS(507),
    [anon_sym_PLUS_EQ] = ACTIONS(507),
    [sym_test_operator] = ACTIONS(507),
    [anon_sym_PLUS_PLUS] = ACTIONS(507),
    [anon_sym_RBRACK] = ACTIONS(507),
    [anon_sym_DASH] = ACTIONS(505),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_EQ] = ACTIONS(505),
    [anon_sym_EQ_EQ] = ACTIONS(507),
    [anon_sym_PIPE_PIPE] = ACTIONS(507),
    [anon_sym_GT_EQ] = ACTIONS(507),
    [sym__concat] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(507),
    [anon_sym_LT_EQ] = ACTIONS(507),
    [anon_sym_AMP_AMP] = ACTIONS(507),
    [anon_sym_DASH_EQ] = ACTIONS(507),
  },
  [472] = {
    [anon_sym_BANG_EQ] = ACTIONS(511),
    [anon_sym_PLUS_EQ] = ACTIONS(511),
    [sym_test_operator] = ACTIONS(511),
    [anon_sym_PLUS_PLUS] = ACTIONS(511),
    [anon_sym_RBRACK] = ACTIONS(511),
    [anon_sym_DASH] = ACTIONS(509),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_EQ] = ACTIONS(509),
    [anon_sym_EQ_EQ] = ACTIONS(511),
    [anon_sym_PIPE_PIPE] = ACTIONS(511),
    [anon_sym_GT_EQ] = ACTIONS(511),
    [sym__concat] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(511),
    [anon_sym_DASH_DASH] = ACTIONS(511),
    [anon_sym_LT_EQ] = ACTIONS(511),
    [anon_sym_AMP_AMP] = ACTIONS(511),
    [anon_sym_DASH_EQ] = ACTIONS(511),
  },
  [473] = {
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [anon_sym_PLUS_EQ] = ACTIONS(515),
    [sym_test_operator] = ACTIONS(515),
    [anon_sym_PLUS_PLUS] = ACTIONS(515),
    [anon_sym_RBRACK] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(513),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_GT_EQ] = ACTIONS(515),
    [sym__concat] = ACTIONS(515),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(515),
    [anon_sym_DASH_DASH] = ACTIONS(515),
    [anon_sym_LT_EQ] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_DASH_EQ] = ACTIONS(515),
  },
  [474] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(1780),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [475] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1780),
  },
  [476] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(851),
    [sym_concatenation] = STATE(851),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1784),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1786),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1786),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1786),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1786),
    [anon_sym_PERCENT] = ACTIONS(1786),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1790),
    [anon_sym_COLON_DASH] = ACTIONS(1786),
    [sym__special_character] = ACTIONS(553),
  },
  [477] = {
    [sym_subscript] = STATE(852),
    [anon_sym_STAR] = ACTIONS(1792),
    [anon_sym_QMARK] = ACTIONS(1792),
    [anon_sym_AT] = ACTIONS(1792),
    [sym_variable_name] = ACTIONS(1794),
    [anon_sym_DOLLAR] = ACTIONS(1796),
    [anon_sym_DASH] = ACTIONS(1796),
    [anon_sym_0] = ACTIONS(1798),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1798),
    [anon_sym__] = ACTIONS(1798),
  },
  [478] = {
    [anon_sym_EQ] = ACTIONS(1800),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [479] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(858),
    [sym_concatenation] = STATE(858),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(1802),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1804),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(1806),
    [anon_sym_DASH] = ACTIONS(1804),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1804),
    [anon_sym_PERCENT] = ACTIONS(1804),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1808),
    [anon_sym_COLON_DASH] = ACTIONS(1804),
    [sym__special_character] = ACTIONS(553),
  },
  [480] = {
    [anon_sym_BANG_EQ] = ACTIONS(189),
    [anon_sym_PLUS_EQ] = ACTIONS(189),
    [sym_test_operator] = ACTIONS(189),
    [anon_sym_PLUS_PLUS] = ACTIONS(189),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_EQ] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(189),
    [anon_sym_PIPE_PIPE] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(189),
    [anon_sym_PLUS] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(189),
    [anon_sym_DASH_DASH] = ACTIONS(189),
    [anon_sym_LT_EQ] = ACTIONS(189),
    [anon_sym_AMP_AMP] = ACTIONS(189),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_DASH_EQ] = ACTIONS(189),
  },
  [481] = {
    [aux_sym__literal_repeat1] = STATE(481),
    [anon_sym_BANG_EQ] = ACTIONS(888),
    [anon_sym_PLUS_EQ] = ACTIONS(888),
    [sym_test_operator] = ACTIONS(888),
    [anon_sym_PLUS_PLUS] = ACTIONS(888),
    [anon_sym_RBRACK] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(888),
    [anon_sym_PIPE_PIPE] = ACTIONS(888),
    [anon_sym_GT_EQ] = ACTIONS(888),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(888),
    [sym__special_character] = ACTIONS(1810),
    [anon_sym_DASH_EQ] = ACTIONS(888),
  },
  [482] = {
    [sym_command_substitution] = STATE(168),
    [sym_unary_expression] = STATE(859),
    [sym_postfix_expression] = STATE(859),
    [sym_string] = STATE(168),
    [aux_sym__literal_repeat1] = STATE(175),
    [sym_process_substitution] = STATE(168),
    [sym_parenthesized_expression] = STATE(859),
    [sym_simple_expansion] = STATE(168),
    [sym_string_expansion] = STATE(168),
    [sym__expression] = STATE(859),
    [sym_binary_expression] = STATE(859),
    [sym_concatenation] = STATE(859),
    [sym_expansion] = STATE(168),
    [sym_test_operator] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym_word] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_LT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR] = ACTIONS(279),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [sym__special_character] = ACTIONS(283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(285),
  },
  [483] = {
    [anon_sym_BANG_EQ] = ACTIONS(1537),
    [anon_sym_PLUS_EQ] = ACTIONS(1537),
    [sym_test_operator] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1537),
    [anon_sym_RBRACK] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1537),
    [anon_sym_PIPE_PIPE] = ACTIONS(1537),
    [anon_sym_GT_EQ] = ACTIONS(1537),
    [anon_sym_PLUS] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1539),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1537),
    [anon_sym_DASH_DASH] = ACTIONS(1537),
    [anon_sym_LT_EQ] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1537),
    [anon_sym_DASH_EQ] = ACTIONS(1537),
  },
  [484] = {
    [sym_command_substitution] = STATE(168),
    [sym_unary_expression] = STATE(859),
    [sym_postfix_expression] = STATE(859),
    [sym_string] = STATE(168),
    [aux_sym__literal_repeat1] = STATE(175),
    [sym_process_substitution] = STATE(168),
    [sym_parenthesized_expression] = STATE(859),
    [sym_simple_expansion] = STATE(168),
    [sym_string_expansion] = STATE(168),
    [sym__expression] = STATE(859),
    [sym_binary_expression] = STATE(859),
    [sym_concatenation] = STATE(859),
    [sym_expansion] = STATE(168),
    [sym_test_operator] = ACTIONS(263),
    [anon_sym_LPAREN] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [sym_raw_string] = ACTIONS(271),
    [anon_sym_BANG] = ACTIONS(275),
    [anon_sym_DOLLAR] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym_word] = ACTIONS(269),
    [anon_sym_LT_LPAREN] = ACTIONS(277),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(283),
    [sym_regex] = ACTIONS(1813),
  },
  [485] = {
    [anon_sym_BANG_EQ] = ACTIONS(877),
    [anon_sym_PLUS_EQ] = ACTIONS(877),
    [sym_test_operator] = ACTIONS(877),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_EQ] = ACTIONS(879),
    [anon_sym_EQ_EQ] = ACTIONS(881),
    [anon_sym_PIPE_PIPE] = ACTIONS(877),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1486),
    [anon_sym_GT_EQ] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(877),
    [anon_sym_DASH_EQ] = ACTIONS(877),
  },
  [486] = {
    [aux_sym_concatenation_repeat1] = STATE(861),
    [anon_sym_BANG_EQ] = ACTIONS(585),
    [anon_sym_PLUS_EQ] = ACTIONS(585),
    [sym_test_operator] = ACTIONS(585),
    [anon_sym_PLUS_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(585),
    [anon_sym_GT_EQ] = ACTIONS(585),
    [sym__concat] = ACTIONS(1502),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(585),
    [anon_sym_DASH_DASH] = ACTIONS(585),
    [anon_sym_LT_EQ] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_DASH_EQ] = ACTIONS(585),
  },
  [487] = {
    [aux_sym__literal_repeat1] = STATE(487),
    [anon_sym_BANG_EQ] = ACTIONS(888),
    [anon_sym_PLUS_EQ] = ACTIONS(888),
    [sym_test_operator] = ACTIONS(888),
    [anon_sym_PLUS_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(888),
    [anon_sym_PIPE_PIPE] = ACTIONS(888),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(888),
    [anon_sym_GT_EQ] = ACTIONS(888),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(888),
    [sym__special_character] = ACTIONS(1815),
    [anon_sym_DASH_EQ] = ACTIONS(888),
  },
  [488] = {
    [sym_command_substitution] = STATE(178),
    [sym_unary_expression] = STATE(730),
    [sym_postfix_expression] = STATE(730),
    [sym_string] = STATE(178),
    [aux_sym__literal_repeat1] = STATE(180),
    [sym_process_substitution] = STATE(178),
    [sym_parenthesized_expression] = STATE(730),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym__expression] = STATE(730),
    [sym_binary_expression] = STATE(730),
    [sym_concatenation] = STATE(730),
    [sym_expansion] = STATE(178),
    [sym_test_operator] = ACTIONS(287),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(289),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [489] = {
    [sym_command_substitution] = STATE(178),
    [sym_unary_expression] = STATE(730),
    [sym_postfix_expression] = STATE(730),
    [sym_string] = STATE(178),
    [aux_sym__literal_repeat1] = STATE(180),
    [sym_process_substitution] = STATE(178),
    [sym_parenthesized_expression] = STATE(730),
    [sym_simple_expansion] = STATE(178),
    [sym_string_expansion] = STATE(178),
    [sym__expression] = STATE(730),
    [sym_binary_expression] = STATE(730),
    [sym_concatenation] = STATE(730),
    [sym_expansion] = STATE(178),
    [sym_test_operator] = ACTIONS(287),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [sym_raw_string] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(289),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(295),
    [sym_regex] = ACTIONS(1541),
  },
  [490] = {
    [sym_heredoc_redirect] = STATE(192),
    [aux_sym_redirected_statement_repeat1] = STATE(192),
    [sym_herestring_redirect] = STATE(192),
    [sym_file_redirect] = STATE(192),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [sym_file_descriptor] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [ts_builtin_sym_end] = ACTIONS(1820),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
  },
  [491] = {
    [sym_heredoc_redirect] = STATE(192),
    [aux_sym_redirected_statement_repeat1] = STATE(192),
    [sym_herestring_redirect] = STATE(192),
    [sym_file_redirect] = STATE(192),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [ts_builtin_sym_end] = ACTIONS(1820),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
  },
  [492] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(862),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [493] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(865),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [494] = {
    [aux_sym_concatenation_repeat1] = STATE(867),
    [anon_sym_LT_LT_DASH] = ACTIONS(391),
    [anon_sym_AMP_GT_GT] = ACTIONS(391),
    [anon_sym_LF] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(391),
    [sym_file_descriptor] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_AMP_GT] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(391),
    [ts_builtin_sym_end] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(391),
    [anon_sym_PIPE] = ACTIONS(391),
    [anon_sym_GT_AMP] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_LT_AMP] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(391),
    [anon_sym_SEMI_SEMI] = ACTIONS(391),
    [anon_sym_PIPE_AMP] = ACTIONS(391),
  },
  [495] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(868),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [496] = {
    [sym_string] = STATE(870),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [anon_sym_STAR] = ACTIONS(1828),
    [anon_sym_QMARK] = ACTIONS(1828),
    [sym_raw_string] = ACTIONS(1830),
    [anon_sym_BANG] = ACTIONS(1832),
    [anon_sym_AT] = ACTIONS(1828),
    [anon_sym_DOLLAR] = ACTIONS(1832),
    [anon_sym_POUND] = ACTIONS(1832),
    [anon_sym_DASH] = ACTIONS(1832),
    [anon_sym_0] = ACTIONS(1834),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1834),
    [anon_sym__] = ACTIONS(1834),
  },
  [497] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(872),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(873),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [498] = {
    [aux_sym_concatenation_repeat1] = STATE(867),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [ts_builtin_sym_end] = ACTIONS(189),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [499] = {
    [sym_subscript] = STATE(874),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_QMARK] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1838),
    [anon_sym_AT] = ACTIONS(1836),
    [sym_variable_name] = ACTIONS(1840),
    [anon_sym_DOLLAR] = ACTIONS(1842),
    [anon_sym_DASH] = ACTIONS(1842),
    [anon_sym_0] = ACTIONS(1844),
    [anon_sym_POUND] = ACTIONS(1838),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1844),
    [anon_sym__] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [aux_sym__literal_repeat1] = STATE(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(415),
    [anon_sym_LF] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [sym_file_descriptor] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_AMP_GT] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [ts_builtin_sym_end] = ACTIONS(413),
    [anon_sym_LT_LT_LT] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(415),
    [anon_sym_GT_AMP] = ACTIONS(415),
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_LT_AMP] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(415),
    [anon_sym_PIPE_AMP] = ACTIONS(415),
  },
  [501] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(391),
    [anon_sym_AMP_GT_GT] = ACTIONS(391),
    [anon_sym_LF] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(391),
    [sym_file_descriptor] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_AMP_GT] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(391),
    [ts_builtin_sym_end] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(391),
    [anon_sym_PIPE] = ACTIONS(391),
    [anon_sym_GT_AMP] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_LT_AMP] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(391),
    [anon_sym_AMP_AMP] = ACTIONS(391),
    [anon_sym_SEMI_SEMI] = ACTIONS(391),
    [anon_sym_PIPE_AMP] = ACTIONS(391),
  },
  [502] = {
    [anon_sym_BQUOTE] = ACTIONS(1848),
    [ts_builtin_sym_end] = ACTIONS(1850),
    [anon_sym_LF] = ACTIONS(1850),
    [anon_sym_SEMI] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_esac] = ACTIONS(1848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1848),
    [anon_sym_SEMI_SEMI] = ACTIONS(1848),
  },
  [503] = {
    [sym_command_substitution] = STATE(885),
    [sym_simple_expansion] = STATE(885),
    [sym_expansion] = STATE(885),
    [aux_sym_heredoc_body_repeat1] = STATE(885),
    [anon_sym_DOLLAR] = ACTIONS(1852),
    [anon_sym_BQUOTE] = ACTIONS(1854),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1856),
    [sym__heredoc_body_end] = ACTIONS(1858),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1860),
    [sym__heredoc_body_middle] = ACTIONS(1862),
  },
  [504] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1864),
    [ts_builtin_sym_end] = ACTIONS(1866),
    [anon_sym_LF] = ACTIONS(1868),
    [anon_sym_SEMI] = ACTIONS(1870),
    [anon_sym_SEMI_SEMI] = ACTIONS(1870),
    [anon_sym_AMP] = ACTIONS(1870),
  },
  [505] = {
    [sym_command_substitution] = STATE(887),
    [aux_sym__literal_repeat1] = STATE(888),
    [sym_string] = STATE(887),
    [sym_process_substitution] = STATE(887),
    [sym_simple_expansion] = STATE(887),
    [sym_string_expansion] = STATE(887),
    [sym_concatenation] = STATE(889),
    [sym_expansion] = STATE(887),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(1872),
    [sym_raw_string] = ACTIONS(1872),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [506] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1874),
    [anon_sym_BQUOTE] = ACTIONS(1874),
    [anon_sym_AMP_GT_GT] = ACTIONS(1874),
    [anon_sym_LF] = ACTIONS(1876),
    [anon_sym_SEMI] = ACTIONS(1874),
    [anon_sym_LT_LT] = ACTIONS(1874),
    [sym_file_descriptor] = ACTIONS(1876),
    [anon_sym_GT] = ACTIONS(1874),
    [anon_sym_RPAREN] = ACTIONS(1874),
    [anon_sym_AMP_GT] = ACTIONS(1874),
    [anon_sym_PIPE_PIPE] = ACTIONS(1874),
    [ts_builtin_sym_end] = ACTIONS(1876),
    [anon_sym_LT_LT_LT] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(1874),
    [anon_sym_GT_AMP] = ACTIONS(1874),
    [anon_sym_LT] = ACTIONS(1874),
    [anon_sym_LT_AMP] = ACTIONS(1874),
    [anon_sym_GT_GT] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(1874),
    [anon_sym_AMP_AMP] = ACTIONS(1874),
    [anon_sym_SEMI_SEMI] = ACTIONS(1874),
    [anon_sym_PIPE_AMP] = ACTIONS(1874),
  },
  [507] = {
    [sym_heredoc_redirect] = STATE(192),
    [aux_sym_redirected_statement_repeat1] = STATE(192),
    [sym_herestring_redirect] = STATE(192),
    [sym_file_redirect] = STATE(192),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [sym_file_descriptor] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [ts_builtin_sym_end] = ACTIONS(1880),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(319),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(319),
  },
  [508] = {
    [sym_heredoc_redirect] = STATE(192),
    [aux_sym_redirected_statement_repeat1] = STATE(192),
    [sym_herestring_redirect] = STATE(192),
    [sym_file_redirect] = STATE(192),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(319),
    [anon_sym_AMP] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [ts_builtin_sym_end] = ACTIONS(1880),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(319),
  },
  [509] = {
    [aux_sym_concatenation_repeat1] = STATE(867),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [ts_builtin_sym_end] = ACTIONS(1884),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [anon_sym_PIPE] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
  },
  [510] = {
    [aux_sym__literal_repeat1] = STATE(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1888),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_LT_LT] = ACTIONS(1886),
    [sym_file_descriptor] = ACTIONS(1888),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_PIPE_PIPE] = ACTIONS(1886),
    [ts_builtin_sym_end] = ACTIONS(1888),
    [anon_sym_LT_LT_LT] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_GT_AMP] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_LT_AMP] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1886),
    [anon_sym_AMP] = ACTIONS(1886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1886),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1886),
    [anon_sym_PIPE_AMP] = ACTIONS(1886),
  },
  [511] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1882),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [ts_builtin_sym_end] = ACTIONS(1884),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [anon_sym_PIPE] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
  },
  [512] = {
    [sym_heredoc_redirect] = STATE(512),
    [aux_sym_redirected_statement_repeat1] = STATE(512),
    [sym_herestring_redirect] = STATE(512),
    [sym_file_redirect] = STATE(512),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_AMP_GT_GT] = ACTIONS(1893),
    [anon_sym_LF] = ACTIONS(1896),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_LT_LT] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1900),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_AMP_GT] = ACTIONS(1893),
    [anon_sym_PIPE_PIPE] = ACTIONS(1898),
    [ts_builtin_sym_end] = ACTIONS(1896),
    [anon_sym_LT_LT_LT] = ACTIONS(1903),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_GT_AMP] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_LT_AMP] = ACTIONS(1893),
    [anon_sym_GT_GT] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1898),
    [anon_sym_SEMI_SEMI] = ACTIONS(1898),
    [anon_sym_PIPE_AMP] = ACTIONS(1898),
  },
  [513] = {
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [ts_builtin_sym_end] = ACTIONS(1866),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [514] = {
    [sym_heredoc_body] = STATE(890),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__simple_heredoc_body] = ACTIONS(910),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [sym__heredoc_body_beginning] = ACTIONS(912),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [ts_builtin_sym_end] = ACTIONS(1866),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [515] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
    [anon_sym_AMP_GT_GT] = ACTIONS(609),
    [anon_sym_LF] = ACTIONS(1906),
    [anon_sym_SEMI] = ACTIONS(1908),
    [sym_file_descriptor] = ACTIONS(615),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_AMP_GT] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_LT_LT_LT] = ACTIONS(619),
    [anon_sym_GT_AMP] = ACTIONS(609),
    [anon_sym_PIPE] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_AMP] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(1908),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
  },
  [516] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(1908),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1906),
    [anon_sym_SEMI] = ACTIONS(1908),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(619),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(1908),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
  },
  [517] = {
    [sym_command_substitution] = STATE(198),
    [aux_sym__literal_repeat1] = STATE(200),
    [sym_string] = STATE(198),
    [sym_process_substitution] = STATE(198),
    [sym_simple_expansion] = STATE(198),
    [sym_string_expansion] = STATE(198),
    [aux_sym_command_repeat2] = STATE(521),
    [sym_concatenation] = STATE(521),
    [sym_expansion] = STATE(198),
    [anon_sym_AMP_GT_GT] = ACTIONS(1910),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1910),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1910),
    [sym_word] = ACTIONS(339),
    [anon_sym_PIPE] = ACTIONS(1910),
    [anon_sym_AMP] = ACTIONS(1910),
    [anon_sym_LT] = ACTIONS(1910),
    [anon_sym_LT_AMP] = ACTIONS(1910),
    [anon_sym_GT_GT] = ACTIONS(1910),
    [anon_sym_EQ_TILDE] = ACTIONS(341),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(1910),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(1912),
    [anon_sym_SEMI] = ACTIONS(1910),
    [sym_raw_string] = ACTIONS(339),
    [sym_file_descriptor] = ACTIONS(1912),
    [anon_sym_GT] = ACTIONS(1910),
    [anon_sym_AMP_GT] = ACTIONS(1910),
    [anon_sym_EQ_EQ] = ACTIONS(341),
    [ts_builtin_sym_end] = ACTIONS(1912),
    [anon_sym_LT_LT_LT] = ACTIONS(1910),
    [anon_sym_GT_AMP] = ACTIONS(1910),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1910),
    [anon_sym_SEMI_SEMI] = ACTIONS(1910),
    [anon_sym_PIPE_AMP] = ACTIONS(1910),
  },
  [518] = {
    [aux_sym_concatenation_repeat1] = STATE(99),
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(1914),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [sym_word] = ACTIONS(1914),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(1914),
    [sym__special_character] = ACTIONS(1914),
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [sym_raw_string] = ACTIONS(1914),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1914),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(1914),
    [anon_sym_DQUOTE] = ACTIONS(1914),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [ts_builtin_sym_end] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [519] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(1914),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [sym_word] = ACTIONS(1914),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [anon_sym_EQ_TILDE] = ACTIONS(1914),
    [sym__special_character] = ACTIONS(1914),
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [sym_raw_string] = ACTIONS(1914),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_RPAREN] = ACTIONS(1914),
    [anon_sym_GT] = ACTIONS(1914),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(1914),
    [anon_sym_DQUOTE] = ACTIONS(1914),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [ts_builtin_sym_end] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [520] = {
    [aux_sym__literal_repeat1] = STATE(183),
    [anon_sym_AMP_GT_GT] = ACTIONS(1918),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [anon_sym_LT_LT] = ACTIONS(1918),
    [anon_sym_GT_LPAREN] = ACTIONS(1918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1918),
    [anon_sym_PIPE_PIPE] = ACTIONS(1918),
    [sym_word] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_LT_AMP] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1918),
    [anon_sym_EQ_TILDE] = ACTIONS(1918),
    [sym__special_character] = ACTIONS(299),
    [anon_sym_LT_LT_DASH] = ACTIONS(1918),
    [anon_sym_BQUOTE] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1918),
    [sym_file_descriptor] = ACTIONS(1920),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_EQ_EQ] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1918),
    [anon_sym_LT_LT_LT] = ACTIONS(1918),
    [anon_sym_GT_AMP] = ACTIONS(1918),
    [ts_builtin_sym_end] = ACTIONS(1920),
    [anon_sym_LT_LPAREN] = ACTIONS(1918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE_AMP] = ACTIONS(1918),
  },
  [521] = {
    [sym_command_substitution] = STATE(198),
    [aux_sym__literal_repeat1] = STATE(200),
    [sym_string] = STATE(198),
    [sym_process_substitution] = STATE(198),
    [sym_simple_expansion] = STATE(198),
    [sym_string_expansion] = STATE(198),
    [aux_sym_command_repeat2] = STATE(521),
    [sym_concatenation] = STATE(521),
    [sym_expansion] = STATE(198),
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(1922),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_LPAREN] = ACTIONS(1925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1931),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [sym_word] = ACTIONS(1934),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [anon_sym_EQ_TILDE] = ACTIONS(1937),
    [sym__special_character] = ACTIONS(1940),
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(1943),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [sym_raw_string] = ACTIONS(1934),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1914),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(1937),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [ts_builtin_sym_end] = ACTIONS(1916),
    [anon_sym_LT_LPAREN] = ACTIONS(1925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [522] = {
    [aux_sym_concatenation_repeat1] = STATE(893),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [523] = {
    [sym_command_substitution] = STATE(894),
    [aux_sym__literal_repeat1] = STATE(895),
    [sym_string] = STATE(894),
    [sym_array] = STATE(574),
    [sym_process_substitution] = STATE(894),
    [sym_simple_expansion] = STATE(894),
    [sym_string_expansion] = STATE(894),
    [sym_concatenation] = STATE(574),
    [sym_expansion] = STATE(894),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [anon_sym_DQUOTE] = ACTIONS(431),
    [sym_word] = ACTIONS(1949),
    [sym_raw_string] = ACTIONS(1949),
    [anon_sym_LT_LPAREN] = ACTIONS(1121),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [sym__special_character] = ACTIONS(1951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [sym__empty_value] = ACTIONS(1137),
  },
  [524] = {
    [aux_sym__literal_repeat1] = STATE(524),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [aux_sym__simple_variable_name_token1] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(1165),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_variable_name] = ACTIONS(888),
    [anon_sym_RPAREN] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [525] = {
    [sym_command_substitution] = STATE(202),
    [aux_sym__literal_repeat1] = STATE(205),
    [sym_string] = STATE(202),
    [aux_sym_declaration_command_repeat1] = STATE(525),
    [sym_process_substitution] = STATE(202),
    [sym_simple_expansion] = STATE(202),
    [sym_subscript] = STATE(207),
    [sym_string_expansion] = STATE(202),
    [sym_variable_assignment] = STATE(525),
    [sym_concatenation] = STATE(525),
    [sym_expansion] = STATE(202),
    [anon_sym_AMP_GT_GT] = ACTIONS(1168),
    [anon_sym_DOLLAR] = ACTIONS(1170),
    [anon_sym_LT_LT] = ACTIONS(1168),
    [anon_sym_GT_LPAREN] = ACTIONS(1173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1176),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1953),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1182),
    [anon_sym_PIPE_PIPE] = ACTIONS(1168),
    [sym_word] = ACTIONS(1956),
    [anon_sym_PIPE] = ACTIONS(1168),
    [anon_sym_AMP] = ACTIONS(1168),
    [anon_sym_LT] = ACTIONS(1168),
    [anon_sym_LT_AMP] = ACTIONS(1168),
    [anon_sym_GT_GT] = ACTIONS(1168),
    [sym__special_character] = ACTIONS(1959),
    [anon_sym_LT_LT_DASH] = ACTIONS(1168),
    [anon_sym_BQUOTE] = ACTIONS(1191),
    [anon_sym_LF] = ACTIONS(1194),
    [anon_sym_SEMI] = ACTIONS(1168),
    [sym_raw_string] = ACTIONS(1956),
    [sym_variable_name] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1168),
    [sym_file_descriptor] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1168),
    [anon_sym_AMP_GT] = ACTIONS(1168),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_LT_LT_LT] = ACTIONS(1168),
    [anon_sym_GT_AMP] = ACTIONS(1168),
    [anon_sym_LT_LPAREN] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_SEMI_SEMI] = ACTIONS(1168),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
  },
  [526] = {
    [aux_sym_concatenation_repeat1] = STATE(896),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(1218),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [anon_sym_RPAREN] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [527] = {
    [aux_sym__literal_repeat1] = STATE(527),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [aux_sym__simple_variable_name_token1] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(1248),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [528] = {
    [sym_command_substitution] = STATE(208),
    [aux_sym__literal_repeat1] = STATE(210),
    [sym_string] = STATE(208),
    [aux_sym_unset_command_repeat1] = STATE(528),
    [sym_process_substitution] = STATE(208),
    [sym_simple_expansion] = STATE(208),
    [sym_string_expansion] = STATE(208),
    [sym_concatenation] = STATE(528),
    [sym_expansion] = STATE(208),
    [anon_sym_AMP_GT_GT] = ACTIONS(1251),
    [anon_sym_DOLLAR] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_GT_LPAREN] = ACTIONS(1256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1259),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1251),
    [sym_word] = ACTIONS(1968),
    [anon_sym_PIPE] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1251),
    [anon_sym_LT_AMP] = ACTIONS(1251),
    [anon_sym_GT_GT] = ACTIONS(1251),
    [sym__special_character] = ACTIONS(1971),
    [anon_sym_LT_LT_DASH] = ACTIONS(1251),
    [anon_sym_BQUOTE] = ACTIONS(1274),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1251),
    [sym_raw_string] = ACTIONS(1968),
    [anon_sym_RPAREN] = ACTIONS(1251),
    [sym_file_descriptor] = ACTIONS(1277),
    [anon_sym_GT] = ACTIONS(1251),
    [anon_sym_AMP_GT] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [anon_sym_LT_LT_LT] = ACTIONS(1251),
    [anon_sym_GT_AMP] = ACTIONS(1251),
    [anon_sym_LT_LPAREN] = ACTIONS(1256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1251),
    [anon_sym_SEMI_SEMI] = ACTIONS(1251),
    [anon_sym_PIPE_AMP] = ACTIONS(1251),
  },
  [529] = {
    [aux_sym_concatenation_repeat1] = STATE(529),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1396),
    [anon_sym_EQ_TILDE] = ACTIONS(1390),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [530] = {
    [aux_sym_concatenation_repeat1] = STATE(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__concat] = ACTIONS(1591),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [anon_sym_RPAREN] = ACTIONS(1589),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [531] = {
    [aux_sym_concatenation_repeat1] = STATE(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(1591),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [532] = {
    [aux_sym__literal_repeat1] = STATE(898),
    [anon_sym_AMP_GT_GT] = ACTIONS(1613),
    [anon_sym_DOLLAR] = ACTIONS(1613),
    [anon_sym_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1613),
    [anon_sym_PIPE_PIPE] = ACTIONS(1613),
    [sym_word] = ACTIONS(1613),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_LT_AMP] = ACTIONS(1613),
    [anon_sym_GT_GT] = ACTIONS(1613),
    [sym__special_character] = ACTIONS(1615),
    [anon_sym_LT_LT_DASH] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1613),
    [anon_sym_LF] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1613),
    [sym_raw_string] = ACTIONS(1613),
    [sym_variable_name] = ACTIONS(1617),
    [anon_sym_RPAREN] = ACTIONS(1613),
    [sym_file_descriptor] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1613),
    [anon_sym_AMP_GT] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_LT_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_AMP] = ACTIONS(1613),
    [anon_sym_LT_LPAREN] = ACTIONS(1613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1613),
    [anon_sym_SEMI_SEMI] = ACTIONS(1613),
    [anon_sym_PIPE_AMP] = ACTIONS(1613),
  },
  [533] = {
    [sym_heredoc_redirect] = STATE(220),
    [aux_sym_redirected_statement_repeat1] = STATE(220),
    [sym_herestring_redirect] = STATE(220),
    [sym_file_redirect] = STATE(220),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [sym_file_descriptor] = ACTIONS(1820),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
  },
  [534] = {
    [sym_heredoc_redirect] = STATE(220),
    [aux_sym_redirected_statement_repeat1] = STATE(220),
    [sym_herestring_redirect] = STATE(220),
    [sym_file_redirect] = STATE(220),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(1820),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
  },
  [535] = {
    [aux_sym_concatenation_repeat1] = STATE(899),
    [anon_sym_LT_LT_DASH] = ACTIONS(391),
    [anon_sym_AMP_GT_GT] = ACTIONS(391),
    [anon_sym_LF] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(391),
    [anon_sym_GT] = ACTIONS(391),
    [sym_file_descriptor] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(391),
    [anon_sym_LT_LT_LT] = ACTIONS(391),
    [anon_sym_PIPE] = ACTIONS(391),
    [anon_sym_GT_AMP] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_LT_AMP] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(391),
    [anon_sym_SEMI_SEMI] = ACTIONS(391),
    [anon_sym_PIPE_AMP] = ACTIONS(391),
  },
  [536] = {
    [aux_sym_concatenation_repeat1] = STATE(899),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_RPAREN] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [537] = {
    [aux_sym__literal_repeat1] = STATE(900),
    [anon_sym_LT_LT_DASH] = ACTIONS(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(415),
    [anon_sym_LF] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT] = ACTIONS(415),
    [sym_file_descriptor] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_LT_LT_LT] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(415),
    [anon_sym_GT_AMP] = ACTIONS(415),
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_LT_AMP] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(415),
    [anon_sym_PIPE_AMP] = ACTIONS(415),
  },
  [538] = {
    [sym_command_substitution] = STATE(901),
    [aux_sym__literal_repeat1] = STATE(902),
    [sym_string] = STATE(901),
    [sym_process_substitution] = STATE(901),
    [sym_simple_expansion] = STATE(901),
    [sym_string_expansion] = STATE(901),
    [sym_concatenation] = STATE(889),
    [sym_expansion] = STATE(901),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(1974),
    [sym_raw_string] = ACTIONS(1974),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(1054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [539] = {
    [sym_heredoc_redirect] = STATE(220),
    [aux_sym_redirected_statement_repeat1] = STATE(220),
    [sym_herestring_redirect] = STATE(220),
    [sym_file_redirect] = STATE(220),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_RPAREN] = ACTIONS(1878),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(1878),
    [sym_file_descriptor] = ACTIONS(1880),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(375),
  },
  [540] = {
    [sym_heredoc_redirect] = STATE(220),
    [aux_sym_redirected_statement_repeat1] = STATE(220),
    [sym_herestring_redirect] = STATE(220),
    [sym_file_redirect] = STATE(220),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(1878),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(375),
  },
  [541] = {
    [aux_sym_concatenation_repeat1] = STATE(899),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1882),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1882),
    [anon_sym_GT] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1884),
    [anon_sym_AMP_GT] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [anon_sym_PIPE] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
  },
  [542] = {
    [aux_sym__literal_repeat1] = STATE(900),
    [anon_sym_LT_LT_DASH] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1888),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_RPAREN] = ACTIONS(1886),
    [anon_sym_LT_LT] = ACTIONS(1886),
    [anon_sym_GT] = ACTIONS(1886),
    [sym_file_descriptor] = ACTIONS(1888),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_PIPE_PIPE] = ACTIONS(1886),
    [anon_sym_LT_LT_LT] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_GT_AMP] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_LT_AMP] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1886),
    [anon_sym_AMP] = ACTIONS(1886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1886),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1886),
    [anon_sym_PIPE_AMP] = ACTIONS(1886),
  },
  [543] = {
    [sym_heredoc_redirect] = STATE(543),
    [aux_sym_redirected_statement_repeat1] = STATE(543),
    [sym_herestring_redirect] = STATE(543),
    [sym_file_redirect] = STATE(543),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_AMP_GT_GT] = ACTIONS(1976),
    [anon_sym_LF] = ACTIONS(1896),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_RPAREN] = ACTIONS(1898),
    [anon_sym_LT_LT] = ACTIONS(1890),
    [anon_sym_GT] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(1979),
    [anon_sym_AMP_GT] = ACTIONS(1976),
    [anon_sym_PIPE_PIPE] = ACTIONS(1898),
    [anon_sym_LT_LT_LT] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_GT_AMP] = ACTIONS(1976),
    [anon_sym_LT] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(1976),
    [anon_sym_GT_GT] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1898),
    [anon_sym_SEMI_SEMI] = ACTIONS(1898),
    [anon_sym_PIPE_AMP] = ACTIONS(1898),
  },
  [544] = {
    [sym_command_substitution] = STATE(225),
    [aux_sym__literal_repeat1] = STATE(227),
    [sym_string] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [aux_sym_command_repeat2] = STATE(547),
    [sym_concatenation] = STATE(547),
    [sym_expansion] = STATE(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(1910),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1910),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1910),
    [sym_word] = ACTIONS(381),
    [anon_sym_PIPE] = ACTIONS(1910),
    [anon_sym_AMP] = ACTIONS(1910),
    [anon_sym_LT] = ACTIONS(1910),
    [anon_sym_LT_AMP] = ACTIONS(1910),
    [anon_sym_GT_GT] = ACTIONS(1910),
    [anon_sym_EQ_TILDE] = ACTIONS(383),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_LT_LT_DASH] = ACTIONS(1910),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(1912),
    [anon_sym_SEMI] = ACTIONS(1910),
    [sym_raw_string] = ACTIONS(381),
    [anon_sym_RPAREN] = ACTIONS(1910),
    [sym_file_descriptor] = ACTIONS(1912),
    [anon_sym_GT] = ACTIONS(1910),
    [anon_sym_AMP_GT] = ACTIONS(1910),
    [anon_sym_EQ_EQ] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(1910),
    [anon_sym_GT_AMP] = ACTIONS(1910),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1910),
    [anon_sym_SEMI_SEMI] = ACTIONS(1910),
    [anon_sym_PIPE_AMP] = ACTIONS(1910),
  },
  [545] = {
    [aux_sym_concatenation_repeat1] = STATE(212),
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(1914),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [sym_word] = ACTIONS(1914),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(1914),
    [sym__special_character] = ACTIONS(1914),
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [sym_raw_string] = ACTIONS(1914),
    [anon_sym_RPAREN] = ACTIONS(1914),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1914),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(1914),
    [anon_sym_DQUOTE] = ACTIONS(1914),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [anon_sym_LT_LPAREN] = ACTIONS(1914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [546] = {
    [aux_sym__literal_repeat1] = STATE(214),
    [anon_sym_AMP_GT_GT] = ACTIONS(1918),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [anon_sym_LT_LT] = ACTIONS(1918),
    [anon_sym_GT_LPAREN] = ACTIONS(1918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1918),
    [anon_sym_PIPE_PIPE] = ACTIONS(1918),
    [sym_word] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_LT_AMP] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1918),
    [anon_sym_EQ_TILDE] = ACTIONS(1918),
    [sym__special_character] = ACTIONS(299),
    [anon_sym_LT_LT_DASH] = ACTIONS(1918),
    [anon_sym_BQUOTE] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1918),
    [anon_sym_RPAREN] = ACTIONS(1918),
    [sym_file_descriptor] = ACTIONS(1920),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_EQ_EQ] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1918),
    [anon_sym_LT_LT_LT] = ACTIONS(1918),
    [anon_sym_GT_AMP] = ACTIONS(1918),
    [anon_sym_LT_LPAREN] = ACTIONS(1918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE_AMP] = ACTIONS(1918),
  },
  [547] = {
    [sym_command_substitution] = STATE(225),
    [aux_sym__literal_repeat1] = STATE(227),
    [sym_string] = STATE(225),
    [sym_process_substitution] = STATE(225),
    [sym_simple_expansion] = STATE(225),
    [sym_string_expansion] = STATE(225),
    [aux_sym_command_repeat2] = STATE(547),
    [sym_concatenation] = STATE(547),
    [sym_expansion] = STATE(225),
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(1922),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_LPAREN] = ACTIONS(1925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1931),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [sym_word] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [anon_sym_EQ_TILDE] = ACTIONS(1988),
    [sym__special_character] = ACTIONS(1991),
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(1943),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [sym_raw_string] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1914),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1914),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [anon_sym_LT_LPAREN] = ACTIONS(1925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [548] = {
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_AMP_GT_GT] = ACTIONS(1290),
    [sym_raw_string] = ACTIONS(1290),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [sym_file_descriptor] = ACTIONS(1290),
    [sym_variable_name] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1290),
    [anon_sym_AMP_GT] = ACTIONS(1288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1290),
    [anon_sym_GT_LPAREN] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_DQUOTE] = ACTIONS(1290),
    [sym_word] = ACTIONS(1290),
    [anon_sym_GT_AMP] = ACTIONS(1290),
    [sym__concat] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_LT_AMP] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1290),
    [anon_sym_LT_LPAREN] = ACTIONS(1290),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1290),
  },
  [549] = {
    [anon_sym_BQUOTE] = ACTIONS(1641),
    [anon_sym_AMP_GT_GT] = ACTIONS(1641),
    [sym_raw_string] = ACTIONS(1641),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [sym_file_descriptor] = ACTIONS(1641),
    [sym_variable_name] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1641),
    [anon_sym_AMP_GT] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1641),
    [anon_sym_GT_LPAREN] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DQUOTE] = ACTIONS(1641),
    [sym_word] = ACTIONS(1641),
    [anon_sym_GT_AMP] = ACTIONS(1641),
    [sym__concat] = ACTIONS(1641),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_LT_AMP] = ACTIONS(1641),
    [anon_sym_GT_GT] = ACTIONS(1641),
    [anon_sym_LT_LPAREN] = ACTIONS(1641),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1641),
  },
  [550] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [551] = {
    [anon_sym_BQUOTE] = ACTIONS(1392),
    [anon_sym_AMP_GT_GT] = ACTIONS(1392),
    [sym_raw_string] = ACTIONS(1392),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [sym_variable_name] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1392),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1392),
    [anon_sym_GT_LPAREN] = ACTIONS(1392),
    [anon_sym_RPAREN] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_word] = ACTIONS(1392),
    [anon_sym_GT_AMP] = ACTIONS(1392),
    [sym__concat] = ACTIONS(1392),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1392),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1392),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1392),
  },
  [552] = {
    [sym_command_substitution] = STATE(551),
    [sym_simple_expansion] = STATE(551),
    [sym_string_expansion] = STATE(551),
    [sym_string] = STATE(551),
    [sym_process_substitution] = STATE(551),
    [sym_expansion] = STATE(551),
    [anon_sym_BQUOTE] = ACTIONS(75),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [sym_word] = ACTIONS(1076),
    [sym_raw_string] = ACTIONS(1076),
    [anon_sym_LT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(1996),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(81),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(85),
    [sym__special_character] = ACTIONS(1076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(89),
  },
  [553] = {
    [aux_sym_concatenation_repeat1] = STATE(553),
    [anon_sym_BQUOTE] = ACTIONS(1392),
    [anon_sym_AMP_GT_GT] = ACTIONS(1392),
    [sym_raw_string] = ACTIONS(1392),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [sym_variable_name] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1392),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1392),
    [anon_sym_GT_LPAREN] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_word] = ACTIONS(1392),
    [anon_sym_GT_AMP] = ACTIONS(1392),
    [sym__concat] = ACTIONS(1998),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1392),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1392),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1392),
  },
  [554] = {
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [anon_sym_AMP_GT_GT] = ACTIONS(1284),
    [sym_raw_string] = ACTIONS(1284),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [sym_file_descriptor] = ACTIONS(1284),
    [sym_variable_name] = ACTIONS(1284),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1284),
    [anon_sym_AMP_GT] = ACTIONS(1282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1284),
    [anon_sym_GT_LPAREN] = ACTIONS(1284),
    [anon_sym_RPAREN] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [sym_word] = ACTIONS(1284),
    [anon_sym_GT_AMP] = ACTIONS(1284),
    [sym__concat] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_LT_AMP] = ACTIONS(1284),
    [anon_sym_GT_GT] = ACTIONS(1284),
    [anon_sym_LT_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1284),
  },
  [555] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(907),
    [sym_concatenation] = STATE(907),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2001),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2003),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2005),
    [anon_sym_COLON_DASH] = ACTIONS(2001),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2007),
  },
  [556] = {
    [anon_sym_BQUOTE] = ACTIONS(1326),
    [anon_sym_AMP_GT_GT] = ACTIONS(1326),
    [sym_raw_string] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [sym_file_descriptor] = ACTIONS(1326),
    [sym_variable_name] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1326),
    [anon_sym_AMP_GT] = ACTIONS(1324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1326),
    [anon_sym_GT_LPAREN] = ACTIONS(1326),
    [anon_sym_RPAREN] = ACTIONS(1326),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [sym_word] = ACTIONS(1326),
    [anon_sym_GT_AMP] = ACTIONS(1326),
    [sym__concat] = ACTIONS(1326),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_LT_AMP] = ACTIONS(1326),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_LT_LPAREN] = ACTIONS(1326),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1326),
  },
  [557] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2003),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [558] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(907),
    [sym_concatenation] = STATE(907),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2009),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2001),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2003),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(2001),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2005),
    [anon_sym_COLON_DASH] = ACTIONS(2001),
    [sym__special_character] = ACTIONS(553),
  },
  [559] = {
    [anon_sym_EQ] = ACTIONS(2011),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [560] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(912),
    [sym_concatenation] = STATE(912),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2015),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2015),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2015),
    [anon_sym_PERCENT] = ACTIONS(2015),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2019),
    [anon_sym_COLON_DASH] = ACTIONS(2015),
    [sym__special_character] = ACTIONS(553),
  },
  [561] = {
    [sym_command_substitution] = STATE(913),
    [aux_sym__literal_repeat1] = STATE(914),
    [sym_string] = STATE(913),
    [sym_process_substitution] = STATE(913),
    [sym_simple_expansion] = STATE(913),
    [sym_string_expansion] = STATE(913),
    [sym_concatenation] = STATE(915),
    [sym_expansion] = STATE(913),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2021),
    [sym_raw_string] = ACTIONS(2021),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2003),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [562] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(918),
    [sym_concatenation] = STATE(918),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2023),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2025),
    [anon_sym_DASH] = ACTIONS(2023),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2023),
    [anon_sym_PERCENT] = ACTIONS(2023),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2027),
    [anon_sym_COLON_DASH] = ACTIONS(2023),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2029),
  },
  [563] = {
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [sym_raw_string] = ACTIONS(1382),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1382),
    [sym_variable_name] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1382),
    [anon_sym_GT_LPAREN] = ACTIONS(1382),
    [anon_sym_RPAREN] = ACTIONS(1382),
    [anon_sym_DQUOTE] = ACTIONS(1382),
    [sym_word] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [sym__concat] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(1382),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1382),
  },
  [564] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2025),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [565] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1288),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE_PIPE] = ACTIONS(1288),
    [sym_word] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_LT_AMP] = ACTIONS(1288),
    [anon_sym_GT_GT] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [sym__special_character] = ACTIONS(1288),
    [anon_sym_LT_LT_DASH] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LF] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1288),
    [sym_raw_string] = ACTIONS(1288),
    [sym_variable_name] = ACTIONS(1290),
    [sym_file_descriptor] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_AMP_GT] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_LT_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_AMP] = ACTIONS(1288),
    [ts_builtin_sym_end] = ACTIONS(1290),
    [anon_sym_LT_LPAREN] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
    [anon_sym_PIPE_AMP] = ACTIONS(1288),
  },
  [566] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1639),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1639),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [sym_word] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_LT_AMP] = ACTIONS(1639),
    [anon_sym_GT_GT] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [sym__special_character] = ACTIONS(1639),
    [anon_sym_LT_LT_DASH] = ACTIONS(1639),
    [anon_sym_BQUOTE] = ACTIONS(1639),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1639),
    [sym_raw_string] = ACTIONS(1639),
    [sym_variable_name] = ACTIONS(1641),
    [sym_file_descriptor] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_AMP_GT] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_LT_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_AMP] = ACTIONS(1639),
    [ts_builtin_sym_end] = ACTIONS(1641),
    [anon_sym_LT_LPAREN] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [anon_sym_PIPE_AMP] = ACTIONS(1639),
  },
  [567] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(2031),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [568] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [ts_builtin_sym_end] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [569] = {
    [sym_command_substitution] = STATE(568),
    [sym_simple_expansion] = STATE(568),
    [sym_string_expansion] = STATE(568),
    [sym_string] = STATE(568),
    [sym_process_substitution] = STATE(568),
    [sym_expansion] = STATE(568),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [anon_sym_DQUOTE] = ACTIONS(431),
    [sym_word] = ACTIONS(1119),
    [sym_raw_string] = ACTIONS(1119),
    [anon_sym_LT_LPAREN] = ACTIONS(1121),
    [anon_sym_DOLLAR] = ACTIONS(2033),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [sym__special_character] = ACTIONS(1119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
  },
  [570] = {
    [aux_sym_concatenation_repeat1] = STATE(570),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(2035),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [ts_builtin_sym_end] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [571] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1282),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [sym_word] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_LT_AMP] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [sym__special_character] = ACTIONS(1282),
    [anon_sym_LT_LT_DASH] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_LF] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [sym_raw_string] = ACTIONS(1282),
    [sym_variable_name] = ACTIONS(1284),
    [sym_file_descriptor] = ACTIONS(1284),
    [anon_sym_RPAREN] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_AMP_GT] = ACTIONS(1282),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_LT_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_AMP] = ACTIONS(1282),
    [ts_builtin_sym_end] = ACTIONS(1284),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
    [anon_sym_PIPE_AMP] = ACTIONS(1282),
  },
  [572] = {
    [sym_command_substitution] = STATE(753),
    [aux_sym__literal_repeat1] = STATE(760),
    [sym_string] = STATE(753),
    [sym_process_substitution] = STATE(753),
    [aux_sym_for_statement_repeat1] = STATE(922),
    [sym_simple_expansion] = STATE(753),
    [sym_string_expansion] = STATE(753),
    [sym_concatenation] = STATE(922),
    [sym_expansion] = STATE(753),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(1571),
    [sym_raw_string] = ACTIONS(1571),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(2038),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [573] = {
    [aux_sym_concatenation_repeat1] = STATE(252),
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__concat] = ACTIONS(425),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [ts_builtin_sym_end] = ACTIONS(1593),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [574] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_RPAREN] = ACTIONS(1589),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [ts_builtin_sym_end] = ACTIONS(1593),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [575] = {
    [aux_sym__literal_repeat1] = STATE(265),
    [anon_sym_AMP_GT_GT] = ACTIONS(1613),
    [anon_sym_DOLLAR] = ACTIONS(1613),
    [anon_sym_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1613),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1613),
    [anon_sym_PIPE_PIPE] = ACTIONS(1613),
    [sym_word] = ACTIONS(1613),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_LT_AMP] = ACTIONS(1613),
    [anon_sym_GT_GT] = ACTIONS(1613),
    [sym__special_character] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1613),
    [anon_sym_LF] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1613),
    [sym_raw_string] = ACTIONS(1613),
    [sym_variable_name] = ACTIONS(1617),
    [sym_file_descriptor] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1613),
    [anon_sym_AMP_GT] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_LT_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_AMP] = ACTIONS(1613),
    [ts_builtin_sym_end] = ACTIONS(1617),
    [anon_sym_LT_LPAREN] = ACTIONS(1613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1613),
    [anon_sym_SEMI_SEMI] = ACTIONS(1613),
    [anon_sym_PIPE_AMP] = ACTIONS(1613),
  },
  [576] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(925),
    [sym_concatenation] = STATE(925),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2040),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2040),
    [anon_sym_PERCENT] = ACTIONS(2040),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2044),
    [anon_sym_COLON_DASH] = ACTIONS(2040),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2046),
  },
  [577] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1324),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [sym_word] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_LT_AMP] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [sym__special_character] = ACTIONS(1324),
    [anon_sym_LT_LT_DASH] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [anon_sym_LF] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_raw_string] = ACTIONS(1324),
    [sym_variable_name] = ACTIONS(1326),
    [sym_file_descriptor] = ACTIONS(1326),
    [anon_sym_RPAREN] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_AMP_GT] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_LT_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_AMP] = ACTIONS(1324),
    [ts_builtin_sym_end] = ACTIONS(1326),
    [anon_sym_LT_LPAREN] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
    [anon_sym_PIPE_AMP] = ACTIONS(1324),
  },
  [578] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [579] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(925),
    [sym_concatenation] = STATE(925),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2048),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2040),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2040),
    [anon_sym_PERCENT] = ACTIONS(2040),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2044),
    [anon_sym_COLON_DASH] = ACTIONS(2040),
    [sym__special_character] = ACTIONS(553),
  },
  [580] = {
    [anon_sym_EQ] = ACTIONS(2050),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [581] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(930),
    [sym_concatenation] = STATE(930),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2052),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2054),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2054),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2054),
    [anon_sym_PERCENT] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2058),
    [anon_sym_COLON_DASH] = ACTIONS(2054),
    [sym__special_character] = ACTIONS(553),
  },
  [582] = {
    [sym_command_substitution] = STATE(931),
    [aux_sym__literal_repeat1] = STATE(932),
    [sym_string] = STATE(931),
    [sym_process_substitution] = STATE(931),
    [sym_simple_expansion] = STATE(931),
    [sym_string_expansion] = STATE(931),
    [sym_concatenation] = STATE(933),
    [sym_expansion] = STATE(931),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2060),
    [sym_raw_string] = ACTIONS(2060),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [583] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(936),
    [sym_concatenation] = STATE(936),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2062),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2064),
    [anon_sym_DASH] = ACTIONS(2062),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2062),
    [anon_sym_PERCENT] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2066),
    [anon_sym_COLON_DASH] = ACTIONS(2062),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2068),
  },
  [584] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym_word] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [sym_variable_name] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [ts_builtin_sym_end] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
  },
  [585] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2064),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [586] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1288),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE_PIPE] = ACTIONS(1288),
    [sym_word] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_LT_AMP] = ACTIONS(1288),
    [anon_sym_GT_GT] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [sym__special_character] = ACTIONS(1288),
    [anon_sym_LT_LT_DASH] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LF] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1288),
    [sym_raw_string] = ACTIONS(1288),
    [sym_file_descriptor] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_AMP_GT] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_LT_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_AMP] = ACTIONS(1288),
    [ts_builtin_sym_end] = ACTIONS(1290),
    [anon_sym_LT_LPAREN] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
    [anon_sym_PIPE_AMP] = ACTIONS(1288),
  },
  [587] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1639),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1639),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [sym_word] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_LT_AMP] = ACTIONS(1639),
    [anon_sym_GT_GT] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [sym__special_character] = ACTIONS(1639),
    [anon_sym_LT_LT_DASH] = ACTIONS(1639),
    [anon_sym_BQUOTE] = ACTIONS(1639),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1639),
    [sym_raw_string] = ACTIONS(1639),
    [sym_file_descriptor] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_AMP_GT] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_LT_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_AMP] = ACTIONS(1639),
    [ts_builtin_sym_end] = ACTIONS(1641),
    [anon_sym_LT_LPAREN] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [anon_sym_PIPE_AMP] = ACTIONS(1639),
  },
  [588] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(2070),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [589] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [ts_builtin_sym_end] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [590] = {
    [sym_command_substitution] = STATE(589),
    [sym_simple_expansion] = STATE(589),
    [sym_string_expansion] = STATE(589),
    [sym_string] = STATE(589),
    [sym_process_substitution] = STATE(589),
    [sym_expansion] = STATE(589),
    [anon_sym_BQUOTE] = ACTIONS(1208),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [sym_word] = ACTIONS(1210),
    [sym_raw_string] = ACTIONS(1210),
    [anon_sym_LT_LPAREN] = ACTIONS(1212),
    [anon_sym_DOLLAR] = ACTIONS(2072),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1214),
    [sym__special_character] = ACTIONS(1210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1216),
  },
  [591] = {
    [aux_sym_concatenation_repeat1] = STATE(591),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(2074),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [ts_builtin_sym_end] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [592] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1282),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [sym_word] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_LT_AMP] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [sym__special_character] = ACTIONS(1282),
    [anon_sym_LT_LT_DASH] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_LF] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [sym_raw_string] = ACTIONS(1282),
    [sym_file_descriptor] = ACTIONS(1284),
    [anon_sym_RPAREN] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_AMP_GT] = ACTIONS(1282),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_LT_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_AMP] = ACTIONS(1282),
    [ts_builtin_sym_end] = ACTIONS(1284),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
    [anon_sym_PIPE_AMP] = ACTIONS(1282),
  },
  [593] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(941),
    [sym_concatenation] = STATE(941),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2077),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2077),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2077),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2081),
    [anon_sym_COLON_DASH] = ACTIONS(2077),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2083),
  },
  [594] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1324),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [sym_word] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_LT_AMP] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [sym__special_character] = ACTIONS(1324),
    [anon_sym_LT_LT_DASH] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [anon_sym_LF] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_raw_string] = ACTIONS(1324),
    [sym_file_descriptor] = ACTIONS(1326),
    [anon_sym_RPAREN] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_AMP_GT] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_LT_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_AMP] = ACTIONS(1324),
    [ts_builtin_sym_end] = ACTIONS(1326),
    [anon_sym_LT_LPAREN] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
    [anon_sym_PIPE_AMP] = ACTIONS(1324),
  },
  [595] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [596] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(941),
    [sym_concatenation] = STATE(941),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2085),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2077),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2079),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2077),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2077),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2081),
    [anon_sym_COLON_DASH] = ACTIONS(2077),
    [sym__special_character] = ACTIONS(553),
  },
  [597] = {
    [anon_sym_EQ] = ACTIONS(2087),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [598] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(946),
    [sym_concatenation] = STATE(946),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2089),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2091),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2091),
    [anon_sym_PERCENT] = ACTIONS(2091),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2095),
    [anon_sym_COLON_DASH] = ACTIONS(2091),
    [sym__special_character] = ACTIONS(553),
  },
  [599] = {
    [sym_command_substitution] = STATE(947),
    [aux_sym__literal_repeat1] = STATE(948),
    [sym_string] = STATE(947),
    [sym_process_substitution] = STATE(947),
    [sym_simple_expansion] = STATE(947),
    [sym_string_expansion] = STATE(947),
    [sym_concatenation] = STATE(949),
    [sym_expansion] = STATE(947),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2097),
    [sym_raw_string] = ACTIONS(2097),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2079),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [600] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(952),
    [sym_concatenation] = STATE(952),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2099),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2099),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2099),
    [anon_sym_PERCENT] = ACTIONS(2099),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2103),
    [anon_sym_COLON_DASH] = ACTIONS(2099),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2105),
  },
  [601] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym_word] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [ts_builtin_sym_end] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
  },
  [602] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [603] = {
    [aux_sym_concatenation_repeat1] = STATE(953),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_AMP_GT_GT] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_RPAREN] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [sym_variable_name] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [anon_sym_GT_AMP] = ACTIONS(585),
    [sym__concat] = ACTIONS(1078),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(585),
    [anon_sym_GT_GT] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(585),
  },
  [604] = {
    [aux_sym__literal_repeat1] = STATE(604),
    [anon_sym_BQUOTE] = ACTIONS(888),
    [anon_sym_AMP_GT_GT] = ACTIONS(888),
    [sym_raw_string] = ACTIONS(888),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(888),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(888),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(888),
    [anon_sym_GT_LPAREN] = ACTIONS(888),
    [sym_variable_name] = ACTIONS(888),
    [anon_sym_DQUOTE] = ACTIONS(888),
    [sym_word] = ACTIONS(888),
    [anon_sym_GT_AMP] = ACTIONS(888),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(888),
    [anon_sym_GT_GT] = ACTIONS(888),
    [anon_sym_LT_LPAREN] = ACTIONS(888),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1108),
  },
  [605] = {
    [aux_sym_concatenation_repeat1] = STATE(603),
    [anon_sym_BQUOTE] = ACTIONS(1631),
    [anon_sym_AMP_GT_GT] = ACTIONS(1631),
    [sym_raw_string] = ACTIONS(1631),
    [anon_sym_DOLLAR] = ACTIONS(1633),
    [anon_sym_RPAREN] = ACTIONS(1631),
    [sym_file_descriptor] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1631),
    [anon_sym_AMP_GT] = ACTIONS(1633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1631),
    [anon_sym_GT_LPAREN] = ACTIONS(1631),
    [sym_variable_name] = ACTIONS(1631),
    [anon_sym_DQUOTE] = ACTIONS(1631),
    [sym_word] = ACTIONS(1631),
    [anon_sym_GT_AMP] = ACTIONS(1631),
    [sym__concat] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_LT_AMP] = ACTIONS(1631),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_LT_LPAREN] = ACTIONS(1631),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1631),
  },
  [606] = {
    [aux_sym__literal_repeat1] = STATE(604),
    [anon_sym_BQUOTE] = ACTIONS(1635),
    [anon_sym_AMP_GT_GT] = ACTIONS(1635),
    [sym_raw_string] = ACTIONS(1635),
    [anon_sym_DOLLAR] = ACTIONS(1637),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1635),
    [anon_sym_AMP_GT] = ACTIONS(1637),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1635),
    [anon_sym_GT_LPAREN] = ACTIONS(1635),
    [sym_variable_name] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [sym_word] = ACTIONS(1635),
    [anon_sym_GT_AMP] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_LT_AMP] = ACTIONS(1635),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_LT_LPAREN] = ACTIONS(1635),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(417),
  },
  [607] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2107),
  },
  [608] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [sym_word] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_LT_AMP] = ACTIONS(2109),
    [anon_sym_GT_GT] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [anon_sym_EQ_TILDE] = ACTIONS(2109),
    [sym__special_character] = ACTIONS(2109),
    [anon_sym_LT_LT_DASH] = ACTIONS(2109),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [anon_sym_LF] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [sym_raw_string] = ACTIONS(2109),
    [sym_file_descriptor] = ACTIONS(2111),
    [anon_sym_RPAREN] = ACTIONS(2109),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_AMP_GT] = ACTIONS(2109),
    [anon_sym_EQ_EQ] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [anon_sym_LT_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_AMP] = ACTIONS(2109),
    [ts_builtin_sym_end] = ACTIONS(2111),
    [anon_sym_LT_LPAREN] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
    [anon_sym_PIPE_AMP] = ACTIONS(2109),
  },
  [609] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(956),
    [sym_concatenation] = STATE(956),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2113),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2113),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2113),
    [anon_sym_PERCENT] = ACTIONS(2113),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2117),
    [anon_sym_COLON_DASH] = ACTIONS(2113),
    [sym__special_character] = ACTIONS(553),
  },
  [610] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [611] = {
    [sym_command_substitution] = STATE(957),
    [sym_simple_expansion] = STATE(957),
    [sym_string_expansion] = STATE(957),
    [sym_string] = STATE(957),
    [sym_process_substitution] = STATE(957),
    [sym_expansion] = STATE(957),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(2119),
    [sym_raw_string] = ACTIONS(2119),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [sym__special_character] = ACTIONS(2119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
  },
  [612] = {
    [aux_sym_concatenation_repeat1] = STATE(959),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [anon_sym_COLON_QMARK] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
    [anon_sym_PERCENT] = ACTIONS(581),
    [anon_sym_COLON] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [sym_word] = ACTIONS(581),
    [sym__concat] = ACTIONS(2121),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(585),
    [anon_sym_COLON_DASH] = ACTIONS(581),
    [sym__special_character] = ACTIONS(581),
  },
  [613] = {
    [anon_sym_BQUOTE] = ACTIONS(507),
    [sym_raw_string] = ACTIONS(507),
    [anon_sym_COLON_QMARK] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_RBRACE] = ACTIONS(507),
    [anon_sym_DASH] = ACTIONS(505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(507),
    [anon_sym_EQ] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(507),
    [anon_sym_PERCENT] = ACTIONS(505),
    [anon_sym_COLON] = ACTIONS(505),
    [anon_sym_GT_LPAREN] = ACTIONS(507),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [sym_word] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [anon_sym_LT_LPAREN] = ACTIONS(507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(507),
    [anon_sym_COLON_DASH] = ACTIONS(505),
    [sym__special_character] = ACTIONS(505),
  },
  [614] = {
    [anon_sym_BQUOTE] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(511),
    [anon_sym_COLON_QMARK] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_RBRACE] = ACTIONS(511),
    [anon_sym_DASH] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(511),
    [anon_sym_EQ] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(511),
    [anon_sym_PERCENT] = ACTIONS(509),
    [anon_sym_COLON] = ACTIONS(509),
    [anon_sym_GT_LPAREN] = ACTIONS(511),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_word] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [anon_sym_LT_LPAREN] = ACTIONS(511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(511),
    [anon_sym_COLON_DASH] = ACTIONS(509),
    [sym__special_character] = ACTIONS(509),
  },
  [615] = {
    [anon_sym_BQUOTE] = ACTIONS(515),
    [sym_raw_string] = ACTIONS(515),
    [anon_sym_COLON_QMARK] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_PERCENT] = ACTIONS(513),
    [anon_sym_COLON] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(515),
    [sym_word] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [anon_sym_LT_LPAREN] = ACTIONS(515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(515),
    [anon_sym_COLON_DASH] = ACTIONS(513),
    [sym__special_character] = ACTIONS(513),
  },
  [616] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2123),
  },
  [617] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(2107),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [618] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2107),
  },
  [619] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(963),
    [sym_concatenation] = STATE(963),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2125),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2127),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2127),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2127),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2131),
    [anon_sym_COLON_DASH] = ACTIONS(2127),
    [sym__special_character] = ACTIONS(553),
  },
  [620] = {
    [sym_subscript] = STATE(964),
    [anon_sym_STAR] = ACTIONS(2133),
    [anon_sym_QMARK] = ACTIONS(2133),
    [anon_sym_AT] = ACTIONS(2133),
    [sym_variable_name] = ACTIONS(2135),
    [anon_sym_DOLLAR] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2137),
    [anon_sym_0] = ACTIONS(2139),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2139),
    [anon_sym__] = ACTIONS(2139),
  },
  [621] = {
    [anon_sym_EQ] = ACTIONS(2141),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [622] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(970),
    [sym_concatenation] = STATE(970),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2143),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2145),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2145),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2149),
    [anon_sym_COLON_DASH] = ACTIONS(2145),
    [sym__special_character] = ACTIONS(553),
  },
  [623] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(2151),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [624] = {
    [anon_sym_BQUOTE] = ACTIONS(789),
    [sym_raw_string] = ACTIONS(789),
    [anon_sym_COLON_QMARK] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(789),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(789),
    [anon_sym_PERCENT] = ACTIONS(787),
    [anon_sym_COLON] = ACTIONS(787),
    [anon_sym_GT_LPAREN] = ACTIONS(789),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [sym_word] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [anon_sym_LT_LPAREN] = ACTIONS(789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(789),
    [anon_sym_COLON_DASH] = ACTIONS(787),
    [sym__special_character] = ACTIONS(787),
  },
  [625] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(2153),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(2151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [626] = {
    [anon_sym_BQUOTE] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(189),
    [anon_sym_COLON_QMARK] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(189),
    [anon_sym_PERCENT] = ACTIONS(187),
    [anon_sym_COLON] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [sym_word] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(189),
    [anon_sym_COLON_DASH] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
  },
  [627] = {
    [aux_sym__literal_repeat1] = STATE(627),
    [anon_sym_BQUOTE] = ACTIONS(888),
    [sym_raw_string] = ACTIONS(888),
    [anon_sym_COLON_QMARK] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_RBRACE] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(888),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(888),
    [anon_sym_PERCENT] = ACTIONS(883),
    [anon_sym_COLON] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(888),
    [anon_sym_DQUOTE] = ACTIONS(888),
    [sym_word] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(888),
    [anon_sym_COLON_DASH] = ACTIONS(883),
    [sym__special_character] = ACTIONS(2155),
  },
  [628] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(2158),
    [sym_raw_string] = ACTIONS(2161),
    [anon_sym_COLON_QMARK] = ACTIONS(2164),
    [anon_sym_DOLLAR] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_DASH] = ACTIONS(2164),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2172),
    [anon_sym_EQ] = ACTIONS(2164),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2175),
    [anon_sym_PERCENT] = ACTIONS(2164),
    [anon_sym_COLON] = ACTIONS(2164),
    [anon_sym_GT_LPAREN] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2181),
    [sym_word] = ACTIONS(2184),
    [anon_sym_LT_LPAREN] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2187),
    [anon_sym_COLON_DASH] = ACTIONS(2164),
    [sym__special_character] = ACTIONS(2190),
  },
  [629] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(956),
    [sym_concatenation] = STATE(956),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2113),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2113),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2113),
    [anon_sym_PERCENT] = ACTIONS(2113),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2117),
    [anon_sym_COLON_DASH] = ACTIONS(2113),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2193),
  },
  [630] = {
    [sym_command_substitution] = STATE(974),
    [aux_sym__literal_repeat1] = STATE(975),
    [sym_string] = STATE(974),
    [sym_process_substitution] = STATE(974),
    [sym_simple_expansion] = STATE(974),
    [sym_string_expansion] = STATE(974),
    [sym_concatenation] = STATE(976),
    [sym_expansion] = STATE(974),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2195),
    [sym_raw_string] = ACTIONS(2195),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [631] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(979),
    [sym_concatenation] = STATE(979),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2197),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2201),
    [anon_sym_COLON_DASH] = ACTIONS(2197),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2203),
  },
  [632] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [anon_sym_EQ_TILDE] = ACTIONS(2205),
    [sym__special_character] = ACTIONS(2205),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [sym_file_descriptor] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [ts_builtin_sym_end] = ACTIONS(2207),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
  },
  [633] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [634] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(980),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [635] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(983),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(2209),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [636] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [sym__concat] = ACTIONS(2213),
  },
  [637] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(986),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [638] = {
    [sym_string] = STATE(988),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [anon_sym_STAR] = ACTIONS(2215),
    [anon_sym_QMARK] = ACTIONS(2215),
    [sym_raw_string] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2219),
    [anon_sym_AT] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(2219),
    [anon_sym_POUND] = ACTIONS(2219),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_0] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2221),
    [anon_sym__] = ACTIONS(2221),
  },
  [639] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(990),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(991),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [640] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(189),
    [sym__concat] = ACTIONS(2213),
    [sym__special_character] = ACTIONS(187),
  },
  [641] = {
    [sym_subscript] = STATE(992),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2223),
    [sym_variable_name] = ACTIONS(2227),
    [anon_sym_DOLLAR] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_0] = ACTIONS(2231),
    [anon_sym_POUND] = ACTIONS(2225),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2231),
    [anon_sym__] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
  },
  [642] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2235),
  },
  [643] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2115),
  },
  [644] = {
    [aux_sym_concatenation_repeat1] = STATE(782),
    [anon_sym_RBRACK] = ACTIONS(2237),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(2239),
  },
  [645] = {
    [aux_sym__literal_repeat1] = STATE(786),
    [anon_sym_RBRACK] = ACTIONS(2241),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(2243),
    [sym__special_character] = ACTIONS(1627),
  },
  [646] = {
    [anon_sym_RBRACK] = ACTIONS(2237),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(2245),
  },
  [647] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2247),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2247),
    [sym_word] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_LT_AMP] = ACTIONS(2247),
    [anon_sym_GT_GT] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [anon_sym_EQ_TILDE] = ACTIONS(2247),
    [sym__special_character] = ACTIONS(2247),
    [anon_sym_LT_LT_DASH] = ACTIONS(2247),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [sym_raw_string] = ACTIONS(2247),
    [sym_file_descriptor] = ACTIONS(2249),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_AMP_GT] = ACTIONS(2247),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_LT_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_AMP] = ACTIONS(2247),
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_LT_LPAREN] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
    [anon_sym_PIPE_AMP] = ACTIONS(2247),
  },
  [648] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1005),
    [sym_concatenation] = STATE(1005),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2251),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2253),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2251),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2251),
    [anon_sym_PERCENT] = ACTIONS(2251),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2255),
    [anon_sym_COLON_DASH] = ACTIONS(2251),
    [sym__special_character] = ACTIONS(553),
  },
  [649] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2253),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [650] = {
    [sym_compound_statement] = STATE(1006),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
  },
  [651] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2257),
    [anon_sym_BQUOTE] = ACTIONS(2257),
    [anon_sym_AMP_GT_GT] = ACTIONS(2257),
    [anon_sym_LF] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_LT_LT] = ACTIONS(2257),
    [sym_file_descriptor] = ACTIONS(2259),
    [anon_sym_GT] = ACTIONS(2257),
    [anon_sym_RPAREN] = ACTIONS(2257),
    [anon_sym_AMP_GT] = ACTIONS(2257),
    [anon_sym_PIPE_PIPE] = ACTIONS(2257),
    [ts_builtin_sym_end] = ACTIONS(2259),
    [anon_sym_LT_LT_LT] = ACTIONS(2257),
    [anon_sym_PIPE] = ACTIONS(2257),
    [anon_sym_GT_AMP] = ACTIONS(2257),
    [anon_sym_LT] = ACTIONS(2257),
    [anon_sym_LT_AMP] = ACTIONS(2257),
    [anon_sym_GT_GT] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(2257),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_SEMI_SEMI] = ACTIONS(2257),
    [anon_sym_PIPE_AMP] = ACTIONS(2257),
  },
  [652] = {
    [sym_string] = STATE(85),
    [anon_sym__] = ACTIONS(143),
    [anon_sym_AMP_GT_GT] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(2263),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(2263),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [sym_word] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_LT_AMP] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_EQ_TILDE] = ACTIONS(2261),
    [sym__special_character] = ACTIONS(2261),
    [anon_sym_LT_LT_DASH] = ACTIONS(2261),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(143),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(2267),
    [anon_sym_BANG] = ACTIONS(2263),
    [sym_file_descriptor] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(143),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_AMP_GT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_AMP] = ACTIONS(2261),
    [ts_builtin_sym_end] = ACTIONS(2265),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2263),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_PIPE_AMP] = ACTIONS(2261),
  },
  [653] = {
    [aux_sym_concatenation_repeat1] = STATE(1007),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(1127),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [654] = {
    [sym_command_substitution] = STATE(1008),
    [aux_sym__literal_repeat1] = STATE(1009),
    [sym_string] = STATE(1008),
    [sym_array] = STATE(574),
    [sym_process_substitution] = STATE(1008),
    [sym_simple_expansion] = STATE(1008),
    [sym_string_expansion] = STATE(1008),
    [sym_concatenation] = STATE(574),
    [sym_expansion] = STATE(1008),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [anon_sym_DQUOTE] = ACTIONS(431),
    [sym_word] = ACTIONS(2269),
    [sym_raw_string] = ACTIONS(2269),
    [anon_sym_LT_LPAREN] = ACTIONS(1121),
    [anon_sym_DOLLAR] = ACTIONS(93),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1123),
    [sym__special_character] = ACTIONS(2271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1125),
    [sym__empty_value] = ACTIONS(1137),
  },
  [655] = {
    [aux_sym__literal_repeat1] = STATE(655),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [aux_sym__simple_variable_name_token1] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(1165),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_variable_name] = ACTIONS(888),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [656] = {
    [sym_command_substitution] = STATE(318),
    [aux_sym__literal_repeat1] = STATE(321),
    [sym_string] = STATE(318),
    [aux_sym_declaration_command_repeat1] = STATE(656),
    [sym_process_substitution] = STATE(318),
    [sym_simple_expansion] = STATE(318),
    [sym_subscript] = STATE(323),
    [sym_string_expansion] = STATE(318),
    [sym_variable_assignment] = STATE(656),
    [sym_concatenation] = STATE(656),
    [sym_expansion] = STATE(318),
    [anon_sym_AMP_GT_GT] = ACTIONS(1168),
    [anon_sym_DOLLAR] = ACTIONS(1170),
    [anon_sym_LT_LT] = ACTIONS(1168),
    [anon_sym_GT_LPAREN] = ACTIONS(1173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1176),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1182),
    [anon_sym_PIPE_PIPE] = ACTIONS(1168),
    [sym_word] = ACTIONS(2276),
    [anon_sym_PIPE] = ACTIONS(1168),
    [anon_sym_AMP] = ACTIONS(1168),
    [anon_sym_LT] = ACTIONS(1168),
    [anon_sym_LT_AMP] = ACTIONS(1168),
    [anon_sym_GT_GT] = ACTIONS(1168),
    [sym__special_character] = ACTIONS(2279),
    [anon_sym_LT_LT_DASH] = ACTIONS(1168),
    [anon_sym_BQUOTE] = ACTIONS(1191),
    [anon_sym_LF] = ACTIONS(1194),
    [anon_sym_SEMI] = ACTIONS(1168),
    [sym_raw_string] = ACTIONS(2276),
    [sym_variable_name] = ACTIONS(2282),
    [sym_file_descriptor] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1168),
    [anon_sym_AMP_GT] = ACTIONS(1168),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_LT_LT_LT] = ACTIONS(1168),
    [anon_sym_GT_AMP] = ACTIONS(1168),
    [anon_sym_LT_LPAREN] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_SEMI_SEMI] = ACTIONS(1168),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
  },
  [657] = {
    [aux_sym_concatenation_repeat1] = STATE(1010),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(1218),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [658] = {
    [aux_sym__literal_repeat1] = STATE(658),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [aux_sym__simple_variable_name_token1] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(1248),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [659] = {
    [sym_command_substitution] = STATE(324),
    [aux_sym__literal_repeat1] = STATE(326),
    [sym_string] = STATE(324),
    [aux_sym_unset_command_repeat1] = STATE(659),
    [sym_process_substitution] = STATE(324),
    [sym_simple_expansion] = STATE(324),
    [sym_string_expansion] = STATE(324),
    [sym_concatenation] = STATE(659),
    [sym_expansion] = STATE(324),
    [anon_sym_AMP_GT_GT] = ACTIONS(1251),
    [anon_sym_DOLLAR] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_GT_LPAREN] = ACTIONS(1256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1259),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1251),
    [sym_word] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1251),
    [anon_sym_LT_AMP] = ACTIONS(1251),
    [anon_sym_GT_GT] = ACTIONS(1251),
    [sym__special_character] = ACTIONS(2291),
    [anon_sym_LT_LT_DASH] = ACTIONS(1251),
    [anon_sym_BQUOTE] = ACTIONS(1274),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1251),
    [sym_raw_string] = ACTIONS(2288),
    [sym_file_descriptor] = ACTIONS(1277),
    [anon_sym_GT] = ACTIONS(1251),
    [anon_sym_AMP_GT] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [anon_sym_LT_LT_LT] = ACTIONS(1251),
    [anon_sym_GT_AMP] = ACTIONS(1251),
    [anon_sym_LT_LPAREN] = ACTIONS(1256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1251),
    [anon_sym_SEMI_SEMI] = ACTIONS(1251),
    [anon_sym_PIPE_AMP] = ACTIONS(1251),
  },
  [660] = {
    [aux_sym_concatenation_repeat1] = STATE(660),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1396),
    [anon_sym_EQ_TILDE] = ACTIONS(1390),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [661] = {
    [aux_sym_concatenation_repeat1] = STATE(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__concat] = ACTIONS(1591),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [662] = {
    [aux_sym_concatenation_repeat1] = STATE(1011),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(1591),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [663] = {
    [aux_sym__literal_repeat1] = STATE(1012),
    [anon_sym_AMP_GT_GT] = ACTIONS(1613),
    [anon_sym_DOLLAR] = ACTIONS(1613),
    [anon_sym_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1613),
    [anon_sym_PIPE_PIPE] = ACTIONS(1613),
    [sym_word] = ACTIONS(1613),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_LT_AMP] = ACTIONS(1613),
    [anon_sym_GT_GT] = ACTIONS(1613),
    [sym__special_character] = ACTIONS(1615),
    [anon_sym_LT_LT_DASH] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1613),
    [anon_sym_LF] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1613),
    [sym_raw_string] = ACTIONS(1613),
    [sym_variable_name] = ACTIONS(1617),
    [sym_file_descriptor] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1613),
    [anon_sym_AMP_GT] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_LT_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_AMP] = ACTIONS(1613),
    [anon_sym_LT_LPAREN] = ACTIONS(1613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1613),
    [anon_sym_SEMI_SEMI] = ACTIONS(1613),
    [anon_sym_PIPE_AMP] = ACTIONS(1613),
  },
  [664] = {
    [aux_sym_concatenation_repeat1] = STATE(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(391),
    [anon_sym_AMP_GT_GT] = ACTIONS(391),
    [anon_sym_LF] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(391),
    [sym_file_descriptor] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_AMP_GT] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(391),
    [anon_sym_LT_LT_LT] = ACTIONS(391),
    [anon_sym_PIPE] = ACTIONS(391),
    [anon_sym_GT_AMP] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_LT_AMP] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(391),
    [anon_sym_SEMI_SEMI] = ACTIONS(391),
    [anon_sym_PIPE_AMP] = ACTIONS(391),
  },
  [665] = {
    [aux_sym_concatenation_repeat1] = STATE(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [666] = {
    [aux_sym__literal_repeat1] = STATE(1014),
    [anon_sym_LT_LT_DASH] = ACTIONS(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(415),
    [anon_sym_LF] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [sym_file_descriptor] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_AMP_GT] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_LT_LT_LT] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(415),
    [anon_sym_GT_AMP] = ACTIONS(415),
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_LT_AMP] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(415),
    [anon_sym_PIPE_AMP] = ACTIONS(415),
  },
  [667] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(2294),
    [anon_sym_SEMI] = ACTIONS(2296),
    [anon_sym_SEMI_SEMI] = ACTIONS(2296),
    [anon_sym_AMP] = ACTIONS(2296),
  },
  [668] = {
    [sym_command_substitution] = STATE(1016),
    [aux_sym__literal_repeat1] = STATE(1017),
    [sym_string] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_string_expansion] = STATE(1016),
    [sym_concatenation] = STATE(889),
    [sym_expansion] = STATE(1016),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(2298),
    [sym_raw_string] = ACTIONS(2298),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(1411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [669] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [sym_file_descriptor] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(607),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
  },
  [670] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
  },
  [671] = {
    [aux_sym_concatenation_repeat1] = STATE(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [anon_sym_PIPE] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
  },
  [672] = {
    [aux_sym__literal_repeat1] = STATE(1014),
    [anon_sym_LT_LT_DASH] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1888),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_LT_LT] = ACTIONS(1886),
    [sym_file_descriptor] = ACTIONS(1888),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_PIPE_PIPE] = ACTIONS(1886),
    [anon_sym_LT_LT_LT] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_GT_AMP] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_LT_AMP] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1886),
    [anon_sym_AMP] = ACTIONS(1886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1886),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1886),
    [anon_sym_PIPE_AMP] = ACTIONS(1886),
  },
  [673] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [sym_file_descriptor] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
  },
  [674] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
  },
  [675] = {
    [sym_heredoc_redirect] = STATE(675),
    [aux_sym_redirected_statement_repeat1] = STATE(675),
    [sym_herestring_redirect] = STATE(675),
    [sym_file_redirect] = STATE(675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_AMP_GT_GT] = ACTIONS(2300),
    [anon_sym_LF] = ACTIONS(1896),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_LT_LT] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(2303),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_AMP_GT] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(1898),
    [anon_sym_LT_LT_LT] = ACTIONS(2306),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_GT_AMP] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_AMP] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1898),
    [anon_sym_SEMI_SEMI] = ACTIONS(1898),
    [anon_sym_PIPE_AMP] = ACTIONS(1898),
  },
  [676] = {
    [sym_command_substitution] = STATE(342),
    [aux_sym__literal_repeat1] = STATE(344),
    [sym_string] = STATE(342),
    [sym_process_substitution] = STATE(342),
    [sym_simple_expansion] = STATE(342),
    [sym_string_expansion] = STATE(342),
    [aux_sym_command_repeat2] = STATE(679),
    [sym_concatenation] = STATE(679),
    [sym_expansion] = STATE(342),
    [anon_sym_AMP_GT_GT] = ACTIONS(1910),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1910),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1910),
    [sym_word] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1910),
    [anon_sym_AMP] = ACTIONS(1910),
    [anon_sym_LT] = ACTIONS(1910),
    [anon_sym_LT_AMP] = ACTIONS(1910),
    [anon_sym_GT_GT] = ACTIONS(1910),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_LT_LT_DASH] = ACTIONS(1910),
    [anon_sym_BQUOTE] = ACTIONS(343),
    [anon_sym_LF] = ACTIONS(1912),
    [anon_sym_SEMI] = ACTIONS(1910),
    [sym_raw_string] = ACTIONS(625),
    [sym_file_descriptor] = ACTIONS(1912),
    [anon_sym_GT] = ACTIONS(1910),
    [anon_sym_AMP_GT] = ACTIONS(1910),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(1910),
    [anon_sym_GT_AMP] = ACTIONS(1910),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1910),
    [anon_sym_SEMI_SEMI] = ACTIONS(1910),
    [anon_sym_PIPE_AMP] = ACTIONS(1910),
  },
  [677] = {
    [aux_sym_concatenation_repeat1] = STATE(328),
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(1914),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [sym_word] = ACTIONS(1914),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [sym__concat] = ACTIONS(167),
    [anon_sym_EQ_TILDE] = ACTIONS(1914),
    [sym__special_character] = ACTIONS(1914),
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [sym_raw_string] = ACTIONS(1914),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1914),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(1914),
    [anon_sym_DQUOTE] = ACTIONS(1914),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [anon_sym_LT_LPAREN] = ACTIONS(1914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [678] = {
    [aux_sym__literal_repeat1] = STATE(330),
    [anon_sym_AMP_GT_GT] = ACTIONS(1918),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [anon_sym_LT_LT] = ACTIONS(1918),
    [anon_sym_GT_LPAREN] = ACTIONS(1918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1918),
    [anon_sym_PIPE_PIPE] = ACTIONS(1918),
    [sym_word] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_LT_AMP] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1918),
    [anon_sym_EQ_TILDE] = ACTIONS(1918),
    [sym__special_character] = ACTIONS(299),
    [anon_sym_LT_LT_DASH] = ACTIONS(1918),
    [anon_sym_BQUOTE] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1918),
    [sym_file_descriptor] = ACTIONS(1920),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_EQ_EQ] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1918),
    [anon_sym_LT_LT_LT] = ACTIONS(1918),
    [anon_sym_GT_AMP] = ACTIONS(1918),
    [anon_sym_LT_LPAREN] = ACTIONS(1918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE_AMP] = ACTIONS(1918),
  },
  [679] = {
    [sym_command_substitution] = STATE(342),
    [aux_sym__literal_repeat1] = STATE(344),
    [sym_string] = STATE(342),
    [sym_process_substitution] = STATE(342),
    [sym_simple_expansion] = STATE(342),
    [sym_string_expansion] = STATE(342),
    [aux_sym_command_repeat2] = STATE(679),
    [sym_concatenation] = STATE(679),
    [sym_expansion] = STATE(342),
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(1922),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_LPAREN] = ACTIONS(1925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1931),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [sym_word] = ACTIONS(2309),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [anon_sym_EQ_TILDE] = ACTIONS(2312),
    [sym__special_character] = ACTIONS(2315),
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(1943),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [sym_raw_string] = ACTIONS(2309),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1914),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [anon_sym_LT_LPAREN] = ACTIONS(1925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [680] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1018),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_fi] = ACTIONS(2318),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [681] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2320),
    [anon_sym_BQUOTE] = ACTIONS(2320),
    [anon_sym_AMP_GT_GT] = ACTIONS(2320),
    [anon_sym_LF] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2320),
    [anon_sym_LT_LT] = ACTIONS(2320),
    [sym_file_descriptor] = ACTIONS(2322),
    [anon_sym_GT] = ACTIONS(2320),
    [anon_sym_RPAREN] = ACTIONS(2320),
    [anon_sym_AMP_GT] = ACTIONS(2320),
    [anon_sym_PIPE_PIPE] = ACTIONS(2320),
    [ts_builtin_sym_end] = ACTIONS(2322),
    [anon_sym_LT_LT_LT] = ACTIONS(2320),
    [anon_sym_PIPE] = ACTIONS(2320),
    [anon_sym_GT_AMP] = ACTIONS(2320),
    [anon_sym_LT] = ACTIONS(2320),
    [anon_sym_LT_AMP] = ACTIONS(2320),
    [anon_sym_GT_GT] = ACTIONS(2320),
    [anon_sym_AMP] = ACTIONS(2320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(2320),
    [anon_sym_AMP_AMP] = ACTIONS(2320),
    [anon_sym_SEMI_SEMI] = ACTIONS(2320),
    [anon_sym_PIPE_AMP] = ACTIONS(2320),
  },
  [682] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym__terminated_statement] = STATE(1019),
    [sym_if_statement] = STATE(116),
    [sym_function_definition] = STATE(116),
    [sym_negated_command] = STATE(116),
    [sym_test_command] = STATE(116),
    [sym_variable_assignment] = STATE(117),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [sym_redirected_statement] = STATE(116),
    [sym_for_statement] = STATE(116),
    [sym_compound_statement] = STATE(116),
    [sym_subshell] = STATE(116),
    [sym_declaration_command] = STATE(116),
    [sym_unset_command] = STATE(116),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(116),
    [sym_while_statement] = STATE(116),
    [sym_case_statement] = STATE(116),
    [sym_pipeline] = STATE(116),
    [sym_list] = STATE(116),
    [sym_command] = STATE(116),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [683] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1021),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_elif_clause] = STATE(1023),
    [sym_else_clause] = STATE(1022),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_if_statement_repeat1] = STATE(1023),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_else] = ACTIONS(1425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_fi] = ACTIONS(2324),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_elif] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [684] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(2326),
  },
  [685] = {
    [aux_sym_if_statement_repeat1] = STATE(1024),
    [sym_elif_clause] = STATE(1024),
    [sym_else_clause] = STATE(1022),
    [anon_sym_elif] = ACTIONS(2328),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(2326),
    [anon_sym_else] = ACTIONS(2330),
  },
  [686] = {
    [anon_sym_AMP] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1290),
    [anon_sym_LF] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym_in] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
  },
  [687] = {
    [anon_sym_AMP] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1641),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_in] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
  },
  [688] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [689] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2336),
    [anon_sym_SEMI_SEMI] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2336),
  },
  [690] = {
    [anon_sym_AMP] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1392),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_in] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
  },
  [691] = {
    [sym_command_substitution] = STATE(1027),
    [aux_sym__literal_repeat1] = STATE(1030),
    [sym_case_item] = STATE(1032),
    [sym_string] = STATE(1027),
    [sym_process_substitution] = STATE(1027),
    [sym_last_case_item] = STATE(1031),
    [sym_simple_expansion] = STATE(1027),
    [sym_string_expansion] = STATE(1027),
    [aux_sym_case_statement_repeat1] = STATE(1032),
    [sym_concatenation] = STATE(1033),
    [sym_expansion] = STATE(1027),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(2338),
    [sym_raw_string] = ACTIONS(2340),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_esac] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [692] = {
    [sym_command_substitution] = STATE(690),
    [sym_simple_expansion] = STATE(690),
    [sym_string_expansion] = STATE(690),
    [sym_string] = STATE(690),
    [sym_process_substitution] = STATE(690),
    [sym_expansion] = STATE(690),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(193),
    [sym_word] = ACTIONS(1441),
    [sym_raw_string] = ACTIONS(1441),
    [anon_sym_LT_LPAREN] = ACTIONS(197),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(201),
    [sym__special_character] = ACTIONS(1441),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(205),
  },
  [693] = {
    [aux_sym_concatenation_repeat1] = STATE(693),
    [anon_sym_AMP] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2348),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_in] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
  },
  [694] = {
    [anon_sym_AMP] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1284),
    [anon_sym_LF] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [anon_sym_in] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
  },
  [695] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1037),
    [sym_concatenation] = STATE(1037),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2351),
    [anon_sym_PERCENT] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2355),
    [anon_sym_COLON_DASH] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2357),
  },
  [696] = {
    [anon_sym_AMP] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1326),
    [anon_sym_LF] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym_in] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
  },
  [697] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [698] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1037),
    [sym_concatenation] = STATE(1037),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2359),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2351),
    [anon_sym_PERCENT] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2355),
    [anon_sym_COLON_DASH] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(553),
  },
  [699] = {
    [anon_sym_EQ] = ACTIONS(2361),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [700] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1042),
    [sym_concatenation] = STATE(1042),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2363),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2365),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2365),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2365),
    [anon_sym_PERCENT] = ACTIONS(2365),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2369),
    [anon_sym_COLON_DASH] = ACTIONS(2365),
    [sym__special_character] = ACTIONS(553),
  },
  [701] = {
    [sym_command_substitution] = STATE(1043),
    [aux_sym__literal_repeat1] = STATE(1044),
    [sym_string] = STATE(1043),
    [sym_process_substitution] = STATE(1043),
    [sym_simple_expansion] = STATE(1043),
    [sym_string_expansion] = STATE(1043),
    [sym_concatenation] = STATE(1045),
    [sym_expansion] = STATE(1043),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2371),
    [sym_raw_string] = ACTIONS(2371),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2353),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [702] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1048),
    [sym_concatenation] = STATE(1048),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2373),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2375),
    [anon_sym_DASH] = ACTIONS(2373),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2377),
    [anon_sym_COLON_DASH] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2379),
  },
  [703] = {
    [anon_sym_AMP] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1382),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_in] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
  },
  [704] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2375),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [705] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(2381),
    [anon_sym_SEMI] = ACTIONS(2383),
    [anon_sym_SEMI_SEMI] = ACTIONS(2383),
    [anon_sym_AMP] = ACTIONS(2383),
  },
  [706] = {
    [sym_command_substitution] = STATE(1027),
    [aux_sym__literal_repeat1] = STATE(1030),
    [sym_case_item] = STATE(1052),
    [sym_string] = STATE(1027),
    [sym_process_substitution] = STATE(1027),
    [sym_last_case_item] = STATE(1051),
    [sym_simple_expansion] = STATE(1027),
    [sym_string_expansion] = STATE(1027),
    [aux_sym_case_statement_repeat1] = STATE(1052),
    [sym_concatenation] = STATE(1033),
    [sym_expansion] = STATE(1027),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(2338),
    [sym_raw_string] = ACTIONS(2340),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_esac] = ACTIONS(2385),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [707] = {
    [anon_sym_BANG_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1488),
    [sym_test_operator] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_PIPE_PIPE] = ACTIONS(1488),
    [anon_sym_GT_EQ] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1492),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(1488),
    [anon_sym_AMP_AMP] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1488),
  },
  [708] = {
    [aux_sym_concatenation_repeat1] = STATE(1053),
    [anon_sym_BANG_EQ] = ACTIONS(585),
    [anon_sym_PLUS_EQ] = ACTIONS(585),
    [sym_test_operator] = ACTIONS(585),
    [anon_sym_PLUS_PLUS] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_GT_EQ] = ACTIONS(585),
    [sym__concat] = ACTIONS(1502),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(585),
    [anon_sym_DASH_DASH] = ACTIONS(585),
    [anon_sym_LT_EQ] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_DASH_EQ] = ACTIONS(585),
  },
  [709] = {
    [aux_sym__literal_repeat1] = STATE(709),
    [anon_sym_BANG_EQ] = ACTIONS(888),
    [anon_sym_PLUS_EQ] = ACTIONS(888),
    [sym_test_operator] = ACTIONS(888),
    [anon_sym_PLUS_PLUS] = ACTIONS(888),
    [anon_sym_RPAREN] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(888),
    [anon_sym_PIPE_PIPE] = ACTIONS(888),
    [anon_sym_GT_EQ] = ACTIONS(888),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(888),
    [anon_sym_DASH_DASH] = ACTIONS(888),
    [anon_sym_LT_EQ] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(888),
    [sym__special_character] = ACTIONS(1534),
    [anon_sym_DASH_EQ] = ACTIONS(888),
  },
  [710] = {
    [sym_command_substitution] = STATE(372),
    [sym_unary_expression] = STATE(730),
    [sym_postfix_expression] = STATE(730),
    [sym_string] = STATE(372),
    [aux_sym__literal_repeat1] = STATE(374),
    [sym_process_substitution] = STATE(372),
    [sym_parenthesized_expression] = STATE(730),
    [sym_simple_expansion] = STATE(372),
    [sym_string_expansion] = STATE(372),
    [sym__expression] = STATE(730),
    [sym_binary_expression] = STATE(730),
    [sym_concatenation] = STATE(730),
    [sym_expansion] = STATE(372),
    [sym_test_operator] = ACTIONS(673),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(675),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_BANG] = ACTIONS(679),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [711] = {
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_PLUS_EQ] = ACTIONS(2387),
    [sym_test_operator] = ACTIONS(2387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2387),
    [anon_sym_RPAREN] = ACTIONS(2389),
    [anon_sym_DASH] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_EQ] = ACTIONS(2389),
    [anon_sym_EQ_EQ] = ACTIONS(2387),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2387),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2389),
    [anon_sym_LT] = ACTIONS(2389),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [anon_sym_DASH_DASH] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2387),
    [anon_sym_AMP_AMP] = ACTIONS(2387),
    [anon_sym_DASH_EQ] = ACTIONS(2387),
  },
  [712] = {
    [sym_command_substitution] = STATE(372),
    [sym_unary_expression] = STATE(730),
    [sym_postfix_expression] = STATE(730),
    [sym_string] = STATE(372),
    [aux_sym__literal_repeat1] = STATE(374),
    [sym_process_substitution] = STATE(372),
    [sym_parenthesized_expression] = STATE(730),
    [sym_simple_expansion] = STATE(372),
    [sym_string_expansion] = STATE(372),
    [sym__expression] = STATE(730),
    [sym_binary_expression] = STATE(730),
    [sym_concatenation] = STATE(730),
    [sym_expansion] = STATE(372),
    [sym_test_operator] = ACTIONS(673),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [sym_raw_string] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(679),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(675),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(681),
    [sym_regex] = ACTIONS(1541),
  },
  [713] = {
    [anon_sym_BANG_EQ] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [sym_test_operator] = ACTIONS(1641),
    [anon_sym_PLUS_PLUS] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_DASH] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_EQ] = ACTIONS(1639),
    [anon_sym_EQ_EQ] = ACTIONS(1641),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(1641),
    [anon_sym_GT_EQ] = ACTIONS(1641),
    [sym__concat] = ACTIONS(1641),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1641),
    [anon_sym_PLUS] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1639),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1641),
    [anon_sym_DASH_DASH] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
  },
  [714] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(2391),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [715] = {
    [anon_sym_BANG_EQ] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1392),
    [sym_test_operator] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1392),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1392),
    [anon_sym_PIPE_PIPE] = ACTIONS(1392),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [sym__concat] = ACTIONS(1392),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_AMP_AMP] = ACTIONS(1392),
    [anon_sym_DASH_EQ] = ACTIONS(1392),
  },
  [716] = {
    [sym_command_substitution] = STATE(715),
    [sym_simple_expansion] = STATE(715),
    [sym_string_expansion] = STATE(715),
    [sym_string] = STATE(715),
    [sym_process_substitution] = STATE(715),
    [sym_expansion] = STATE(715),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(1500),
    [sym_raw_string] = ACTIONS(1500),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(2393),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [717] = {
    [aux_sym_concatenation_repeat1] = STATE(717),
    [anon_sym_BANG_EQ] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1392),
    [sym_test_operator] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1392),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1392),
    [anon_sym_PIPE_PIPE] = ACTIONS(1392),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [sym__concat] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_AMP_AMP] = ACTIONS(1392),
    [anon_sym_DASH_EQ] = ACTIONS(1392),
  },
  [718] = {
    [anon_sym_BANG_EQ] = ACTIONS(1290),
    [anon_sym_PLUS_EQ] = ACTIONS(1290),
    [sym_test_operator] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_EQ] = ACTIONS(1288),
    [anon_sym_EQ_EQ] = ACTIONS(1290),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [sym__concat] = ACTIONS(1290),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_DASH_EQ] = ACTIONS(1290),
  },
  [719] = {
    [anon_sym_BANG_EQ] = ACTIONS(1284),
    [anon_sym_PLUS_EQ] = ACTIONS(1284),
    [sym_test_operator] = ACTIONS(1284),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [anon_sym_RPAREN] = ACTIONS(1282),
    [anon_sym_DASH] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_EQ_EQ] = ACTIONS(1284),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1284),
    [anon_sym_PIPE_PIPE] = ACTIONS(1284),
    [anon_sym_GT_EQ] = ACTIONS(1284),
    [sym__concat] = ACTIONS(1284),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1282),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1284),
    [anon_sym_LT_EQ] = ACTIONS(1284),
    [anon_sym_AMP_AMP] = ACTIONS(1284),
    [anon_sym_DASH_EQ] = ACTIONS(1284),
  },
  [720] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1058),
    [sym_concatenation] = STATE(1058),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2398),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2398),
    [anon_sym_PERCENT] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2402),
    [anon_sym_COLON_DASH] = ACTIONS(2398),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2404),
  },
  [721] = {
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_PLUS_EQ] = ACTIONS(1326),
    [sym_test_operator] = ACTIONS(1326),
    [anon_sym_PLUS_PLUS] = ACTIONS(1326),
    [anon_sym_RPAREN] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_EQ] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1326),
    [anon_sym_PIPE_PIPE] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [sym__concat] = ACTIONS(1326),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1324),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1326),
    [anon_sym_DASH_DASH] = ACTIONS(1326),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_AMP_AMP] = ACTIONS(1326),
    [anon_sym_DASH_EQ] = ACTIONS(1326),
  },
  [722] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [723] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1058),
    [sym_concatenation] = STATE(1058),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2406),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2398),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2398),
    [anon_sym_PERCENT] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2402),
    [anon_sym_COLON_DASH] = ACTIONS(2398),
    [sym__special_character] = ACTIONS(553),
  },
  [724] = {
    [anon_sym_EQ] = ACTIONS(2408),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [725] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1063),
    [sym_concatenation] = STATE(1063),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2410),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2412),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2412),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2412),
    [anon_sym_PERCENT] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2416),
    [anon_sym_COLON_DASH] = ACTIONS(2412),
    [sym__special_character] = ACTIONS(553),
  },
  [726] = {
    [sym_command_substitution] = STATE(1064),
    [aux_sym__literal_repeat1] = STATE(1065),
    [sym_string] = STATE(1064),
    [sym_process_substitution] = STATE(1064),
    [sym_simple_expansion] = STATE(1064),
    [sym_string_expansion] = STATE(1064),
    [sym_concatenation] = STATE(1066),
    [sym_expansion] = STATE(1064),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2418),
    [sym_raw_string] = ACTIONS(2418),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [727] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1069),
    [sym_concatenation] = STATE(1069),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2420),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2424),
    [anon_sym_COLON_DASH] = ACTIONS(2420),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2426),
  },
  [728] = {
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_PLUS_EQ] = ACTIONS(1382),
    [sym_test_operator] = ACTIONS(1382),
    [anon_sym_PLUS_PLUS] = ACTIONS(1382),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_EQ] = ACTIONS(1380),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_GT_EQ] = ACTIONS(1382),
    [sym__concat] = ACTIONS(1382),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1382),
    [anon_sym_DASH_DASH] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_DASH_EQ] = ACTIONS(1382),
  },
  [729] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [730] = {
    [anon_sym_BANG_EQ] = ACTIONS(2428),
    [anon_sym_PLUS_EQ] = ACTIONS(2428),
    [sym_test_operator] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_RPAREN] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2428),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_DASH_EQ] = ACTIONS(2428),
  },
  [731] = {
    [anon_sym_BANG_EQ] = ACTIONS(2428),
    [anon_sym_PLUS_EQ] = ACTIONS(2428),
    [sym_test_operator] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_RPAREN] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2428),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_DASH_EQ] = ACTIONS(2428),
  },
  [732] = {
    [sym_heredoc_redirect] = STATE(407),
    [aux_sym_redirected_statement_repeat1] = STATE(407),
    [sym_herestring_redirect] = STATE(407),
    [sym_file_redirect] = STATE(407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [sym_file_descriptor] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
  },
  [733] = {
    [sym_heredoc_redirect] = STATE(407),
    [aux_sym_redirected_statement_repeat1] = STATE(407),
    [sym_herestring_redirect] = STATE(407),
    [sym_file_redirect] = STATE(407),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
  },
  [734] = {
    [aux_sym_concatenation_repeat1] = STATE(1070),
    [anon_sym_LT_LT_DASH] = ACTIONS(391),
    [anon_sym_BQUOTE] = ACTIONS(391),
    [anon_sym_AMP_GT_GT] = ACTIONS(391),
    [anon_sym_LF] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(391),
    [sym_file_descriptor] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_AMP_GT] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(391),
    [anon_sym_LT_LT_LT] = ACTIONS(391),
    [anon_sym_PIPE] = ACTIONS(391),
    [anon_sym_GT_AMP] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_LT_AMP] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(391),
    [anon_sym_SEMI_SEMI] = ACTIONS(391),
    [anon_sym_PIPE_AMP] = ACTIONS(391),
  },
  [735] = {
    [aux_sym_concatenation_repeat1] = STATE(1070),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [736] = {
    [aux_sym__literal_repeat1] = STATE(1071),
    [anon_sym_LT_LT_DASH] = ACTIONS(415),
    [anon_sym_BQUOTE] = ACTIONS(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(415),
    [anon_sym_LF] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [sym_file_descriptor] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_AMP_GT] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_LT_LT_LT] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(415),
    [anon_sym_GT_AMP] = ACTIONS(415),
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_LT_AMP] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(415),
    [anon_sym_PIPE_AMP] = ACTIONS(415),
  },
  [737] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1864),
    [anon_sym_LF] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2434),
    [anon_sym_SEMI_SEMI] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2434),
  },
  [738] = {
    [sym_command_substitution] = STATE(1073),
    [aux_sym__literal_repeat1] = STATE(1074),
    [sym_string] = STATE(1073),
    [sym_process_substitution] = STATE(1073),
    [sym_simple_expansion] = STATE(1073),
    [sym_string_expansion] = STATE(1073),
    [sym_concatenation] = STATE(889),
    [sym_expansion] = STATE(1073),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(2436),
    [sym_raw_string] = ACTIONS(2436),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(1549),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [739] = {
    [sym_heredoc_redirect] = STATE(407),
    [aux_sym_redirected_statement_repeat1] = STATE(407),
    [sym_herestring_redirect] = STATE(407),
    [sym_file_redirect] = STATE(407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [sym_file_descriptor] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(743),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(743),
  },
  [740] = {
    [sym_heredoc_redirect] = STATE(407),
    [aux_sym_redirected_statement_repeat1] = STATE(407),
    [sym_herestring_redirect] = STATE(407),
    [sym_file_redirect] = STATE(407),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(743),
    [anon_sym_AMP] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(743),
  },
  [741] = {
    [aux_sym_concatenation_repeat1] = STATE(1070),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [anon_sym_PIPE] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
  },
  [742] = {
    [aux_sym__literal_repeat1] = STATE(1071),
    [anon_sym_LT_LT_DASH] = ACTIONS(1886),
    [anon_sym_BQUOTE] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1888),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_LT_LT] = ACTIONS(1886),
    [sym_file_descriptor] = ACTIONS(1888),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_PIPE_PIPE] = ACTIONS(1886),
    [anon_sym_LT_LT_LT] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_GT_AMP] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_LT_AMP] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1886),
    [anon_sym_AMP] = ACTIONS(1886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1886),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1886),
    [anon_sym_PIPE_AMP] = ACTIONS(1886),
  },
  [743] = {
    [sym_heredoc_redirect] = STATE(743),
    [aux_sym_redirected_statement_repeat1] = STATE(743),
    [sym_herestring_redirect] = STATE(743),
    [sym_file_redirect] = STATE(743),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1898),
    [anon_sym_AMP_GT_GT] = ACTIONS(2438),
    [anon_sym_LF] = ACTIONS(1896),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_LT_LT] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(2441),
    [anon_sym_GT] = ACTIONS(2438),
    [anon_sym_AMP_GT] = ACTIONS(2438),
    [anon_sym_PIPE_PIPE] = ACTIONS(1898),
    [anon_sym_LT_LT_LT] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_GT_AMP] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_LT_AMP] = ACTIONS(2438),
    [anon_sym_GT_GT] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1898),
    [anon_sym_SEMI_SEMI] = ACTIONS(1898),
    [anon_sym_PIPE_AMP] = ACTIONS(1898),
  },
  [744] = {
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(1866),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [745] = {
    [sym_heredoc_body] = STATE(1075),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__simple_heredoc_body] = ACTIONS(910),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(1866),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [sym__heredoc_body_beginning] = ACTIONS(912),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [746] = {
    [sym_command_substitution] = STATE(342),
    [aux_sym__literal_repeat1] = STATE(344),
    [sym_string] = STATE(342),
    [sym_process_substitution] = STATE(342),
    [sym_simple_expansion] = STATE(342),
    [sym_string_expansion] = STATE(342),
    [aux_sym_command_repeat2] = STATE(679),
    [sym_concatenation] = STATE(679),
    [sym_expansion] = STATE(342),
    [anon_sym_AMP_GT_GT] = ACTIONS(1910),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1910),
    [anon_sym_GT_LPAREN] = ACTIONS(333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1910),
    [sym_word] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(1910),
    [anon_sym_AMP] = ACTIONS(1910),
    [anon_sym_LT] = ACTIONS(1910),
    [anon_sym_LT_AMP] = ACTIONS(1910),
    [anon_sym_GT_GT] = ACTIONS(1910),
    [anon_sym_EQ_TILDE] = ACTIONS(627),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_LT_LT_DASH] = ACTIONS(1910),
    [anon_sym_BQUOTE] = ACTIONS(1910),
    [anon_sym_LF] = ACTIONS(1912),
    [anon_sym_SEMI] = ACTIONS(1910),
    [sym_raw_string] = ACTIONS(625),
    [sym_file_descriptor] = ACTIONS(1912),
    [anon_sym_GT] = ACTIONS(1910),
    [anon_sym_AMP_GT] = ACTIONS(1910),
    [anon_sym_EQ_EQ] = ACTIONS(627),
    [anon_sym_DQUOTE] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(1910),
    [anon_sym_GT_AMP] = ACTIONS(1910),
    [anon_sym_LT_LPAREN] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1910),
    [anon_sym_SEMI_SEMI] = ACTIONS(1910),
    [anon_sym_PIPE_AMP] = ACTIONS(1910),
  },
  [747] = {
    [sym_command_substitution] = STATE(753),
    [aux_sym__literal_repeat1] = STATE(760),
    [sym_string] = STATE(753),
    [sym_process_substitution] = STATE(753),
    [aux_sym_for_statement_repeat1] = STATE(1077),
    [sym_simple_expansion] = STATE(753),
    [sym_string_expansion] = STATE(753),
    [sym_concatenation] = STATE(1077),
    [sym_expansion] = STATE(753),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(1571),
    [sym_raw_string] = ACTIONS(1571),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(2447),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [748] = {
    [aux_sym_concatenation_repeat1] = STATE(234),
    [anon_sym_BQUOTE] = ACTIONS(1593),
    [anon_sym_AMP_GT_GT] = ACTIONS(1593),
    [sym_raw_string] = ACTIONS(1593),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [sym_file_descriptor] = ACTIONS(1593),
    [sym_variable_name] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1593),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1593),
    [anon_sym_GT_LPAREN] = ACTIONS(1593),
    [anon_sym_DQUOTE] = ACTIONS(1593),
    [sym_word] = ACTIONS(1593),
    [anon_sym_GT_AMP] = ACTIONS(1593),
    [sym__concat] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1593),
    [anon_sym_GT_GT] = ACTIONS(1593),
    [anon_sym_LT_LPAREN] = ACTIONS(1593),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1593),
  },
  [749] = {
    [anon_sym_BQUOTE] = ACTIONS(1593),
    [anon_sym_AMP_GT_GT] = ACTIONS(1593),
    [sym_raw_string] = ACTIONS(1593),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [sym_file_descriptor] = ACTIONS(1593),
    [sym_variable_name] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1593),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1593),
    [anon_sym_GT_LPAREN] = ACTIONS(1593),
    [anon_sym_DQUOTE] = ACTIONS(1593),
    [sym_word] = ACTIONS(1593),
    [anon_sym_GT_AMP] = ACTIONS(1593),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1593),
    [anon_sym_GT_GT] = ACTIONS(1593),
    [anon_sym_LT_LPAREN] = ACTIONS(1593),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1593),
  },
  [750] = {
    [aux_sym__literal_repeat1] = STATE(246),
    [anon_sym_BQUOTE] = ACTIONS(1617),
    [anon_sym_AMP_GT_GT] = ACTIONS(1617),
    [sym_raw_string] = ACTIONS(1617),
    [anon_sym_DOLLAR] = ACTIONS(1613),
    [sym_file_descriptor] = ACTIONS(1617),
    [sym_variable_name] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1617),
    [anon_sym_AMP_GT] = ACTIONS(1613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1617),
    [anon_sym_GT_LPAREN] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [sym_word] = ACTIONS(1617),
    [anon_sym_GT_AMP] = ACTIONS(1617),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_LT_AMP] = ACTIONS(1617),
    [anon_sym_GT_GT] = ACTIONS(1617),
    [anon_sym_LT_LPAREN] = ACTIONS(1617),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(417),
  },
  [751] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(1078),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [752] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(1081),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(2449),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(2451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [753] = {
    [aux_sym_concatenation_repeat1] = STATE(1083),
    [anon_sym_BQUOTE] = ACTIONS(2453),
    [anon_sym_DQUOTE] = ACTIONS(2453),
    [sym_word] = ACTIONS(2453),
    [sym_raw_string] = ACTIONS(2453),
    [sym__concat] = ACTIONS(2455),
    [anon_sym_LT_LPAREN] = ACTIONS(2453),
    [anon_sym_DOLLAR] = ACTIONS(2457),
    [anon_sym_RPAREN] = ACTIONS(2453),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2453),
    [sym__special_character] = ACTIONS(2453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2453),
  },
  [754] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(1084),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [755] = {
    [sym_string] = STATE(1086),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [anon_sym_STAR] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2459),
    [sym_raw_string] = ACTIONS(2461),
    [anon_sym_BANG] = ACTIONS(2463),
    [anon_sym_AT] = ACTIONS(2459),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [anon_sym_POUND] = ACTIONS(2463),
    [anon_sym_DASH] = ACTIONS(2463),
    [anon_sym_0] = ACTIONS(2465),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2465),
    [anon_sym__] = ACTIONS(2465),
  },
  [756] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2467),
    [anon_sym_DOLLAR] = ACTIONS(2467),
    [anon_sym_LT_LT] = ACTIONS(2467),
    [anon_sym_GT_LPAREN] = ACTIONS(2467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE] = ACTIONS(2467),
    [sym_word] = ACTIONS(2467),
    [anon_sym_PIPE] = ACTIONS(2467),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_LT_AMP] = ACTIONS(2467),
    [anon_sym_GT_GT] = ACTIONS(2467),
    [sym__special_character] = ACTIONS(2467),
    [anon_sym_LT_LT_DASH] = ACTIONS(2467),
    [anon_sym_BQUOTE] = ACTIONS(2467),
    [anon_sym_LF] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2467),
    [sym_raw_string] = ACTIONS(2467),
    [sym_variable_name] = ACTIONS(2469),
    [sym_file_descriptor] = ACTIONS(2469),
    [anon_sym_RPAREN] = ACTIONS(2467),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_AMP_GT] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [anon_sym_LT_LT_LT] = ACTIONS(2467),
    [anon_sym_GT_AMP] = ACTIONS(2467),
    [ts_builtin_sym_end] = ACTIONS(2469),
    [anon_sym_LT_LPAREN] = ACTIONS(2467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2467),
    [anon_sym_SEMI_SEMI] = ACTIONS(2467),
    [anon_sym_PIPE_AMP] = ACTIONS(2467),
  },
  [757] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(1088),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(1089),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [758] = {
    [aux_sym_concatenation_repeat1] = STATE(1083),
    [anon_sym_BQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [sym_word] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(189),
    [sym__concat] = ACTIONS(2455),
    [anon_sym_LT_LPAREN] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_RPAREN] = ACTIONS(189),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(189),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(189),
    [sym__special_character] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(189),
  },
  [759] = {
    [sym_subscript] = STATE(1090),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_AT] = ACTIONS(2471),
    [sym_variable_name] = ACTIONS(2475),
    [anon_sym_DOLLAR] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_0] = ACTIONS(2479),
    [anon_sym_POUND] = ACTIONS(2473),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2479),
    [anon_sym__] = ACTIONS(2479),
    [sym_comment] = ACTIONS(3),
  },
  [760] = {
    [aux_sym__literal_repeat1] = STATE(1095),
    [anon_sym_BQUOTE] = ACTIONS(2481),
    [anon_sym_DQUOTE] = ACTIONS(2481),
    [sym_word] = ACTIONS(2481),
    [sym_raw_string] = ACTIONS(2481),
    [anon_sym_LT_LPAREN] = ACTIONS(2481),
    [anon_sym_DOLLAR] = ACTIONS(2483),
    [anon_sym_RPAREN] = ACTIONS(2481),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2481),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2481),
    [sym__special_character] = ACTIONS(2485),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2481),
  },
  [761] = {
    [sym_command_substitution] = STATE(753),
    [aux_sym__literal_repeat1] = STATE(760),
    [sym_string] = STATE(753),
    [sym_process_substitution] = STATE(753),
    [aux_sym_for_statement_repeat1] = STATE(1097),
    [sym_simple_expansion] = STATE(753),
    [sym_string_expansion] = STATE(753),
    [sym_concatenation] = STATE(1097),
    [sym_expansion] = STATE(753),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(1571),
    [sym_raw_string] = ACTIONS(1571),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(2487),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [762] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2489),
  },
  [763] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [764] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(787),
    [anon_sym_GT_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [sym_word] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_LT_AMP] = ACTIONS(787),
    [anon_sym_GT_GT] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [sym__special_character] = ACTIONS(787),
    [anon_sym_LT_LT_DASH] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(787),
    [anon_sym_LF] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [sym_raw_string] = ACTIONS(787),
    [sym_variable_name] = ACTIONS(789),
    [sym_file_descriptor] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_AMP_GT] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_LT_LT_LT] = ACTIONS(787),
    [anon_sym_GT_AMP] = ACTIONS(787),
    [ts_builtin_sym_end] = ACTIONS(789),
    [anon_sym_LT_LPAREN] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
    [anon_sym_PIPE_AMP] = ACTIONS(787),
  },
  [765] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(2493),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [766] = {
    [sym_command_substitution] = STATE(1101),
    [sym_simple_expansion] = STATE(1101),
    [sym_string_expansion] = STATE(1101),
    [sym_string] = STATE(1101),
    [sym_process_substitution] = STATE(1101),
    [sym_expansion] = STATE(1101),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [sym_word] = ACTIONS(2495),
    [sym_raw_string] = ACTIONS(2495),
    [anon_sym_LT_LPAREN] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(761),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(763),
    [sym__special_character] = ACTIONS(2495),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(767),
  },
  [767] = {
    [aux_sym_concatenation_repeat1] = STATE(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(2497),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [ts_builtin_sym_end] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [768] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2499),
  },
  [769] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_LT_LT] = ACTIONS(505),
    [anon_sym_GT_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [sym_word] = ACTIONS(505),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_AMP] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_LT_AMP] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [sym__special_character] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [sym_raw_string] = ACTIONS(505),
    [sym_variable_name] = ACTIONS(507),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(505),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(505),
    [anon_sym_LT_LT_LT] = ACTIONS(505),
    [anon_sym_GT_AMP] = ACTIONS(505),
    [ts_builtin_sym_end] = ACTIONS(507),
    [anon_sym_LT_LPAREN] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
    [anon_sym_PIPE_AMP] = ACTIONS(505),
  },
  [770] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(509),
    [anon_sym_GT_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(509),
    [anon_sym_PIPE_PIPE] = ACTIONS(509),
    [sym_word] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_GT] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_LT_LT_DASH] = ACTIONS(509),
    [anon_sym_BQUOTE] = ACTIONS(509),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(509),
    [sym_variable_name] = ACTIONS(511),
    [sym_file_descriptor] = ACTIONS(511),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_LT_LT_LT] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [ts_builtin_sym_end] = ACTIONS(511),
    [anon_sym_LT_LPAREN] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
    [anon_sym_PIPE_AMP] = ACTIONS(509),
  },
  [771] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_variable_name] = ACTIONS(515),
    [sym_file_descriptor] = ACTIONS(515),
    [anon_sym_RPAREN] = ACTIONS(513),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [ts_builtin_sym_end] = ACTIONS(515),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [772] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(2489),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [773] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2489),
  },
  [774] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1107),
    [sym_concatenation] = STATE(1107),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2501),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2503),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2505),
    [anon_sym_DASH] = ACTIONS(2503),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2503),
    [anon_sym_PERCENT] = ACTIONS(2503),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2507),
    [anon_sym_COLON_DASH] = ACTIONS(2503),
    [sym__special_character] = ACTIONS(553),
  },
  [775] = {
    [sym_subscript] = STATE(1108),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_QMARK] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(2509),
    [sym_variable_name] = ACTIONS(2511),
    [anon_sym_DOLLAR] = ACTIONS(2513),
    [anon_sym_DASH] = ACTIONS(2513),
    [anon_sym_0] = ACTIONS(2515),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2515),
    [anon_sym__] = ACTIONS(2515),
  },
  [776] = {
    [anon_sym_EQ] = ACTIONS(2517),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [777] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1114),
    [sym_concatenation] = STATE(1114),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2519),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2521),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(2521),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2521),
    [anon_sym_PERCENT] = ACTIONS(2521),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2525),
    [anon_sym_COLON_DASH] = ACTIONS(2521),
    [sym__special_character] = ACTIONS(553),
  },
  [778] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [ts_builtin_sym_end] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [779] = {
    [aux_sym__literal_repeat1] = STATE(779),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(2527),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_variable_name] = ACTIONS(888),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [ts_builtin_sym_end] = ACTIONS(888),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [780] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(2530),
    [sym__concat] = ACTIONS(2532),
    [anon_sym_EQ] = ACTIONS(2530),
  },
  [781] = {
    [sym_command_substitution] = STATE(844),
    [sym_simple_expansion] = STATE(844),
    [sym_string_expansion] = STATE(844),
    [sym_string] = STATE(844),
    [sym_process_substitution] = STATE(844),
    [sym_expansion] = STATE(844),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym_word] = ACTIONS(1776),
    [sym_raw_string] = ACTIONS(1776),
    [anon_sym_LT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(2534),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [sym__special_character] = ACTIONS(2536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(285),
  },
  [782] = {
    [aux_sym_concatenation_repeat1] = STATE(1118),
    [anon_sym_RBRACK] = ACTIONS(585),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(2538),
  },
  [783] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(2540),
    [sym__concat] = ACTIONS(2542),
    [anon_sym_EQ] = ACTIONS(2540),
  },
  [784] = {
    [anon_sym_RBRACK] = ACTIONS(189),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(189),
    [sym__special_character] = ACTIONS(187),
  },
  [785] = {
    [anon_sym_RBRACK] = ACTIONS(2544),
    [sym_comment] = ACTIONS(51),
  },
  [786] = {
    [aux_sym__literal_repeat1] = STATE(786),
    [anon_sym_RBRACK] = ACTIONS(888),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(888),
    [sym__special_character] = ACTIONS(2546),
  },
  [787] = {
    [anon_sym_RBRACK] = ACTIONS(2534),
    [sym_comment] = ACTIONS(51),
  },
  [788] = {
    [anon_sym_DOLLAR] = ACTIONS(2549),
    [anon_sym_BQUOTE] = ACTIONS(2551),
    [anon_sym_DQUOTE] = ACTIONS(2551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2551),
    [sym__string_content] = ACTIONS(2549),
  },
  [789] = {
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_DQUOTE] = ACTIONS(1290),
    [sym__concat] = ACTIONS(1290),
    [sym__string_content] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1290),
  },
  [790] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1123),
    [sym_concatenation] = STATE(1123),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2557),
    [anon_sym_COLON_DASH] = ACTIONS(2553),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2559),
  },
  [791] = {
    [anon_sym_BQUOTE] = ACTIONS(1326),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [sym__concat] = ACTIONS(1326),
    [sym__string_content] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1326),
  },
  [792] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [793] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1123),
    [sym_concatenation] = STATE(1123),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2557),
    [anon_sym_COLON_DASH] = ACTIONS(2553),
    [sym__special_character] = ACTIONS(553),
  },
  [794] = {
    [anon_sym_EQ] = ACTIONS(2563),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [795] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1128),
    [sym_concatenation] = STATE(1128),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2565),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2571),
    [anon_sym_COLON_DASH] = ACTIONS(2567),
    [sym__special_character] = ACTIONS(553),
  },
  [796] = {
    [sym_command_substitution] = STATE(1129),
    [aux_sym__literal_repeat1] = STATE(1130),
    [sym_string] = STATE(1129),
    [sym_process_substitution] = STATE(1129),
    [sym_simple_expansion] = STATE(1129),
    [sym_string_expansion] = STATE(1129),
    [sym_concatenation] = STATE(1131),
    [sym_expansion] = STATE(1129),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2573),
    [sym_raw_string] = ACTIONS(2573),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [797] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1134),
    [sym_concatenation] = STATE(1134),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2575),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2575),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2575),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2579),
    [anon_sym_COLON_DASH] = ACTIONS(2575),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2581),
  },
  [798] = {
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [anon_sym_DQUOTE] = ACTIONS(1382),
    [sym__concat] = ACTIONS(1382),
    [sym__string_content] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1382),
  },
  [799] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [800] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2583),
    [anon_sym_PIPE_PIPE] = ACTIONS(2583),
    [sym_word] = ACTIONS(2583),
    [anon_sym_PIPE] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_LT_AMP] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_EQ_TILDE] = ACTIONS(2583),
    [sym__special_character] = ACTIONS(2583),
    [anon_sym_LT_LT_DASH] = ACTIONS(2583),
    [anon_sym_BQUOTE] = ACTIONS(2583),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [sym_raw_string] = ACTIONS(2583),
    [sym_file_descriptor] = ACTIONS(2585),
    [anon_sym_RPAREN] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_AMP_GT] = ACTIONS(2583),
    [anon_sym_EQ_EQ] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2583),
    [anon_sym_LT_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_AMP] = ACTIONS(2583),
    [ts_builtin_sym_end] = ACTIONS(2585),
    [anon_sym_LT_LPAREN] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
    [anon_sym_PIPE_AMP] = ACTIONS(2583),
  },
  [801] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [802] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(1135),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [803] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(1138),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(2587),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(2589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [804] = {
    [aux_sym_concatenation_repeat1] = STATE(1140),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [sym_raw_string] = ACTIONS(2457),
    [anon_sym_LF] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_DOLLAR] = ACTIONS(2457),
    [anon_sym_GT_LPAREN] = ACTIONS(2457),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2457),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [sym_word] = ACTIONS(2457),
    [sym__concat] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_LT_LPAREN] = ACTIONS(2457),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2457),
    [anon_sym_SEMI_SEMI] = ACTIONS(2457),
  },
  [805] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(1141),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [806] = {
    [sym_string] = STATE(1143),
    [anon_sym_DQUOTE] = ACTIONS(1696),
    [anon_sym_STAR] = ACTIONS(2593),
    [anon_sym_QMARK] = ACTIONS(2593),
    [sym_raw_string] = ACTIONS(2595),
    [anon_sym_BANG] = ACTIONS(2597),
    [anon_sym_AT] = ACTIONS(2593),
    [anon_sym_DOLLAR] = ACTIONS(2597),
    [anon_sym_POUND] = ACTIONS(2597),
    [anon_sym_DASH] = ACTIONS(2597),
    [anon_sym_0] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2599),
    [anon_sym__] = ACTIONS(2599),
  },
  [807] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(1145),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(1146),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [808] = {
    [aux_sym_concatenation_repeat1] = STATE(1140),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [sym__concat] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
  },
  [809] = {
    [sym_subscript] = STATE(1147),
    [anon_sym_STAR] = ACTIONS(2601),
    [anon_sym_QMARK] = ACTIONS(2601),
    [anon_sym_BANG] = ACTIONS(2603),
    [anon_sym_AT] = ACTIONS(2601),
    [sym_variable_name] = ACTIONS(2605),
    [anon_sym_DOLLAR] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2607),
    [anon_sym_0] = ACTIONS(2609),
    [anon_sym_POUND] = ACTIONS(2603),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2609),
    [anon_sym__] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
  },
  [810] = {
    [aux_sym__literal_repeat1] = STATE(1152),
    [anon_sym_BQUOTE] = ACTIONS(2483),
    [sym_raw_string] = ACTIONS(2483),
    [anon_sym_LF] = ACTIONS(2481),
    [anon_sym_SEMI] = ACTIONS(2483),
    [anon_sym_DOLLAR] = ACTIONS(2483),
    [anon_sym_GT_LPAREN] = ACTIONS(2483),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2483),
    [anon_sym_DQUOTE] = ACTIONS(2483),
    [sym_word] = ACTIONS(2483),
    [anon_sym_AMP] = ACTIONS(2483),
    [anon_sym_LT_LPAREN] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2611),
    [anon_sym_SEMI_SEMI] = ACTIONS(2483),
  },
  [811] = {
    [sym_command_substitution] = STATE(804),
    [aux_sym__literal_repeat1] = STATE(810),
    [sym_string] = STATE(804),
    [sym_process_substitution] = STATE(804),
    [aux_sym_for_statement_repeat1] = STATE(1154),
    [sym_simple_expansion] = STATE(804),
    [sym_string_expansion] = STATE(804),
    [sym_concatenation] = STATE(1154),
    [sym_expansion] = STATE(804),
    [anon_sym_BQUOTE] = ACTIONS(2613),
    [sym_raw_string] = ACTIONS(2615),
    [anon_sym_LF] = ACTIONS(2617),
    [anon_sym_SEMI] = ACTIONS(2619),
    [anon_sym_DOLLAR] = ACTIONS(1702),
    [anon_sym_GT_LPAREN] = ACTIONS(2621),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2623),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2625),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [sym_word] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2619),
    [anon_sym_LT_LPAREN] = ACTIONS(2621),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2629),
    [anon_sym_SEMI_SEMI] = ACTIONS(2619),
  },
  [812] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2631),
    [anon_sym_BQUOTE] = ACTIONS(2631),
    [anon_sym_AMP_GT_GT] = ACTIONS(2631),
    [anon_sym_LF] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym_LT_LT] = ACTIONS(2631),
    [sym_file_descriptor] = ACTIONS(2633),
    [anon_sym_GT] = ACTIONS(2631),
    [anon_sym_RPAREN] = ACTIONS(2631),
    [anon_sym_AMP_GT] = ACTIONS(2631),
    [anon_sym_PIPE_PIPE] = ACTIONS(2631),
    [ts_builtin_sym_end] = ACTIONS(2633),
    [anon_sym_LT_LT_LT] = ACTIONS(2631),
    [anon_sym_PIPE] = ACTIONS(2631),
    [anon_sym_GT_AMP] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2631),
    [anon_sym_LT_AMP] = ACTIONS(2631),
    [anon_sym_GT_GT] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(2631),
    [anon_sym_AMP_AMP] = ACTIONS(2631),
    [anon_sym_SEMI_SEMI] = ACTIONS(2631),
    [anon_sym_PIPE_AMP] = ACTIONS(2631),
  },
  [813] = {
    [anon_sym_BANG_EQ] = ACTIONS(1754),
    [anon_sym_PLUS_EQ] = ACTIONS(1754),
    [sym_test_operator] = ACTIONS(1756),
    [anon_sym_LF] = ACTIONS(2635),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1760),
    [anon_sym_DASH] = ACTIONS(1754),
    [anon_sym_GT] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(1754),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_GT_EQ] = ACTIONS(1754),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_LT] = ACTIONS(1754),
    [anon_sym_AMP] = ACTIONS(2635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1762),
    [anon_sym_DASH_DASH] = ACTIONS(1760),
    [anon_sym_AMP_AMP] = ACTIONS(1754),
    [anon_sym_LT_EQ] = ACTIONS(1754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2635),
    [anon_sym_DASH_EQ] = ACTIONS(1754),
  },
  [814] = {
    [anon_sym_BANG_EQ] = ACTIONS(1488),
    [anon_sym_PLUS_EQ] = ACTIONS(1488),
    [sym_test_operator] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_RPAREN] = ACTIONS(2637),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_EQ] = ACTIONS(1492),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_PIPE_PIPE] = ACTIONS(1488),
    [anon_sym_GT_EQ] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_LT] = ACTIONS(1492),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(1488),
    [anon_sym_AMP_AMP] = ACTIONS(1488),
    [anon_sym_DASH_EQ] = ACTIONS(1488),
  },
  [815] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2639),
  },
  [816] = {
    [sym_command_substitution] = STATE(1157),
    [sym_simple_expansion] = STATE(1157),
    [sym_string_expansion] = STATE(1157),
    [sym_string] = STATE(1157),
    [sym_process_substitution] = STATE(1157),
    [sym_expansion] = STATE(1157),
    [anon_sym_BQUOTE] = ACTIONS(1716),
    [anon_sym_DQUOTE] = ACTIONS(1712),
    [sym_word] = ACTIONS(2641),
    [sym_raw_string] = ACTIONS(2641),
    [anon_sym_LT_LPAREN] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1720),
    [sym__special_character] = ACTIONS(2641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
  },
  [817] = {
    [aux_sym_concatenation_repeat1] = STATE(1159),
    [anon_sym_BANG_EQ] = ACTIONS(581),
    [anon_sym_PLUS_EQ] = ACTIONS(581),
    [sym_test_operator] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(581),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_EQ] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [anon_sym_GT_EQ] = ACTIONS(581),
    [sym__concat] = ACTIONS(2643),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_LT_EQ] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_DASH_EQ] = ACTIONS(581),
  },
  [818] = {
    [sym_command_substitution] = STATE(131),
    [sym_unary_expression] = STATE(1161),
    [sym_postfix_expression] = STATE(1161),
    [sym_string] = STATE(131),
    [aux_sym__literal_repeat1] = STATE(138),
    [sym_process_substitution] = STATE(131),
    [sym_parenthesized_expression] = STATE(1161),
    [sym_simple_expansion] = STATE(131),
    [sym_string_expansion] = STATE(131),
    [sym__expression] = STATE(1161),
    [sym_binary_expression] = STATE(1161),
    [sym_concatenation] = STATE(1161),
    [sym_expansion] = STATE(131),
    [sym_test_operator] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [sym_raw_string] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2645),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(213),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(227),
  },
  [819] = {
    [anon_sym_BANG_EQ] = ACTIONS(1754),
    [anon_sym_PLUS_EQ] = ACTIONS(1754),
    [sym_test_operator] = ACTIONS(1756),
    [anon_sym_LF] = ACTIONS(2647),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1760),
    [anon_sym_DASH] = ACTIONS(1754),
    [anon_sym_GT] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(1754),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_GT_EQ] = ACTIONS(1754),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_LT] = ACTIONS(1754),
    [anon_sym_AMP] = ACTIONS(2647),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1762),
    [anon_sym_DASH_DASH] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1754),
    [anon_sym_SEMI_SEMI] = ACTIONS(2647),
    [anon_sym_DASH_EQ] = ACTIONS(1754),
  },
  [820] = {
    [anon_sym_BANG_EQ] = ACTIONS(505),
    [anon_sym_PLUS_EQ] = ACTIONS(505),
    [sym_test_operator] = ACTIONS(507),
    [anon_sym_LF] = ACTIONS(505),
    [anon_sym_SEMI] = ACTIONS(505),
    [anon_sym_PLUS_PLUS] = ACTIONS(505),
    [anon_sym_DASH] = ACTIONS(505),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_EQ] = ACTIONS(505),
    [anon_sym_EQ_EQ] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [anon_sym_GT_EQ] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_AMP] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(505),
    [anon_sym_DASH_DASH] = ACTIONS(505),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_LT_EQ] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
    [anon_sym_DASH_EQ] = ACTIONS(505),
  },
  [821] = {
    [anon_sym_BANG_EQ] = ACTIONS(509),
    [anon_sym_PLUS_EQ] = ACTIONS(509),
    [sym_test_operator] = ACTIONS(511),
    [anon_sym_LF] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(509),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DASH] = ACTIONS(509),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_EQ] = ACTIONS(509),
    [anon_sym_EQ_EQ] = ACTIONS(509),
    [anon_sym_PIPE_PIPE] = ACTIONS(509),
    [anon_sym_GT_EQ] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_AMP] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_LT_EQ] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
    [anon_sym_DASH_EQ] = ACTIONS(509),
  },
  [822] = {
    [anon_sym_BANG_EQ] = ACTIONS(513),
    [anon_sym_PLUS_EQ] = ACTIONS(513),
    [sym_test_operator] = ACTIONS(515),
    [anon_sym_LF] = ACTIONS(513),
    [anon_sym_SEMI] = ACTIONS(513),
    [anon_sym_PLUS_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [anon_sym_GT_EQ] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(513),
    [anon_sym_DASH_DASH] = ACTIONS(513),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_LT_EQ] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_DASH_EQ] = ACTIONS(513),
  },
  [823] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2649),
  },
  [824] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [825] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2639),
  },
  [826] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1166),
    [sym_concatenation] = STATE(1166),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2651),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2653),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2653),
    [anon_sym_PERCENT] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2657),
    [anon_sym_COLON_DASH] = ACTIONS(2653),
    [sym__special_character] = ACTIONS(553),
  },
  [827] = {
    [sym_subscript] = STATE(1167),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_QMARK] = ACTIONS(2659),
    [anon_sym_AT] = ACTIONS(2659),
    [sym_variable_name] = ACTIONS(2661),
    [anon_sym_DOLLAR] = ACTIONS(2663),
    [anon_sym_DASH] = ACTIONS(2663),
    [anon_sym_0] = ACTIONS(2665),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2665),
    [anon_sym__] = ACTIONS(2665),
  },
  [828] = {
    [anon_sym_EQ] = ACTIONS(2667),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [829] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1173),
    [sym_concatenation] = STATE(1173),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2669),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2671),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2673),
    [anon_sym_DASH] = ACTIONS(2671),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2671),
    [anon_sym_PERCENT] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2675),
    [anon_sym_COLON_DASH] = ACTIONS(2671),
    [sym__special_character] = ACTIONS(553),
  },
  [830] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(2677),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [831] = {
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_PLUS_EQ] = ACTIONS(787),
    [sym_test_operator] = ACTIONS(789),
    [anon_sym_LF] = ACTIONS(787),
    [anon_sym_SEMI] = ACTIONS(787),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [anon_sym_GT_EQ] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_LT_EQ] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
    [anon_sym_DASH_EQ] = ACTIONS(787),
  },
  [832] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(2679),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [833] = {
    [anon_sym_BANG_EQ] = ACTIONS(187),
    [anon_sym_PLUS_EQ] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [sym_test_operator] = ACTIONS(189),
    [anon_sym_LF] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_PLUS_PLUS] = ACTIONS(187),
    [anon_sym_DASH] = ACTIONS(187),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_EQ] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [anon_sym_GT_EQ] = ACTIONS(187),
    [anon_sym_PLUS] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(187),
    [anon_sym_DASH_DASH] = ACTIONS(187),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_LT_EQ] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_DASH_EQ] = ACTIONS(187),
  },
  [834] = {
    [aux_sym__literal_repeat1] = STATE(834),
    [anon_sym_BANG_EQ] = ACTIONS(883),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [sym__special_character] = ACTIONS(2681),
    [sym_test_operator] = ACTIONS(888),
    [anon_sym_LF] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(883),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_GT_EQ] = ACTIONS(883),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_DASH_DASH] = ACTIONS(883),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_LT_EQ] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
  },
  [835] = {
    [sym_command_substitution] = STATE(450),
    [sym_unary_expression] = STATE(1176),
    [sym_postfix_expression] = STATE(1176),
    [sym_string] = STATE(450),
    [aux_sym__literal_repeat1] = STATE(458),
    [sym_process_substitution] = STATE(450),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_simple_expansion] = STATE(450),
    [sym_string_expansion] = STATE(450),
    [sym__expression] = STATE(1176),
    [sym_binary_expression] = STATE(1176),
    [sym_concatenation] = STATE(1176),
    [sym_expansion] = STATE(450),
    [sym_test_operator] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(1712),
    [sym_word] = ACTIONS(821),
    [sym_raw_string] = ACTIONS(1714),
    [anon_sym_BQUOTE] = ACTIONS(1716),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_LT_LPAREN] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1720),
    [sym__special_character] = ACTIONS(1722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
  },
  [836] = {
    [sym_command_substitution] = STATE(450),
    [sym_unary_expression] = STATE(1177),
    [sym_postfix_expression] = STATE(1177),
    [sym_string] = STATE(450),
    [aux_sym__literal_repeat1] = STATE(458),
    [sym_process_substitution] = STATE(450),
    [sym_parenthesized_expression] = STATE(1177),
    [sym_simple_expansion] = STATE(450),
    [sym_string_expansion] = STATE(450),
    [sym__expression] = STATE(1177),
    [sym_binary_expression] = STATE(1177),
    [sym_concatenation] = STATE(1177),
    [sym_expansion] = STATE(450),
    [sym_test_operator] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(817),
    [anon_sym_BQUOTE] = ACTIONS(819),
    [sym_raw_string] = ACTIONS(821),
    [anon_sym_LF] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [anon_sym_GT_LPAREN] = ACTIONS(829),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(835),
    [sym_word] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_LT_LPAREN] = ACTIONS(829),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(837),
    [anon_sym_SEMI_SEMI] = ACTIONS(2647),
  },
  [837] = {
    [anon_sym_BANG_EQ] = ACTIONS(1539),
    [anon_sym_PLUS_EQ] = ACTIONS(1539),
    [sym_test_operator] = ACTIONS(1537),
    [anon_sym_LF] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_AMP] = ACTIONS(1539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_SEMI_SEMI] = ACTIONS(1539),
    [anon_sym_DASH_EQ] = ACTIONS(1539),
  },
  [838] = {
    [sym_command_substitution] = STATE(450),
    [sym_unary_expression] = STATE(1176),
    [sym_postfix_expression] = STATE(1176),
    [sym_string] = STATE(450),
    [aux_sym__literal_repeat1] = STATE(458),
    [sym_process_substitution] = STATE(450),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_simple_expansion] = STATE(450),
    [sym_string_expansion] = STATE(450),
    [sym__expression] = STATE(1176),
    [sym_binary_expression] = STATE(1176),
    [sym_concatenation] = STATE(1176),
    [sym_expansion] = STATE(450),
    [sym_test_operator] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_BQUOTE] = ACTIONS(1716),
    [sym_raw_string] = ACTIONS(1714),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_DOLLAR] = ACTIONS(827),
    [anon_sym_GT_LPAREN] = ACTIONS(1718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
    [anon_sym_DQUOTE] = ACTIONS(1712),
    [sym_word] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(1718),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1722),
    [sym_regex] = ACTIONS(2684),
  },
  [839] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2686),
    [anon_sym_BQUOTE] = ACTIONS(2686),
    [anon_sym_AMP_GT_GT] = ACTIONS(2686),
    [anon_sym_LF] = ACTIONS(2688),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym_LT_LT] = ACTIONS(2686),
    [sym_file_descriptor] = ACTIONS(2688),
    [anon_sym_GT] = ACTIONS(2686),
    [anon_sym_RPAREN] = ACTIONS(2686),
    [anon_sym_AMP_GT] = ACTIONS(2686),
    [anon_sym_PIPE_PIPE] = ACTIONS(2686),
    [ts_builtin_sym_end] = ACTIONS(2688),
    [anon_sym_LT_LT_LT] = ACTIONS(2686),
    [anon_sym_PIPE] = ACTIONS(2686),
    [anon_sym_GT_AMP] = ACTIONS(2686),
    [anon_sym_LT] = ACTIONS(2686),
    [anon_sym_LT_AMP] = ACTIONS(2686),
    [anon_sym_GT_GT] = ACTIONS(2686),
    [anon_sym_AMP] = ACTIONS(2686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2686),
    [anon_sym_SEMI_SEMI] = ACTIONS(2686),
    [anon_sym_PIPE_AMP] = ACTIONS(2686),
  },
  [840] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1180),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_done] = ACTIONS(2690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [841] = {
    [anon_sym_BANG_EQ] = ACTIONS(2387),
    [anon_sym_PLUS_EQ] = ACTIONS(2387),
    [sym_test_operator] = ACTIONS(2387),
    [anon_sym_PLUS_PLUS] = ACTIONS(2387),
    [anon_sym_RBRACK] = ACTIONS(2387),
    [anon_sym_DASH] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_EQ] = ACTIONS(2389),
    [anon_sym_EQ_EQ] = ACTIONS(2387),
    [anon_sym_PIPE_PIPE] = ACTIONS(2387),
    [anon_sym_GT_EQ] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2389),
    [anon_sym_LT] = ACTIONS(2389),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2387),
    [anon_sym_DASH_DASH] = ACTIONS(2387),
    [anon_sym_LT_EQ] = ACTIONS(2387),
    [anon_sym_AMP_AMP] = ACTIONS(2387),
    [anon_sym_DASH_EQ] = ACTIONS(2387),
  },
  [842] = {
    [anon_sym_BANG_EQ] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [sym_test_operator] = ACTIONS(1641),
    [anon_sym_PLUS_PLUS] = ACTIONS(1641),
    [anon_sym_RBRACK] = ACTIONS(1641),
    [anon_sym_DASH] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_EQ] = ACTIONS(1639),
    [anon_sym_EQ_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(1641),
    [anon_sym_GT_EQ] = ACTIONS(1641),
    [sym__concat] = ACTIONS(1641),
    [anon_sym_PLUS] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1641),
    [anon_sym_DASH_DASH] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
  },
  [843] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [844] = {
    [anon_sym_BANG_EQ] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1392),
    [sym_test_operator] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_RBRACK] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1392),
    [anon_sym_PIPE_PIPE] = ACTIONS(1392),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [sym__concat] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_AMP_AMP] = ACTIONS(1392),
    [anon_sym_DASH_EQ] = ACTIONS(1392),
  },
  [845] = {
    [sym_command_substitution] = STATE(844),
    [sym_simple_expansion] = STATE(844),
    [sym_string_expansion] = STATE(844),
    [sym_string] = STATE(844),
    [sym_process_substitution] = STATE(844),
    [sym_expansion] = STATE(844),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym_word] = ACTIONS(1776),
    [sym_raw_string] = ACTIONS(1776),
    [anon_sym_LT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR] = ACTIONS(2694),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [sym__special_character] = ACTIONS(1776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(285),
  },
  [846] = {
    [aux_sym_concatenation_repeat1] = STATE(846),
    [anon_sym_BANG_EQ] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1392),
    [sym_test_operator] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_RBRACK] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1392),
    [anon_sym_PIPE_PIPE] = ACTIONS(1392),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [sym__concat] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_AMP_AMP] = ACTIONS(1392),
    [anon_sym_DASH_EQ] = ACTIONS(1392),
  },
  [847] = {
    [anon_sym_BANG_EQ] = ACTIONS(1290),
    [anon_sym_PLUS_EQ] = ACTIONS(1290),
    [sym_test_operator] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_EQ] = ACTIONS(1288),
    [anon_sym_EQ_EQ] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [sym__concat] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_DASH_EQ] = ACTIONS(1290),
  },
  [848] = {
    [anon_sym_BANG_EQ] = ACTIONS(1284),
    [anon_sym_PLUS_EQ] = ACTIONS(1284),
    [sym_test_operator] = ACTIONS(1284),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [anon_sym_RBRACK] = ACTIONS(1284),
    [anon_sym_DASH] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_EQ_EQ] = ACTIONS(1284),
    [anon_sym_PIPE_PIPE] = ACTIONS(1284),
    [anon_sym_GT_EQ] = ACTIONS(1284),
    [sym__concat] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1284),
    [anon_sym_LT_EQ] = ACTIONS(1284),
    [anon_sym_AMP_AMP] = ACTIONS(1284),
    [anon_sym_DASH_EQ] = ACTIONS(1284),
  },
  [849] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1185),
    [sym_concatenation] = STATE(1185),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2699),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(2699),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2699),
    [anon_sym_PERCENT] = ACTIONS(2699),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2703),
    [anon_sym_COLON_DASH] = ACTIONS(2699),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2705),
  },
  [850] = {
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_PLUS_EQ] = ACTIONS(1326),
    [sym_test_operator] = ACTIONS(1326),
    [anon_sym_PLUS_PLUS] = ACTIONS(1326),
    [anon_sym_RBRACK] = ACTIONS(1326),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_EQ] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_PIPE_PIPE] = ACTIONS(1326),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [sym__concat] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1326),
    [anon_sym_DASH_DASH] = ACTIONS(1326),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_AMP_AMP] = ACTIONS(1326),
    [anon_sym_DASH_EQ] = ACTIONS(1326),
  },
  [851] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [852] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1185),
    [sym_concatenation] = STATE(1185),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2707),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2699),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2701),
    [anon_sym_DASH] = ACTIONS(2699),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2699),
    [anon_sym_PERCENT] = ACTIONS(2699),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2703),
    [anon_sym_COLON_DASH] = ACTIONS(2699),
    [sym__special_character] = ACTIONS(553),
  },
  [853] = {
    [anon_sym_EQ] = ACTIONS(2709),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [854] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1190),
    [sym_concatenation] = STATE(1190),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2711),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2717),
    [anon_sym_COLON_DASH] = ACTIONS(2713),
    [sym__special_character] = ACTIONS(553),
  },
  [855] = {
    [sym_command_substitution] = STATE(1191),
    [aux_sym__literal_repeat1] = STATE(1192),
    [sym_string] = STATE(1191),
    [sym_process_substitution] = STATE(1191),
    [sym_simple_expansion] = STATE(1191),
    [sym_string_expansion] = STATE(1191),
    [sym_concatenation] = STATE(1193),
    [sym_expansion] = STATE(1191),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2719),
    [sym_raw_string] = ACTIONS(2719),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2701),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [856] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1196),
    [sym_concatenation] = STATE(1196),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2721),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2721),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2721),
    [anon_sym_PERCENT] = ACTIONS(2721),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2725),
    [anon_sym_COLON_DASH] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2727),
  },
  [857] = {
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_PLUS_EQ] = ACTIONS(1382),
    [sym_test_operator] = ACTIONS(1382),
    [anon_sym_PLUS_PLUS] = ACTIONS(1382),
    [anon_sym_RBRACK] = ACTIONS(1382),
    [anon_sym_DASH] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_EQ] = ACTIONS(1380),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_GT_EQ] = ACTIONS(1382),
    [sym__concat] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1382),
    [anon_sym_DASH_DASH] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_DASH_EQ] = ACTIONS(1382),
  },
  [858] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [859] = {
    [anon_sym_BANG_EQ] = ACTIONS(2428),
    [anon_sym_PLUS_EQ] = ACTIONS(2428),
    [sym_test_operator] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_DASH_EQ] = ACTIONS(2428),
  },
  [860] = {
    [anon_sym_BANG_EQ] = ACTIONS(2428),
    [anon_sym_PLUS_EQ] = ACTIONS(2428),
    [sym_test_operator] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_DASH_EQ] = ACTIONS(2428),
  },
  [861] = {
    [aux_sym_concatenation_repeat1] = STATE(861),
    [anon_sym_BANG_EQ] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1392),
    [sym_test_operator] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1392),
    [anon_sym_PIPE_PIPE] = ACTIONS(1392),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1392),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [sym__concat] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_AMP_AMP] = ACTIONS(1392),
    [anon_sym_DASH_EQ] = ACTIONS(1392),
  },
  [862] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2729),
  },
  [863] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(2731),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [864] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(787),
    [anon_sym_AMP_GT_GT] = ACTIONS(787),
    [anon_sym_LF] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(787),
    [sym_file_descriptor] = ACTIONS(789),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_AMP_GT] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [ts_builtin_sym_end] = ACTIONS(789),
    [anon_sym_LT_LT_LT] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_GT_AMP] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_LT_AMP] = ACTIONS(787),
    [anon_sym_GT_GT] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_esac] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
    [anon_sym_PIPE_AMP] = ACTIONS(787),
  },
  [865] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(2733),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [866] = {
    [sym_command_substitution] = STATE(1200),
    [sym_simple_expansion] = STATE(1200),
    [sym_string_expansion] = STATE(1200),
    [sym_string] = STATE(1200),
    [sym_process_substitution] = STATE(1200),
    [sym_expansion] = STATE(1200),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(2735),
    [sym_raw_string] = ACTIONS(2735),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(2735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [867] = {
    [aux_sym_concatenation_repeat1] = STATE(1202),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [ts_builtin_sym_end] = ACTIONS(585),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [sym__concat] = ACTIONS(2737),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [868] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2739),
  },
  [869] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [anon_sym_AMP_GT_GT] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [anon_sym_LT_LT] = ACTIONS(505),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(505),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [ts_builtin_sym_end] = ACTIONS(507),
    [anon_sym_LT_LT_LT] = ACTIONS(505),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_GT_AMP] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_LT_AMP] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(505),
    [anon_sym_AMP] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_esac] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
    [anon_sym_PIPE_AMP] = ACTIONS(505),
  },
  [870] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(509),
    [anon_sym_BQUOTE] = ACTIONS(509),
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(509),
    [sym_file_descriptor] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_RPAREN] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(509),
    [anon_sym_PIPE_PIPE] = ACTIONS(509),
    [ts_builtin_sym_end] = ACTIONS(511),
    [anon_sym_LT_LT_LT] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_AMP] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_esac] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
    [anon_sym_PIPE_AMP] = ACTIONS(509),
  },
  [871] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_RPAREN] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [ts_builtin_sym_end] = ACTIONS(515),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_esac] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [872] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [873] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2729),
  },
  [874] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1206),
    [sym_concatenation] = STATE(1206),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2741),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2743),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2743),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2743),
    [anon_sym_PERCENT] = ACTIONS(2743),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2747),
    [anon_sym_COLON_DASH] = ACTIONS(2743),
    [sym__special_character] = ACTIONS(553),
  },
  [875] = {
    [sym_subscript] = STATE(1207),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_QMARK] = ACTIONS(2749),
    [anon_sym_AT] = ACTIONS(2749),
    [sym_variable_name] = ACTIONS(2751),
    [anon_sym_DOLLAR] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2753),
    [anon_sym_0] = ACTIONS(2755),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2755),
    [anon_sym__] = ACTIONS(2755),
  },
  [876] = {
    [anon_sym_EQ] = ACTIONS(2757),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [877] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1213),
    [sym_concatenation] = STATE(1213),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2759),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2761),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2761),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2765),
    [anon_sym_COLON_DASH] = ACTIONS(2761),
    [sym__special_character] = ACTIONS(553),
  },
  [878] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_RPAREN] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [ts_builtin_sym_end] = ACTIONS(189),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(187),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [879] = {
    [aux_sym__literal_repeat1] = STATE(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [ts_builtin_sym_end] = ACTIONS(888),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [sym__special_character] = ACTIONS(2767),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [880] = {
    [anon_sym_STAR] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_BANG] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_POUND] = ACTIONS(2772),
    [anon_sym_DASH] = ACTIONS(2772),
    [anon_sym_0] = ACTIONS(2774),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2774),
    [anon_sym__] = ACTIONS(2774),
  },
  [881] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(1216),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [882] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(1217),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(1218),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [883] = {
    [anon_sym_BQUOTE] = ACTIONS(2776),
    [ts_builtin_sym_end] = ACTIONS(2778),
    [anon_sym_LF] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2776),
    [anon_sym_AMP] = ACTIONS(2776),
    [anon_sym_esac] = ACTIONS(2776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(2776),
    [anon_sym_SEMI_SEMI] = ACTIONS(2776),
  },
  [884] = {
    [sym_subscript] = STATE(1219),
    [anon_sym_STAR] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_AT] = ACTIONS(2780),
    [sym_variable_name] = ACTIONS(2784),
    [anon_sym_DOLLAR] = ACTIONS(2786),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_0] = ACTIONS(2788),
    [anon_sym_POUND] = ACTIONS(2782),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2788),
    [anon_sym__] = ACTIONS(2788),
    [sym_comment] = ACTIONS(3),
  },
  [885] = {
    [sym_command_substitution] = STATE(1224),
    [sym_simple_expansion] = STATE(1224),
    [sym_expansion] = STATE(1224),
    [aux_sym_heredoc_body_repeat1] = STATE(1224),
    [anon_sym_DOLLAR] = ACTIONS(1852),
    [anon_sym_BQUOTE] = ACTIONS(1854),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1856),
    [sym__heredoc_body_end] = ACTIONS(2790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1860),
    [sym__heredoc_body_middle] = ACTIONS(2792),
  },
  [886] = {
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_AMP_GT_GT] = ACTIONS(2796),
    [anon_sym_local] = ACTIONS(2794),
    [anon_sym_typeset] = ACTIONS(2794),
    [anon_sym_unsetenv] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2794),
    [anon_sym_GT_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2794),
    [sym_word] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_LT_AMP] = ACTIONS(2796),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2794),
    [sym__special_character] = ACTIONS(2794),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2794),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2796),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BQUOTE] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [sym_variable_name] = ACTIONS(2796),
    [sym_file_descriptor] = ACTIONS(2796),
    [anon_sym_RPAREN] = ACTIONS(2798),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP_GT] = ACTIONS(2794),
    [anon_sym_readonly] = ACTIONS(2794),
    [anon_sym_unset] = ACTIONS(2794),
    [ts_builtin_sym_end] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [anon_sym_GT_AMP] = ACTIONS(2796),
    [anon_sym_LT_LPAREN] = ACTIONS(2796),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2796),
  },
  [887] = {
    [aux_sym_concatenation_repeat1] = STATE(867),
    [anon_sym_LT_LT_DASH] = ACTIONS(1633),
    [anon_sym_AMP_GT_GT] = ACTIONS(1633),
    [anon_sym_LF] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [sym_file_descriptor] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_AMP_GT] = ACTIONS(1633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [ts_builtin_sym_end] = ACTIONS(1631),
    [anon_sym_LT_LT_LT] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_GT_AMP] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_LT_AMP] = ACTIONS(1633),
    [anon_sym_GT_GT] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [anon_sym_SEMI_SEMI] = ACTIONS(1633),
    [anon_sym_PIPE_AMP] = ACTIONS(1633),
  },
  [888] = {
    [aux_sym__literal_repeat1] = STATE(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(1637),
    [anon_sym_AMP_GT_GT] = ACTIONS(1637),
    [anon_sym_LF] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_LT_LT] = ACTIONS(1637),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_AMP_GT] = ACTIONS(1637),
    [anon_sym_PIPE_PIPE] = ACTIONS(1637),
    [ts_builtin_sym_end] = ACTIONS(1635),
    [anon_sym_LT_LT_LT] = ACTIONS(1637),
    [anon_sym_PIPE] = ACTIONS(1637),
    [anon_sym_GT_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_LT_AMP] = ACTIONS(1637),
    [anon_sym_GT_GT] = ACTIONS(1637),
    [anon_sym_AMP] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1637),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1637),
    [anon_sym_PIPE_AMP] = ACTIONS(1637),
  },
  [889] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1633),
    [anon_sym_BQUOTE] = ACTIONS(1633),
    [anon_sym_AMP_GT_GT] = ACTIONS(1633),
    [anon_sym_LF] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [sym_file_descriptor] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_RPAREN] = ACTIONS(1633),
    [anon_sym_AMP_GT] = ACTIONS(1633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [ts_builtin_sym_end] = ACTIONS(1631),
    [anon_sym_LT_LT_LT] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_GT_AMP] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_LT_AMP] = ACTIONS(1633),
    [anon_sym_GT_GT] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [anon_sym_SEMI_SEMI] = ACTIONS(1633),
    [anon_sym_PIPE_AMP] = ACTIONS(1633),
  },
  [890] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(2800),
    [ts_builtin_sym_end] = ACTIONS(2798),
    [anon_sym_LF] = ACTIONS(2802),
    [anon_sym_SEMI] = ACTIONS(2804),
    [anon_sym_SEMI_SEMI] = ACTIONS(2804),
    [anon_sym_AMP] = ACTIONS(2804),
  },
  [891] = {
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_fi] = ACTIONS(906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_done] = ACTIONS(906),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_elif] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [892] = {
    [sym_heredoc_body] = STATE(1226),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_fi] = ACTIONS(906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_done] = ACTIONS(906),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__simple_heredoc_body] = ACTIONS(910),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [sym__heredoc_body_beginning] = ACTIONS(912),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_elif] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
  },
  [893] = {
    [aux_sym_concatenation_repeat1] = STATE(893),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(2035),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [894] = {
    [aux_sym_concatenation_repeat1] = STATE(522),
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__concat] = ACTIONS(425),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [anon_sym_RPAREN] = ACTIONS(1589),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [895] = {
    [aux_sym__literal_repeat1] = STATE(524),
    [anon_sym_AMP_GT_GT] = ACTIONS(1613),
    [anon_sym_DOLLAR] = ACTIONS(1613),
    [anon_sym_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1613),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1613),
    [anon_sym_PIPE_PIPE] = ACTIONS(1613),
    [sym_word] = ACTIONS(1613),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_LT_AMP] = ACTIONS(1613),
    [anon_sym_GT_GT] = ACTIONS(1613),
    [sym__special_character] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1613),
    [anon_sym_LF] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1613),
    [sym_raw_string] = ACTIONS(1613),
    [sym_variable_name] = ACTIONS(1617),
    [anon_sym_RPAREN] = ACTIONS(1613),
    [sym_file_descriptor] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1613),
    [anon_sym_AMP_GT] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_LT_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_AMP] = ACTIONS(1613),
    [anon_sym_LT_LPAREN] = ACTIONS(1613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1613),
    [anon_sym_SEMI_SEMI] = ACTIONS(1613),
    [anon_sym_PIPE_AMP] = ACTIONS(1613),
  },
  [896] = {
    [aux_sym_concatenation_repeat1] = STATE(896),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(2074),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [897] = {
    [aux_sym_concatenation_repeat1] = STATE(1227),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(2497),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [898] = {
    [aux_sym__literal_repeat1] = STATE(898),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(2527),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_variable_name] = ACTIONS(888),
    [anon_sym_RPAREN] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [899] = {
    [aux_sym_concatenation_repeat1] = STATE(1228),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [anon_sym_RPAREN] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [sym__concat] = ACTIONS(2737),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [900] = {
    [aux_sym__literal_repeat1] = STATE(900),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [sym__special_character] = ACTIONS(2767),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [901] = {
    [aux_sym_concatenation_repeat1] = STATE(899),
    [anon_sym_LT_LT_DASH] = ACTIONS(1633),
    [anon_sym_AMP_GT_GT] = ACTIONS(1633),
    [anon_sym_LF] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_RPAREN] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(1633),
    [sym_file_descriptor] = ACTIONS(1631),
    [anon_sym_AMP_GT] = ACTIONS(1633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_LT_LT_LT] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_GT_AMP] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_LT_AMP] = ACTIONS(1633),
    [anon_sym_GT_GT] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [anon_sym_SEMI_SEMI] = ACTIONS(1633),
    [anon_sym_PIPE_AMP] = ACTIONS(1633),
  },
  [902] = {
    [aux_sym__literal_repeat1] = STATE(900),
    [anon_sym_LT_LT_DASH] = ACTIONS(1637),
    [anon_sym_AMP_GT_GT] = ACTIONS(1637),
    [anon_sym_LF] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_RPAREN] = ACTIONS(1637),
    [anon_sym_LT_LT] = ACTIONS(1637),
    [anon_sym_GT] = ACTIONS(1637),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_AMP_GT] = ACTIONS(1637),
    [anon_sym_PIPE_PIPE] = ACTIONS(1637),
    [anon_sym_LT_LT_LT] = ACTIONS(1637),
    [anon_sym_PIPE] = ACTIONS(1637),
    [anon_sym_GT_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_LT_AMP] = ACTIONS(1637),
    [anon_sym_GT_GT] = ACTIONS(1637),
    [anon_sym_AMP] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1637),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1637),
    [anon_sym_PIPE_AMP] = ACTIONS(1637),
  },
  [903] = {
    [anon_sym_BQUOTE] = ACTIONS(2585),
    [anon_sym_AMP_GT_GT] = ACTIONS(2585),
    [sym_raw_string] = ACTIONS(2585),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [sym_file_descriptor] = ACTIONS(2585),
    [sym_variable_name] = ACTIONS(2585),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2585),
    [anon_sym_AMP_GT] = ACTIONS(2583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2585),
    [anon_sym_GT_LPAREN] = ACTIONS(2585),
    [anon_sym_RPAREN] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(2585),
    [sym_word] = ACTIONS(2585),
    [anon_sym_GT_AMP] = ACTIONS(2585),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_LT_AMP] = ACTIONS(2585),
    [anon_sym_GT_GT] = ACTIONS(2585),
    [anon_sym_LT_LPAREN] = ACTIONS(2585),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2585),
  },
  [904] = {
    [sym_string] = STATE(237),
    [anon_sym_AMP_GT_GT] = ACTIONS(2265),
    [anon_sym_DOLLAR] = ACTIONS(2806),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_GT_LPAREN] = ACTIONS(2265),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2265),
    [aux_sym__simple_variable_name_token1] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2265),
    [sym_word] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_LT_AMP] = ACTIONS(2265),
    [anon_sym_GT_GT] = ACTIONS(2265),
    [sym__special_character] = ACTIONS(2265),
    [anon_sym_BQUOTE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(397),
    [anon_sym_BANG] = ACTIONS(2806),
    [sym_variable_name] = ACTIONS(2265),
    [sym_file_descriptor] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2265),
    [anon_sym_AMP_GT] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(77),
    [anon_sym_GT_AMP] = ACTIONS(2265),
    [anon_sym_LT_LPAREN] = ACTIONS(2265),
    [anon_sym_AT] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(399),
    [anon_sym__] = ACTIONS(401),
  },
  [905] = {
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [anon_sym_AMP_GT_GT] = ACTIONS(2111),
    [sym_raw_string] = ACTIONS(2111),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [sym_file_descriptor] = ACTIONS(2111),
    [sym_variable_name] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2111),
    [anon_sym_AMP_GT] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2111),
    [anon_sym_GT_LPAREN] = ACTIONS(2111),
    [anon_sym_RPAREN] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [sym_word] = ACTIONS(2111),
    [anon_sym_GT_AMP] = ACTIONS(2111),
    [sym__concat] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_LT_AMP] = ACTIONS(2111),
    [anon_sym_GT_GT] = ACTIONS(2111),
    [anon_sym_LT_LPAREN] = ACTIONS(2111),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2111),
  },
  [906] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1230),
    [sym_concatenation] = STATE(1230),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2808),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2808),
    [anon_sym_PERCENT] = ACTIONS(2808),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2812),
    [anon_sym_COLON_DASH] = ACTIONS(2808),
    [sym__special_character] = ACTIONS(553),
  },
  [907] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [908] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1230),
    [sym_concatenation] = STATE(1230),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2808),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2808),
    [anon_sym_PERCENT] = ACTIONS(2808),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2812),
    [anon_sym_COLON_DASH] = ACTIONS(2808),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2814),
  },
  [909] = {
    [sym_command_substitution] = STATE(1232),
    [aux_sym__literal_repeat1] = STATE(1233),
    [sym_string] = STATE(1232),
    [sym_process_substitution] = STATE(1232),
    [sym_simple_expansion] = STATE(1232),
    [sym_string_expansion] = STATE(1232),
    [sym_concatenation] = STATE(1234),
    [sym_expansion] = STATE(1232),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2816),
    [sym_raw_string] = ACTIONS(2816),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [910] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1237),
    [sym_concatenation] = STATE(1237),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2818),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2818),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2818),
    [anon_sym_PERCENT] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2822),
    [anon_sym_COLON_DASH] = ACTIONS(2818),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2824),
  },
  [911] = {
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [anon_sym_AMP_GT_GT] = ACTIONS(2207),
    [sym_raw_string] = ACTIONS(2207),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [sym_file_descriptor] = ACTIONS(2207),
    [sym_variable_name] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2207),
    [anon_sym_AMP_GT] = ACTIONS(2205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2207),
    [anon_sym_GT_LPAREN] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [sym_word] = ACTIONS(2207),
    [anon_sym_GT_AMP] = ACTIONS(2207),
    [sym__concat] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(2207),
    [anon_sym_LT_LPAREN] = ACTIONS(2207),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2207),
  },
  [912] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [913] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [sym__concat] = ACTIONS(2213),
  },
  [914] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2826),
  },
  [915] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2810),
  },
  [916] = {
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_AMP_GT_GT] = ACTIONS(2249),
    [sym_raw_string] = ACTIONS(2249),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [sym_file_descriptor] = ACTIONS(2249),
    [sym_variable_name] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2249),
    [anon_sym_AMP_GT] = ACTIONS(2247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2249),
    [anon_sym_GT_LPAREN] = ACTIONS(2249),
    [anon_sym_RPAREN] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_word] = ACTIONS(2249),
    [anon_sym_GT_AMP] = ACTIONS(2249),
    [sym__concat] = ACTIONS(2249),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_LT_AMP] = ACTIONS(2249),
    [anon_sym_GT_GT] = ACTIONS(2249),
    [anon_sym_LT_LPAREN] = ACTIONS(2249),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2249),
  },
  [917] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1240),
    [sym_concatenation] = STATE(1240),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2828),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2828),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2828),
    [anon_sym_PERCENT] = ACTIONS(2828),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2832),
    [anon_sym_COLON_DASH] = ACTIONS(2828),
    [sym__special_character] = ACTIONS(553),
  },
  [918] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [919] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2583),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2583),
    [anon_sym_PIPE_PIPE] = ACTIONS(2583),
    [sym_word] = ACTIONS(2583),
    [anon_sym_PIPE] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_LT_AMP] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [sym__special_character] = ACTIONS(2583),
    [anon_sym_LT_LT_DASH] = ACTIONS(2583),
    [anon_sym_BQUOTE] = ACTIONS(2583),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [sym_raw_string] = ACTIONS(2583),
    [sym_variable_name] = ACTIONS(2585),
    [sym_file_descriptor] = ACTIONS(2585),
    [anon_sym_RPAREN] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_AMP_GT] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2583),
    [anon_sym_LT_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_AMP] = ACTIONS(2583),
    [ts_builtin_sym_end] = ACTIONS(2585),
    [anon_sym_LT_LPAREN] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
    [anon_sym_PIPE_AMP] = ACTIONS(2583),
  },
  [920] = {
    [sym_string] = STATE(256),
    [anon_sym__] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(2834),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(2834),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(439),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [sym_word] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_LT_AMP] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(439),
    [sym__special_character] = ACTIONS(2261),
    [anon_sym_LT_LT_DASH] = ACTIONS(2261),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2834),
    [sym_variable_name] = ACTIONS(2265),
    [sym_file_descriptor] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_AMP_GT] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_AMP] = ACTIONS(2261),
    [ts_builtin_sym_end] = ACTIONS(2265),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2834),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_PIPE_AMP] = ACTIONS(2261),
  },
  [921] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2467),
    [anon_sym_DOLLAR] = ACTIONS(2467),
    [anon_sym_LT_LT] = ACTIONS(2467),
    [anon_sym_GT_LPAREN] = ACTIONS(2467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2467),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE] = ACTIONS(2467),
    [sym_word] = ACTIONS(2467),
    [anon_sym_PIPE] = ACTIONS(2467),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_LT_AMP] = ACTIONS(2467),
    [anon_sym_GT_GT] = ACTIONS(2467),
    [sym__special_character] = ACTIONS(2467),
    [anon_sym_LT_LT_DASH] = ACTIONS(2467),
    [anon_sym_BQUOTE] = ACTIONS(2467),
    [anon_sym_LF] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2467),
    [sym_raw_string] = ACTIONS(2467),
    [sym_variable_name] = ACTIONS(2469),
    [sym_file_descriptor] = ACTIONS(2469),
    [anon_sym_RPAREN] = ACTIONS(2467),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_AMP_GT] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [anon_sym_LT_LT_LT] = ACTIONS(2467),
    [anon_sym_GT_AMP] = ACTIONS(2467),
    [ts_builtin_sym_end] = ACTIONS(2469),
    [anon_sym_LT_LPAREN] = ACTIONS(2467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2467),
    [anon_sym_SEMI_SEMI] = ACTIONS(2467),
    [anon_sym_PIPE_AMP] = ACTIONS(2467),
  },
  [922] = {
    [sym_command_substitution] = STATE(753),
    [aux_sym__literal_repeat1] = STATE(760),
    [sym_string] = STATE(753),
    [sym_process_substitution] = STATE(753),
    [aux_sym_for_statement_repeat1] = STATE(1097),
    [sym_simple_expansion] = STATE(753),
    [sym_string_expansion] = STATE(753),
    [sym_concatenation] = STATE(1097),
    [sym_expansion] = STATE(753),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(1571),
    [sym_raw_string] = ACTIONS(1571),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(2838),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [923] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2109),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [sym_word] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_LT_AMP] = ACTIONS(2109),
    [anon_sym_GT_GT] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [sym__special_character] = ACTIONS(2109),
    [anon_sym_LT_LT_DASH] = ACTIONS(2109),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [anon_sym_LF] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [sym_raw_string] = ACTIONS(2109),
    [sym_variable_name] = ACTIONS(2111),
    [sym_file_descriptor] = ACTIONS(2111),
    [anon_sym_RPAREN] = ACTIONS(2109),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_AMP_GT] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [anon_sym_LT_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_AMP] = ACTIONS(2109),
    [ts_builtin_sym_end] = ACTIONS(2111),
    [anon_sym_LT_LPAREN] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
    [anon_sym_PIPE_AMP] = ACTIONS(2109),
  },
  [924] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1243),
    [sym_concatenation] = STATE(1243),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2840),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_DASH] = ACTIONS(2840),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2840),
    [anon_sym_PERCENT] = ACTIONS(2840),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2844),
    [anon_sym_COLON_DASH] = ACTIONS(2840),
    [sym__special_character] = ACTIONS(553),
  },
  [925] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [926] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1243),
    [sym_concatenation] = STATE(1243),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2840),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_DASH] = ACTIONS(2840),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2840),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2840),
    [anon_sym_PERCENT] = ACTIONS(2840),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2844),
    [anon_sym_COLON_DASH] = ACTIONS(2840),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2846),
  },
  [927] = {
    [sym_command_substitution] = STATE(1245),
    [aux_sym__literal_repeat1] = STATE(1246),
    [sym_string] = STATE(1245),
    [sym_process_substitution] = STATE(1245),
    [sym_simple_expansion] = STATE(1245),
    [sym_string_expansion] = STATE(1245),
    [sym_concatenation] = STATE(1247),
    [sym_expansion] = STATE(1245),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2848),
    [sym_raw_string] = ACTIONS(2848),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [928] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1250),
    [sym_concatenation] = STATE(1250),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2850),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2850),
    [anon_sym_PERCENT] = ACTIONS(2850),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2854),
    [anon_sym_COLON_DASH] = ACTIONS(2850),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2856),
  },
  [929] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [sym__special_character] = ACTIONS(2205),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [sym_variable_name] = ACTIONS(2207),
    [sym_file_descriptor] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [ts_builtin_sym_end] = ACTIONS(2207),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
  },
  [930] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [931] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [sym__concat] = ACTIONS(2213),
  },
  [932] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2858),
  },
  [933] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2842),
  },
  [934] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2247),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2247),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2247),
    [sym_word] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_LT_AMP] = ACTIONS(2247),
    [anon_sym_GT_GT] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [sym__special_character] = ACTIONS(2247),
    [anon_sym_LT_LT_DASH] = ACTIONS(2247),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [sym_raw_string] = ACTIONS(2247),
    [sym_variable_name] = ACTIONS(2249),
    [sym_file_descriptor] = ACTIONS(2249),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_AMP_GT] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_LT_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_AMP] = ACTIONS(2247),
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_LT_LPAREN] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
    [anon_sym_PIPE_AMP] = ACTIONS(2247),
  },
  [935] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1253),
    [sym_concatenation] = STATE(1253),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2860),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2860),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2860),
    [anon_sym_PERCENT] = ACTIONS(2860),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2864),
    [anon_sym_COLON_DASH] = ACTIONS(2860),
    [sym__special_character] = ACTIONS(553),
  },
  [936] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [937] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2583),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2583),
    [anon_sym_PIPE_PIPE] = ACTIONS(2583),
    [sym_word] = ACTIONS(2583),
    [anon_sym_PIPE] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_LT_AMP] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [sym__special_character] = ACTIONS(2583),
    [anon_sym_LT_LT_DASH] = ACTIONS(2583),
    [anon_sym_BQUOTE] = ACTIONS(2583),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [sym_raw_string] = ACTIONS(2583),
    [sym_file_descriptor] = ACTIONS(2585),
    [anon_sym_RPAREN] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_AMP_GT] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2583),
    [anon_sym_LT_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_AMP] = ACTIONS(2583),
    [ts_builtin_sym_end] = ACTIONS(2585),
    [anon_sym_LT_LPAREN] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
    [anon_sym_PIPE_AMP] = ACTIONS(2583),
  },
  [938] = {
    [sym_string] = STATE(275),
    [anon_sym__] = ACTIONS(481),
    [anon_sym_AMP_GT_GT] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(2866),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(2866),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [sym_word] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_LT_AMP] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(481),
    [sym__special_character] = ACTIONS(2261),
    [anon_sym_LT_LT_DASH] = ACTIONS(2261),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(2868),
    [anon_sym_BANG] = ACTIONS(2866),
    [sym_file_descriptor] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_AMP_GT] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(135),
    [anon_sym_LT_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_AMP] = ACTIONS(2261),
    [ts_builtin_sym_end] = ACTIONS(2265),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2866),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_PIPE_AMP] = ACTIONS(2261),
  },
  [939] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2109),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [sym_word] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_LT_AMP] = ACTIONS(2109),
    [anon_sym_GT_GT] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [sym__special_character] = ACTIONS(2109),
    [anon_sym_LT_LT_DASH] = ACTIONS(2109),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [anon_sym_LF] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [sym_raw_string] = ACTIONS(2109),
    [sym_file_descriptor] = ACTIONS(2111),
    [anon_sym_RPAREN] = ACTIONS(2109),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_AMP_GT] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [anon_sym_LT_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_AMP] = ACTIONS(2109),
    [ts_builtin_sym_end] = ACTIONS(2111),
    [anon_sym_LT_LPAREN] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
    [anon_sym_PIPE_AMP] = ACTIONS(2109),
  },
  [940] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1255),
    [sym_concatenation] = STATE(1255),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2870),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2870),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2874),
    [anon_sym_COLON_DASH] = ACTIONS(2870),
    [sym__special_character] = ACTIONS(553),
  },
  [941] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [942] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1255),
    [sym_concatenation] = STATE(1255),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2870),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2870),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2870),
    [anon_sym_PERCENT] = ACTIONS(2870),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2874),
    [anon_sym_COLON_DASH] = ACTIONS(2870),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2876),
  },
  [943] = {
    [sym_command_substitution] = STATE(1257),
    [aux_sym__literal_repeat1] = STATE(1258),
    [sym_string] = STATE(1257),
    [sym_process_substitution] = STATE(1257),
    [sym_simple_expansion] = STATE(1257),
    [sym_string_expansion] = STATE(1257),
    [sym_concatenation] = STATE(1259),
    [sym_expansion] = STATE(1257),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2878),
    [sym_raw_string] = ACTIONS(2878),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2872),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [944] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1262),
    [sym_concatenation] = STATE(1262),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2880),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2882),
    [anon_sym_DASH] = ACTIONS(2880),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2880),
    [anon_sym_PERCENT] = ACTIONS(2880),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2884),
    [anon_sym_COLON_DASH] = ACTIONS(2880),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2886),
  },
  [945] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [sym__special_character] = ACTIONS(2205),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [sym_file_descriptor] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [ts_builtin_sym_end] = ACTIONS(2207),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
  },
  [946] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2882),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [947] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2872),
    [sym__concat] = ACTIONS(2213),
  },
  [948] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2888),
  },
  [949] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2872),
  },
  [950] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2247),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2247),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2247),
    [sym_word] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_LT_AMP] = ACTIONS(2247),
    [anon_sym_GT_GT] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [sym__special_character] = ACTIONS(2247),
    [anon_sym_LT_LT_DASH] = ACTIONS(2247),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [sym_raw_string] = ACTIONS(2247),
    [sym_file_descriptor] = ACTIONS(2249),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_AMP_GT] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_LT_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_AMP] = ACTIONS(2247),
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_LT_LPAREN] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
    [anon_sym_PIPE_AMP] = ACTIONS(2247),
  },
  [951] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1265),
    [sym_concatenation] = STATE(1265),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2890),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2890),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2890),
    [anon_sym_PERCENT] = ACTIONS(2890),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2894),
    [anon_sym_COLON_DASH] = ACTIONS(2890),
    [sym__special_character] = ACTIONS(553),
  },
  [952] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [953] = {
    [aux_sym_concatenation_repeat1] = STATE(953),
    [anon_sym_BQUOTE] = ACTIONS(1392),
    [anon_sym_AMP_GT_GT] = ACTIONS(1392),
    [sym_raw_string] = ACTIONS(1392),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1392),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1392),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1392),
    [anon_sym_GT_LPAREN] = ACTIONS(1392),
    [sym_variable_name] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_word] = ACTIONS(1392),
    [anon_sym_GT_AMP] = ACTIONS(1392),
    [sym__concat] = ACTIONS(1998),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1392),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1392),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1392),
  },
  [954] = {
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [sym_raw_string] = ACTIONS(1290),
    [anon_sym_COLON_QMARK] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1288),
    [anon_sym_COLON] = ACTIONS(1288),
    [anon_sym_GT_LPAREN] = ACTIONS(1290),
    [anon_sym_DQUOTE] = ACTIONS(1290),
    [sym_word] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [anon_sym_LT_LPAREN] = ACTIONS(1290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1290),
    [anon_sym_COLON_DASH] = ACTIONS(1288),
    [sym__special_character] = ACTIONS(1288),
  },
  [955] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [sym_word] = ACTIONS(2896),
    [anon_sym_PIPE] = ACTIONS(2896),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_LT_AMP] = ACTIONS(2896),
    [anon_sym_GT_GT] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [anon_sym_EQ_TILDE] = ACTIONS(2896),
    [sym__special_character] = ACTIONS(2896),
    [anon_sym_LT_LT_DASH] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [sym_raw_string] = ACTIONS(2896),
    [sym_file_descriptor] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2896),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_AMP_GT] = ACTIONS(2896),
    [anon_sym_EQ_EQ] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [anon_sym_LT_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_AMP] = ACTIONS(2896),
    [ts_builtin_sym_end] = ACTIONS(2898),
    [anon_sym_LT_LPAREN] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
    [anon_sym_PIPE_AMP] = ACTIONS(2896),
  },
  [956] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [957] = {
    [anon_sym_BQUOTE] = ACTIONS(1392),
    [sym_raw_string] = ACTIONS(1392),
    [anon_sym_COLON_QMARK] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1392),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_COLON] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_word] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1392),
    [anon_sym_COLON_DASH] = ACTIONS(1390),
    [sym__special_character] = ACTIONS(1390),
  },
  [958] = {
    [sym_command_substitution] = STATE(957),
    [sym_simple_expansion] = STATE(957),
    [sym_string_expansion] = STATE(957),
    [sym_string] = STATE(957),
    [sym_process_substitution] = STATE(957),
    [sym_expansion] = STATE(957),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(2119),
    [sym_raw_string] = ACTIONS(2119),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [sym__special_character] = ACTIONS(2119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
  },
  [959] = {
    [aux_sym_concatenation_repeat1] = STATE(959),
    [anon_sym_BQUOTE] = ACTIONS(1392),
    [sym_raw_string] = ACTIONS(1392),
    [anon_sym_COLON_QMARK] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1392),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_COLON] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_word] = ACTIONS(1390),
    [sym__concat] = ACTIONS(2904),
    [anon_sym_LT_LPAREN] = ACTIONS(1392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1392),
    [anon_sym_COLON_DASH] = ACTIONS(1390),
    [sym__special_character] = ACTIONS(1390),
  },
  [960] = {
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [sym_raw_string] = ACTIONS(1284),
    [anon_sym_COLON_QMARK] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_DASH] = ACTIONS(1282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1284),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1284),
    [anon_sym_PERCENT] = ACTIONS(1282),
    [anon_sym_COLON] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [sym_word] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [anon_sym_LT_LPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1284),
    [anon_sym_COLON_DASH] = ACTIONS(1282),
    [sym__special_character] = ACTIONS(1282),
  },
  [961] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [sym_concatenation] = STATE(1270),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2907),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2907),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2907),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2907),
    [anon_sym_PERCENT] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2911),
    [anon_sym_COLON_DASH] = ACTIONS(2907),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2913),
  },
  [962] = {
    [anon_sym_BQUOTE] = ACTIONS(1326),
    [sym_raw_string] = ACTIONS(1326),
    [anon_sym_COLON_QMARK] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_RBRACE] = ACTIONS(1326),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1324),
    [anon_sym_COLON] = ACTIONS(1324),
    [anon_sym_GT_LPAREN] = ACTIONS(1326),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [sym_word] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [anon_sym_LT_LPAREN] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1326),
    [anon_sym_COLON_DASH] = ACTIONS(1324),
    [sym__special_character] = ACTIONS(1324),
  },
  [963] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [964] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [sym_concatenation] = STATE(1270),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2915),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2907),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2907),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2907),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2907),
    [anon_sym_PERCENT] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2911),
    [anon_sym_COLON_DASH] = ACTIONS(2907),
    [sym__special_character] = ACTIONS(553),
  },
  [965] = {
    [anon_sym_EQ] = ACTIONS(2917),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [966] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1275),
    [sym_concatenation] = STATE(1275),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2919),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2921),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2921),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2925),
    [anon_sym_COLON_DASH] = ACTIONS(2921),
    [sym__special_character] = ACTIONS(553),
  },
  [967] = {
    [sym_command_substitution] = STATE(1276),
    [aux_sym__literal_repeat1] = STATE(1277),
    [sym_string] = STATE(1276),
    [sym_process_substitution] = STATE(1276),
    [sym_simple_expansion] = STATE(1276),
    [sym_string_expansion] = STATE(1276),
    [sym_concatenation] = STATE(1278),
    [sym_expansion] = STATE(1276),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2927),
    [sym_raw_string] = ACTIONS(2927),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2909),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [968] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1281),
    [sym_concatenation] = STATE(1281),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2929),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2929),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2933),
    [anon_sym_COLON_DASH] = ACTIONS(2929),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(2935),
  },
  [969] = {
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [sym_raw_string] = ACTIONS(1382),
    [anon_sym_COLON_QMARK] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_RBRACE] = ACTIONS(1382),
    [anon_sym_DASH] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1382),
    [anon_sym_EQ] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1382),
    [anon_sym_PERCENT] = ACTIONS(1380),
    [anon_sym_COLON] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1382),
    [anon_sym_DQUOTE] = ACTIONS(1382),
    [sym_word] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1382),
    [anon_sym_COLON_DASH] = ACTIONS(1380),
    [sym__special_character] = ACTIONS(1380),
  },
  [970] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [971] = {
    [anon_sym_BQUOTE] = ACTIONS(1641),
    [sym_raw_string] = ACTIONS(1641),
    [anon_sym_COLON_QMARK] = ACTIONS(1639),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DASH] = ACTIONS(1639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1641),
    [anon_sym_EQ] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1641),
    [anon_sym_PERCENT] = ACTIONS(1639),
    [anon_sym_COLON] = ACTIONS(1639),
    [anon_sym_GT_LPAREN] = ACTIONS(1641),
    [anon_sym_DQUOTE] = ACTIONS(1641),
    [sym_word] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [anon_sym_LT_LPAREN] = ACTIONS(1641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1641),
    [anon_sym_COLON_DASH] = ACTIONS(1639),
    [sym__special_character] = ACTIONS(1639),
  },
  [972] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [973] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1283),
    [sym_concatenation] = STATE(1283),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2939),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2939),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2939),
    [anon_sym_PERCENT] = ACTIONS(2939),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2941),
    [anon_sym_COLON_DASH] = ACTIONS(2939),
    [sym__special_character] = ACTIONS(553),
  },
  [974] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2900),
    [sym__concat] = ACTIONS(2213),
  },
  [975] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2943),
  },
  [976] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2900),
  },
  [977] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [sym_word] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2945),
    [sym__special_character] = ACTIONS(2945),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [sym_file_descriptor] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [ts_builtin_sym_end] = ACTIONS(2947),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
  },
  [978] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1286),
    [sym_concatenation] = STATE(1286),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2949),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2949),
    [anon_sym_PERCENT] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2953),
    [anon_sym_COLON_DASH] = ACTIONS(2949),
    [sym__special_character] = ACTIONS(553),
  },
  [979] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [980] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2955),
  },
  [981] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [982] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(789),
    [sym__concat] = ACTIONS(789),
  },
  [983] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(2959),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [984] = {
    [sym_command_substitution] = STATE(1290),
    [sym_simple_expansion] = STATE(1290),
    [sym_string_expansion] = STATE(1290),
    [sym_string] = STATE(1290),
    [sym_process_substitution] = STATE(1290),
    [sym_expansion] = STATE(1290),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2961),
    [sym_raw_string] = ACTIONS(2961),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(2961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [985] = {
    [aux_sym_concatenation_repeat1] = STATE(1292),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(585),
    [sym__concat] = ACTIONS(2963),
  },
  [986] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2965),
  },
  [987] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(507),
    [sym__concat] = ACTIONS(507),
  },
  [988] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(511),
    [sym__concat] = ACTIONS(511),
  },
  [989] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(515),
    [sym__concat] = ACTIONS(515),
  },
  [990] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(2955),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [991] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2955),
  },
  [992] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1296),
    [sym_concatenation] = STATE(1296),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2967),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2969),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2971),
    [anon_sym_DASH] = ACTIONS(2969),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2969),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2969),
    [anon_sym_PERCENT] = ACTIONS(2969),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2973),
    [anon_sym_COLON_DASH] = ACTIONS(2969),
    [sym__special_character] = ACTIONS(553),
  },
  [993] = {
    [sym_subscript] = STATE(1297),
    [anon_sym_STAR] = ACTIONS(2975),
    [anon_sym_QMARK] = ACTIONS(2975),
    [anon_sym_AT] = ACTIONS(2975),
    [sym_variable_name] = ACTIONS(2977),
    [anon_sym_DOLLAR] = ACTIONS(2979),
    [anon_sym_DASH] = ACTIONS(2979),
    [anon_sym_0] = ACTIONS(2981),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2981),
    [anon_sym__] = ACTIONS(2981),
  },
  [994] = {
    [anon_sym_EQ] = ACTIONS(2983),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [995] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1303),
    [sym_concatenation] = STATE(1303),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(2985),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(2987),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2987),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(2987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2991),
    [anon_sym_COLON_DASH] = ACTIONS(2987),
    [sym__special_character] = ACTIONS(553),
  },
  [996] = {
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_RBRACE] = ACTIONS(189),
  },
  [997] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [sym_word] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_LT_AMP] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [anon_sym_EQ_TILDE] = ACTIONS(2993),
    [sym__special_character] = ACTIONS(2993),
    [anon_sym_LT_LT_DASH] = ACTIONS(2993),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [sym_raw_string] = ACTIONS(2993),
    [sym_file_descriptor] = ACTIONS(2995),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_AMP_GT] = ACTIONS(2993),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_LT_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_AMP] = ACTIONS(2993),
    [ts_builtin_sym_end] = ACTIONS(2995),
    [anon_sym_LT_LPAREN] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
    [anon_sym_PIPE_AMP] = ACTIONS(2993),
  },
  [998] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2997),
    [anon_sym_RBRACE] = ACTIONS(888),
  },
  [999] = {
    [anon_sym_BQUOTE] = ACTIONS(2530),
    [anon_sym_SLASH] = ACTIONS(2530),
    [sym_raw_string] = ACTIONS(2530),
    [anon_sym_COLON_QMARK] = ACTIONS(3000),
    [anon_sym_DOLLAR] = ACTIONS(3000),
    [anon_sym_RBRACE] = ACTIONS(2530),
    [anon_sym_DASH] = ACTIONS(3000),
    [anon_sym_EQ] = ACTIONS(3000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2530),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2530),
    [anon_sym_PERCENT] = ACTIONS(3000),
    [anon_sym_COLON] = ACTIONS(3000),
    [anon_sym_GT_LPAREN] = ACTIONS(2530),
    [anon_sym_DQUOTE] = ACTIONS(2530),
    [sym_word] = ACTIONS(3000),
    [sym__concat] = ACTIONS(3002),
    [anon_sym_LT_LPAREN] = ACTIONS(2530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2530),
    [anon_sym_COLON_DASH] = ACTIONS(3000),
    [sym__special_character] = ACTIONS(3000),
  },
  [1000] = {
    [sym_command_substitution] = STATE(844),
    [sym_simple_expansion] = STATE(844),
    [sym_string_expansion] = STATE(844),
    [sym_string] = STATE(844),
    [sym_process_substitution] = STATE(844),
    [sym_expansion] = STATE(844),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym_word] = ACTIONS(1776),
    [sym_raw_string] = ACTIONS(1776),
    [anon_sym_LT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR] = ACTIONS(279),
    [anon_sym_RBRACK] = ACTIONS(3004),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [sym__special_character] = ACTIONS(2536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(285),
  },
  [1001] = {
    [anon_sym_BQUOTE] = ACTIONS(2540),
    [anon_sym_SLASH] = ACTIONS(2540),
    [sym_raw_string] = ACTIONS(2540),
    [anon_sym_COLON_QMARK] = ACTIONS(3006),
    [anon_sym_DOLLAR] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [anon_sym_DASH] = ACTIONS(3006),
    [anon_sym_EQ] = ACTIONS(3006),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2540),
    [anon_sym_PERCENT] = ACTIONS(3006),
    [anon_sym_COLON] = ACTIONS(3006),
    [anon_sym_GT_LPAREN] = ACTIONS(2540),
    [anon_sym_DQUOTE] = ACTIONS(2540),
    [sym_word] = ACTIONS(3006),
    [sym__concat] = ACTIONS(3008),
    [anon_sym_LT_LPAREN] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2540),
    [anon_sym_COLON_DASH] = ACTIONS(3006),
    [sym__special_character] = ACTIONS(3006),
  },
  [1002] = {
    [anon_sym_RBRACK] = ACTIONS(3010),
    [sym_comment] = ACTIONS(51),
  },
  [1003] = {
    [anon_sym_RBRACK] = ACTIONS(3004),
    [sym_comment] = ACTIONS(51),
  },
  [1004] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3012),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [sym_word] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_LT_AMP] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [anon_sym_EQ_TILDE] = ACTIONS(3012),
    [sym__special_character] = ACTIONS(3012),
    [anon_sym_LT_LT_DASH] = ACTIONS(3012),
    [anon_sym_BQUOTE] = ACTIONS(3012),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [sym_raw_string] = ACTIONS(3012),
    [sym_file_descriptor] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_AMP_GT] = ACTIONS(3012),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_LT_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_AMP] = ACTIONS(3012),
    [ts_builtin_sym_end] = ACTIONS(3014),
    [anon_sym_LT_LPAREN] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
    [anon_sym_PIPE_AMP] = ACTIONS(3012),
  },
  [1005] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1006] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3018),
    [anon_sym_BQUOTE] = ACTIONS(3018),
    [anon_sym_AMP_GT_GT] = ACTIONS(3018),
    [anon_sym_LF] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_LT_LT] = ACTIONS(3018),
    [sym_file_descriptor] = ACTIONS(3020),
    [anon_sym_GT] = ACTIONS(3018),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [anon_sym_AMP_GT] = ACTIONS(3018),
    [anon_sym_PIPE_PIPE] = ACTIONS(3018),
    [ts_builtin_sym_end] = ACTIONS(3020),
    [anon_sym_LT_LT_LT] = ACTIONS(3018),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_GT_AMP] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3018),
    [anon_sym_LT_AMP] = ACTIONS(3018),
    [anon_sym_GT_GT] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3018),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_SEMI_SEMI] = ACTIONS(3018),
    [anon_sym_PIPE_AMP] = ACTIONS(3018),
  },
  [1007] = {
    [aux_sym_concatenation_repeat1] = STATE(1007),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(2035),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1008] = {
    [aux_sym_concatenation_repeat1] = STATE(653),
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__concat] = ACTIONS(425),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [1009] = {
    [aux_sym__literal_repeat1] = STATE(655),
    [anon_sym_AMP_GT_GT] = ACTIONS(1613),
    [anon_sym_DOLLAR] = ACTIONS(1613),
    [anon_sym_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1613),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1613),
    [anon_sym_PIPE_PIPE] = ACTIONS(1613),
    [sym_word] = ACTIONS(1613),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_LT_AMP] = ACTIONS(1613),
    [anon_sym_GT_GT] = ACTIONS(1613),
    [sym__special_character] = ACTIONS(453),
    [anon_sym_LT_LT_DASH] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1613),
    [anon_sym_LF] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1613),
    [sym_raw_string] = ACTIONS(1613),
    [sym_variable_name] = ACTIONS(1617),
    [sym_file_descriptor] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1613),
    [anon_sym_AMP_GT] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_LT_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_AMP] = ACTIONS(1613),
    [anon_sym_LT_LPAREN] = ACTIONS(1613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1613),
    [anon_sym_SEMI_SEMI] = ACTIONS(1613),
    [anon_sym_PIPE_AMP] = ACTIONS(1613),
  },
  [1010] = {
    [aux_sym_concatenation_repeat1] = STATE(1010),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(2074),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1011] = {
    [aux_sym_concatenation_repeat1] = STATE(1309),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(2497),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [1012] = {
    [aux_sym__literal_repeat1] = STATE(1012),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(2527),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_variable_name] = ACTIONS(888),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [1013] = {
    [aux_sym_concatenation_repeat1] = STATE(1310),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [sym__concat] = ACTIONS(2737),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [1014] = {
    [aux_sym__literal_repeat1] = STATE(1014),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [sym__special_character] = ACTIONS(2767),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [1015] = {
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_AMP_GT_GT] = ACTIONS(2796),
    [anon_sym_local] = ACTIONS(2794),
    [anon_sym_typeset] = ACTIONS(2794),
    [anon_sym_unsetenv] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2794),
    [anon_sym_GT_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2794),
    [sym_word] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_LT_AMP] = ACTIONS(2796),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2794),
    [sym__special_character] = ACTIONS(2794),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2794),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2796),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BQUOTE] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [sym_variable_name] = ACTIONS(2796),
    [sym_file_descriptor] = ACTIONS(2796),
    [anon_sym_RBRACE] = ACTIONS(2796),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP_GT] = ACTIONS(2794),
    [anon_sym_readonly] = ACTIONS(2794),
    [anon_sym_unset] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [anon_sym_GT_AMP] = ACTIONS(2796),
    [anon_sym_LT_LPAREN] = ACTIONS(2796),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2796),
  },
  [1016] = {
    [aux_sym_concatenation_repeat1] = STATE(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1633),
    [anon_sym_AMP_GT_GT] = ACTIONS(1633),
    [anon_sym_LF] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [sym_file_descriptor] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_AMP_GT] = ACTIONS(1633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_LT_LT_LT] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_GT_AMP] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_LT_AMP] = ACTIONS(1633),
    [anon_sym_GT_GT] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [anon_sym_SEMI_SEMI] = ACTIONS(1633),
    [anon_sym_PIPE_AMP] = ACTIONS(1633),
  },
  [1017] = {
    [aux_sym__literal_repeat1] = STATE(1014),
    [anon_sym_LT_LT_DASH] = ACTIONS(1637),
    [anon_sym_AMP_GT_GT] = ACTIONS(1637),
    [anon_sym_LF] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_LT_LT] = ACTIONS(1637),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_AMP_GT] = ACTIONS(1637),
    [anon_sym_PIPE_PIPE] = ACTIONS(1637),
    [anon_sym_LT_LT_LT] = ACTIONS(1637),
    [anon_sym_PIPE] = ACTIONS(1637),
    [anon_sym_GT_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_LT_AMP] = ACTIONS(1637),
    [anon_sym_GT_GT] = ACTIONS(1637),
    [anon_sym_AMP] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1637),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1637),
    [anon_sym_PIPE_AMP] = ACTIONS(1637),
  },
  [1018] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1311),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_fi] = ACTIONS(3022),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1019] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_then] = ACTIONS(3024),
  },
  [1020] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3026),
    [anon_sym_BQUOTE] = ACTIONS(3026),
    [anon_sym_AMP_GT_GT] = ACTIONS(3026),
    [anon_sym_LF] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3026),
    [anon_sym_LT_LT] = ACTIONS(3026),
    [sym_file_descriptor] = ACTIONS(3028),
    [anon_sym_GT] = ACTIONS(3026),
    [anon_sym_RPAREN] = ACTIONS(3026),
    [anon_sym_AMP_GT] = ACTIONS(3026),
    [anon_sym_PIPE_PIPE] = ACTIONS(3026),
    [ts_builtin_sym_end] = ACTIONS(3028),
    [anon_sym_LT_LT_LT] = ACTIONS(3026),
    [anon_sym_PIPE] = ACTIONS(3026),
    [anon_sym_GT_AMP] = ACTIONS(3026),
    [anon_sym_LT] = ACTIONS(3026),
    [anon_sym_LT_AMP] = ACTIONS(3026),
    [anon_sym_GT_GT] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3026),
    [anon_sym_AMP_AMP] = ACTIONS(3026),
    [anon_sym_SEMI_SEMI] = ACTIONS(3026),
    [anon_sym_PIPE_AMP] = ACTIONS(3026),
  },
  [1021] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1021),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_local] = ACTIONS(938),
    [anon_sym_typeset] = ACTIONS(938),
    [anon_sym_unsetenv] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [anon_sym_fi] = ACTIONS(906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_else] = ACTIONS(906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(953),
    [anon_sym_GT_LPAREN] = ACTIONS(947),
    [anon_sym_function] = ACTIONS(956),
    [sym_word] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(938),
    [sym__special_character] = ACTIONS(968),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(974),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(980),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_declare] = ACTIONS(938),
    [sym_variable_name] = ACTIONS(989),
    [sym_file_descriptor] = ACTIONS(992),
    [anon_sym_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(965),
    [anon_sym_readonly] = ACTIONS(938),
    [anon_sym_unset] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LPAREN] = ACTIONS(947),
    [anon_sym_elif] = ACTIONS(906),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(1004),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1007),
  },
  [1022] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3030),
  },
  [1023] = {
    [aux_sym_if_statement_repeat1] = STATE(1024),
    [sym_elif_clause] = STATE(1024),
    [sym_else_clause] = STATE(1314),
    [anon_sym_elif] = ACTIONS(2328),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3030),
    [anon_sym_else] = ACTIONS(2330),
  },
  [1024] = {
    [aux_sym_if_statement_repeat1] = STATE(1024),
    [sym_elif_clause] = STATE(1024),
    [anon_sym_elif] = ACTIONS(3032),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3035),
    [anon_sym_else] = ACTIONS(3035),
  },
  [1025] = {
    [anon_sym_AMP] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [anon_sym_in] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
  },
  [1026] = {
    [sym_command_substitution] = STATE(1027),
    [aux_sym__literal_repeat1] = STATE(1030),
    [sym_case_item] = STATE(1317),
    [sym_string] = STATE(1027),
    [sym_process_substitution] = STATE(1027),
    [sym_last_case_item] = STATE(1316),
    [sym_simple_expansion] = STATE(1027),
    [sym_string_expansion] = STATE(1027),
    [aux_sym_case_statement_repeat1] = STATE(1317),
    [sym_concatenation] = STATE(1033),
    [sym_expansion] = STATE(1027),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(2338),
    [sym_raw_string] = ACTIONS(2340),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_esac] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [1027] = {
    [aux_sym_concatenation_repeat1] = STATE(1320),
    [aux_sym_case_item_repeat1] = STATE(1321),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [sym__concat] = ACTIONS(691),
    [anon_sym_PIPE] = ACTIONS(3041),
  },
  [1028] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3043),
    [anon_sym_BQUOTE] = ACTIONS(3043),
    [anon_sym_AMP_GT_GT] = ACTIONS(3043),
    [anon_sym_LF] = ACTIONS(3045),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_LT_LT] = ACTIONS(3043),
    [sym_file_descriptor] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3043),
    [anon_sym_RPAREN] = ACTIONS(3043),
    [anon_sym_AMP_GT] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [ts_builtin_sym_end] = ACTIONS(3045),
    [anon_sym_LT_LT_LT] = ACTIONS(3043),
    [anon_sym_PIPE] = ACTIONS(3043),
    [anon_sym_GT_AMP] = ACTIONS(3043),
    [anon_sym_LT] = ACTIONS(3043),
    [anon_sym_LT_AMP] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_SEMI_SEMI] = ACTIONS(3043),
    [anon_sym_PIPE_AMP] = ACTIONS(3043),
  },
  [1029] = {
    [aux_sym_concatenation_repeat1] = STATE(1320),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(189),
    [sym__concat] = ACTIONS(691),
    [anon_sym_PIPE] = ACTIONS(189),
    [sym__special_character] = ACTIONS(189),
  },
  [1030] = {
    [aux_sym__literal_repeat1] = STATE(1323),
    [aux_sym_case_item_repeat1] = STATE(1324),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3047),
    [anon_sym_PIPE] = ACTIONS(3041),
    [sym__special_character] = ACTIONS(715),
  },
  [1031] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(3049),
  },
  [1032] = {
    [sym_command_substitution] = STATE(1027),
    [aux_sym__literal_repeat1] = STATE(1030),
    [sym_case_item] = STATE(1325),
    [sym_string] = STATE(1027),
    [sym_process_substitution] = STATE(1027),
    [sym_last_case_item] = STATE(1316),
    [sym_simple_expansion] = STATE(1027),
    [sym_string_expansion] = STATE(1027),
    [aux_sym_case_statement_repeat1] = STATE(1325),
    [sym_concatenation] = STATE(1033),
    [sym_expansion] = STATE(1027),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(2340),
    [sym_raw_string] = ACTIONS(2340),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [1033] = {
    [aux_sym_case_item_repeat1] = STATE(1321),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [sym_comment] = ACTIONS(51),
  },
  [1034] = {
    [sym_string] = STATE(358),
    [anon_sym_STAR] = ACTIONS(653),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3053),
    [anon_sym_0] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(3053),
    [aux_sym__simple_variable_name_token1] = ACTIONS(653),
    [anon_sym_in] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(653),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3053),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym__] = ACTIONS(653),
  },
  [1035] = {
    [anon_sym_AMP] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2111),
    [anon_sym_LF] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [anon_sym_in] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
  },
  [1036] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1327),
    [sym_concatenation] = STATE(1327),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3057),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3061),
    [anon_sym_COLON_DASH] = ACTIONS(3057),
    [sym__special_character] = ACTIONS(553),
  },
  [1037] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1038] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1327),
    [sym_concatenation] = STATE(1327),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3057),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3061),
    [anon_sym_COLON_DASH] = ACTIONS(3057),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3063),
  },
  [1039] = {
    [sym_command_substitution] = STATE(1329),
    [aux_sym__literal_repeat1] = STATE(1330),
    [sym_string] = STATE(1329),
    [sym_process_substitution] = STATE(1329),
    [sym_simple_expansion] = STATE(1329),
    [sym_string_expansion] = STATE(1329),
    [sym_concatenation] = STATE(1331),
    [sym_expansion] = STATE(1329),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3065),
    [sym_raw_string] = ACTIONS(3065),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1040] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1334),
    [sym_concatenation] = STATE(1334),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3071),
    [anon_sym_COLON_DASH] = ACTIONS(3067),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3073),
  },
  [1041] = {
    [anon_sym_AMP] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2207),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_in] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
  },
  [1042] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1043] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [sym__concat] = ACTIONS(2213),
  },
  [1044] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3075),
  },
  [1045] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3059),
  },
  [1046] = {
    [anon_sym_AMP] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2249),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym_in] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
  },
  [1047] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1337),
    [sym_concatenation] = STATE(1337),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3077),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3077),
    [anon_sym_PERCENT] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3081),
    [anon_sym_COLON_DASH] = ACTIONS(3077),
    [sym__special_character] = ACTIONS(553),
  },
  [1048] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1049] = {
    [sym_command_substitution] = STATE(1027),
    [aux_sym__literal_repeat1] = STATE(1030),
    [sym_case_item] = STATE(1340),
    [sym_string] = STATE(1027),
    [sym_process_substitution] = STATE(1027),
    [sym_last_case_item] = STATE(1339),
    [sym_simple_expansion] = STATE(1027),
    [sym_string_expansion] = STATE(1027),
    [aux_sym_case_statement_repeat1] = STATE(1340),
    [sym_concatenation] = STATE(1033),
    [sym_expansion] = STATE(1027),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(2338),
    [sym_raw_string] = ACTIONS(2340),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_esac] = ACTIONS(3083),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [1050] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3085),
    [anon_sym_BQUOTE] = ACTIONS(3085),
    [anon_sym_AMP_GT_GT] = ACTIONS(3085),
    [anon_sym_LF] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [sym_file_descriptor] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_AMP_GT] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [ts_builtin_sym_end] = ACTIONS(3087),
    [anon_sym_LT_LT_LT] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_GT_AMP] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_LT_AMP] = ACTIONS(3085),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_SEMI_SEMI] = ACTIONS(3085),
    [anon_sym_PIPE_AMP] = ACTIONS(3085),
  },
  [1051] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(3089),
  },
  [1052] = {
    [sym_command_substitution] = STATE(1027),
    [aux_sym__literal_repeat1] = STATE(1030),
    [sym_case_item] = STATE(1325),
    [sym_string] = STATE(1027),
    [sym_process_substitution] = STATE(1027),
    [sym_last_case_item] = STATE(1339),
    [sym_simple_expansion] = STATE(1027),
    [sym_string_expansion] = STATE(1027),
    [aux_sym_case_statement_repeat1] = STATE(1325),
    [sym_concatenation] = STATE(1033),
    [sym_expansion] = STATE(1027),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(2340),
    [sym_raw_string] = ACTIONS(2340),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [1053] = {
    [aux_sym_concatenation_repeat1] = STATE(1053),
    [anon_sym_BANG_EQ] = ACTIONS(1392),
    [anon_sym_PLUS_EQ] = ACTIONS(1392),
    [sym_test_operator] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [anon_sym_RPAREN] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1392),
    [anon_sym_PIPE_PIPE] = ACTIONS(1392),
    [anon_sym_GT_EQ] = ACTIONS(1392),
    [sym__concat] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_LT_EQ] = ACTIONS(1392),
    [anon_sym_AMP_AMP] = ACTIONS(1392),
    [anon_sym_DASH_EQ] = ACTIONS(1392),
  },
  [1054] = {
    [anon_sym_BANG_EQ] = ACTIONS(2585),
    [anon_sym_PLUS_EQ] = ACTIONS(2585),
    [sym_test_operator] = ACTIONS(2585),
    [anon_sym_PLUS_PLUS] = ACTIONS(2585),
    [anon_sym_RPAREN] = ACTIONS(2583),
    [anon_sym_DASH] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_EQ] = ACTIONS(2583),
    [anon_sym_EQ_EQ] = ACTIONS(2585),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2585),
    [anon_sym_GT_EQ] = ACTIONS(2585),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2585),
    [anon_sym_PLUS] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_PIPE] = ACTIONS(2583),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2585),
    [anon_sym_DASH_DASH] = ACTIONS(2585),
    [anon_sym_LT_EQ] = ACTIONS(2585),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_DASH_EQ] = ACTIONS(2585),
  },
  [1055] = {
    [sym_string] = STATE(384),
    [sym_test_operator] = ACTIONS(2265),
    [anon_sym_PLUS_EQ] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_DOLLAR] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(3091),
    [aux_sym__simple_variable_name_token1] = ACTIONS(699),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2265),
    [anon_sym_PIPE_PIPE] = ACTIONS(2265),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2265),
    [anon_sym_QMARK] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_EQ_TILDE] = ACTIONS(2265),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_LT_EQ] = ACTIONS(2265),
    [anon_sym_DASH_EQ] = ACTIONS(2265),
    [anon_sym_BANG_EQ] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(693),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_BANG] = ACTIONS(3091),
    [anon_sym_0] = ACTIONS(699),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(2265),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(697),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym__] = ACTIONS(699),
  },
  [1056] = {
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_PLUS_EQ] = ACTIONS(2111),
    [sym_test_operator] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_RPAREN] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_EQ] = ACTIONS(2109),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2111),
    [anon_sym_PIPE_PIPE] = ACTIONS(2111),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [sym__concat] = ACTIONS(2111),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2109),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_AMP_AMP] = ACTIONS(2111),
    [anon_sym_DASH_EQ] = ACTIONS(2111),
  },
  [1057] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1342),
    [sym_concatenation] = STATE(1342),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3093),
    [anon_sym_PERCENT] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3097),
    [anon_sym_COLON_DASH] = ACTIONS(3093),
    [sym__special_character] = ACTIONS(553),
  },
  [1058] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1059] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1342),
    [sym_concatenation] = STATE(1342),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3093),
    [anon_sym_PERCENT] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3097),
    [anon_sym_COLON_DASH] = ACTIONS(3093),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3099),
  },
  [1060] = {
    [sym_command_substitution] = STATE(1344),
    [aux_sym__literal_repeat1] = STATE(1345),
    [sym_string] = STATE(1344),
    [sym_process_substitution] = STATE(1344),
    [sym_simple_expansion] = STATE(1344),
    [sym_string_expansion] = STATE(1344),
    [sym_concatenation] = STATE(1346),
    [sym_expansion] = STATE(1344),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3101),
    [sym_raw_string] = ACTIONS(3101),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1061] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1349),
    [sym_concatenation] = STATE(1349),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3107),
    [anon_sym_COLON_DASH] = ACTIONS(3103),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3109),
  },
  [1062] = {
    [anon_sym_BANG_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [sym_test_operator] = ACTIONS(2207),
    [anon_sym_PLUS_PLUS] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_GT_EQ] = ACTIONS(2207),
    [sym__concat] = ACTIONS(2207),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2207),
    [anon_sym_DASH_DASH] = ACTIONS(2207),
    [anon_sym_LT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
  },
  [1063] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1064] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [sym__concat] = ACTIONS(2213),
  },
  [1065] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3111),
  },
  [1066] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3095),
  },
  [1067] = {
    [anon_sym_BANG_EQ] = ACTIONS(2249),
    [anon_sym_PLUS_EQ] = ACTIONS(2249),
    [sym_test_operator] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_EQ] = ACTIONS(2247),
    [anon_sym_EQ_EQ] = ACTIONS(2249),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2249),
    [anon_sym_PIPE_PIPE] = ACTIONS(2249),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [sym__concat] = ACTIONS(2249),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2249),
    [anon_sym_PLUS] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2247),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2249),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_LT_EQ] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_DASH_EQ] = ACTIONS(2249),
  },
  [1068] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1352),
    [sym_concatenation] = STATE(1352),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3113),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3113),
    [anon_sym_PERCENT] = ACTIONS(3113),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3117),
    [anon_sym_COLON_DASH] = ACTIONS(3113),
    [sym__special_character] = ACTIONS(553),
  },
  [1069] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1070] = {
    [aux_sym_concatenation_repeat1] = STATE(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [sym__concat] = ACTIONS(2737),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [1071] = {
    [aux_sym__literal_repeat1] = STATE(1071),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [sym__special_character] = ACTIONS(2767),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [1072] = {
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_AMP_GT_GT] = ACTIONS(2796),
    [anon_sym_local] = ACTIONS(2794),
    [anon_sym_typeset] = ACTIONS(2794),
    [anon_sym_unsetenv] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2794),
    [anon_sym_GT_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2794),
    [sym_word] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_LT_AMP] = ACTIONS(2796),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2794),
    [sym__special_character] = ACTIONS(2794),
    [anon_sym_BQUOTE] = ACTIONS(2798),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2796),
    [anon_sym_case] = ACTIONS(2794),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [sym_variable_name] = ACTIONS(2796),
    [sym_file_descriptor] = ACTIONS(2796),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP_GT] = ACTIONS(2794),
    [anon_sym_readonly] = ACTIONS(2794),
    [anon_sym_unset] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [anon_sym_GT_AMP] = ACTIONS(2796),
    [anon_sym_LT_LPAREN] = ACTIONS(2796),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2796),
  },
  [1073] = {
    [aux_sym_concatenation_repeat1] = STATE(1070),
    [anon_sym_LT_LT_DASH] = ACTIONS(1633),
    [anon_sym_BQUOTE] = ACTIONS(1633),
    [anon_sym_AMP_GT_GT] = ACTIONS(1633),
    [anon_sym_LF] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [sym_file_descriptor] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_AMP_GT] = ACTIONS(1633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_LT_LT_LT] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_GT_AMP] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_LT_AMP] = ACTIONS(1633),
    [anon_sym_GT_GT] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [sym__concat] = ACTIONS(1826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [anon_sym_SEMI_SEMI] = ACTIONS(1633),
    [anon_sym_PIPE_AMP] = ACTIONS(1633),
  },
  [1074] = {
    [aux_sym__literal_repeat1] = STATE(1071),
    [anon_sym_LT_LT_DASH] = ACTIONS(1637),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [anon_sym_AMP_GT_GT] = ACTIONS(1637),
    [anon_sym_LF] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_LT_LT] = ACTIONS(1637),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_AMP_GT] = ACTIONS(1637),
    [anon_sym_PIPE_PIPE] = ACTIONS(1637),
    [anon_sym_LT_LT_LT] = ACTIONS(1637),
    [anon_sym_PIPE] = ACTIONS(1637),
    [anon_sym_GT_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_LT_AMP] = ACTIONS(1637),
    [anon_sym_GT_GT] = ACTIONS(1637),
    [anon_sym_AMP] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1637),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1637),
    [anon_sym_PIPE_AMP] = ACTIONS(1637),
  },
  [1075] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2800),
    [anon_sym_LF] = ACTIONS(3119),
    [anon_sym_SEMI] = ACTIONS(3121),
    [anon_sym_SEMI_SEMI] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3121),
  },
  [1076] = {
    [anon_sym_BQUOTE] = ACTIONS(2469),
    [anon_sym_AMP_GT_GT] = ACTIONS(2469),
    [sym_raw_string] = ACTIONS(2469),
    [anon_sym_DOLLAR] = ACTIONS(2467),
    [sym_file_descriptor] = ACTIONS(2469),
    [sym_variable_name] = ACTIONS(2469),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2469),
    [anon_sym_AMP_GT] = ACTIONS(2467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2469),
    [anon_sym_GT_LPAREN] = ACTIONS(2469),
    [anon_sym_DQUOTE] = ACTIONS(2469),
    [sym_word] = ACTIONS(2469),
    [anon_sym_GT_AMP] = ACTIONS(2469),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_LT_AMP] = ACTIONS(2469),
    [anon_sym_GT_GT] = ACTIONS(2469),
    [anon_sym_LT_LPAREN] = ACTIONS(2469),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2469),
  },
  [1077] = {
    [sym_command_substitution] = STATE(753),
    [aux_sym__literal_repeat1] = STATE(760),
    [sym_string] = STATE(753),
    [sym_process_substitution] = STATE(753),
    [aux_sym_for_statement_repeat1] = STATE(1097),
    [sym_simple_expansion] = STATE(753),
    [sym_string_expansion] = STATE(753),
    [sym_concatenation] = STATE(1097),
    [sym_expansion] = STATE(753),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(1571),
    [sym_raw_string] = ACTIONS(1571),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(3123),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [1078] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3125),
  },
  [1079] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1080] = {
    [anon_sym_BQUOTE] = ACTIONS(789),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [sym_word] = ACTIONS(789),
    [sym_raw_string] = ACTIONS(789),
    [sym__concat] = ACTIONS(789),
    [anon_sym_LT_LPAREN] = ACTIONS(789),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_RPAREN] = ACTIONS(789),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(789),
    [sym__special_character] = ACTIONS(789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(789),
  },
  [1081] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(3129),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [1082] = {
    [sym_command_substitution] = STATE(1359),
    [sym_simple_expansion] = STATE(1359),
    [sym_string_expansion] = STATE(1359),
    [sym_string] = STATE(1359),
    [sym_process_substitution] = STATE(1359),
    [sym_expansion] = STATE(1359),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(3131),
    [sym_raw_string] = ACTIONS(3131),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(3131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [1083] = {
    [aux_sym_concatenation_repeat1] = STATE(1361),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [sym__concat] = ACTIONS(3133),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_RPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [sym__special_character] = ACTIONS(585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
  },
  [1084] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3135),
  },
  [1085] = {
    [anon_sym_BQUOTE] = ACTIONS(507),
    [anon_sym_DQUOTE] = ACTIONS(507),
    [sym_word] = ACTIONS(507),
    [sym_raw_string] = ACTIONS(507),
    [sym__concat] = ACTIONS(507),
    [anon_sym_LT_LPAREN] = ACTIONS(507),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(507),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(507),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(507),
    [sym__special_character] = ACTIONS(507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(507),
  },
  [1086] = {
    [anon_sym_BQUOTE] = ACTIONS(511),
    [anon_sym_DQUOTE] = ACTIONS(511),
    [sym_word] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(511),
    [sym__concat] = ACTIONS(511),
    [anon_sym_LT_LPAREN] = ACTIONS(511),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_RPAREN] = ACTIONS(511),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(511),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(511),
    [sym__special_character] = ACTIONS(511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(511),
  },
  [1087] = {
    [anon_sym_BQUOTE] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(515),
    [sym_word] = ACTIONS(515),
    [sym_raw_string] = ACTIONS(515),
    [sym__concat] = ACTIONS(515),
    [anon_sym_LT_LPAREN] = ACTIONS(515),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_RPAREN] = ACTIONS(515),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [sym__special_character] = ACTIONS(515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
  },
  [1088] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(3125),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [1089] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3125),
  },
  [1090] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1365),
    [sym_concatenation] = STATE(1365),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3137),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3141),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3143),
    [anon_sym_COLON_DASH] = ACTIONS(3139),
    [sym__special_character] = ACTIONS(553),
  },
  [1091] = {
    [sym_subscript] = STATE(1366),
    [anon_sym_STAR] = ACTIONS(3145),
    [anon_sym_QMARK] = ACTIONS(3145),
    [anon_sym_AT] = ACTIONS(3145),
    [sym_variable_name] = ACTIONS(3147),
    [anon_sym_DOLLAR] = ACTIONS(3149),
    [anon_sym_DASH] = ACTIONS(3149),
    [anon_sym_0] = ACTIONS(3151),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3151),
    [anon_sym__] = ACTIONS(3151),
  },
  [1092] = {
    [anon_sym_EQ] = ACTIONS(3153),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1093] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1372),
    [sym_concatenation] = STATE(1372),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3155),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3157),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3159),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3157),
    [anon_sym_PERCENT] = ACTIONS(3157),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3161),
    [anon_sym_COLON_DASH] = ACTIONS(3157),
    [sym__special_character] = ACTIONS(553),
  },
  [1094] = {
    [anon_sym_BQUOTE] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(189),
    [sym_word] = ACTIONS(189),
    [sym_raw_string] = ACTIONS(189),
    [anon_sym_LT_LPAREN] = ACTIONS(189),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_RPAREN] = ACTIONS(189),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(189),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(189),
    [sym__special_character] = ACTIONS(189),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(189),
  },
  [1095] = {
    [aux_sym__literal_repeat1] = STATE(1095),
    [anon_sym_BQUOTE] = ACTIONS(888),
    [anon_sym_DQUOTE] = ACTIONS(888),
    [sym_word] = ACTIONS(888),
    [sym_raw_string] = ACTIONS(888),
    [anon_sym_LT_LPAREN] = ACTIONS(888),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_RPAREN] = ACTIONS(888),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(888),
    [sym__special_character] = ACTIONS(3163),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(888),
  },
  [1096] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3166),
    [anon_sym_DOLLAR] = ACTIONS(3166),
    [anon_sym_LT_LT] = ACTIONS(3166),
    [anon_sym_GT_LPAREN] = ACTIONS(3166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3166),
    [sym_word] = ACTIONS(3166),
    [anon_sym_PIPE] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3166),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_LT_AMP] = ACTIONS(3166),
    [anon_sym_GT_GT] = ACTIONS(3166),
    [sym__special_character] = ACTIONS(3166),
    [anon_sym_LT_LT_DASH] = ACTIONS(3166),
    [anon_sym_BQUOTE] = ACTIONS(3166),
    [anon_sym_LF] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3166),
    [sym_raw_string] = ACTIONS(3166),
    [sym_variable_name] = ACTIONS(3168),
    [sym_file_descriptor] = ACTIONS(3168),
    [anon_sym_RPAREN] = ACTIONS(3166),
    [anon_sym_GT] = ACTIONS(3166),
    [anon_sym_AMP_GT] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [anon_sym_LT_LT_LT] = ACTIONS(3166),
    [anon_sym_GT_AMP] = ACTIONS(3166),
    [ts_builtin_sym_end] = ACTIONS(3168),
    [anon_sym_LT_LPAREN] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_SEMI_SEMI] = ACTIONS(3166),
    [anon_sym_PIPE_AMP] = ACTIONS(3166),
  },
  [1097] = {
    [sym_command_substitution] = STATE(753),
    [aux_sym__literal_repeat1] = STATE(760),
    [sym_string] = STATE(753),
    [sym_process_substitution] = STATE(753),
    [aux_sym_for_statement_repeat1] = STATE(1097),
    [sym_simple_expansion] = STATE(753),
    [sym_string_expansion] = STATE(753),
    [sym_concatenation] = STATE(1097),
    [sym_expansion] = STATE(753),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3173),
    [sym_word] = ACTIONS(3176),
    [sym_raw_string] = ACTIONS(3176),
    [anon_sym_LT_LPAREN] = ACTIONS(3179),
    [anon_sym_DOLLAR] = ACTIONS(3182),
    [anon_sym_RPAREN] = ACTIONS(3185),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3187),
    [sym__special_character] = ACTIONS(3190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3193),
  },
  [1098] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE_PIPE] = ACTIONS(1288),
    [sym_word] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_LT_AMP] = ACTIONS(1288),
    [anon_sym_GT_GT] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [sym__special_character] = ACTIONS(1288),
    [anon_sym_LT_LT_DASH] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LF] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1288),
    [sym_raw_string] = ACTIONS(1288),
    [sym_variable_name] = ACTIONS(1290),
    [sym_file_descriptor] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_AMP_GT] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_LT_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_AMP] = ACTIONS(1288),
    [ts_builtin_sym_end] = ACTIONS(1290),
    [anon_sym_LT_LPAREN] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
    [anon_sym_PIPE_AMP] = ACTIONS(1288),
  },
  [1099] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1639),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [sym_word] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_LT_AMP] = ACTIONS(1639),
    [anon_sym_GT_GT] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [sym__special_character] = ACTIONS(1639),
    [anon_sym_LT_LT_DASH] = ACTIONS(1639),
    [anon_sym_BQUOTE] = ACTIONS(1639),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1639),
    [sym_raw_string] = ACTIONS(1639),
    [sym_variable_name] = ACTIONS(1641),
    [sym_file_descriptor] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_AMP_GT] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_LT_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_AMP] = ACTIONS(1639),
    [ts_builtin_sym_end] = ACTIONS(1641),
    [anon_sym_LT_LPAREN] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [anon_sym_PIPE_AMP] = ACTIONS(1639),
  },
  [1100] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(3196),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1101] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [ts_builtin_sym_end] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1102] = {
    [sym_command_substitution] = STATE(1101),
    [sym_simple_expansion] = STATE(1101),
    [sym_string_expansion] = STATE(1101),
    [sym_string] = STATE(1101),
    [sym_process_substitution] = STATE(1101),
    [sym_expansion] = STATE(1101),
    [anon_sym_BQUOTE] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [sym_word] = ACTIONS(2495),
    [sym_raw_string] = ACTIONS(2495),
    [anon_sym_LT_LPAREN] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(3198),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(759),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(763),
    [sym__special_character] = ACTIONS(2495),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(767),
  },
  [1103] = {
    [aux_sym_concatenation_repeat1] = STATE(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(3200),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [ts_builtin_sym_end] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1104] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [sym_word] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_LT_AMP] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [sym__special_character] = ACTIONS(1282),
    [anon_sym_LT_LT_DASH] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_LF] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [sym_raw_string] = ACTIONS(1282),
    [sym_variable_name] = ACTIONS(1284),
    [sym_file_descriptor] = ACTIONS(1284),
    [anon_sym_RPAREN] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_AMP_GT] = ACTIONS(1282),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_LT_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_AMP] = ACTIONS(1282),
    [ts_builtin_sym_end] = ACTIONS(1284),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
    [anon_sym_PIPE_AMP] = ACTIONS(1282),
  },
  [1105] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1377),
    [sym_concatenation] = STATE(1377),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3203),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3203),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3203),
    [anon_sym_PERCENT] = ACTIONS(3203),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3207),
    [anon_sym_COLON_DASH] = ACTIONS(3203),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3209),
  },
  [1106] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [sym_word] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_LT_AMP] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [sym__special_character] = ACTIONS(1324),
    [anon_sym_LT_LT_DASH] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [anon_sym_LF] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_raw_string] = ACTIONS(1324),
    [sym_variable_name] = ACTIONS(1326),
    [sym_file_descriptor] = ACTIONS(1326),
    [anon_sym_RPAREN] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_AMP_GT] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_LT_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_AMP] = ACTIONS(1324),
    [ts_builtin_sym_end] = ACTIONS(1326),
    [anon_sym_LT_LPAREN] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
    [anon_sym_PIPE_AMP] = ACTIONS(1324),
  },
  [1107] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1108] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1377),
    [sym_concatenation] = STATE(1377),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3211),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3203),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3203),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3203),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3203),
    [anon_sym_PERCENT] = ACTIONS(3203),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3207),
    [anon_sym_COLON_DASH] = ACTIONS(3203),
    [sym__special_character] = ACTIONS(553),
  },
  [1109] = {
    [anon_sym_EQ] = ACTIONS(3213),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1110] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1382),
    [sym_concatenation] = STATE(1382),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3215),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3217),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3217),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3217),
    [anon_sym_PERCENT] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3221),
    [anon_sym_COLON_DASH] = ACTIONS(3217),
    [sym__special_character] = ACTIONS(553),
  },
  [1111] = {
    [sym_command_substitution] = STATE(1383),
    [aux_sym__literal_repeat1] = STATE(1384),
    [sym_string] = STATE(1383),
    [sym_process_substitution] = STATE(1383),
    [sym_simple_expansion] = STATE(1383),
    [sym_string_expansion] = STATE(1383),
    [sym_concatenation] = STATE(1385),
    [sym_expansion] = STATE(1383),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3223),
    [sym_raw_string] = ACTIONS(3223),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3205),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1112] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1388),
    [sym_concatenation] = STATE(1388),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3225),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3225),
    [anon_sym_PERCENT] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3229),
    [anon_sym_COLON_DASH] = ACTIONS(3225),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3231),
  },
  [1113] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym_word] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [sym_variable_name] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [ts_builtin_sym_end] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
  },
  [1114] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1115] = {
    [anon_sym_EQ] = ACTIONS(3233),
    [anon_sym_PLUS_EQ] = ACTIONS(3233),
    [sym_comment] = ACTIONS(51),
  },
  [1116] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(3233),
    [sym__concat] = ACTIONS(3235),
    [anon_sym_EQ] = ACTIONS(3233),
  },
  [1117] = {
    [sym_command_substitution] = STATE(844),
    [sym_simple_expansion] = STATE(844),
    [sym_string_expansion] = STATE(844),
    [sym_string] = STATE(844),
    [sym_process_substitution] = STATE(844),
    [sym_expansion] = STATE(844),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym_word] = ACTIONS(1776),
    [sym_raw_string] = ACTIONS(1776),
    [anon_sym_LT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR] = ACTIONS(3237),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(277),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [sym__special_character] = ACTIONS(1776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(285),
  },
  [1118] = {
    [aux_sym_concatenation_repeat1] = STATE(1118),
    [anon_sym_RBRACK] = ACTIONS(1392),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(2696),
  },
  [1119] = {
    [anon_sym_EQ] = ACTIONS(3239),
    [anon_sym_PLUS_EQ] = ACTIONS(3239),
    [sym_comment] = ACTIONS(51),
  },
  [1120] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(3239),
    [sym__concat] = ACTIONS(3241),
    [anon_sym_EQ] = ACTIONS(3239),
  },
  [1121] = {
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [sym__concat] = ACTIONS(2111),
    [sym__string_content] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2111),
  },
  [1122] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1393),
    [sym_concatenation] = STATE(1393),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3243),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3243),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3243),
    [anon_sym_PERCENT] = ACTIONS(3243),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3247),
    [anon_sym_COLON_DASH] = ACTIONS(3243),
    [sym__special_character] = ACTIONS(553),
  },
  [1123] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1124] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1393),
    [sym_concatenation] = STATE(1393),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3243),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3243),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3243),
    [anon_sym_PERCENT] = ACTIONS(3243),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3247),
    [anon_sym_COLON_DASH] = ACTIONS(3243),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3249),
  },
  [1125] = {
    [sym_command_substitution] = STATE(1395),
    [aux_sym__literal_repeat1] = STATE(1396),
    [sym_string] = STATE(1395),
    [sym_process_substitution] = STATE(1395),
    [sym_simple_expansion] = STATE(1395),
    [sym_string_expansion] = STATE(1395),
    [sym_concatenation] = STATE(1397),
    [sym_expansion] = STATE(1395),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3251),
    [sym_raw_string] = ACTIONS(3251),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1126] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1400),
    [sym_concatenation] = STATE(1400),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3253),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3253),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3253),
    [anon_sym_PERCENT] = ACTIONS(3253),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3257),
    [anon_sym_COLON_DASH] = ACTIONS(3253),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3259),
  },
  [1127] = {
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [sym__concat] = ACTIONS(2207),
    [sym__string_content] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2207),
  },
  [1128] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1129] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [sym__concat] = ACTIONS(2213),
  },
  [1130] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3261),
  },
  [1131] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3245),
  },
  [1132] = {
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym__concat] = ACTIONS(2249),
    [sym__string_content] = ACTIONS(2247),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2249),
  },
  [1133] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1403),
    [sym_concatenation] = STATE(1403),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3263),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3263),
    [anon_sym_PERCENT] = ACTIONS(3263),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3267),
    [anon_sym_COLON_DASH] = ACTIONS(3263),
    [sym__special_character] = ACTIONS(553),
  },
  [1134] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1135] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3269),
  },
  [1136] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1137] = {
    [anon_sym_BQUOTE] = ACTIONS(787),
    [sym_raw_string] = ACTIONS(787),
    [anon_sym_LF] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_GT_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [sym_word] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_LT_LPAREN] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
  },
  [1138] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(3273),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(3271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [1139] = {
    [sym_command_substitution] = STATE(1407),
    [sym_simple_expansion] = STATE(1407),
    [sym_string_expansion] = STATE(1407),
    [sym_string] = STATE(1407),
    [sym_process_substitution] = STATE(1407),
    [sym_expansion] = STATE(1407),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1696),
    [sym_word] = ACTIONS(3275),
    [sym_raw_string] = ACTIONS(3275),
    [anon_sym_LT_LPAREN] = ACTIONS(1700),
    [anon_sym_DOLLAR] = ACTIONS(1702),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1704),
    [sym__special_character] = ACTIONS(3275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1708),
  },
  [1140] = {
    [aux_sym_concatenation_repeat1] = STATE(1409),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [sym__concat] = ACTIONS(3277),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
  },
  [1141] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3279),
  },
  [1142] = {
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_raw_string] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_GT_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(505),
    [sym_word] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [anon_sym_AMP] = ACTIONS(505),
    [anon_sym_LT_LPAREN] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
  },
  [1143] = {
    [anon_sym_BQUOTE] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(509),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_GT_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [sym_word] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_LT_LPAREN] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
  },
  [1144] = {
    [anon_sym_BQUOTE] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
  },
  [1145] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(3269),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [1146] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3269),
  },
  [1147] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1413),
    [sym_concatenation] = STATE(1413),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3281),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3283),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3287),
    [anon_sym_COLON_DASH] = ACTIONS(3283),
    [sym__special_character] = ACTIONS(553),
  },
  [1148] = {
    [sym_subscript] = STATE(1414),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_QMARK] = ACTIONS(3289),
    [anon_sym_AT] = ACTIONS(3289),
    [sym_variable_name] = ACTIONS(3291),
    [anon_sym_DOLLAR] = ACTIONS(3293),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_0] = ACTIONS(3295),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3295),
    [anon_sym__] = ACTIONS(3295),
  },
  [1149] = {
    [anon_sym_EQ] = ACTIONS(3297),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1150] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1420),
    [sym_concatenation] = STATE(1420),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3299),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3301),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3301),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3301),
    [anon_sym_PERCENT] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3305),
    [anon_sym_COLON_DASH] = ACTIONS(3301),
    [sym__special_character] = ACTIONS(553),
  },
  [1151] = {
    [anon_sym_BQUOTE] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
  },
  [1152] = {
    [aux_sym__literal_repeat1] = STATE(1152),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3307),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
  },
  [1153] = {
    [sym_do_group] = STATE(1421),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(839),
  },
  [1154] = {
    [sym_command_substitution] = STATE(804),
    [aux_sym__literal_repeat1] = STATE(810),
    [sym_string] = STATE(804),
    [sym_process_substitution] = STATE(804),
    [aux_sym_for_statement_repeat1] = STATE(1154),
    [sym_simple_expansion] = STATE(804),
    [sym_string_expansion] = STATE(804),
    [sym_concatenation] = STATE(1154),
    [sym_expansion] = STATE(804),
    [anon_sym_BQUOTE] = ACTIONS(3310),
    [sym_raw_string] = ACTIONS(3313),
    [anon_sym_LF] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [anon_sym_GT_LPAREN] = ACTIONS(3321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(3330),
    [sym_word] = ACTIONS(3313),
    [anon_sym_AMP] = ACTIONS(3316),
    [anon_sym_LT_LPAREN] = ACTIONS(3321),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3333),
    [anon_sym_SEMI_SEMI] = ACTIONS(3316),
  },
  [1155] = {
    [anon_sym_BANG_EQ] = ACTIONS(2389),
    [anon_sym_PLUS_EQ] = ACTIONS(2389),
    [sym_test_operator] = ACTIONS(2387),
    [anon_sym_LF] = ACTIONS(2389),
    [anon_sym_SEMI] = ACTIONS(2389),
    [anon_sym_PLUS_PLUS] = ACTIONS(2389),
    [anon_sym_DASH] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_EQ] = ACTIONS(2389),
    [anon_sym_EQ_EQ] = ACTIONS(2389),
    [anon_sym_PIPE_PIPE] = ACTIONS(2389),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_PLUS] = ACTIONS(2389),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_AMP] = ACTIONS(2389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2389),
    [anon_sym_DASH_DASH] = ACTIONS(2389),
    [anon_sym_AMP_AMP] = ACTIONS(2389),
    [anon_sym_LT_EQ] = ACTIONS(2389),
    [anon_sym_SEMI_SEMI] = ACTIONS(2389),
    [anon_sym_DASH_EQ] = ACTIONS(2389),
  },
  [1156] = {
    [anon_sym_BANG_EQ] = ACTIONS(1288),
    [anon_sym_PLUS_EQ] = ACTIONS(1288),
    [sym_test_operator] = ACTIONS(1290),
    [anon_sym_LF] = ACTIONS(1288),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym_PLUS_PLUS] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_EQ] = ACTIONS(1288),
    [anon_sym_EQ_EQ] = ACTIONS(1288),
    [anon_sym_PIPE_PIPE] = ACTIONS(1288),
    [anon_sym_GT_EQ] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1288),
    [anon_sym_DASH_DASH] = ACTIONS(1288),
    [anon_sym_AMP_AMP] = ACTIONS(1288),
    [anon_sym_LT_EQ] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
    [anon_sym_DASH_EQ] = ACTIONS(1288),
  },
  [1157] = {
    [anon_sym_BANG_EQ] = ACTIONS(1390),
    [anon_sym_PLUS_EQ] = ACTIONS(1390),
    [sym_test_operator] = ACTIONS(1392),
    [anon_sym_LF] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_PLUS_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [anon_sym_GT_EQ] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1390),
    [anon_sym_DASH_DASH] = ACTIONS(1390),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_LT_EQ] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_DASH_EQ] = ACTIONS(1390),
  },
  [1158] = {
    [sym_command_substitution] = STATE(1157),
    [sym_simple_expansion] = STATE(1157),
    [sym_string_expansion] = STATE(1157),
    [sym_string] = STATE(1157),
    [sym_process_substitution] = STATE(1157),
    [sym_expansion] = STATE(1157),
    [anon_sym_BQUOTE] = ACTIONS(1716),
    [anon_sym_DQUOTE] = ACTIONS(1712),
    [sym_word] = ACTIONS(2641),
    [sym_raw_string] = ACTIONS(2641),
    [anon_sym_LT_LPAREN] = ACTIONS(1718),
    [anon_sym_DOLLAR] = ACTIONS(3336),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1718),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1720),
    [sym__special_character] = ACTIONS(2641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1724),
  },
  [1159] = {
    [aux_sym_concatenation_repeat1] = STATE(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1390),
    [anon_sym_PLUS_EQ] = ACTIONS(1390),
    [sym_test_operator] = ACTIONS(1392),
    [anon_sym_LF] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_PLUS_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [anon_sym_GT_EQ] = ACTIONS(1390),
    [sym__concat] = ACTIONS(3338),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1390),
    [anon_sym_DASH_DASH] = ACTIONS(1390),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_LT_EQ] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_DASH_EQ] = ACTIONS(1390),
  },
  [1160] = {
    [sym_do_group] = STATE(1424),
    [sym_compound_statement] = STATE(1424),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(3341),
    [anon_sym_do] = ACTIONS(839),
  },
  [1161] = {
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_PLUS_EQ] = ACTIONS(717),
    [sym_test_operator] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(721),
    [anon_sym_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ] = ACTIONS(723),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3343),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(721),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_DASH_EQ] = ACTIONS(717),
  },
  [1162] = {
    [sym_command_substitution] = STATE(131),
    [sym_unary_expression] = STATE(1426),
    [sym_postfix_expression] = STATE(1426),
    [sym_string] = STATE(131),
    [aux_sym__literal_repeat1] = STATE(138),
    [sym_process_substitution] = STATE(131),
    [sym_parenthesized_expression] = STATE(1426),
    [sym_simple_expansion] = STATE(131),
    [sym_string_expansion] = STATE(131),
    [sym__expression] = STATE(1426),
    [sym_binary_expression] = STATE(1426),
    [sym_concatenation] = STATE(1426),
    [sym_expansion] = STATE(131),
    [sym_test_operator] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [sym_raw_string] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3343),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(213),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(227),
  },
  [1163] = {
    [anon_sym_BANG_EQ] = ACTIONS(1282),
    [anon_sym_PLUS_EQ] = ACTIONS(1282),
    [sym_test_operator] = ACTIONS(1284),
    [anon_sym_LF] = ACTIONS(1282),
    [anon_sym_SEMI] = ACTIONS(1282),
    [anon_sym_PLUS_PLUS] = ACTIONS(1282),
    [anon_sym_DASH] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_EQ_EQ] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [anon_sym_GT_EQ] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1282),
    [anon_sym_DASH_DASH] = ACTIONS(1282),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_LT_EQ] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
    [anon_sym_DASH_EQ] = ACTIONS(1282),
  },
  [1164] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1429),
    [sym_concatenation] = STATE(1429),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3345),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3345),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3345),
    [anon_sym_PERCENT] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3349),
    [anon_sym_COLON_DASH] = ACTIONS(3345),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3351),
  },
  [1165] = {
    [anon_sym_BANG_EQ] = ACTIONS(1324),
    [anon_sym_PLUS_EQ] = ACTIONS(1324),
    [sym_test_operator] = ACTIONS(1326),
    [anon_sym_LF] = ACTIONS(1324),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_EQ] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1324),
    [anon_sym_DASH_DASH] = ACTIONS(1324),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
    [anon_sym_DASH_EQ] = ACTIONS(1324),
  },
  [1166] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1167] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1429),
    [sym_concatenation] = STATE(1429),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3353),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3345),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3345),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3345),
    [anon_sym_PERCENT] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3349),
    [anon_sym_COLON_DASH] = ACTIONS(3345),
    [sym__special_character] = ACTIONS(553),
  },
  [1168] = {
    [anon_sym_EQ] = ACTIONS(3355),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1169] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1434),
    [sym_concatenation] = STATE(1434),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3357),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3359),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3359),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3359),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3359),
    [anon_sym_PERCENT] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3363),
    [anon_sym_COLON_DASH] = ACTIONS(3359),
    [sym__special_character] = ACTIONS(553),
  },
  [1170] = {
    [sym_command_substitution] = STATE(1435),
    [aux_sym__literal_repeat1] = STATE(1436),
    [sym_string] = STATE(1435),
    [sym_process_substitution] = STATE(1435),
    [sym_simple_expansion] = STATE(1435),
    [sym_string_expansion] = STATE(1435),
    [sym_concatenation] = STATE(1437),
    [sym_expansion] = STATE(1435),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3365),
    [sym_raw_string] = ACTIONS(3365),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3347),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1171] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1440),
    [sym_concatenation] = STATE(1440),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3367),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3367),
    [anon_sym_PERCENT] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3371),
    [anon_sym_COLON_DASH] = ACTIONS(3367),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3373),
  },
  [1172] = {
    [anon_sym_BANG_EQ] = ACTIONS(1380),
    [anon_sym_PLUS_EQ] = ACTIONS(1380),
    [sym_test_operator] = ACTIONS(1382),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_EQ] = ACTIONS(1380),
    [anon_sym_EQ_EQ] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_GT_EQ] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1380),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_LT_EQ] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_DASH_EQ] = ACTIONS(1380),
  },
  [1173] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1174] = {
    [anon_sym_BANG_EQ] = ACTIONS(1639),
    [anon_sym_PLUS_EQ] = ACTIONS(1639),
    [sym_test_operator] = ACTIONS(1641),
    [anon_sym_LF] = ACTIONS(1639),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_DASH] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_EQ] = ACTIONS(1639),
    [anon_sym_EQ_EQ] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [anon_sym_PLUS] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1639),
    [anon_sym_DASH_DASH] = ACTIONS(1639),
    [anon_sym_AMP_AMP] = ACTIONS(1639),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [anon_sym_DASH_EQ] = ACTIONS(1639),
  },
  [1175] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1176] = {
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(2430),
    [sym_test_operator] = ACTIONS(2428),
    [anon_sym_LF] = ACTIONS(2430),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_PIPE_PIPE] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2430),
    [anon_sym_LT_EQ] = ACTIONS(2430),
    [anon_sym_SEMI_SEMI] = ACTIONS(2430),
    [anon_sym_DASH_EQ] = ACTIONS(2430),
  },
  [1177] = {
    [anon_sym_BANG_EQ] = ACTIONS(1754),
    [anon_sym_PLUS_EQ] = ACTIONS(1754),
    [sym_test_operator] = ACTIONS(1756),
    [anon_sym_LF] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(1760),
    [anon_sym_DASH] = ACTIONS(1754),
    [anon_sym_GT] = ACTIONS(1754),
    [anon_sym_EQ] = ACTIONS(1754),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1754),
    [anon_sym_GT_EQ] = ACTIONS(1754),
    [anon_sym_PLUS] = ACTIONS(1754),
    [anon_sym_LT] = ACTIONS(1754),
    [anon_sym_AMP] = ACTIONS(3377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1762),
    [anon_sym_DASH_DASH] = ACTIONS(1760),
    [anon_sym_LT_EQ] = ACTIONS(1754),
    [anon_sym_AMP_AMP] = ACTIONS(1754),
    [anon_sym_SEMI_SEMI] = ACTIONS(3377),
    [anon_sym_DASH_EQ] = ACTIONS(1754),
  },
  [1178] = {
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(2430),
    [sym_test_operator] = ACTIONS(2428),
    [anon_sym_LF] = ACTIONS(2430),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_PIPE_PIPE] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2430),
    [anon_sym_LT_EQ] = ACTIONS(2430),
    [anon_sym_SEMI_SEMI] = ACTIONS(2430),
    [anon_sym_DASH_EQ] = ACTIONS(2430),
  },
  [1179] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3379),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [anon_sym_AMP_GT_GT] = ACTIONS(3379),
    [anon_sym_LF] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(3379),
    [sym_file_descriptor] = ACTIONS(3381),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_RPAREN] = ACTIONS(3379),
    [anon_sym_AMP_GT] = ACTIONS(3379),
    [anon_sym_PIPE_PIPE] = ACTIONS(3379),
    [ts_builtin_sym_end] = ACTIONS(3381),
    [anon_sym_LT_LT_LT] = ACTIONS(3379),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_GT_AMP] = ACTIONS(3379),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_LT_AMP] = ACTIONS(3379),
    [anon_sym_GT_GT] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3379),
    [anon_sym_AMP_AMP] = ACTIONS(3379),
    [anon_sym_SEMI_SEMI] = ACTIONS(3379),
    [anon_sym_PIPE_AMP] = ACTIONS(3379),
  },
  [1180] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1180),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_local] = ACTIONS(938),
    [anon_sym_typeset] = ACTIONS(938),
    [anon_sym_unsetenv] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [anon_sym_GT_LPAREN] = ACTIONS(947),
    [anon_sym_done] = ACTIONS(906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(956),
    [sym_word] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(938),
    [sym__special_character] = ACTIONS(968),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(974),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(980),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_declare] = ACTIONS(938),
    [sym_variable_name] = ACTIONS(989),
    [sym_file_descriptor] = ACTIONS(992),
    [anon_sym_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(965),
    [anon_sym_readonly] = ACTIONS(938),
    [anon_sym_unset] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LPAREN] = ACTIONS(947),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(1004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1007),
  },
  [1181] = {
    [anon_sym_BANG_EQ] = ACTIONS(2585),
    [anon_sym_PLUS_EQ] = ACTIONS(2585),
    [sym_test_operator] = ACTIONS(2585),
    [anon_sym_PLUS_PLUS] = ACTIONS(2585),
    [anon_sym_RBRACK] = ACTIONS(2585),
    [anon_sym_DASH] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_EQ] = ACTIONS(2583),
    [anon_sym_EQ_EQ] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2585),
    [anon_sym_GT_EQ] = ACTIONS(2585),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_PLUS] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2585),
    [anon_sym_DASH_DASH] = ACTIONS(2585),
    [anon_sym_LT_EQ] = ACTIONS(2585),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_DASH_EQ] = ACTIONS(2585),
  },
  [1182] = {
    [sym_string] = STATE(472),
    [sym_test_operator] = ACTIONS(2265),
    [anon_sym_PLUS_EQ] = ACTIONS(2265),
    [anon_sym_PLUS_PLUS] = ACTIONS(2265),
    [anon_sym_DOLLAR] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(3383),
    [aux_sym__simple_variable_name_token1] = ACTIONS(853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2265),
    [anon_sym_QMARK] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_EQ_TILDE] = ACTIONS(2265),
    [anon_sym_DASH_DASH] = ACTIONS(2265),
    [anon_sym_LT_EQ] = ACTIONS(2265),
    [anon_sym_DASH_EQ] = ACTIONS(2265),
    [anon_sym_BANG_EQ] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(847),
    [sym_raw_string] = ACTIONS(849),
    [anon_sym_BANG] = ACTIONS(3383),
    [anon_sym_RBRACK] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(853),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(2265),
    [anon_sym_GT_EQ] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_PLUS] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(2265),
    [anon_sym__] = ACTIONS(853),
  },
  [1183] = {
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_PLUS_EQ] = ACTIONS(2111),
    [sym_test_operator] = ACTIONS(2111),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_RBRACK] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_EQ] = ACTIONS(2109),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_PIPE_PIPE] = ACTIONS(2111),
    [anon_sym_GT_EQ] = ACTIONS(2111),
    [sym__concat] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [anon_sym_LT_EQ] = ACTIONS(2111),
    [anon_sym_AMP_AMP] = ACTIONS(2111),
    [anon_sym_DASH_EQ] = ACTIONS(2111),
  },
  [1184] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1444),
    [sym_concatenation] = STATE(1444),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3385),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3385),
    [anon_sym_PERCENT] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3389),
    [anon_sym_COLON_DASH] = ACTIONS(3385),
    [sym__special_character] = ACTIONS(553),
  },
  [1185] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1186] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1444),
    [sym_concatenation] = STATE(1444),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3385),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3385),
    [anon_sym_PERCENT] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3389),
    [anon_sym_COLON_DASH] = ACTIONS(3385),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3391),
  },
  [1187] = {
    [sym_command_substitution] = STATE(1446),
    [aux_sym__literal_repeat1] = STATE(1447),
    [sym_string] = STATE(1446),
    [sym_process_substitution] = STATE(1446),
    [sym_simple_expansion] = STATE(1446),
    [sym_string_expansion] = STATE(1446),
    [sym_concatenation] = STATE(1448),
    [sym_expansion] = STATE(1446),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3393),
    [sym_raw_string] = ACTIONS(3393),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1188] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1451),
    [sym_concatenation] = STATE(1451),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3395),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3395),
    [anon_sym_PERCENT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3399),
    [anon_sym_COLON_DASH] = ACTIONS(3395),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3401),
  },
  [1189] = {
    [anon_sym_BANG_EQ] = ACTIONS(2207),
    [anon_sym_PLUS_EQ] = ACTIONS(2207),
    [sym_test_operator] = ACTIONS(2207),
    [anon_sym_PLUS_PLUS] = ACTIONS(2207),
    [anon_sym_RBRACK] = ACTIONS(2207),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2207),
    [anon_sym_GT_EQ] = ACTIONS(2207),
    [sym__concat] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2207),
    [anon_sym_DASH_DASH] = ACTIONS(2207),
    [anon_sym_LT_EQ] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2207),
    [anon_sym_DASH_EQ] = ACTIONS(2207),
  },
  [1190] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1191] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [sym__concat] = ACTIONS(2213),
  },
  [1192] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3403),
  },
  [1193] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3387),
  },
  [1194] = {
    [anon_sym_BANG_EQ] = ACTIONS(2249),
    [anon_sym_PLUS_EQ] = ACTIONS(2249),
    [sym_test_operator] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_RBRACK] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_EQ] = ACTIONS(2247),
    [anon_sym_EQ_EQ] = ACTIONS(2249),
    [anon_sym_PIPE_PIPE] = ACTIONS(2249),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [sym__concat] = ACTIONS(2249),
    [anon_sym_PLUS] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2249),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_LT_EQ] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_DASH_EQ] = ACTIONS(2249),
  },
  [1195] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1454),
    [sym_concatenation] = STATE(1454),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3405),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3405),
    [anon_sym_PERCENT] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3409),
    [anon_sym_COLON_DASH] = ACTIONS(3405),
    [sym__special_character] = ACTIONS(553),
  },
  [1196] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1197] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_AMP_GT_GT] = ACTIONS(1288),
    [anon_sym_LF] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym_LT_LT] = ACTIONS(1288),
    [sym_file_descriptor] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [anon_sym_AMP_GT] = ACTIONS(1288),
    [anon_sym_PIPE_PIPE] = ACTIONS(1288),
    [ts_builtin_sym_end] = ACTIONS(1290),
    [anon_sym_LT_LT_LT] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_GT_AMP] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_LT_AMP] = ACTIONS(1288),
    [anon_sym_GT_GT] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1288),
    [anon_sym_esac] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
    [anon_sym_PIPE_AMP] = ACTIONS(1288),
  },
  [1198] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1639),
    [anon_sym_BQUOTE] = ACTIONS(1639),
    [anon_sym_AMP_GT_GT] = ACTIONS(1639),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_LT_LT] = ACTIONS(1639),
    [sym_file_descriptor] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_AMP_GT] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [ts_builtin_sym_end] = ACTIONS(1641),
    [anon_sym_LT_LT_LT] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1639),
    [anon_sym_GT_AMP] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_LT_AMP] = ACTIONS(1639),
    [anon_sym_GT_GT] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1639),
    [anon_sym_esac] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [anon_sym_PIPE_AMP] = ACTIONS(1639),
  },
  [1199] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(3411),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1200] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [ts_builtin_sym_end] = ACTIONS(1392),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_esac] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1201] = {
    [sym_command_substitution] = STATE(1200),
    [sym_simple_expansion] = STATE(1200),
    [sym_string_expansion] = STATE(1200),
    [sym_string] = STATE(1200),
    [sym_process_substitution] = STATE(1200),
    [sym_expansion] = STATE(1200),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(2735),
    [sym_raw_string] = ACTIONS(2735),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(3413),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(2735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [1202] = {
    [aux_sym_concatenation_repeat1] = STATE(1202),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [ts_builtin_sym_end] = ACTIONS(1392),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [sym__concat] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1203] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_AMP_GT_GT] = ACTIONS(1282),
    [anon_sym_LF] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [sym_file_descriptor] = ACTIONS(1284),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_RPAREN] = ACTIONS(1282),
    [anon_sym_AMP_GT] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [ts_builtin_sym_end] = ACTIONS(1284),
    [anon_sym_LT_LT_LT] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_GT_AMP] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_LT_AMP] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_esac] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
    [anon_sym_PIPE_AMP] = ACTIONS(1282),
  },
  [1204] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1459),
    [sym_concatenation] = STATE(1459),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3418),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3420),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3418),
    [anon_sym_PERCENT] = ACTIONS(3418),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3422),
    [anon_sym_COLON_DASH] = ACTIONS(3418),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3424),
  },
  [1205] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [anon_sym_AMP_GT_GT] = ACTIONS(1324),
    [anon_sym_LF] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1324),
    [sym_file_descriptor] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_RPAREN] = ACTIONS(1324),
    [anon_sym_AMP_GT] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [ts_builtin_sym_end] = ACTIONS(1326),
    [anon_sym_LT_LT_LT] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1324),
    [anon_sym_GT_AMP] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_LT_AMP] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_esac] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
    [anon_sym_PIPE_AMP] = ACTIONS(1324),
  },
  [1206] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3420),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1207] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1459),
    [sym_concatenation] = STATE(1459),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3426),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3418),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3420),
    [anon_sym_DASH] = ACTIONS(3418),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3418),
    [anon_sym_PERCENT] = ACTIONS(3418),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3422),
    [anon_sym_COLON_DASH] = ACTIONS(3418),
    [sym__special_character] = ACTIONS(553),
  },
  [1208] = {
    [anon_sym_EQ] = ACTIONS(3428),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1209] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1464),
    [sym_concatenation] = STATE(1464),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3430),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3432),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3434),
    [anon_sym_DASH] = ACTIONS(3432),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3432),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3432),
    [anon_sym_PERCENT] = ACTIONS(3432),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3436),
    [anon_sym_COLON_DASH] = ACTIONS(3432),
    [sym__special_character] = ACTIONS(553),
  },
  [1210] = {
    [sym_command_substitution] = STATE(1465),
    [aux_sym__literal_repeat1] = STATE(1466),
    [sym_string] = STATE(1465),
    [sym_process_substitution] = STATE(1465),
    [sym_simple_expansion] = STATE(1465),
    [sym_string_expansion] = STATE(1465),
    [sym_concatenation] = STATE(1467),
    [sym_expansion] = STATE(1465),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3438),
    [sym_raw_string] = ACTIONS(3438),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3420),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1211] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1470),
    [sym_concatenation] = STATE(1470),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3440),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(3440),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3444),
    [anon_sym_COLON_DASH] = ACTIONS(3440),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3446),
  },
  [1212] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [ts_builtin_sym_end] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_esac] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
  },
  [1213] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3442),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1214] = {
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_BQUOTE] = ACTIONS(507),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(507),
    [sym__heredoc_body_end] = ACTIONS(507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(507),
    [sym__heredoc_body_middle] = ACTIONS(507),
  },
  [1215] = {
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(515),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(515),
    [sym__heredoc_body_end] = ACTIONS(515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [sym__heredoc_body_middle] = ACTIONS(515),
  },
  [1216] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3448),
  },
  [1217] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(3448),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [1218] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3448),
  },
  [1219] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1474),
    [sym_concatenation] = STATE(1474),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3450),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3452),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3454),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3452),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3452),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3456),
    [anon_sym_COLON_DASH] = ACTIONS(3452),
    [sym__special_character] = ACTIONS(553),
  },
  [1220] = {
    [sym_subscript] = STATE(1475),
    [anon_sym_STAR] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3458),
    [anon_sym_AT] = ACTIONS(3458),
    [sym_variable_name] = ACTIONS(3460),
    [anon_sym_DOLLAR] = ACTIONS(3462),
    [anon_sym_DASH] = ACTIONS(3462),
    [anon_sym_0] = ACTIONS(3464),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3464),
    [anon_sym__] = ACTIONS(3464),
  },
  [1221] = {
    [anon_sym_EQ] = ACTIONS(3466),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1222] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1481),
    [sym_concatenation] = STATE(1481),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3468),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3470),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3470),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3470),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3470),
    [anon_sym_PERCENT] = ACTIONS(3470),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3474),
    [anon_sym_COLON_DASH] = ACTIONS(3470),
    [sym__special_character] = ACTIONS(553),
  },
  [1223] = {
    [anon_sym_BQUOTE] = ACTIONS(3476),
    [ts_builtin_sym_end] = ACTIONS(3478),
    [anon_sym_LF] = ACTIONS(3478),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_esac] = ACTIONS(3476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(3476),
    [anon_sym_SEMI_SEMI] = ACTIONS(3476),
  },
  [1224] = {
    [sym_command_substitution] = STATE(1224),
    [sym_simple_expansion] = STATE(1224),
    [sym_expansion] = STATE(1224),
    [aux_sym_heredoc_body_repeat1] = STATE(1224),
    [anon_sym_DOLLAR] = ACTIONS(3480),
    [anon_sym_BQUOTE] = ACTIONS(3483),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3486),
    [sym__heredoc_body_end] = ACTIONS(3489),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3491),
    [sym__heredoc_body_middle] = ACTIONS(3494),
  },
  [1225] = {
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_AMP_GT_GT] = ACTIONS(2796),
    [anon_sym_local] = ACTIONS(2794),
    [anon_sym_typeset] = ACTIONS(2794),
    [anon_sym_unsetenv] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2794),
    [anon_sym_GT_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2794),
    [sym_word] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_LT_AMP] = ACTIONS(2796),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2794),
    [sym__special_character] = ACTIONS(2794),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2794),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2796),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BQUOTE] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [sym_variable_name] = ACTIONS(2796),
    [sym_file_descriptor] = ACTIONS(2796),
    [anon_sym_RPAREN] = ACTIONS(3497),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP_GT] = ACTIONS(2794),
    [anon_sym_readonly] = ACTIONS(2794),
    [anon_sym_unset] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [ts_builtin_sym_end] = ACTIONS(3497),
    [anon_sym_GT_AMP] = ACTIONS(2796),
    [anon_sym_LT_LPAREN] = ACTIONS(2796),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2796),
  },
  [1226] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(3499),
    [anon_sym_SEMI] = ACTIONS(3501),
    [anon_sym_SEMI_SEMI] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3501),
  },
  [1227] = {
    [aux_sym_concatenation_repeat1] = STATE(1227),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(3200),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1228] = {
    [aux_sym_concatenation_repeat1] = STATE(1228),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [sym__concat] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1229] = {
    [anon_sym_BQUOTE] = ACTIONS(2898),
    [anon_sym_AMP_GT_GT] = ACTIONS(2898),
    [sym_raw_string] = ACTIONS(2898),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [sym_file_descriptor] = ACTIONS(2898),
    [sym_variable_name] = ACTIONS(2898),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2898),
    [anon_sym_AMP_GT] = ACTIONS(2896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2898),
    [anon_sym_GT_LPAREN] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2898),
    [anon_sym_DQUOTE] = ACTIONS(2898),
    [sym_word] = ACTIONS(2898),
    [anon_sym_GT_AMP] = ACTIONS(2898),
    [sym__concat] = ACTIONS(2898),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_LT_AMP] = ACTIONS(2898),
    [anon_sym_GT_GT] = ACTIONS(2898),
    [anon_sym_LT_LPAREN] = ACTIONS(2898),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2898),
  },
  [1230] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1231] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1484),
    [sym_concatenation] = STATE(1484),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3505),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3507),
    [anon_sym_COLON_DASH] = ACTIONS(3505),
    [sym__special_character] = ACTIONS(553),
  },
  [1232] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [sym__concat] = ACTIONS(2213),
  },
  [1233] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3509),
  },
  [1234] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3503),
  },
  [1235] = {
    [anon_sym_BQUOTE] = ACTIONS(2947),
    [anon_sym_AMP_GT_GT] = ACTIONS(2947),
    [sym_raw_string] = ACTIONS(2947),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [sym_file_descriptor] = ACTIONS(2947),
    [sym_variable_name] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2947),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2947),
    [anon_sym_GT_LPAREN] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [sym_word] = ACTIONS(2947),
    [anon_sym_GT_AMP] = ACTIONS(2947),
    [sym__concat] = ACTIONS(2947),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_LT_LPAREN] = ACTIONS(2947),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2947),
  },
  [1236] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1487),
    [sym_concatenation] = STATE(1487),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3511),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3511),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3515),
    [anon_sym_COLON_DASH] = ACTIONS(3511),
    [sym__special_character] = ACTIONS(553),
  },
  [1237] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1238] = {
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [anon_sym_AMP_GT_GT] = ACTIONS(2995),
    [sym_raw_string] = ACTIONS(2995),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [sym_file_descriptor] = ACTIONS(2995),
    [sym_variable_name] = ACTIONS(2995),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2995),
    [anon_sym_AMP_GT] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2995),
    [anon_sym_GT_LPAREN] = ACTIONS(2995),
    [anon_sym_RPAREN] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [sym_word] = ACTIONS(2995),
    [anon_sym_GT_AMP] = ACTIONS(2995),
    [sym__concat] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_LT_AMP] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_LT_LPAREN] = ACTIONS(2995),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2995),
  },
  [1239] = {
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [anon_sym_AMP_GT_GT] = ACTIONS(3014),
    [sym_raw_string] = ACTIONS(3014),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [sym_file_descriptor] = ACTIONS(3014),
    [sym_variable_name] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3014),
    [anon_sym_AMP_GT] = ACTIONS(3012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3014),
    [anon_sym_GT_LPAREN] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_word] = ACTIONS(3014),
    [anon_sym_GT_AMP] = ACTIONS(3014),
    [sym__concat] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_LT_AMP] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3014),
    [anon_sym_LT_LPAREN] = ACTIONS(3014),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3014),
  },
  [1240] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1241] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3166),
    [anon_sym_DOLLAR] = ACTIONS(3166),
    [anon_sym_LT_LT] = ACTIONS(3166),
    [anon_sym_GT_LPAREN] = ACTIONS(3166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3166),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3166),
    [sym_word] = ACTIONS(3166),
    [anon_sym_PIPE] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3166),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_LT_AMP] = ACTIONS(3166),
    [anon_sym_GT_GT] = ACTIONS(3166),
    [sym__special_character] = ACTIONS(3166),
    [anon_sym_LT_LT_DASH] = ACTIONS(3166),
    [anon_sym_BQUOTE] = ACTIONS(3166),
    [anon_sym_LF] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3166),
    [sym_raw_string] = ACTIONS(3166),
    [sym_variable_name] = ACTIONS(3168),
    [sym_file_descriptor] = ACTIONS(3168),
    [anon_sym_RPAREN] = ACTIONS(3166),
    [anon_sym_GT] = ACTIONS(3166),
    [anon_sym_AMP_GT] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [anon_sym_LT_LT_LT] = ACTIONS(3166),
    [anon_sym_GT_AMP] = ACTIONS(3166),
    [ts_builtin_sym_end] = ACTIONS(3168),
    [anon_sym_LT_LPAREN] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_SEMI_SEMI] = ACTIONS(3166),
    [anon_sym_PIPE_AMP] = ACTIONS(3166),
  },
  [1242] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2896),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [sym_word] = ACTIONS(2896),
    [anon_sym_PIPE] = ACTIONS(2896),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_LT_AMP] = ACTIONS(2896),
    [anon_sym_GT_GT] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [sym__special_character] = ACTIONS(2896),
    [anon_sym_LT_LT_DASH] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [sym_raw_string] = ACTIONS(2896),
    [sym_variable_name] = ACTIONS(2898),
    [sym_file_descriptor] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2896),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_AMP_GT] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [anon_sym_LT_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_AMP] = ACTIONS(2896),
    [ts_builtin_sym_end] = ACTIONS(2898),
    [anon_sym_LT_LPAREN] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
    [anon_sym_PIPE_AMP] = ACTIONS(2896),
  },
  [1243] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1244] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1490),
    [sym_concatenation] = STATE(1490),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3521),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3521),
    [anon_sym_PERCENT] = ACTIONS(3521),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3523),
    [anon_sym_COLON_DASH] = ACTIONS(3521),
    [sym__special_character] = ACTIONS(553),
  },
  [1245] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [sym__concat] = ACTIONS(2213),
  },
  [1246] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3525),
  },
  [1247] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3519),
  },
  [1248] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [sym_word] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [sym__special_character] = ACTIONS(2945),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [sym_variable_name] = ACTIONS(2947),
    [sym_file_descriptor] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [ts_builtin_sym_end] = ACTIONS(2947),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
  },
  [1249] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1493),
    [sym_concatenation] = STATE(1493),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3527),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3527),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3531),
    [anon_sym_COLON_DASH] = ACTIONS(3527),
    [sym__special_character] = ACTIONS(553),
  },
  [1250] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1251] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2993),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [sym_word] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_LT_AMP] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [sym__special_character] = ACTIONS(2993),
    [anon_sym_LT_LT_DASH] = ACTIONS(2993),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [sym_raw_string] = ACTIONS(2993),
    [sym_variable_name] = ACTIONS(2995),
    [sym_file_descriptor] = ACTIONS(2995),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_AMP_GT] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_LT_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_AMP] = ACTIONS(2993),
    [ts_builtin_sym_end] = ACTIONS(2995),
    [anon_sym_LT_LPAREN] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
    [anon_sym_PIPE_AMP] = ACTIONS(2993),
  },
  [1252] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3012),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3012),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [sym_word] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_LT_AMP] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [sym__special_character] = ACTIONS(3012),
    [anon_sym_LT_LT_DASH] = ACTIONS(3012),
    [anon_sym_BQUOTE] = ACTIONS(3012),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [sym_raw_string] = ACTIONS(3012),
    [sym_variable_name] = ACTIONS(3014),
    [sym_file_descriptor] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_AMP_GT] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_LT_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_AMP] = ACTIONS(3012),
    [ts_builtin_sym_end] = ACTIONS(3014),
    [anon_sym_LT_LPAREN] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
    [anon_sym_PIPE_AMP] = ACTIONS(3012),
  },
  [1253] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1254] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2896),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [sym_word] = ACTIONS(2896),
    [anon_sym_PIPE] = ACTIONS(2896),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_LT_AMP] = ACTIONS(2896),
    [anon_sym_GT_GT] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [sym__special_character] = ACTIONS(2896),
    [anon_sym_LT_LT_DASH] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [sym_raw_string] = ACTIONS(2896),
    [sym_file_descriptor] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2896),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_AMP_GT] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [anon_sym_LT_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_AMP] = ACTIONS(2896),
    [ts_builtin_sym_end] = ACTIONS(2898),
    [anon_sym_LT_LPAREN] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
    [anon_sym_PIPE_AMP] = ACTIONS(2896),
  },
  [1255] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1256] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1496),
    [sym_concatenation] = STATE(1496),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3537),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_PERCENT] = ACTIONS(3537),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3539),
    [anon_sym_COLON_DASH] = ACTIONS(3537),
    [sym__special_character] = ACTIONS(553),
  },
  [1257] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3535),
    [sym__concat] = ACTIONS(2213),
  },
  [1258] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3541),
  },
  [1259] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3535),
  },
  [1260] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [sym_word] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [sym__special_character] = ACTIONS(2945),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [sym_file_descriptor] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [ts_builtin_sym_end] = ACTIONS(2947),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
  },
  [1261] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1499),
    [sym_concatenation] = STATE(1499),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3543),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3543),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3547),
    [anon_sym_COLON_DASH] = ACTIONS(3543),
    [sym__special_character] = ACTIONS(553),
  },
  [1262] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1263] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2993),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [sym_word] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_LT_AMP] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [sym__special_character] = ACTIONS(2993),
    [anon_sym_LT_LT_DASH] = ACTIONS(2993),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [sym_raw_string] = ACTIONS(2993),
    [sym_file_descriptor] = ACTIONS(2995),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_AMP_GT] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_LT_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_AMP] = ACTIONS(2993),
    [ts_builtin_sym_end] = ACTIONS(2995),
    [anon_sym_LT_LPAREN] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
    [anon_sym_PIPE_AMP] = ACTIONS(2993),
  },
  [1264] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3012),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3012),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [sym_word] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_LT_AMP] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [sym__special_character] = ACTIONS(3012),
    [anon_sym_LT_LT_DASH] = ACTIONS(3012),
    [anon_sym_BQUOTE] = ACTIONS(3012),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [sym_raw_string] = ACTIONS(3012),
    [sym_file_descriptor] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_AMP_GT] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_LT_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_AMP] = ACTIONS(3012),
    [ts_builtin_sym_end] = ACTIONS(3014),
    [anon_sym_LT_LPAREN] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
    [anon_sym_PIPE_AMP] = ACTIONS(3012),
  },
  [1265] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3549),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1266] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3551),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [sym_word] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_LT_AMP] = ACTIONS(3551),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [anon_sym_EQ_TILDE] = ACTIONS(3551),
    [sym__special_character] = ACTIONS(3551),
    [anon_sym_LT_LT_DASH] = ACTIONS(3551),
    [anon_sym_BQUOTE] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3551),
    [sym_raw_string] = ACTIONS(3551),
    [sym_file_descriptor] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(3551),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_AMP_GT] = ACTIONS(3551),
    [anon_sym_EQ_EQ] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_LT_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_AMP] = ACTIONS(3551),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [anon_sym_LT_LPAREN] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_PIPE_AMP] = ACTIONS(3551),
  },
  [1267] = {
    [sym_string] = STATE(614),
    [anon_sym_BQUOTE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1312),
    [sym_raw_string] = ACTIONS(1308),
    [anon_sym_COLON_QMARK] = ACTIONS(2261),
    [anon_sym_BANG] = ACTIONS(3555),
    [anon_sym_DOLLAR] = ACTIONS(3555),
    [anon_sym_0] = ACTIONS(1312),
    [anon_sym_RBRACE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2265),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2265),
    [anon_sym_PERCENT] = ACTIONS(2261),
    [anon_sym_COLON] = ACTIONS(2261),
    [anon_sym_GT_LPAREN] = ACTIONS(2265),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(1312),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1312),
    [anon_sym_LT_LPAREN] = ACTIONS(2265),
    [anon_sym_AT] = ACTIONS(1312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1310),
    [anon_sym_COLON_DASH] = ACTIONS(2261),
    [sym__special_character] = ACTIONS(2261),
    [anon_sym__] = ACTIONS(1312),
  },
  [1268] = {
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_raw_string] = ACTIONS(2111),
    [anon_sym_COLON_QMARK] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2111),
    [anon_sym_EQ] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2111),
    [anon_sym_PERCENT] = ACTIONS(2109),
    [anon_sym_COLON] = ACTIONS(2109),
    [anon_sym_GT_LPAREN] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [sym_word] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [anon_sym_LT_LPAREN] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2111),
    [anon_sym_COLON_DASH] = ACTIONS(2109),
    [sym__special_character] = ACTIONS(2109),
  },
  [1269] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1502),
    [sym_concatenation] = STATE(1502),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3557),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3557),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3557),
    [anon_sym_PERCENT] = ACTIONS(3557),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3561),
    [anon_sym_COLON_DASH] = ACTIONS(3557),
    [sym__special_character] = ACTIONS(553),
  },
  [1270] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1271] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1502),
    [sym_concatenation] = STATE(1502),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3557),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3557),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3557),
    [anon_sym_PERCENT] = ACTIONS(3557),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3561),
    [anon_sym_COLON_DASH] = ACTIONS(3557),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3563),
  },
  [1272] = {
    [sym_command_substitution] = STATE(1504),
    [aux_sym__literal_repeat1] = STATE(1505),
    [sym_string] = STATE(1504),
    [sym_process_substitution] = STATE(1504),
    [sym_simple_expansion] = STATE(1504),
    [sym_string_expansion] = STATE(1504),
    [sym_concatenation] = STATE(1506),
    [sym_expansion] = STATE(1504),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3565),
    [sym_raw_string] = ACTIONS(3565),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1273] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1509),
    [sym_concatenation] = STATE(1509),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3567),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_DASH] = ACTIONS(3567),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3567),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3567),
    [anon_sym_PERCENT] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3571),
    [anon_sym_COLON_DASH] = ACTIONS(3567),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3573),
  },
  [1274] = {
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_raw_string] = ACTIONS(2207),
    [anon_sym_COLON_QMARK] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_RBRACE] = ACTIONS(2207),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2207),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2207),
    [anon_sym_PERCENT] = ACTIONS(2205),
    [anon_sym_COLON] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [sym_word] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [anon_sym_LT_LPAREN] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2207),
    [anon_sym_COLON_DASH] = ACTIONS(2205),
    [sym__special_character] = ACTIONS(2205),
  },
  [1275] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1276] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [sym__concat] = ACTIONS(2213),
  },
  [1277] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3575),
  },
  [1278] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3559),
  },
  [1279] = {
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [sym_raw_string] = ACTIONS(2249),
    [anon_sym_COLON_QMARK] = ACTIONS(2247),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2249),
    [anon_sym_EQ] = ACTIONS(2247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2249),
    [anon_sym_PERCENT] = ACTIONS(2247),
    [anon_sym_COLON] = ACTIONS(2247),
    [anon_sym_GT_LPAREN] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_word] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [anon_sym_LT_LPAREN] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2249),
    [anon_sym_COLON_DASH] = ACTIONS(2247),
    [sym__special_character] = ACTIONS(2247),
  },
  [1280] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1512),
    [sym_concatenation] = STATE(1512),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3577),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [anon_sym_DASH] = ACTIONS(3577),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3577),
    [anon_sym_PERCENT] = ACTIONS(3577),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3581),
    [anon_sym_COLON_DASH] = ACTIONS(3577),
    [sym__special_character] = ACTIONS(553),
  },
  [1281] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3579),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1282] = {
    [anon_sym_BQUOTE] = ACTIONS(2585),
    [sym_raw_string] = ACTIONS(2585),
    [anon_sym_COLON_QMARK] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_RBRACE] = ACTIONS(2585),
    [anon_sym_DASH] = ACTIONS(2583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2585),
    [anon_sym_EQ] = ACTIONS(2583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2585),
    [anon_sym_PERCENT] = ACTIONS(2583),
    [anon_sym_COLON] = ACTIONS(2583),
    [anon_sym_GT_LPAREN] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(2585),
    [sym_word] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_LT_LPAREN] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2585),
    [anon_sym_COLON_DASH] = ACTIONS(2583),
    [sym__special_character] = ACTIONS(2583),
  },
  [1283] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1284] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [sym_word] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_LT_AMP] = ACTIONS(3585),
    [anon_sym_GT_GT] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [anon_sym_EQ_TILDE] = ACTIONS(3585),
    [sym__special_character] = ACTIONS(3585),
    [anon_sym_LT_LT_DASH] = ACTIONS(3585),
    [anon_sym_BQUOTE] = ACTIONS(3585),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3585),
    [sym_raw_string] = ACTIONS(3585),
    [sym_file_descriptor] = ACTIONS(3587),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_AMP_GT] = ACTIONS(3585),
    [anon_sym_EQ_EQ] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_LT_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_AMP] = ACTIONS(3585),
    [ts_builtin_sym_end] = ACTIONS(3587),
    [anon_sym_LT_LPAREN] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
    [anon_sym_PIPE_AMP] = ACTIONS(3585),
  },
  [1285] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3589),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3589),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [sym_word] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_AMP] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [anon_sym_EQ_TILDE] = ACTIONS(3589),
    [sym__special_character] = ACTIONS(3589),
    [anon_sym_LT_LT_DASH] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(3589),
    [anon_sym_LF] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [sym_raw_string] = ACTIONS(3589),
    [sym_file_descriptor] = ACTIONS(3591),
    [anon_sym_RPAREN] = ACTIONS(3589),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_AMP_GT] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_LT_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_AMP] = ACTIONS(3589),
    [ts_builtin_sym_end] = ACTIONS(3591),
    [anon_sym_LT_LPAREN] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
    [anon_sym_PIPE_AMP] = ACTIONS(3589),
  },
  [1286] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3593),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1287] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [sym__concat] = ACTIONS(1290),
  },
  [1288] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [sym__concat] = ACTIONS(1641),
  },
  [1289] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(3595),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1290] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1392),
    [sym__concat] = ACTIONS(1392),
  },
  [1291] = {
    [sym_command_substitution] = STATE(1290),
    [sym_simple_expansion] = STATE(1290),
    [sym_string_expansion] = STATE(1290),
    [sym_string] = STATE(1290),
    [sym_process_substitution] = STATE(1290),
    [sym_expansion] = STATE(1290),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(2961),
    [sym_raw_string] = ACTIONS(2961),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(3597),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(2961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1292] = {
    [aux_sym_concatenation_repeat1] = STATE(1292),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1392),
    [sym__concat] = ACTIONS(3599),
  },
  [1293] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [sym__concat] = ACTIONS(1284),
  },
  [1294] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1519),
    [sym_concatenation] = STATE(1519),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3606),
    [anon_sym_COLON_DASH] = ACTIONS(3602),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3608),
  },
  [1295] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1326),
    [sym__concat] = ACTIONS(1326),
  },
  [1296] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1297] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1519),
    [sym_concatenation] = STATE(1519),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3610),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3606),
    [anon_sym_COLON_DASH] = ACTIONS(3602),
    [sym__special_character] = ACTIONS(553),
  },
  [1298] = {
    [anon_sym_EQ] = ACTIONS(3612),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1299] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1524),
    [sym_concatenation] = STATE(1524),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3614),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3616),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3618),
    [anon_sym_DASH] = ACTIONS(3616),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_PERCENT] = ACTIONS(3616),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3620),
    [anon_sym_COLON_DASH] = ACTIONS(3616),
    [sym__special_character] = ACTIONS(553),
  },
  [1300] = {
    [sym_command_substitution] = STATE(1525),
    [aux_sym__literal_repeat1] = STATE(1526),
    [sym_string] = STATE(1525),
    [sym_process_substitution] = STATE(1525),
    [sym_simple_expansion] = STATE(1525),
    [sym_string_expansion] = STATE(1525),
    [sym_concatenation] = STATE(1527),
    [sym_expansion] = STATE(1525),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3622),
    [sym_raw_string] = ACTIONS(3622),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3604),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1301] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1530),
    [sym_concatenation] = STATE(1530),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3624),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3626),
    [anon_sym_DASH] = ACTIONS(3624),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_PERCENT] = ACTIONS(3624),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3628),
    [anon_sym_COLON_DASH] = ACTIONS(3624),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3630),
  },
  [1302] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1382),
    [sym__concat] = ACTIONS(1382),
  },
  [1303] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3626),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1304] = {
    [anon_sym_BQUOTE] = ACTIONS(3233),
    [anon_sym_SLASH] = ACTIONS(3233),
    [sym_raw_string] = ACTIONS(3233),
    [anon_sym_COLON_QMARK] = ACTIONS(3632),
    [anon_sym_DOLLAR] = ACTIONS(3632),
    [anon_sym_RBRACE] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_EQ] = ACTIONS(3632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3233),
    [anon_sym_PERCENT] = ACTIONS(3632),
    [anon_sym_COLON] = ACTIONS(3632),
    [anon_sym_GT_LPAREN] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_word] = ACTIONS(3632),
    [anon_sym_LT_LPAREN] = ACTIONS(3233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3233),
    [anon_sym_COLON_DASH] = ACTIONS(3632),
    [sym__special_character] = ACTIONS(3632),
  },
  [1305] = {
    [anon_sym_BQUOTE] = ACTIONS(3233),
    [anon_sym_SLASH] = ACTIONS(3233),
    [sym_raw_string] = ACTIONS(3233),
    [anon_sym_COLON_QMARK] = ACTIONS(3632),
    [anon_sym_DOLLAR] = ACTIONS(3632),
    [anon_sym_RBRACE] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_EQ] = ACTIONS(3632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3233),
    [anon_sym_PERCENT] = ACTIONS(3632),
    [anon_sym_COLON] = ACTIONS(3632),
    [anon_sym_GT_LPAREN] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [sym_word] = ACTIONS(3632),
    [sym__concat] = ACTIONS(3634),
    [anon_sym_LT_LPAREN] = ACTIONS(3233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3233),
    [anon_sym_COLON_DASH] = ACTIONS(3632),
    [sym__special_character] = ACTIONS(3632),
  },
  [1306] = {
    [anon_sym_BQUOTE] = ACTIONS(3239),
    [anon_sym_SLASH] = ACTIONS(3239),
    [sym_raw_string] = ACTIONS(3239),
    [anon_sym_COLON_QMARK] = ACTIONS(3636),
    [anon_sym_DOLLAR] = ACTIONS(3636),
    [anon_sym_RBRACE] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3636),
    [anon_sym_EQ] = ACTIONS(3636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3239),
    [anon_sym_PERCENT] = ACTIONS(3636),
    [anon_sym_COLON] = ACTIONS(3636),
    [anon_sym_GT_LPAREN] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [sym_word] = ACTIONS(3636),
    [anon_sym_LT_LPAREN] = ACTIONS(3239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3239),
    [anon_sym_COLON_DASH] = ACTIONS(3636),
    [sym__special_character] = ACTIONS(3636),
  },
  [1307] = {
    [anon_sym_BQUOTE] = ACTIONS(3239),
    [anon_sym_SLASH] = ACTIONS(3239),
    [sym_raw_string] = ACTIONS(3239),
    [anon_sym_COLON_QMARK] = ACTIONS(3636),
    [anon_sym_DOLLAR] = ACTIONS(3636),
    [anon_sym_RBRACE] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3636),
    [anon_sym_EQ] = ACTIONS(3636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3239),
    [anon_sym_PERCENT] = ACTIONS(3636),
    [anon_sym_COLON] = ACTIONS(3636),
    [anon_sym_GT_LPAREN] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [sym_word] = ACTIONS(3636),
    [sym__concat] = ACTIONS(3638),
    [anon_sym_LT_LPAREN] = ACTIONS(3239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3239),
    [anon_sym_COLON_DASH] = ACTIONS(3636),
    [sym__special_character] = ACTIONS(3636),
  },
  [1308] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3640),
    [anon_sym_PIPE_PIPE] = ACTIONS(3640),
    [sym_word] = ACTIONS(3640),
    [anon_sym_PIPE] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_LT_AMP] = ACTIONS(3640),
    [anon_sym_GT_GT] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3640),
    [sym__special_character] = ACTIONS(3640),
    [anon_sym_LT_LT_DASH] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(3640),
    [anon_sym_LF] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3640),
    [sym_raw_string] = ACTIONS(3640),
    [sym_file_descriptor] = ACTIONS(3642),
    [anon_sym_RPAREN] = ACTIONS(3640),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_AMP_GT] = ACTIONS(3640),
    [anon_sym_EQ_EQ] = ACTIONS(3640),
    [anon_sym_DQUOTE] = ACTIONS(3640),
    [anon_sym_LT_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_AMP] = ACTIONS(3640),
    [ts_builtin_sym_end] = ACTIONS(3642),
    [anon_sym_LT_LPAREN] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
    [anon_sym_PIPE_AMP] = ACTIONS(3640),
  },
  [1309] = {
    [aux_sym_concatenation_repeat1] = STATE(1309),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(3200),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1310] = {
    [aux_sym_concatenation_repeat1] = STATE(1310),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [sym__concat] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1311] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1311),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_local] = ACTIONS(938),
    [anon_sym_typeset] = ACTIONS(938),
    [anon_sym_unsetenv] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(944),
    [anon_sym_fi] = ACTIONS(906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(956),
    [sym_word] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(965),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(938),
    [sym__special_character] = ACTIONS(968),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(974),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(977),
    [sym_raw_string] = ACTIONS(980),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_declare] = ACTIONS(938),
    [sym_variable_name] = ACTIONS(989),
    [sym_file_descriptor] = ACTIONS(992),
    [anon_sym_GT] = ACTIONS(965),
    [anon_sym_AMP_GT] = ACTIONS(965),
    [anon_sym_readonly] = ACTIONS(938),
    [anon_sym_unset] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT_LPAREN] = ACTIONS(947),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(1004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1007),
  },
  [1312] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1533),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_fi] = ACTIONS(3644),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_else] = ACTIONS(3644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_elif] = ACTIONS(3644),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1313] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3646),
    [anon_sym_BQUOTE] = ACTIONS(3646),
    [anon_sym_AMP_GT_GT] = ACTIONS(3646),
    [anon_sym_LF] = ACTIONS(3648),
    [anon_sym_SEMI] = ACTIONS(3646),
    [anon_sym_LT_LT] = ACTIONS(3646),
    [sym_file_descriptor] = ACTIONS(3648),
    [anon_sym_GT] = ACTIONS(3646),
    [anon_sym_RPAREN] = ACTIONS(3646),
    [anon_sym_AMP_GT] = ACTIONS(3646),
    [anon_sym_PIPE_PIPE] = ACTIONS(3646),
    [ts_builtin_sym_end] = ACTIONS(3648),
    [anon_sym_LT_LT_LT] = ACTIONS(3646),
    [anon_sym_PIPE] = ACTIONS(3646),
    [anon_sym_GT_AMP] = ACTIONS(3646),
    [anon_sym_LT] = ACTIONS(3646),
    [anon_sym_LT_AMP] = ACTIONS(3646),
    [anon_sym_GT_GT] = ACTIONS(3646),
    [anon_sym_AMP] = ACTIONS(3646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3646),
    [anon_sym_AMP_AMP] = ACTIONS(3646),
    [anon_sym_SEMI_SEMI] = ACTIONS(3646),
    [anon_sym_PIPE_AMP] = ACTIONS(3646),
  },
  [1314] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3650),
  },
  [1315] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3652),
    [anon_sym_BQUOTE] = ACTIONS(3652),
    [anon_sym_AMP_GT_GT] = ACTIONS(3652),
    [anon_sym_LF] = ACTIONS(3654),
    [anon_sym_SEMI] = ACTIONS(3652),
    [anon_sym_LT_LT] = ACTIONS(3652),
    [sym_file_descriptor] = ACTIONS(3654),
    [anon_sym_GT] = ACTIONS(3652),
    [anon_sym_RPAREN] = ACTIONS(3652),
    [anon_sym_AMP_GT] = ACTIONS(3652),
    [anon_sym_PIPE_PIPE] = ACTIONS(3652),
    [ts_builtin_sym_end] = ACTIONS(3654),
    [anon_sym_LT_LT_LT] = ACTIONS(3652),
    [anon_sym_PIPE] = ACTIONS(3652),
    [anon_sym_GT_AMP] = ACTIONS(3652),
    [anon_sym_LT] = ACTIONS(3652),
    [anon_sym_LT_AMP] = ACTIONS(3652),
    [anon_sym_GT_GT] = ACTIONS(3652),
    [anon_sym_AMP] = ACTIONS(3652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3652),
    [anon_sym_AMP_AMP] = ACTIONS(3652),
    [anon_sym_SEMI_SEMI] = ACTIONS(3652),
    [anon_sym_PIPE_AMP] = ACTIONS(3652),
  },
  [1316] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(3656),
  },
  [1317] = {
    [sym_command_substitution] = STATE(1027),
    [aux_sym__literal_repeat1] = STATE(1030),
    [sym_case_item] = STATE(1325),
    [sym_string] = STATE(1027),
    [sym_process_substitution] = STATE(1027),
    [sym_last_case_item] = STATE(1536),
    [sym_simple_expansion] = STATE(1027),
    [sym_string_expansion] = STATE(1027),
    [aux_sym_case_statement_repeat1] = STATE(1325),
    [sym_concatenation] = STATE(1033),
    [sym_expansion] = STATE(1027),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(2340),
    [sym_raw_string] = ACTIONS(2340),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [1318] = {
    [sym_command_substitution] = STATE(1537),
    [aux_sym__literal_repeat1] = STATE(1538),
    [sym_string] = STATE(1537),
    [sym_process_substitution] = STATE(1537),
    [sym_simple_expansion] = STATE(1537),
    [sym_string_expansion] = STATE(1537),
    [sym_concatenation] = STATE(1539),
    [sym_expansion] = STATE(1537),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(3658),
    [sym_raw_string] = ACTIONS(3658),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [1319] = {
    [aux_sym__literal_repeat1] = STATE(1554),
    [sym_if_statement] = STATE(1555),
    [sym_function_definition] = STATE(1555),
    [sym_negated_command] = STATE(1555),
    [sym_test_command] = STATE(1555),
    [sym_variable_assignment] = STATE(1556),
    [sym_subscript] = STATE(1557),
    [sym_concatenation] = STATE(1558),
    [sym_expansion] = STATE(1548),
    [sym_command_substitution] = STATE(1548),
    [aux_sym__statements_repeat1] = STATE(1559),
    [sym_redirected_statement] = STATE(1555),
    [sym_for_statement] = STATE(1555),
    [sym_compound_statement] = STATE(1555),
    [sym_subshell] = STATE(1555),
    [sym_declaration_command] = STATE(1555),
    [sym_unset_command] = STATE(1555),
    [sym_file_redirect] = STATE(1560),
    [sym_string] = STATE(1548),
    [sym_process_substitution] = STATE(1548),
    [aux_sym_command_repeat1] = STATE(1560),
    [sym__statements] = STATE(1561),
    [sym_c_style_for_statement] = STATE(1555),
    [sym_while_statement] = STATE(1555),
    [sym_case_statement] = STATE(1555),
    [sym_pipeline] = STATE(1555),
    [sym_list] = STATE(1555),
    [sym_command] = STATE(1555),
    [sym_command_name] = STATE(1562),
    [sym_simple_expansion] = STATE(1548),
    [sym_string_expansion] = STATE(1548),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(3660),
    [anon_sym_typeset] = ACTIONS(3660),
    [anon_sym_unsetenv] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(3660),
    [sym__special_character] = ACTIONS(3674),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3676),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3680),
    [anon_sym_declare] = ACTIONS(3660),
    [sym_variable_name] = ACTIONS(3682),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(3660),
    [anon_sym_unset] = ACTIONS(3662),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [anon_sym_esac] = ACTIONS(3686),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(3688),
  },
  [1320] = {
    [aux_sym_concatenation_repeat1] = STATE(1563),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(585),
    [sym__concat] = ACTIONS(1502),
    [anon_sym_PIPE] = ACTIONS(585),
  },
  [1321] = {
    [aux_sym_case_item_repeat1] = STATE(1565),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_RPAREN] = ACTIONS(3690),
    [sym_comment] = ACTIONS(51),
  },
  [1322] = {
    [aux_sym__literal_repeat1] = STATE(1554),
    [sym_if_statement] = STATE(1555),
    [sym_function_definition] = STATE(1555),
    [sym_negated_command] = STATE(1555),
    [sym_test_command] = STATE(1555),
    [sym_variable_assignment] = STATE(1556),
    [sym_subscript] = STATE(1557),
    [sym_concatenation] = STATE(1558),
    [sym_expansion] = STATE(1548),
    [sym_command_substitution] = STATE(1548),
    [aux_sym__statements_repeat1] = STATE(1559),
    [sym_redirected_statement] = STATE(1555),
    [sym_for_statement] = STATE(1555),
    [sym_compound_statement] = STATE(1555),
    [sym_subshell] = STATE(1555),
    [sym_declaration_command] = STATE(1555),
    [sym_unset_command] = STATE(1555),
    [sym_file_redirect] = STATE(1560),
    [sym_string] = STATE(1548),
    [sym_process_substitution] = STATE(1548),
    [aux_sym_command_repeat1] = STATE(1560),
    [sym__statements] = STATE(1567),
    [sym_c_style_for_statement] = STATE(1555),
    [sym_while_statement] = STATE(1555),
    [sym_case_statement] = STATE(1555),
    [sym_pipeline] = STATE(1555),
    [sym_list] = STATE(1555),
    [sym_command] = STATE(1555),
    [sym_command_name] = STATE(1562),
    [sym_simple_expansion] = STATE(1548),
    [sym_string_expansion] = STATE(1548),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(3660),
    [anon_sym_typeset] = ACTIONS(3660),
    [anon_sym_unsetenv] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(3660),
    [sym__special_character] = ACTIONS(3674),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3676),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3680),
    [anon_sym_declare] = ACTIONS(3660),
    [sym_variable_name] = ACTIONS(3682),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(3660),
    [anon_sym_unset] = ACTIONS(3662),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [anon_sym_esac] = ACTIONS(3692),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(3694),
  },
  [1323] = {
    [aux_sym__literal_repeat1] = STATE(1323),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(888),
    [anon_sym_PIPE] = ACTIONS(888),
    [sym__special_character] = ACTIONS(1534),
  },
  [1324] = {
    [aux_sym_case_item_repeat1] = STATE(1565),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_RPAREN] = ACTIONS(3696),
    [sym_comment] = ACTIONS(51),
  },
  [1325] = {
    [sym_command_substitution] = STATE(1569),
    [aux_sym__literal_repeat1] = STATE(1570),
    [sym_case_item] = STATE(1325),
    [sym_string] = STATE(1569),
    [sym_process_substitution] = STATE(1569),
    [sym_simple_expansion] = STATE(1569),
    [sym_string_expansion] = STATE(1569),
    [aux_sym_case_statement_repeat1] = STATE(1325),
    [sym_concatenation] = STATE(1571),
    [sym_expansion] = STATE(1569),
    [anon_sym_BQUOTE] = ACTIONS(3698),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [sym_word] = ACTIONS(3704),
    [sym_raw_string] = ACTIONS(3704),
    [anon_sym_LT_LPAREN] = ACTIONS(3707),
    [anon_sym_DOLLAR] = ACTIONS(3710),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3707),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3713),
    [sym__special_character] = ACTIONS(3716),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3719),
  },
  [1326] = {
    [anon_sym_AMP] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2898),
    [anon_sym_LF] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [anon_sym_in] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
  },
  [1327] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1328] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1573),
    [sym_concatenation] = STATE(1573),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3724),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [anon_sym_DASH] = ACTIONS(3724),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3724),
    [anon_sym_PERCENT] = ACTIONS(3724),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3726),
    [anon_sym_COLON_DASH] = ACTIONS(3724),
    [sym__special_character] = ACTIONS(553),
  },
  [1329] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3722),
    [sym__concat] = ACTIONS(2213),
  },
  [1330] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3728),
  },
  [1331] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3722),
  },
  [1332] = {
    [anon_sym_AMP] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym_in] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
  },
  [1333] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1576),
    [sym_concatenation] = STATE(1576),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3730),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3730),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3730),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_PERCENT] = ACTIONS(3730),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3734),
    [anon_sym_COLON_DASH] = ACTIONS(3730),
    [sym__special_character] = ACTIONS(553),
  },
  [1334] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1335] = {
    [anon_sym_AMP] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2995),
    [anon_sym_LF] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_in] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
  },
  [1336] = {
    [anon_sym_AMP] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(3014),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_in] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
  },
  [1337] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3736),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1338] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3738),
    [anon_sym_BQUOTE] = ACTIONS(3738),
    [anon_sym_AMP_GT_GT] = ACTIONS(3738),
    [anon_sym_LF] = ACTIONS(3740),
    [anon_sym_SEMI] = ACTIONS(3738),
    [anon_sym_LT_LT] = ACTIONS(3738),
    [sym_file_descriptor] = ACTIONS(3740),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_RPAREN] = ACTIONS(3738),
    [anon_sym_AMP_GT] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE] = ACTIONS(3738),
    [ts_builtin_sym_end] = ACTIONS(3740),
    [anon_sym_LT_LT_LT] = ACTIONS(3738),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_GT_AMP] = ACTIONS(3738),
    [anon_sym_LT] = ACTIONS(3738),
    [anon_sym_LT_AMP] = ACTIONS(3738),
    [anon_sym_GT_GT] = ACTIONS(3738),
    [anon_sym_AMP] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3738),
    [anon_sym_AMP_AMP] = ACTIONS(3738),
    [anon_sym_SEMI_SEMI] = ACTIONS(3738),
    [anon_sym_PIPE_AMP] = ACTIONS(3738),
  },
  [1339] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(3742),
  },
  [1340] = {
    [sym_command_substitution] = STATE(1027),
    [aux_sym__literal_repeat1] = STATE(1030),
    [sym_case_item] = STATE(1325),
    [sym_string] = STATE(1027),
    [sym_process_substitution] = STATE(1027),
    [sym_last_case_item] = STATE(1579),
    [sym_simple_expansion] = STATE(1027),
    [sym_string_expansion] = STATE(1027),
    [aux_sym_case_statement_repeat1] = STATE(1325),
    [sym_concatenation] = STATE(1033),
    [sym_expansion] = STATE(1027),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(2340),
    [sym_raw_string] = ACTIONS(2340),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
  },
  [1341] = {
    [anon_sym_BANG_EQ] = ACTIONS(2898),
    [anon_sym_PLUS_EQ] = ACTIONS(2898),
    [sym_test_operator] = ACTIONS(2898),
    [anon_sym_PLUS_PLUS] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2896),
    [anon_sym_DASH] = ACTIONS(2896),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_EQ_EQ] = ACTIONS(2898),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2898),
    [anon_sym_PIPE_PIPE] = ACTIONS(2898),
    [anon_sym_GT_EQ] = ACTIONS(2898),
    [sym__concat] = ACTIONS(2898),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_PIPE] = ACTIONS(2896),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2898),
    [anon_sym_DASH_DASH] = ACTIONS(2898),
    [anon_sym_LT_EQ] = ACTIONS(2898),
    [anon_sym_AMP_AMP] = ACTIONS(2898),
    [anon_sym_DASH_EQ] = ACTIONS(2898),
  },
  [1342] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1343] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1581),
    [sym_concatenation] = STATE(1581),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3746),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3746),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3748),
    [anon_sym_COLON_DASH] = ACTIONS(3746),
    [sym__special_character] = ACTIONS(553),
  },
  [1344] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [sym__concat] = ACTIONS(2213),
  },
  [1345] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3750),
  },
  [1346] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3744),
  },
  [1347] = {
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [sym_test_operator] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2947),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [sym__concat] = ACTIONS(2947),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
  },
  [1348] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1584),
    [sym_concatenation] = STATE(1584),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3752),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_DASH] = ACTIONS(3752),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3752),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3752),
    [anon_sym_PERCENT] = ACTIONS(3752),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3756),
    [anon_sym_COLON_DASH] = ACTIONS(3752),
    [sym__special_character] = ACTIONS(553),
  },
  [1349] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1350] = {
    [anon_sym_BANG_EQ] = ACTIONS(2995),
    [anon_sym_PLUS_EQ] = ACTIONS(2995),
    [sym_test_operator] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_EQ] = ACTIONS(2993),
    [anon_sym_EQ_EQ] = ACTIONS(2995),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2995),
    [anon_sym_PIPE_PIPE] = ACTIONS(2995),
    [anon_sym_GT_EQ] = ACTIONS(2995),
    [sym__concat] = ACTIONS(2995),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2995),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2995),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_LT_EQ] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2995),
    [anon_sym_DASH_EQ] = ACTIONS(2995),
  },
  [1351] = {
    [anon_sym_BANG_EQ] = ACTIONS(3014),
    [anon_sym_PLUS_EQ] = ACTIONS(3014),
    [sym_test_operator] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ] = ACTIONS(3014),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3014),
    [sym__concat] = ACTIONS(3014),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3012),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_DASH_EQ] = ACTIONS(3014),
  },
  [1352] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1353] = {
    [aux_sym_concatenation_repeat1] = STATE(1353),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [sym__concat] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1354] = {
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_AMP_GT_GT] = ACTIONS(2796),
    [anon_sym_local] = ACTIONS(2794),
    [anon_sym_typeset] = ACTIONS(2794),
    [anon_sym_unsetenv] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2794),
    [anon_sym_GT_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2794),
    [sym_word] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_LT_AMP] = ACTIONS(2796),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2794),
    [sym__special_character] = ACTIONS(2794),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2794),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2796),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BQUOTE] = ACTIONS(3497),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [sym_variable_name] = ACTIONS(2796),
    [sym_file_descriptor] = ACTIONS(2796),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP_GT] = ACTIONS(2794),
    [anon_sym_readonly] = ACTIONS(2794),
    [anon_sym_unset] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [anon_sym_GT_AMP] = ACTIONS(2796),
    [anon_sym_LT_LPAREN] = ACTIONS(2796),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2796),
  },
  [1355] = {
    [anon_sym_BQUOTE] = ACTIONS(3168),
    [anon_sym_AMP_GT_GT] = ACTIONS(3168),
    [sym_raw_string] = ACTIONS(3168),
    [anon_sym_DOLLAR] = ACTIONS(3166),
    [sym_file_descriptor] = ACTIONS(3168),
    [sym_variable_name] = ACTIONS(3168),
    [anon_sym_GT] = ACTIONS(3166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3168),
    [anon_sym_AMP_GT] = ACTIONS(3166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3168),
    [anon_sym_GT_LPAREN] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [sym_word] = ACTIONS(3168),
    [anon_sym_GT_AMP] = ACTIONS(3168),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_LT_AMP] = ACTIONS(3168),
    [anon_sym_GT_GT] = ACTIONS(3168),
    [anon_sym_LT_LPAREN] = ACTIONS(3168),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3168),
  },
  [1356] = {
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_DQUOTE] = ACTIONS(1290),
    [sym_word] = ACTIONS(1290),
    [sym_raw_string] = ACTIONS(1290),
    [sym__concat] = ACTIONS(1290),
    [anon_sym_LT_LPAREN] = ACTIONS(1290),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1290),
    [sym__special_character] = ACTIONS(1290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1290),
  },
  [1357] = {
    [anon_sym_BQUOTE] = ACTIONS(1641),
    [anon_sym_DQUOTE] = ACTIONS(1641),
    [sym_word] = ACTIONS(1641),
    [sym_raw_string] = ACTIONS(1641),
    [sym__concat] = ACTIONS(1641),
    [anon_sym_LT_LPAREN] = ACTIONS(1641),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1641),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1641),
    [sym__special_character] = ACTIONS(1641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1641),
  },
  [1358] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(3760),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1359] = {
    [anon_sym_BQUOTE] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_word] = ACTIONS(1392),
    [sym_raw_string] = ACTIONS(1392),
    [sym__concat] = ACTIONS(1392),
    [anon_sym_LT_LPAREN] = ACTIONS(1392),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1392),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1392),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1392),
    [sym__special_character] = ACTIONS(1392),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1392),
  },
  [1360] = {
    [sym_command_substitution] = STATE(1359),
    [sym_simple_expansion] = STATE(1359),
    [sym_string_expansion] = STATE(1359),
    [sym_string] = STATE(1359),
    [sym_process_substitution] = STATE(1359),
    [sym_expansion] = STATE(1359),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(3131),
    [sym_raw_string] = ACTIONS(3131),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(3762),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(3131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [1361] = {
    [aux_sym_concatenation_repeat1] = STATE(1361),
    [anon_sym_BQUOTE] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [sym_word] = ACTIONS(1392),
    [sym_raw_string] = ACTIONS(1392),
    [sym__concat] = ACTIONS(3764),
    [anon_sym_LT_LPAREN] = ACTIONS(1392),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_RPAREN] = ACTIONS(1392),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1392),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1392),
    [sym__special_character] = ACTIONS(1392),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1392),
  },
  [1362] = {
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [sym_word] = ACTIONS(1284),
    [sym_raw_string] = ACTIONS(1284),
    [sym__concat] = ACTIONS(1284),
    [anon_sym_LT_LPAREN] = ACTIONS(1284),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [anon_sym_RPAREN] = ACTIONS(1284),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1284),
    [sym__special_character] = ACTIONS(1284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1284),
  },
  [1363] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1590),
    [sym_concatenation] = STATE(1590),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3769),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3771),
    [anon_sym_COLON_DASH] = ACTIONS(3767),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3773),
  },
  [1364] = {
    [anon_sym_BQUOTE] = ACTIONS(1326),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [sym_word] = ACTIONS(1326),
    [sym_raw_string] = ACTIONS(1326),
    [sym__concat] = ACTIONS(1326),
    [anon_sym_LT_LPAREN] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_RPAREN] = ACTIONS(1326),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1326),
    [sym__special_character] = ACTIONS(1326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1326),
  },
  [1365] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3769),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1366] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1590),
    [sym_concatenation] = STATE(1590),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3775),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3769),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3767),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3771),
    [anon_sym_COLON_DASH] = ACTIONS(3767),
    [sym__special_character] = ACTIONS(553),
  },
  [1367] = {
    [anon_sym_EQ] = ACTIONS(3777),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1368] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1595),
    [sym_concatenation] = STATE(1595),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3779),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3781),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3783),
    [anon_sym_DASH] = ACTIONS(3781),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3781),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3781),
    [anon_sym_PERCENT] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3785),
    [anon_sym_COLON_DASH] = ACTIONS(3781),
    [sym__special_character] = ACTIONS(553),
  },
  [1369] = {
    [sym_command_substitution] = STATE(1596),
    [aux_sym__literal_repeat1] = STATE(1597),
    [sym_string] = STATE(1596),
    [sym_process_substitution] = STATE(1596),
    [sym_simple_expansion] = STATE(1596),
    [sym_string_expansion] = STATE(1596),
    [sym_concatenation] = STATE(1598),
    [sym_expansion] = STATE(1596),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3787),
    [sym_raw_string] = ACTIONS(3787),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3769),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1370] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1601),
    [sym_concatenation] = STATE(1601),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3789),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_DASH] = ACTIONS(3789),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3789),
    [anon_sym_PERCENT] = ACTIONS(3789),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3793),
    [anon_sym_COLON_DASH] = ACTIONS(3789),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3795),
  },
  [1371] = {
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [anon_sym_DQUOTE] = ACTIONS(1382),
    [sym_word] = ACTIONS(1382),
    [sym_raw_string] = ACTIONS(1382),
    [sym__concat] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(1382),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1382),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1382),
  },
  [1372] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1373] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2583),
    [anon_sym_PIPE_PIPE] = ACTIONS(2583),
    [sym_word] = ACTIONS(2583),
    [anon_sym_PIPE] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_LT_AMP] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [sym__special_character] = ACTIONS(2583),
    [anon_sym_LT_LT_DASH] = ACTIONS(2583),
    [anon_sym_BQUOTE] = ACTIONS(2583),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [sym_raw_string] = ACTIONS(2583),
    [sym_variable_name] = ACTIONS(2585),
    [sym_file_descriptor] = ACTIONS(2585),
    [anon_sym_RPAREN] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_AMP_GT] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2583),
    [anon_sym_LT_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_AMP] = ACTIONS(2583),
    [ts_builtin_sym_end] = ACTIONS(2585),
    [anon_sym_LT_LPAREN] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
    [anon_sym_PIPE_AMP] = ACTIONS(2583),
  },
  [1374] = {
    [sym_string] = STATE(770),
    [anon_sym__] = ACTIONS(1601),
    [anon_sym_AMP_GT_GT] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(3797),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(3797),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [sym_word] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_LT_AMP] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(1601),
    [sym__special_character] = ACTIONS(2261),
    [anon_sym_LT_LT_DASH] = ACTIONS(2261),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(3799),
    [anon_sym_BANG] = ACTIONS(3797),
    [sym_variable_name] = ACTIONS(2265),
    [sym_file_descriptor] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(1601),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_AMP_GT] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(3801),
    [anon_sym_LT_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_AMP] = ACTIONS(2261),
    [ts_builtin_sym_end] = ACTIONS(2265),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(1601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3797),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_PIPE_AMP] = ACTIONS(2261),
  },
  [1375] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [sym_word] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_LT_AMP] = ACTIONS(2109),
    [anon_sym_GT_GT] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [sym__special_character] = ACTIONS(2109),
    [anon_sym_LT_LT_DASH] = ACTIONS(2109),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [anon_sym_LF] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [sym_raw_string] = ACTIONS(2109),
    [sym_variable_name] = ACTIONS(2111),
    [sym_file_descriptor] = ACTIONS(2111),
    [anon_sym_RPAREN] = ACTIONS(2109),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_AMP_GT] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [anon_sym_LT_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_AMP] = ACTIONS(2109),
    [ts_builtin_sym_end] = ACTIONS(2111),
    [anon_sym_LT_LPAREN] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
    [anon_sym_PIPE_AMP] = ACTIONS(2109),
  },
  [1376] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1603),
    [sym_concatenation] = STATE(1603),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3803),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3803),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3807),
    [anon_sym_COLON_DASH] = ACTIONS(3803),
    [sym__special_character] = ACTIONS(553),
  },
  [1377] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1378] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1603),
    [sym_concatenation] = STATE(1603),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3803),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3803),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3807),
    [anon_sym_COLON_DASH] = ACTIONS(3803),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3809),
  },
  [1379] = {
    [sym_command_substitution] = STATE(1605),
    [aux_sym__literal_repeat1] = STATE(1606),
    [sym_string] = STATE(1605),
    [sym_process_substitution] = STATE(1605),
    [sym_simple_expansion] = STATE(1605),
    [sym_string_expansion] = STATE(1605),
    [sym_concatenation] = STATE(1607),
    [sym_expansion] = STATE(1605),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3811),
    [sym_raw_string] = ACTIONS(3811),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1380] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1610),
    [sym_concatenation] = STATE(1610),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3813),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3813),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3817),
    [anon_sym_COLON_DASH] = ACTIONS(3813),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3819),
  },
  [1381] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [sym__special_character] = ACTIONS(2205),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [sym_variable_name] = ACTIONS(2207),
    [sym_file_descriptor] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [ts_builtin_sym_end] = ACTIONS(2207),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
  },
  [1382] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1383] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [sym__concat] = ACTIONS(2213),
  },
  [1384] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3821),
  },
  [1385] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3805),
  },
  [1386] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2247),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2247),
    [sym_word] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_LT_AMP] = ACTIONS(2247),
    [anon_sym_GT_GT] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [sym__special_character] = ACTIONS(2247),
    [anon_sym_LT_LT_DASH] = ACTIONS(2247),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [sym_raw_string] = ACTIONS(2247),
    [sym_variable_name] = ACTIONS(2249),
    [sym_file_descriptor] = ACTIONS(2249),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_AMP_GT] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_LT_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_AMP] = ACTIONS(2247),
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_LT_LPAREN] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
    [anon_sym_PIPE_AMP] = ACTIONS(2247),
  },
  [1387] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1613),
    [sym_concatenation] = STATE(1613),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3823),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(3823),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3823),
    [anon_sym_PERCENT] = ACTIONS(3823),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3827),
    [anon_sym_COLON_DASH] = ACTIONS(3823),
    [sym__special_character] = ACTIONS(553),
  },
  [1388] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1389] = {
    [anon_sym_EQ] = ACTIONS(3829),
    [anon_sym_PLUS_EQ] = ACTIONS(3829),
    [sym_comment] = ACTIONS(51),
  },
  [1390] = {
    [sym_string] = STATE(472),
    [anon_sym_STAR] = ACTIONS(847),
    [sym_raw_string] = ACTIONS(849),
    [anon_sym_BANG] = ACTIONS(851),
    [anon_sym_RBRACK] = ACTIONS(2265),
    [anon_sym_DOLLAR] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_0] = ACTIONS(853),
    [aux_sym__simple_variable_name_token1] = ACTIONS(853),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [sym__concat] = ACTIONS(2265),
    [anon_sym_QMARK] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(851),
    [anon_sym__] = ACTIONS(853),
  },
  [1391] = {
    [anon_sym_EQ] = ACTIONS(3831),
    [anon_sym_PLUS_EQ] = ACTIONS(3831),
    [sym_comment] = ACTIONS(51),
  },
  [1392] = {
    [anon_sym_BQUOTE] = ACTIONS(2898),
    [anon_sym_DQUOTE] = ACTIONS(2898),
    [sym__concat] = ACTIONS(2898),
    [sym__string_content] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2898),
  },
  [1393] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1394] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1615),
    [sym_concatenation] = STATE(1615),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3835),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [anon_sym_DASH] = ACTIONS(3835),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3835),
    [anon_sym_PERCENT] = ACTIONS(3835),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3837),
    [anon_sym_COLON_DASH] = ACTIONS(3835),
    [sym__special_character] = ACTIONS(553),
  },
  [1395] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [sym__concat] = ACTIONS(2213),
  },
  [1396] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3839),
  },
  [1397] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3833),
  },
  [1398] = {
    [anon_sym_BQUOTE] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [sym__concat] = ACTIONS(2947),
    [sym__string_content] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2947),
  },
  [1399] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1618),
    [sym_concatenation] = STATE(1618),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3841),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3841),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3841),
    [anon_sym_PERCENT] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3845),
    [anon_sym_COLON_DASH] = ACTIONS(3841),
    [sym__special_character] = ACTIONS(553),
  },
  [1400] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1401] = {
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [sym__concat] = ACTIONS(2995),
    [sym__string_content] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2995),
  },
  [1402] = {
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym__concat] = ACTIONS(3014),
    [sym__string_content] = ACTIONS(3012),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3014),
  },
  [1403] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1404] = {
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [sym_raw_string] = ACTIONS(1288),
    [anon_sym_LF] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_GT_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [sym_word] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_LT_LPAREN] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
  },
  [1405] = {
    [anon_sym_BQUOTE] = ACTIONS(1639),
    [sym_raw_string] = ACTIONS(1639),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_GT_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [sym_word] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_LT_LPAREN] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
  },
  [1406] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(3849),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1407] = {
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
  },
  [1408] = {
    [sym_command_substitution] = STATE(1407),
    [sym_simple_expansion] = STATE(1407),
    [sym_string_expansion] = STATE(1407),
    [sym_string] = STATE(1407),
    [sym_process_substitution] = STATE(1407),
    [sym_expansion] = STATE(1407),
    [anon_sym_BQUOTE] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1696),
    [sym_word] = ACTIONS(3275),
    [sym_raw_string] = ACTIONS(3275),
    [anon_sym_LT_LPAREN] = ACTIONS(1700),
    [anon_sym_DOLLAR] = ACTIONS(3851),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1704),
    [sym__special_character] = ACTIONS(3275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1708),
  },
  [1409] = {
    [aux_sym_concatenation_repeat1] = STATE(1409),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [sym__concat] = ACTIONS(3853),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
  },
  [1410] = {
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [sym_raw_string] = ACTIONS(1282),
    [anon_sym_LF] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1282),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [sym_word] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
  },
  [1411] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1624),
    [sym_concatenation] = STATE(1624),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3860),
    [anon_sym_COLON_DASH] = ACTIONS(3856),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3862),
  },
  [1412] = {
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [sym_raw_string] = ACTIONS(1324),
    [anon_sym_LF] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_GT_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [sym_word] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_LT_LPAREN] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
  },
  [1413] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1414] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1624),
    [sym_concatenation] = STATE(1624),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3864),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3856),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_DASH] = ACTIONS(3856),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3860),
    [anon_sym_COLON_DASH] = ACTIONS(3856),
    [sym__special_character] = ACTIONS(553),
  },
  [1415] = {
    [anon_sym_EQ] = ACTIONS(3866),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1416] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1629),
    [sym_concatenation] = STATE(1629),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3868),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3870),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3872),
    [anon_sym_DASH] = ACTIONS(3870),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3870),
    [anon_sym_PERCENT] = ACTIONS(3870),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3874),
    [anon_sym_COLON_DASH] = ACTIONS(3870),
    [sym__special_character] = ACTIONS(553),
  },
  [1417] = {
    [sym_command_substitution] = STATE(1630),
    [aux_sym__literal_repeat1] = STATE(1631),
    [sym_string] = STATE(1630),
    [sym_process_substitution] = STATE(1630),
    [sym_simple_expansion] = STATE(1630),
    [sym_string_expansion] = STATE(1630),
    [sym_concatenation] = STATE(1632),
    [sym_expansion] = STATE(1630),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3876),
    [sym_raw_string] = ACTIONS(3876),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1418] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1635),
    [sym_concatenation] = STATE(1635),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3878),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3880),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3882),
    [anon_sym_COLON_DASH] = ACTIONS(3878),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3884),
  },
  [1419] = {
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_word] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
  },
  [1420] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3880),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1421] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3886),
    [anon_sym_BQUOTE] = ACTIONS(3886),
    [anon_sym_AMP_GT_GT] = ACTIONS(3886),
    [anon_sym_LF] = ACTIONS(3888),
    [anon_sym_SEMI] = ACTIONS(3886),
    [anon_sym_LT_LT] = ACTIONS(3886),
    [sym_file_descriptor] = ACTIONS(3888),
    [anon_sym_GT] = ACTIONS(3886),
    [anon_sym_RPAREN] = ACTIONS(3886),
    [anon_sym_AMP_GT] = ACTIONS(3886),
    [anon_sym_PIPE_PIPE] = ACTIONS(3886),
    [ts_builtin_sym_end] = ACTIONS(3888),
    [anon_sym_LT_LT_LT] = ACTIONS(3886),
    [anon_sym_PIPE] = ACTIONS(3886),
    [anon_sym_GT_AMP] = ACTIONS(3886),
    [anon_sym_LT] = ACTIONS(3886),
    [anon_sym_LT_AMP] = ACTIONS(3886),
    [anon_sym_GT_GT] = ACTIONS(3886),
    [anon_sym_AMP] = ACTIONS(3886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3886),
    [anon_sym_AMP_AMP] = ACTIONS(3886),
    [anon_sym_SEMI_SEMI] = ACTIONS(3886),
    [anon_sym_PIPE_AMP] = ACTIONS(3886),
  },
  [1422] = {
    [sym_string] = STATE(821),
    [sym_test_operator] = ACTIONS(2265),
    [anon_sym_PLUS_EQ] = ACTIONS(2261),
    [anon_sym_PLUS_PLUS] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(3890),
    [anon_sym_DASH] = ACTIONS(3890),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1736),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(1736),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_EQ_TILDE] = ACTIONS(2261),
    [anon_sym_DASH_DASH] = ACTIONS(2261),
    [anon_sym_LT_EQ] = ACTIONS(2261),
    [anon_sym_DASH_EQ] = ACTIONS(2261),
    [anon_sym_BANG_EQ] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(1736),
    [anon_sym_LF] = ACTIONS(2261),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(3892),
    [anon_sym_BANG] = ACTIONS(3890),
    [anon_sym_0] = ACTIONS(1736),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_EQ] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(2261),
    [anon_sym_GT_EQ] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(1736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3890),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym__] = ACTIONS(1736),
  },
  [1423] = {
    [sym_do_group] = STATE(1636),
    [sym_compound_statement] = STATE(1636),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(839),
  },
  [1424] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3894),
    [anon_sym_BQUOTE] = ACTIONS(3894),
    [anon_sym_AMP_GT_GT] = ACTIONS(3894),
    [anon_sym_LF] = ACTIONS(3896),
    [anon_sym_SEMI] = ACTIONS(3894),
    [anon_sym_LT_LT] = ACTIONS(3894),
    [sym_file_descriptor] = ACTIONS(3896),
    [anon_sym_GT] = ACTIONS(3894),
    [anon_sym_RPAREN] = ACTIONS(3894),
    [anon_sym_AMP_GT] = ACTIONS(3894),
    [anon_sym_PIPE_PIPE] = ACTIONS(3894),
    [ts_builtin_sym_end] = ACTIONS(3896),
    [anon_sym_LT_LT_LT] = ACTIONS(3894),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_GT_AMP] = ACTIONS(3894),
    [anon_sym_LT] = ACTIONS(3894),
    [anon_sym_LT_AMP] = ACTIONS(3894),
    [anon_sym_GT_GT] = ACTIONS(3894),
    [anon_sym_AMP] = ACTIONS(3894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(3894),
    [anon_sym_AMP_AMP] = ACTIONS(3894),
    [anon_sym_SEMI_SEMI] = ACTIONS(3894),
    [anon_sym_PIPE_AMP] = ACTIONS(3894),
  },
  [1425] = {
    [sym_do_group] = STATE(1636),
    [sym_compound_statement] = STATE(1636),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(3898),
    [anon_sym_do] = ACTIONS(839),
  },
  [1426] = {
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_PLUS_EQ] = ACTIONS(717),
    [sym_test_operator] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(721),
    [anon_sym_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ] = ACTIONS(723),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(721),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_DASH_EQ] = ACTIONS(717),
  },
  [1427] = {
    [anon_sym_BANG_EQ] = ACTIONS(2109),
    [anon_sym_PLUS_EQ] = ACTIONS(2109),
    [sym_test_operator] = ACTIONS(2111),
    [anon_sym_LF] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_EQ] = ACTIONS(2109),
    [anon_sym_EQ_EQ] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [anon_sym_GT_EQ] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2109),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_LT_EQ] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
    [anon_sym_DASH_EQ] = ACTIONS(2109),
  },
  [1428] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1640),
    [sym_concatenation] = STATE(1640),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3902),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3904),
    [anon_sym_DASH] = ACTIONS(3902),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3902),
    [anon_sym_PERCENT] = ACTIONS(3902),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3906),
    [anon_sym_COLON_DASH] = ACTIONS(3902),
    [sym__special_character] = ACTIONS(553),
  },
  [1429] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3904),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1430] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1640),
    [sym_concatenation] = STATE(1640),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3902),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3904),
    [anon_sym_DASH] = ACTIONS(3902),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3902),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3902),
    [anon_sym_PERCENT] = ACTIONS(3902),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3906),
    [anon_sym_COLON_DASH] = ACTIONS(3902),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3908),
  },
  [1431] = {
    [sym_command_substitution] = STATE(1642),
    [aux_sym__literal_repeat1] = STATE(1643),
    [sym_string] = STATE(1642),
    [sym_process_substitution] = STATE(1642),
    [sym_simple_expansion] = STATE(1642),
    [sym_string_expansion] = STATE(1642),
    [sym_concatenation] = STATE(1644),
    [sym_expansion] = STATE(1642),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3910),
    [sym_raw_string] = ACTIONS(3910),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3904),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1432] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1647),
    [sym_concatenation] = STATE(1647),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3912),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(3912),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3912),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3912),
    [anon_sym_PERCENT] = ACTIONS(3912),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3916),
    [anon_sym_COLON_DASH] = ACTIONS(3912),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3918),
  },
  [1433] = {
    [anon_sym_BANG_EQ] = ACTIONS(2205),
    [anon_sym_PLUS_EQ] = ACTIONS(2205),
    [sym_test_operator] = ACTIONS(2207),
    [anon_sym_LF] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_EQ] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [anon_sym_GT_EQ] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [anon_sym_PLUS] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2205),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_LT_EQ] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
    [anon_sym_DASH_EQ] = ACTIONS(2205),
  },
  [1434] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3914),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1435] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3904),
    [sym__concat] = ACTIONS(2213),
  },
  [1436] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3920),
  },
  [1437] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3904),
  },
  [1438] = {
    [anon_sym_BANG_EQ] = ACTIONS(2247),
    [anon_sym_PLUS_EQ] = ACTIONS(2247),
    [sym_test_operator] = ACTIONS(2249),
    [anon_sym_LF] = ACTIONS(2247),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym_PLUS_PLUS] = ACTIONS(2247),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_EQ] = ACTIONS(2247),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2247),
    [anon_sym_GT_EQ] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [anon_sym_PLUS] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2247),
    [anon_sym_DASH_DASH] = ACTIONS(2247),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_LT_EQ] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
    [anon_sym_DASH_EQ] = ACTIONS(2247),
  },
  [1439] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1650),
    [sym_concatenation] = STATE(1650),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3922),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3924),
    [anon_sym_DASH] = ACTIONS(3922),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3922),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3922),
    [anon_sym_PERCENT] = ACTIONS(3922),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3926),
    [anon_sym_COLON_DASH] = ACTIONS(3922),
    [sym__special_character] = ACTIONS(553),
  },
  [1440] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3924),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1441] = {
    [anon_sym_BANG_EQ] = ACTIONS(2583),
    [anon_sym_PLUS_EQ] = ACTIONS(2583),
    [sym_test_operator] = ACTIONS(2585),
    [anon_sym_LF] = ACTIONS(2583),
    [anon_sym_SEMI] = ACTIONS(2583),
    [anon_sym_PLUS_PLUS] = ACTIONS(2583),
    [anon_sym_DASH] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_EQ] = ACTIONS(2583),
    [anon_sym_EQ_EQ] = ACTIONS(2583),
    [anon_sym_PIPE_PIPE] = ACTIONS(2583),
    [anon_sym_GT_EQ] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_PLUS] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2583),
    [anon_sym_DASH_DASH] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2583),
    [anon_sym_LT_EQ] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
    [anon_sym_DASH_EQ] = ACTIONS(2583),
  },
  [1442] = {
    [sym_command_substitution] = STATE(131),
    [sym_unary_expression] = STATE(1651),
    [sym_postfix_expression] = STATE(1651),
    [sym_string] = STATE(131),
    [aux_sym__literal_repeat1] = STATE(138),
    [sym_process_substitution] = STATE(131),
    [sym_parenthesized_expression] = STATE(1651),
    [sym_simple_expansion] = STATE(131),
    [sym_string_expansion] = STATE(131),
    [sym__expression] = STATE(1651),
    [sym_binary_expression] = STATE(1651),
    [sym_concatenation] = STATE(1651),
    [sym_expansion] = STATE(131),
    [sym_test_operator] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [sym_raw_string] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_GT_LPAREN] = ACTIONS(221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(229),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3900),
    [anon_sym_DQUOTE] = ACTIONS(211),
    [sym_word] = ACTIONS(213),
    [anon_sym_LT_LPAREN] = ACTIONS(221),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(227),
  },
  [1443] = {
    [anon_sym_BANG_EQ] = ACTIONS(2898),
    [anon_sym_PLUS_EQ] = ACTIONS(2898),
    [sym_test_operator] = ACTIONS(2898),
    [anon_sym_PLUS_PLUS] = ACTIONS(2898),
    [anon_sym_RBRACK] = ACTIONS(2898),
    [anon_sym_DASH] = ACTIONS(2896),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_EQ_EQ] = ACTIONS(2898),
    [anon_sym_PIPE_PIPE] = ACTIONS(2898),
    [anon_sym_GT_EQ] = ACTIONS(2898),
    [sym__concat] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2898),
    [anon_sym_DASH_DASH] = ACTIONS(2898),
    [anon_sym_LT_EQ] = ACTIONS(2898),
    [anon_sym_AMP_AMP] = ACTIONS(2898),
    [anon_sym_DASH_EQ] = ACTIONS(2898),
  },
  [1444] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3928),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1445] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1653),
    [sym_concatenation] = STATE(1653),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3930),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3928),
    [anon_sym_DASH] = ACTIONS(3930),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3930),
    [anon_sym_PERCENT] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3932),
    [anon_sym_COLON_DASH] = ACTIONS(3930),
    [sym__special_character] = ACTIONS(553),
  },
  [1446] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3928),
    [sym__concat] = ACTIONS(2213),
  },
  [1447] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3934),
  },
  [1448] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3928),
  },
  [1449] = {
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [sym_test_operator] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_RBRACK] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [sym__concat] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
  },
  [1450] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1656),
    [sym_concatenation] = STATE(1656),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3936),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3938),
    [anon_sym_DASH] = ACTIONS(3936),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3936),
    [anon_sym_PERCENT] = ACTIONS(3936),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3940),
    [anon_sym_COLON_DASH] = ACTIONS(3936),
    [sym__special_character] = ACTIONS(553),
  },
  [1451] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3938),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1452] = {
    [anon_sym_BANG_EQ] = ACTIONS(2995),
    [anon_sym_PLUS_EQ] = ACTIONS(2995),
    [sym_test_operator] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_RBRACK] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_EQ] = ACTIONS(2993),
    [anon_sym_EQ_EQ] = ACTIONS(2995),
    [anon_sym_PIPE_PIPE] = ACTIONS(2995),
    [anon_sym_GT_EQ] = ACTIONS(2995),
    [sym__concat] = ACTIONS(2995),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(2995),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_LT_EQ] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2995),
    [anon_sym_DASH_EQ] = ACTIONS(2995),
  },
  [1453] = {
    [anon_sym_BANG_EQ] = ACTIONS(3014),
    [anon_sym_PLUS_EQ] = ACTIONS(3014),
    [sym_test_operator] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_RBRACK] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3014),
    [sym__concat] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_DASH_EQ] = ACTIONS(3014),
  },
  [1454] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3942),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1455] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2583),
    [anon_sym_BQUOTE] = ACTIONS(2583),
    [anon_sym_AMP_GT_GT] = ACTIONS(2583),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(2583),
    [sym_file_descriptor] = ACTIONS(2585),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_RPAREN] = ACTIONS(2583),
    [anon_sym_AMP_GT] = ACTIONS(2583),
    [anon_sym_PIPE_PIPE] = ACTIONS(2583),
    [ts_builtin_sym_end] = ACTIONS(2585),
    [anon_sym_LT_LT_LT] = ACTIONS(2583),
    [anon_sym_PIPE] = ACTIONS(2583),
    [anon_sym_GT_AMP] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_LT_AMP] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2583),
    [anon_sym_esac] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
    [anon_sym_PIPE_AMP] = ACTIONS(2583),
  },
  [1456] = {
    [sym_string] = STATE(870),
    [anon_sym__] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(3944),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(3944),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_LT_AMP] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(1834),
    [anon_sym_LT_LT_DASH] = ACTIONS(2261),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(3946),
    [anon_sym_BANG] = ACTIONS(3944),
    [sym_file_descriptor] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_AMP_GT] = ACTIONS(2261),
    [ts_builtin_sym_end] = ACTIONS(2265),
    [anon_sym_LT_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_AMP] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [anon_sym_AT] = ACTIONS(1834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3944),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_PIPE_AMP] = ACTIONS(2261),
  },
  [1457] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2109),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [anon_sym_AMP_GT_GT] = ACTIONS(2109),
    [anon_sym_LF] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [sym_file_descriptor] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_RPAREN] = ACTIONS(2109),
    [anon_sym_AMP_GT] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [ts_builtin_sym_end] = ACTIONS(2111),
    [anon_sym_LT_LT_LT] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2109),
    [anon_sym_GT_AMP] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_LT_AMP] = ACTIONS(2109),
    [anon_sym_GT_GT] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_esac] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
    [anon_sym_PIPE_AMP] = ACTIONS(2109),
  },
  [1458] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1659),
    [sym_concatenation] = STATE(1659),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3952),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3954),
    [anon_sym_COLON_DASH] = ACTIONS(3950),
    [sym__special_character] = ACTIONS(553),
  },
  [1459] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3952),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1460] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1659),
    [sym_concatenation] = STATE(1659),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3950),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3952),
    [anon_sym_DASH] = ACTIONS(3950),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3950),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3954),
    [anon_sym_COLON_DASH] = ACTIONS(3950),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3956),
  },
  [1461] = {
    [sym_command_substitution] = STATE(1661),
    [aux_sym__literal_repeat1] = STATE(1662),
    [sym_string] = STATE(1661),
    [sym_process_substitution] = STATE(1661),
    [sym_simple_expansion] = STATE(1661),
    [sym_string_expansion] = STATE(1661),
    [sym_concatenation] = STATE(1663),
    [sym_expansion] = STATE(1661),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3958),
    [sym_raw_string] = ACTIONS(3958),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3952),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1462] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1666),
    [sym_concatenation] = STATE(1666),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3960),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3960),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3960),
    [anon_sym_PERCENT] = ACTIONS(3960),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3964),
    [anon_sym_COLON_DASH] = ACTIONS(3960),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3966),
  },
  [1463] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [sym_file_descriptor] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [ts_builtin_sym_end] = ACTIONS(2207),
    [anon_sym_LT_LT_LT] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_esac] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
  },
  [1464] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1465] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3952),
    [sym__concat] = ACTIONS(2213),
  },
  [1466] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(3968),
  },
  [1467] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3952),
  },
  [1468] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2247),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [anon_sym_AMP_GT_GT] = ACTIONS(2247),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(2247),
    [sym_file_descriptor] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_RPAREN] = ACTIONS(2247),
    [anon_sym_AMP_GT] = ACTIONS(2247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2247),
    [ts_builtin_sym_end] = ACTIONS(2249),
    [anon_sym_LT_LT_LT] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_GT_AMP] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_LT_AMP] = ACTIONS(2247),
    [anon_sym_GT_GT] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_esac] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
    [anon_sym_PIPE_AMP] = ACTIONS(2247),
  },
  [1469] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1669),
    [sym_concatenation] = STATE(1669),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3970),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(3970),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3970),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3970),
    [anon_sym_PERCENT] = ACTIONS(3970),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3974),
    [anon_sym_COLON_DASH] = ACTIONS(3970),
    [sym__special_character] = ACTIONS(553),
  },
  [1470] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3972),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1471] = {
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1290),
    [sym__heredoc_body_end] = ACTIONS(1290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1290),
    [sym__heredoc_body_middle] = ACTIONS(1290),
  },
  [1472] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1672),
    [sym_concatenation] = STATE(1672),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3978),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3976),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3980),
    [anon_sym_COLON_DASH] = ACTIONS(3976),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(3982),
  },
  [1473] = {
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1326),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1326),
    [sym__heredoc_body_end] = ACTIONS(1326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1326),
    [sym__heredoc_body_middle] = ACTIONS(1326),
  },
  [1474] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3978),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1475] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1672),
    [sym_concatenation] = STATE(1672),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3984),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3976),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3978),
    [anon_sym_DASH] = ACTIONS(3976),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3976),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3976),
    [anon_sym_PERCENT] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3980),
    [anon_sym_COLON_DASH] = ACTIONS(3976),
    [sym__special_character] = ACTIONS(553),
  },
  [1476] = {
    [anon_sym_EQ] = ACTIONS(3986),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1477] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1677),
    [sym_concatenation] = STATE(1677),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(3988),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3990),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3990),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3990),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3994),
    [anon_sym_COLON_DASH] = ACTIONS(3990),
    [sym__special_character] = ACTIONS(553),
  },
  [1478] = {
    [sym_command_substitution] = STATE(1678),
    [aux_sym__literal_repeat1] = STATE(1679),
    [sym_string] = STATE(1678),
    [sym_process_substitution] = STATE(1678),
    [sym_simple_expansion] = STATE(1678),
    [sym_string_expansion] = STATE(1678),
    [sym_concatenation] = STATE(1680),
    [sym_expansion] = STATE(1678),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(3996),
    [sym_raw_string] = ACTIONS(3996),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3978),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1479] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1683),
    [sym_concatenation] = STATE(1683),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(3998),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4000),
    [anon_sym_DASH] = ACTIONS(3998),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(3998),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(3998),
    [anon_sym_PERCENT] = ACTIONS(3998),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4002),
    [anon_sym_COLON_DASH] = ACTIONS(3998),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4004),
  },
  [1480] = {
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1382),
    [sym__heredoc_body_end] = ACTIONS(1382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1382),
    [sym__heredoc_body_middle] = ACTIONS(1382),
  },
  [1481] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4000),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1482] = {
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_AMP_GT_GT] = ACTIONS(2796),
    [anon_sym_local] = ACTIONS(2794),
    [anon_sym_typeset] = ACTIONS(2794),
    [anon_sym_unsetenv] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2794),
    [anon_sym_GT_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2796),
    [anon_sym_fi] = ACTIONS(2794),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2796),
    [anon_sym_else] = ACTIONS(2794),
    [anon_sym_done] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2794),
    [sym_word] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_LT_AMP] = ACTIONS(2796),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2794),
    [sym__special_character] = ACTIONS(2794),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2794),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2796),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BQUOTE] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [sym_variable_name] = ACTIONS(2796),
    [sym_file_descriptor] = ACTIONS(2796),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP_GT] = ACTIONS(2794),
    [anon_sym_readonly] = ACTIONS(2794),
    [anon_sym_unset] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [anon_sym_GT_AMP] = ACTIONS(2796),
    [anon_sym_LT_LPAREN] = ACTIONS(2796),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_elif] = ACTIONS(2794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2796),
  },
  [1483] = {
    [anon_sym_BQUOTE] = ACTIONS(3553),
    [anon_sym_AMP_GT_GT] = ACTIONS(3553),
    [sym_raw_string] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [sym_file_descriptor] = ACTIONS(3553),
    [sym_variable_name] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3553),
    [anon_sym_AMP_GT] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3553),
    [anon_sym_GT_LPAREN] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [sym_word] = ACTIONS(3553),
    [anon_sym_GT_AMP] = ACTIONS(3553),
    [sym__concat] = ACTIONS(3553),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_LT_AMP] = ACTIONS(3553),
    [anon_sym_GT_GT] = ACTIONS(3553),
    [anon_sym_LT_LPAREN] = ACTIONS(3553),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3553),
  },
  [1484] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4006),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1485] = {
    [anon_sym_BQUOTE] = ACTIONS(3587),
    [anon_sym_AMP_GT_GT] = ACTIONS(3587),
    [sym_raw_string] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [sym_file_descriptor] = ACTIONS(3587),
    [sym_variable_name] = ACTIONS(3587),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3587),
    [anon_sym_AMP_GT] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3587),
    [anon_sym_GT_LPAREN] = ACTIONS(3587),
    [anon_sym_RPAREN] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3587),
    [sym_word] = ACTIONS(3587),
    [anon_sym_GT_AMP] = ACTIONS(3587),
    [sym__concat] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_LT_AMP] = ACTIONS(3587),
    [anon_sym_GT_GT] = ACTIONS(3587),
    [anon_sym_LT_LPAREN] = ACTIONS(3587),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3587),
  },
  [1486] = {
    [anon_sym_BQUOTE] = ACTIONS(3591),
    [anon_sym_AMP_GT_GT] = ACTIONS(3591),
    [sym_raw_string] = ACTIONS(3591),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [sym_file_descriptor] = ACTIONS(3591),
    [sym_variable_name] = ACTIONS(3591),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3591),
    [anon_sym_AMP_GT] = ACTIONS(3589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3591),
    [anon_sym_GT_LPAREN] = ACTIONS(3591),
    [anon_sym_RPAREN] = ACTIONS(3591),
    [anon_sym_DQUOTE] = ACTIONS(3591),
    [sym_word] = ACTIONS(3591),
    [anon_sym_GT_AMP] = ACTIONS(3591),
    [sym__concat] = ACTIONS(3591),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_AMP] = ACTIONS(3591),
    [anon_sym_GT_GT] = ACTIONS(3591),
    [anon_sym_LT_LPAREN] = ACTIONS(3591),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3591),
  },
  [1487] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4008),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1488] = {
    [anon_sym_BQUOTE] = ACTIONS(3642),
    [anon_sym_AMP_GT_GT] = ACTIONS(3642),
    [sym_raw_string] = ACTIONS(3642),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [sym_file_descriptor] = ACTIONS(3642),
    [sym_variable_name] = ACTIONS(3642),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3642),
    [anon_sym_AMP_GT] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3642),
    [anon_sym_GT_LPAREN] = ACTIONS(3642),
    [anon_sym_RPAREN] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [sym_word] = ACTIONS(3642),
    [anon_sym_GT_AMP] = ACTIONS(3642),
    [sym__concat] = ACTIONS(3642),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_LT_AMP] = ACTIONS(3642),
    [anon_sym_GT_GT] = ACTIONS(3642),
    [anon_sym_LT_LPAREN] = ACTIONS(3642),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3642),
  },
  [1489] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3551),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [sym_word] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_LT_AMP] = ACTIONS(3551),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [sym__special_character] = ACTIONS(3551),
    [anon_sym_LT_LT_DASH] = ACTIONS(3551),
    [anon_sym_BQUOTE] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3551),
    [sym_raw_string] = ACTIONS(3551),
    [sym_variable_name] = ACTIONS(3553),
    [sym_file_descriptor] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(3551),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_AMP_GT] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_LT_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_AMP] = ACTIONS(3551),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [anon_sym_LT_LPAREN] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_PIPE_AMP] = ACTIONS(3551),
  },
  [1490] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4010),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1491] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3585),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [sym_word] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_LT_AMP] = ACTIONS(3585),
    [anon_sym_GT_GT] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [sym__special_character] = ACTIONS(3585),
    [anon_sym_LT_LT_DASH] = ACTIONS(3585),
    [anon_sym_BQUOTE] = ACTIONS(3585),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3585),
    [sym_raw_string] = ACTIONS(3585),
    [sym_variable_name] = ACTIONS(3587),
    [sym_file_descriptor] = ACTIONS(3587),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_AMP_GT] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_LT_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_AMP] = ACTIONS(3585),
    [ts_builtin_sym_end] = ACTIONS(3587),
    [anon_sym_LT_LPAREN] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
    [anon_sym_PIPE_AMP] = ACTIONS(3585),
  },
  [1492] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3589),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3589),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3589),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [sym_word] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_AMP] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [sym__special_character] = ACTIONS(3589),
    [anon_sym_LT_LT_DASH] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(3589),
    [anon_sym_LF] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [sym_raw_string] = ACTIONS(3589),
    [sym_variable_name] = ACTIONS(3591),
    [sym_file_descriptor] = ACTIONS(3591),
    [anon_sym_RPAREN] = ACTIONS(3589),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_AMP_GT] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_LT_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_AMP] = ACTIONS(3589),
    [ts_builtin_sym_end] = ACTIONS(3591),
    [anon_sym_LT_LPAREN] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
    [anon_sym_PIPE_AMP] = ACTIONS(3589),
  },
  [1493] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4012),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1494] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3640),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3640),
    [anon_sym_PIPE_PIPE] = ACTIONS(3640),
    [sym_word] = ACTIONS(3640),
    [anon_sym_PIPE] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_LT_AMP] = ACTIONS(3640),
    [anon_sym_GT_GT] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [sym__special_character] = ACTIONS(3640),
    [anon_sym_LT_LT_DASH] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(3640),
    [anon_sym_LF] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3640),
    [sym_raw_string] = ACTIONS(3640),
    [sym_variable_name] = ACTIONS(3642),
    [sym_file_descriptor] = ACTIONS(3642),
    [anon_sym_RPAREN] = ACTIONS(3640),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_AMP_GT] = ACTIONS(3640),
    [anon_sym_DQUOTE] = ACTIONS(3640),
    [anon_sym_LT_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_AMP] = ACTIONS(3640),
    [ts_builtin_sym_end] = ACTIONS(3642),
    [anon_sym_LT_LPAREN] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
    [anon_sym_PIPE_AMP] = ACTIONS(3640),
  },
  [1495] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3551),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [sym_word] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_LT_AMP] = ACTIONS(3551),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [sym__special_character] = ACTIONS(3551),
    [anon_sym_LT_LT_DASH] = ACTIONS(3551),
    [anon_sym_BQUOTE] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3551),
    [sym_raw_string] = ACTIONS(3551),
    [sym_file_descriptor] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(3551),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_AMP_GT] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_LT_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_AMP] = ACTIONS(3551),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [anon_sym_LT_LPAREN] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_PIPE_AMP] = ACTIONS(3551),
  },
  [1496] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4014),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1497] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3585),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [sym_word] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_LT_AMP] = ACTIONS(3585),
    [anon_sym_GT_GT] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [sym__special_character] = ACTIONS(3585),
    [anon_sym_LT_LT_DASH] = ACTIONS(3585),
    [anon_sym_BQUOTE] = ACTIONS(3585),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3585),
    [sym_raw_string] = ACTIONS(3585),
    [sym_file_descriptor] = ACTIONS(3587),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_AMP_GT] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_LT_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_AMP] = ACTIONS(3585),
    [ts_builtin_sym_end] = ACTIONS(3587),
    [anon_sym_LT_LPAREN] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
    [anon_sym_PIPE_AMP] = ACTIONS(3585),
  },
  [1498] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3589),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3589),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3589),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [sym_word] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_AMP] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [sym__special_character] = ACTIONS(3589),
    [anon_sym_LT_LT_DASH] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(3589),
    [anon_sym_LF] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [sym_raw_string] = ACTIONS(3589),
    [sym_file_descriptor] = ACTIONS(3591),
    [anon_sym_RPAREN] = ACTIONS(3589),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_AMP_GT] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_LT_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_AMP] = ACTIONS(3589),
    [ts_builtin_sym_end] = ACTIONS(3591),
    [anon_sym_LT_LPAREN] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
    [anon_sym_PIPE_AMP] = ACTIONS(3589),
  },
  [1499] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1500] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3640),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3640),
    [anon_sym_PIPE_PIPE] = ACTIONS(3640),
    [sym_word] = ACTIONS(3640),
    [anon_sym_PIPE] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_LT_AMP] = ACTIONS(3640),
    [anon_sym_GT_GT] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [sym__special_character] = ACTIONS(3640),
    [anon_sym_LT_LT_DASH] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(3640),
    [anon_sym_LF] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3640),
    [sym_raw_string] = ACTIONS(3640),
    [sym_file_descriptor] = ACTIONS(3642),
    [anon_sym_RPAREN] = ACTIONS(3640),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_AMP_GT] = ACTIONS(3640),
    [anon_sym_DQUOTE] = ACTIONS(3640),
    [anon_sym_LT_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_AMP] = ACTIONS(3640),
    [ts_builtin_sym_end] = ACTIONS(3642),
    [anon_sym_LT_LPAREN] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
    [anon_sym_PIPE_AMP] = ACTIONS(3640),
  },
  [1501] = {
    [anon_sym_BQUOTE] = ACTIONS(2898),
    [sym_raw_string] = ACTIONS(2898),
    [anon_sym_COLON_QMARK] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_DASH] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2898),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2898),
    [anon_sym_PERCENT] = ACTIONS(2896),
    [anon_sym_COLON] = ACTIONS(2896),
    [anon_sym_GT_LPAREN] = ACTIONS(2898),
    [anon_sym_DQUOTE] = ACTIONS(2898),
    [sym_word] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [anon_sym_LT_LPAREN] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2898),
    [anon_sym_COLON_DASH] = ACTIONS(2896),
    [sym__special_character] = ACTIONS(2896),
  },
  [1502] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1503] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1691),
    [sym_concatenation] = STATE(1691),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4020),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4020),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4020),
    [anon_sym_PERCENT] = ACTIONS(4020),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4022),
    [anon_sym_COLON_DASH] = ACTIONS(4020),
    [sym__special_character] = ACTIONS(553),
  },
  [1504] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4018),
    [sym__concat] = ACTIONS(2213),
  },
  [1505] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4024),
  },
  [1506] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4018),
  },
  [1507] = {
    [anon_sym_BQUOTE] = ACTIONS(2947),
    [sym_raw_string] = ACTIONS(2947),
    [anon_sym_COLON_QMARK] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(2945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2945),
    [anon_sym_COLON] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [sym_word] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [anon_sym_LT_LPAREN] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2947),
    [anon_sym_COLON_DASH] = ACTIONS(2945),
    [sym__special_character] = ACTIONS(2945),
  },
  [1508] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1694),
    [sym_concatenation] = STATE(1694),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4026),
    [anon_sym_PERCENT] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4030),
    [anon_sym_COLON_DASH] = ACTIONS(4026),
    [sym__special_character] = ACTIONS(553),
  },
  [1509] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1510] = {
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [sym_raw_string] = ACTIONS(2995),
    [anon_sym_COLON_QMARK] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_RBRACE] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2995),
    [anon_sym_EQ] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2993),
    [anon_sym_COLON] = ACTIONS(2993),
    [anon_sym_GT_LPAREN] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [sym_word] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [anon_sym_LT_LPAREN] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2995),
    [anon_sym_COLON_DASH] = ACTIONS(2993),
    [sym__special_character] = ACTIONS(2993),
  },
  [1511] = {
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [sym_raw_string] = ACTIONS(3014),
    [anon_sym_COLON_QMARK] = ACTIONS(3012),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3014),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [anon_sym_COLON] = ACTIONS(3012),
    [anon_sym_GT_LPAREN] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_word] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [anon_sym_LT_LPAREN] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3014),
    [anon_sym_COLON_DASH] = ACTIONS(3012),
    [sym__special_character] = ACTIONS(3012),
  },
  [1512] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1513] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [sym_word] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_EQ_TILDE] = ACTIONS(4034),
    [sym__special_character] = ACTIONS(4034),
    [anon_sym_LT_LT_DASH] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4034),
    [sym_raw_string] = ACTIONS(4034),
    [sym_file_descriptor] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4034),
    [anon_sym_EQ_EQ] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [ts_builtin_sym_end] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
  },
  [1514] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_EQ_TILDE] = ACTIONS(4038),
    [sym__special_character] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [sym_file_descriptor] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [ts_builtin_sym_end] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
  },
  [1515] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2585),
    [sym__concat] = ACTIONS(2585),
  },
  [1516] = {
    [sym_string] = STATE(988),
    [anon_sym_STAR] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [anon_sym_QMARK] = ACTIONS(2215),
    [sym_raw_string] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2219),
    [anon_sym_AT] = ACTIONS(2215),
    [anon_sym_DOLLAR] = ACTIONS(2219),
    [anon_sym_POUND] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2219),
    [anon_sym_0] = ACTIONS(2221),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2221),
    [anon_sym__] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
  },
  [1517] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [sym__concat] = ACTIONS(2111),
  },
  [1518] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1697),
    [sym_concatenation] = STATE(1697),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4046),
    [anon_sym_COLON_DASH] = ACTIONS(4042),
    [sym__special_character] = ACTIONS(553),
  },
  [1519] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1520] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1697),
    [sym_concatenation] = STATE(1697),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4042),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4042),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4046),
    [anon_sym_COLON_DASH] = ACTIONS(4042),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4048),
  },
  [1521] = {
    [sym_command_substitution] = STATE(1699),
    [aux_sym__literal_repeat1] = STATE(1700),
    [sym_string] = STATE(1699),
    [sym_process_substitution] = STATE(1699),
    [sym_simple_expansion] = STATE(1699),
    [sym_string_expansion] = STATE(1699),
    [sym_concatenation] = STATE(1701),
    [sym_expansion] = STATE(1699),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(4050),
    [sym_raw_string] = ACTIONS(4050),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1522] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1704),
    [sym_concatenation] = STATE(1704),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4056),
    [anon_sym_COLON_DASH] = ACTIONS(4052),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4058),
  },
  [1523] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2207),
    [sym__concat] = ACTIONS(2207),
  },
  [1524] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1525] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4044),
    [sym__concat] = ACTIONS(2213),
  },
  [1526] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4060),
  },
  [1527] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4044),
  },
  [1528] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [sym__concat] = ACTIONS(2249),
  },
  [1529] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1707),
    [sym_concatenation] = STATE(1707),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4062),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4062),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4062),
    [anon_sym_PERCENT] = ACTIONS(4062),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4066),
    [anon_sym_COLON_DASH] = ACTIONS(4062),
    [sym__special_character] = ACTIONS(553),
  },
  [1530] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1531] = {
    [anon_sym_BQUOTE] = ACTIONS(3829),
    [anon_sym_SLASH] = ACTIONS(3829),
    [sym_raw_string] = ACTIONS(3829),
    [anon_sym_COLON_QMARK] = ACTIONS(4068),
    [anon_sym_DOLLAR] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(4068),
    [anon_sym_EQ] = ACTIONS(4068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3829),
    [anon_sym_PERCENT] = ACTIONS(4068),
    [anon_sym_COLON] = ACTIONS(4068),
    [anon_sym_GT_LPAREN] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [sym_word] = ACTIONS(4068),
    [anon_sym_LT_LPAREN] = ACTIONS(3829),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3829),
    [anon_sym_COLON_DASH] = ACTIONS(4068),
    [sym__special_character] = ACTIONS(4068),
  },
  [1532] = {
    [anon_sym_BQUOTE] = ACTIONS(3831),
    [anon_sym_SLASH] = ACTIONS(3831),
    [sym_raw_string] = ACTIONS(3831),
    [anon_sym_COLON_QMARK] = ACTIONS(4070),
    [anon_sym_DOLLAR] = ACTIONS(4070),
    [anon_sym_RBRACE] = ACTIONS(3831),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3831),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3831),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [anon_sym_COLON] = ACTIONS(4070),
    [anon_sym_GT_LPAREN] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(3831),
    [sym_word] = ACTIONS(4070),
    [anon_sym_LT_LPAREN] = ACTIONS(3831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3831),
    [anon_sym_COLON_DASH] = ACTIONS(4070),
    [sym__special_character] = ACTIONS(4070),
  },
  [1533] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(515),
    [sym_function_definition] = STATE(515),
    [sym_negated_command] = STATE(515),
    [sym_test_command] = STATE(515),
    [sym_variable_assignment] = STATE(516),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1021),
    [sym_redirected_statement] = STATE(515),
    [sym_for_statement] = STATE(515),
    [sym_compound_statement] = STATE(515),
    [sym_subshell] = STATE(515),
    [sym_declaration_command] = STATE(515),
    [sym_unset_command] = STATE(515),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(515),
    [sym_while_statement] = STATE(515),
    [sym_case_statement] = STATE(515),
    [sym_pipeline] = STATE(515),
    [sym_list] = STATE(515),
    [sym_command] = STATE(515),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_fi] = ACTIONS(4072),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_else] = ACTIONS(4072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_elif] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1534] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4074),
    [anon_sym_BQUOTE] = ACTIONS(4074),
    [anon_sym_AMP_GT_GT] = ACTIONS(4074),
    [anon_sym_LF] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_LT_LT] = ACTIONS(4074),
    [sym_file_descriptor] = ACTIONS(4076),
    [anon_sym_GT] = ACTIONS(4074),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_AMP_GT] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4074),
    [ts_builtin_sym_end] = ACTIONS(4076),
    [anon_sym_LT_LT_LT] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4074),
    [anon_sym_GT_AMP] = ACTIONS(4074),
    [anon_sym_LT] = ACTIONS(4074),
    [anon_sym_LT_AMP] = ACTIONS(4074),
    [anon_sym_GT_GT] = ACTIONS(4074),
    [anon_sym_AMP] = ACTIONS(4074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(4074),
    [anon_sym_AMP_AMP] = ACTIONS(4074),
    [anon_sym_SEMI_SEMI] = ACTIONS(4074),
    [anon_sym_PIPE_AMP] = ACTIONS(4074),
  },
  [1535] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4078),
    [anon_sym_BQUOTE] = ACTIONS(4078),
    [anon_sym_AMP_GT_GT] = ACTIONS(4078),
    [anon_sym_LF] = ACTIONS(4080),
    [anon_sym_SEMI] = ACTIONS(4078),
    [anon_sym_LT_LT] = ACTIONS(4078),
    [sym_file_descriptor] = ACTIONS(4080),
    [anon_sym_GT] = ACTIONS(4078),
    [anon_sym_RPAREN] = ACTIONS(4078),
    [anon_sym_AMP_GT] = ACTIONS(4078),
    [anon_sym_PIPE_PIPE] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(4080),
    [anon_sym_LT_LT_LT] = ACTIONS(4078),
    [anon_sym_PIPE] = ACTIONS(4078),
    [anon_sym_GT_AMP] = ACTIONS(4078),
    [anon_sym_LT] = ACTIONS(4078),
    [anon_sym_LT_AMP] = ACTIONS(4078),
    [anon_sym_GT_GT] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(4078),
    [anon_sym_AMP_AMP] = ACTIONS(4078),
    [anon_sym_SEMI_SEMI] = ACTIONS(4078),
    [anon_sym_PIPE_AMP] = ACTIONS(4078),
  },
  [1536] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(4082),
  },
  [1537] = {
    [aux_sym_concatenation_repeat1] = STATE(1320),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4084),
    [sym__concat] = ACTIONS(691),
    [anon_sym_PIPE] = ACTIONS(4084),
  },
  [1538] = {
    [aux_sym__literal_repeat1] = STATE(1323),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_PIPE] = ACTIONS(4086),
    [sym__special_character] = ACTIONS(715),
  },
  [1539] = {
    [anon_sym_PIPE] = ACTIONS(4084),
    [anon_sym_RPAREN] = ACTIONS(4084),
    [sym_comment] = ACTIONS(51),
  },
  [1540] = {
    [sym_command_substitution] = STATE(1711),
    [aux_sym__literal_repeat1] = STATE(1718),
    [sym_string] = STATE(1711),
    [aux_sym_declaration_command_repeat1] = STATE(1719),
    [sym_process_substitution] = STATE(1711),
    [sym_simple_expansion] = STATE(1711),
    [sym_subscript] = STATE(1720),
    [sym_string_expansion] = STATE(1711),
    [sym_variable_assignment] = STATE(1719),
    [sym_concatenation] = STATE(1719),
    [sym_expansion] = STATE(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(91),
    [anon_sym_DOLLAR] = ACTIONS(4088),
    [anon_sym_LT_LT] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(4090),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4092),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4094),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(91),
    [sym_word] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_AMP] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_LT_AMP] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(91),
    [sym__special_character] = ACTIONS(4100),
    [anon_sym_LT_LT_DASH] = ACTIONS(91),
    [anon_sym_BQUOTE] = ACTIONS(4102),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(4098),
    [sym_variable_name] = ACTIONS(4104),
    [sym_file_descriptor] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(91),
    [anon_sym_AMP_GT] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(4106),
    [anon_sym_LT_LT_LT] = ACTIONS(91),
    [anon_sym_GT_AMP] = ACTIONS(91),
    [anon_sym_LT_LPAREN] = ACTIONS(4090),
    [anon_sym_esac] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(91),
    [anon_sym_SEMI_SEMI] = ACTIONS(91),
    [anon_sym_PIPE_AMP] = ACTIONS(91),
  },
  [1541] = {
    [sym_command_substitution] = STATE(1723),
    [aux_sym__literal_repeat1] = STATE(1729),
    [sym_string] = STATE(1723),
    [aux_sym_unset_command_repeat1] = STATE(1730),
    [sym_process_substitution] = STATE(1723),
    [sym_simple_expansion] = STATE(1723),
    [sym_string_expansion] = STATE(1723),
    [sym_concatenation] = STATE(1730),
    [sym_expansion] = STATE(1723),
    [anon_sym_AMP_GT_GT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_GT_LPAREN] = ACTIONS(4110),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4112),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4116),
    [anon_sym_PIPE_PIPE] = ACTIONS(115),
    [sym_word] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_LT_AMP] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym__special_character] = ACTIONS(4120),
    [anon_sym_LT_LT_DASH] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(4122),
    [anon_sym_LF] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(115),
    [sym_raw_string] = ACTIONS(4118),
    [sym_file_descriptor] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP_GT] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(4124),
    [anon_sym_LT_LT_LT] = ACTIONS(115),
    [anon_sym_GT_AMP] = ACTIONS(115),
    [anon_sym_LT_LPAREN] = ACTIONS(4110),
    [anon_sym_esac] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(115),
    [anon_sym_SEMI_SEMI] = ACTIONS(115),
    [anon_sym_PIPE_AMP] = ACTIONS(115),
  },
  [1542] = {
    [sym_string] = STATE(1732),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [sym_raw_string] = ACTIONS(4128),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_AT] = ACTIONS(4126),
    [anon_sym_DOLLAR] = ACTIONS(4130),
    [anon_sym_POUND] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_0] = ACTIONS(4132),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4132),
    [anon_sym__] = ACTIONS(4132),
  },
  [1543] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(1734),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1544] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(1735),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(1736),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1545] = {
    [sym_subscript] = STATE(1737),
    [anon_sym_STAR] = ACTIONS(4134),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4136),
    [anon_sym_AT] = ACTIONS(4134),
    [sym_variable_name] = ACTIONS(4138),
    [anon_sym_DOLLAR] = ACTIONS(4140),
    [anon_sym_DASH] = ACTIONS(4140),
    [anon_sym_0] = ACTIONS(4142),
    [anon_sym_POUND] = ACTIONS(4136),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4142),
    [anon_sym__] = ACTIONS(4142),
    [sym_comment] = ACTIONS(3),
  },
  [1546] = {
    [aux_sym_concatenation_repeat1] = STATE(1742),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(4144),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_esac] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [1547] = {
    [aux_sym_concatenation_repeat1] = STATE(1742),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(4144),
    [anon_sym_EQ_TILDE] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [anon_sym_esac] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [1548] = {
    [aux_sym_concatenation_repeat1] = STATE(1742),
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym__concat] = ACTIONS(4144),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_esac] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [1549] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(1743),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1550] = {
    [aux_sym__literal_repeat1] = STATE(1554),
    [sym_string] = STATE(1548),
    [sym_process_substitution] = STATE(1548),
    [sym_test_command] = STATE(150),
    [aux_sym_command_repeat1] = STATE(1560),
    [sym_subscript] = STATE(151),
    [sym_variable_assignment] = STATE(1560),
    [sym_concatenation] = STATE(1558),
    [sym_expansion] = STATE(1548),
    [sym_command_substitution] = STATE(1548),
    [sym_command] = STATE(150),
    [sym_command_name] = STATE(1562),
    [sym_simple_expansion] = STATE(1548),
    [sym_string_expansion] = STATE(1548),
    [sym_subshell] = STATE(150),
    [sym_file_redirect] = STATE(1560),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3676),
    [sym_variable_name] = ACTIONS(237),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [sym_word] = ACTIONS(3676),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(3674),
  },
  [1551] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_EQ] = ACTIONS(4146),
  },
  [1552] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(1747),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(4148),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(4150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [1553] = {
    [anon_sym_BQUOTE] = ACTIONS(4152),
    [anon_sym_DQUOTE] = ACTIONS(4152),
    [sym_word] = ACTIONS(4154),
    [sym_raw_string] = ACTIONS(4152),
    [anon_sym_LT_LPAREN] = ACTIONS(4152),
    [anon_sym_esac] = ACTIONS(4156),
    [anon_sym_DOLLAR] = ACTIONS(4154),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4152),
    [sym__special_character] = ACTIONS(4152),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4152),
  },
  [1554] = {
    [aux_sym__literal_repeat1] = STATE(1749),
    [anon_sym_AMP_GT_GT] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(297),
    [anon_sym_LT_LT] = ACTIONS(297),
    [anon_sym_GT_LPAREN] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_PIPE_PIPE] = ACTIONS(297),
    [sym_word] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(297),
    [anon_sym_AMP] = ACTIONS(297),
    [anon_sym_LT] = ACTIONS(297),
    [anon_sym_LT_AMP] = ACTIONS(297),
    [anon_sym_GT_GT] = ACTIONS(297),
    [anon_sym_EQ_TILDE] = ACTIONS(297),
    [sym__special_character] = ACTIONS(4158),
    [anon_sym_LT_LT_DASH] = ACTIONS(297),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [anon_sym_LF] = ACTIONS(301),
    [anon_sym_SEMI] = ACTIONS(297),
    [sym_raw_string] = ACTIONS(297),
    [sym_file_descriptor] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(297),
    [anon_sym_AMP_GT] = ACTIONS(297),
    [anon_sym_EQ_EQ] = ACTIONS(297),
    [anon_sym_DQUOTE] = ACTIONS(297),
    [anon_sym_LT_LT_LT] = ACTIONS(297),
    [anon_sym_GT_AMP] = ACTIONS(297),
    [anon_sym_LT_LPAREN] = ACTIONS(297),
    [anon_sym_esac] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(297),
    [anon_sym_SEMI_SEMI] = ACTIONS(297),
    [anon_sym_PIPE_AMP] = ACTIONS(297),
  },
  [1555] = {
    [sym_heredoc_redirect] = STATE(1757),
    [aux_sym_redirected_statement_repeat1] = STATE(1757),
    [sym_herestring_redirect] = STATE(1757),
    [sym_file_redirect] = STATE(1757),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_AMP_GT_GT] = ACTIONS(4160),
    [anon_sym_LF] = ACTIONS(4162),
    [anon_sym_SEMI] = ACTIONS(4164),
    [sym_file_descriptor] = ACTIONS(4166),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_AMP_GT] = ACTIONS(4160),
    [anon_sym_PIPE_PIPE] = ACTIONS(4168),
    [anon_sym_LT_LT_LT] = ACTIONS(4170),
    [anon_sym_GT_AMP] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_esac] = ACTIONS(367),
    [anon_sym_LT_AMP] = ACTIONS(4160),
    [anon_sym_GT_GT] = ACTIONS(4160),
    [anon_sym_PIPE] = ACTIONS(4172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(4172),
  },
  [1556] = {
    [sym_heredoc_redirect] = STATE(1757),
    [aux_sym_redirected_statement_repeat1] = STATE(1757),
    [sym_herestring_redirect] = STATE(1757),
    [sym_file_redirect] = STATE(1757),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(4168),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(4162),
    [anon_sym_SEMI] = ACTIONS(4164),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(4170),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [anon_sym_esac] = ACTIONS(367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(4172),
  },
  [1557] = {
    [anon_sym_EQ] = ACTIONS(4146),
    [anon_sym_PLUS_EQ] = ACTIONS(4146),
    [sym_comment] = ACTIONS(51),
  },
  [1558] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_LT_LT] = ACTIONS(165),
    [anon_sym_GT_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(165),
    [anon_sym_PIPE_PIPE] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_LT_AMP] = ACTIONS(165),
    [anon_sym_GT_GT] = ACTIONS(165),
    [anon_sym_EQ_TILDE] = ACTIONS(165),
    [sym__special_character] = ACTIONS(165),
    [anon_sym_LT_LT_DASH] = ACTIONS(165),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(165),
    [sym_raw_string] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP_GT] = ACTIONS(165),
    [anon_sym_EQ_EQ] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(165),
    [anon_sym_GT_AMP] = ACTIONS(165),
    [anon_sym_LT_LPAREN] = ACTIONS(165),
    [anon_sym_esac] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(165),
    [anon_sym_SEMI_SEMI] = ACTIONS(165),
    [anon_sym_PIPE_AMP] = ACTIONS(165),
  },
  [1559] = {
    [aux_sym__literal_repeat1] = STATE(1554),
    [sym_if_statement] = STATE(1758),
    [sym_function_definition] = STATE(1758),
    [sym_negated_command] = STATE(1758),
    [sym_test_command] = STATE(1758),
    [sym_variable_assignment] = STATE(1759),
    [sym_subscript] = STATE(1557),
    [sym_concatenation] = STATE(1558),
    [sym_expansion] = STATE(1548),
    [sym_command_substitution] = STATE(1548),
    [aux_sym__statements_repeat1] = STATE(195),
    [sym_redirected_statement] = STATE(1758),
    [sym_for_statement] = STATE(1758),
    [sym_compound_statement] = STATE(1758),
    [sym_subshell] = STATE(1758),
    [sym_declaration_command] = STATE(1758),
    [sym_unset_command] = STATE(1758),
    [sym_file_redirect] = STATE(1560),
    [sym_string] = STATE(1548),
    [sym_process_substitution] = STATE(1548),
    [aux_sym_command_repeat1] = STATE(1560),
    [sym_c_style_for_statement] = STATE(1758),
    [sym_while_statement] = STATE(1758),
    [sym_case_statement] = STATE(1758),
    [sym_pipeline] = STATE(1758),
    [sym_list] = STATE(1758),
    [sym_command] = STATE(1758),
    [sym_command_name] = STATE(1562),
    [sym_simple_expansion] = STATE(1548),
    [sym_string_expansion] = STATE(1548),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(3660),
    [anon_sym_typeset] = ACTIONS(3660),
    [anon_sym_unsetenv] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(3660),
    [sym__special_character] = ACTIONS(3674),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3676),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3680),
    [anon_sym_declare] = ACTIONS(3660),
    [sym_variable_name] = ACTIONS(3682),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(3660),
    [anon_sym_unset] = ACTIONS(3662),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1560] = {
    [sym_command_substitution] = STATE(1548),
    [aux_sym__literal_repeat1] = STATE(1554),
    [sym_expansion] = STATE(1548),
    [sym_string] = STATE(1548),
    [sym_command_name] = STATE(1760),
    [sym_process_substitution] = STATE(1548),
    [sym_simple_expansion] = STATE(1548),
    [sym_string_expansion] = STATE(1548),
    [sym_subscript] = STATE(151),
    [sym_variable_assignment] = STATE(197),
    [aux_sym_command_repeat1] = STATE(197),
    [sym_concatenation] = STATE(1558),
    [sym_file_redirect] = STATE(197),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(3676),
    [sym_variable_name] = ACTIONS(237),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [sym_word] = ACTIONS(3676),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(4174),
  },
  [1561] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(4176),
    [anon_sym_esac] = ACTIONS(4178),
  },
  [1562] = {
    [sym_command_substitution] = STATE(1762),
    [aux_sym__literal_repeat1] = STATE(1764),
    [sym_string] = STATE(1762),
    [sym_process_substitution] = STATE(1762),
    [sym_simple_expansion] = STATE(1762),
    [sym_string_expansion] = STATE(1762),
    [aux_sym_command_repeat2] = STATE(1765),
    [sym_concatenation] = STATE(1765),
    [sym_expansion] = STATE(1762),
    [anon_sym_AMP_GT_GT] = ACTIONS(331),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_LT_LT] = ACTIONS(331),
    [anon_sym_GT_LPAREN] = ACTIONS(4180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4184),
    [anon_sym_PIPE_PIPE] = ACTIONS(331),
    [sym_word] = ACTIONS(4186),
    [anon_sym_PIPE] = ACTIONS(331),
    [anon_sym_AMP] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(331),
    [anon_sym_LT_AMP] = ACTIONS(331),
    [anon_sym_GT_GT] = ACTIONS(331),
    [anon_sym_EQ_TILDE] = ACTIONS(4188),
    [sym__special_character] = ACTIONS(3674),
    [anon_sym_LT_LT_DASH] = ACTIONS(331),
    [anon_sym_BQUOTE] = ACTIONS(4190),
    [anon_sym_LF] = ACTIONS(345),
    [anon_sym_SEMI] = ACTIONS(331),
    [sym_raw_string] = ACTIONS(4186),
    [sym_file_descriptor] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(331),
    [anon_sym_AMP_GT] = ACTIONS(331),
    [anon_sym_EQ_EQ] = ACTIONS(4188),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_LT_LT_LT] = ACTIONS(331),
    [anon_sym_GT_AMP] = ACTIONS(331),
    [anon_sym_LT_LPAREN] = ACTIONS(4180),
    [anon_sym_esac] = ACTIONS(331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(331),
    [anon_sym_SEMI_SEMI] = ACTIONS(331),
    [anon_sym_PIPE_AMP] = ACTIONS(331),
  },
  [1563] = {
    [aux_sym_concatenation_repeat1] = STATE(1563),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1392),
    [sym__concat] = ACTIONS(2395),
    [anon_sym_PIPE] = ACTIONS(1392),
  },
  [1564] = {
    [aux_sym__literal_repeat1] = STATE(1554),
    [sym_if_statement] = STATE(1555),
    [sym_function_definition] = STATE(1555),
    [sym_negated_command] = STATE(1555),
    [sym_test_command] = STATE(1555),
    [sym_variable_assignment] = STATE(1556),
    [sym_subscript] = STATE(1557),
    [sym_concatenation] = STATE(1558),
    [sym_expansion] = STATE(1548),
    [sym_command_substitution] = STATE(1548),
    [aux_sym__statements_repeat1] = STATE(1559),
    [sym_redirected_statement] = STATE(1555),
    [sym_for_statement] = STATE(1555),
    [sym_compound_statement] = STATE(1555),
    [sym_subshell] = STATE(1555),
    [sym_declaration_command] = STATE(1555),
    [sym_unset_command] = STATE(1555),
    [sym_file_redirect] = STATE(1560),
    [sym_string] = STATE(1548),
    [sym_process_substitution] = STATE(1548),
    [aux_sym_command_repeat1] = STATE(1560),
    [sym__statements] = STATE(1766),
    [sym_c_style_for_statement] = STATE(1555),
    [sym_while_statement] = STATE(1555),
    [sym_case_statement] = STATE(1555),
    [sym_pipeline] = STATE(1555),
    [sym_list] = STATE(1555),
    [sym_command] = STATE(1555),
    [sym_command_name] = STATE(1562),
    [sym_simple_expansion] = STATE(1548),
    [sym_string_expansion] = STATE(1548),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(3660),
    [anon_sym_typeset] = ACTIONS(3660),
    [anon_sym_unsetenv] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(3660),
    [sym__special_character] = ACTIONS(3674),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3676),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3680),
    [anon_sym_declare] = ACTIONS(3660),
    [sym_variable_name] = ACTIONS(3682),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(3660),
    [anon_sym_unset] = ACTIONS(3662),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [anon_sym_esac] = ACTIONS(4156),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(4176),
  },
  [1565] = {
    [aux_sym_case_item_repeat1] = STATE(1565),
    [anon_sym_PIPE] = ACTIONS(4194),
    [anon_sym_RPAREN] = ACTIONS(4084),
    [sym_comment] = ACTIONS(51),
  },
  [1566] = {
    [anon_sym_BQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [sym_word] = ACTIONS(4199),
    [sym_raw_string] = ACTIONS(4197),
    [anon_sym_LT_LPAREN] = ACTIONS(4197),
    [anon_sym_esac] = ACTIONS(4201),
    [anon_sym_DOLLAR] = ACTIONS(4199),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4197),
    [sym__special_character] = ACTIONS(4197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4197),
  },
  [1567] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(4203),
    [anon_sym_esac] = ACTIONS(4205),
  },
  [1568] = {
    [aux_sym__literal_repeat1] = STATE(1554),
    [sym_if_statement] = STATE(1555),
    [sym_function_definition] = STATE(1555),
    [sym_negated_command] = STATE(1555),
    [sym_test_command] = STATE(1555),
    [sym_variable_assignment] = STATE(1556),
    [sym_subscript] = STATE(1557),
    [sym_concatenation] = STATE(1558),
    [sym_expansion] = STATE(1548),
    [sym_command_substitution] = STATE(1548),
    [aux_sym__statements_repeat1] = STATE(1559),
    [sym_redirected_statement] = STATE(1555),
    [sym_for_statement] = STATE(1555),
    [sym_compound_statement] = STATE(1555),
    [sym_subshell] = STATE(1555),
    [sym_declaration_command] = STATE(1555),
    [sym_unset_command] = STATE(1555),
    [sym_file_redirect] = STATE(1560),
    [sym_string] = STATE(1548),
    [sym_process_substitution] = STATE(1548),
    [aux_sym_command_repeat1] = STATE(1560),
    [sym__statements] = STATE(1768),
    [sym_c_style_for_statement] = STATE(1555),
    [sym_while_statement] = STATE(1555),
    [sym_case_statement] = STATE(1555),
    [sym_pipeline] = STATE(1555),
    [sym_list] = STATE(1555),
    [sym_command] = STATE(1555),
    [sym_command_name] = STATE(1562),
    [sym_simple_expansion] = STATE(1548),
    [sym_string_expansion] = STATE(1548),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(3660),
    [anon_sym_typeset] = ACTIONS(3660),
    [anon_sym_unsetenv] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(3660),
    [sym__special_character] = ACTIONS(3674),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3676),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3680),
    [anon_sym_declare] = ACTIONS(3660),
    [sym_variable_name] = ACTIONS(3682),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(3660),
    [anon_sym_unset] = ACTIONS(3662),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [anon_sym_esac] = ACTIONS(4201),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(4203),
  },
  [1569] = {
    [aux_sym_concatenation_repeat1] = STATE(1320),
    [aux_sym_case_item_repeat1] = STATE(1770),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4207),
    [sym__concat] = ACTIONS(691),
    [anon_sym_PIPE] = ACTIONS(3041),
  },
  [1570] = {
    [aux_sym__literal_repeat1] = STATE(1323),
    [aux_sym_case_item_repeat1] = STATE(1772),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4209),
    [anon_sym_PIPE] = ACTIONS(3041),
    [sym__special_character] = ACTIONS(715),
  },
  [1571] = {
    [aux_sym_case_item_repeat1] = STATE(1770),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_RPAREN] = ACTIONS(4207),
    [sym_comment] = ACTIONS(51),
  },
  [1572] = {
    [anon_sym_AMP] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(3553),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3551),
    [anon_sym_in] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
  },
  [1573] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1574] = {
    [anon_sym_AMP] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(3587),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_in] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
  },
  [1575] = {
    [anon_sym_AMP] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(3591),
    [anon_sym_LF] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_in] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
  },
  [1576] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1577] = {
    [anon_sym_AMP] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(3642),
    [anon_sym_LF] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3640),
    [anon_sym_in] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
  },
  [1578] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4215),
    [anon_sym_BQUOTE] = ACTIONS(4215),
    [anon_sym_AMP_GT_GT] = ACTIONS(4215),
    [anon_sym_LF] = ACTIONS(4217),
    [anon_sym_SEMI] = ACTIONS(4215),
    [anon_sym_LT_LT] = ACTIONS(4215),
    [sym_file_descriptor] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4215),
    [anon_sym_RPAREN] = ACTIONS(4215),
    [anon_sym_AMP_GT] = ACTIONS(4215),
    [anon_sym_PIPE_PIPE] = ACTIONS(4215),
    [ts_builtin_sym_end] = ACTIONS(4217),
    [anon_sym_LT_LT_LT] = ACTIONS(4215),
    [anon_sym_PIPE] = ACTIONS(4215),
    [anon_sym_GT_AMP] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(4215),
    [anon_sym_LT_AMP] = ACTIONS(4215),
    [anon_sym_GT_GT] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(4215),
    [anon_sym_AMP_AMP] = ACTIONS(4215),
    [anon_sym_SEMI_SEMI] = ACTIONS(4215),
    [anon_sym_PIPE_AMP] = ACTIONS(4215),
  },
  [1579] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(4219),
  },
  [1580] = {
    [anon_sym_BANG_EQ] = ACTIONS(3553),
    [anon_sym_PLUS_EQ] = ACTIONS(3553),
    [sym_test_operator] = ACTIONS(3553),
    [anon_sym_PLUS_PLUS] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3551),
    [anon_sym_EQ_EQ] = ACTIONS(3553),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3553),
    [anon_sym_PIPE_PIPE] = ACTIONS(3553),
    [anon_sym_GT_EQ] = ACTIONS(3553),
    [sym__concat] = ACTIONS(3553),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3553),
    [anon_sym_DASH_DASH] = ACTIONS(3553),
    [anon_sym_LT_EQ] = ACTIONS(3553),
    [anon_sym_AMP_AMP] = ACTIONS(3553),
    [anon_sym_DASH_EQ] = ACTIONS(3553),
  },
  [1581] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4221),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1582] = {
    [anon_sym_BANG_EQ] = ACTIONS(3587),
    [anon_sym_PLUS_EQ] = ACTIONS(3587),
    [sym_test_operator] = ACTIONS(3587),
    [anon_sym_PLUS_PLUS] = ACTIONS(3587),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3585),
    [anon_sym_EQ_EQ] = ACTIONS(3587),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3587),
    [anon_sym_GT_EQ] = ACTIONS(3587),
    [sym__concat] = ACTIONS(3587),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3585),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3587),
    [anon_sym_DASH_DASH] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3587),
    [anon_sym_AMP_AMP] = ACTIONS(3587),
    [anon_sym_DASH_EQ] = ACTIONS(3587),
  },
  [1583] = {
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_PLUS_EQ] = ACTIONS(3591),
    [sym_test_operator] = ACTIONS(3591),
    [anon_sym_PLUS_PLUS] = ACTIONS(3591),
    [anon_sym_RPAREN] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3589),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3591),
    [anon_sym_PIPE_PIPE] = ACTIONS(3591),
    [anon_sym_GT_EQ] = ACTIONS(3591),
    [sym__concat] = ACTIONS(3591),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3591),
    [anon_sym_LT_EQ] = ACTIONS(3591),
    [anon_sym_AMP_AMP] = ACTIONS(3591),
    [anon_sym_DASH_EQ] = ACTIONS(3591),
  },
  [1584] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1585] = {
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_PLUS_EQ] = ACTIONS(3642),
    [sym_test_operator] = ACTIONS(3642),
    [anon_sym_PLUS_PLUS] = ACTIONS(3642),
    [anon_sym_RPAREN] = ACTIONS(3640),
    [anon_sym_DASH] = ACTIONS(3640),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_EQ_EQ] = ACTIONS(3642),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_GT_EQ] = ACTIONS(3642),
    [sym__concat] = ACTIONS(3642),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_PIPE] = ACTIONS(3640),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_DASH_DASH] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_DASH_EQ] = ACTIONS(3642),
  },
  [1586] = {
    [anon_sym_BQUOTE] = ACTIONS(2585),
    [anon_sym_DQUOTE] = ACTIONS(2585),
    [sym_word] = ACTIONS(2585),
    [sym_raw_string] = ACTIONS(2585),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_LT_LPAREN] = ACTIONS(2585),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_RPAREN] = ACTIONS(2585),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2585),
    [sym__special_character] = ACTIONS(2585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2585),
  },
  [1587] = {
    [sym_string] = STATE(1086),
    [anon_sym_BQUOTE] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(2465),
    [sym_raw_string] = ACTIONS(2461),
    [anon_sym_BANG] = ACTIONS(4225),
    [anon_sym_DOLLAR] = ACTIONS(4225),
    [anon_sym_RPAREN] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_GT_LPAREN] = ACTIONS(2265),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(2465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2265),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2465),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(2465),
    [anon_sym_LT_LPAREN] = ACTIONS(2265),
    [anon_sym_AT] = ACTIONS(2465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2463),
    [sym__special_character] = ACTIONS(2265),
    [anon_sym__] = ACTIONS(2465),
  },
  [1588] = {
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [sym_word] = ACTIONS(2111),
    [sym_raw_string] = ACTIONS(2111),
    [sym__concat] = ACTIONS(2111),
    [anon_sym_LT_LPAREN] = ACTIONS(2111),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_RPAREN] = ACTIONS(2111),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2111),
    [sym__special_character] = ACTIONS(2111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2111),
  },
  [1589] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1779),
    [sym_concatenation] = STATE(1779),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4227),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4229),
    [anon_sym_DASH] = ACTIONS(4227),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4227),
    [anon_sym_PERCENT] = ACTIONS(4227),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4231),
    [anon_sym_COLON_DASH] = ACTIONS(4227),
    [sym__special_character] = ACTIONS(553),
  },
  [1590] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4229),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1591] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1779),
    [sym_concatenation] = STATE(1779),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4227),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4229),
    [anon_sym_DASH] = ACTIONS(4227),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4227),
    [anon_sym_PERCENT] = ACTIONS(4227),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4231),
    [anon_sym_COLON_DASH] = ACTIONS(4227),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4233),
  },
  [1592] = {
    [sym_command_substitution] = STATE(1781),
    [aux_sym__literal_repeat1] = STATE(1782),
    [sym_string] = STATE(1781),
    [sym_process_substitution] = STATE(1781),
    [sym_simple_expansion] = STATE(1781),
    [sym_string_expansion] = STATE(1781),
    [sym_concatenation] = STATE(1783),
    [sym_expansion] = STATE(1781),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(4235),
    [sym_raw_string] = ACTIONS(4235),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4229),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1593] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1786),
    [sym_concatenation] = STATE(1786),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4237),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_DASH] = ACTIONS(4237),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4237),
    [anon_sym_PERCENT] = ACTIONS(4237),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4241),
    [anon_sym_COLON_DASH] = ACTIONS(4237),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4243),
  },
  [1594] = {
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [anon_sym_DQUOTE] = ACTIONS(2207),
    [sym_word] = ACTIONS(2207),
    [sym_raw_string] = ACTIONS(2207),
    [sym__concat] = ACTIONS(2207),
    [anon_sym_LT_LPAREN] = ACTIONS(2207),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_RPAREN] = ACTIONS(2207),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2207),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2207),
    [sym__special_character] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2207),
  },
  [1595] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1596] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4229),
    [sym__concat] = ACTIONS(2213),
  },
  [1597] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4245),
  },
  [1598] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4229),
  },
  [1599] = {
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_word] = ACTIONS(2249),
    [sym_raw_string] = ACTIONS(2249),
    [sym__concat] = ACTIONS(2249),
    [anon_sym_LT_LPAREN] = ACTIONS(2249),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_RPAREN] = ACTIONS(2249),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2249),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2249),
    [sym__special_character] = ACTIONS(2249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2249),
  },
  [1600] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1789),
    [sym_concatenation] = STATE(1789),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4247),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(4247),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4247),
    [anon_sym_PERCENT] = ACTIONS(4247),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4251),
    [anon_sym_COLON_DASH] = ACTIONS(4247),
    [sym__special_character] = ACTIONS(553),
  },
  [1601] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1602] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [sym_word] = ACTIONS(2896),
    [anon_sym_PIPE] = ACTIONS(2896),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_LT_AMP] = ACTIONS(2896),
    [anon_sym_GT_GT] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [sym__special_character] = ACTIONS(2896),
    [anon_sym_LT_LT_DASH] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [sym_raw_string] = ACTIONS(2896),
    [sym_variable_name] = ACTIONS(2898),
    [sym_file_descriptor] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2896),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_AMP_GT] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [anon_sym_LT_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_AMP] = ACTIONS(2896),
    [ts_builtin_sym_end] = ACTIONS(2898),
    [anon_sym_LT_LPAREN] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
    [anon_sym_PIPE_AMP] = ACTIONS(2896),
  },
  [1603] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4253),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1604] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1791),
    [sym_concatenation] = STATE(1791),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4255),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4253),
    [anon_sym_DASH] = ACTIONS(4255),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4255),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4255),
    [anon_sym_PERCENT] = ACTIONS(4255),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4257),
    [anon_sym_COLON_DASH] = ACTIONS(4255),
    [sym__special_character] = ACTIONS(553),
  },
  [1605] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4253),
    [sym__concat] = ACTIONS(2213),
  },
  [1606] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4259),
  },
  [1607] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4253),
  },
  [1608] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [sym_word] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [sym__special_character] = ACTIONS(2945),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [sym_variable_name] = ACTIONS(2947),
    [sym_file_descriptor] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [ts_builtin_sym_end] = ACTIONS(2947),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
  },
  [1609] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1794),
    [sym_concatenation] = STATE(1794),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4261),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4263),
    [anon_sym_DASH] = ACTIONS(4261),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4261),
    [anon_sym_PERCENT] = ACTIONS(4261),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4265),
    [anon_sym_COLON_DASH] = ACTIONS(4261),
    [sym__special_character] = ACTIONS(553),
  },
  [1610] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4263),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1611] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [sym_word] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_LT_AMP] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [sym__special_character] = ACTIONS(2993),
    [anon_sym_LT_LT_DASH] = ACTIONS(2993),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [sym_raw_string] = ACTIONS(2993),
    [sym_variable_name] = ACTIONS(2995),
    [sym_file_descriptor] = ACTIONS(2995),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_AMP_GT] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_LT_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_AMP] = ACTIONS(2993),
    [ts_builtin_sym_end] = ACTIONS(2995),
    [anon_sym_LT_LPAREN] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
    [anon_sym_PIPE_AMP] = ACTIONS(2993),
  },
  [1612] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3012),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [sym_word] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_LT_AMP] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [sym__special_character] = ACTIONS(3012),
    [anon_sym_LT_LT_DASH] = ACTIONS(3012),
    [anon_sym_BQUOTE] = ACTIONS(3012),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [sym_raw_string] = ACTIONS(3012),
    [sym_variable_name] = ACTIONS(3014),
    [sym_file_descriptor] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_AMP_GT] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_LT_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_AMP] = ACTIONS(3012),
    [ts_builtin_sym_end] = ACTIONS(3014),
    [anon_sym_LT_LPAREN] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
    [anon_sym_PIPE_AMP] = ACTIONS(3012),
  },
  [1613] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4267),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1614] = {
    [anon_sym_BQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [sym__concat] = ACTIONS(3553),
    [sym__string_content] = ACTIONS(3551),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3553),
  },
  [1615] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4269),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1616] = {
    [anon_sym_BQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3587),
    [sym__concat] = ACTIONS(3587),
    [sym__string_content] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3587),
  },
  [1617] = {
    [anon_sym_BQUOTE] = ACTIONS(3591),
    [anon_sym_DQUOTE] = ACTIONS(3591),
    [sym__concat] = ACTIONS(3591),
    [sym__string_content] = ACTIONS(3589),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3591),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3591),
  },
  [1618] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4271),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1619] = {
    [anon_sym_BQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [sym__concat] = ACTIONS(3642),
    [sym__string_content] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3642),
  },
  [1620] = {
    [anon_sym_BQUOTE] = ACTIONS(2583),
    [sym_raw_string] = ACTIONS(2583),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_GT_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2583),
    [sym_word] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_LT_LPAREN] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
  },
  [1621] = {
    [sym_string] = STATE(1143),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(2599),
    [sym_raw_string] = ACTIONS(4273),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym_BANG] = ACTIONS(4275),
    [anon_sym_DOLLAR] = ACTIONS(4275),
    [anon_sym_0] = ACTIONS(2599),
    [anon_sym_DASH] = ACTIONS(4275),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [sym_word] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(2599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4275),
    [sym__special_character] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym__] = ACTIONS(2599),
  },
  [1622] = {
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [sym_raw_string] = ACTIONS(2109),
    [anon_sym_LF] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_GT_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [sym_word] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [anon_sym_AMP] = ACTIONS(2109),
    [anon_sym_LT_LPAREN] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
  },
  [1623] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1799),
    [sym_concatenation] = STATE(1799),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4277),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4277),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4277),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4277),
    [anon_sym_PERCENT] = ACTIONS(4277),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4281),
    [anon_sym_COLON_DASH] = ACTIONS(4277),
    [sym__special_character] = ACTIONS(553),
  },
  [1624] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1625] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1799),
    [sym_concatenation] = STATE(1799),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4277),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4279),
    [anon_sym_DASH] = ACTIONS(4277),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4277),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4277),
    [anon_sym_PERCENT] = ACTIONS(4277),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4281),
    [anon_sym_COLON_DASH] = ACTIONS(4277),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4283),
  },
  [1626] = {
    [sym_command_substitution] = STATE(1801),
    [aux_sym__literal_repeat1] = STATE(1802),
    [sym_string] = STATE(1801),
    [sym_process_substitution] = STATE(1801),
    [sym_simple_expansion] = STATE(1801),
    [sym_string_expansion] = STATE(1801),
    [sym_concatenation] = STATE(1803),
    [sym_expansion] = STATE(1801),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(4285),
    [sym_raw_string] = ACTIONS(4285),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1627] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1806),
    [sym_concatenation] = STATE(1806),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4287),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4289),
    [anon_sym_DASH] = ACTIONS(4287),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4287),
    [anon_sym_PERCENT] = ACTIONS(4287),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4291),
    [anon_sym_COLON_DASH] = ACTIONS(4287),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4293),
  },
  [1628] = {
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2205),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
  },
  [1629] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4289),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1630] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4279),
    [sym__concat] = ACTIONS(2213),
  },
  [1631] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4295),
  },
  [1632] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4279),
  },
  [1633] = {
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [sym_raw_string] = ACTIONS(2247),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_GT_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [sym_word] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_LT_LPAREN] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
  },
  [1634] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1809),
    [sym_concatenation] = STATE(1809),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4297),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4299),
    [anon_sym_DASH] = ACTIONS(4297),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4297),
    [anon_sym_PERCENT] = ACTIONS(4297),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4301),
    [anon_sym_COLON_DASH] = ACTIONS(4297),
    [sym__special_character] = ACTIONS(553),
  },
  [1635] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4299),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1636] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4303),
    [anon_sym_BQUOTE] = ACTIONS(4303),
    [anon_sym_AMP_GT_GT] = ACTIONS(4303),
    [anon_sym_LF] = ACTIONS(4305),
    [anon_sym_SEMI] = ACTIONS(4303),
    [anon_sym_LT_LT] = ACTIONS(4303),
    [sym_file_descriptor] = ACTIONS(4305),
    [anon_sym_GT] = ACTIONS(4303),
    [anon_sym_RPAREN] = ACTIONS(4303),
    [anon_sym_AMP_GT] = ACTIONS(4303),
    [anon_sym_PIPE_PIPE] = ACTIONS(4303),
    [ts_builtin_sym_end] = ACTIONS(4305),
    [anon_sym_LT_LT_LT] = ACTIONS(4303),
    [anon_sym_PIPE] = ACTIONS(4303),
    [anon_sym_GT_AMP] = ACTIONS(4303),
    [anon_sym_LT] = ACTIONS(4303),
    [anon_sym_LT_AMP] = ACTIONS(4303),
    [anon_sym_GT_GT] = ACTIONS(4303),
    [anon_sym_AMP] = ACTIONS(4303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(4303),
    [anon_sym_AMP_AMP] = ACTIONS(4303),
    [anon_sym_SEMI_SEMI] = ACTIONS(4303),
    [anon_sym_PIPE_AMP] = ACTIONS(4303),
  },
  [1637] = {
    [sym_do_group] = STATE(1810),
    [sym_compound_statement] = STATE(1810),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(839),
  },
  [1638] = {
    [sym_do_group] = STATE(1810),
    [sym_compound_statement] = STATE(1810),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(4307),
    [anon_sym_do] = ACTIONS(839),
  },
  [1639] = {
    [anon_sym_BANG_EQ] = ACTIONS(2896),
    [anon_sym_PLUS_EQ] = ACTIONS(2896),
    [sym_test_operator] = ACTIONS(2898),
    [anon_sym_LF] = ACTIONS(2896),
    [anon_sym_SEMI] = ACTIONS(2896),
    [anon_sym_PLUS_PLUS] = ACTIONS(2896),
    [anon_sym_DASH] = ACTIONS(2896),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_EQ_EQ] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [anon_sym_GT_EQ] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_AMP] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2896),
    [anon_sym_DASH_DASH] = ACTIONS(2896),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_LT_EQ] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
    [anon_sym_DASH_EQ] = ACTIONS(2896),
  },
  [1640] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4309),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1641] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1813),
    [sym_concatenation] = STATE(1813),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4311),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4309),
    [anon_sym_DASH] = ACTIONS(4311),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4311),
    [anon_sym_PERCENT] = ACTIONS(4311),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4313),
    [anon_sym_COLON_DASH] = ACTIONS(4311),
    [sym__special_character] = ACTIONS(553),
  },
  [1642] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4309),
    [sym__concat] = ACTIONS(2213),
  },
  [1643] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4315),
  },
  [1644] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4309),
  },
  [1645] = {
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_PLUS_EQ] = ACTIONS(2945),
    [sym_test_operator] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_DASH_EQ] = ACTIONS(2945),
  },
  [1646] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1816),
    [sym_concatenation] = STATE(1816),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4317),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4319),
    [anon_sym_DASH] = ACTIONS(4317),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4317),
    [anon_sym_PERCENT] = ACTIONS(4317),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4321),
    [anon_sym_COLON_DASH] = ACTIONS(4317),
    [sym__special_character] = ACTIONS(553),
  },
  [1647] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4319),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1648] = {
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [sym_test_operator] = ACTIONS(2995),
    [anon_sym_LF] = ACTIONS(2993),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_EQ] = ACTIONS(2993),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
  },
  [1649] = {
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_PLUS_EQ] = ACTIONS(3012),
    [sym_test_operator] = ACTIONS(3014),
    [anon_sym_LF] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_PLUS_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3012),
    [anon_sym_DASH_DASH] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
    [anon_sym_DASH_EQ] = ACTIONS(3012),
  },
  [1650] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4323),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1651] = {
    [anon_sym_BANG_EQ] = ACTIONS(717),
    [anon_sym_PLUS_EQ] = ACTIONS(717),
    [sym_test_operator] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(721),
    [anon_sym_GT] = ACTIONS(721),
    [anon_sym_EQ] = ACTIONS(721),
    [anon_sym_EQ_EQ] = ACTIONS(723),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4325),
    [anon_sym_PIPE_PIPE] = ACTIONS(717),
    [anon_sym_GT_EQ] = ACTIONS(717),
    [anon_sym_PLUS] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(721),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_LT_EQ] = ACTIONS(717),
    [anon_sym_AMP_AMP] = ACTIONS(717),
    [anon_sym_DASH_EQ] = ACTIONS(717),
  },
  [1652] = {
    [anon_sym_BANG_EQ] = ACTIONS(3553),
    [anon_sym_PLUS_EQ] = ACTIONS(3553),
    [sym_test_operator] = ACTIONS(3553),
    [anon_sym_PLUS_PLUS] = ACTIONS(3553),
    [anon_sym_RBRACK] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3551),
    [anon_sym_EQ_EQ] = ACTIONS(3553),
    [anon_sym_PIPE_PIPE] = ACTIONS(3553),
    [anon_sym_GT_EQ] = ACTIONS(3553),
    [sym__concat] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3553),
    [anon_sym_DASH_DASH] = ACTIONS(3553),
    [anon_sym_LT_EQ] = ACTIONS(3553),
    [anon_sym_AMP_AMP] = ACTIONS(3553),
    [anon_sym_DASH_EQ] = ACTIONS(3553),
  },
  [1653] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4327),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1654] = {
    [anon_sym_BANG_EQ] = ACTIONS(3587),
    [anon_sym_PLUS_EQ] = ACTIONS(3587),
    [sym_test_operator] = ACTIONS(3587),
    [anon_sym_PLUS_PLUS] = ACTIONS(3587),
    [anon_sym_RBRACK] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3585),
    [anon_sym_EQ_EQ] = ACTIONS(3587),
    [anon_sym_PIPE_PIPE] = ACTIONS(3587),
    [anon_sym_GT_EQ] = ACTIONS(3587),
    [sym__concat] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3587),
    [anon_sym_DASH_DASH] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3587),
    [anon_sym_AMP_AMP] = ACTIONS(3587),
    [anon_sym_DASH_EQ] = ACTIONS(3587),
  },
  [1655] = {
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_PLUS_EQ] = ACTIONS(3591),
    [sym_test_operator] = ACTIONS(3591),
    [anon_sym_PLUS_PLUS] = ACTIONS(3591),
    [anon_sym_RBRACK] = ACTIONS(3591),
    [anon_sym_DASH] = ACTIONS(3589),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_PIPE_PIPE] = ACTIONS(3591),
    [anon_sym_GT_EQ] = ACTIONS(3591),
    [sym__concat] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3591),
    [anon_sym_LT_EQ] = ACTIONS(3591),
    [anon_sym_AMP_AMP] = ACTIONS(3591),
    [anon_sym_DASH_EQ] = ACTIONS(3591),
  },
  [1656] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1657] = {
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_PLUS_EQ] = ACTIONS(3642),
    [sym_test_operator] = ACTIONS(3642),
    [anon_sym_PLUS_PLUS] = ACTIONS(3642),
    [anon_sym_RBRACK] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3640),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_EQ_EQ] = ACTIONS(3642),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_GT_EQ] = ACTIONS(3642),
    [sym__concat] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_DASH_DASH] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_DASH_EQ] = ACTIONS(3642),
  },
  [1658] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [anon_sym_AMP_GT_GT] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [anon_sym_LT_LT] = ACTIONS(2896),
    [sym_file_descriptor] = ACTIONS(2898),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_RPAREN] = ACTIONS(2896),
    [anon_sym_AMP_GT] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [ts_builtin_sym_end] = ACTIONS(2898),
    [anon_sym_LT_LT_LT] = ACTIONS(2896),
    [anon_sym_PIPE] = ACTIONS(2896),
    [anon_sym_GT_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_LT_AMP] = ACTIONS(2896),
    [anon_sym_GT_GT] = ACTIONS(2896),
    [anon_sym_AMP] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_esac] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
    [anon_sym_PIPE_AMP] = ACTIONS(2896),
  },
  [1659] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1660] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1822),
    [sym_concatenation] = STATE(1822),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4333),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(4333),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4333),
    [anon_sym_PERCENT] = ACTIONS(4333),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4335),
    [anon_sym_COLON_DASH] = ACTIONS(4333),
    [sym__special_character] = ACTIONS(553),
  },
  [1661] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4331),
    [sym__concat] = ACTIONS(2213),
  },
  [1662] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4337),
  },
  [1663] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4331),
  },
  [1664] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [sym_file_descriptor] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [ts_builtin_sym_end] = ACTIONS(2947),
    [anon_sym_LT_LT_LT] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_esac] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
  },
  [1665] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1825),
    [sym_concatenation] = STATE(1825),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4339),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4341),
    [anon_sym_DASH] = ACTIONS(4339),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4343),
    [anon_sym_COLON_DASH] = ACTIONS(4339),
    [sym__special_character] = ACTIONS(553),
  },
  [1666] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4341),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1667] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(2993),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [anon_sym_AMP_GT_GT] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [sym_file_descriptor] = ACTIONS(2995),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_AMP_GT] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [ts_builtin_sym_end] = ACTIONS(2995),
    [anon_sym_LT_LT_LT] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_GT_AMP] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_LT_AMP] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_esac] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
    [anon_sym_PIPE_AMP] = ACTIONS(2993),
  },
  [1668] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3012),
    [anon_sym_BQUOTE] = ACTIONS(3012),
    [anon_sym_AMP_GT_GT] = ACTIONS(3012),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [sym_file_descriptor] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_AMP_GT] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [ts_builtin_sym_end] = ACTIONS(3014),
    [anon_sym_LT_LT_LT] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_GT_AMP] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_LT_AMP] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_esac] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
    [anon_sym_PIPE_AMP] = ACTIONS(3012),
  },
  [1669] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4345),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1670] = {
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2111),
    [sym__heredoc_body_end] = ACTIONS(2111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2111),
    [sym__heredoc_body_middle] = ACTIONS(2111),
  },
  [1671] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1828),
    [sym_concatenation] = STATE(1828),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4347),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4347),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4347),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4351),
    [anon_sym_COLON_DASH] = ACTIONS(4347),
    [sym__special_character] = ACTIONS(553),
  },
  [1672] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1673] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1828),
    [sym_concatenation] = STATE(1828),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4347),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4347),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4347),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4351),
    [anon_sym_COLON_DASH] = ACTIONS(4347),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4353),
  },
  [1674] = {
    [sym_command_substitution] = STATE(1830),
    [aux_sym__literal_repeat1] = STATE(1831),
    [sym_string] = STATE(1830),
    [sym_process_substitution] = STATE(1830),
    [sym_simple_expansion] = STATE(1830),
    [sym_string_expansion] = STATE(1830),
    [sym_concatenation] = STATE(1832),
    [sym_expansion] = STATE(1830),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(4355),
    [sym_raw_string] = ACTIONS(4355),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1675] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1835),
    [sym_concatenation] = STATE(1835),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4357),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4359),
    [anon_sym_DASH] = ACTIONS(4357),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4357),
    [anon_sym_PERCENT] = ACTIONS(4357),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4361),
    [anon_sym_COLON_DASH] = ACTIONS(4357),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4363),
  },
  [1676] = {
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2207),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2207),
    [sym__heredoc_body_end] = ACTIONS(2207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2207),
    [sym__heredoc_body_middle] = ACTIONS(2207),
  },
  [1677] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4359),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1678] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [sym__concat] = ACTIONS(2213),
  },
  [1679] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4365),
  },
  [1680] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4349),
  },
  [1681] = {
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_BQUOTE] = ACTIONS(2249),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2249),
    [sym__heredoc_body_end] = ACTIONS(2249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2249),
    [sym__heredoc_body_middle] = ACTIONS(2249),
  },
  [1682] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1838),
    [sym_concatenation] = STATE(1838),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4367),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4367),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4367),
    [anon_sym_PERCENT] = ACTIONS(4367),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4371),
    [anon_sym_COLON_DASH] = ACTIONS(4367),
    [sym__special_character] = ACTIONS(553),
  },
  [1683] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1684] = {
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_AMP_GT_GT] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [sym_file_descriptor] = ACTIONS(4036),
    [sym_variable_name] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_AMP_GT] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [sym_word] = ACTIONS(4036),
    [anon_sym_GT_AMP] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4036),
    [anon_sym_GT_GT] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(4036),
  },
  [1685] = {
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_AMP_GT_GT] = ACTIONS(4040),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_file_descriptor] = ACTIONS(4040),
    [sym_variable_name] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [sym_word] = ACTIONS(4040),
    [anon_sym_GT_AMP] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4040),
    [anon_sym_GT_GT] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(4040),
  },
  [1686] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [sym_word] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [sym__special_character] = ACTIONS(4034),
    [anon_sym_LT_LT_DASH] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4034),
    [sym_raw_string] = ACTIONS(4034),
    [sym_variable_name] = ACTIONS(4036),
    [sym_file_descriptor] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [ts_builtin_sym_end] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
  },
  [1687] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [sym__special_character] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [sym_variable_name] = ACTIONS(4040),
    [sym_file_descriptor] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [ts_builtin_sym_end] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
  },
  [1688] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [sym_word] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [sym__special_character] = ACTIONS(4034),
    [anon_sym_LT_LT_DASH] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4034),
    [sym_raw_string] = ACTIONS(4034),
    [sym_file_descriptor] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [ts_builtin_sym_end] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
  },
  [1689] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [sym__special_character] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [sym_file_descriptor] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [ts_builtin_sym_end] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
  },
  [1690] = {
    [anon_sym_BQUOTE] = ACTIONS(3553),
    [sym_raw_string] = ACTIONS(3553),
    [anon_sym_COLON_QMARK] = ACTIONS(3551),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_RBRACE] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3553),
    [anon_sym_EQ] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3553),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_COLON] = ACTIONS(3551),
    [anon_sym_GT_LPAREN] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [sym_word] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [anon_sym_LT_LPAREN] = ACTIONS(3553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3553),
    [anon_sym_COLON_DASH] = ACTIONS(3551),
    [sym__special_character] = ACTIONS(3551),
  },
  [1691] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4373),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1692] = {
    [anon_sym_BQUOTE] = ACTIONS(3587),
    [sym_raw_string] = ACTIONS(3587),
    [anon_sym_COLON_QMARK] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_RBRACE] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3587),
    [anon_sym_EQ] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3587),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_COLON] = ACTIONS(3585),
    [anon_sym_GT_LPAREN] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3587),
    [sym_word] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [anon_sym_LT_LPAREN] = ACTIONS(3587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3587),
    [anon_sym_COLON_DASH] = ACTIONS(3585),
    [sym__special_character] = ACTIONS(3585),
  },
  [1693] = {
    [anon_sym_BQUOTE] = ACTIONS(3591),
    [sym_raw_string] = ACTIONS(3591),
    [anon_sym_COLON_QMARK] = ACTIONS(3589),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_RBRACE] = ACTIONS(3591),
    [anon_sym_DASH] = ACTIONS(3589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3591),
    [anon_sym_EQ] = ACTIONS(3589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3591),
    [anon_sym_PERCENT] = ACTIONS(3589),
    [anon_sym_COLON] = ACTIONS(3589),
    [anon_sym_GT_LPAREN] = ACTIONS(3591),
    [anon_sym_DQUOTE] = ACTIONS(3591),
    [sym_word] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [anon_sym_LT_LPAREN] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3591),
    [anon_sym_COLON_DASH] = ACTIONS(3589),
    [sym__special_character] = ACTIONS(3589),
  },
  [1694] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1695] = {
    [anon_sym_BQUOTE] = ACTIONS(3642),
    [sym_raw_string] = ACTIONS(3642),
    [anon_sym_COLON_QMARK] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_RBRACE] = ACTIONS(3642),
    [anon_sym_DASH] = ACTIONS(3640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3642),
    [anon_sym_PERCENT] = ACTIONS(3640),
    [anon_sym_COLON] = ACTIONS(3640),
    [anon_sym_GT_LPAREN] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [sym_word] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [anon_sym_LT_LPAREN] = ACTIONS(3642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3642),
    [anon_sym_COLON_DASH] = ACTIONS(3640),
    [sym__special_character] = ACTIONS(3640),
  },
  [1696] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [sym__concat] = ACTIONS(2898),
  },
  [1697] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4377),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1698] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1842),
    [sym_concatenation] = STATE(1842),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4379),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4377),
    [anon_sym_DASH] = ACTIONS(4379),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4379),
    [anon_sym_PERCENT] = ACTIONS(4379),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4381),
    [anon_sym_COLON_DASH] = ACTIONS(4379),
    [sym__special_character] = ACTIONS(553),
  },
  [1699] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4377),
    [sym__concat] = ACTIONS(2213),
  },
  [1700] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4383),
  },
  [1701] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4377),
  },
  [1702] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [sym__concat] = ACTIONS(2947),
  },
  [1703] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1845),
    [sym_concatenation] = STATE(1845),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4385),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4387),
    [anon_sym_DASH] = ACTIONS(4385),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4385),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4385),
    [anon_sym_PERCENT] = ACTIONS(4385),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4389),
    [anon_sym_COLON_DASH] = ACTIONS(4385),
    [sym__special_character] = ACTIONS(553),
  },
  [1704] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4387),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1705] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(2995),
    [sym__concat] = ACTIONS(2995),
  },
  [1706] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [sym__concat] = ACTIONS(3014),
  },
  [1707] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4391),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1708] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4393),
    [anon_sym_BQUOTE] = ACTIONS(4393),
    [anon_sym_AMP_GT_GT] = ACTIONS(4393),
    [anon_sym_LF] = ACTIONS(4395),
    [anon_sym_SEMI] = ACTIONS(4393),
    [anon_sym_LT_LT] = ACTIONS(4393),
    [sym_file_descriptor] = ACTIONS(4395),
    [anon_sym_GT] = ACTIONS(4393),
    [anon_sym_RPAREN] = ACTIONS(4393),
    [anon_sym_AMP_GT] = ACTIONS(4393),
    [anon_sym_PIPE_PIPE] = ACTIONS(4393),
    [ts_builtin_sym_end] = ACTIONS(4395),
    [anon_sym_LT_LT_LT] = ACTIONS(4393),
    [anon_sym_PIPE] = ACTIONS(4393),
    [anon_sym_GT_AMP] = ACTIONS(4393),
    [anon_sym_LT] = ACTIONS(4393),
    [anon_sym_LT_AMP] = ACTIONS(4393),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_AMP] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(4393),
    [anon_sym_AMP_AMP] = ACTIONS(4393),
    [anon_sym_SEMI_SEMI] = ACTIONS(4393),
    [anon_sym_PIPE_AMP] = ACTIONS(4393),
  },
  [1709] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(1847),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1710] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(1850),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(4397),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(4399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [1711] = {
    [aux_sym_concatenation_repeat1] = STATE(1852),
    [anon_sym_AMP_GT_GT] = ACTIONS(423),
    [anon_sym_DOLLAR] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_LPAREN] = ACTIONS(423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(423),
    [aux_sym__simple_variable_name_token1] = ACTIONS(423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(423),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [sym_word] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(423),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_LT_AMP] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [sym__concat] = ACTIONS(4401),
    [sym__special_character] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(423),
    [anon_sym_BQUOTE] = ACTIONS(423),
    [anon_sym_LF] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(423),
    [sym_raw_string] = ACTIONS(423),
    [sym_variable_name] = ACTIONS(427),
    [sym_file_descriptor] = ACTIONS(427),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [anon_sym_LT_LT_LT] = ACTIONS(423),
    [anon_sym_GT_AMP] = ACTIONS(423),
    [anon_sym_LT_LPAREN] = ACTIONS(423),
    [anon_sym_esac] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(423),
    [anon_sym_PIPE_AMP] = ACTIONS(423),
  },
  [1712] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(1853),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1713] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(4403),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_EQ] = ACTIONS(4403),
  },
  [1714] = {
    [sym_string] = STATE(1856),
    [anon_sym_DQUOTE] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4407),
    [anon_sym_QMARK] = ACTIONS(4407),
    [sym_raw_string] = ACTIONS(4409),
    [anon_sym_BANG] = ACTIONS(4411),
    [anon_sym_AT] = ACTIONS(4407),
    [anon_sym_DOLLAR] = ACTIONS(4411),
    [anon_sym_POUND] = ACTIONS(4411),
    [anon_sym_DASH] = ACTIONS(4411),
    [anon_sym_0] = ACTIONS(4413),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4413),
    [anon_sym__] = ACTIONS(4413),
  },
  [1715] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(1858),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(1859),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1716] = {
    [aux_sym_concatenation_repeat1] = STATE(1852),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(4401),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [anon_sym_esac] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [1717] = {
    [sym_subscript] = STATE(1860),
    [anon_sym_STAR] = ACTIONS(4415),
    [anon_sym_QMARK] = ACTIONS(4415),
    [anon_sym_BANG] = ACTIONS(4417),
    [anon_sym_AT] = ACTIONS(4415),
    [sym_variable_name] = ACTIONS(4419),
    [anon_sym_DOLLAR] = ACTIONS(4421),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_0] = ACTIONS(4423),
    [anon_sym_POUND] = ACTIONS(4417),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4423),
    [anon_sym__] = ACTIONS(4423),
    [sym_comment] = ACTIONS(3),
  },
  [1718] = {
    [aux_sym__literal_repeat1] = STATE(1865),
    [anon_sym_AMP_GT_GT] = ACTIONS(451),
    [anon_sym_DOLLAR] = ACTIONS(451),
    [anon_sym_LT_LT] = ACTIONS(451),
    [anon_sym_GT_LPAREN] = ACTIONS(451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(451),
    [aux_sym__simple_variable_name_token1] = ACTIONS(451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [sym_word] = ACTIONS(451),
    [anon_sym_PIPE] = ACTIONS(451),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(451),
    [anon_sym_LT_AMP] = ACTIONS(451),
    [anon_sym_GT_GT] = ACTIONS(451),
    [sym__special_character] = ACTIONS(4425),
    [anon_sym_LT_LT_DASH] = ACTIONS(451),
    [anon_sym_BQUOTE] = ACTIONS(451),
    [anon_sym_LF] = ACTIONS(455),
    [anon_sym_SEMI] = ACTIONS(451),
    [sym_raw_string] = ACTIONS(451),
    [sym_variable_name] = ACTIONS(455),
    [sym_file_descriptor] = ACTIONS(455),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_AMP_GT] = ACTIONS(451),
    [anon_sym_DQUOTE] = ACTIONS(451),
    [anon_sym_LT_LT_LT] = ACTIONS(451),
    [anon_sym_GT_AMP] = ACTIONS(451),
    [anon_sym_LT_LPAREN] = ACTIONS(451),
    [anon_sym_esac] = ACTIONS(451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_SEMI_SEMI] = ACTIONS(451),
    [anon_sym_PIPE_AMP] = ACTIONS(451),
  },
  [1719] = {
    [sym_command_substitution] = STATE(1711),
    [aux_sym__literal_repeat1] = STATE(1718),
    [sym_string] = STATE(1711),
    [aux_sym_declaration_command_repeat1] = STATE(1866),
    [sym_process_substitution] = STATE(1711),
    [sym_simple_expansion] = STATE(1711),
    [sym_subscript] = STATE(1720),
    [sym_string_expansion] = STATE(1711),
    [sym_variable_assignment] = STATE(1866),
    [sym_concatenation] = STATE(1866),
    [sym_expansion] = STATE(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(4088),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(4090),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4092),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4096),
    [anon_sym_PIPE_PIPE] = ACTIONS(457),
    [sym_word] = ACTIONS(4098),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_LT_AMP] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [sym__special_character] = ACTIONS(4100),
    [anon_sym_LT_LT_DASH] = ACTIONS(457),
    [anon_sym_BQUOTE] = ACTIONS(4102),
    [anon_sym_LF] = ACTIONS(461),
    [anon_sym_SEMI] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(4098),
    [sym_variable_name] = ACTIONS(4104),
    [sym_file_descriptor] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_AMP_GT] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(4106),
    [anon_sym_LT_LT_LT] = ACTIONS(457),
    [anon_sym_GT_AMP] = ACTIONS(457),
    [anon_sym_LT_LPAREN] = ACTIONS(4090),
    [anon_sym_esac] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(457),
    [anon_sym_SEMI_SEMI] = ACTIONS(457),
    [anon_sym_PIPE_AMP] = ACTIONS(457),
  },
  [1720] = {
    [anon_sym_EQ] = ACTIONS(4403),
    [anon_sym_PLUS_EQ] = ACTIONS(4403),
    [sym_comment] = ACTIONS(51),
  },
  [1721] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(1867),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1722] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(1870),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(4429),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(4431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [1723] = {
    [aux_sym_concatenation_repeat1] = STATE(1872),
    [anon_sym_AMP_GT_GT] = ACTIONS(467),
    [anon_sym_DOLLAR] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(467),
    [aux_sym__simple_variable_name_token1] = ACTIONS(467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(467),
    [anon_sym_PIPE_PIPE] = ACTIONS(467),
    [sym_word] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(467),
    [anon_sym_LT_AMP] = ACTIONS(467),
    [anon_sym_GT_GT] = ACTIONS(467),
    [sym__concat] = ACTIONS(4433),
    [sym__special_character] = ACTIONS(467),
    [anon_sym_LT_LT_DASH] = ACTIONS(467),
    [anon_sym_BQUOTE] = ACTIONS(467),
    [anon_sym_LF] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(467),
    [sym_raw_string] = ACTIONS(467),
    [sym_file_descriptor] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(467),
    [anon_sym_AMP_GT] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(467),
    [anon_sym_LT_LT_LT] = ACTIONS(467),
    [anon_sym_GT_AMP] = ACTIONS(467),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_esac] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(467),
    [anon_sym_SEMI_SEMI] = ACTIONS(467),
    [anon_sym_PIPE_AMP] = ACTIONS(467),
  },
  [1724] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(1873),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1725] = {
    [sym_string] = STATE(1875),
    [anon_sym_DQUOTE] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4437),
    [anon_sym_QMARK] = ACTIONS(4437),
    [sym_raw_string] = ACTIONS(4439),
    [anon_sym_BANG] = ACTIONS(4441),
    [anon_sym_AT] = ACTIONS(4437),
    [anon_sym_DOLLAR] = ACTIONS(4441),
    [anon_sym_POUND] = ACTIONS(4441),
    [anon_sym_DASH] = ACTIONS(4441),
    [anon_sym_0] = ACTIONS(4443),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4443),
    [anon_sym__] = ACTIONS(4443),
  },
  [1726] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(1877),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(1878),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1727] = {
    [aux_sym_concatenation_repeat1] = STATE(1872),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(4433),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [anon_sym_esac] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [1728] = {
    [sym_subscript] = STATE(1879),
    [anon_sym_STAR] = ACTIONS(4445),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_BANG] = ACTIONS(4447),
    [anon_sym_AT] = ACTIONS(4445),
    [sym_variable_name] = ACTIONS(4449),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_0] = ACTIONS(4453),
    [anon_sym_POUND] = ACTIONS(4447),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4453),
    [anon_sym__] = ACTIONS(4453),
    [sym_comment] = ACTIONS(3),
  },
  [1729] = {
    [aux_sym__literal_repeat1] = STATE(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(493),
    [anon_sym_DOLLAR] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(493),
    [anon_sym_GT_LPAREN] = ACTIONS(493),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(493),
    [aux_sym__simple_variable_name_token1] = ACTIONS(493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(493),
    [anon_sym_PIPE_PIPE] = ACTIONS(493),
    [sym_word] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_LT_AMP] = ACTIONS(493),
    [anon_sym_GT_GT] = ACTIONS(493),
    [sym__special_character] = ACTIONS(4455),
    [anon_sym_LT_LT_DASH] = ACTIONS(493),
    [anon_sym_BQUOTE] = ACTIONS(493),
    [anon_sym_LF] = ACTIONS(497),
    [anon_sym_SEMI] = ACTIONS(493),
    [sym_raw_string] = ACTIONS(493),
    [sym_file_descriptor] = ACTIONS(497),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_AMP_GT] = ACTIONS(493),
    [anon_sym_DQUOTE] = ACTIONS(493),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(493),
    [anon_sym_LT_LPAREN] = ACTIONS(493),
    [anon_sym_esac] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(493),
    [anon_sym_SEMI_SEMI] = ACTIONS(493),
    [anon_sym_PIPE_AMP] = ACTIONS(493),
  },
  [1730] = {
    [sym_command_substitution] = STATE(1723),
    [aux_sym__literal_repeat1] = STATE(1729),
    [sym_string] = STATE(1723),
    [aux_sym_unset_command_repeat1] = STATE(1885),
    [sym_process_substitution] = STATE(1723),
    [sym_simple_expansion] = STATE(1723),
    [sym_string_expansion] = STATE(1723),
    [sym_concatenation] = STATE(1885),
    [sym_expansion] = STATE(1723),
    [anon_sym_AMP_GT_GT] = ACTIONS(499),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [anon_sym_LT_LT] = ACTIONS(499),
    [anon_sym_GT_LPAREN] = ACTIONS(4110),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4112),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4116),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [sym_word] = ACTIONS(4118),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_AMP] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(499),
    [anon_sym_LT_AMP] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(499),
    [sym__special_character] = ACTIONS(4120),
    [anon_sym_LT_LT_DASH] = ACTIONS(499),
    [anon_sym_BQUOTE] = ACTIONS(4122),
    [anon_sym_LF] = ACTIONS(503),
    [anon_sym_SEMI] = ACTIONS(499),
    [sym_raw_string] = ACTIONS(4118),
    [sym_file_descriptor] = ACTIONS(503),
    [anon_sym_GT] = ACTIONS(499),
    [anon_sym_AMP_GT] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(4124),
    [anon_sym_LT_LT_LT] = ACTIONS(499),
    [anon_sym_GT_AMP] = ACTIONS(499),
    [anon_sym_LT_LPAREN] = ACTIONS(4110),
    [anon_sym_esac] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(499),
    [anon_sym_PIPE_AMP] = ACTIONS(499),
  },
  [1731] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_LT_LT] = ACTIONS(505),
    [anon_sym_GT_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [sym_word] = ACTIONS(505),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_AMP] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_LT_AMP] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [anon_sym_EQ_TILDE] = ACTIONS(505),
    [sym__special_character] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [sym_raw_string] = ACTIONS(505),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_EQ_EQ] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(505),
    [anon_sym_LT_LT_LT] = ACTIONS(505),
    [anon_sym_GT_AMP] = ACTIONS(505),
    [anon_sym_LT_LPAREN] = ACTIONS(505),
    [anon_sym_esac] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
    [anon_sym_PIPE_AMP] = ACTIONS(505),
  },
  [1732] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(509),
    [anon_sym_GT_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(509),
    [anon_sym_PIPE_PIPE] = ACTIONS(509),
    [sym_word] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_GT] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [anon_sym_EQ_TILDE] = ACTIONS(509),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_LT_LT_DASH] = ACTIONS(509),
    [anon_sym_BQUOTE] = ACTIONS(509),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(509),
    [sym_file_descriptor] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(509),
    [anon_sym_EQ_EQ] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_LT_LT_LT] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LPAREN] = ACTIONS(509),
    [anon_sym_esac] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
    [anon_sym_PIPE_AMP] = ACTIONS(509),
  },
  [1733] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [anon_sym_EQ_TILDE] = ACTIONS(513),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [anon_sym_esac] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [1734] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4459),
  },
  [1735] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(4461),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [1736] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4461),
  },
  [1737] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1890),
    [sym_concatenation] = STATE(1890),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(4463),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4465),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4467),
    [anon_sym_DASH] = ACTIONS(4465),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4465),
    [anon_sym_PERCENT] = ACTIONS(4465),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4469),
    [anon_sym_COLON_DASH] = ACTIONS(4465),
    [sym__special_character] = ACTIONS(553),
  },
  [1738] = {
    [sym_subscript] = STATE(1891),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_QMARK] = ACTIONS(4471),
    [anon_sym_AT] = ACTIONS(4471),
    [sym_variable_name] = ACTIONS(4473),
    [anon_sym_DOLLAR] = ACTIONS(4475),
    [anon_sym_DASH] = ACTIONS(4475),
    [anon_sym_0] = ACTIONS(4477),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4477),
    [anon_sym__] = ACTIONS(4477),
  },
  [1739] = {
    [anon_sym_EQ] = ACTIONS(4479),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1740] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1897),
    [sym_concatenation] = STATE(1897),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(4481),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4483),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4485),
    [anon_sym_DASH] = ACTIONS(4483),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4483),
    [anon_sym_PERCENT] = ACTIONS(4483),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4487),
    [anon_sym_COLON_DASH] = ACTIONS(4483),
    [sym__special_character] = ACTIONS(553),
  },
  [1741] = {
    [sym_command_substitution] = STATE(1898),
    [sym_simple_expansion] = STATE(1898),
    [sym_string_expansion] = STATE(1898),
    [sym_string] = STATE(1898),
    [sym_process_substitution] = STATE(1898),
    [sym_expansion] = STATE(1898),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [sym_word] = ACTIONS(4489),
    [sym_raw_string] = ACTIONS(4489),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [sym__special_character] = ACTIONS(4489),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
  },
  [1742] = {
    [aux_sym_concatenation_repeat1] = STATE(1900),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(4491),
    [anon_sym_EQ_TILDE] = ACTIONS(581),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_EQ_EQ] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [anon_sym_esac] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [1743] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4461),
  },
  [1744] = {
    [sym_command_substitution] = STATE(1904),
    [aux_sym__literal_repeat1] = STATE(1911),
    [sym_string] = STATE(1904),
    [sym_array] = STATE(1910),
    [sym_process_substitution] = STATE(1904),
    [sym_simple_expansion] = STATE(1904),
    [sym_string_expansion] = STATE(1904),
    [sym_concatenation] = STATE(1910),
    [sym_expansion] = STATE(1904),
    [anon_sym_LPAREN] = ACTIONS(4493),
    [anon_sym_BQUOTE] = ACTIONS(4495),
    [anon_sym_DQUOTE] = ACTIONS(4497),
    [sym_word] = ACTIONS(4499),
    [sym_raw_string] = ACTIONS(4499),
    [anon_sym_LT_LPAREN] = ACTIONS(4501),
    [anon_sym_DOLLAR] = ACTIONS(4503),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4501),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4505),
    [sym__special_character] = ACTIONS(4507),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4509),
    [sym__empty_value] = ACTIONS(4511),
  },
  [1745] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(4513),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1746] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(787),
    [anon_sym_GT_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [sym_word] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_LT_AMP] = ACTIONS(787),
    [anon_sym_GT_GT] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [anon_sym_EQ_TILDE] = ACTIONS(787),
    [sym__special_character] = ACTIONS(787),
    [anon_sym_LT_LT_DASH] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(787),
    [anon_sym_LF] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [sym_raw_string] = ACTIONS(787),
    [sym_file_descriptor] = ACTIONS(789),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_AMP_GT] = ACTIONS(787),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_LT_LT_LT] = ACTIONS(787),
    [anon_sym_GT_AMP] = ACTIONS(787),
    [anon_sym_LT_LPAREN] = ACTIONS(787),
    [anon_sym_esac] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
    [anon_sym_PIPE_AMP] = ACTIONS(787),
  },
  [1747] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(4515),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(4513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [1748] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [anon_sym_EQ_TILDE] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_EQ_EQ] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [anon_sym_esac] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [1749] = {
    [aux_sym__literal_repeat1] = STATE(1749),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [sym__special_character] = ACTIONS(4517),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [anon_sym_esac] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [1750] = {
    [aux_sym__literal_repeat1] = STATE(1554),
    [sym_if_statement] = STATE(1914),
    [sym_function_definition] = STATE(1914),
    [sym_negated_command] = STATE(1914),
    [sym_test_command] = STATE(1914),
    [sym_variable_assignment] = STATE(1915),
    [sym_subscript] = STATE(1557),
    [sym_concatenation] = STATE(1558),
    [sym_expansion] = STATE(1548),
    [sym_command_substitution] = STATE(1548),
    [sym_redirected_statement] = STATE(1914),
    [sym_for_statement] = STATE(1914),
    [sym_compound_statement] = STATE(1914),
    [sym_subshell] = STATE(1914),
    [sym_declaration_command] = STATE(1914),
    [sym_unset_command] = STATE(1914),
    [sym_file_redirect] = STATE(1560),
    [sym_string] = STATE(1548),
    [sym_process_substitution] = STATE(1548),
    [aux_sym_command_repeat1] = STATE(1560),
    [sym_c_style_for_statement] = STATE(1914),
    [sym_while_statement] = STATE(1914),
    [sym_case_statement] = STATE(1914),
    [sym_pipeline] = STATE(1914),
    [sym_list] = STATE(1914),
    [sym_command] = STATE(1914),
    [sym_command_name] = STATE(1562),
    [sym_simple_expansion] = STATE(1548),
    [sym_string_expansion] = STATE(1548),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(3660),
    [anon_sym_typeset] = ACTIONS(3660),
    [anon_sym_unsetenv] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(3660),
    [sym__special_character] = ACTIONS(3674),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3676),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3680),
    [anon_sym_declare] = ACTIONS(3660),
    [sym_variable_name] = ACTIONS(3682),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(3660),
    [anon_sym_unset] = ACTIONS(3662),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1751] = {
    [sym_command_substitution] = STATE(1916),
    [aux_sym__literal_repeat1] = STATE(1918),
    [sym_string] = STATE(1916),
    [sym_process_substitution] = STATE(1916),
    [sym_simple_expansion] = STATE(1916),
    [sym_string_expansion] = STATE(1916),
    [sym_concatenation] = STATE(501),
    [sym_expansion] = STATE(1916),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(4520),
    [sym_raw_string] = ACTIONS(4520),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(4522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [1752] = {
    [sym_heredoc_body] = STATE(1919),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__simple_heredoc_body] = ACTIONS(910),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [sym__heredoc_body_beginning] = ACTIONS(912),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [anon_sym_esac] = ACTIONS(1062),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
    [anon_sym_SEMI_SEMI] = ACTIONS(914),
  },
  [1753] = {
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [anon_sym_esac] = ACTIONS(1062),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
    [anon_sym_SEMI_SEMI] = ACTIONS(914),
  },
  [1754] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4524),
    [anon_sym_GT_AMP] = ACTIONS(4524),
    [anon_sym_LT] = ACTIONS(4526),
    [anon_sym_LT_AMP] = ACTIONS(4524),
    [anon_sym_GT_GT] = ACTIONS(4524),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(4526),
    [anon_sym_AMP_GT] = ACTIONS(4526),
  },
  [1755] = {
    [aux_sym__literal_repeat1] = STATE(1554),
    [sym_if_statement] = STATE(1921),
    [sym_function_definition] = STATE(1921),
    [sym_negated_command] = STATE(1921),
    [sym_test_command] = STATE(1921),
    [sym_variable_assignment] = STATE(1922),
    [sym_subscript] = STATE(1557),
    [sym_concatenation] = STATE(1558),
    [sym_expansion] = STATE(1548),
    [sym_command_substitution] = STATE(1548),
    [sym_redirected_statement] = STATE(1921),
    [sym_for_statement] = STATE(1921),
    [sym_compound_statement] = STATE(1921),
    [sym_subshell] = STATE(1921),
    [sym_declaration_command] = STATE(1921),
    [sym_unset_command] = STATE(1921),
    [sym_file_redirect] = STATE(1560),
    [sym_string] = STATE(1548),
    [sym_process_substitution] = STATE(1548),
    [aux_sym_command_repeat1] = STATE(1560),
    [sym_c_style_for_statement] = STATE(1921),
    [sym_while_statement] = STATE(1921),
    [sym_case_statement] = STATE(1921),
    [sym_pipeline] = STATE(1921),
    [sym_list] = STATE(1921),
    [sym_command] = STATE(1921),
    [sym_command_name] = STATE(1562),
    [sym_simple_expansion] = STATE(1548),
    [sym_string_expansion] = STATE(1548),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(3660),
    [anon_sym_typeset] = ACTIONS(3660),
    [anon_sym_unsetenv] = ACTIONS(3662),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(3672),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(3660),
    [sym__special_character] = ACTIONS(3674),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(3676),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_BANG] = ACTIONS(3680),
    [anon_sym_declare] = ACTIONS(3660),
    [sym_variable_name] = ACTIONS(3682),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(3660),
    [anon_sym_unset] = ACTIONS(3662),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1756] = {
    [sym_command_substitution] = STATE(1923),
    [aux_sym__literal_repeat1] = STATE(1924),
    [sym_string] = STATE(1923),
    [sym_process_substitution] = STATE(1923),
    [sym_simple_expansion] = STATE(1923),
    [sym_string_expansion] = STATE(1923),
    [sym_concatenation] = STATE(511),
    [sym_expansion] = STATE(1923),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(4528),
    [sym_raw_string] = ACTIONS(4528),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(4522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [1757] = {
    [sym_heredoc_redirect] = STATE(1925),
    [aux_sym_redirected_statement_repeat1] = STATE(1925),
    [sym_herestring_redirect] = STATE(1925),
    [sym_file_redirect] = STATE(1925),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_AMP_GT_GT] = ACTIONS(4160),
    [anon_sym_LF] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(926),
    [anon_sym_LT_LT] = ACTIONS(311),
    [sym_file_descriptor] = ACTIONS(4166),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_AMP_GT] = ACTIONS(4160),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT_LT_LT] = ACTIONS(4170),
    [anon_sym_PIPE] = ACTIONS(926),
    [anon_sym_GT_AMP] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_esac] = ACTIONS(926),
    [anon_sym_GT_GT] = ACTIONS(4160),
    [anon_sym_LT_AMP] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_SEMI_SEMI] = ACTIONS(926),
    [anon_sym_PIPE_AMP] = ACTIONS(926),
  },
  [1758] = {
    [sym_heredoc_redirect] = STATE(1757),
    [aux_sym_redirected_statement_repeat1] = STATE(1757),
    [sym_herestring_redirect] = STATE(1757),
    [sym_file_redirect] = STATE(1757),
    [anon_sym_PIPE_AMP] = ACTIONS(4172),
    [anon_sym_AMP_GT_GT] = ACTIONS(4160),
    [anon_sym_LF] = ACTIONS(4530),
    [anon_sym_SEMI] = ACTIONS(4532),
    [sym_file_descriptor] = ACTIONS(4166),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_AMP_GT] = ACTIONS(4160),
    [anon_sym_PIPE_PIPE] = ACTIONS(4168),
    [anon_sym_LT_LT_LT] = ACTIONS(4170),
    [anon_sym_GT_AMP] = ACTIONS(4160),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_esac] = ACTIONS(1062),
    [anon_sym_LT_AMP] = ACTIONS(4160),
    [anon_sym_GT_GT] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_SEMI_SEMI] = ACTIONS(1062),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
  },
  [1759] = {
    [sym_heredoc_redirect] = STATE(1757),
    [aux_sym_redirected_statement_repeat1] = STATE(1757),
    [sym_herestring_redirect] = STATE(1757),
    [sym_file_redirect] = STATE(1757),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(4168),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(4532),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(4530),
    [anon_sym_SEMI] = ACTIONS(4532),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(4170),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [anon_sym_esac] = ACTIONS(1062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4168),
    [anon_sym_SEMI_SEMI] = ACTIONS(1062),
    [anon_sym_PIPE_AMP] = ACTIONS(4172),
  },
  [1760] = {
    [sym_command_substitution] = STATE(1762),
    [aux_sym__literal_repeat1] = STATE(1764),
    [sym_string] = STATE(1762),
    [sym_process_substitution] = STATE(1762),
    [sym_simple_expansion] = STATE(1762),
    [sym_string_expansion] = STATE(1762),
    [aux_sym_command_repeat2] = STATE(1928),
    [sym_concatenation] = STATE(1928),
    [sym_expansion] = STATE(1762),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(4180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4184),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(4186),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [anon_sym_EQ_TILDE] = ACTIONS(4188),
    [sym__special_character] = ACTIONS(3674),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(4190),
    [anon_sym_LF] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(4186),
    [sym_file_descriptor] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(4188),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(4180),
    [anon_sym_esac] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [1761] = {
    [anon_sym_BQUOTE] = ACTIONS(4534),
    [anon_sym_DQUOTE] = ACTIONS(4534),
    [sym_word] = ACTIONS(4536),
    [sym_raw_string] = ACTIONS(4534),
    [anon_sym_LT_LPAREN] = ACTIONS(4534),
    [anon_sym_esac] = ACTIONS(4538),
    [anon_sym_DOLLAR] = ACTIONS(4536),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4534),
    [sym__special_character] = ACTIONS(4534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4534),
  },
  [1762] = {
    [aux_sym_concatenation_repeat1] = STATE(1742),
    [anon_sym_AMP_GT_GT] = ACTIONS(1030),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_LPAREN] = ACTIONS(1030),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1030),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1030),
    [anon_sym_PIPE_PIPE] = ACTIONS(1030),
    [sym_word] = ACTIONS(1030),
    [anon_sym_PIPE] = ACTIONS(1030),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_LT_AMP] = ACTIONS(1030),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [sym__concat] = ACTIONS(4144),
    [anon_sym_EQ_TILDE] = ACTIONS(1030),
    [sym__special_character] = ACTIONS(1030),
    [anon_sym_LT_LT_DASH] = ACTIONS(1030),
    [anon_sym_BQUOTE] = ACTIONS(1030),
    [anon_sym_LF] = ACTIONS(1032),
    [anon_sym_SEMI] = ACTIONS(1030),
    [sym_raw_string] = ACTIONS(1030),
    [sym_file_descriptor] = ACTIONS(1032),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_AMP_GT] = ACTIONS(1030),
    [anon_sym_EQ_EQ] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_LT_LT_LT] = ACTIONS(1030),
    [anon_sym_GT_AMP] = ACTIONS(1030),
    [anon_sym_LT_LPAREN] = ACTIONS(1030),
    [anon_sym_esac] = ACTIONS(1030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1030),
    [anon_sym_SEMI_SEMI] = ACTIONS(1030),
    [anon_sym_PIPE_AMP] = ACTIONS(1030),
  },
  [1763] = {
    [sym_command_substitution] = STATE(1929),
    [aux_sym__literal_repeat1] = STATE(1931),
    [sym_string] = STATE(1929),
    [sym_process_substitution] = STATE(1929),
    [sym_simple_expansion] = STATE(1929),
    [sym_string_expansion] = STATE(1929),
    [sym_concatenation] = STATE(1930),
    [sym_expansion] = STATE(1929),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [sym_word] = ACTIONS(4540),
    [sym_raw_string] = ACTIONS(4540),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [sym__special_character] = ACTIONS(4174),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
    [sym_regex] = ACTIONS(4542),
  },
  [1764] = {
    [aux_sym__literal_repeat1] = STATE(1749),
    [anon_sym_AMP_GT_GT] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_GT_LPAREN] = ACTIONS(1038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1038),
    [anon_sym_PIPE_PIPE] = ACTIONS(1038),
    [sym_word] = ACTIONS(1038),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_LT_AMP] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_EQ_TILDE] = ACTIONS(1038),
    [sym__special_character] = ACTIONS(4158),
    [anon_sym_LT_LT_DASH] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [anon_sym_LF] = ACTIONS(1040),
    [anon_sym_SEMI] = ACTIONS(1038),
    [sym_raw_string] = ACTIONS(1038),
    [sym_file_descriptor] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_EQ_EQ] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [anon_sym_LT_LT_LT] = ACTIONS(1038),
    [anon_sym_GT_AMP] = ACTIONS(1038),
    [anon_sym_LT_LPAREN] = ACTIONS(1038),
    [anon_sym_esac] = ACTIONS(1038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1038),
    [anon_sym_SEMI_SEMI] = ACTIONS(1038),
    [anon_sym_PIPE_AMP] = ACTIONS(1038),
  },
  [1765] = {
    [sym_command_substitution] = STATE(1762),
    [aux_sym__literal_repeat1] = STATE(1764),
    [sym_string] = STATE(1762),
    [sym_process_substitution] = STATE(1762),
    [sym_simple_expansion] = STATE(1762),
    [sym_string_expansion] = STATE(1762),
    [aux_sym_command_repeat2] = STATE(1932),
    [sym_concatenation] = STATE(1932),
    [sym_expansion] = STATE(1762),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(4180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4184),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(4186),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [anon_sym_EQ_TILDE] = ACTIONS(4188),
    [sym__special_character] = ACTIONS(3674),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(4190),
    [anon_sym_LF] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(4186),
    [sym_file_descriptor] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_EQ_EQ] = ACTIONS(4188),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(4180),
    [anon_sym_esac] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [1766] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(4544),
    [anon_sym_esac] = ACTIONS(4546),
  },
  [1767] = {
    [anon_sym_BQUOTE] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4548),
    [sym_word] = ACTIONS(4550),
    [sym_raw_string] = ACTIONS(4548),
    [anon_sym_LT_LPAREN] = ACTIONS(4548),
    [anon_sym_esac] = ACTIONS(4552),
    [anon_sym_DOLLAR] = ACTIONS(4550),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4548),
    [sym__special_character] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4548),
  },
  [1768] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(4554),
    [anon_sym_esac] = ACTIONS(4556),
  },
  [1769] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(1936),
    [sym_function_definition] = STATE(1936),
    [sym_negated_command] = STATE(1936),
    [sym_test_command] = STATE(1936),
    [sym_variable_assignment] = STATE(1937),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1938),
    [sym_redirected_statement] = STATE(1936),
    [sym_for_statement] = STATE(1936),
    [sym_compound_statement] = STATE(1936),
    [sym_subshell] = STATE(1936),
    [sym_declaration_command] = STATE(1936),
    [sym_unset_command] = STATE(1936),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym__statements] = STATE(1939),
    [sym_c_style_for_statement] = STATE(1936),
    [sym_while_statement] = STATE(1936),
    [sym_case_statement] = STATE(1936),
    [sym_pipeline] = STATE(1936),
    [sym_list] = STATE(1936),
    [sym_command] = STATE(1936),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(4558),
  },
  [1770] = {
    [aux_sym_case_item_repeat1] = STATE(1565),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_RPAREN] = ACTIONS(4560),
    [sym_comment] = ACTIONS(51),
  },
  [1771] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(1936),
    [sym_function_definition] = STATE(1936),
    [sym_negated_command] = STATE(1936),
    [sym_test_command] = STATE(1936),
    [sym_variable_assignment] = STATE(1937),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1938),
    [sym_redirected_statement] = STATE(1936),
    [sym_for_statement] = STATE(1936),
    [sym_compound_statement] = STATE(1936),
    [sym_subshell] = STATE(1936),
    [sym_declaration_command] = STATE(1936),
    [sym_unset_command] = STATE(1936),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym__statements] = STATE(1942),
    [sym_c_style_for_statement] = STATE(1936),
    [sym_while_statement] = STATE(1936),
    [sym_case_statement] = STATE(1936),
    [sym_pipeline] = STATE(1936),
    [sym_list] = STATE(1936),
    [sym_command] = STATE(1936),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(4562),
  },
  [1772] = {
    [aux_sym_case_item_repeat1] = STATE(1565),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_RPAREN] = ACTIONS(4564),
    [sym_comment] = ACTIONS(51),
  },
  [1773] = {
    [anon_sym_AMP] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4034),
    [anon_sym_in] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
  },
  [1774] = {
    [anon_sym_AMP] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
  },
  [1775] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4566),
    [anon_sym_BQUOTE] = ACTIONS(4566),
    [anon_sym_AMP_GT_GT] = ACTIONS(4566),
    [anon_sym_LF] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_LT_LT] = ACTIONS(4566),
    [sym_file_descriptor] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4566),
    [anon_sym_RPAREN] = ACTIONS(4566),
    [anon_sym_AMP_GT] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE] = ACTIONS(4566),
    [ts_builtin_sym_end] = ACTIONS(4568),
    [anon_sym_LT_LT_LT] = ACTIONS(4566),
    [anon_sym_PIPE] = ACTIONS(4566),
    [anon_sym_GT_AMP] = ACTIONS(4566),
    [anon_sym_LT] = ACTIONS(4566),
    [anon_sym_LT_AMP] = ACTIONS(4566),
    [anon_sym_GT_GT] = ACTIONS(4566),
    [anon_sym_AMP] = ACTIONS(4566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(4566),
    [anon_sym_AMP_AMP] = ACTIONS(4566),
    [anon_sym_SEMI_SEMI] = ACTIONS(4566),
    [anon_sym_PIPE_AMP] = ACTIONS(4566),
  },
  [1776] = {
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_PLUS_EQ] = ACTIONS(4036),
    [sym_test_operator] = ACTIONS(4036),
    [anon_sym_PLUS_PLUS] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_EQ] = ACTIONS(4034),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_GT_EQ] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(4036),
    [anon_sym_DASH_DASH] = ACTIONS(4036),
    [anon_sym_LT_EQ] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_DASH_EQ] = ACTIONS(4036),
  },
  [1777] = {
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_PLUS_EQ] = ACTIONS(4040),
    [sym_test_operator] = ACTIONS(4040),
    [anon_sym_PLUS_PLUS] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_EQ] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_GT_EQ] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(4040),
    [anon_sym_DASH_DASH] = ACTIONS(4040),
    [anon_sym_LT_EQ] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_DASH_EQ] = ACTIONS(4040),
  },
  [1778] = {
    [anon_sym_BQUOTE] = ACTIONS(2898),
    [anon_sym_DQUOTE] = ACTIONS(2898),
    [sym_word] = ACTIONS(2898),
    [sym_raw_string] = ACTIONS(2898),
    [sym__concat] = ACTIONS(2898),
    [anon_sym_LT_LPAREN] = ACTIONS(2898),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_RPAREN] = ACTIONS(2898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2898),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2898),
    [sym__special_character] = ACTIONS(2898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2898),
  },
  [1779] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4570),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1780] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1945),
    [sym_concatenation] = STATE(1945),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4570),
    [anon_sym_DASH] = ACTIONS(4572),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4572),
    [anon_sym_PERCENT] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4574),
    [anon_sym_COLON_DASH] = ACTIONS(4572),
    [sym__special_character] = ACTIONS(553),
  },
  [1781] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4570),
    [sym__concat] = ACTIONS(2213),
  },
  [1782] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4576),
  },
  [1783] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4570),
  },
  [1784] = {
    [anon_sym_BQUOTE] = ACTIONS(2947),
    [anon_sym_DQUOTE] = ACTIONS(2947),
    [sym_word] = ACTIONS(2947),
    [sym_raw_string] = ACTIONS(2947),
    [sym__concat] = ACTIONS(2947),
    [anon_sym_LT_LPAREN] = ACTIONS(2947),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2947),
    [sym__special_character] = ACTIONS(2947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2947),
  },
  [1785] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1948),
    [sym_concatenation] = STATE(1948),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4578),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4580),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4578),
    [anon_sym_PERCENT] = ACTIONS(4578),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4582),
    [anon_sym_COLON_DASH] = ACTIONS(4578),
    [sym__special_character] = ACTIONS(553),
  },
  [1786] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4580),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1787] = {
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [sym_word] = ACTIONS(2995),
    [sym_raw_string] = ACTIONS(2995),
    [sym__concat] = ACTIONS(2995),
    [anon_sym_LT_LPAREN] = ACTIONS(2995),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_RPAREN] = ACTIONS(2995),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2995),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2995),
    [sym__special_character] = ACTIONS(2995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2995),
  },
  [1788] = {
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [sym_word] = ACTIONS(3014),
    [sym_raw_string] = ACTIONS(3014),
    [sym__concat] = ACTIONS(3014),
    [anon_sym_LT_LPAREN] = ACTIONS(3014),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3014),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3014),
    [sym__special_character] = ACTIONS(3014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3014),
  },
  [1789] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4584),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1790] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3551),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [sym_word] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_LT_AMP] = ACTIONS(3551),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [sym__special_character] = ACTIONS(3551),
    [anon_sym_LT_LT_DASH] = ACTIONS(3551),
    [anon_sym_BQUOTE] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3551),
    [sym_raw_string] = ACTIONS(3551),
    [sym_variable_name] = ACTIONS(3553),
    [sym_file_descriptor] = ACTIONS(3553),
    [anon_sym_RPAREN] = ACTIONS(3551),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_AMP_GT] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_LT_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_AMP] = ACTIONS(3551),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [anon_sym_LT_LPAREN] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_PIPE_AMP] = ACTIONS(3551),
  },
  [1791] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4586),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1792] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [sym_word] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_LT_AMP] = ACTIONS(3585),
    [anon_sym_GT_GT] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [sym__special_character] = ACTIONS(3585),
    [anon_sym_LT_LT_DASH] = ACTIONS(3585),
    [anon_sym_BQUOTE] = ACTIONS(3585),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3585),
    [sym_raw_string] = ACTIONS(3585),
    [sym_variable_name] = ACTIONS(3587),
    [sym_file_descriptor] = ACTIONS(3587),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_AMP_GT] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_LT_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_AMP] = ACTIONS(3585),
    [ts_builtin_sym_end] = ACTIONS(3587),
    [anon_sym_LT_LPAREN] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
    [anon_sym_PIPE_AMP] = ACTIONS(3585),
  },
  [1793] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3589),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3589),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [sym_word] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_AMP] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [sym__special_character] = ACTIONS(3589),
    [anon_sym_LT_LT_DASH] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(3589),
    [anon_sym_LF] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [sym_raw_string] = ACTIONS(3589),
    [sym_variable_name] = ACTIONS(3591),
    [sym_file_descriptor] = ACTIONS(3591),
    [anon_sym_RPAREN] = ACTIONS(3589),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_AMP_GT] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_LT_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_AMP] = ACTIONS(3589),
    [ts_builtin_sym_end] = ACTIONS(3591),
    [anon_sym_LT_LPAREN] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
    [anon_sym_PIPE_AMP] = ACTIONS(3589),
  },
  [1794] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1795] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3640),
    [anon_sym_PIPE_PIPE] = ACTIONS(3640),
    [sym_word] = ACTIONS(3640),
    [anon_sym_PIPE] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_LT_AMP] = ACTIONS(3640),
    [anon_sym_GT_GT] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [sym__special_character] = ACTIONS(3640),
    [anon_sym_LT_LT_DASH] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(3640),
    [anon_sym_LF] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3640),
    [sym_raw_string] = ACTIONS(3640),
    [sym_variable_name] = ACTIONS(3642),
    [sym_file_descriptor] = ACTIONS(3642),
    [anon_sym_RPAREN] = ACTIONS(3640),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_AMP_GT] = ACTIONS(3640),
    [anon_sym_DQUOTE] = ACTIONS(3640),
    [anon_sym_LT_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_AMP] = ACTIONS(3640),
    [ts_builtin_sym_end] = ACTIONS(3642),
    [anon_sym_LT_LPAREN] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
    [anon_sym_PIPE_AMP] = ACTIONS(3640),
  },
  [1796] = {
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [sym__string_content] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
  },
  [1797] = {
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [sym__string_content] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
  },
  [1798] = {
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [sym_raw_string] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_GT_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_word] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT_LPAREN] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
  },
  [1799] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1800] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1953),
    [sym_concatenation] = STATE(1953),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4592),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4590),
    [anon_sym_DASH] = ACTIONS(4592),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4592),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4592),
    [anon_sym_PERCENT] = ACTIONS(4592),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4594),
    [anon_sym_COLON_DASH] = ACTIONS(4592),
    [sym__special_character] = ACTIONS(553),
  },
  [1801] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4590),
    [sym__concat] = ACTIONS(2213),
  },
  [1802] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4596),
  },
  [1803] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4590),
  },
  [1804] = {
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym_word] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
  },
  [1805] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1956),
    [sym_concatenation] = STATE(1956),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4598),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4600),
    [anon_sym_DASH] = ACTIONS(4598),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4598),
    [anon_sym_PERCENT] = ACTIONS(4598),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4602),
    [anon_sym_COLON_DASH] = ACTIONS(4598),
    [sym__special_character] = ACTIONS(553),
  },
  [1806] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4600),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1807] = {
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [sym_raw_string] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_GT_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [sym_word] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT_LPAREN] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
  },
  [1808] = {
    [anon_sym_BQUOTE] = ACTIONS(3012),
    [sym_raw_string] = ACTIONS(3012),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_GT_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [sym_word] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LT_LPAREN] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
  },
  [1809] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1810] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(4606),
    [anon_sym_AMP_GT_GT] = ACTIONS(4606),
    [anon_sym_LF] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4606),
    [sym_file_descriptor] = ACTIONS(4608),
    [anon_sym_GT] = ACTIONS(4606),
    [anon_sym_RPAREN] = ACTIONS(4606),
    [anon_sym_AMP_GT] = ACTIONS(4606),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [ts_builtin_sym_end] = ACTIONS(4608),
    [anon_sym_LT_LT_LT] = ACTIONS(4606),
    [anon_sym_PIPE] = ACTIONS(4606),
    [anon_sym_GT_AMP] = ACTIONS(4606),
    [anon_sym_LT] = ACTIONS(4606),
    [anon_sym_LT_AMP] = ACTIONS(4606),
    [anon_sym_GT_GT] = ACTIONS(4606),
    [anon_sym_AMP] = ACTIONS(4606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_SEMI_SEMI] = ACTIONS(4606),
    [anon_sym_PIPE_AMP] = ACTIONS(4606),
  },
  [1811] = {
    [sym_do_group] = STATE(1958),
    [sym_compound_statement] = STATE(1958),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(839),
  },
  [1812] = {
    [anon_sym_BANG_EQ] = ACTIONS(3551),
    [anon_sym_PLUS_EQ] = ACTIONS(3551),
    [sym_test_operator] = ACTIONS(3553),
    [anon_sym_LF] = ACTIONS(3551),
    [anon_sym_SEMI] = ACTIONS(3551),
    [anon_sym_PLUS_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_EQ] = ACTIONS(3551),
    [anon_sym_EQ_EQ] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_GT_EQ] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3551),
    [anon_sym_DASH_DASH] = ACTIONS(3551),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_LT_EQ] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_DASH_EQ] = ACTIONS(3551),
  },
  [1813] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1814] = {
    [anon_sym_BANG_EQ] = ACTIONS(3585),
    [anon_sym_PLUS_EQ] = ACTIONS(3585),
    [sym_test_operator] = ACTIONS(3587),
    [anon_sym_LF] = ACTIONS(3585),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_PLUS_PLUS] = ACTIONS(3585),
    [anon_sym_DASH] = ACTIONS(3585),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_EQ] = ACTIONS(3585),
    [anon_sym_EQ_EQ] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [anon_sym_GT_EQ] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3585),
    [anon_sym_DASH_DASH] = ACTIONS(3585),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_LT_EQ] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
    [anon_sym_DASH_EQ] = ACTIONS(3585),
  },
  [1815] = {
    [anon_sym_BANG_EQ] = ACTIONS(3589),
    [anon_sym_PLUS_EQ] = ACTIONS(3589),
    [sym_test_operator] = ACTIONS(3591),
    [anon_sym_LF] = ACTIONS(3589),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3589),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3589),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3589),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
    [anon_sym_DASH_EQ] = ACTIONS(3589),
  },
  [1816] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4612),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1817] = {
    [anon_sym_BANG_EQ] = ACTIONS(3640),
    [anon_sym_PLUS_EQ] = ACTIONS(3640),
    [sym_test_operator] = ACTIONS(3642),
    [anon_sym_LF] = ACTIONS(3640),
    [anon_sym_SEMI] = ACTIONS(3640),
    [anon_sym_PLUS_PLUS] = ACTIONS(3640),
    [anon_sym_DASH] = ACTIONS(3640),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_EQ] = ACTIONS(3640),
    [anon_sym_EQ_EQ] = ACTIONS(3640),
    [anon_sym_PIPE_PIPE] = ACTIONS(3640),
    [anon_sym_GT_EQ] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [anon_sym_PLUS] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(3640),
    [anon_sym_DASH_DASH] = ACTIONS(3640),
    [anon_sym_AMP_AMP] = ACTIONS(3640),
    [anon_sym_LT_EQ] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
    [anon_sym_DASH_EQ] = ACTIONS(3640),
  },
  [1818] = {
    [sym_do_group] = STATE(1958),
    [sym_compound_statement] = STATE(1958),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(4614),
    [anon_sym_do] = ACTIONS(839),
  },
  [1819] = {
    [anon_sym_BANG_EQ] = ACTIONS(4036),
    [anon_sym_PLUS_EQ] = ACTIONS(4036),
    [sym_test_operator] = ACTIONS(4036),
    [anon_sym_PLUS_PLUS] = ACTIONS(4036),
    [anon_sym_RBRACK] = ACTIONS(4036),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_EQ] = ACTIONS(4034),
    [anon_sym_EQ_EQ] = ACTIONS(4036),
    [anon_sym_PIPE_PIPE] = ACTIONS(4036),
    [anon_sym_GT_EQ] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(4036),
    [anon_sym_DASH_DASH] = ACTIONS(4036),
    [anon_sym_LT_EQ] = ACTIONS(4036),
    [anon_sym_AMP_AMP] = ACTIONS(4036),
    [anon_sym_DASH_EQ] = ACTIONS(4036),
  },
  [1820] = {
    [anon_sym_BANG_EQ] = ACTIONS(4040),
    [anon_sym_PLUS_EQ] = ACTIONS(4040),
    [sym_test_operator] = ACTIONS(4040),
    [anon_sym_PLUS_PLUS] = ACTIONS(4040),
    [anon_sym_RBRACK] = ACTIONS(4040),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_EQ] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4040),
    [anon_sym_PIPE_PIPE] = ACTIONS(4040),
    [anon_sym_GT_EQ] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(4040),
    [anon_sym_DASH_DASH] = ACTIONS(4040),
    [anon_sym_LT_EQ] = ACTIONS(4040),
    [anon_sym_AMP_AMP] = ACTIONS(4040),
    [anon_sym_DASH_EQ] = ACTIONS(4040),
  },
  [1821] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3551),
    [anon_sym_BQUOTE] = ACTIONS(3551),
    [anon_sym_AMP_GT_GT] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3551),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [sym_file_descriptor] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_RPAREN] = ACTIONS(3551),
    [anon_sym_AMP_GT] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [anon_sym_LT_LT_LT] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_GT_AMP] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_LT_AMP] = ACTIONS(3551),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_esac] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_PIPE_AMP] = ACTIONS(3551),
  },
  [1822] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4616),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1823] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3585),
    [anon_sym_BQUOTE] = ACTIONS(3585),
    [anon_sym_AMP_GT_GT] = ACTIONS(3585),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_LT_LT] = ACTIONS(3585),
    [sym_file_descriptor] = ACTIONS(3587),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_AMP_GT] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [ts_builtin_sym_end] = ACTIONS(3587),
    [anon_sym_LT_LT_LT] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3585),
    [anon_sym_GT_AMP] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_LT_AMP] = ACTIONS(3585),
    [anon_sym_GT_GT] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_esac] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
    [anon_sym_PIPE_AMP] = ACTIONS(3585),
  },
  [1824] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(3589),
    [anon_sym_AMP_GT_GT] = ACTIONS(3589),
    [anon_sym_LF] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_LT_LT] = ACTIONS(3589),
    [sym_file_descriptor] = ACTIONS(3591),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_RPAREN] = ACTIONS(3589),
    [anon_sym_AMP_GT] = ACTIONS(3589),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [ts_builtin_sym_end] = ACTIONS(3591),
    [anon_sym_LT_LT_LT] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [anon_sym_GT_AMP] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_AMP] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_esac] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
    [anon_sym_PIPE_AMP] = ACTIONS(3589),
  },
  [1825] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4618),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1826] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(3640),
    [anon_sym_AMP_GT_GT] = ACTIONS(3640),
    [anon_sym_LF] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3640),
    [anon_sym_LT_LT] = ACTIONS(3640),
    [sym_file_descriptor] = ACTIONS(3642),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_RPAREN] = ACTIONS(3640),
    [anon_sym_AMP_GT] = ACTIONS(3640),
    [anon_sym_PIPE_PIPE] = ACTIONS(3640),
    [ts_builtin_sym_end] = ACTIONS(3642),
    [anon_sym_LT_LT_LT] = ACTIONS(3640),
    [anon_sym_PIPE] = ACTIONS(3640),
    [anon_sym_GT_AMP] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_LT_AMP] = ACTIONS(3640),
    [anon_sym_GT_GT] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3640),
    [anon_sym_esac] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
    [anon_sym_PIPE_AMP] = ACTIONS(3640),
  },
  [1827] = {
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2898),
    [sym__heredoc_body_end] = ACTIONS(2898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2898),
    [sym__heredoc_body_middle] = ACTIONS(2898),
  },
  [1828] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1829] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1965),
    [sym_concatenation] = STATE(1965),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4622),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [anon_sym_DASH] = ACTIONS(4622),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4622),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4622),
    [anon_sym_PERCENT] = ACTIONS(4622),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4624),
    [anon_sym_COLON_DASH] = ACTIONS(4622),
    [sym__special_character] = ACTIONS(553),
  },
  [1830] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [sym__concat] = ACTIONS(2213),
  },
  [1831] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(4626),
  },
  [1832] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4620),
  },
  [1833] = {
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2947),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2947),
    [sym__heredoc_body_end] = ACTIONS(2947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2947),
    [sym__heredoc_body_middle] = ACTIONS(2947),
  },
  [1834] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1968),
    [sym_concatenation] = STATE(1968),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4628),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4630),
    [anon_sym_DASH] = ACTIONS(4628),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4628),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4628),
    [anon_sym_PERCENT] = ACTIONS(4628),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4632),
    [anon_sym_COLON_DASH] = ACTIONS(4628),
    [sym__special_character] = ACTIONS(553),
  },
  [1835] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4630),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1836] = {
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2995),
    [sym__heredoc_body_end] = ACTIONS(2995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2995),
    [sym__heredoc_body_middle] = ACTIONS(2995),
  },
  [1837] = {
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3014),
    [sym__heredoc_body_end] = ACTIONS(3014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3014),
    [sym__heredoc_body_middle] = ACTIONS(3014),
  },
  [1838] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4634),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1839] = {
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [anon_sym_COLON_QMARK] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [anon_sym_COLON] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [sym_word] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4036),
    [anon_sym_COLON_DASH] = ACTIONS(4034),
    [sym__special_character] = ACTIONS(4034),
  },
  [1840] = {
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [sym_raw_string] = ACTIONS(4040),
    [anon_sym_COLON_QMARK] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [anon_sym_EQ] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [anon_sym_PERCENT] = ACTIONS(4038),
    [anon_sym_COLON] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [sym_word] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4040),
    [anon_sym_COLON_DASH] = ACTIONS(4038),
    [sym__special_character] = ACTIONS(4038),
  },
  [1841] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3553),
    [sym__concat] = ACTIONS(3553),
  },
  [1842] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1843] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3587),
    [sym__concat] = ACTIONS(3587),
  },
  [1844] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3591),
    [sym__concat] = ACTIONS(3591),
  },
  [1845] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4638),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1846] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3642),
    [sym__concat] = ACTIONS(3642),
  },
  [1847] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4640),
  },
  [1848] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(4642),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1849] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(787),
    [anon_sym_GT_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(787),
    [aux_sym__simple_variable_name_token1] = ACTIONS(787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [sym_word] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_LT_AMP] = ACTIONS(787),
    [anon_sym_GT_GT] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [sym__special_character] = ACTIONS(787),
    [anon_sym_LT_LT_DASH] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(787),
    [anon_sym_LF] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [sym_raw_string] = ACTIONS(787),
    [sym_variable_name] = ACTIONS(789),
    [sym_file_descriptor] = ACTIONS(789),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_AMP_GT] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_LT_LT_LT] = ACTIONS(787),
    [anon_sym_GT_AMP] = ACTIONS(787),
    [anon_sym_LT_LPAREN] = ACTIONS(787),
    [anon_sym_esac] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
    [anon_sym_PIPE_AMP] = ACTIONS(787),
  },
  [1850] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(4644),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(4642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [1851] = {
    [sym_command_substitution] = STATE(1975),
    [sym_simple_expansion] = STATE(1975),
    [sym_string_expansion] = STATE(1975),
    [sym_string] = STATE(1975),
    [sym_process_substitution] = STATE(1975),
    [sym_expansion] = STATE(1975),
    [anon_sym_BQUOTE] = ACTIONS(4646),
    [anon_sym_DQUOTE] = ACTIONS(4405),
    [sym_word] = ACTIONS(4648),
    [sym_raw_string] = ACTIONS(4648),
    [anon_sym_LT_LPAREN] = ACTIONS(4650),
    [anon_sym_DOLLAR] = ACTIONS(4088),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4652),
    [sym__special_character] = ACTIONS(4648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4654),
  },
  [1852] = {
    [aux_sym_concatenation_repeat1] = STATE(1977),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(4656),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [anon_sym_esac] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [1853] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4658),
  },
  [1854] = {
    [sym_command_substitution] = STATE(1980),
    [aux_sym__literal_repeat1] = STATE(1982),
    [sym_string] = STATE(1980),
    [sym_array] = STATE(1981),
    [sym_process_substitution] = STATE(1980),
    [sym_simple_expansion] = STATE(1980),
    [sym_string_expansion] = STATE(1980),
    [sym_concatenation] = STATE(1981),
    [sym_expansion] = STATE(1980),
    [anon_sym_LPAREN] = ACTIONS(4660),
    [anon_sym_BQUOTE] = ACTIONS(4646),
    [anon_sym_DQUOTE] = ACTIONS(4405),
    [sym_word] = ACTIONS(4662),
    [sym_raw_string] = ACTIONS(4662),
    [anon_sym_LT_LPAREN] = ACTIONS(4650),
    [anon_sym_DOLLAR] = ACTIONS(4088),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4652),
    [sym__special_character] = ACTIONS(4664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4654),
    [sym__empty_value] = ACTIONS(4666),
  },
  [1855] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_LT_LT] = ACTIONS(505),
    [anon_sym_GT_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(505),
    [aux_sym__simple_variable_name_token1] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [sym_word] = ACTIONS(505),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_AMP] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_LT_AMP] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [sym__special_character] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [sym_raw_string] = ACTIONS(505),
    [sym_variable_name] = ACTIONS(507),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(505),
    [anon_sym_LT_LT_LT] = ACTIONS(505),
    [anon_sym_GT_AMP] = ACTIONS(505),
    [anon_sym_LT_LPAREN] = ACTIONS(505),
    [anon_sym_esac] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
    [anon_sym_PIPE_AMP] = ACTIONS(505),
  },
  [1856] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(509),
    [anon_sym_GT_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(509),
    [aux_sym__simple_variable_name_token1] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(509),
    [anon_sym_PIPE_PIPE] = ACTIONS(509),
    [sym_word] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_GT] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_LT_LT_DASH] = ACTIONS(509),
    [anon_sym_BQUOTE] = ACTIONS(509),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(509),
    [sym_variable_name] = ACTIONS(511),
    [sym_file_descriptor] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_LT_LT_LT] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LPAREN] = ACTIONS(509),
    [anon_sym_esac] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
    [anon_sym_PIPE_AMP] = ACTIONS(509),
  },
  [1857] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_variable_name] = ACTIONS(515),
    [sym_file_descriptor] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [anon_sym_esac] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [1858] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [1859] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4640),
  },
  [1860] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1985),
    [sym_concatenation] = STATE(1985),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(4668),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4670),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4672),
    [anon_sym_DASH] = ACTIONS(4670),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4670),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4670),
    [anon_sym_PERCENT] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4674),
    [anon_sym_COLON_DASH] = ACTIONS(4670),
    [sym__special_character] = ACTIONS(553),
  },
  [1861] = {
    [sym_subscript] = STATE(1986),
    [anon_sym_STAR] = ACTIONS(4676),
    [anon_sym_QMARK] = ACTIONS(4676),
    [anon_sym_AT] = ACTIONS(4676),
    [sym_variable_name] = ACTIONS(4678),
    [anon_sym_DOLLAR] = ACTIONS(4680),
    [anon_sym_DASH] = ACTIONS(4680),
    [anon_sym_0] = ACTIONS(4682),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4682),
    [anon_sym__] = ACTIONS(4682),
  },
  [1862] = {
    [anon_sym_EQ] = ACTIONS(4684),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1863] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(1992),
    [sym_concatenation] = STATE(1992),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(4686),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4688),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4690),
    [anon_sym_DASH] = ACTIONS(4688),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4688),
    [anon_sym_PERCENT] = ACTIONS(4688),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4692),
    [anon_sym_COLON_DASH] = ACTIONS(4688),
    [sym__special_character] = ACTIONS(553),
  },
  [1864] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [anon_sym_esac] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [1865] = {
    [aux_sym__literal_repeat1] = STATE(1865),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [aux_sym__simple_variable_name_token1] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(4694),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_variable_name] = ACTIONS(888),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [anon_sym_esac] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [1866] = {
    [sym_command_substitution] = STATE(1711),
    [aux_sym__literal_repeat1] = STATE(1718),
    [sym_string] = STATE(1711),
    [aux_sym_declaration_command_repeat1] = STATE(1866),
    [sym_process_substitution] = STATE(1711),
    [sym_simple_expansion] = STATE(1711),
    [sym_subscript] = STATE(1720),
    [sym_string_expansion] = STATE(1711),
    [sym_variable_assignment] = STATE(1866),
    [sym_concatenation] = STATE(1866),
    [sym_expansion] = STATE(1711),
    [anon_sym_AMP_GT_GT] = ACTIONS(1168),
    [anon_sym_DOLLAR] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(1168),
    [anon_sym_GT_LPAREN] = ACTIONS(4700),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4703),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4706),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4709),
    [anon_sym_PIPE_PIPE] = ACTIONS(1168),
    [sym_word] = ACTIONS(4712),
    [anon_sym_PIPE] = ACTIONS(1168),
    [anon_sym_AMP] = ACTIONS(1168),
    [anon_sym_LT] = ACTIONS(1168),
    [anon_sym_LT_AMP] = ACTIONS(1168),
    [anon_sym_GT_GT] = ACTIONS(1168),
    [sym__special_character] = ACTIONS(4715),
    [anon_sym_LT_LT_DASH] = ACTIONS(1168),
    [anon_sym_BQUOTE] = ACTIONS(4718),
    [anon_sym_LF] = ACTIONS(1194),
    [anon_sym_SEMI] = ACTIONS(1168),
    [sym_raw_string] = ACTIONS(4712),
    [sym_variable_name] = ACTIONS(4721),
    [sym_file_descriptor] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1168),
    [anon_sym_AMP_GT] = ACTIONS(1168),
    [anon_sym_DQUOTE] = ACTIONS(4724),
    [anon_sym_LT_LT_LT] = ACTIONS(1168),
    [anon_sym_GT_AMP] = ACTIONS(1168),
    [anon_sym_LT_LPAREN] = ACTIONS(4700),
    [anon_sym_esac] = ACTIONS(1168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_SEMI_SEMI] = ACTIONS(1168),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
  },
  [1867] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4727),
  },
  [1868] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(4729),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1869] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(787),
    [anon_sym_GT_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(787),
    [aux_sym__simple_variable_name_token1] = ACTIONS(787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [sym_word] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_LT_AMP] = ACTIONS(787),
    [anon_sym_GT_GT] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [sym__special_character] = ACTIONS(787),
    [anon_sym_LT_LT_DASH] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(787),
    [anon_sym_LF] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [sym_raw_string] = ACTIONS(787),
    [sym_file_descriptor] = ACTIONS(789),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_AMP_GT] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_LT_LT_LT] = ACTIONS(787),
    [anon_sym_GT_AMP] = ACTIONS(787),
    [anon_sym_LT_LPAREN] = ACTIONS(787),
    [anon_sym_esac] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
    [anon_sym_PIPE_AMP] = ACTIONS(787),
  },
  [1870] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(4731),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(4729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [1871] = {
    [sym_command_substitution] = STATE(1996),
    [sym_simple_expansion] = STATE(1996),
    [sym_string_expansion] = STATE(1996),
    [sym_string] = STATE(1996),
    [sym_process_substitution] = STATE(1996),
    [sym_expansion] = STATE(1996),
    [anon_sym_BQUOTE] = ACTIONS(4733),
    [anon_sym_DQUOTE] = ACTIONS(4435),
    [sym_word] = ACTIONS(4735),
    [sym_raw_string] = ACTIONS(4735),
    [anon_sym_LT_LPAREN] = ACTIONS(4737),
    [anon_sym_DOLLAR] = ACTIONS(4108),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4739),
    [sym__special_character] = ACTIONS(4735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4741),
  },
  [1872] = {
    [aux_sym_concatenation_repeat1] = STATE(1998),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(4743),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [anon_sym_esac] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [1873] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4745),
  },
  [1874] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_LT_LT] = ACTIONS(505),
    [anon_sym_GT_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(505),
    [aux_sym__simple_variable_name_token1] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [sym_word] = ACTIONS(505),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_AMP] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_LT_AMP] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [sym__special_character] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [sym_raw_string] = ACTIONS(505),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(505),
    [anon_sym_LT_LT_LT] = ACTIONS(505),
    [anon_sym_GT_AMP] = ACTIONS(505),
    [anon_sym_LT_LPAREN] = ACTIONS(505),
    [anon_sym_esac] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
    [anon_sym_PIPE_AMP] = ACTIONS(505),
  },
  [1875] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(509),
    [anon_sym_GT_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(509),
    [aux_sym__simple_variable_name_token1] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(509),
    [anon_sym_PIPE_PIPE] = ACTIONS(509),
    [sym_word] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_GT] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_LT_LT_DASH] = ACTIONS(509),
    [anon_sym_BQUOTE] = ACTIONS(509),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(509),
    [sym_file_descriptor] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_LT_LT_LT] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LPAREN] = ACTIONS(509),
    [anon_sym_esac] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
    [anon_sym_PIPE_AMP] = ACTIONS(509),
  },
  [1876] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [aux_sym__simple_variable_name_token1] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_file_descriptor] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [anon_sym_esac] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [1877] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(4727),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [1878] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4727),
  },
  [1879] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2002),
    [sym_concatenation] = STATE(2002),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(4747),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4749),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4751),
    [anon_sym_DASH] = ACTIONS(4749),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4749),
    [anon_sym_PERCENT] = ACTIONS(4749),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4753),
    [anon_sym_COLON_DASH] = ACTIONS(4749),
    [sym__special_character] = ACTIONS(553),
  },
  [1880] = {
    [sym_subscript] = STATE(2003),
    [anon_sym_STAR] = ACTIONS(4755),
    [anon_sym_QMARK] = ACTIONS(4755),
    [anon_sym_AT] = ACTIONS(4755),
    [sym_variable_name] = ACTIONS(4757),
    [anon_sym_DOLLAR] = ACTIONS(4759),
    [anon_sym_DASH] = ACTIONS(4759),
    [anon_sym_0] = ACTIONS(4761),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4761),
    [anon_sym__] = ACTIONS(4761),
  },
  [1881] = {
    [anon_sym_EQ] = ACTIONS(4763),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1882] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2009),
    [sym_concatenation] = STATE(2009),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(4765),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4769),
    [anon_sym_DASH] = ACTIONS(4767),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4767),
    [anon_sym_PERCENT] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4771),
    [anon_sym_COLON_DASH] = ACTIONS(4767),
    [sym__special_character] = ACTIONS(553),
  },
  [1883] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [aux_sym__simple_variable_name_token1] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [anon_sym_esac] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [1884] = {
    [aux_sym__literal_repeat1] = STATE(1884),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [aux_sym__simple_variable_name_token1] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(4773),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [anon_sym_esac] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [1885] = {
    [sym_command_substitution] = STATE(1723),
    [aux_sym__literal_repeat1] = STATE(1729),
    [sym_string] = STATE(1723),
    [aux_sym_unset_command_repeat1] = STATE(1885),
    [sym_process_substitution] = STATE(1723),
    [sym_simple_expansion] = STATE(1723),
    [sym_string_expansion] = STATE(1723),
    [sym_concatenation] = STATE(1885),
    [sym_expansion] = STATE(1723),
    [anon_sym_AMP_GT_GT] = ACTIONS(1251),
    [anon_sym_DOLLAR] = ACTIONS(4776),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_GT_LPAREN] = ACTIONS(4779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4782),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4785),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4788),
    [anon_sym_PIPE_PIPE] = ACTIONS(1251),
    [sym_word] = ACTIONS(4791),
    [anon_sym_PIPE] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1251),
    [anon_sym_LT_AMP] = ACTIONS(1251),
    [anon_sym_GT_GT] = ACTIONS(1251),
    [sym__special_character] = ACTIONS(4794),
    [anon_sym_LT_LT_DASH] = ACTIONS(1251),
    [anon_sym_BQUOTE] = ACTIONS(4797),
    [anon_sym_LF] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1251),
    [sym_raw_string] = ACTIONS(4791),
    [sym_file_descriptor] = ACTIONS(1277),
    [anon_sym_GT] = ACTIONS(1251),
    [anon_sym_AMP_GT] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(4800),
    [anon_sym_LT_LT_LT] = ACTIONS(1251),
    [anon_sym_GT_AMP] = ACTIONS(1251),
    [anon_sym_LT_LPAREN] = ACTIONS(4779),
    [anon_sym_esac] = ACTIONS(1251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1251),
    [anon_sym_SEMI_SEMI] = ACTIONS(1251),
    [anon_sym_PIPE_AMP] = ACTIONS(1251),
  },
  [1886] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [sym_word] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_LT_AMP] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [anon_sym_EQ_TILDE] = ACTIONS(1282),
    [sym__special_character] = ACTIONS(1282),
    [anon_sym_LT_LT_DASH] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_LF] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [sym_raw_string] = ACTIONS(1282),
    [sym_file_descriptor] = ACTIONS(1284),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_AMP_GT] = ACTIONS(1282),
    [anon_sym_EQ_EQ] = ACTIONS(1282),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_LT_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_AMP] = ACTIONS(1282),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [anon_sym_esac] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
    [anon_sym_PIPE_AMP] = ACTIONS(1282),
  },
  [1887] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE_PIPE] = ACTIONS(1288),
    [sym_word] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_LT_AMP] = ACTIONS(1288),
    [anon_sym_GT_GT] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [anon_sym_EQ_TILDE] = ACTIONS(1288),
    [sym__special_character] = ACTIONS(1288),
    [anon_sym_LT_LT_DASH] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LF] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1288),
    [sym_raw_string] = ACTIONS(1288),
    [sym_file_descriptor] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_AMP_GT] = ACTIONS(1288),
    [anon_sym_EQ_EQ] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_LT_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_AMP] = ACTIONS(1288),
    [anon_sym_LT_LPAREN] = ACTIONS(1288),
    [anon_sym_esac] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
    [anon_sym_PIPE_AMP] = ACTIONS(1288),
  },
  [1888] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2012),
    [sym_concatenation] = STATE(2012),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4803),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4805),
    [anon_sym_DASH] = ACTIONS(4803),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4803),
    [anon_sym_PERCENT] = ACTIONS(4803),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4807),
    [anon_sym_COLON_DASH] = ACTIONS(4803),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4809),
  },
  [1889] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [sym_word] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_LT_AMP] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [anon_sym_EQ_TILDE] = ACTIONS(1324),
    [sym__special_character] = ACTIONS(1324),
    [anon_sym_LT_LT_DASH] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [anon_sym_LF] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_raw_string] = ACTIONS(1324),
    [sym_file_descriptor] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_AMP_GT] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_LT_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_AMP] = ACTIONS(1324),
    [anon_sym_LT_LPAREN] = ACTIONS(1324),
    [anon_sym_esac] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
    [anon_sym_PIPE_AMP] = ACTIONS(1324),
  },
  [1890] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4805),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1891] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2012),
    [sym_concatenation] = STATE(2012),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(4811),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4803),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4805),
    [anon_sym_DASH] = ACTIONS(4803),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4803),
    [anon_sym_PERCENT] = ACTIONS(4803),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4807),
    [anon_sym_COLON_DASH] = ACTIONS(4803),
    [sym__special_character] = ACTIONS(553),
  },
  [1892] = {
    [anon_sym_EQ] = ACTIONS(4813),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1893] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2017),
    [sym_concatenation] = STATE(2017),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(4815),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4817),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4817),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4817),
    [anon_sym_PERCENT] = ACTIONS(4817),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4821),
    [anon_sym_COLON_DASH] = ACTIONS(4817),
    [sym__special_character] = ACTIONS(553),
  },
  [1894] = {
    [sym_command_substitution] = STATE(2018),
    [aux_sym__literal_repeat1] = STATE(2019),
    [sym_string] = STATE(2018),
    [sym_process_substitution] = STATE(2018),
    [sym_simple_expansion] = STATE(2018),
    [sym_string_expansion] = STATE(2018),
    [sym_concatenation] = STATE(2020),
    [sym_expansion] = STATE(2018),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(4823),
    [sym_raw_string] = ACTIONS(4823),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4805),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1895] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2023),
    [sym_concatenation] = STATE(2023),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4825),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4827),
    [anon_sym_DASH] = ACTIONS(4825),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4825),
    [anon_sym_PERCENT] = ACTIONS(4825),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4829),
    [anon_sym_COLON_DASH] = ACTIONS(4825),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4831),
  },
  [1896] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym_word] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [anon_sym_EQ_TILDE] = ACTIONS(1380),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_EQ_EQ] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_esac] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
  },
  [1897] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4827),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1898] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [anon_sym_EQ_TILDE] = ACTIONS(1390),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [anon_sym_esac] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1899] = {
    [sym_command_substitution] = STATE(1898),
    [sym_simple_expansion] = STATE(1898),
    [sym_string_expansion] = STATE(1898),
    [sym_string] = STATE(1898),
    [sym_process_substitution] = STATE(1898),
    [sym_expansion] = STATE(1898),
    [anon_sym_BQUOTE] = ACTIONS(3678),
    [anon_sym_DQUOTE] = ACTIONS(3684),
    [sym_word] = ACTIONS(4489),
    [sym_raw_string] = ACTIONS(4489),
    [anon_sym_LT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR] = ACTIONS(4833),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3668),
    [sym__special_character] = ACTIONS(4489),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3670),
  },
  [1900] = {
    [aux_sym_concatenation_repeat1] = STATE(1900),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(4835),
    [anon_sym_EQ_TILDE] = ACTIONS(1390),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [anon_sym_esac] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1901] = {
    [sym_command_substitution] = STATE(753),
    [aux_sym__literal_repeat1] = STATE(760),
    [sym_string] = STATE(753),
    [sym_process_substitution] = STATE(753),
    [aux_sym_for_statement_repeat1] = STATE(2026),
    [sym_simple_expansion] = STATE(753),
    [sym_string_expansion] = STATE(753),
    [sym_concatenation] = STATE(2026),
    [sym_expansion] = STATE(753),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(1571),
    [sym_raw_string] = ACTIONS(1571),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(4838),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [1902] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(143),
    [sym_function_definition] = STATE(143),
    [sym_negated_command] = STATE(143),
    [sym_test_command] = STATE(143),
    [sym_variable_assignment] = STATE(144),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(145),
    [sym_redirected_statement] = STATE(143),
    [sym_for_statement] = STATE(143),
    [sym_compound_statement] = STATE(143),
    [sym_subshell] = STATE(143),
    [sym_declaration_command] = STATE(143),
    [sym_unset_command] = STATE(143),
    [sym_file_redirect] = STATE(146),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(146),
    [sym__statements] = STATE(2027),
    [sym_c_style_for_statement] = STATE(143),
    [sym_while_statement] = STATE(143),
    [sym_case_statement] = STATE(143),
    [sym_pipeline] = STATE(143),
    [sym_list] = STATE(143),
    [sym_command] = STATE(143),
    [sym_command_name] = STATE(148),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(231),
    [anon_sym_typeset] = ACTIONS(231),
    [anon_sym_unsetenv] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(231),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_declare] = ACTIONS(231),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_unset] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1903] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(2030),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(4840),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(4842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [1904] = {
    [aux_sym_concatenation_repeat1] = STATE(2032),
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__concat] = ACTIONS(4844),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [anon_sym_esac] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [1905] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(49),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(2033),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1906] = {
    [sym_string] = STATE(2035),
    [anon_sym_DQUOTE] = ACTIONS(4497),
    [anon_sym_STAR] = ACTIONS(4846),
    [anon_sym_QMARK] = ACTIONS(4846),
    [sym_raw_string] = ACTIONS(4848),
    [anon_sym_BANG] = ACTIONS(4850),
    [anon_sym_AT] = ACTIONS(4846),
    [anon_sym_DOLLAR] = ACTIONS(4850),
    [anon_sym_POUND] = ACTIONS(4850),
    [anon_sym_DASH] = ACTIONS(4850),
    [anon_sym_0] = ACTIONS(4852),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4852),
    [anon_sym__] = ACTIONS(4852),
  },
  [1907] = {
    [aux_sym__literal_repeat1] = STATE(44),
    [sym_if_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_negated_command] = STATE(45),
    [sym_test_command] = STATE(45),
    [sym_variable_assignment] = STATE(46),
    [sym_subscript] = STATE(47),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(41),
    [sym_command_substitution] = STATE(41),
    [aux_sym__statements_repeat1] = STATE(48),
    [sym_redirected_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_subshell] = STATE(45),
    [sym_declaration_command] = STATE(45),
    [sym_unset_command] = STATE(45),
    [sym_file_redirect] = STATE(2037),
    [sym_string] = STATE(41),
    [sym_process_substitution] = STATE(41),
    [aux_sym_command_repeat1] = STATE(49),
    [sym__statements] = STATE(2038),
    [sym_c_style_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_case_statement] = STATE(45),
    [sym_pipeline] = STATE(45),
    [sym_list] = STATE(45),
    [sym_command] = STATE(45),
    [sym_command_name] = STATE(51),
    [sym_simple_expansion] = STATE(41),
    [sym_string_expansion] = STATE(41),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(145),
    [anon_sym_local] = ACTIONS(61),
    [anon_sym_typeset] = ACTIONS(61),
    [anon_sym_unsetenv] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(61),
    [sym__special_character] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(71),
    [anon_sym_declare] = ACTIONS(61),
    [sym_variable_name] = ACTIONS(73),
    [sym_file_descriptor] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_readonly] = ACTIONS(61),
    [anon_sym_unset] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1908] = {
    [aux_sym_concatenation_repeat1] = STATE(2032),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__concat] = ACTIONS(4844),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [anon_sym_esac] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [1909] = {
    [sym_subscript] = STATE(2039),
    [anon_sym_STAR] = ACTIONS(4854),
    [anon_sym_QMARK] = ACTIONS(4854),
    [anon_sym_BANG] = ACTIONS(4856),
    [anon_sym_AT] = ACTIONS(4854),
    [sym_variable_name] = ACTIONS(4858),
    [anon_sym_DOLLAR] = ACTIONS(4860),
    [anon_sym_DASH] = ACTIONS(4860),
    [anon_sym_0] = ACTIONS(4862),
    [anon_sym_POUND] = ACTIONS(4856),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4862),
    [anon_sym__] = ACTIONS(4862),
    [sym_comment] = ACTIONS(3),
  },
  [1910] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [anon_sym_esac] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [1911] = {
    [aux_sym__literal_repeat1] = STATE(2044),
    [anon_sym_AMP_GT_GT] = ACTIONS(1613),
    [anon_sym_DOLLAR] = ACTIONS(1613),
    [anon_sym_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1613),
    [anon_sym_PIPE_PIPE] = ACTIONS(1613),
    [sym_word] = ACTIONS(1613),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_LT_AMP] = ACTIONS(1613),
    [anon_sym_GT_GT] = ACTIONS(1613),
    [sym__special_character] = ACTIONS(4864),
    [anon_sym_LT_LT_DASH] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1613),
    [anon_sym_LF] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1613),
    [sym_raw_string] = ACTIONS(1613),
    [sym_variable_name] = ACTIONS(1617),
    [sym_file_descriptor] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1613),
    [anon_sym_AMP_GT] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_LT_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_AMP] = ACTIONS(1613),
    [anon_sym_LT_LPAREN] = ACTIONS(1613),
    [anon_sym_esac] = ACTIONS(1613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1613),
    [anon_sym_SEMI_SEMI] = ACTIONS(1613),
    [anon_sym_PIPE_AMP] = ACTIONS(1613),
  },
  [1912] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1639),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [sym_word] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_LT_AMP] = ACTIONS(1639),
    [anon_sym_GT_GT] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [anon_sym_EQ_TILDE] = ACTIONS(1639),
    [sym__special_character] = ACTIONS(1639),
    [anon_sym_LT_LT_DASH] = ACTIONS(1639),
    [anon_sym_BQUOTE] = ACTIONS(1639),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1639),
    [sym_raw_string] = ACTIONS(1639),
    [sym_file_descriptor] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_AMP_GT] = ACTIONS(1639),
    [anon_sym_EQ_EQ] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_LT_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_AMP] = ACTIONS(1639),
    [anon_sym_LT_LPAREN] = ACTIONS(1639),
    [anon_sym_esac] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [anon_sym_PIPE_AMP] = ACTIONS(1639),
  },
  [1913] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(4866),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1914] = {
    [sym_heredoc_redirect] = STATE(1757),
    [aux_sym_redirected_statement_repeat1] = STATE(1757),
    [sym_herestring_redirect] = STATE(1757),
    [sym_file_redirect] = STATE(1757),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_LF] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [sym_file_descriptor] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_esac] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
  },
  [1915] = {
    [sym_heredoc_redirect] = STATE(1757),
    [aux_sym_redirected_statement_repeat1] = STATE(1757),
    [sym_herestring_redirect] = STATE(1757),
    [sym_file_redirect] = STATE(1757),
    [anon_sym_AMP_GT_GT] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(1818),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1818),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1818),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_LT_AMP] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1818),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1820),
    [anon_sym_SEMI] = ACTIONS(1818),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(1820),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(1818),
    [anon_sym_GT_AMP] = ACTIONS(1818),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [anon_sym_esac] = ACTIONS(1818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1818),
    [anon_sym_SEMI_SEMI] = ACTIONS(1818),
    [anon_sym_PIPE_AMP] = ACTIONS(1818),
  },
  [1916] = {
    [aux_sym_concatenation_repeat1] = STATE(2046),
    [anon_sym_LT_LT_DASH] = ACTIONS(391),
    [anon_sym_AMP_GT_GT] = ACTIONS(391),
    [anon_sym_LF] = ACTIONS(389),
    [anon_sym_SEMI] = ACTIONS(391),
    [anon_sym_LT_LT] = ACTIONS(391),
    [sym_file_descriptor] = ACTIONS(389),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_AMP_GT] = ACTIONS(391),
    [anon_sym_PIPE_PIPE] = ACTIONS(391),
    [anon_sym_LT_LT_LT] = ACTIONS(391),
    [anon_sym_PIPE] = ACTIONS(391),
    [anon_sym_GT_AMP] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_esac] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_LT_AMP] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
    [sym__concat] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(391),
    [anon_sym_PIPE_AMP] = ACTIONS(391),
  },
  [1917] = {
    [aux_sym_concatenation_repeat1] = STATE(2046),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_esac] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [sym__concat] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [1918] = {
    [aux_sym__literal_repeat1] = STATE(2047),
    [anon_sym_LT_LT_DASH] = ACTIONS(415),
    [anon_sym_AMP_GT_GT] = ACTIONS(415),
    [anon_sym_LF] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [sym_file_descriptor] = ACTIONS(413),
    [anon_sym_GT] = ACTIONS(415),
    [anon_sym_AMP_GT] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_LT_LT_LT] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(415),
    [anon_sym_GT_AMP] = ACTIONS(415),
    [anon_sym_LT] = ACTIONS(415),
    [anon_sym_esac] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_LT_AMP] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(415),
    [anon_sym_PIPE_AMP] = ACTIONS(415),
  },
  [1919] = {
    [anon_sym_AMP] = ACTIONS(4868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(4870),
    [anon_sym_SEMI] = ACTIONS(4868),
    [anon_sym_SEMI_SEMI] = ACTIONS(1864),
    [anon_sym_esac] = ACTIONS(1864),
  },
  [1920] = {
    [sym_command_substitution] = STATE(2049),
    [aux_sym__literal_repeat1] = STATE(2050),
    [sym_string] = STATE(2049),
    [sym_process_substitution] = STATE(2049),
    [sym_simple_expansion] = STATE(2049),
    [sym_string_expansion] = STATE(2049),
    [sym_concatenation] = STATE(889),
    [sym_expansion] = STATE(2049),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(4872),
    [sym_raw_string] = ACTIONS(4872),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(898),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(4522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [1921] = {
    [sym_heredoc_redirect] = STATE(1757),
    [aux_sym_redirected_statement_repeat1] = STATE(1757),
    [sym_herestring_redirect] = STATE(1757),
    [sym_file_redirect] = STATE(1757),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_AMP_GT_GT] = ACTIONS(1878),
    [anon_sym_LF] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [sym_file_descriptor] = ACTIONS(1880),
    [anon_sym_GT] = ACTIONS(1878),
    [anon_sym_AMP_GT] = ACTIONS(1878),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_GT_AMP] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1878),
    [anon_sym_GT_GT] = ACTIONS(1878),
    [anon_sym_LT_AMP] = ACTIONS(1878),
    [anon_sym_AMP] = ACTIONS(1878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(4172),
  },
  [1922] = {
    [sym_heredoc_redirect] = STATE(1757),
    [aux_sym_redirected_statement_repeat1] = STATE(1757),
    [sym_herestring_redirect] = STATE(1757),
    [sym_file_redirect] = STATE(1757),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(1878),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1878),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_AMP] = ACTIONS(1878),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(1878),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(1880),
    [anon_sym_SEMI] = ACTIONS(1878),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(1878),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [anon_sym_esac] = ACTIONS(1878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1878),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_PIPE_AMP] = ACTIONS(4172),
  },
  [1923] = {
    [aux_sym_concatenation_repeat1] = STATE(2046),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LF] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1882),
    [sym_file_descriptor] = ACTIONS(1884),
    [anon_sym_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT_LT_LT] = ACTIONS(1882),
    [anon_sym_PIPE] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1882),
    [anon_sym_esac] = ACTIONS(1882),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1882),
    [sym__concat] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
  },
  [1924] = {
    [aux_sym__literal_repeat1] = STATE(2047),
    [anon_sym_LT_LT_DASH] = ACTIONS(1886),
    [anon_sym_AMP_GT_GT] = ACTIONS(1886),
    [anon_sym_LF] = ACTIONS(1888),
    [anon_sym_SEMI] = ACTIONS(1886),
    [anon_sym_LT_LT] = ACTIONS(1886),
    [sym_file_descriptor] = ACTIONS(1888),
    [anon_sym_GT] = ACTIONS(1886),
    [anon_sym_AMP_GT] = ACTIONS(1886),
    [anon_sym_PIPE_PIPE] = ACTIONS(1886),
    [anon_sym_LT_LT_LT] = ACTIONS(1886),
    [anon_sym_PIPE] = ACTIONS(1886),
    [anon_sym_GT_AMP] = ACTIONS(1886),
    [anon_sym_LT] = ACTIONS(1886),
    [anon_sym_esac] = ACTIONS(1886),
    [anon_sym_GT_GT] = ACTIONS(1886),
    [anon_sym_LT_AMP] = ACTIONS(1886),
    [anon_sym_AMP] = ACTIONS(1886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1886),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1886),
    [anon_sym_PIPE_AMP] = ACTIONS(1886),
  },
  [1925] = {
    [sym_heredoc_redirect] = STATE(1925),
    [aux_sym_redirected_statement_repeat1] = STATE(1925),
    [sym_herestring_redirect] = STATE(1925),
    [sym_file_redirect] = STATE(1925),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_AMP_GT_GT] = ACTIONS(4874),
    [anon_sym_LF] = ACTIONS(1896),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_LT_LT] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(4877),
    [anon_sym_GT] = ACTIONS(4874),
    [anon_sym_AMP_GT] = ACTIONS(4874),
    [anon_sym_PIPE_PIPE] = ACTIONS(1898),
    [anon_sym_LT_LT_LT] = ACTIONS(4880),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_GT_AMP] = ACTIONS(4874),
    [anon_sym_LT] = ACTIONS(4874),
    [anon_sym_esac] = ACTIONS(1898),
    [anon_sym_GT_GT] = ACTIONS(4874),
    [anon_sym_LT_AMP] = ACTIONS(4874),
    [anon_sym_AMP] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1898),
    [anon_sym_SEMI_SEMI] = ACTIONS(1898),
    [anon_sym_PIPE_AMP] = ACTIONS(1898),
  },
  [1926] = {
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [anon_sym_esac] = ACTIONS(1864),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
    [anon_sym_SEMI_SEMI] = ACTIONS(1866),
  },
  [1927] = {
    [sym_heredoc_body] = STATE(2051),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__simple_heredoc_body] = ACTIONS(910),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [sym__heredoc_body_beginning] = ACTIONS(912),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [anon_sym_esac] = ACTIONS(1864),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
    [anon_sym_SEMI_SEMI] = ACTIONS(1866),
  },
  [1928] = {
    [sym_command_substitution] = STATE(1762),
    [aux_sym__literal_repeat1] = STATE(1764),
    [sym_string] = STATE(1762),
    [sym_process_substitution] = STATE(1762),
    [sym_simple_expansion] = STATE(1762),
    [sym_string_expansion] = STATE(1762),
    [aux_sym_command_repeat2] = STATE(1932),
    [sym_concatenation] = STATE(1932),
    [sym_expansion] = STATE(1762),
    [anon_sym_AMP_GT_GT] = ACTIONS(1910),
    [anon_sym_DOLLAR] = ACTIONS(3664),
    [anon_sym_LT_LT] = ACTIONS(1910),
    [anon_sym_GT_LPAREN] = ACTIONS(4180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4184),
    [anon_sym_PIPE_PIPE] = ACTIONS(1910),
    [sym_word] = ACTIONS(4186),
    [anon_sym_PIPE] = ACTIONS(1910),
    [anon_sym_AMP] = ACTIONS(1910),
    [anon_sym_LT] = ACTIONS(1910),
    [anon_sym_LT_AMP] = ACTIONS(1910),
    [anon_sym_GT_GT] = ACTIONS(1910),
    [anon_sym_EQ_TILDE] = ACTIONS(4188),
    [sym__special_character] = ACTIONS(3674),
    [anon_sym_LT_LT_DASH] = ACTIONS(1910),
    [anon_sym_BQUOTE] = ACTIONS(4190),
    [anon_sym_LF] = ACTIONS(1912),
    [anon_sym_SEMI] = ACTIONS(1910),
    [sym_raw_string] = ACTIONS(4186),
    [sym_file_descriptor] = ACTIONS(1912),
    [anon_sym_GT] = ACTIONS(1910),
    [anon_sym_AMP_GT] = ACTIONS(1910),
    [anon_sym_EQ_EQ] = ACTIONS(4188),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_LT_LT_LT] = ACTIONS(1910),
    [anon_sym_GT_AMP] = ACTIONS(1910),
    [anon_sym_LT_LPAREN] = ACTIONS(4180),
    [anon_sym_esac] = ACTIONS(1910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1910),
    [anon_sym_SEMI_SEMI] = ACTIONS(1910),
    [anon_sym_PIPE_AMP] = ACTIONS(1910),
  },
  [1929] = {
    [aux_sym_concatenation_repeat1] = STATE(1742),
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(1914),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [sym_word] = ACTIONS(1914),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [sym__concat] = ACTIONS(4144),
    [anon_sym_EQ_TILDE] = ACTIONS(1914),
    [sym__special_character] = ACTIONS(1914),
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [sym_raw_string] = ACTIONS(1914),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1914),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(1914),
    [anon_sym_DQUOTE] = ACTIONS(1914),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [anon_sym_LT_LPAREN] = ACTIONS(1914),
    [anon_sym_esac] = ACTIONS(1914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [1930] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(1914),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1914),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1914),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [sym_word] = ACTIONS(1914),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [anon_sym_EQ_TILDE] = ACTIONS(1914),
    [sym__special_character] = ACTIONS(1914),
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [sym_raw_string] = ACTIONS(1914),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1914),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(1914),
    [anon_sym_DQUOTE] = ACTIONS(1914),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [anon_sym_LT_LPAREN] = ACTIONS(1914),
    [anon_sym_esac] = ACTIONS(1914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [1931] = {
    [aux_sym__literal_repeat1] = STATE(1749),
    [anon_sym_AMP_GT_GT] = ACTIONS(1918),
    [anon_sym_DOLLAR] = ACTIONS(1918),
    [anon_sym_LT_LT] = ACTIONS(1918),
    [anon_sym_GT_LPAREN] = ACTIONS(1918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1918),
    [anon_sym_PIPE_PIPE] = ACTIONS(1918),
    [sym_word] = ACTIONS(1918),
    [anon_sym_PIPE] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_LT_AMP] = ACTIONS(1918),
    [anon_sym_GT_GT] = ACTIONS(1918),
    [anon_sym_EQ_TILDE] = ACTIONS(1918),
    [sym__special_character] = ACTIONS(4158),
    [anon_sym_LT_LT_DASH] = ACTIONS(1918),
    [anon_sym_BQUOTE] = ACTIONS(1918),
    [anon_sym_LF] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1918),
    [sym_raw_string] = ACTIONS(1918),
    [sym_file_descriptor] = ACTIONS(1920),
    [anon_sym_GT] = ACTIONS(1918),
    [anon_sym_AMP_GT] = ACTIONS(1918),
    [anon_sym_EQ_EQ] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1918),
    [anon_sym_LT_LT_LT] = ACTIONS(1918),
    [anon_sym_GT_AMP] = ACTIONS(1918),
    [anon_sym_LT_LPAREN] = ACTIONS(1918),
    [anon_sym_esac] = ACTIONS(1918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_SEMI_SEMI] = ACTIONS(1918),
    [anon_sym_PIPE_AMP] = ACTIONS(1918),
  },
  [1932] = {
    [sym_command_substitution] = STATE(1762),
    [aux_sym__literal_repeat1] = STATE(1764),
    [sym_string] = STATE(1762),
    [sym_process_substitution] = STATE(1762),
    [sym_simple_expansion] = STATE(1762),
    [sym_string_expansion] = STATE(1762),
    [aux_sym_command_repeat2] = STATE(1932),
    [sym_concatenation] = STATE(1932),
    [sym_expansion] = STATE(1762),
    [anon_sym_AMP_GT_GT] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(4883),
    [anon_sym_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_LPAREN] = ACTIONS(4886),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4892),
    [anon_sym_PIPE_PIPE] = ACTIONS(1914),
    [sym_word] = ACTIONS(4895),
    [anon_sym_PIPE] = ACTIONS(1914),
    [anon_sym_AMP] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_LT_AMP] = ACTIONS(1914),
    [anon_sym_GT_GT] = ACTIONS(1914),
    [anon_sym_EQ_TILDE] = ACTIONS(4898),
    [sym__special_character] = ACTIONS(4901),
    [anon_sym_LT_LT_DASH] = ACTIONS(1914),
    [anon_sym_BQUOTE] = ACTIONS(4904),
    [anon_sym_LF] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [sym_raw_string] = ACTIONS(4895),
    [sym_file_descriptor] = ACTIONS(1916),
    [anon_sym_GT] = ACTIONS(1914),
    [anon_sym_AMP_GT] = ACTIONS(1914),
    [anon_sym_EQ_EQ] = ACTIONS(4898),
    [anon_sym_DQUOTE] = ACTIONS(4907),
    [anon_sym_LT_LT_LT] = ACTIONS(1914),
    [anon_sym_GT_AMP] = ACTIONS(1914),
    [anon_sym_LT_LPAREN] = ACTIONS(4886),
    [anon_sym_esac] = ACTIONS(1914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1914),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
    [anon_sym_PIPE_AMP] = ACTIONS(1914),
  },
  [1933] = {
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [sym_word] = ACTIONS(4912),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_esac] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [sym__special_character] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
  },
  [1934] = {
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [sym_word] = ACTIONS(4918),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(4916),
    [anon_sym_esac] = ACTIONS(4920),
    [anon_sym_DOLLAR] = ACTIONS(4918),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [sym__special_character] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
  },
  [1935] = {
    [anon_sym_BQUOTE] = ACTIONS(4152),
    [anon_sym_DQUOTE] = ACTIONS(4152),
    [sym_word] = ACTIONS(4152),
    [sym_raw_string] = ACTIONS(4152),
    [anon_sym_LT_LPAREN] = ACTIONS(4152),
    [anon_sym_DOLLAR] = ACTIONS(4154),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4152),
    [sym__special_character] = ACTIONS(4152),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4152),
  },
  [1936] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_AMP_GT_GT] = ACTIONS(609),
    [anon_sym_LF] = ACTIONS(4922),
    [anon_sym_SEMI] = ACTIONS(4924),
    [sym_file_descriptor] = ACTIONS(615),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_AMP_GT] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_LT_LT_LT] = ACTIONS(619),
    [anon_sym_GT_AMP] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(4924),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_AMP] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_PIPE] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
  },
  [1937] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(4924),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(4922),
    [anon_sym_SEMI] = ACTIONS(4924),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(619),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(367),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
  },
  [1938] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(2054),
    [sym_function_definition] = STATE(2054),
    [sym_negated_command] = STATE(2054),
    [sym_test_command] = STATE(2054),
    [sym_variable_assignment] = STATE(2055),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(195),
    [sym_redirected_statement] = STATE(2054),
    [sym_for_statement] = STATE(2054),
    [sym_compound_statement] = STATE(2054),
    [sym_subshell] = STATE(2054),
    [sym_declaration_command] = STATE(2054),
    [sym_unset_command] = STATE(2054),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym_c_style_for_statement] = STATE(2054),
    [sym_while_statement] = STATE(2054),
    [sym_case_statement] = STATE(2054),
    [sym_pipeline] = STATE(2054),
    [sym_list] = STATE(2054),
    [sym_command] = STATE(2054),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [1939] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(4926),
  },
  [1940] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(1936),
    [sym_function_definition] = STATE(1936),
    [sym_negated_command] = STATE(1936),
    [sym_test_command] = STATE(1936),
    [sym_variable_assignment] = STATE(1937),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1938),
    [sym_redirected_statement] = STATE(1936),
    [sym_for_statement] = STATE(1936),
    [sym_compound_statement] = STATE(1936),
    [sym_subshell] = STATE(1936),
    [sym_declaration_command] = STATE(1936),
    [sym_unset_command] = STATE(1936),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym__statements] = STATE(2057),
    [sym_c_style_for_statement] = STATE(1936),
    [sym_while_statement] = STATE(1936),
    [sym_case_statement] = STATE(1936),
    [sym_pipeline] = STATE(1936),
    [sym_list] = STATE(1936),
    [sym_command] = STATE(1936),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(4926),
  },
  [1941] = {
    [anon_sym_BQUOTE] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(4197),
    [sym_word] = ACTIONS(4197),
    [sym_raw_string] = ACTIONS(4197),
    [anon_sym_LT_LPAREN] = ACTIONS(4197),
    [anon_sym_DOLLAR] = ACTIONS(4199),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4197),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4197),
    [sym__special_character] = ACTIONS(4197),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4197),
  },
  [1942] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(4928),
  },
  [1943] = {
    [aux_sym__literal_repeat1] = STATE(108),
    [sym_if_statement] = STATE(1936),
    [sym_function_definition] = STATE(1936),
    [sym_negated_command] = STATE(1936),
    [sym_test_command] = STATE(1936),
    [sym_variable_assignment] = STATE(1937),
    [sym_subscript] = STATE(111),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(104),
    [sym_command_substitution] = STATE(104),
    [aux_sym__statements_repeat1] = STATE(1938),
    [sym_redirected_statement] = STATE(1936),
    [sym_for_statement] = STATE(1936),
    [sym_compound_statement] = STATE(1936),
    [sym_subshell] = STATE(1936),
    [sym_declaration_command] = STATE(1936),
    [sym_unset_command] = STATE(1936),
    [sym_file_redirect] = STATE(113),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [aux_sym_command_repeat1] = STATE(113),
    [sym__statements] = STATE(2059),
    [sym_c_style_for_statement] = STATE(1936),
    [sym_while_statement] = STATE(1936),
    [sym_case_statement] = STATE(1936),
    [sym_pipeline] = STATE(1936),
    [sym_list] = STATE(1936),
    [sym_command] = STATE(1936),
    [sym_command_name] = STATE(114),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(171),
    [anon_sym_typeset] = ACTIONS(171),
    [anon_sym_unsetenv] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(175),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(171),
    [sym__special_character] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(179),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(181),
    [anon_sym_declare] = ACTIONS(171),
    [sym_variable_name] = ACTIONS(183),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(171),
    [anon_sym_unset] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [anon_sym_SEMI_SEMI] = ACTIONS(4928),
  },
  [1944] = {
    [anon_sym_BQUOTE] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [sym_word] = ACTIONS(3553),
    [sym_raw_string] = ACTIONS(3553),
    [sym__concat] = ACTIONS(3553),
    [anon_sym_LT_LPAREN] = ACTIONS(3553),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_RPAREN] = ACTIONS(3553),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3553),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3553),
    [sym__special_character] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3553),
  },
  [1945] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4930),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1946] = {
    [anon_sym_BQUOTE] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3587),
    [sym_word] = ACTIONS(3587),
    [sym_raw_string] = ACTIONS(3587),
    [sym__concat] = ACTIONS(3587),
    [anon_sym_LT_LPAREN] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_RPAREN] = ACTIONS(3587),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3587),
    [sym__special_character] = ACTIONS(3587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3587),
  },
  [1947] = {
    [anon_sym_BQUOTE] = ACTIONS(3591),
    [anon_sym_DQUOTE] = ACTIONS(3591),
    [sym_word] = ACTIONS(3591),
    [sym_raw_string] = ACTIONS(3591),
    [sym__concat] = ACTIONS(3591),
    [anon_sym_LT_LPAREN] = ACTIONS(3591),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_RPAREN] = ACTIONS(3591),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3591),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3591),
    [sym__special_character] = ACTIONS(3591),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3591),
  },
  [1948] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4932),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1949] = {
    [anon_sym_BQUOTE] = ACTIONS(3642),
    [anon_sym_DQUOTE] = ACTIONS(3642),
    [sym_word] = ACTIONS(3642),
    [sym_raw_string] = ACTIONS(3642),
    [sym__concat] = ACTIONS(3642),
    [anon_sym_LT_LPAREN] = ACTIONS(3642),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_RPAREN] = ACTIONS(3642),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(3642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3642),
    [sym__special_character] = ACTIONS(3642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3642),
  },
  [1950] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [sym_word] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [sym__special_character] = ACTIONS(4034),
    [anon_sym_LT_LT_DASH] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4034),
    [sym_raw_string] = ACTIONS(4034),
    [sym_variable_name] = ACTIONS(4036),
    [sym_file_descriptor] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [ts_builtin_sym_end] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
  },
  [1951] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [sym__special_character] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [sym_variable_name] = ACTIONS(4040),
    [sym_file_descriptor] = ACTIONS(4040),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [ts_builtin_sym_end] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
  },
  [1952] = {
    [anon_sym_BQUOTE] = ACTIONS(3551),
    [sym_raw_string] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3551),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_GT_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [sym_word] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LT_LPAREN] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
  },
  [1953] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1954] = {
    [anon_sym_BQUOTE] = ACTIONS(3585),
    [sym_raw_string] = ACTIONS(3585),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_GT_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [sym_word] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LT_LPAREN] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
  },
  [1955] = {
    [anon_sym_BQUOTE] = ACTIONS(3589),
    [sym_raw_string] = ACTIONS(3589),
    [anon_sym_LF] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_GT_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [sym_word] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_LT_LPAREN] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
  },
  [1956] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4936),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1957] = {
    [anon_sym_BQUOTE] = ACTIONS(3640),
    [sym_raw_string] = ACTIONS(3640),
    [anon_sym_LF] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_GT_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3640),
    [anon_sym_DQUOTE] = ACTIONS(3640),
    [sym_word] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [anon_sym_AMP] = ACTIONS(3640),
    [anon_sym_LT_LPAREN] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
  },
  [1958] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4938),
    [anon_sym_BQUOTE] = ACTIONS(4938),
    [anon_sym_AMP_GT_GT] = ACTIONS(4938),
    [anon_sym_LF] = ACTIONS(4940),
    [anon_sym_SEMI] = ACTIONS(4938),
    [anon_sym_LT_LT] = ACTIONS(4938),
    [sym_file_descriptor] = ACTIONS(4940),
    [anon_sym_GT] = ACTIONS(4938),
    [anon_sym_RPAREN] = ACTIONS(4938),
    [anon_sym_AMP_GT] = ACTIONS(4938),
    [anon_sym_PIPE_PIPE] = ACTIONS(4938),
    [ts_builtin_sym_end] = ACTIONS(4940),
    [anon_sym_LT_LT_LT] = ACTIONS(4938),
    [anon_sym_PIPE] = ACTIONS(4938),
    [anon_sym_GT_AMP] = ACTIONS(4938),
    [anon_sym_LT] = ACTIONS(4938),
    [anon_sym_LT_AMP] = ACTIONS(4938),
    [anon_sym_GT_GT] = ACTIONS(4938),
    [anon_sym_AMP] = ACTIONS(4938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(4938),
    [anon_sym_AMP_AMP] = ACTIONS(4938),
    [anon_sym_SEMI_SEMI] = ACTIONS(4938),
    [anon_sym_PIPE_AMP] = ACTIONS(4938),
  },
  [1959] = {
    [anon_sym_BANG_EQ] = ACTIONS(4034),
    [anon_sym_PLUS_EQ] = ACTIONS(4034),
    [sym_test_operator] = ACTIONS(4036),
    [anon_sym_LF] = ACTIONS(4034),
    [anon_sym_SEMI] = ACTIONS(4034),
    [anon_sym_PLUS_PLUS] = ACTIONS(4034),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_EQ] = ACTIONS(4034),
    [anon_sym_EQ_EQ] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [anon_sym_GT_EQ] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(4034),
    [anon_sym_DASH_DASH] = ACTIONS(4034),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_LT_EQ] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
    [anon_sym_DASH_EQ] = ACTIONS(4034),
  },
  [1960] = {
    [anon_sym_BANG_EQ] = ACTIONS(4038),
    [anon_sym_PLUS_EQ] = ACTIONS(4038),
    [sym_test_operator] = ACTIONS(4040),
    [anon_sym_LF] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_PLUS_PLUS] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_EQ] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_PLUS] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(4038),
    [anon_sym_DASH_DASH] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_DASH_EQ] = ACTIONS(4038),
  },
  [1961] = {
    [sym_do_group] = STATE(2064),
    [sym_compound_statement] = STATE(2064),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(839),
  },
  [1962] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4034),
    [sym_file_descriptor] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_RPAREN] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [ts_builtin_sym_end] = ACTIONS(4036),
    [anon_sym_LT_LT_LT] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
  },
  [1963] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [sym_file_descriptor] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [ts_builtin_sym_end] = ACTIONS(4040),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_esac] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
  },
  [1964] = {
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_BQUOTE] = ACTIONS(3553),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3553),
    [sym__heredoc_body_end] = ACTIONS(3553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3553),
    [sym__heredoc_body_middle] = ACTIONS(3553),
  },
  [1965] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4942),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1966] = {
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_BQUOTE] = ACTIONS(3587),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3587),
    [sym__heredoc_body_end] = ACTIONS(3587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3587),
    [sym__heredoc_body_middle] = ACTIONS(3587),
  },
  [1967] = {
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(3591),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3591),
    [sym__heredoc_body_end] = ACTIONS(3591),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3591),
    [sym__heredoc_body_middle] = ACTIONS(3591),
  },
  [1968] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4944),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1969] = {
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(3642),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3642),
    [sym__heredoc_body_end] = ACTIONS(3642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3642),
    [sym__heredoc_body_middle] = ACTIONS(3642),
  },
  [1970] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
  },
  [1971] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
  },
  [1972] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1288),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE_PIPE] = ACTIONS(1288),
    [sym_word] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_LT_AMP] = ACTIONS(1288),
    [anon_sym_GT_GT] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [sym__special_character] = ACTIONS(1288),
    [anon_sym_LT_LT_DASH] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LF] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1288),
    [sym_raw_string] = ACTIONS(1288),
    [sym_variable_name] = ACTIONS(1290),
    [sym_file_descriptor] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_AMP_GT] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_LT_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_AMP] = ACTIONS(1288),
    [anon_sym_LT_LPAREN] = ACTIONS(1288),
    [anon_sym_esac] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
    [anon_sym_PIPE_AMP] = ACTIONS(1288),
  },
  [1973] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1639),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1639),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [sym_word] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_LT_AMP] = ACTIONS(1639),
    [anon_sym_GT_GT] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [sym__special_character] = ACTIONS(1639),
    [anon_sym_LT_LT_DASH] = ACTIONS(1639),
    [anon_sym_BQUOTE] = ACTIONS(1639),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1639),
    [sym_raw_string] = ACTIONS(1639),
    [sym_variable_name] = ACTIONS(1641),
    [sym_file_descriptor] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_AMP_GT] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_LT_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_AMP] = ACTIONS(1639),
    [anon_sym_LT_LPAREN] = ACTIONS(1639),
    [anon_sym_esac] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [anon_sym_PIPE_AMP] = ACTIONS(1639),
  },
  [1974] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(4946),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1975] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [anon_sym_esac] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1976] = {
    [sym_command_substitution] = STATE(1975),
    [sym_simple_expansion] = STATE(1975),
    [sym_string_expansion] = STATE(1975),
    [sym_string] = STATE(1975),
    [sym_process_substitution] = STATE(1975),
    [sym_expansion] = STATE(1975),
    [anon_sym_BQUOTE] = ACTIONS(4646),
    [anon_sym_DQUOTE] = ACTIONS(4405),
    [sym_word] = ACTIONS(4648),
    [sym_raw_string] = ACTIONS(4648),
    [anon_sym_LT_LPAREN] = ACTIONS(4650),
    [anon_sym_DOLLAR] = ACTIONS(4948),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4652),
    [sym__special_character] = ACTIONS(4648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4654),
  },
  [1977] = {
    [aux_sym_concatenation_repeat1] = STATE(1977),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(4950),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [anon_sym_esac] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1978] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1282),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [sym_word] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_LT_AMP] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [sym__special_character] = ACTIONS(1282),
    [anon_sym_LT_LT_DASH] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_LF] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [sym_raw_string] = ACTIONS(1282),
    [sym_variable_name] = ACTIONS(1284),
    [sym_file_descriptor] = ACTIONS(1284),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_AMP_GT] = ACTIONS(1282),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_LT_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_AMP] = ACTIONS(1282),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [anon_sym_esac] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
    [anon_sym_PIPE_AMP] = ACTIONS(1282),
  },
  [1979] = {
    [sym_command_substitution] = STATE(753),
    [aux_sym__literal_repeat1] = STATE(760),
    [sym_string] = STATE(753),
    [sym_process_substitution] = STATE(753),
    [aux_sym_for_statement_repeat1] = STATE(2070),
    [sym_simple_expansion] = STATE(753),
    [sym_string_expansion] = STATE(753),
    [sym_concatenation] = STATE(2070),
    [sym_expansion] = STATE(753),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(1571),
    [sym_raw_string] = ACTIONS(1571),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(4953),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [1980] = {
    [aux_sym_concatenation_repeat1] = STATE(1852),
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__concat] = ACTIONS(4401),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [anon_sym_esac] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [1981] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(1589),
    [anon_sym_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_LPAREN] = ACTIONS(1589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1589),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [sym_word] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_LT_AMP] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [sym__special_character] = ACTIONS(1589),
    [anon_sym_LT_LT_DASH] = ACTIONS(1589),
    [anon_sym_BQUOTE] = ACTIONS(1589),
    [anon_sym_LF] = ACTIONS(1593),
    [anon_sym_SEMI] = ACTIONS(1589),
    [sym_raw_string] = ACTIONS(1589),
    [sym_variable_name] = ACTIONS(1593),
    [sym_file_descriptor] = ACTIONS(1593),
    [anon_sym_GT] = ACTIONS(1589),
    [anon_sym_AMP_GT] = ACTIONS(1589),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_LT_LT_LT] = ACTIONS(1589),
    [anon_sym_GT_AMP] = ACTIONS(1589),
    [anon_sym_LT_LPAREN] = ACTIONS(1589),
    [anon_sym_esac] = ACTIONS(1589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1589),
    [anon_sym_SEMI_SEMI] = ACTIONS(1589),
    [anon_sym_PIPE_AMP] = ACTIONS(1589),
  },
  [1982] = {
    [aux_sym__literal_repeat1] = STATE(1865),
    [anon_sym_AMP_GT_GT] = ACTIONS(1613),
    [anon_sym_DOLLAR] = ACTIONS(1613),
    [anon_sym_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_LPAREN] = ACTIONS(1613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1613),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1613),
    [anon_sym_PIPE_PIPE] = ACTIONS(1613),
    [sym_word] = ACTIONS(1613),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_LT_AMP] = ACTIONS(1613),
    [anon_sym_GT_GT] = ACTIONS(1613),
    [sym__special_character] = ACTIONS(4425),
    [anon_sym_LT_LT_DASH] = ACTIONS(1613),
    [anon_sym_BQUOTE] = ACTIONS(1613),
    [anon_sym_LF] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1613),
    [sym_raw_string] = ACTIONS(1613),
    [sym_variable_name] = ACTIONS(1617),
    [sym_file_descriptor] = ACTIONS(1617),
    [anon_sym_GT] = ACTIONS(1613),
    [anon_sym_AMP_GT] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_LT_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_AMP] = ACTIONS(1613),
    [anon_sym_LT_LPAREN] = ACTIONS(1613),
    [anon_sym_esac] = ACTIONS(1613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1613),
    [anon_sym_SEMI_SEMI] = ACTIONS(1613),
    [anon_sym_PIPE_AMP] = ACTIONS(1613),
  },
  [1983] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2073),
    [sym_concatenation] = STATE(2073),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4959),
    [anon_sym_COLON_DASH] = ACTIONS(4955),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4961),
  },
  [1984] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1324),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [sym_word] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_LT_AMP] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [sym__special_character] = ACTIONS(1324),
    [anon_sym_LT_LT_DASH] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [anon_sym_LF] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_raw_string] = ACTIONS(1324),
    [sym_variable_name] = ACTIONS(1326),
    [sym_file_descriptor] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_AMP_GT] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_LT_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_AMP] = ACTIONS(1324),
    [anon_sym_LT_LPAREN] = ACTIONS(1324),
    [anon_sym_esac] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
    [anon_sym_PIPE_AMP] = ACTIONS(1324),
  },
  [1985] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1986] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2073),
    [sym_concatenation] = STATE(2073),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(4963),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_DASH] = ACTIONS(4955),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4955),
    [anon_sym_PERCENT] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4959),
    [anon_sym_COLON_DASH] = ACTIONS(4955),
    [sym__special_character] = ACTIONS(553),
  },
  [1987] = {
    [anon_sym_EQ] = ACTIONS(4965),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [1988] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2078),
    [sym_concatenation] = STATE(2078),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(4967),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4969),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4971),
    [anon_sym_DASH] = ACTIONS(4969),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4969),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4969),
    [anon_sym_PERCENT] = ACTIONS(4969),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4973),
    [anon_sym_COLON_DASH] = ACTIONS(4969),
    [sym__special_character] = ACTIONS(553),
  },
  [1989] = {
    [sym_command_substitution] = STATE(2079),
    [aux_sym__literal_repeat1] = STATE(2080),
    [sym_string] = STATE(2079),
    [sym_process_substitution] = STATE(2079),
    [sym_simple_expansion] = STATE(2079),
    [sym_string_expansion] = STATE(2079),
    [sym_concatenation] = STATE(2081),
    [sym_expansion] = STATE(2079),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(4975),
    [sym_raw_string] = ACTIONS(4975),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [1990] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2084),
    [sym_concatenation] = STATE(2084),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4977),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4979),
    [anon_sym_DASH] = ACTIONS(4977),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4977),
    [anon_sym_PERCENT] = ACTIONS(4977),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4981),
    [anon_sym_COLON_DASH] = ACTIONS(4977),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4983),
  },
  [1991] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym_word] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [sym_variable_name] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_esac] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
  },
  [1992] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4979),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [1993] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1288),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE_PIPE] = ACTIONS(1288),
    [sym_word] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_LT_AMP] = ACTIONS(1288),
    [anon_sym_GT_GT] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [sym__special_character] = ACTIONS(1288),
    [anon_sym_LT_LT_DASH] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LF] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1288),
    [sym_raw_string] = ACTIONS(1288),
    [sym_file_descriptor] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_AMP_GT] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_LT_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_AMP] = ACTIONS(1288),
    [anon_sym_LT_LPAREN] = ACTIONS(1288),
    [anon_sym_esac] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
    [anon_sym_PIPE_AMP] = ACTIONS(1288),
  },
  [1994] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1639),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1639),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [sym_word] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_LT_AMP] = ACTIONS(1639),
    [anon_sym_GT_GT] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [sym__special_character] = ACTIONS(1639),
    [anon_sym_LT_LT_DASH] = ACTIONS(1639),
    [anon_sym_BQUOTE] = ACTIONS(1639),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1639),
    [sym_raw_string] = ACTIONS(1639),
    [sym_file_descriptor] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_AMP_GT] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_LT_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_AMP] = ACTIONS(1639),
    [anon_sym_LT_LPAREN] = ACTIONS(1639),
    [anon_sym_esac] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [anon_sym_PIPE_AMP] = ACTIONS(1639),
  },
  [1995] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(4985),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [1996] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [anon_sym_esac] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1997] = {
    [sym_command_substitution] = STATE(1996),
    [sym_simple_expansion] = STATE(1996),
    [sym_string_expansion] = STATE(1996),
    [sym_string] = STATE(1996),
    [sym_process_substitution] = STATE(1996),
    [sym_expansion] = STATE(1996),
    [anon_sym_BQUOTE] = ACTIONS(4733),
    [anon_sym_DQUOTE] = ACTIONS(4435),
    [sym_word] = ACTIONS(4735),
    [sym_raw_string] = ACTIONS(4735),
    [anon_sym_LT_LPAREN] = ACTIONS(4737),
    [anon_sym_DOLLAR] = ACTIONS(4987),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4737),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4739),
    [sym__special_character] = ACTIONS(4735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4741),
  },
  [1998] = {
    [aux_sym_concatenation_repeat1] = STATE(1998),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(4989),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [anon_sym_esac] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [1999] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1282),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [sym_word] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_LT_AMP] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [sym__special_character] = ACTIONS(1282),
    [anon_sym_LT_LT_DASH] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_LF] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [sym_raw_string] = ACTIONS(1282),
    [sym_file_descriptor] = ACTIONS(1284),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_AMP_GT] = ACTIONS(1282),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_LT_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_AMP] = ACTIONS(1282),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [anon_sym_esac] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
    [anon_sym_PIPE_AMP] = ACTIONS(1282),
  },
  [2000] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2089),
    [sym_concatenation] = STATE(2089),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4992),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(4992),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4992),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4992),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4996),
    [anon_sym_COLON_DASH] = ACTIONS(4992),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(4998),
  },
  [2001] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1324),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [sym_word] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_LT_AMP] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [sym__special_character] = ACTIONS(1324),
    [anon_sym_LT_LT_DASH] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [anon_sym_LF] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_raw_string] = ACTIONS(1324),
    [sym_file_descriptor] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_AMP_GT] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_LT_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_AMP] = ACTIONS(1324),
    [anon_sym_LT_LPAREN] = ACTIONS(1324),
    [anon_sym_esac] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
    [anon_sym_PIPE_AMP] = ACTIONS(1324),
  },
  [2002] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2003] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2089),
    [sym_concatenation] = STATE(2089),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(5000),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(4992),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(4992),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(4992),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(4992),
    [anon_sym_PERCENT] = ACTIONS(4992),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4996),
    [anon_sym_COLON_DASH] = ACTIONS(4992),
    [sym__special_character] = ACTIONS(553),
  },
  [2004] = {
    [anon_sym_EQ] = ACTIONS(5002),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [2005] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2094),
    [sym_concatenation] = STATE(2094),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(5004),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5006),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5008),
    [anon_sym_DASH] = ACTIONS(5006),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5006),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5010),
    [anon_sym_COLON_DASH] = ACTIONS(5006),
    [sym__special_character] = ACTIONS(553),
  },
  [2006] = {
    [sym_command_substitution] = STATE(2095),
    [aux_sym__literal_repeat1] = STATE(2096),
    [sym_string] = STATE(2095),
    [sym_process_substitution] = STATE(2095),
    [sym_simple_expansion] = STATE(2095),
    [sym_string_expansion] = STATE(2095),
    [sym_concatenation] = STATE(2097),
    [sym_expansion] = STATE(2095),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(5012),
    [sym_raw_string] = ACTIONS(5012),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4994),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [2007] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2100),
    [sym_concatenation] = STATE(2100),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5014),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5016),
    [anon_sym_DASH] = ACTIONS(5014),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5014),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5014),
    [anon_sym_PERCENT] = ACTIONS(5014),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5018),
    [anon_sym_COLON_DASH] = ACTIONS(5014),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(5020),
  },
  [2008] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym_word] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_esac] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
  },
  [2009] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5016),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2010] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [sym_word] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_LT_AMP] = ACTIONS(2109),
    [anon_sym_GT_GT] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [anon_sym_EQ_TILDE] = ACTIONS(2109),
    [sym__special_character] = ACTIONS(2109),
    [anon_sym_LT_LT_DASH] = ACTIONS(2109),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [anon_sym_LF] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [sym_raw_string] = ACTIONS(2109),
    [sym_file_descriptor] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_AMP_GT] = ACTIONS(2109),
    [anon_sym_EQ_EQ] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [anon_sym_LT_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_AMP] = ACTIONS(2109),
    [anon_sym_LT_LPAREN] = ACTIONS(2109),
    [anon_sym_esac] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
    [anon_sym_PIPE_AMP] = ACTIONS(2109),
  },
  [2011] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2102),
    [sym_concatenation] = STATE(2102),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5022),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5024),
    [anon_sym_DASH] = ACTIONS(5022),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5022),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5022),
    [anon_sym_PERCENT] = ACTIONS(5022),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5026),
    [anon_sym_COLON_DASH] = ACTIONS(5022),
    [sym__special_character] = ACTIONS(553),
  },
  [2012] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5024),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2013] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2102),
    [sym_concatenation] = STATE(2102),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5022),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5024),
    [anon_sym_DASH] = ACTIONS(5022),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5022),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5022),
    [anon_sym_PERCENT] = ACTIONS(5022),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5026),
    [anon_sym_COLON_DASH] = ACTIONS(5022),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(5028),
  },
  [2014] = {
    [sym_command_substitution] = STATE(2104),
    [aux_sym__literal_repeat1] = STATE(2105),
    [sym_string] = STATE(2104),
    [sym_process_substitution] = STATE(2104),
    [sym_simple_expansion] = STATE(2104),
    [sym_string_expansion] = STATE(2104),
    [sym_concatenation] = STATE(2106),
    [sym_expansion] = STATE(2104),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(5030),
    [sym_raw_string] = ACTIONS(5030),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5024),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [2015] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2109),
    [sym_concatenation] = STATE(2109),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5032),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5034),
    [anon_sym_DASH] = ACTIONS(5032),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5032),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5032),
    [anon_sym_PERCENT] = ACTIONS(5032),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5036),
    [anon_sym_COLON_DASH] = ACTIONS(5032),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(5038),
  },
  [2016] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [anon_sym_EQ_TILDE] = ACTIONS(2205),
    [sym__special_character] = ACTIONS(2205),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [sym_file_descriptor] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [anon_sym_esac] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
  },
  [2017] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5034),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2018] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5024),
    [sym__concat] = ACTIONS(2213),
  },
  [2019] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(5040),
  },
  [2020] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5024),
  },
  [2021] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2247),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2247),
    [sym_word] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_LT_AMP] = ACTIONS(2247),
    [anon_sym_GT_GT] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [anon_sym_EQ_TILDE] = ACTIONS(2247),
    [sym__special_character] = ACTIONS(2247),
    [anon_sym_LT_LT_DASH] = ACTIONS(2247),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [sym_raw_string] = ACTIONS(2247),
    [sym_file_descriptor] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_AMP_GT] = ACTIONS(2247),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_LT_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_AMP] = ACTIONS(2247),
    [anon_sym_LT_LPAREN] = ACTIONS(2247),
    [anon_sym_esac] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
    [anon_sym_PIPE_AMP] = ACTIONS(2247),
  },
  [2022] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2112),
    [sym_concatenation] = STATE(2112),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5042),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5044),
    [anon_sym_DASH] = ACTIONS(5042),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5042),
    [anon_sym_PERCENT] = ACTIONS(5042),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5046),
    [anon_sym_COLON_DASH] = ACTIONS(5042),
    [sym__special_character] = ACTIONS(553),
  },
  [2023] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5044),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2024] = {
    [sym_string] = STATE(1732),
    [anon_sym__] = ACTIONS(4132),
    [anon_sym_AMP_GT_GT] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(5048),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(5048),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4132),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [sym_word] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_LT_AMP] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(4132),
    [anon_sym_EQ_TILDE] = ACTIONS(2261),
    [sym__special_character] = ACTIONS(2261),
    [anon_sym_LT_LT_DASH] = ACTIONS(2261),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(4132),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(5050),
    [anon_sym_BANG] = ACTIONS(5048),
    [sym_file_descriptor] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(4132),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_AMP_GT] = ACTIONS(2261),
    [anon_sym_EQ_EQ] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_LT_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_AMP] = ACTIONS(2261),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_esac] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(4132),
    [anon_sym_POUND] = ACTIONS(5048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_PIPE_AMP] = ACTIONS(2261),
  },
  [2025] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2467),
    [anon_sym_DOLLAR] = ACTIONS(2467),
    [anon_sym_LT_LT] = ACTIONS(2467),
    [anon_sym_GT_LPAREN] = ACTIONS(2467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE] = ACTIONS(2467),
    [sym_word] = ACTIONS(2467),
    [anon_sym_PIPE] = ACTIONS(2467),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_LT_AMP] = ACTIONS(2467),
    [anon_sym_GT_GT] = ACTIONS(2467),
    [sym__special_character] = ACTIONS(2467),
    [anon_sym_LT_LT_DASH] = ACTIONS(2467),
    [anon_sym_BQUOTE] = ACTIONS(2467),
    [anon_sym_LF] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2467),
    [sym_raw_string] = ACTIONS(2467),
    [sym_variable_name] = ACTIONS(2469),
    [sym_file_descriptor] = ACTIONS(2469),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_AMP_GT] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [anon_sym_LT_LT_LT] = ACTIONS(2467),
    [anon_sym_GT_AMP] = ACTIONS(2467),
    [anon_sym_LT_LPAREN] = ACTIONS(2467),
    [anon_sym_esac] = ACTIONS(2467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2467),
    [anon_sym_SEMI_SEMI] = ACTIONS(2467),
    [anon_sym_PIPE_AMP] = ACTIONS(2467),
  },
  [2026] = {
    [sym_command_substitution] = STATE(753),
    [aux_sym__literal_repeat1] = STATE(760),
    [sym_string] = STATE(753),
    [sym_process_substitution] = STATE(753),
    [aux_sym_for_statement_repeat1] = STATE(1097),
    [sym_simple_expansion] = STATE(753),
    [sym_string_expansion] = STATE(753),
    [sym_concatenation] = STATE(1097),
    [sym_expansion] = STATE(753),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(1571),
    [sym_raw_string] = ACTIONS(1571),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(5052),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [2027] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(5054),
  },
  [2028] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(5056),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [2029] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(787),
    [anon_sym_LT_LT] = ACTIONS(787),
    [anon_sym_GT_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(787),
    [anon_sym_PIPE_PIPE] = ACTIONS(787),
    [sym_word] = ACTIONS(787),
    [anon_sym_PIPE] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(787),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_LT_AMP] = ACTIONS(787),
    [anon_sym_GT_GT] = ACTIONS(787),
    [sym__concat] = ACTIONS(789),
    [sym__special_character] = ACTIONS(787),
    [anon_sym_LT_LT_DASH] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(787),
    [anon_sym_LF] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [sym_raw_string] = ACTIONS(787),
    [sym_variable_name] = ACTIONS(789),
    [sym_file_descriptor] = ACTIONS(789),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_AMP_GT] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(787),
    [anon_sym_LT_LT_LT] = ACTIONS(787),
    [anon_sym_GT_AMP] = ACTIONS(787),
    [anon_sym_LT_LPAREN] = ACTIONS(787),
    [anon_sym_esac] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(787),
    [anon_sym_SEMI_SEMI] = ACTIONS(787),
    [anon_sym_PIPE_AMP] = ACTIONS(787),
  },
  [2030] = {
    [sym_command_substitution] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [aux_sym_string_repeat1] = STATE(444),
    [sym_expansion] = STATE(160),
    [anon_sym_DOLLAR] = ACTIONS(5058),
    [anon_sym_BQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(5056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(255),
    [sym__string_content] = ACTIONS(257),
  },
  [2031] = {
    [sym_command_substitution] = STATE(2117),
    [sym_simple_expansion] = STATE(2117),
    [sym_string_expansion] = STATE(2117),
    [sym_string] = STATE(2117),
    [sym_process_substitution] = STATE(2117),
    [sym_expansion] = STATE(2117),
    [anon_sym_BQUOTE] = ACTIONS(4495),
    [anon_sym_DQUOTE] = ACTIONS(4497),
    [sym_word] = ACTIONS(5060),
    [sym_raw_string] = ACTIONS(5060),
    [anon_sym_LT_LPAREN] = ACTIONS(4501),
    [anon_sym_DOLLAR] = ACTIONS(4503),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4501),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4505),
    [sym__special_character] = ACTIONS(5060),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4509),
  },
  [2032] = {
    [aux_sym_concatenation_repeat1] = STATE(2119),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [anon_sym_GT_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [sym_word] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [sym__concat] = ACTIONS(5062),
    [sym__special_character] = ACTIONS(581),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_BQUOTE] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [sym_raw_string] = ACTIONS(581),
    [sym_variable_name] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT_LPAREN] = ACTIONS(581),
    [anon_sym_esac] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [2033] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5064),
  },
  [2034] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(505),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_LT_LT] = ACTIONS(505),
    [anon_sym_GT_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(505),
    [anon_sym_PIPE_PIPE] = ACTIONS(505),
    [sym_word] = ACTIONS(505),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_AMP] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(505),
    [anon_sym_LT_AMP] = ACTIONS(505),
    [anon_sym_GT_GT] = ACTIONS(505),
    [sym__concat] = ACTIONS(507),
    [sym__special_character] = ACTIONS(505),
    [anon_sym_LT_LT_DASH] = ACTIONS(505),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [sym_raw_string] = ACTIONS(505),
    [sym_variable_name] = ACTIONS(507),
    [sym_file_descriptor] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(505),
    [anon_sym_AMP_GT] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(505),
    [anon_sym_LT_LT_LT] = ACTIONS(505),
    [anon_sym_GT_AMP] = ACTIONS(505),
    [anon_sym_LT_LPAREN] = ACTIONS(505),
    [anon_sym_esac] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(505),
    [anon_sym_SEMI_SEMI] = ACTIONS(505),
    [anon_sym_PIPE_AMP] = ACTIONS(505),
  },
  [2035] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(509),
    [anon_sym_LT_LT] = ACTIONS(509),
    [anon_sym_GT_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(509),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(509),
    [anon_sym_PIPE_PIPE] = ACTIONS(509),
    [sym_word] = ACTIONS(509),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_LT_AMP] = ACTIONS(509),
    [anon_sym_GT_GT] = ACTIONS(509),
    [sym__concat] = ACTIONS(511),
    [sym__special_character] = ACTIONS(509),
    [anon_sym_LT_LT_DASH] = ACTIONS(509),
    [anon_sym_BQUOTE] = ACTIONS(509),
    [anon_sym_LF] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(509),
    [sym_raw_string] = ACTIONS(509),
    [sym_variable_name] = ACTIONS(511),
    [sym_file_descriptor] = ACTIONS(511),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_AMP_GT] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_LT_LT_LT] = ACTIONS(509),
    [anon_sym_GT_AMP] = ACTIONS(509),
    [anon_sym_LT_LPAREN] = ACTIONS(509),
    [anon_sym_esac] = ACTIONS(509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(509),
    [anon_sym_SEMI_SEMI] = ACTIONS(509),
    [anon_sym_PIPE_AMP] = ACTIONS(509),
  },
  [2036] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(513),
    [anon_sym_DOLLAR] = ACTIONS(513),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(513),
    [anon_sym_PIPE_PIPE] = ACTIONS(513),
    [sym_word] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_LT_AMP] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [sym__concat] = ACTIONS(515),
    [sym__special_character] = ACTIONS(513),
    [anon_sym_LT_LT_DASH] = ACTIONS(513),
    [anon_sym_BQUOTE] = ACTIONS(513),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_raw_string] = ACTIONS(513),
    [sym_variable_name] = ACTIONS(515),
    [sym_file_descriptor] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_AMP_GT] = ACTIONS(513),
    [anon_sym_DQUOTE] = ACTIONS(513),
    [anon_sym_LT_LT_LT] = ACTIONS(513),
    [anon_sym_GT_AMP] = ACTIONS(513),
    [anon_sym_LT_LPAREN] = ACTIONS(513),
    [anon_sym_esac] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [anon_sym_PIPE_AMP] = ACTIONS(513),
  },
  [2037] = {
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [sym_file_descriptor] = ACTIONS(323),
    [sym_variable_name] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_RPAREN] = ACTIONS(5054),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [sym_word] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(323),
  },
  [2038] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5054),
  },
  [2039] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2123),
    [sym_concatenation] = STATE(2123),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(5066),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5068),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5070),
    [anon_sym_DASH] = ACTIONS(5068),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5068),
    [anon_sym_PERCENT] = ACTIONS(5068),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5072),
    [anon_sym_COLON_DASH] = ACTIONS(5068),
    [sym__special_character] = ACTIONS(553),
  },
  [2040] = {
    [sym_subscript] = STATE(2124),
    [anon_sym_STAR] = ACTIONS(5074),
    [anon_sym_QMARK] = ACTIONS(5074),
    [anon_sym_AT] = ACTIONS(5074),
    [sym_variable_name] = ACTIONS(5076),
    [anon_sym_DOLLAR] = ACTIONS(5078),
    [anon_sym_DASH] = ACTIONS(5078),
    [anon_sym_0] = ACTIONS(5080),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5080),
    [anon_sym__] = ACTIONS(5080),
  },
  [2041] = {
    [anon_sym_EQ] = ACTIONS(5082),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [2042] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2130),
    [sym_concatenation] = STATE(2130),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(5084),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5086),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5088),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5086),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5086),
    [anon_sym_PERCENT] = ACTIONS(5086),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5090),
    [anon_sym_COLON_DASH] = ACTIONS(5086),
    [sym__special_character] = ACTIONS(553),
  },
  [2043] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(187),
    [anon_sym_DOLLAR] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(187),
    [anon_sym_GT_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(187),
    [sym_word] = ACTIONS(187),
    [anon_sym_PIPE] = ACTIONS(187),
    [anon_sym_AMP] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(187),
    [anon_sym_LT_AMP] = ACTIONS(187),
    [anon_sym_GT_GT] = ACTIONS(187),
    [sym__special_character] = ACTIONS(187),
    [anon_sym_LT_LT_DASH] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(187),
    [anon_sym_LF] = ACTIONS(189),
    [anon_sym_SEMI] = ACTIONS(187),
    [sym_raw_string] = ACTIONS(187),
    [sym_variable_name] = ACTIONS(189),
    [sym_file_descriptor] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(187),
    [anon_sym_AMP_GT] = ACTIONS(187),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_LT_LT_LT] = ACTIONS(187),
    [anon_sym_GT_AMP] = ACTIONS(187),
    [anon_sym_LT_LPAREN] = ACTIONS(187),
    [anon_sym_esac] = ACTIONS(187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(187),
    [anon_sym_SEMI_SEMI] = ACTIONS(187),
    [anon_sym_PIPE_AMP] = ACTIONS(187),
  },
  [2044] = {
    [aux_sym__literal_repeat1] = STATE(2044),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [sym_word] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [sym__special_character] = ACTIONS(5092),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [sym_variable_name] = ACTIONS(888),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [anon_sym_esac] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [2045] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2583),
    [anon_sym_PIPE_PIPE] = ACTIONS(2583),
    [sym_word] = ACTIONS(2583),
    [anon_sym_PIPE] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_LT_AMP] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_EQ_TILDE] = ACTIONS(2583),
    [sym__special_character] = ACTIONS(2583),
    [anon_sym_LT_LT_DASH] = ACTIONS(2583),
    [anon_sym_BQUOTE] = ACTIONS(2583),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [sym_raw_string] = ACTIONS(2583),
    [sym_file_descriptor] = ACTIONS(2585),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_AMP_GT] = ACTIONS(2583),
    [anon_sym_EQ_EQ] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2583),
    [anon_sym_LT_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_AMP] = ACTIONS(2583),
    [anon_sym_LT_LPAREN] = ACTIONS(2583),
    [anon_sym_esac] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
    [anon_sym_PIPE_AMP] = ACTIONS(2583),
  },
  [2046] = {
    [aux_sym_concatenation_repeat1] = STATE(2132),
    [anon_sym_LT_LT_DASH] = ACTIONS(581),
    [anon_sym_AMP_GT_GT] = ACTIONS(581),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(581),
    [anon_sym_LT_LT] = ACTIONS(581),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(581),
    [anon_sym_AMP_GT] = ACTIONS(581),
    [anon_sym_PIPE_PIPE] = ACTIONS(581),
    [anon_sym_LT_LT_LT] = ACTIONS(581),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_GT_AMP] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_esac] = ACTIONS(581),
    [anon_sym_GT_GT] = ACTIONS(581),
    [anon_sym_LT_AMP] = ACTIONS(581),
    [anon_sym_AMP] = ACTIONS(581),
    [sym__concat] = ACTIONS(5095),
    [anon_sym_AMP_AMP] = ACTIONS(581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(581),
    [anon_sym_PIPE_AMP] = ACTIONS(581),
  },
  [2047] = {
    [aux_sym__literal_repeat1] = STATE(2047),
    [anon_sym_LT_LT_DASH] = ACTIONS(883),
    [anon_sym_AMP_GT_GT] = ACTIONS(883),
    [anon_sym_LF] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(883),
    [anon_sym_LT_LT] = ACTIONS(883),
    [sym_file_descriptor] = ACTIONS(888),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_AMP_GT] = ACTIONS(883),
    [anon_sym_PIPE_PIPE] = ACTIONS(883),
    [anon_sym_LT_LT_LT] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_GT_AMP] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_esac] = ACTIONS(883),
    [anon_sym_GT_GT] = ACTIONS(883),
    [anon_sym_LT_AMP] = ACTIONS(883),
    [anon_sym_AMP] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(883),
    [sym__special_character] = ACTIONS(2767),
    [anon_sym_SEMI_SEMI] = ACTIONS(883),
    [anon_sym_PIPE_AMP] = ACTIONS(883),
  },
  [2048] = {
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_AMP_GT_GT] = ACTIONS(2796),
    [anon_sym_local] = ACTIONS(2794),
    [anon_sym_typeset] = ACTIONS(2794),
    [anon_sym_unsetenv] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2794),
    [anon_sym_GT_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2794),
    [sym_word] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_LT_AMP] = ACTIONS(2796),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2794),
    [sym__special_character] = ACTIONS(2794),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2794),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2796),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BQUOTE] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [sym_variable_name] = ACTIONS(2796),
    [sym_file_descriptor] = ACTIONS(2796),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP_GT] = ACTIONS(2794),
    [anon_sym_readonly] = ACTIONS(2794),
    [anon_sym_unset] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [anon_sym_GT_AMP] = ACTIONS(2796),
    [anon_sym_LT_LPAREN] = ACTIONS(2796),
    [anon_sym_esac] = ACTIONS(2800),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2796),
    [anon_sym_SEMI_SEMI] = ACTIONS(2798),
  },
  [2049] = {
    [aux_sym_concatenation_repeat1] = STATE(2046),
    [anon_sym_LT_LT_DASH] = ACTIONS(1633),
    [anon_sym_AMP_GT_GT] = ACTIONS(1633),
    [anon_sym_LF] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [sym_file_descriptor] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1633),
    [anon_sym_AMP_GT] = ACTIONS(1633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_LT_LT_LT] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_GT_AMP] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_esac] = ACTIONS(1633),
    [anon_sym_GT_GT] = ACTIONS(1633),
    [anon_sym_LT_AMP] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [sym__concat] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(1633),
    [anon_sym_PIPE_AMP] = ACTIONS(1633),
  },
  [2050] = {
    [aux_sym__literal_repeat1] = STATE(2047),
    [anon_sym_LT_LT_DASH] = ACTIONS(1637),
    [anon_sym_AMP_GT_GT] = ACTIONS(1637),
    [anon_sym_LF] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_LT_LT] = ACTIONS(1637),
    [sym_file_descriptor] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1637),
    [anon_sym_AMP_GT] = ACTIONS(1637),
    [anon_sym_PIPE_PIPE] = ACTIONS(1637),
    [anon_sym_LT_LT_LT] = ACTIONS(1637),
    [anon_sym_PIPE] = ACTIONS(1637),
    [anon_sym_GT_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_esac] = ACTIONS(1637),
    [anon_sym_GT_GT] = ACTIONS(1637),
    [anon_sym_LT_AMP] = ACTIONS(1637),
    [anon_sym_AMP] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1637),
    [sym__special_character] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1637),
    [anon_sym_PIPE_AMP] = ACTIONS(1637),
  },
  [2051] = {
    [anon_sym_AMP] = ACTIONS(5097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(5099),
    [anon_sym_SEMI] = ACTIONS(5097),
    [anon_sym_SEMI_SEMI] = ACTIONS(2800),
    [anon_sym_esac] = ACTIONS(2800),
  },
  [2052] = {
    [sym_heredoc_body] = STATE(2134),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__simple_heredoc_body] = ACTIONS(910),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [sym__heredoc_body_beginning] = ACTIONS(912),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
    [anon_sym_SEMI_SEMI] = ACTIONS(914),
  },
  [2053] = {
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
    [anon_sym_SEMI_SEMI] = ACTIONS(914),
  },
  [2054] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
    [anon_sym_AMP_GT_GT] = ACTIONS(609),
    [anon_sym_LF] = ACTIONS(5101),
    [anon_sym_SEMI] = ACTIONS(5103),
    [sym_file_descriptor] = ACTIONS(615),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(609),
    [anon_sym_AMP_GT] = ACTIONS(609),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_LT_LT_LT] = ACTIONS(619),
    [anon_sym_GT_AMP] = ACTIONS(609),
    [anon_sym_PIPE] = ACTIONS(607),
    [anon_sym_LT] = ACTIONS(609),
    [anon_sym_LT_AMP] = ACTIONS(609),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_AMP] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(1062),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
  },
  [2055] = {
    [sym_heredoc_redirect] = STATE(338),
    [aux_sym_redirected_statement_repeat1] = STATE(338),
    [sym_herestring_redirect] = STATE(338),
    [sym_file_redirect] = STATE(338),
    [anon_sym_AMP_GT_GT] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(311),
    [anon_sym_GT_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [sym_word] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(321),
    [anon_sym_LT_AMP] = ACTIONS(321),
    [anon_sym_GT_GT] = ACTIONS(321),
    [sym__special_character] = ACTIONS(321),
    [anon_sym_LT_LT_DASH] = ACTIONS(311),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [sym_raw_string] = ACTIONS(321),
    [anon_sym_LF] = ACTIONS(5101),
    [anon_sym_SEMI] = ACTIONS(5103),
    [sym_variable_name] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(321),
    [anon_sym_AMP_GT] = ACTIONS(321),
    [anon_sym_DQUOTE] = ACTIONS(321),
    [anon_sym_LT_LT_LT] = ACTIONS(619),
    [anon_sym_GT_AMP] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_SEMI_SEMI] = ACTIONS(1062),
    [anon_sym_PIPE_AMP] = ACTIONS(607),
  },
  [2056] = {
    [anon_sym_BQUOTE] = ACTIONS(4534),
    [anon_sym_DQUOTE] = ACTIONS(4534),
    [sym_word] = ACTIONS(4534),
    [sym_raw_string] = ACTIONS(4534),
    [anon_sym_LT_LPAREN] = ACTIONS(4534),
    [anon_sym_DOLLAR] = ACTIONS(4536),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4534),
    [sym__special_character] = ACTIONS(4534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4534),
  },
  [2057] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(5105),
  },
  [2058] = {
    [anon_sym_BQUOTE] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4548),
    [sym_word] = ACTIONS(4548),
    [sym_raw_string] = ACTIONS(4548),
    [anon_sym_LT_LPAREN] = ACTIONS(4548),
    [anon_sym_DOLLAR] = ACTIONS(4550),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4548),
    [sym__special_character] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4548),
  },
  [2059] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(5107),
  },
  [2060] = {
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [sym_word] = ACTIONS(4036),
    [sym_raw_string] = ACTIONS(4036),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_LT_LPAREN] = ACTIONS(4036),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_RPAREN] = ACTIONS(4036),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [sym__special_character] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
  },
  [2061] = {
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4040),
    [sym_word] = ACTIONS(4040),
    [sym_raw_string] = ACTIONS(4040),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_LT_LPAREN] = ACTIONS(4040),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_RPAREN] = ACTIONS(4040),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [sym__special_character] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
  },
  [2062] = {
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [sym_raw_string] = ACTIONS(4034),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [sym_word] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
  },
  [2063] = {
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
  },
  [2064] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(5109),
    [anon_sym_BQUOTE] = ACTIONS(5109),
    [anon_sym_AMP_GT_GT] = ACTIONS(5109),
    [anon_sym_LF] = ACTIONS(5111),
    [anon_sym_SEMI] = ACTIONS(5109),
    [anon_sym_LT_LT] = ACTIONS(5109),
    [sym_file_descriptor] = ACTIONS(5111),
    [anon_sym_GT] = ACTIONS(5109),
    [anon_sym_RPAREN] = ACTIONS(5109),
    [anon_sym_AMP_GT] = ACTIONS(5109),
    [anon_sym_PIPE_PIPE] = ACTIONS(5109),
    [ts_builtin_sym_end] = ACTIONS(5111),
    [anon_sym_LT_LT_LT] = ACTIONS(5109),
    [anon_sym_PIPE] = ACTIONS(5109),
    [anon_sym_GT_AMP] = ACTIONS(5109),
    [anon_sym_LT] = ACTIONS(5109),
    [anon_sym_LT_AMP] = ACTIONS(5109),
    [anon_sym_GT_GT] = ACTIONS(5109),
    [anon_sym_AMP] = ACTIONS(5109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_esac] = ACTIONS(5109),
    [anon_sym_AMP_AMP] = ACTIONS(5109),
    [anon_sym_SEMI_SEMI] = ACTIONS(5109),
    [anon_sym_PIPE_AMP] = ACTIONS(5109),
  },
  [2065] = {
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4036),
    [sym__heredoc_body_end] = ACTIONS(4036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4036),
    [sym__heredoc_body_middle] = ACTIONS(4036),
  },
  [2066] = {
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4040),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4040),
    [sym__heredoc_body_end] = ACTIONS(4040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4040),
    [sym__heredoc_body_middle] = ACTIONS(4040),
  },
  [2067] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2583),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2583),
    [anon_sym_PIPE_PIPE] = ACTIONS(2583),
    [sym_word] = ACTIONS(2583),
    [anon_sym_PIPE] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_LT_AMP] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [sym__special_character] = ACTIONS(2583),
    [anon_sym_LT_LT_DASH] = ACTIONS(2583),
    [anon_sym_BQUOTE] = ACTIONS(2583),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [sym_raw_string] = ACTIONS(2583),
    [sym_variable_name] = ACTIONS(2585),
    [sym_file_descriptor] = ACTIONS(2585),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_AMP_GT] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2583),
    [anon_sym_LT_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_AMP] = ACTIONS(2583),
    [anon_sym_LT_LPAREN] = ACTIONS(2583),
    [anon_sym_esac] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
    [anon_sym_PIPE_AMP] = ACTIONS(2583),
  },
  [2068] = {
    [sym_string] = STATE(1856),
    [anon_sym__] = ACTIONS(4413),
    [anon_sym_AMP_GT_GT] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(5113),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [sym_word] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_LT_AMP] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(4413),
    [sym__special_character] = ACTIONS(2261),
    [anon_sym_LT_LT_DASH] = ACTIONS(2261),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(4413),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(5115),
    [anon_sym_BANG] = ACTIONS(5113),
    [sym_variable_name] = ACTIONS(2265),
    [sym_file_descriptor] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(4413),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_AMP_GT] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(4106),
    [anon_sym_LT_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_AMP] = ACTIONS(2261),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_esac] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(4413),
    [anon_sym_POUND] = ACTIONS(5113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_PIPE_AMP] = ACTIONS(2261),
  },
  [2069] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2467),
    [anon_sym_DOLLAR] = ACTIONS(2467),
    [anon_sym_LT_LT] = ACTIONS(2467),
    [anon_sym_GT_LPAREN] = ACTIONS(2467),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2467),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2467),
    [anon_sym_PIPE_PIPE] = ACTIONS(2467),
    [sym_word] = ACTIONS(2467),
    [anon_sym_PIPE] = ACTIONS(2467),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_LT_AMP] = ACTIONS(2467),
    [anon_sym_GT_GT] = ACTIONS(2467),
    [sym__special_character] = ACTIONS(2467),
    [anon_sym_LT_LT_DASH] = ACTIONS(2467),
    [anon_sym_BQUOTE] = ACTIONS(2467),
    [anon_sym_LF] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2467),
    [sym_raw_string] = ACTIONS(2467),
    [sym_variable_name] = ACTIONS(2469),
    [sym_file_descriptor] = ACTIONS(2469),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_AMP_GT] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [anon_sym_LT_LT_LT] = ACTIONS(2467),
    [anon_sym_GT_AMP] = ACTIONS(2467),
    [anon_sym_LT_LPAREN] = ACTIONS(2467),
    [anon_sym_esac] = ACTIONS(2467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2467),
    [anon_sym_SEMI_SEMI] = ACTIONS(2467),
    [anon_sym_PIPE_AMP] = ACTIONS(2467),
  },
  [2070] = {
    [sym_command_substitution] = STATE(753),
    [aux_sym__literal_repeat1] = STATE(760),
    [sym_string] = STATE(753),
    [sym_process_substitution] = STATE(753),
    [aux_sym_for_statement_repeat1] = STATE(1097),
    [sym_simple_expansion] = STATE(753),
    [sym_string_expansion] = STATE(753),
    [sym_concatenation] = STATE(1097),
    [sym_expansion] = STATE(753),
    [anon_sym_BQUOTE] = ACTIONS(1567),
    [anon_sym_DQUOTE] = ACTIONS(1569),
    [sym_word] = ACTIONS(1571),
    [sym_raw_string] = ACTIONS(1571),
    [anon_sym_LT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(5117),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1573),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1579),
    [sym__special_character] = ACTIONS(1581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1583),
  },
  [2071] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2109),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [sym_word] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_LT_AMP] = ACTIONS(2109),
    [anon_sym_GT_GT] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [sym__special_character] = ACTIONS(2109),
    [anon_sym_LT_LT_DASH] = ACTIONS(2109),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [anon_sym_LF] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [sym_raw_string] = ACTIONS(2109),
    [sym_variable_name] = ACTIONS(2111),
    [sym_file_descriptor] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_AMP_GT] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [anon_sym_LT_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_AMP] = ACTIONS(2109),
    [anon_sym_LT_LPAREN] = ACTIONS(2109),
    [anon_sym_esac] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
    [anon_sym_PIPE_AMP] = ACTIONS(2109),
  },
  [2072] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2141),
    [sym_concatenation] = STATE(2141),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5119),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_DASH] = ACTIONS(5119),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5123),
    [anon_sym_COLON_DASH] = ACTIONS(5119),
    [sym__special_character] = ACTIONS(553),
  },
  [2073] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2074] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2141),
    [sym_concatenation] = STATE(2141),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5119),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_DASH] = ACTIONS(5119),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5119),
    [anon_sym_PERCENT] = ACTIONS(5119),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5123),
    [anon_sym_COLON_DASH] = ACTIONS(5119),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(5125),
  },
  [2075] = {
    [sym_command_substitution] = STATE(2143),
    [aux_sym__literal_repeat1] = STATE(2144),
    [sym_string] = STATE(2143),
    [sym_process_substitution] = STATE(2143),
    [sym_simple_expansion] = STATE(2143),
    [sym_string_expansion] = STATE(2143),
    [sym_concatenation] = STATE(2145),
    [sym_expansion] = STATE(2143),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(5127),
    [sym_raw_string] = ACTIONS(5127),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [2076] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2148),
    [sym_concatenation] = STATE(2148),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5129),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5129),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5129),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5133),
    [anon_sym_COLON_DASH] = ACTIONS(5129),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(5135),
  },
  [2077] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [sym__special_character] = ACTIONS(2205),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [sym_variable_name] = ACTIONS(2207),
    [sym_file_descriptor] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [anon_sym_esac] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
  },
  [2078] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2079] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [sym__concat] = ACTIONS(2213),
  },
  [2080] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(5137),
  },
  [2081] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5121),
  },
  [2082] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2247),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2247),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2247),
    [sym_word] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_LT_AMP] = ACTIONS(2247),
    [anon_sym_GT_GT] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [sym__special_character] = ACTIONS(2247),
    [anon_sym_LT_LT_DASH] = ACTIONS(2247),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [sym_raw_string] = ACTIONS(2247),
    [sym_variable_name] = ACTIONS(2249),
    [sym_file_descriptor] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_AMP_GT] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_LT_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_AMP] = ACTIONS(2247),
    [anon_sym_LT_LPAREN] = ACTIONS(2247),
    [anon_sym_esac] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
    [anon_sym_PIPE_AMP] = ACTIONS(2247),
  },
  [2083] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2151),
    [sym_concatenation] = STATE(2151),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5139),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5141),
    [anon_sym_DASH] = ACTIONS(5139),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5139),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5139),
    [anon_sym_PERCENT] = ACTIONS(5139),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5143),
    [anon_sym_COLON_DASH] = ACTIONS(5139),
    [sym__special_character] = ACTIONS(553),
  },
  [2084] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5141),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2085] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2583),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2583),
    [anon_sym_PIPE_PIPE] = ACTIONS(2583),
    [sym_word] = ACTIONS(2583),
    [anon_sym_PIPE] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_LT_AMP] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [sym__special_character] = ACTIONS(2583),
    [anon_sym_LT_LT_DASH] = ACTIONS(2583),
    [anon_sym_BQUOTE] = ACTIONS(2583),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [sym_raw_string] = ACTIONS(2583),
    [sym_file_descriptor] = ACTIONS(2585),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_AMP_GT] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2583),
    [anon_sym_LT_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_AMP] = ACTIONS(2583),
    [anon_sym_LT_LPAREN] = ACTIONS(2583),
    [anon_sym_esac] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
    [anon_sym_PIPE_AMP] = ACTIONS(2583),
  },
  [2086] = {
    [sym_string] = STATE(1875),
    [anon_sym__] = ACTIONS(4443),
    [anon_sym_AMP_GT_GT] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(5145),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(5145),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [sym_word] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_LT_AMP] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(4443),
    [sym__special_character] = ACTIONS(2261),
    [anon_sym_LT_LT_DASH] = ACTIONS(2261),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(5147),
    [anon_sym_BANG] = ACTIONS(5145),
    [sym_file_descriptor] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(4443),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_AMP_GT] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(4124),
    [anon_sym_LT_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_AMP] = ACTIONS(2261),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_esac] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(4443),
    [anon_sym_POUND] = ACTIONS(5145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_PIPE_AMP] = ACTIONS(2261),
  },
  [2087] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2109),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [sym_word] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_LT_AMP] = ACTIONS(2109),
    [anon_sym_GT_GT] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [sym__special_character] = ACTIONS(2109),
    [anon_sym_LT_LT_DASH] = ACTIONS(2109),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [anon_sym_LF] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [sym_raw_string] = ACTIONS(2109),
    [sym_file_descriptor] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_AMP_GT] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [anon_sym_LT_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_AMP] = ACTIONS(2109),
    [anon_sym_LT_LPAREN] = ACTIONS(2109),
    [anon_sym_esac] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
    [anon_sym_PIPE_AMP] = ACTIONS(2109),
  },
  [2088] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2153),
    [sym_concatenation] = STATE(2153),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5149),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5151),
    [anon_sym_DASH] = ACTIONS(5149),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5149),
    [anon_sym_PERCENT] = ACTIONS(5149),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5153),
    [anon_sym_COLON_DASH] = ACTIONS(5149),
    [sym__special_character] = ACTIONS(553),
  },
  [2089] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5151),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2090] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2153),
    [sym_concatenation] = STATE(2153),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5149),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5151),
    [anon_sym_DASH] = ACTIONS(5149),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5149),
    [anon_sym_PERCENT] = ACTIONS(5149),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5153),
    [anon_sym_COLON_DASH] = ACTIONS(5149),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(5155),
  },
  [2091] = {
    [sym_command_substitution] = STATE(2155),
    [aux_sym__literal_repeat1] = STATE(2156),
    [sym_string] = STATE(2155),
    [sym_process_substitution] = STATE(2155),
    [sym_simple_expansion] = STATE(2155),
    [sym_string_expansion] = STATE(2155),
    [sym_concatenation] = STATE(2157),
    [sym_expansion] = STATE(2155),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(5157),
    [sym_raw_string] = ACTIONS(5157),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5151),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [2092] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2160),
    [sym_concatenation] = STATE(2160),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5159),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5161),
    [anon_sym_DASH] = ACTIONS(5159),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5159),
    [anon_sym_PERCENT] = ACTIONS(5159),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5163),
    [anon_sym_COLON_DASH] = ACTIONS(5159),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(5165),
  },
  [2093] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [sym__special_character] = ACTIONS(2205),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [sym_file_descriptor] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [anon_sym_esac] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
  },
  [2094] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5161),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2095] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5151),
    [sym__concat] = ACTIONS(2213),
  },
  [2096] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(5167),
  },
  [2097] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5151),
  },
  [2098] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2247),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2247),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2247),
    [sym_word] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_LT_AMP] = ACTIONS(2247),
    [anon_sym_GT_GT] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [sym__special_character] = ACTIONS(2247),
    [anon_sym_LT_LT_DASH] = ACTIONS(2247),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [sym_raw_string] = ACTIONS(2247),
    [sym_file_descriptor] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_AMP_GT] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_LT_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_AMP] = ACTIONS(2247),
    [anon_sym_LT_LPAREN] = ACTIONS(2247),
    [anon_sym_esac] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
    [anon_sym_PIPE_AMP] = ACTIONS(2247),
  },
  [2099] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2163),
    [sym_concatenation] = STATE(2163),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5169),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [anon_sym_DASH] = ACTIONS(5169),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5169),
    [anon_sym_PERCENT] = ACTIONS(5169),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5173),
    [anon_sym_COLON_DASH] = ACTIONS(5169),
    [sym__special_character] = ACTIONS(553),
  },
  [2100] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2101] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [sym_word] = ACTIONS(2896),
    [anon_sym_PIPE] = ACTIONS(2896),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_LT_AMP] = ACTIONS(2896),
    [anon_sym_GT_GT] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [anon_sym_EQ_TILDE] = ACTIONS(2896),
    [sym__special_character] = ACTIONS(2896),
    [anon_sym_LT_LT_DASH] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [sym_raw_string] = ACTIONS(2896),
    [sym_file_descriptor] = ACTIONS(2898),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_AMP_GT] = ACTIONS(2896),
    [anon_sym_EQ_EQ] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [anon_sym_LT_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_AMP] = ACTIONS(2896),
    [anon_sym_LT_LPAREN] = ACTIONS(2896),
    [anon_sym_esac] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
    [anon_sym_PIPE_AMP] = ACTIONS(2896),
  },
  [2102] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2103] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2165),
    [sym_concatenation] = STATE(2165),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5177),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5175),
    [anon_sym_DASH] = ACTIONS(5177),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5177),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5177),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5179),
    [anon_sym_COLON_DASH] = ACTIONS(5177),
    [sym__special_character] = ACTIONS(553),
  },
  [2104] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5175),
    [sym__concat] = ACTIONS(2213),
  },
  [2105] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(5181),
  },
  [2106] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5175),
  },
  [2107] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [sym_word] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2945),
    [sym__special_character] = ACTIONS(2945),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [sym_file_descriptor] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [anon_sym_esac] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
  },
  [2108] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2168),
    [sym_concatenation] = STATE(2168),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5183),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [anon_sym_DASH] = ACTIONS(5183),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5183),
    [anon_sym_PERCENT] = ACTIONS(5183),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5187),
    [anon_sym_COLON_DASH] = ACTIONS(5183),
    [sym__special_character] = ACTIONS(553),
  },
  [2109] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2110] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [sym_word] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_LT_AMP] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [anon_sym_EQ_TILDE] = ACTIONS(2993),
    [sym__special_character] = ACTIONS(2993),
    [anon_sym_LT_LT_DASH] = ACTIONS(2993),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [sym_raw_string] = ACTIONS(2993),
    [sym_file_descriptor] = ACTIONS(2995),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_AMP_GT] = ACTIONS(2993),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_LT_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_AMP] = ACTIONS(2993),
    [anon_sym_LT_LPAREN] = ACTIONS(2993),
    [anon_sym_esac] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
    [anon_sym_PIPE_AMP] = ACTIONS(2993),
  },
  [2111] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3012),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [sym_word] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_LT_AMP] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [anon_sym_EQ_TILDE] = ACTIONS(3012),
    [sym__special_character] = ACTIONS(3012),
    [anon_sym_LT_LT_DASH] = ACTIONS(3012),
    [anon_sym_BQUOTE] = ACTIONS(3012),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [sym_raw_string] = ACTIONS(3012),
    [sym_file_descriptor] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_AMP_GT] = ACTIONS(3012),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_LT_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_AMP] = ACTIONS(3012),
    [anon_sym_LT_LPAREN] = ACTIONS(3012),
    [anon_sym_esac] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
    [anon_sym_PIPE_AMP] = ACTIONS(3012),
  },
  [2112] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5189),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2113] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3166),
    [anon_sym_DOLLAR] = ACTIONS(3166),
    [anon_sym_LT_LT] = ACTIONS(3166),
    [anon_sym_GT_LPAREN] = ACTIONS(3166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3166),
    [sym_word] = ACTIONS(3166),
    [anon_sym_PIPE] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3166),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_LT_AMP] = ACTIONS(3166),
    [anon_sym_GT_GT] = ACTIONS(3166),
    [sym__special_character] = ACTIONS(3166),
    [anon_sym_LT_LT_DASH] = ACTIONS(3166),
    [anon_sym_BQUOTE] = ACTIONS(3166),
    [anon_sym_LF] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3166),
    [sym_raw_string] = ACTIONS(3166),
    [sym_variable_name] = ACTIONS(3168),
    [sym_file_descriptor] = ACTIONS(3168),
    [anon_sym_GT] = ACTIONS(3166),
    [anon_sym_AMP_GT] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [anon_sym_LT_LT_LT] = ACTIONS(3166),
    [anon_sym_GT_AMP] = ACTIONS(3166),
    [anon_sym_LT_LPAREN] = ACTIONS(3166),
    [anon_sym_esac] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_SEMI_SEMI] = ACTIONS(3166),
    [anon_sym_PIPE_AMP] = ACTIONS(3166),
  },
  [2114] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1288),
    [anon_sym_PIPE_PIPE] = ACTIONS(1288),
    [sym_word] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_LT_AMP] = ACTIONS(1288),
    [anon_sym_GT_GT] = ACTIONS(1288),
    [sym__concat] = ACTIONS(1290),
    [sym__special_character] = ACTIONS(1288),
    [anon_sym_LT_LT_DASH] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_LF] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1288),
    [sym_raw_string] = ACTIONS(1288),
    [sym_variable_name] = ACTIONS(1290),
    [sym_file_descriptor] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_AMP_GT] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [anon_sym_LT_LT_LT] = ACTIONS(1288),
    [anon_sym_GT_AMP] = ACTIONS(1288),
    [anon_sym_LT_LPAREN] = ACTIONS(1288),
    [anon_sym_esac] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1288),
    [anon_sym_SEMI_SEMI] = ACTIONS(1288),
    [anon_sym_PIPE_AMP] = ACTIONS(1288),
  },
  [2115] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1639),
    [anon_sym_DOLLAR] = ACTIONS(1639),
    [anon_sym_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [sym_word] = ACTIONS(1639),
    [anon_sym_PIPE] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_LT_AMP] = ACTIONS(1639),
    [anon_sym_GT_GT] = ACTIONS(1639),
    [sym__concat] = ACTIONS(1641),
    [sym__special_character] = ACTIONS(1639),
    [anon_sym_LT_LT_DASH] = ACTIONS(1639),
    [anon_sym_BQUOTE] = ACTIONS(1639),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_SEMI] = ACTIONS(1639),
    [sym_raw_string] = ACTIONS(1639),
    [sym_variable_name] = ACTIONS(1641),
    [sym_file_descriptor] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_AMP_GT] = ACTIONS(1639),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_LT_LT_LT] = ACTIONS(1639),
    [anon_sym_GT_AMP] = ACTIONS(1639),
    [anon_sym_LT_LPAREN] = ACTIONS(1639),
    [anon_sym_esac] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1639),
    [anon_sym_PIPE_AMP] = ACTIONS(1639),
  },
  [2116] = {
    [anon_sym_STAR] = ACTIONS(777),
    [anon_sym_DQUOTE] = ACTIONS(5191),
    [anon_sym_QMARK] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_POUND] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_0] = ACTIONS(783),
    [sym__string_content] = ACTIONS(785),
    [aux_sym__simple_variable_name_token1] = ACTIONS(783),
    [anon_sym__] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [2117] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(1392),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [anon_sym_esac] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [2118] = {
    [sym_command_substitution] = STATE(2117),
    [sym_simple_expansion] = STATE(2117),
    [sym_string_expansion] = STATE(2117),
    [sym_string] = STATE(2117),
    [sym_process_substitution] = STATE(2117),
    [sym_expansion] = STATE(2117),
    [anon_sym_BQUOTE] = ACTIONS(4495),
    [anon_sym_DQUOTE] = ACTIONS(4497),
    [sym_word] = ACTIONS(5060),
    [sym_raw_string] = ACTIONS(5060),
    [anon_sym_LT_LPAREN] = ACTIONS(4501),
    [anon_sym_DOLLAR] = ACTIONS(5193),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4501),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4505),
    [sym__special_character] = ACTIONS(5060),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4509),
  },
  [2119] = {
    [aux_sym_concatenation_repeat1] = STATE(2119),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [sym_word] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [sym__concat] = ACTIONS(5195),
    [sym__special_character] = ACTIONS(1390),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [sym_variable_name] = ACTIONS(1392),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [anon_sym_esac] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [2120] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [sym_word] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1282),
    [anon_sym_LT_AMP] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1282),
    [sym__concat] = ACTIONS(1284),
    [sym__special_character] = ACTIONS(1282),
    [anon_sym_LT_LT_DASH] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_LF] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [sym_raw_string] = ACTIONS(1282),
    [sym_variable_name] = ACTIONS(1284),
    [sym_file_descriptor] = ACTIONS(1284),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_AMP_GT] = ACTIONS(1282),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_LT_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_AMP] = ACTIONS(1282),
    [anon_sym_LT_LPAREN] = ACTIONS(1282),
    [anon_sym_esac] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_SEMI_SEMI] = ACTIONS(1282),
    [anon_sym_PIPE_AMP] = ACTIONS(1282),
  },
  [2121] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2174),
    [sym_concatenation] = STATE(2174),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5198),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_DASH] = ACTIONS(5198),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5198),
    [anon_sym_PERCENT] = ACTIONS(5198),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5202),
    [anon_sym_COLON_DASH] = ACTIONS(5198),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(5204),
  },
  [2122] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [sym_word] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_LT_AMP] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1324),
    [sym__concat] = ACTIONS(1326),
    [sym__special_character] = ACTIONS(1324),
    [anon_sym_LT_LT_DASH] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [anon_sym_LF] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [sym_raw_string] = ACTIONS(1324),
    [sym_variable_name] = ACTIONS(1326),
    [sym_file_descriptor] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_AMP_GT] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_LT_LT_LT] = ACTIONS(1324),
    [anon_sym_GT_AMP] = ACTIONS(1324),
    [anon_sym_LT_LPAREN] = ACTIONS(1324),
    [anon_sym_esac] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_SEMI_SEMI] = ACTIONS(1324),
    [anon_sym_PIPE_AMP] = ACTIONS(1324),
  },
  [2123] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2124] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2174),
    [sym_concatenation] = STATE(2174),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(5206),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5198),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_DASH] = ACTIONS(5198),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5198),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5198),
    [anon_sym_PERCENT] = ACTIONS(5198),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5202),
    [anon_sym_COLON_DASH] = ACTIONS(5198),
    [sym__special_character] = ACTIONS(553),
  },
  [2125] = {
    [anon_sym_EQ] = ACTIONS(5208),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(565),
  },
  [2126] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2179),
    [sym_concatenation] = STATE(2179),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(5210),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5212),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5214),
    [anon_sym_DASH] = ACTIONS(5212),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5216),
    [anon_sym_COLON_DASH] = ACTIONS(5212),
    [sym__special_character] = ACTIONS(553),
  },
  [2127] = {
    [sym_command_substitution] = STATE(2180),
    [aux_sym__literal_repeat1] = STATE(2181),
    [sym_string] = STATE(2180),
    [sym_process_substitution] = STATE(2180),
    [sym_simple_expansion] = STATE(2180),
    [sym_string_expansion] = STATE(2180),
    [sym_concatenation] = STATE(2182),
    [sym_expansion] = STATE(2180),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(5218),
    [sym_raw_string] = ACTIONS(5218),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [2128] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2185),
    [sym_concatenation] = STATE(2185),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5220),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5222),
    [anon_sym_DASH] = ACTIONS(5220),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5220),
    [anon_sym_PERCENT] = ACTIONS(5220),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5224),
    [anon_sym_COLON_DASH] = ACTIONS(5220),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(5226),
  },
  [2129] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym_word] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [sym__concat] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [sym_variable_name] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_esac] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
  },
  [2130] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5222),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2131] = {
    [sym_command_substitution] = STATE(1200),
    [sym_simple_expansion] = STATE(1200),
    [sym_string_expansion] = STATE(1200),
    [sym_string] = STATE(1200),
    [sym_process_substitution] = STATE(1200),
    [sym_expansion] = STATE(1200),
    [anon_sym_BQUOTE] = ACTIONS(890),
    [anon_sym_DQUOTE] = ACTIONS(892),
    [sym_word] = ACTIONS(2735),
    [sym_raw_string] = ACTIONS(2735),
    [anon_sym_LT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR] = ACTIONS(5228),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(900),
    [sym__special_character] = ACTIONS(2735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(904),
  },
  [2132] = {
    [aux_sym_concatenation_repeat1] = STATE(2132),
    [anon_sym_LT_LT_DASH] = ACTIONS(1390),
    [anon_sym_AMP_GT_GT] = ACTIONS(1390),
    [anon_sym_LF] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [sym_file_descriptor] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1390),
    [anon_sym_AMP_GT] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1390),
    [anon_sym_GT_AMP] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_esac] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1390),
    [anon_sym_LT_AMP] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1390),
    [sym__concat] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(1390),
    [anon_sym_PIPE_AMP] = ACTIONS(1390),
  },
  [2133] = {
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_AMP_GT_GT] = ACTIONS(2796),
    [anon_sym_local] = ACTIONS(2794),
    [anon_sym_typeset] = ACTIONS(2794),
    [anon_sym_unsetenv] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2794),
    [anon_sym_GT_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2794),
    [sym_word] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_LT_AMP] = ACTIONS(2796),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2794),
    [sym__special_character] = ACTIONS(2794),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2794),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2796),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BQUOTE] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [sym_variable_name] = ACTIONS(2796),
    [sym_file_descriptor] = ACTIONS(2796),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP_GT] = ACTIONS(2794),
    [anon_sym_readonly] = ACTIONS(2794),
    [anon_sym_unset] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [anon_sym_GT_AMP] = ACTIONS(2796),
    [anon_sym_LT_LPAREN] = ACTIONS(2796),
    [anon_sym_esac] = ACTIONS(5230),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2796),
    [anon_sym_SEMI_SEMI] = ACTIONS(3497),
  },
  [2134] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(5232),
    [anon_sym_SEMI] = ACTIONS(5234),
    [anon_sym_SEMI_SEMI] = ACTIONS(1864),
    [anon_sym_AMP] = ACTIONS(5234),
  },
  [2135] = {
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
    [anon_sym_SEMI_SEMI] = ACTIONS(1866),
  },
  [2136] = {
    [sym_heredoc_body] = STATE(2188),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_AMP_GT_GT] = ACTIONS(908),
    [anon_sym_local] = ACTIONS(906),
    [anon_sym_typeset] = ACTIONS(906),
    [anon_sym_unsetenv] = ACTIONS(906),
    [anon_sym_DOLLAR] = ACTIONS(906),
    [anon_sym_GT_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(906),
    [sym_word] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(906),
    [anon_sym_LT_AMP] = ACTIONS(908),
    [anon_sym_GT_GT] = ACTIONS(908),
    [anon_sym_export] = ACTIONS(906),
    [sym__simple_heredoc_body] = ACTIONS(910),
    [sym__special_character] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_case] = ACTIONS(906),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(908),
    [sym_raw_string] = ACTIONS(908),
    [anon_sym_BQUOTE] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_declare] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(908),
    [sym_file_descriptor] = ACTIONS(908),
    [sym__heredoc_body_beginning] = ACTIONS(912),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_AMP_GT] = ACTIONS(906),
    [anon_sym_readonly] = ACTIONS(906),
    [anon_sym_unset] = ACTIONS(906),
    [anon_sym_DQUOTE] = ACTIONS(908),
    [anon_sym_GT_AMP] = ACTIONS(908),
    [anon_sym_LT_LPAREN] = ACTIONS(908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(906),
    [anon_sym_while] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(908),
    [anon_sym_SEMI_SEMI] = ACTIONS(1866),
  },
  [2137] = {
    [anon_sym_BQUOTE] = ACTIONS(4910),
    [anon_sym_DQUOTE] = ACTIONS(4910),
    [sym_word] = ACTIONS(4910),
    [sym_raw_string] = ACTIONS(4910),
    [anon_sym_LT_LPAREN] = ACTIONS(4910),
    [anon_sym_DOLLAR] = ACTIONS(4912),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4910),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4910),
    [sym__special_character] = ACTIONS(4910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4910),
  },
  [2138] = {
    [anon_sym_BQUOTE] = ACTIONS(4916),
    [anon_sym_DQUOTE] = ACTIONS(4916),
    [sym_word] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4916),
    [anon_sym_LT_LPAREN] = ACTIONS(4916),
    [anon_sym_DOLLAR] = ACTIONS(4918),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(4916),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4916),
    [sym__special_character] = ACTIONS(4916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4916),
  },
  [2139] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3166),
    [anon_sym_DOLLAR] = ACTIONS(3166),
    [anon_sym_LT_LT] = ACTIONS(3166),
    [anon_sym_GT_LPAREN] = ACTIONS(3166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3166),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3166),
    [sym_word] = ACTIONS(3166),
    [anon_sym_PIPE] = ACTIONS(3166),
    [anon_sym_AMP] = ACTIONS(3166),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_LT_AMP] = ACTIONS(3166),
    [anon_sym_GT_GT] = ACTIONS(3166),
    [sym__special_character] = ACTIONS(3166),
    [anon_sym_LT_LT_DASH] = ACTIONS(3166),
    [anon_sym_BQUOTE] = ACTIONS(3166),
    [anon_sym_LF] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3166),
    [sym_raw_string] = ACTIONS(3166),
    [sym_variable_name] = ACTIONS(3168),
    [sym_file_descriptor] = ACTIONS(3168),
    [anon_sym_GT] = ACTIONS(3166),
    [anon_sym_AMP_GT] = ACTIONS(3166),
    [anon_sym_DQUOTE] = ACTIONS(3166),
    [anon_sym_LT_LT_LT] = ACTIONS(3166),
    [anon_sym_GT_AMP] = ACTIONS(3166),
    [anon_sym_LT_LPAREN] = ACTIONS(3166),
    [anon_sym_esac] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3166),
    [anon_sym_SEMI_SEMI] = ACTIONS(3166),
    [anon_sym_PIPE_AMP] = ACTIONS(3166),
  },
  [2140] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2896),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [sym_word] = ACTIONS(2896),
    [anon_sym_PIPE] = ACTIONS(2896),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_LT_AMP] = ACTIONS(2896),
    [anon_sym_GT_GT] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [sym__special_character] = ACTIONS(2896),
    [anon_sym_LT_LT_DASH] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [sym_raw_string] = ACTIONS(2896),
    [sym_variable_name] = ACTIONS(2898),
    [sym_file_descriptor] = ACTIONS(2898),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_AMP_GT] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [anon_sym_LT_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_AMP] = ACTIONS(2896),
    [anon_sym_LT_LPAREN] = ACTIONS(2896),
    [anon_sym_esac] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
    [anon_sym_PIPE_AMP] = ACTIONS(2896),
  },
  [2141] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2142] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2190),
    [sym_concatenation] = STATE(2190),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5238),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5238),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5238),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5240),
    [anon_sym_COLON_DASH] = ACTIONS(5238),
    [sym__special_character] = ACTIONS(553),
  },
  [2143] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [sym__concat] = ACTIONS(2213),
  },
  [2144] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(5242),
  },
  [2145] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5236),
  },
  [2146] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [sym_word] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [sym__special_character] = ACTIONS(2945),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [sym_variable_name] = ACTIONS(2947),
    [sym_file_descriptor] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [anon_sym_esac] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
  },
  [2147] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2193),
    [sym_concatenation] = STATE(2193),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5244),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_DASH] = ACTIONS(5244),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5244),
    [anon_sym_PERCENT] = ACTIONS(5244),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5248),
    [anon_sym_COLON_DASH] = ACTIONS(5244),
    [sym__special_character] = ACTIONS(553),
  },
  [2148] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2149] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2993),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [sym_word] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_LT_AMP] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [sym__special_character] = ACTIONS(2993),
    [anon_sym_LT_LT_DASH] = ACTIONS(2993),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [sym_raw_string] = ACTIONS(2993),
    [sym_variable_name] = ACTIONS(2995),
    [sym_file_descriptor] = ACTIONS(2995),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_AMP_GT] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_LT_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_AMP] = ACTIONS(2993),
    [anon_sym_LT_LPAREN] = ACTIONS(2993),
    [anon_sym_esac] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
    [anon_sym_PIPE_AMP] = ACTIONS(2993),
  },
  [2150] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3012),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3012),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [sym_word] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_LT_AMP] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [sym__special_character] = ACTIONS(3012),
    [anon_sym_LT_LT_DASH] = ACTIONS(3012),
    [anon_sym_BQUOTE] = ACTIONS(3012),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [sym_raw_string] = ACTIONS(3012),
    [sym_variable_name] = ACTIONS(3014),
    [sym_file_descriptor] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_AMP_GT] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_LT_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_AMP] = ACTIONS(3012),
    [anon_sym_LT_LPAREN] = ACTIONS(3012),
    [anon_sym_esac] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
    [anon_sym_PIPE_AMP] = ACTIONS(3012),
  },
  [2151] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5250),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2152] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2896),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [sym_word] = ACTIONS(2896),
    [anon_sym_PIPE] = ACTIONS(2896),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_LT_AMP] = ACTIONS(2896),
    [anon_sym_GT_GT] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [sym__special_character] = ACTIONS(2896),
    [anon_sym_LT_LT_DASH] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [sym_raw_string] = ACTIONS(2896),
    [sym_file_descriptor] = ACTIONS(2898),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_AMP_GT] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [anon_sym_LT_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_AMP] = ACTIONS(2896),
    [anon_sym_LT_LPAREN] = ACTIONS(2896),
    [anon_sym_esac] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
    [anon_sym_PIPE_AMP] = ACTIONS(2896),
  },
  [2153] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5252),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2154] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2196),
    [sym_concatenation] = STATE(2196),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5254),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5252),
    [anon_sym_DASH] = ACTIONS(5254),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5254),
    [anon_sym_PERCENT] = ACTIONS(5254),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5256),
    [anon_sym_COLON_DASH] = ACTIONS(5254),
    [sym__special_character] = ACTIONS(553),
  },
  [2155] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5252),
    [sym__concat] = ACTIONS(2213),
  },
  [2156] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(5258),
  },
  [2157] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5252),
  },
  [2158] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [sym_word] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [sym__special_character] = ACTIONS(2945),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [sym_file_descriptor] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [anon_sym_esac] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
  },
  [2159] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2199),
    [sym_concatenation] = STATE(2199),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5260),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5262),
    [anon_sym_DASH] = ACTIONS(5260),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5260),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5260),
    [anon_sym_PERCENT] = ACTIONS(5260),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5264),
    [anon_sym_COLON_DASH] = ACTIONS(5260),
    [sym__special_character] = ACTIONS(553),
  },
  [2160] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5262),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2161] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2993),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [sym_word] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_LT_AMP] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [sym__special_character] = ACTIONS(2993),
    [anon_sym_LT_LT_DASH] = ACTIONS(2993),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [sym_raw_string] = ACTIONS(2993),
    [sym_file_descriptor] = ACTIONS(2995),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_AMP_GT] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_LT_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_AMP] = ACTIONS(2993),
    [anon_sym_LT_LPAREN] = ACTIONS(2993),
    [anon_sym_esac] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
    [anon_sym_PIPE_AMP] = ACTIONS(2993),
  },
  [2162] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3012),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3012),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [sym_word] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_LT_AMP] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [sym__special_character] = ACTIONS(3012),
    [anon_sym_LT_LT_DASH] = ACTIONS(3012),
    [anon_sym_BQUOTE] = ACTIONS(3012),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [sym_raw_string] = ACTIONS(3012),
    [sym_file_descriptor] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_AMP_GT] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_LT_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_AMP] = ACTIONS(3012),
    [anon_sym_LT_LPAREN] = ACTIONS(3012),
    [anon_sym_esac] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
    [anon_sym_PIPE_AMP] = ACTIONS(3012),
  },
  [2163] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5266),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2164] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3551),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [sym_word] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_LT_AMP] = ACTIONS(3551),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [anon_sym_EQ_TILDE] = ACTIONS(3551),
    [sym__special_character] = ACTIONS(3551),
    [anon_sym_LT_LT_DASH] = ACTIONS(3551),
    [anon_sym_BQUOTE] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3551),
    [sym_raw_string] = ACTIONS(3551),
    [sym_file_descriptor] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_AMP_GT] = ACTIONS(3551),
    [anon_sym_EQ_EQ] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_LT_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_AMP] = ACTIONS(3551),
    [anon_sym_LT_LPAREN] = ACTIONS(3551),
    [anon_sym_esac] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_PIPE_AMP] = ACTIONS(3551),
  },
  [2165] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5268),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2166] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [sym_word] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_LT_AMP] = ACTIONS(3585),
    [anon_sym_GT_GT] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [anon_sym_EQ_TILDE] = ACTIONS(3585),
    [sym__special_character] = ACTIONS(3585),
    [anon_sym_LT_LT_DASH] = ACTIONS(3585),
    [anon_sym_BQUOTE] = ACTIONS(3585),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3585),
    [sym_raw_string] = ACTIONS(3585),
    [sym_file_descriptor] = ACTIONS(3587),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_AMP_GT] = ACTIONS(3585),
    [anon_sym_EQ_EQ] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_LT_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_AMP] = ACTIONS(3585),
    [anon_sym_LT_LPAREN] = ACTIONS(3585),
    [anon_sym_esac] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
    [anon_sym_PIPE_AMP] = ACTIONS(3585),
  },
  [2167] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3589),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3589),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [sym_word] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_AMP] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [anon_sym_EQ_TILDE] = ACTIONS(3589),
    [sym__special_character] = ACTIONS(3589),
    [anon_sym_LT_LT_DASH] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(3589),
    [anon_sym_LF] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [sym_raw_string] = ACTIONS(3589),
    [sym_file_descriptor] = ACTIONS(3591),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_AMP_GT] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_LT_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_AMP] = ACTIONS(3589),
    [anon_sym_LT_LPAREN] = ACTIONS(3589),
    [anon_sym_esac] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
    [anon_sym_PIPE_AMP] = ACTIONS(3589),
  },
  [2168] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5270),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2169] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3640),
    [anon_sym_PIPE_PIPE] = ACTIONS(3640),
    [sym_word] = ACTIONS(3640),
    [anon_sym_PIPE] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_LT_AMP] = ACTIONS(3640),
    [anon_sym_GT_GT] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3640),
    [sym__special_character] = ACTIONS(3640),
    [anon_sym_LT_LT_DASH] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(3640),
    [anon_sym_LF] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3640),
    [sym_raw_string] = ACTIONS(3640),
    [sym_file_descriptor] = ACTIONS(3642),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_AMP_GT] = ACTIONS(3640),
    [anon_sym_EQ_EQ] = ACTIONS(3640),
    [anon_sym_DQUOTE] = ACTIONS(3640),
    [anon_sym_LT_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_AMP] = ACTIONS(3640),
    [anon_sym_LT_LPAREN] = ACTIONS(3640),
    [anon_sym_esac] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
    [anon_sym_PIPE_AMP] = ACTIONS(3640),
  },
  [2170] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2583),
    [anon_sym_PIPE_PIPE] = ACTIONS(2583),
    [sym_word] = ACTIONS(2583),
    [anon_sym_PIPE] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_LT_AMP] = ACTIONS(2583),
    [anon_sym_GT_GT] = ACTIONS(2583),
    [sym__concat] = ACTIONS(2585),
    [sym__special_character] = ACTIONS(2583),
    [anon_sym_LT_LT_DASH] = ACTIONS(2583),
    [anon_sym_BQUOTE] = ACTIONS(2583),
    [anon_sym_LF] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [sym_raw_string] = ACTIONS(2583),
    [sym_variable_name] = ACTIONS(2585),
    [sym_file_descriptor] = ACTIONS(2585),
    [anon_sym_GT] = ACTIONS(2583),
    [anon_sym_AMP_GT] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2583),
    [anon_sym_LT_LT_LT] = ACTIONS(2583),
    [anon_sym_GT_AMP] = ACTIONS(2583),
    [anon_sym_LT_LPAREN] = ACTIONS(2583),
    [anon_sym_esac] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2583),
    [anon_sym_SEMI_SEMI] = ACTIONS(2583),
    [anon_sym_PIPE_AMP] = ACTIONS(2583),
  },
  [2171] = {
    [sym_string] = STATE(2035),
    [anon_sym__] = ACTIONS(4852),
    [anon_sym_AMP_GT_GT] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(5272),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(5272),
    [anon_sym_GT_LPAREN] = ACTIONS(2261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4852),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2261),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [sym_word] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_LT_AMP] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(4852),
    [sym__special_character] = ACTIONS(2261),
    [anon_sym_LT_LT_DASH] = ACTIONS(2261),
    [anon_sym_BQUOTE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(4852),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(5274),
    [anon_sym_BANG] = ACTIONS(5272),
    [sym_variable_name] = ACTIONS(2265),
    [sym_file_descriptor] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(4852),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_AMP_GT] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(5276),
    [anon_sym_LT_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_AMP] = ACTIONS(2261),
    [anon_sym_LT_LPAREN] = ACTIONS(2261),
    [anon_sym_esac] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(4852),
    [anon_sym_POUND] = ACTIONS(5272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_PIPE_AMP] = ACTIONS(2261),
  },
  [2172] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2109),
    [anon_sym_DOLLAR] = ACTIONS(2109),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [sym_word] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_LT_AMP] = ACTIONS(2109),
    [anon_sym_GT_GT] = ACTIONS(2109),
    [sym__concat] = ACTIONS(2111),
    [sym__special_character] = ACTIONS(2109),
    [anon_sym_LT_LT_DASH] = ACTIONS(2109),
    [anon_sym_BQUOTE] = ACTIONS(2109),
    [anon_sym_LF] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [sym_raw_string] = ACTIONS(2109),
    [sym_variable_name] = ACTIONS(2111),
    [sym_file_descriptor] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_AMP_GT] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2109),
    [anon_sym_LT_LT_LT] = ACTIONS(2109),
    [anon_sym_GT_AMP] = ACTIONS(2109),
    [anon_sym_LT_LPAREN] = ACTIONS(2109),
    [anon_sym_esac] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_SEMI_SEMI] = ACTIONS(2109),
    [anon_sym_PIPE_AMP] = ACTIONS(2109),
  },
  [2173] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2204),
    [sym_concatenation] = STATE(2204),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5278),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5280),
    [anon_sym_DASH] = ACTIONS(5278),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5278),
    [anon_sym_PERCENT] = ACTIONS(5278),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5282),
    [anon_sym_COLON_DASH] = ACTIONS(5278),
    [sym__special_character] = ACTIONS(553),
  },
  [2174] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5280),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2175] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2204),
    [sym_concatenation] = STATE(2204),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5278),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5280),
    [anon_sym_DASH] = ACTIONS(5278),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5278),
    [anon_sym_PERCENT] = ACTIONS(5278),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5282),
    [anon_sym_COLON_DASH] = ACTIONS(5278),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(5284),
  },
  [2176] = {
    [sym_command_substitution] = STATE(2206),
    [aux_sym__literal_repeat1] = STATE(2207),
    [sym_string] = STATE(2206),
    [sym_process_substitution] = STATE(2206),
    [sym_simple_expansion] = STATE(2206),
    [sym_string_expansion] = STATE(2206),
    [sym_concatenation] = STATE(2208),
    [sym_expansion] = STATE(2206),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_word] = ACTIONS(5286),
    [sym_raw_string] = ACTIONS(5286),
    [anon_sym_LT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5280),
    [anon_sym_GT_LPAREN] = ACTIONS(1360),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1368),
  },
  [2177] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2211),
    [sym_concatenation] = STATE(2211),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5288),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5290),
    [anon_sym_DASH] = ACTIONS(5288),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5288),
    [anon_sym_PERCENT] = ACTIONS(5288),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5292),
    [anon_sym_COLON_DASH] = ACTIONS(5288),
    [sym__special_character] = ACTIONS(553),
    [sym_regex] = ACTIONS(5294),
  },
  [2178] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2205),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [sym_word] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2205),
    [anon_sym_LT_AMP] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2205),
    [sym__concat] = ACTIONS(2207),
    [sym__special_character] = ACTIONS(2205),
    [anon_sym_LT_LT_DASH] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_LF] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2205),
    [sym_variable_name] = ACTIONS(2207),
    [sym_file_descriptor] = ACTIONS(2207),
    [anon_sym_GT] = ACTIONS(2205),
    [anon_sym_AMP_GT] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [anon_sym_LT_LT_LT] = ACTIONS(2205),
    [anon_sym_GT_AMP] = ACTIONS(2205),
    [anon_sym_LT_LPAREN] = ACTIONS(2205),
    [anon_sym_esac] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_SEMI_SEMI] = ACTIONS(2205),
    [anon_sym_PIPE_AMP] = ACTIONS(2205),
  },
  [2179] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5290),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2180] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5280),
    [sym__concat] = ACTIONS(2213),
  },
  [2181] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(5296),
  },
  [2182] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5280),
  },
  [2183] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2247),
    [anon_sym_DOLLAR] = ACTIONS(2247),
    [anon_sym_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2247),
    [anon_sym_PIPE_PIPE] = ACTIONS(2247),
    [sym_word] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_LT_AMP] = ACTIONS(2247),
    [anon_sym_GT_GT] = ACTIONS(2247),
    [sym__concat] = ACTIONS(2249),
    [sym__special_character] = ACTIONS(2247),
    [anon_sym_LT_LT_DASH] = ACTIONS(2247),
    [anon_sym_BQUOTE] = ACTIONS(2247),
    [anon_sym_LF] = ACTIONS(2249),
    [anon_sym_SEMI] = ACTIONS(2247),
    [sym_raw_string] = ACTIONS(2247),
    [sym_variable_name] = ACTIONS(2249),
    [sym_file_descriptor] = ACTIONS(2249),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_AMP_GT] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_LT_LT_LT] = ACTIONS(2247),
    [anon_sym_GT_AMP] = ACTIONS(2247),
    [anon_sym_LT_LPAREN] = ACTIONS(2247),
    [anon_sym_esac] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2247),
    [anon_sym_SEMI_SEMI] = ACTIONS(2247),
    [anon_sym_PIPE_AMP] = ACTIONS(2247),
  },
  [2184] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2214),
    [sym_concatenation] = STATE(2214),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5298),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5300),
    [anon_sym_DASH] = ACTIONS(5298),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5298),
    [anon_sym_PERCENT] = ACTIONS(5298),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5302),
    [anon_sym_COLON_DASH] = ACTIONS(5298),
    [sym__special_character] = ACTIONS(553),
  },
  [2185] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5300),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2186] = {
    [sym_string] = STATE(870),
    [anon_sym__] = ACTIONS(1834),
    [anon_sym_AMP_GT_GT] = ACTIONS(2261),
    [anon_sym_DOLLAR] = ACTIONS(3944),
    [anon_sym_LT_LT] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(3944),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1834),
    [anon_sym_PIPE_PIPE] = ACTIONS(2261),
    [anon_sym_PIPE] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(2261),
    [anon_sym_LT_AMP] = ACTIONS(2261),
    [anon_sym_GT_GT] = ACTIONS(2261),
    [anon_sym_QMARK] = ACTIONS(1834),
    [anon_sym_LT_LT_DASH] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(1834),
    [anon_sym_LF] = ACTIONS(2265),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_raw_string] = ACTIONS(3946),
    [anon_sym_BANG] = ACTIONS(3944),
    [sym_file_descriptor] = ACTIONS(2265),
    [anon_sym_0] = ACTIONS(1834),
    [anon_sym_GT] = ACTIONS(2261),
    [anon_sym_AMP_GT] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(3948),
    [anon_sym_LT_LT_LT] = ACTIONS(2261),
    [anon_sym_GT_AMP] = ACTIONS(2261),
    [anon_sym_esac] = ACTIONS(2261),
    [anon_sym_AT] = ACTIONS(1834),
    [anon_sym_POUND] = ACTIONS(3944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_SEMI_SEMI] = ACTIONS(2261),
    [anon_sym_PIPE_AMP] = ACTIONS(2261),
  },
  [2187] = {
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_AMP_GT_GT] = ACTIONS(2796),
    [anon_sym_local] = ACTIONS(2794),
    [anon_sym_typeset] = ACTIONS(2794),
    [anon_sym_unsetenv] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2794),
    [anon_sym_GT_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2794),
    [sym_word] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_LT_AMP] = ACTIONS(2796),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2794),
    [sym__special_character] = ACTIONS(2794),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2794),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2796),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BQUOTE] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [sym_variable_name] = ACTIONS(2796),
    [sym_file_descriptor] = ACTIONS(2796),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP_GT] = ACTIONS(2794),
    [anon_sym_readonly] = ACTIONS(2794),
    [anon_sym_unset] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [anon_sym_GT_AMP] = ACTIONS(2796),
    [anon_sym_LT_LPAREN] = ACTIONS(2796),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2796),
    [anon_sym_SEMI_SEMI] = ACTIONS(2798),
  },
  [2188] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(5306),
    [anon_sym_SEMI_SEMI] = ACTIONS(2800),
    [anon_sym_AMP] = ACTIONS(5306),
  },
  [2189] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3551),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [sym_word] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_LT_AMP] = ACTIONS(3551),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [sym__special_character] = ACTIONS(3551),
    [anon_sym_LT_LT_DASH] = ACTIONS(3551),
    [anon_sym_BQUOTE] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3551),
    [sym_raw_string] = ACTIONS(3551),
    [sym_variable_name] = ACTIONS(3553),
    [sym_file_descriptor] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_AMP_GT] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_LT_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_AMP] = ACTIONS(3551),
    [anon_sym_LT_LPAREN] = ACTIONS(3551),
    [anon_sym_esac] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_PIPE_AMP] = ACTIONS(3551),
  },
  [2190] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5308),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2191] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3585),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [sym_word] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_LT_AMP] = ACTIONS(3585),
    [anon_sym_GT_GT] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [sym__special_character] = ACTIONS(3585),
    [anon_sym_LT_LT_DASH] = ACTIONS(3585),
    [anon_sym_BQUOTE] = ACTIONS(3585),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3585),
    [sym_raw_string] = ACTIONS(3585),
    [sym_variable_name] = ACTIONS(3587),
    [sym_file_descriptor] = ACTIONS(3587),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_AMP_GT] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_LT_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_AMP] = ACTIONS(3585),
    [anon_sym_LT_LPAREN] = ACTIONS(3585),
    [anon_sym_esac] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
    [anon_sym_PIPE_AMP] = ACTIONS(3585),
  },
  [2192] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3589),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3589),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3589),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [sym_word] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_AMP] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [sym__special_character] = ACTIONS(3589),
    [anon_sym_LT_LT_DASH] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(3589),
    [anon_sym_LF] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [sym_raw_string] = ACTIONS(3589),
    [sym_variable_name] = ACTIONS(3591),
    [sym_file_descriptor] = ACTIONS(3591),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_AMP_GT] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_LT_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_AMP] = ACTIONS(3589),
    [anon_sym_LT_LPAREN] = ACTIONS(3589),
    [anon_sym_esac] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
    [anon_sym_PIPE_AMP] = ACTIONS(3589),
  },
  [2193] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5310),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2194] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3640),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3640),
    [anon_sym_PIPE_PIPE] = ACTIONS(3640),
    [sym_word] = ACTIONS(3640),
    [anon_sym_PIPE] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_LT_AMP] = ACTIONS(3640),
    [anon_sym_GT_GT] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [sym__special_character] = ACTIONS(3640),
    [anon_sym_LT_LT_DASH] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(3640),
    [anon_sym_LF] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3640),
    [sym_raw_string] = ACTIONS(3640),
    [sym_variable_name] = ACTIONS(3642),
    [sym_file_descriptor] = ACTIONS(3642),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_AMP_GT] = ACTIONS(3640),
    [anon_sym_DQUOTE] = ACTIONS(3640),
    [anon_sym_LT_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_AMP] = ACTIONS(3640),
    [anon_sym_LT_LPAREN] = ACTIONS(3640),
    [anon_sym_esac] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
    [anon_sym_PIPE_AMP] = ACTIONS(3640),
  },
  [2195] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3551),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3551),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [sym_word] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_LT_AMP] = ACTIONS(3551),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [sym__special_character] = ACTIONS(3551),
    [anon_sym_LT_LT_DASH] = ACTIONS(3551),
    [anon_sym_BQUOTE] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3551),
    [sym_raw_string] = ACTIONS(3551),
    [sym_file_descriptor] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_AMP_GT] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_LT_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_AMP] = ACTIONS(3551),
    [anon_sym_LT_LPAREN] = ACTIONS(3551),
    [anon_sym_esac] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_PIPE_AMP] = ACTIONS(3551),
  },
  [2196] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5312),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2197] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3585),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [sym_word] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_LT_AMP] = ACTIONS(3585),
    [anon_sym_GT_GT] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [sym__special_character] = ACTIONS(3585),
    [anon_sym_LT_LT_DASH] = ACTIONS(3585),
    [anon_sym_BQUOTE] = ACTIONS(3585),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3585),
    [sym_raw_string] = ACTIONS(3585),
    [sym_file_descriptor] = ACTIONS(3587),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_AMP_GT] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_LT_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_AMP] = ACTIONS(3585),
    [anon_sym_LT_LPAREN] = ACTIONS(3585),
    [anon_sym_esac] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
    [anon_sym_PIPE_AMP] = ACTIONS(3585),
  },
  [2198] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3589),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3589),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3589),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [sym_word] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_AMP] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [sym__special_character] = ACTIONS(3589),
    [anon_sym_LT_LT_DASH] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(3589),
    [anon_sym_LF] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [sym_raw_string] = ACTIONS(3589),
    [sym_file_descriptor] = ACTIONS(3591),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_AMP_GT] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_LT_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_AMP] = ACTIONS(3589),
    [anon_sym_LT_LPAREN] = ACTIONS(3589),
    [anon_sym_esac] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
    [anon_sym_PIPE_AMP] = ACTIONS(3589),
  },
  [2199] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5314),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2200] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3640),
    [aux_sym__simple_variable_name_token1] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3640),
    [anon_sym_PIPE_PIPE] = ACTIONS(3640),
    [sym_word] = ACTIONS(3640),
    [anon_sym_PIPE] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_LT_AMP] = ACTIONS(3640),
    [anon_sym_GT_GT] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [sym__special_character] = ACTIONS(3640),
    [anon_sym_LT_LT_DASH] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(3640),
    [anon_sym_LF] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3640),
    [sym_raw_string] = ACTIONS(3640),
    [sym_file_descriptor] = ACTIONS(3642),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_AMP_GT] = ACTIONS(3640),
    [anon_sym_DQUOTE] = ACTIONS(3640),
    [anon_sym_LT_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_AMP] = ACTIONS(3640),
    [anon_sym_LT_LPAREN] = ACTIONS(3640),
    [anon_sym_esac] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
    [anon_sym_PIPE_AMP] = ACTIONS(3640),
  },
  [2201] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [sym_word] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [anon_sym_EQ_TILDE] = ACTIONS(4034),
    [sym__special_character] = ACTIONS(4034),
    [anon_sym_LT_LT_DASH] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4034),
    [sym_raw_string] = ACTIONS(4034),
    [sym_file_descriptor] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4034),
    [anon_sym_EQ_EQ] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
  },
  [2202] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [anon_sym_EQ_TILDE] = ACTIONS(4038),
    [sym__special_character] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [sym_file_descriptor] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_esac] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
  },
  [2203] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [sym_word] = ACTIONS(2896),
    [anon_sym_PIPE] = ACTIONS(2896),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2896),
    [anon_sym_LT_AMP] = ACTIONS(2896),
    [anon_sym_GT_GT] = ACTIONS(2896),
    [sym__concat] = ACTIONS(2898),
    [sym__special_character] = ACTIONS(2896),
    [anon_sym_LT_LT_DASH] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2896),
    [sym_raw_string] = ACTIONS(2896),
    [sym_variable_name] = ACTIONS(2898),
    [sym_file_descriptor] = ACTIONS(2898),
    [anon_sym_GT] = ACTIONS(2896),
    [anon_sym_AMP_GT] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [anon_sym_LT_LT_LT] = ACTIONS(2896),
    [anon_sym_GT_AMP] = ACTIONS(2896),
    [anon_sym_LT_LPAREN] = ACTIONS(2896),
    [anon_sym_esac] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_SEMI_SEMI] = ACTIONS(2896),
    [anon_sym_PIPE_AMP] = ACTIONS(2896),
  },
  [2204] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5316),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2205] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2221),
    [sym_concatenation] = STATE(2221),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5318),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5316),
    [anon_sym_DASH] = ACTIONS(5318),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5318),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5318),
    [anon_sym_PERCENT] = ACTIONS(5318),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5320),
    [anon_sym_COLON_DASH] = ACTIONS(5318),
    [sym__special_character] = ACTIONS(553),
  },
  [2206] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5316),
    [sym__concat] = ACTIONS(2213),
  },
  [2207] = {
    [aux_sym__literal_repeat1] = STATE(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(5322),
  },
  [2208] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5316),
  },
  [2209] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [sym_word] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_LT_AMP] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [sym__concat] = ACTIONS(2947),
    [sym__special_character] = ACTIONS(2945),
    [anon_sym_LT_LT_DASH] = ACTIONS(2945),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [sym_raw_string] = ACTIONS(2945),
    [sym_variable_name] = ACTIONS(2947),
    [sym_file_descriptor] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_AMP_GT] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_LT_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_AMP] = ACTIONS(2945),
    [anon_sym_LT_LPAREN] = ACTIONS(2945),
    [anon_sym_esac] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_PIPE_AMP] = ACTIONS(2945),
  },
  [2210] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(2224),
    [sym_concatenation] = STATE(2224),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(5324),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5326),
    [anon_sym_DASH] = ACTIONS(5324),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(5324),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(5324),
    [anon_sym_PERCENT] = ACTIONS(5324),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5328),
    [anon_sym_COLON_DASH] = ACTIONS(5324),
    [sym__special_character] = ACTIONS(553),
  },
  [2211] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5326),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2212] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [sym_word] = ACTIONS(2993),
    [anon_sym_PIPE] = ACTIONS(2993),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_LT_AMP] = ACTIONS(2993),
    [anon_sym_GT_GT] = ACTIONS(2993),
    [sym__concat] = ACTIONS(2995),
    [sym__special_character] = ACTIONS(2993),
    [anon_sym_LT_LT_DASH] = ACTIONS(2993),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [anon_sym_LF] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [sym_raw_string] = ACTIONS(2993),
    [sym_variable_name] = ACTIONS(2995),
    [sym_file_descriptor] = ACTIONS(2995),
    [anon_sym_GT] = ACTIONS(2993),
    [anon_sym_AMP_GT] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_LT_LT_LT] = ACTIONS(2993),
    [anon_sym_GT_AMP] = ACTIONS(2993),
    [anon_sym_LT_LPAREN] = ACTIONS(2993),
    [anon_sym_esac] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_SEMI_SEMI] = ACTIONS(2993),
    [anon_sym_PIPE_AMP] = ACTIONS(2993),
  },
  [2213] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3012),
    [anon_sym_DOLLAR] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [sym_word] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_LT_AMP] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [sym__concat] = ACTIONS(3014),
    [sym__special_character] = ACTIONS(3012),
    [anon_sym_LT_LT_DASH] = ACTIONS(3012),
    [anon_sym_BQUOTE] = ACTIONS(3012),
    [anon_sym_LF] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [sym_raw_string] = ACTIONS(3012),
    [sym_variable_name] = ACTIONS(3014),
    [sym_file_descriptor] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_AMP_GT] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_LT_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_AMP] = ACTIONS(3012),
    [anon_sym_LT_LPAREN] = ACTIONS(3012),
    [anon_sym_esac] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_SEMI_SEMI] = ACTIONS(3012),
    [anon_sym_PIPE_AMP] = ACTIONS(3012),
  },
  [2214] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5330),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2215] = {
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_AMP_GT_GT] = ACTIONS(2796),
    [anon_sym_local] = ACTIONS(2794),
    [anon_sym_typeset] = ACTIONS(2794),
    [anon_sym_unsetenv] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2794),
    [anon_sym_GT_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2794),
    [sym_word] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_LT_AMP] = ACTIONS(2796),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2794),
    [sym__special_character] = ACTIONS(2794),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2794),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2796),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BQUOTE] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [sym_variable_name] = ACTIONS(2796),
    [sym_file_descriptor] = ACTIONS(2796),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP_GT] = ACTIONS(2794),
    [anon_sym_readonly] = ACTIONS(2794),
    [anon_sym_unset] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2796),
    [anon_sym_GT_AMP] = ACTIONS(2796),
    [anon_sym_LT_LPAREN] = ACTIONS(2796),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2796),
    [anon_sym_SEMI_SEMI] = ACTIONS(3497),
  },
  [2216] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [sym_word] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [sym__special_character] = ACTIONS(4034),
    [anon_sym_LT_LT_DASH] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4034),
    [sym_raw_string] = ACTIONS(4034),
    [sym_variable_name] = ACTIONS(4036),
    [sym_file_descriptor] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
  },
  [2217] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [sym__special_character] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [sym_variable_name] = ACTIONS(4040),
    [sym_file_descriptor] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_esac] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
  },
  [2218] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [sym_word] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [sym__special_character] = ACTIONS(4034),
    [anon_sym_LT_LT_DASH] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4034),
    [sym_raw_string] = ACTIONS(4034),
    [sym_file_descriptor] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
  },
  [2219] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [aux_sym__simple_variable_name_token1] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [sym__special_character] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [sym_file_descriptor] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_esac] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
  },
  [2220] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3551),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [sym_word] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_LT_AMP] = ACTIONS(3551),
    [anon_sym_GT_GT] = ACTIONS(3551),
    [sym__concat] = ACTIONS(3553),
    [sym__special_character] = ACTIONS(3551),
    [anon_sym_LT_LT_DASH] = ACTIONS(3551),
    [anon_sym_BQUOTE] = ACTIONS(3551),
    [anon_sym_LF] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3551),
    [sym_raw_string] = ACTIONS(3551),
    [sym_variable_name] = ACTIONS(3553),
    [sym_file_descriptor] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3551),
    [anon_sym_AMP_GT] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_LT_LT_LT] = ACTIONS(3551),
    [anon_sym_GT_AMP] = ACTIONS(3551),
    [anon_sym_LT_LPAREN] = ACTIONS(3551),
    [anon_sym_esac] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_SEMI_SEMI] = ACTIONS(3551),
    [anon_sym_PIPE_AMP] = ACTIONS(3551),
  },
  [2221] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5332),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2222] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3585),
    [anon_sym_PIPE_PIPE] = ACTIONS(3585),
    [sym_word] = ACTIONS(3585),
    [anon_sym_PIPE] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_LT] = ACTIONS(3585),
    [anon_sym_LT_AMP] = ACTIONS(3585),
    [anon_sym_GT_GT] = ACTIONS(3585),
    [sym__concat] = ACTIONS(3587),
    [sym__special_character] = ACTIONS(3585),
    [anon_sym_LT_LT_DASH] = ACTIONS(3585),
    [anon_sym_BQUOTE] = ACTIONS(3585),
    [anon_sym_LF] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3585),
    [sym_raw_string] = ACTIONS(3585),
    [sym_variable_name] = ACTIONS(3587),
    [sym_file_descriptor] = ACTIONS(3587),
    [anon_sym_GT] = ACTIONS(3585),
    [anon_sym_AMP_GT] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_LT_LT_LT] = ACTIONS(3585),
    [anon_sym_GT_AMP] = ACTIONS(3585),
    [anon_sym_LT_LPAREN] = ACTIONS(3585),
    [anon_sym_esac] = ACTIONS(3585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3585),
    [anon_sym_SEMI_SEMI] = ACTIONS(3585),
    [anon_sym_PIPE_AMP] = ACTIONS(3585),
  },
  [2223] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3589),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [anon_sym_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3589),
    [anon_sym_PIPE_PIPE] = ACTIONS(3589),
    [sym_word] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_AMP] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3589),
    [sym__concat] = ACTIONS(3591),
    [sym__special_character] = ACTIONS(3589),
    [anon_sym_LT_LT_DASH] = ACTIONS(3589),
    [anon_sym_BQUOTE] = ACTIONS(3589),
    [anon_sym_LF] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3589),
    [sym_raw_string] = ACTIONS(3589),
    [sym_variable_name] = ACTIONS(3591),
    [sym_file_descriptor] = ACTIONS(3591),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_AMP_GT] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_LT_LT_LT] = ACTIONS(3589),
    [anon_sym_GT_AMP] = ACTIONS(3589),
    [anon_sym_LT_LPAREN] = ACTIONS(3589),
    [anon_sym_esac] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3589),
    [anon_sym_SEMI_SEMI] = ACTIONS(3589),
    [anon_sym_PIPE_AMP] = ACTIONS(3589),
  },
  [2224] = {
    [sym_command_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(302),
    [sym_string] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [aux_sym_expansion_repeat1] = STATE(628),
    [sym_concatenation] = STATE(628),
    [sym_expansion] = STATE(294),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_raw_string] = ACTIONS(533),
    [anon_sym_COLON_QMARK] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(5334),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(541),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(543),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(545),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(547),
    [sym_word] = ACTIONS(549),
    [anon_sym_LT_LPAREN] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1340),
    [anon_sym_COLON_DASH] = ACTIONS(1338),
    [sym__special_character] = ACTIONS(553),
  },
  [2225] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(3640),
    [anon_sym_DOLLAR] = ACTIONS(3640),
    [anon_sym_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3640),
    [anon_sym_PIPE_PIPE] = ACTIONS(3640),
    [sym_word] = ACTIONS(3640),
    [anon_sym_PIPE] = ACTIONS(3640),
    [anon_sym_AMP] = ACTIONS(3640),
    [anon_sym_LT] = ACTIONS(3640),
    [anon_sym_LT_AMP] = ACTIONS(3640),
    [anon_sym_GT_GT] = ACTIONS(3640),
    [sym__concat] = ACTIONS(3642),
    [sym__special_character] = ACTIONS(3640),
    [anon_sym_LT_LT_DASH] = ACTIONS(3640),
    [anon_sym_BQUOTE] = ACTIONS(3640),
    [anon_sym_LF] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3640),
    [sym_raw_string] = ACTIONS(3640),
    [sym_variable_name] = ACTIONS(3642),
    [sym_file_descriptor] = ACTIONS(3642),
    [anon_sym_GT] = ACTIONS(3640),
    [anon_sym_AMP_GT] = ACTIONS(3640),
    [anon_sym_DQUOTE] = ACTIONS(3640),
    [anon_sym_LT_LT_LT] = ACTIONS(3640),
    [anon_sym_GT_AMP] = ACTIONS(3640),
    [anon_sym_LT_LPAREN] = ACTIONS(3640),
    [anon_sym_esac] = ACTIONS(3640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3640),
    [anon_sym_SEMI_SEMI] = ACTIONS(3640),
    [anon_sym_PIPE_AMP] = ACTIONS(3640),
  },
  [2226] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4034),
    [anon_sym_DOLLAR] = ACTIONS(4034),
    [anon_sym_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4034),
    [anon_sym_PIPE_PIPE] = ACTIONS(4034),
    [sym_word] = ACTIONS(4034),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4034),
    [anon_sym_LT_AMP] = ACTIONS(4034),
    [anon_sym_GT_GT] = ACTIONS(4034),
    [sym__concat] = ACTIONS(4036),
    [sym__special_character] = ACTIONS(4034),
    [anon_sym_LT_LT_DASH] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4034),
    [anon_sym_LF] = ACTIONS(4036),
    [anon_sym_SEMI] = ACTIONS(4034),
    [sym_raw_string] = ACTIONS(4034),
    [sym_variable_name] = ACTIONS(4036),
    [sym_file_descriptor] = ACTIONS(4036),
    [anon_sym_GT] = ACTIONS(4034),
    [anon_sym_AMP_GT] = ACTIONS(4034),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_LT_LT_LT] = ACTIONS(4034),
    [anon_sym_GT_AMP] = ACTIONS(4034),
    [anon_sym_LT_LPAREN] = ACTIONS(4034),
    [anon_sym_esac] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4034),
    [anon_sym_SEMI_SEMI] = ACTIONS(4034),
    [anon_sym_PIPE_AMP] = ACTIONS(4034),
  },
  [2227] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(4038),
    [anon_sym_DOLLAR] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [sym_word] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4038),
    [anon_sym_AMP] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_LT_AMP] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4038),
    [sym__concat] = ACTIONS(4040),
    [sym__special_character] = ACTIONS(4038),
    [anon_sym_LT_LT_DASH] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_LF] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(4038),
    [sym_raw_string] = ACTIONS(4038),
    [sym_variable_name] = ACTIONS(4040),
    [sym_file_descriptor] = ACTIONS(4040),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_AMP_GT] = ACTIONS(4038),
    [anon_sym_DQUOTE] = ACTIONS(4038),
    [anon_sym_LT_LT_LT] = ACTIONS(4038),
    [anon_sym_GT_AMP] = ACTIONS(4038),
    [anon_sym_LT_LPAREN] = ACTIONS(4038),
    [anon_sym_esac] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_SEMI_SEMI] = ACTIONS(4038),
    [anon_sym_PIPE_AMP] = ACTIONS(4038),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = false}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = false}, SHIFT(4),
  [11] = {.count = 1, .reusable = false}, SHIFT(5),
  [13] = {.count = 1, .reusable = false}, SHIFT(6),
  [15] = {.count = 1, .reusable = true}, SHIFT(7),
  [17] = {.count = 1, .reusable = true}, SHIFT(8),
  [19] = {.count = 1, .reusable = true}, SHIFT(9),
  [21] = {.count = 1, .reusable = false}, SHIFT(10),
  [23] = {.count = 1, .reusable = false}, SHIFT(11),
  [25] = {.count = 1, .reusable = true}, SHIFT(12),
  [27] = {.count = 1, .reusable = false}, SHIFT(3),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = false}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = true}, SHIFT(16),
  [37] = {.count = 1, .reusable = true}, SHIFT(17),
  [39] = {.count = 1, .reusable = true}, SHIFT(18),
  [41] = {.count = 1, .reusable = false}, SHIFT(19),
  [43] = {.count = 1, .reusable = true}, SHIFT(20),
  [45] = {.count = 1, .reusable = true}, SHIFT(21),
  [47] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [53] = {.count = 1, .reusable = false}, SHIFT(23),
  [55] = {.count = 1, .reusable = false}, SHIFT(24),
  [57] = {.count = 1, .reusable = false}, SHIFT(25),
  [59] = {.count = 1, .reusable = true}, SHIFT(26),
  [61] = {.count = 1, .reusable = false}, SHIFT(37),
  [63] = {.count = 1, .reusable = false}, SHIFT(38),
  [65] = {.count = 1, .reusable = false}, SHIFT(39),
  [67] = {.count = 1, .reusable = false}, SHIFT(40),
  [69] = {.count = 1, .reusable = true}, SHIFT(41),
  [71] = {.count = 1, .reusable = false}, SHIFT(42),
  [73] = {.count = 1, .reusable = true}, SHIFT(43),
  [75] = {.count = 1, .reusable = true}, SHIFT(52),
  [77] = {.count = 1, .reusable = true}, SHIFT(53),
  [79] = {.count = 1, .reusable = true}, SHIFT(54),
  [81] = {.count = 1, .reusable = true}, SHIFT(55),
  [83] = {.count = 1, .reusable = false}, SHIFT(56),
  [85] = {.count = 1, .reusable = true}, SHIFT(57),
  [87] = {.count = 1, .reusable = true}, SHIFT(58),
  [89] = {.count = 1, .reusable = true}, SHIFT(59),
  [91] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [93] = {.count = 1, .reusable = false}, SHIFT(67),
  [95] = {.count = 1, .reusable = false}, SHIFT(65),
  [97] = {.count = 1, .reusable = false}, SHIFT(68),
  [99] = {.count = 1, .reusable = false}, SHIFT(72),
  [101] = {.count = 1, .reusable = false}, SHIFT(70),
  [103] = {.count = 1, .reusable = false}, SHIFT(64),
  [105] = {.count = 1, .reusable = false}, SHIFT(69),
  [107] = {.count = 1, .reusable = false}, SHIFT(62),
  [109] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [111] = {.count = 1, .reusable = true}, SHIFT(66),
  [113] = {.count = 1, .reusable = false}, SHIFT(63),
  [115] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [117] = {.count = 1, .reusable = false}, SHIFT(78),
  [119] = {.count = 1, .reusable = false}, SHIFT(77),
  [121] = {.count = 1, .reusable = false}, SHIFT(79),
  [123] = {.count = 1, .reusable = false}, SHIFT(83),
  [125] = {.count = 1, .reusable = false}, SHIFT(81),
  [127] = {.count = 1, .reusable = false}, SHIFT(76),
  [129] = {.count = 1, .reusable = false}, SHIFT(80),
  [131] = {.count = 1, .reusable = false}, SHIFT(74),
  [133] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [135] = {.count = 1, .reusable = false}, SHIFT(75),
  [137] = {.count = 1, .reusable = true}, SHIFT(84),
  [139] = {.count = 1, .reusable = true}, SHIFT(85),
  [141] = {.count = 1, .reusable = true}, SHIFT(86),
  [143] = {.count = 1, .reusable = false}, SHIFT(84),
  [145] = {.count = 1, .reusable = true}, SHIFT(88),
  [147] = {.count = 1, .reusable = false}, SHIFT(88),
  [149] = {.count = 1, .reusable = true}, SHIFT(89),
  [151] = {.count = 1, .reusable = true}, SHIFT(92),
  [153] = {.count = 1, .reusable = true}, SHIFT(93),
  [155] = {.count = 1, .reusable = true}, SHIFT(94),
  [157] = {.count = 1, .reusable = true}, SHIFT(95),
  [159] = {.count = 1, .reusable = false}, SHIFT(92),
  [161] = {.count = 1, .reusable = true}, SHIFT(96),
  [163] = {.count = 1, .reusable = false}, SHIFT(97),
  [165] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [167] = {.count = 1, .reusable = true}, SHIFT(98),
  [169] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [171] = {.count = 1, .reusable = false}, SHIFT(100),
  [173] = {.count = 1, .reusable = false}, SHIFT(101),
  [175] = {.count = 1, .reusable = false}, SHIFT(102),
  [177] = {.count = 1, .reusable = false}, SHIFT(103),
  [179] = {.count = 1, .reusable = true}, SHIFT(104),
  [181] = {.count = 1, .reusable = false}, SHIFT(105),
  [183] = {.count = 1, .reusable = true}, SHIFT(106),
  [185] = {.count = 1, .reusable = true}, SHIFT(107),
  [187] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 1),
  [189] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 1),
  [191] = {.count = 1, .reusable = true}, SHIFT(118),
  [193] = {.count = 1, .reusable = true}, SHIFT(119),
  [195] = {.count = 1, .reusable = true}, SHIFT(120),
  [197] = {.count = 1, .reusable = true}, SHIFT(121),
  [199] = {.count = 1, .reusable = false}, SHIFT(122),
  [201] = {.count = 1, .reusable = true}, SHIFT(123),
  [203] = {.count = 1, .reusable = true}, SHIFT(124),
  [205] = {.count = 1, .reusable = true}, SHIFT(125),
  [207] = {.count = 1, .reusable = true}, SHIFT(128),
  [209] = {.count = 1, .reusable = true}, SHIFT(129),
  [211] = {.count = 1, .reusable = true}, SHIFT(130),
  [213] = {.count = 1, .reusable = false}, SHIFT(131),
  [215] = {.count = 1, .reusable = true}, SHIFT(131),
  [217] = {.count = 1, .reusable = true}, SHIFT(132),
  [219] = {.count = 1, .reusable = false}, SHIFT(128),
  [221] = {.count = 1, .reusable = true}, SHIFT(133),
  [223] = {.count = 1, .reusable = false}, SHIFT(134),
  [225] = {.count = 1, .reusable = true}, SHIFT(135),
  [227] = {.count = 1, .reusable = true}, SHIFT(136),
  [229] = {.count = 1, .reusable = true}, SHIFT(137),
  [231] = {.count = 1, .reusable = false}, SHIFT(140),
  [233] = {.count = 1, .reusable = false}, SHIFT(141),
  [235] = {.count = 1, .reusable = false}, SHIFT(142),
  [237] = {.count = 1, .reusable = true}, SHIFT(149),
  [239] = {.count = 1, .reusable = true}, SHIFT(152),
  [241] = {.count = 1, .reusable = true}, SHIFT(153),
  [243] = {.count = 1, .reusable = true}, SHIFT(154),
  [245] = {.count = 1, .reusable = false}, SHIFT(154),
  [247] = {.count = 1, .reusable = false}, SHIFT(155),
  [249] = {.count = 1, .reusable = true}, SHIFT(156),
  [251] = {.count = 1, .reusable = true}, SHIFT(157),
  [253] = {.count = 1, .reusable = true}, SHIFT(158),
  [255] = {.count = 1, .reusable = true}, SHIFT(159),
  [257] = {.count = 1, .reusable = false}, SHIFT(160),
  [259] = {.count = 1, .reusable = true}, SHIFT(162),
  [261] = {.count = 1, .reusable = true}, SHIFT(163),
  [263] = {.count = 1, .reusable = true}, SHIFT(165),
  [265] = {.count = 1, .reusable = true}, SHIFT(166),
  [267] = {.count = 1, .reusable = true}, SHIFT(167),
  [269] = {.count = 1, .reusable = false}, SHIFT(168),
  [271] = {.count = 1, .reusable = true}, SHIFT(168),
  [273] = {.count = 1, .reusable = true}, SHIFT(169),
  [275] = {.count = 1, .reusable = false}, SHIFT(165),
  [277] = {.count = 1, .reusable = true}, SHIFT(170),
  [279] = {.count = 1, .reusable = false}, SHIFT(171),
  [281] = {.count = 1, .reusable = true}, SHIFT(172),
  [283] = {.count = 1, .reusable = true}, SHIFT(173),
  [285] = {.count = 1, .reusable = true}, SHIFT(174),
  [287] = {.count = 1, .reusable = true}, SHIFT(177),
  [289] = {.count = 1, .reusable = false}, SHIFT(178),
  [291] = {.count = 1, .reusable = true}, SHIFT(178),
  [293] = {.count = 1, .reusable = false}, SHIFT(177),
  [295] = {.count = 1, .reusable = true}, SHIFT(179),
  [297] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [299] = {.count = 1, .reusable = false}, SHIFT(182),
  [301] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [303] = {.count = 1, .reusable = false}, SHIFT(187),
  [305] = {.count = 1, .reusable = false}, SHIFT(185),
  [307] = {.count = 1, .reusable = true}, SHIFT(186),
  [309] = {.count = 1, .reusable = true}, SHIFT(188),
  [311] = {.count = 1, .reusable = false}, SHIFT(189),
  [313] = {.count = 1, .reusable = false}, SHIFT(190),
  [315] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [317] = {.count = 1, .reusable = false}, SHIFT(191),
  [319] = {.count = 1, .reusable = false}, SHIFT(184),
  [321] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [323] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [325] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [327] = {.count = 1, .reusable = true}, SHIFT(13),
  [329] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [331] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [333] = {.count = 1, .reusable = false}, SHIFT(7),
  [335] = {.count = 1, .reusable = false}, SHIFT(8),
  [337] = {.count = 1, .reusable = false}, SHIFT(9),
  [339] = {.count = 1, .reusable = false}, SHIFT(198),
  [341] = {.count = 1, .reusable = false}, SHIFT(199),
  [343] = {.count = 1, .reusable = false}, SHIFT(18),
  [345] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [347] = {.count = 1, .reusable = false}, SHIFT(22),
  [349] = {.count = 1, .reusable = false}, SHIFT(206),
  [351] = {.count = 1, .reusable = false}, SHIFT(202),
  [353] = {.count = 1, .reusable = false}, SHIFT(204),
  [355] = {.count = 1, .reusable = true}, SHIFT(203),
  [357] = {.count = 1, .reusable = false}, SHIFT(211),
  [359] = {.count = 1, .reusable = false}, SHIFT(208),
  [361] = {.count = 1, .reusable = false}, SHIFT(209),
  [363] = {.count = 1, .reusable = true}, SHIFT(213),
  [365] = {.count = 1, .reusable = false}, SHIFT(216),
  [367] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 1),
  [369] = {.count = 1, .reusable = true}, SHIFT(217),
  [371] = {.count = 1, .reusable = false}, SHIFT(218),
  [373] = {.count = 1, .reusable = false}, SHIFT(219),
  [375] = {.count = 1, .reusable = false}, SHIFT(215),
  [377] = {.count = 1, .reusable = true}, SHIFT(40),
  [379] = {.count = 1, .reusable = true}, SHIFT(224),
  [381] = {.count = 1, .reusable = false}, SHIFT(225),
  [383] = {.count = 1, .reusable = false}, SHIFT(226),
  [385] = {.count = 1, .reusable = false}, SHIFT(230),
  [387] = {.count = 1, .reusable = true}, SHIFT(231),
  [389] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [391] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [393] = {.count = 1, .reusable = true}, SHIFT(233),
  [395] = {.count = 1, .reusable = true}, SHIFT(236),
  [397] = {.count = 1, .reusable = true}, SHIFT(237),
  [399] = {.count = 1, .reusable = true}, SHIFT(238),
  [401] = {.count = 1, .reusable = false}, SHIFT(236),
  [403] = {.count = 1, .reusable = true}, SHIFT(241),
  [405] = {.count = 1, .reusable = true}, SHIFT(242),
  [407] = {.count = 1, .reusable = true}, SHIFT(243),
  [409] = {.count = 1, .reusable = true}, SHIFT(244),
  [411] = {.count = 1, .reusable = false}, SHIFT(241),
  [413] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [415] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [417] = {.count = 1, .reusable = true}, SHIFT(245),
  [419] = {.count = 1, .reusable = false}, SHIFT(248),
  [421] = {.count = 1, .reusable = true}, SHIFT(249),
  [423] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [425] = {.count = 1, .reusable = true}, SHIFT(251),
  [427] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [429] = {.count = 1, .reusable = true}, SHIFT(254),
  [431] = {.count = 1, .reusable = true}, SHIFT(63),
  [433] = {.count = 1, .reusable = true}, SHIFT(255),
  [435] = {.count = 1, .reusable = true}, SHIFT(256),
  [437] = {.count = 1, .reusable = true}, SHIFT(257),
  [439] = {.count = 1, .reusable = false}, SHIFT(255),
  [441] = {.count = 1, .reusable = true}, SHIFT(260),
  [443] = {.count = 1, .reusable = true}, SHIFT(261),
  [445] = {.count = 1, .reusable = true}, SHIFT(262),
  [447] = {.count = 1, .reusable = true}, SHIFT(263),
  [449] = {.count = 1, .reusable = false}, SHIFT(260),
  [451] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [453] = {.count = 1, .reusable = false}, SHIFT(264),
  [455] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [457] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [459] = {.count = 1, .reusable = false}, SHIFT(266),
  [461] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [463] = {.count = 1, .reusable = false}, SHIFT(268),
  [465] = {.count = 1, .reusable = true}, SHIFT(269),
  [467] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [469] = {.count = 1, .reusable = true}, SHIFT(271),
  [471] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [473] = {.count = 1, .reusable = true}, SHIFT(75),
  [475] = {.count = 1, .reusable = true}, SHIFT(274),
  [477] = {.count = 1, .reusable = true}, SHIFT(275),
  [479] = {.count = 1, .reusable = true}, SHIFT(276),
  [481] = {.count = 1, .reusable = false}, SHIFT(274),
  [483] = {.count = 1, .reusable = true}, SHIFT(279),
  [485] = {.count = 1, .reusable = true}, SHIFT(280),
  [487] = {.count = 1, .reusable = true}, SHIFT(281),
  [489] = {.count = 1, .reusable = true}, SHIFT(282),
  [491] = {.count = 1, .reusable = false}, SHIFT(279),
  [493] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [495] = {.count = 1, .reusable = false}, SHIFT(283),
  [497] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [499] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [501] = {.count = 1, .reusable = false}, SHIFT(285),
  [503] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [505] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2),
  [507] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2),
  [509] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [511] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [513] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [515] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [517] = {.count = 1, .reusable = true}, SHIFT(286),
  [519] = {.count = 1, .reusable = true}, SHIFT(287),
  [521] = {.count = 1, .reusable = true}, SHIFT(288),
  [523] = {.count = 1, .reusable = true}, SHIFT(290),
  [525] = {.count = 1, .reusable = false}, SHIFT(290),
  [527] = {.count = 1, .reusable = true}, SHIFT(291),
  [529] = {.count = 1, .reusable = true}, SHIFT(292),
  [531] = {.count = 1, .reusable = true}, SHIFT(293),
  [533] = {.count = 1, .reusable = true}, SHIFT(294),
  [535] = {.count = 1, .reusable = false}, SHIFT(303),
  [537] = {.count = 1, .reusable = false}, SHIFT(295),
  [539] = {.count = 1, .reusable = true}, SHIFT(299),
  [541] = {.count = 1, .reusable = true}, SHIFT(296),
  [543] = {.count = 1, .reusable = true}, SHIFT(297),
  [545] = {.count = 1, .reusable = true}, SHIFT(298),
  [547] = {.count = 1, .reusable = true}, SHIFT(300),
  [549] = {.count = 1, .reusable = false}, SHIFT(294),
  [551] = {.count = 1, .reusable = true}, SHIFT(303),
  [553] = {.count = 1, .reusable = false}, SHIFT(301),
  [555] = {.count = 1, .reusable = true}, SHIFT(304),
  [557] = {.count = 1, .reusable = true}, SHIFT(305),
  [559] = {.count = 1, .reusable = true}, SHIFT(306),
  [561] = {.count = 1, .reusable = false}, SHIFT(304),
  [563] = {.count = 1, .reusable = true}, SHIFT(307),
  [565] = {.count = 1, .reusable = true}, SHIFT(308),
  [567] = {.count = 1, .reusable = true}, SHIFT(309),
  [569] = {.count = 1, .reusable = false}, SHIFT(311),
  [571] = {.count = 1, .reusable = true}, SHIFT(310),
  [573] = {.count = 1, .reusable = true}, SHIFT(311),
  [575] = {.count = 1, .reusable = true}, SHIFT(312),
  [577] = {.count = 1, .reusable = true}, SHIFT(314),
  [579] = {.count = 1, .reusable = true}, SHIFT(315),
  [581] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [583] = {.count = 1, .reusable = true}, SHIFT(316),
  [585] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [587] = {.count = 1, .reusable = false}, SHIFT(322),
  [589] = {.count = 1, .reusable = false}, SHIFT(318),
  [591] = {.count = 1, .reusable = false}, SHIFT(320),
  [593] = {.count = 1, .reusable = true}, SHIFT(319),
  [595] = {.count = 1, .reusable = false}, SHIFT(327),
  [597] = {.count = 1, .reusable = false}, SHIFT(324),
  [599] = {.count = 1, .reusable = false}, SHIFT(325),
  [601] = {.count = 1, .reusable = true}, SHIFT(329),
  [603] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [605] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [607] = {.count = 1, .reusable = false}, SHIFT(337),
  [609] = {.count = 1, .reusable = false}, SHIFT(332),
  [611] = {.count = 1, .reusable = true}, SHIFT(333),
  [613] = {.count = 1, .reusable = false}, SHIFT(331),
  [615] = {.count = 1, .reusable = true}, SHIFT(334),
  [617] = {.count = 1, .reusable = false}, SHIFT(335),
  [619] = {.count = 1, .reusable = false}, SHIFT(336),
  [621] = {.count = 1, .reusable = true}, SHIFT(339),
  [623] = {.count = 1, .reusable = true}, SHIFT(103),
  [625] = {.count = 1, .reusable = false}, SHIFT(342),
  [627] = {.count = 1, .reusable = false}, SHIFT(343),
  [629] = {.count = 1, .reusable = true}, SHIFT(346),
  [631] = {.count = 1, .reusable = false}, SHIFT(347),
  [633] = {.count = 1, .reusable = true}, SHIFT(347),
  [635] = {.count = 1, .reusable = false}, SHIFT(349),
  [637] = {.count = 1, .reusable = true}, SHIFT(350),
  [639] = {.count = 1, .reusable = false}, SHIFT(352),
  [641] = {.count = 1, .reusable = true}, SHIFT(353),
  [643] = {.count = 1, .reusable = true}, SHIFT(352),
  [645] = {.count = 1, .reusable = false}, SHIFT(354),
  [647] = {.count = 1, .reusable = true}, SHIFT(357),
  [649] = {.count = 1, .reusable = true}, SHIFT(358),
  [651] = {.count = 1, .reusable = true}, SHIFT(359),
  [653] = {.count = 1, .reusable = false}, SHIFT(357),
  [655] = {.count = 1, .reusable = true}, SHIFT(362),
  [657] = {.count = 1, .reusable = true}, SHIFT(363),
  [659] = {.count = 1, .reusable = true}, SHIFT(364),
  [661] = {.count = 1, .reusable = true}, SHIFT(365),
  [663] = {.count = 1, .reusable = false}, SHIFT(362),
  [665] = {.count = 1, .reusable = false}, SHIFT(368),
  [667] = {.count = 1, .reusable = false}, SHIFT(366),
  [669] = {.count = 1, .reusable = true}, SHIFT(366),
  [671] = {.count = 1, .reusable = false}, SHIFT(367),
  [673] = {.count = 1, .reusable = true}, SHIFT(371),
  [675] = {.count = 1, .reusable = false}, SHIFT(372),
  [677] = {.count = 1, .reusable = true}, SHIFT(372),
  [679] = {.count = 1, .reusable = false}, SHIFT(371),
  [681] = {.count = 1, .reusable = true}, SHIFT(373),
  [683] = {.count = 1, .reusable = false}, SHIFT(376),
  [685] = {.count = 1, .reusable = true}, SHIFT(377),
  [687] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [689] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [691] = {.count = 1, .reusable = true}, SHIFT(379),
  [693] = {.count = 1, .reusable = true}, SHIFT(383),
  [695] = {.count = 1, .reusable = true}, SHIFT(384),
  [697] = {.count = 1, .reusable = true}, SHIFT(385),
  [699] = {.count = 1, .reusable = false}, SHIFT(383),
  [701] = {.count = 1, .reusable = true}, SHIFT(388),
  [703] = {.count = 1, .reusable = true}, SHIFT(389),
  [705] = {.count = 1, .reusable = true}, SHIFT(390),
  [707] = {.count = 1, .reusable = true}, SHIFT(391),
  [709] = {.count = 1, .reusable = false}, SHIFT(388),
  [711] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [713] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [715] = {.count = 1, .reusable = true}, SHIFT(392),
  [717] = {.count = 1, .reusable = true}, SHIFT(394),
  [719] = {.count = 1, .reusable = true}, SHIFT(395),
  [721] = {.count = 1, .reusable = false}, SHIFT(394),
  [723] = {.count = 1, .reusable = true}, SHIFT(396),
  [725] = {.count = 1, .reusable = true}, SHIFT(397),
  [727] = {.count = 1, .reusable = false}, SHIFT(398),
  [729] = {.count = 1, .reusable = false}, SHIFT(399),
  [731] = {.count = 1, .reusable = false}, SHIFT(403),
  [733] = {.count = 1, .reusable = false}, SHIFT(401),
  [735] = {.count = 1, .reusable = true}, SHIFT(402),
  [737] = {.count = 1, .reusable = true}, SHIFT(404),
  [739] = {.count = 1, .reusable = false}, SHIFT(405),
  [741] = {.count = 1, .reusable = false}, SHIFT(406),
  [743] = {.count = 1, .reusable = false}, SHIFT(400),
  [745] = {.count = 1, .reusable = true}, SHIFT(412),
  [747] = {.count = 1, .reusable = false}, REDUCE(sym_negated_command, 2),
  [749] = {.count = 1, .reusable = true}, REDUCE(sym_negated_command, 2),
  [751] = {.count = 1, .reusable = true}, SHIFT(413),
  [753] = {.count = 1, .reusable = true}, SHIFT(414),
  [755] = {.count = 1, .reusable = true}, SHIFT(415),
  [757] = {.count = 1, .reusable = true}, SHIFT(416),
  [759] = {.count = 1, .reusable = true}, SHIFT(417),
  [761] = {.count = 1, .reusable = false}, SHIFT(418),
  [763] = {.count = 1, .reusable = true}, SHIFT(419),
  [765] = {.count = 1, .reusable = true}, SHIFT(420),
  [767] = {.count = 1, .reusable = true}, SHIFT(421),
  [769] = {.count = 1, .reusable = true}, SHIFT(422),
  [771] = {.count = 1, .reusable = true}, SHIFT(424),
  [773] = {.count = 1, .reusable = true}, SHIFT(425),
  [775] = {.count = 1, .reusable = true}, SHIFT(428),
  [777] = {.count = 1, .reusable = true}, SHIFT(431),
  [779] = {.count = 1, .reusable = true}, SHIFT(432),
  [781] = {.count = 1, .reusable = true}, SHIFT(433),
  [783] = {.count = 1, .reusable = false}, SHIFT(431),
  [785] = {.count = 1, .reusable = false}, SHIFT(434),
  [787] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [789] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [791] = {.count = 1, .reusable = true}, SHIFT(438),
  [793] = {.count = 1, .reusable = true}, SHIFT(439),
  [795] = {.count = 1, .reusable = true}, SHIFT(440),
  [797] = {.count = 1, .reusable = true}, SHIFT(441),
  [799] = {.count = 1, .reusable = false}, SHIFT(438),
  [801] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [803] = {.count = 1, .reusable = true}, SHIFT(442),
  [805] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [807] = {.count = 1, .reusable = false}, SHIFT(443),
  [809] = {.count = 1, .reusable = false}, SHIFT(446),
  [811] = {.count = 1, .reusable = true}, SHIFT(446),
  [813] = {.count = 1, .reusable = false}, SHIFT(445),
  [815] = {.count = 1, .reusable = true}, SHIFT(447),
  [817] = {.count = 1, .reusable = false}, SHIFT(448),
  [819] = {.count = 1, .reusable = false}, SHIFT(449),
  [821] = {.count = 1, .reusable = false}, SHIFT(450),
  [823] = {.count = 1, .reusable = false}, SHIFT(451),
  [825] = {.count = 1, .reusable = false}, SHIFT(447),
  [827] = {.count = 1, .reusable = false}, SHIFT(452),
  [829] = {.count = 1, .reusable = false}, SHIFT(453),
  [831] = {.count = 1, .reusable = false}, SHIFT(454),
  [833] = {.count = 1, .reusable = false}, SHIFT(455),
  [835] = {.count = 1, .reusable = false}, SHIFT(456),
  [837] = {.count = 1, .reusable = false}, SHIFT(457),
  [839] = {.count = 1, .reusable = true}, SHIFT(460),
  [841] = {.count = 1, .reusable = false}, SHIFT(464),
  [843] = {.count = 1, .reusable = true}, SHIFT(465),
  [845] = {.count = 1, .reusable = true}, SHIFT(467),
  [847] = {.count = 1, .reusable = true}, SHIFT(471),
  [849] = {.count = 1, .reusable = true}, SHIFT(472),
  [851] = {.count = 1, .reusable = true}, SHIFT(473),
  [853] = {.count = 1, .reusable = false}, SHIFT(471),
  [855] = {.count = 1, .reusable = true}, SHIFT(476),
  [857] = {.count = 1, .reusable = true}, SHIFT(477),
  [859] = {.count = 1, .reusable = true}, SHIFT(478),
  [861] = {.count = 1, .reusable = true}, SHIFT(479),
  [863] = {.count = 1, .reusable = false}, SHIFT(476),
  [865] = {.count = 1, .reusable = false}, SHIFT(480),
  [867] = {.count = 1, .reusable = true}, SHIFT(482),
  [869] = {.count = 1, .reusable = true}, SHIFT(483),
  [871] = {.count = 1, .reusable = false}, SHIFT(482),
  [873] = {.count = 1, .reusable = true}, SHIFT(484),
  [875] = {.count = 1, .reusable = false}, SHIFT(392),
  [877] = {.count = 1, .reusable = true}, SHIFT(488),
  [879] = {.count = 1, .reusable = false}, SHIFT(488),
  [881] = {.count = 1, .reusable = true}, SHIFT(489),
  [883] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2),
  [885] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(182),
  [888] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2),
  [890] = {.count = 1, .reusable = true}, SHIFT(492),
  [892] = {.count = 1, .reusable = true}, SHIFT(493),
  [894] = {.count = 1, .reusable = true}, SHIFT(494),
  [896] = {.count = 1, .reusable = true}, SHIFT(495),
  [898] = {.count = 1, .reusable = false}, SHIFT(496),
  [900] = {.count = 1, .reusable = true}, SHIFT(497),
  [902] = {.count = 1, .reusable = true}, SHIFT(498),
  [904] = {.count = 1, .reusable = true}, SHIFT(499),
  [906] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [908] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [910] = {.count = 1, .reusable = true}, SHIFT(502),
  [912] = {.count = 1, .reusable = true}, SHIFT(503),
  [914] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [916] = {.count = 1, .reusable = true}, SHIFT(505),
  [918] = {.count = 1, .reusable = false}, SHIFT(505),
  [920] = {.count = 1, .reusable = true}, SHIFT(506),
  [922] = {.count = 1, .reusable = true}, SHIFT(509),
  [924] = {.count = 1, .reusable = true}, REDUCE(sym_redirected_statement, 2),
  [926] = {.count = 1, .reusable = false}, REDUCE(sym_redirected_statement, 2),
  [928] = {.count = 1, .reusable = true}, SHIFT(514),
  [930] = {.count = 1, .reusable = false}, SHIFT(513),
  [932] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2),
  [935] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(3),
  [938] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(100),
  [941] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(101),
  [944] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(6),
  [947] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(7),
  [950] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8),
  [953] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9),
  [956] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(10),
  [959] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(102),
  [962] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(12),
  [965] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(3),
  [968] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(103),
  [971] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(14),
  [974] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(15),
  [977] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(16),
  [980] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(104),
  [983] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(18),
  [986] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(105),
  [989] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(106),
  [992] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(21),
  [995] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(22),
  [998] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(23),
  [1001] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(24),
  [1004] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(25),
  [1007] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(26),
  [1010] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [1012] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [1014] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [1016] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(3),
  [1019] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [1021] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(21),
  [1024] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(149),
  [1027] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(3),
  [1030] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [1032] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [1034] = {.count = 1, .reusable = true}, SHIFT(518),
  [1036] = {.count = 1, .reusable = true}, SHIFT(519),
  [1038] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [1040] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [1042] = {.count = 1, .reusable = true}, SHIFT(523),
  [1044] = {.count = 1, .reusable = false}, SHIFT(525),
  [1046] = {.count = 1, .reusable = false}, SHIFT(528),
  [1048] = {.count = 1, .reusable = true}, SHIFT(530),
  [1050] = {.count = 1, .reusable = true}, SHIFT(531),
  [1052] = {.count = 1, .reusable = true}, SHIFT(535),
  [1054] = {.count = 1, .reusable = true}, SHIFT(536),
  [1056] = {.count = 1, .reusable = true}, SHIFT(538),
  [1058] = {.count = 1, .reusable = false}, SHIFT(538),
  [1060] = {.count = 1, .reusable = true}, SHIFT(541),
  [1062] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 2),
  [1064] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [1066] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [1068] = {.count = 1, .reusable = true}, SHIFT(545),
  [1070] = {.count = 1, .reusable = true}, SHIFT(548),
  [1072] = {.count = 1, .reusable = true}, SHIFT(549),
  [1074] = {.count = 1, .reusable = false}, SHIFT(550),
  [1076] = {.count = 1, .reusable = true}, SHIFT(551),
  [1078] = {.count = 1, .reusable = true}, SHIFT(552),
  [1080] = {.count = 1, .reusable = true}, SHIFT(554),
  [1082] = {.count = 1, .reusable = true}, SHIFT(555),
  [1084] = {.count = 1, .reusable = false}, SHIFT(557),
  [1086] = {.count = 1, .reusable = true}, SHIFT(556),
  [1088] = {.count = 1, .reusable = true}, SHIFT(557),
  [1090] = {.count = 1, .reusable = true}, SHIFT(558),
  [1092] = {.count = 1, .reusable = true}, SHIFT(559),
  [1094] = {.count = 1, .reusable = true}, SHIFT(560),
  [1096] = {.count = 1, .reusable = false}, SHIFT(558),
  [1098] = {.count = 1, .reusable = true}, SHIFT(561),
  [1100] = {.count = 1, .reusable = true}, SHIFT(562),
  [1102] = {.count = 1, .reusable = false}, SHIFT(564),
  [1104] = {.count = 1, .reusable = true}, SHIFT(563),
  [1106] = {.count = 1, .reusable = true}, SHIFT(564),
  [1108] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(245),
  [1111] = {.count = 1, .reusable = true}, SHIFT(565),
  [1113] = {.count = 1, .reusable = true}, SHIFT(566),
  [1115] = {.count = 1, .reusable = false}, SHIFT(567),
  [1117] = {.count = 1, .reusable = true}, SHIFT(62),
  [1119] = {.count = 1, .reusable = true}, SHIFT(568),
  [1121] = {.count = 1, .reusable = true}, SHIFT(65),
  [1123] = {.count = 1, .reusable = true}, SHIFT(68),
  [1125] = {.count = 1, .reusable = true}, SHIFT(70),
  [1127] = {.count = 1, .reusable = true}, SHIFT(569),
  [1129] = {.count = 1, .reusable = true}, SHIFT(571),
  [1131] = {.count = 1, .reusable = true}, SHIFT(572),
  [1133] = {.count = 1, .reusable = true}, SHIFT(573),
  [1135] = {.count = 1, .reusable = true}, SHIFT(69),
  [1137] = {.count = 1, .reusable = true}, SHIFT(574),
  [1139] = {.count = 1, .reusable = true}, SHIFT(576),
  [1141] = {.count = 1, .reusable = false}, SHIFT(578),
  [1143] = {.count = 1, .reusable = true}, SHIFT(577),
  [1145] = {.count = 1, .reusable = true}, SHIFT(578),
  [1147] = {.count = 1, .reusable = true}, SHIFT(579),
  [1149] = {.count = 1, .reusable = true}, SHIFT(580),
  [1151] = {.count = 1, .reusable = true}, SHIFT(581),
  [1153] = {.count = 1, .reusable = false}, SHIFT(579),
  [1155] = {.count = 1, .reusable = true}, SHIFT(582),
  [1157] = {.count = 1, .reusable = true}, SHIFT(583),
  [1159] = {.count = 1, .reusable = false}, SHIFT(585),
  [1161] = {.count = 1, .reusable = true}, SHIFT(584),
  [1163] = {.count = 1, .reusable = true}, SHIFT(585),
  [1165] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(264),
  [1168] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1170] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(67),
  [1173] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(65),
  [1176] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(68),
  [1179] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(266),
  [1182] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(70),
  [1185] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(64),
  [1188] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(69),
  [1191] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(62),
  [1194] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1196] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(66),
  [1199] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(63),
  [1202] = {.count = 1, .reusable = true}, SHIFT(586),
  [1204] = {.count = 1, .reusable = true}, SHIFT(587),
  [1206] = {.count = 1, .reusable = false}, SHIFT(588),
  [1208] = {.count = 1, .reusable = true}, SHIFT(74),
  [1210] = {.count = 1, .reusable = true}, SHIFT(589),
  [1212] = {.count = 1, .reusable = true}, SHIFT(77),
  [1214] = {.count = 1, .reusable = true}, SHIFT(79),
  [1216] = {.count = 1, .reusable = true}, SHIFT(81),
  [1218] = {.count = 1, .reusable = true}, SHIFT(590),
  [1220] = {.count = 1, .reusable = true}, SHIFT(592),
  [1222] = {.count = 1, .reusable = true}, SHIFT(593),
  [1224] = {.count = 1, .reusable = false}, SHIFT(595),
  [1226] = {.count = 1, .reusable = true}, SHIFT(594),
  [1228] = {.count = 1, .reusable = true}, SHIFT(595),
  [1230] = {.count = 1, .reusable = true}, SHIFT(596),
  [1232] = {.count = 1, .reusable = true}, SHIFT(597),
  [1234] = {.count = 1, .reusable = true}, SHIFT(598),
  [1236] = {.count = 1, .reusable = false}, SHIFT(596),
  [1238] = {.count = 1, .reusable = true}, SHIFT(599),
  [1240] = {.count = 1, .reusable = true}, SHIFT(600),
  [1242] = {.count = 1, .reusable = false}, SHIFT(602),
  [1244] = {.count = 1, .reusable = true}, SHIFT(601),
  [1246] = {.count = 1, .reusable = true}, SHIFT(602),
  [1248] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(283),
  [1251] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1253] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(78),
  [1256] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(77),
  [1259] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(79),
  [1262] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(285),
  [1265] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(81),
  [1268] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(76),
  [1271] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(80),
  [1274] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(74),
  [1277] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [1279] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(75),
  [1282] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [1284] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [1286] = {.count = 1, .reusable = true}, SHIFT(605),
  [1288] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [1290] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [1292] = {.count = 1, .reusable = false}, SHIFT(610),
  [1294] = {.count = 1, .reusable = true}, SHIFT(608),
  [1296] = {.count = 1, .reusable = true}, SHIFT(610),
  [1298] = {.count = 1, .reusable = true}, SHIFT(609),
  [1300] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1302] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1304] = {.count = 1, .reusable = true}, SHIFT(611),
  [1306] = {.count = 1, .reusable = true}, SHIFT(613),
  [1308] = {.count = 1, .reusable = true}, SHIFT(614),
  [1310] = {.count = 1, .reusable = true}, SHIFT(615),
  [1312] = {.count = 1, .reusable = false}, SHIFT(613),
  [1314] = {.count = 1, .reusable = true}, SHIFT(619),
  [1316] = {.count = 1, .reusable = true}, SHIFT(620),
  [1318] = {.count = 1, .reusable = true}, SHIFT(621),
  [1320] = {.count = 1, .reusable = true}, SHIFT(622),
  [1322] = {.count = 1, .reusable = false}, SHIFT(619),
  [1324] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [1326] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [1328] = {.count = 1, .reusable = false}, SHIFT(623),
  [1330] = {.count = 1, .reusable = true}, SHIFT(624),
  [1332] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1334] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1336] = {.count = 1, .reusable = false}, SHIFT(626),
  [1338] = {.count = 1, .reusable = false}, SHIFT(628),
  [1340] = {.count = 1, .reusable = true}, SHIFT(628),
  [1342] = {.count = 1, .reusable = true}, SHIFT(629),
  [1344] = {.count = 1, .reusable = true}, SHIFT(630),
  [1346] = {.count = 1, .reusable = true}, SHIFT(631),
  [1348] = {.count = 1, .reusable = false}, SHIFT(633),
  [1350] = {.count = 1, .reusable = true}, SHIFT(632),
  [1352] = {.count = 1, .reusable = true}, SHIFT(633),
  [1354] = {.count = 1, .reusable = true}, SHIFT(634),
  [1356] = {.count = 1, .reusable = true}, SHIFT(635),
  [1358] = {.count = 1, .reusable = true}, SHIFT(636),
  [1360] = {.count = 1, .reusable = true}, SHIFT(637),
  [1362] = {.count = 1, .reusable = false}, SHIFT(638),
  [1364] = {.count = 1, .reusable = true}, SHIFT(639),
  [1366] = {.count = 1, .reusable = false}, SHIFT(640),
  [1368] = {.count = 1, .reusable = true}, SHIFT(641),
  [1370] = {.count = 1, .reusable = true}, SHIFT(644),
  [1372] = {.count = 1, .reusable = false}, SHIFT(649),
  [1374] = {.count = 1, .reusable = true}, SHIFT(647),
  [1376] = {.count = 1, .reusable = true}, SHIFT(649),
  [1378] = {.count = 1, .reusable = true}, SHIFT(648),
  [1380] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [1382] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [1384] = {.count = 1, .reusable = true}, SHIFT(650),
  [1386] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1388] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1390] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1392] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1394] = {.count = 1, .reusable = false}, SHIFT(652),
  [1396] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(98),
  [1399] = {.count = 1, .reusable = true}, SHIFT(654),
  [1401] = {.count = 1, .reusable = false}, SHIFT(656),
  [1403] = {.count = 1, .reusable = false}, SHIFT(659),
  [1405] = {.count = 1, .reusable = true}, SHIFT(661),
  [1407] = {.count = 1, .reusable = true}, SHIFT(662),
  [1409] = {.count = 1, .reusable = true}, SHIFT(664),
  [1411] = {.count = 1, .reusable = true}, SHIFT(665),
  [1413] = {.count = 1, .reusable = true}, SHIFT(668),
  [1415] = {.count = 1, .reusable = false}, SHIFT(668),
  [1417] = {.count = 1, .reusable = true}, SHIFT(671),
  [1419] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [1421] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [1423] = {.count = 1, .reusable = true}, SHIFT(677),
  [1425] = {.count = 1, .reusable = false}, SHIFT(680),
  [1427] = {.count = 1, .reusable = false}, SHIFT(681),
  [1429] = {.count = 1, .reusable = false}, SHIFT(682),
  [1431] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [1433] = {.count = 1, .reusable = true}, SHIFT(686),
  [1435] = {.count = 1, .reusable = true}, SHIFT(687),
  [1437] = {.count = 1, .reusable = false}, SHIFT(688),
  [1439] = {.count = 1, .reusable = true}, SHIFT(689),
  [1441] = {.count = 1, .reusable = true}, SHIFT(690),
  [1443] = {.count = 1, .reusable = true}, SHIFT(691),
  [1445] = {.count = 1, .reusable = false}, SHIFT(691),
  [1447] = {.count = 1, .reusable = true}, SHIFT(692),
  [1449] = {.count = 1, .reusable = true}, SHIFT(694),
  [1451] = {.count = 1, .reusable = true}, SHIFT(695),
  [1453] = {.count = 1, .reusable = false}, SHIFT(697),
  [1455] = {.count = 1, .reusable = true}, SHIFT(696),
  [1457] = {.count = 1, .reusable = true}, SHIFT(697),
  [1459] = {.count = 1, .reusable = true}, SHIFT(698),
  [1461] = {.count = 1, .reusable = true}, SHIFT(699),
  [1463] = {.count = 1, .reusable = true}, SHIFT(700),
  [1465] = {.count = 1, .reusable = false}, SHIFT(698),
  [1467] = {.count = 1, .reusable = true}, SHIFT(701),
  [1469] = {.count = 1, .reusable = true}, SHIFT(702),
  [1471] = {.count = 1, .reusable = false}, SHIFT(704),
  [1473] = {.count = 1, .reusable = true}, SHIFT(703),
  [1475] = {.count = 1, .reusable = true}, SHIFT(704),
  [1477] = {.count = 1, .reusable = true}, SHIFT(705),
  [1479] = {.count = 1, .reusable = true}, SHIFT(706),
  [1481] = {.count = 1, .reusable = false}, SHIFT(706),
  [1483] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(367),
  [1486] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1488] = {.count = 1, .reusable = true}, SHIFT(710),
  [1490] = {.count = 1, .reusable = true}, SHIFT(711),
  [1492] = {.count = 1, .reusable = false}, SHIFT(710),
  [1494] = {.count = 1, .reusable = true}, SHIFT(712),
  [1496] = {.count = 1, .reusable = true}, SHIFT(713),
  [1498] = {.count = 1, .reusable = false}, SHIFT(714),
  [1500] = {.count = 1, .reusable = true}, SHIFT(715),
  [1502] = {.count = 1, .reusable = true}, SHIFT(716),
  [1504] = {.count = 1, .reusable = true}, SHIFT(718),
  [1506] = {.count = 1, .reusable = true}, SHIFT(719),
  [1508] = {.count = 1, .reusable = true}, SHIFT(720),
  [1510] = {.count = 1, .reusable = false}, SHIFT(722),
  [1512] = {.count = 1, .reusable = true}, SHIFT(721),
  [1514] = {.count = 1, .reusable = true}, SHIFT(722),
  [1516] = {.count = 1, .reusable = true}, SHIFT(723),
  [1518] = {.count = 1, .reusable = true}, SHIFT(724),
  [1520] = {.count = 1, .reusable = true}, SHIFT(725),
  [1522] = {.count = 1, .reusable = false}, SHIFT(723),
  [1524] = {.count = 1, .reusable = true}, SHIFT(726),
  [1526] = {.count = 1, .reusable = true}, SHIFT(727),
  [1528] = {.count = 1, .reusable = false}, SHIFT(729),
  [1530] = {.count = 1, .reusable = true}, SHIFT(728),
  [1532] = {.count = 1, .reusable = true}, SHIFT(729),
  [1534] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(392),
  [1537] = {.count = 1, .reusable = true}, REDUCE(sym_postfix_expression, 2),
  [1539] = {.count = 1, .reusable = false}, REDUCE(sym_postfix_expression, 2),
  [1541] = {.count = 1, .reusable = true}, SHIFT(731),
  [1543] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 3),
  [1545] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 3),
  [1547] = {.count = 1, .reusable = true}, SHIFT(734),
  [1549] = {.count = 1, .reusable = true}, SHIFT(735),
  [1551] = {.count = 1, .reusable = true}, SHIFT(738),
  [1553] = {.count = 1, .reusable = false}, SHIFT(738),
  [1555] = {.count = 1, .reusable = true}, SHIFT(741),
  [1557] = {.count = 1, .reusable = true}, SHIFT(745),
  [1559] = {.count = 1, .reusable = false}, SHIFT(744),
  [1561] = {.count = 1, .reusable = true}, SHIFT(747),
  [1563] = {.count = 1, .reusable = true}, SHIFT(748),
  [1565] = {.count = 1, .reusable = true}, SHIFT(749),
  [1567] = {.count = 1, .reusable = true}, SHIFT(751),
  [1569] = {.count = 1, .reusable = true}, SHIFT(752),
  [1571] = {.count = 1, .reusable = true}, SHIFT(753),
  [1573] = {.count = 1, .reusable = true}, SHIFT(754),
  [1575] = {.count = 1, .reusable = false}, SHIFT(755),
  [1577] = {.count = 1, .reusable = true}, SHIFT(756),
  [1579] = {.count = 1, .reusable = true}, SHIFT(757),
  [1581] = {.count = 1, .reusable = true}, SHIFT(758),
  [1583] = {.count = 1, .reusable = true}, SHIFT(759),
  [1585] = {.count = 1, .reusable = false}, SHIFT(763),
  [1587] = {.count = 1, .reusable = true}, SHIFT(764),
  [1589] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3),
  [1591] = {.count = 1, .reusable = true}, SHIFT(766),
  [1593] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3),
  [1595] = {.count = 1, .reusable = true}, SHIFT(769),
  [1597] = {.count = 1, .reusable = true}, SHIFT(770),
  [1599] = {.count = 1, .reusable = true}, SHIFT(771),
  [1601] = {.count = 1, .reusable = false}, SHIFT(769),
  [1603] = {.count = 1, .reusable = true}, SHIFT(774),
  [1605] = {.count = 1, .reusable = true}, SHIFT(775),
  [1607] = {.count = 1, .reusable = true}, SHIFT(776),
  [1609] = {.count = 1, .reusable = true}, SHIFT(777),
  [1611] = {.count = 1, .reusable = false}, SHIFT(774),
  [1613] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1615] = {.count = 1, .reusable = false}, SHIFT(778),
  [1617] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1619] = {.count = 1, .reusable = true}, SHIFT(780),
  [1621] = {.count = 1, .reusable = true}, SHIFT(781),
  [1623] = {.count = 1, .reusable = true}, SHIFT(783),
  [1625] = {.count = 1, .reusable = true}, SHIFT(785),
  [1627] = {.count = 1, .reusable = false}, SHIFT(784),
  [1629] = {.count = 1, .reusable = true}, SHIFT(787),
  [1631] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [1633] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [1635] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1637] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1639] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1641] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1643] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1645] = {.count = 1, .reusable = true}, SHIFT(788),
  [1647] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1649] = {.count = 1, .reusable = true}, SHIFT(789),
  [1651] = {.count = 1, .reusable = true}, SHIFT(790),
  [1653] = {.count = 1, .reusable = false}, SHIFT(792),
  [1655] = {.count = 1, .reusable = true}, SHIFT(791),
  [1657] = {.count = 1, .reusable = true}, SHIFT(792),
  [1659] = {.count = 1, .reusable = true}, SHIFT(793),
  [1661] = {.count = 1, .reusable = true}, SHIFT(794),
  [1663] = {.count = 1, .reusable = true}, SHIFT(795),
  [1665] = {.count = 1, .reusable = false}, SHIFT(793),
  [1667] = {.count = 1, .reusable = true}, SHIFT(796),
  [1669] = {.count = 1, .reusable = true}, SHIFT(797),
  [1671] = {.count = 1, .reusable = false}, SHIFT(799),
  [1673] = {.count = 1, .reusable = true}, SHIFT(798),
  [1675] = {.count = 1, .reusable = true}, SHIFT(799),
  [1677] = {.count = 1, .reusable = true}, SHIFT(800),
  [1679] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(801),
  [1682] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(156),
  [1685] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(158),
  [1688] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(159),
  [1691] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(160),
  [1694] = {.count = 1, .reusable = true}, SHIFT(802),
  [1696] = {.count = 1, .reusable = true}, SHIFT(803),
  [1698] = {.count = 1, .reusable = true}, SHIFT(804),
  [1700] = {.count = 1, .reusable = true}, SHIFT(805),
  [1702] = {.count = 1, .reusable = false}, SHIFT(806),
  [1704] = {.count = 1, .reusable = true}, SHIFT(807),
  [1706] = {.count = 1, .reusable = true}, SHIFT(808),
  [1708] = {.count = 1, .reusable = true}, SHIFT(809),
  [1710] = {.count = 1, .reusable = true}, SHIFT(448),
  [1712] = {.count = 1, .reusable = true}, SHIFT(456),
  [1714] = {.count = 1, .reusable = true}, SHIFT(450),
  [1716] = {.count = 1, .reusable = true}, SHIFT(449),
  [1718] = {.count = 1, .reusable = true}, SHIFT(453),
  [1720] = {.count = 1, .reusable = true}, SHIFT(454),
  [1722] = {.count = 1, .reusable = true}, SHIFT(457),
  [1724] = {.count = 1, .reusable = true}, SHIFT(455),
  [1726] = {.count = 1, .reusable = true}, SHIFT(816),
  [1728] = {.count = 1, .reusable = false}, SHIFT(818),
  [1730] = {.count = 1, .reusable = true}, SHIFT(820),
  [1732] = {.count = 1, .reusable = true}, SHIFT(821),
  [1734] = {.count = 1, .reusable = true}, SHIFT(822),
  [1736] = {.count = 1, .reusable = false}, SHIFT(820),
  [1738] = {.count = 1, .reusable = true}, SHIFT(826),
  [1740] = {.count = 1, .reusable = true}, SHIFT(827),
  [1742] = {.count = 1, .reusable = true}, SHIFT(828),
  [1744] = {.count = 1, .reusable = true}, SHIFT(829),
  [1746] = {.count = 1, .reusable = false}, SHIFT(826),
  [1748] = {.count = 1, .reusable = false}, SHIFT(830),
  [1750] = {.count = 1, .reusable = true}, SHIFT(831),
  [1752] = {.count = 1, .reusable = false}, SHIFT(833),
  [1754] = {.count = 1, .reusable = false}, SHIFT(835),
  [1756] = {.count = 1, .reusable = true}, SHIFT(835),
  [1758] = {.count = 1, .reusable = false}, SHIFT(836),
  [1760] = {.count = 1, .reusable = false}, SHIFT(837),
  [1762] = {.count = 1, .reusable = false}, SHIFT(838),
  [1764] = {.count = 1, .reusable = false}, SHIFT(839),
  [1766] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1768] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1770] = {.count = 1, .reusable = true}, SHIFT(841),
  [1772] = {.count = 1, .reusable = true}, SHIFT(842),
  [1774] = {.count = 1, .reusable = false}, SHIFT(843),
  [1776] = {.count = 1, .reusable = true}, SHIFT(844),
  [1778] = {.count = 1, .reusable = true}, SHIFT(845),
  [1780] = {.count = 1, .reusable = true}, SHIFT(847),
  [1782] = {.count = 1, .reusable = true}, SHIFT(848),
  [1784] = {.count = 1, .reusable = true}, SHIFT(849),
  [1786] = {.count = 1, .reusable = false}, SHIFT(851),
  [1788] = {.count = 1, .reusable = true}, SHIFT(850),
  [1790] = {.count = 1, .reusable = true}, SHIFT(851),
  [1792] = {.count = 1, .reusable = true}, SHIFT(852),
  [1794] = {.count = 1, .reusable = true}, SHIFT(853),
  [1796] = {.count = 1, .reusable = true}, SHIFT(854),
  [1798] = {.count = 1, .reusable = false}, SHIFT(852),
  [1800] = {.count = 1, .reusable = true}, SHIFT(855),
  [1802] = {.count = 1, .reusable = true}, SHIFT(856),
  [1804] = {.count = 1, .reusable = false}, SHIFT(858),
  [1806] = {.count = 1, .reusable = true}, SHIFT(857),
  [1808] = {.count = 1, .reusable = true}, SHIFT(858),
  [1810] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(480),
  [1813] = {.count = 1, .reusable = true}, SHIFT(860),
  [1815] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(392),
  [1818] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [1820] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [1822] = {.count = 1, .reusable = false}, SHIFT(863),
  [1824] = {.count = 1, .reusable = true}, SHIFT(864),
  [1826] = {.count = 1, .reusable = true}, SHIFT(866),
  [1828] = {.count = 1, .reusable = true}, SHIFT(869),
  [1830] = {.count = 1, .reusable = true}, SHIFT(870),
  [1832] = {.count = 1, .reusable = true}, SHIFT(871),
  [1834] = {.count = 1, .reusable = false}, SHIFT(869),
  [1836] = {.count = 1, .reusable = true}, SHIFT(874),
  [1838] = {.count = 1, .reusable = true}, SHIFT(875),
  [1840] = {.count = 1, .reusable = true}, SHIFT(876),
  [1842] = {.count = 1, .reusable = true}, SHIFT(877),
  [1844] = {.count = 1, .reusable = false}, SHIFT(874),
  [1846] = {.count = 1, .reusable = false}, SHIFT(878),
  [1848] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [1850] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [1852] = {.count = 1, .reusable = false}, SHIFT(880),
  [1854] = {.count = 1, .reusable = true}, SHIFT(881),
  [1856] = {.count = 1, .reusable = true}, SHIFT(882),
  [1858] = {.count = 1, .reusable = true}, SHIFT(883),
  [1860] = {.count = 1, .reusable = true}, SHIFT(884),
  [1862] = {.count = 1, .reusable = true}, SHIFT(885),
  [1864] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 3),
  [1866] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 3),
  [1868] = {.count = 1, .reusable = true}, SHIFT(886),
  [1870] = {.count = 1, .reusable = false}, SHIFT(886),
  [1872] = {.count = 1, .reusable = true}, SHIFT(887),
  [1874] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [1876] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [1878] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [1880] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [1882] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [1884] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [1886] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [1888] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [1890] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(189),
  [1893] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(185),
  [1896] = {.count = 1, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [1898] = {.count = 1, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [1900] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(188),
  [1903] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(191),
  [1906] = {.count = 1, .reusable = true}, SHIFT(892),
  [1908] = {.count = 1, .reusable = false}, SHIFT(891),
  [1910] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [1912] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [1914] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1916] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [1918] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [1920] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [1922] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(6),
  [1925] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(7),
  [1928] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(8),
  [1931] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(9),
  [1934] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(198),
  [1937] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(199),
  [1940] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(13),
  [1943] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(18),
  [1946] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [1949] = {.count = 1, .reusable = true}, SHIFT(894),
  [1951] = {.count = 1, .reusable = true}, SHIFT(204),
  [1953] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(525),
  [1956] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(202),
  [1959] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(204),
  [1962] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(203),
  [1965] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(528),
  [1968] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(208),
  [1971] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(209),
  [1974] = {.count = 1, .reusable = true}, SHIFT(901),
  [1976] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(216),
  [1979] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(217),
  [1982] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(219),
  [1985] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(225),
  [1988] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(226),
  [1991] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(40),
  [1994] = {.count = 1, .reusable = true}, SHIFT(903),
  [1996] = {.count = 1, .reusable = false}, SHIFT(904),
  [1998] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(233),
  [2001] = {.count = 1, .reusable = false}, SHIFT(907),
  [2003] = {.count = 1, .reusable = true}, SHIFT(905),
  [2005] = {.count = 1, .reusable = true}, SHIFT(907),
  [2007] = {.count = 1, .reusable = true}, SHIFT(906),
  [2009] = {.count = 1, .reusable = true}, SHIFT(908),
  [2011] = {.count = 1, .reusable = true}, SHIFT(909),
  [2013] = {.count = 1, .reusable = true}, SHIFT(910),
  [2015] = {.count = 1, .reusable = false}, SHIFT(912),
  [2017] = {.count = 1, .reusable = true}, SHIFT(911),
  [2019] = {.count = 1, .reusable = true}, SHIFT(912),
  [2021] = {.count = 1, .reusable = true}, SHIFT(913),
  [2023] = {.count = 1, .reusable = false}, SHIFT(918),
  [2025] = {.count = 1, .reusable = true}, SHIFT(916),
  [2027] = {.count = 1, .reusable = true}, SHIFT(918),
  [2029] = {.count = 1, .reusable = true}, SHIFT(917),
  [2031] = {.count = 1, .reusable = true}, SHIFT(919),
  [2033] = {.count = 1, .reusable = false}, SHIFT(920),
  [2035] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(251),
  [2038] = {.count = 1, .reusable = true}, SHIFT(921),
  [2040] = {.count = 1, .reusable = false}, SHIFT(925),
  [2042] = {.count = 1, .reusable = true}, SHIFT(923),
  [2044] = {.count = 1, .reusable = true}, SHIFT(925),
  [2046] = {.count = 1, .reusable = true}, SHIFT(924),
  [2048] = {.count = 1, .reusable = true}, SHIFT(926),
  [2050] = {.count = 1, .reusable = true}, SHIFT(927),
  [2052] = {.count = 1, .reusable = true}, SHIFT(928),
  [2054] = {.count = 1, .reusable = false}, SHIFT(930),
  [2056] = {.count = 1, .reusable = true}, SHIFT(929),
  [2058] = {.count = 1, .reusable = true}, SHIFT(930),
  [2060] = {.count = 1, .reusable = true}, SHIFT(931),
  [2062] = {.count = 1, .reusable = false}, SHIFT(936),
  [2064] = {.count = 1, .reusable = true}, SHIFT(934),
  [2066] = {.count = 1, .reusable = true}, SHIFT(936),
  [2068] = {.count = 1, .reusable = true}, SHIFT(935),
  [2070] = {.count = 1, .reusable = true}, SHIFT(937),
  [2072] = {.count = 1, .reusable = false}, SHIFT(938),
  [2074] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(271),
  [2077] = {.count = 1, .reusable = false}, SHIFT(941),
  [2079] = {.count = 1, .reusable = true}, SHIFT(939),
  [2081] = {.count = 1, .reusable = true}, SHIFT(941),
  [2083] = {.count = 1, .reusable = true}, SHIFT(940),
  [2085] = {.count = 1, .reusable = true}, SHIFT(942),
  [2087] = {.count = 1, .reusable = true}, SHIFT(943),
  [2089] = {.count = 1, .reusable = true}, SHIFT(944),
  [2091] = {.count = 1, .reusable = false}, SHIFT(946),
  [2093] = {.count = 1, .reusable = true}, SHIFT(945),
  [2095] = {.count = 1, .reusable = true}, SHIFT(946),
  [2097] = {.count = 1, .reusable = true}, SHIFT(947),
  [2099] = {.count = 1, .reusable = false}, SHIFT(952),
  [2101] = {.count = 1, .reusable = true}, SHIFT(950),
  [2103] = {.count = 1, .reusable = true}, SHIFT(952),
  [2105] = {.count = 1, .reusable = true}, SHIFT(951),
  [2107] = {.count = 1, .reusable = true}, SHIFT(954),
  [2109] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [2111] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [2113] = {.count = 1, .reusable = false}, SHIFT(956),
  [2115] = {.count = 1, .reusable = true}, SHIFT(955),
  [2117] = {.count = 1, .reusable = true}, SHIFT(956),
  [2119] = {.count = 1, .reusable = true}, SHIFT(957),
  [2121] = {.count = 1, .reusable = true}, SHIFT(958),
  [2123] = {.count = 1, .reusable = true}, SHIFT(960),
  [2125] = {.count = 1, .reusable = true}, SHIFT(961),
  [2127] = {.count = 1, .reusable = false}, SHIFT(963),
  [2129] = {.count = 1, .reusable = true}, SHIFT(962),
  [2131] = {.count = 1, .reusable = true}, SHIFT(963),
  [2133] = {.count = 1, .reusable = true}, SHIFT(964),
  [2135] = {.count = 1, .reusable = true}, SHIFT(965),
  [2137] = {.count = 1, .reusable = true}, SHIFT(966),
  [2139] = {.count = 1, .reusable = false}, SHIFT(964),
  [2141] = {.count = 1, .reusable = true}, SHIFT(967),
  [2143] = {.count = 1, .reusable = true}, SHIFT(968),
  [2145] = {.count = 1, .reusable = false}, SHIFT(970),
  [2147] = {.count = 1, .reusable = true}, SHIFT(969),
  [2149] = {.count = 1, .reusable = true}, SHIFT(970),
  [2151] = {.count = 1, .reusable = true}, SHIFT(971),
  [2153] = {.count = 1, .reusable = false}, SHIFT(972),
  [2155] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(626),
  [2158] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(292),
  [2161] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(294),
  [2164] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(628),
  [2167] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(295),
  [2170] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [2172] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(297),
  [2175] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(298),
  [2178] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(296),
  [2181] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(300),
  [2184] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(294),
  [2187] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(628),
  [2190] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(301),
  [2193] = {.count = 1, .reusable = true}, SHIFT(973),
  [2195] = {.count = 1, .reusable = true}, SHIFT(974),
  [2197] = {.count = 1, .reusable = false}, SHIFT(979),
  [2199] = {.count = 1, .reusable = true}, SHIFT(977),
  [2201] = {.count = 1, .reusable = true}, SHIFT(979),
  [2203] = {.count = 1, .reusable = true}, SHIFT(978),
  [2205] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2207] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2209] = {.count = 1, .reusable = false}, SHIFT(981),
  [2211] = {.count = 1, .reusable = true}, SHIFT(982),
  [2213] = {.count = 1, .reusable = true}, SHIFT(984),
  [2215] = {.count = 1, .reusable = true}, SHIFT(987),
  [2217] = {.count = 1, .reusable = true}, SHIFT(988),
  [2219] = {.count = 1, .reusable = true}, SHIFT(989),
  [2221] = {.count = 1, .reusable = false}, SHIFT(987),
  [2223] = {.count = 1, .reusable = true}, SHIFT(992),
  [2225] = {.count = 1, .reusable = true}, SHIFT(993),
  [2227] = {.count = 1, .reusable = true}, SHIFT(994),
  [2229] = {.count = 1, .reusable = true}, SHIFT(995),
  [2231] = {.count = 1, .reusable = false}, SHIFT(992),
  [2233] = {.count = 1, .reusable = false}, SHIFT(996),
  [2235] = {.count = 1, .reusable = true}, SHIFT(997),
  [2237] = {.count = 1, .reusable = true}, SHIFT(999),
  [2239] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2241] = {.count = 1, .reusable = true}, SHIFT(1001),
  [2243] = {.count = 1, .reusable = true}, SHIFT(1002),
  [2245] = {.count = 1, .reusable = true}, SHIFT(1003),
  [2247] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [2249] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [2251] = {.count = 1, .reusable = false}, SHIFT(1005),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2257] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [2259] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [2261] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 4),
  [2263] = {.count = 1, .reusable = false}, SHIFT(86),
  [2265] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 4),
  [2267] = {.count = 1, .reusable = false}, SHIFT(85),
  [2269] = {.count = 1, .reusable = true}, SHIFT(1008),
  [2271] = {.count = 1, .reusable = true}, SHIFT(320),
  [2273] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(656),
  [2276] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(318),
  [2279] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(320),
  [2282] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(319),
  [2285] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(659),
  [2288] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(324),
  [2291] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(325),
  [2294] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2296] = {.count = 1, .reusable = false}, SHIFT(1015),
  [2298] = {.count = 1, .reusable = true}, SHIFT(1016),
  [2300] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(332),
  [2303] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(334),
  [2306] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(336),
  [2309] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(342),
  [2312] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(343),
  [2315] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(103),
  [2318] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [2320] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [2322] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [2324] = {.count = 1, .reusable = false}, SHIFT(1020),
  [2326] = {.count = 1, .reusable = true}, SHIFT(1020),
  [2328] = {.count = 1, .reusable = true}, SHIFT(682),
  [2330] = {.count = 1, .reusable = true}, SHIFT(680),
  [2332] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2334] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2336] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2338] = {.count = 1, .reusable = false}, SHIFT(1027),
  [2340] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2342] = {.count = 1, .reusable = false}, SHIFT(1028),
  [2344] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2346] = {.count = 1, .reusable = false}, SHIFT(1034),
  [2348] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(353),
  [2351] = {.count = 1, .reusable = false}, SHIFT(1037),
  [2353] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2355] = {.count = 1, .reusable = true}, SHIFT(1037),
  [2357] = {.count = 1, .reusable = true}, SHIFT(1036),
  [2359] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2361] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2363] = {.count = 1, .reusable = true}, SHIFT(1040),
  [2365] = {.count = 1, .reusable = false}, SHIFT(1042),
  [2367] = {.count = 1, .reusable = true}, SHIFT(1041),
  [2369] = {.count = 1, .reusable = true}, SHIFT(1042),
  [2371] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2373] = {.count = 1, .reusable = false}, SHIFT(1048),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2377] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2379] = {.count = 1, .reusable = true}, SHIFT(1047),
  [2381] = {.count = 1, .reusable = true}, SHIFT(1049),
  [2383] = {.count = 1, .reusable = false}, SHIFT(1049),
  [2385] = {.count = 1, .reusable = false}, SHIFT(1050),
  [2387] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2389] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2391] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2393] = {.count = 1, .reusable = false}, SHIFT(1055),
  [2395] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(379),
  [2398] = {.count = 1, .reusable = false}, SHIFT(1058),
  [2400] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2402] = {.count = 1, .reusable = true}, SHIFT(1058),
  [2404] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2406] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2408] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2410] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2412] = {.count = 1, .reusable = false}, SHIFT(1063),
  [2414] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2416] = {.count = 1, .reusable = true}, SHIFT(1063),
  [2418] = {.count = 1, .reusable = true}, SHIFT(1064),
  [2420] = {.count = 1, .reusable = false}, SHIFT(1069),
  [2422] = {.count = 1, .reusable = true}, SHIFT(1067),
  [2424] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2428] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2430] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2432] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2434] = {.count = 1, .reusable = false}, SHIFT(1072),
  [2436] = {.count = 1, .reusable = true}, SHIFT(1073),
  [2438] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(401),
  [2441] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(404),
  [2444] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(406),
  [2447] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2449] = {.count = 1, .reusable = false}, SHIFT(1079),
  [2451] = {.count = 1, .reusable = true}, SHIFT(1080),
  [2453] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2455] = {.count = 1, .reusable = true}, SHIFT(1082),
  [2457] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2459] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2461] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2463] = {.count = 1, .reusable = true}, SHIFT(1087),
  [2465] = {.count = 1, .reusable = false}, SHIFT(1085),
  [2467] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2469] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2471] = {.count = 1, .reusable = true}, SHIFT(1090),
  [2473] = {.count = 1, .reusable = true}, SHIFT(1091),
  [2475] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2477] = {.count = 1, .reusable = true}, SHIFT(1093),
  [2479] = {.count = 1, .reusable = false}, SHIFT(1090),
  [2481] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2483] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2485] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2487] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2489] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2491] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2493] = {.count = 1, .reusable = false}, SHIFT(1100),
  [2495] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2497] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2499] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2501] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2503] = {.count = 1, .reusable = false}, SHIFT(1107),
  [2505] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2507] = {.count = 1, .reusable = true}, SHIFT(1107),
  [2509] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2511] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2513] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2515] = {.count = 1, .reusable = false}, SHIFT(1108),
  [2517] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2519] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2521] = {.count = 1, .reusable = false}, SHIFT(1114),
  [2523] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2525] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2527] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(778),
  [2530] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2532] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2534] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2536] = {.count = 1, .reusable = false}, SHIFT(844),
  [2538] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2540] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [2542] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2544] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2546] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(784),
  [2549] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [2551] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [2553] = {.count = 1, .reusable = false}, SHIFT(1123),
  [2555] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2559] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2561] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2563] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2565] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2567] = {.count = 1, .reusable = false}, SHIFT(1128),
  [2569] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2571] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2573] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2575] = {.count = 1, .reusable = false}, SHIFT(1134),
  [2577] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2579] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2581] = {.count = 1, .reusable = true}, SHIFT(1133),
  [2583] = {.count = 1, .reusable = false}, REDUCE(sym_string, 4),
  [2585] = {.count = 1, .reusable = true}, REDUCE(sym_string, 4),
  [2587] = {.count = 1, .reusable = false}, SHIFT(1136),
  [2589] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2591] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2593] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2595] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2597] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2599] = {.count = 1, .reusable = false}, SHIFT(1142),
  [2601] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2603] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2605] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2609] = {.count = 1, .reusable = false}, SHIFT(1147),
  [2611] = {.count = 1, .reusable = false}, SHIFT(1151),
  [2613] = {.count = 1, .reusable = false}, SHIFT(802),
  [2615] = {.count = 1, .reusable = false}, SHIFT(804),
  [2617] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2619] = {.count = 1, .reusable = false}, SHIFT(1153),
  [2621] = {.count = 1, .reusable = false}, SHIFT(805),
  [2623] = {.count = 1, .reusable = false}, SHIFT(807),
  [2625] = {.count = 1, .reusable = false}, SHIFT(809),
  [2627] = {.count = 1, .reusable = false}, SHIFT(803),
  [2629] = {.count = 1, .reusable = false}, SHIFT(808),
  [2631] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4),
  [2633] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4),
  [2635] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [2637] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2639] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2641] = {.count = 1, .reusable = true}, SHIFT(1157),
  [2643] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2645] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2647] = {.count = 1, .reusable = false}, SHIFT(1162),
  [2649] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2651] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2653] = {.count = 1, .reusable = false}, SHIFT(1166),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2657] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2659] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2661] = {.count = 1, .reusable = true}, SHIFT(1168),
  [2663] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2665] = {.count = 1, .reusable = false}, SHIFT(1167),
  [2667] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2671] = {.count = 1, .reusable = false}, SHIFT(1173),
  [2673] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2675] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2677] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2679] = {.count = 1, .reusable = false}, SHIFT(1175),
  [2681] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(833),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2686] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [2688] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [2690] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2692] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2694] = {.count = 1, .reusable = false}, SHIFT(1182),
  [2696] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(467),
  [2699] = {.count = 1, .reusable = false}, SHIFT(1185),
  [2701] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2703] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2705] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2707] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2709] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2711] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2713] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2715] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2717] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2719] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2721] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2723] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2725] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2727] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2729] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2731] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2733] = {.count = 1, .reusable = false}, SHIFT(1199),
  [2735] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2737] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2739] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2741] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2743] = {.count = 1, .reusable = false}, SHIFT(1206),
  [2745] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2747] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2749] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2755] = {.count = 1, .reusable = false}, SHIFT(1207),
  [2757] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2761] = {.count = 1, .reusable = false}, SHIFT(1213),
  [2763] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2765] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2767] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(878),
  [2770] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2772] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2774] = {.count = 1, .reusable = false}, SHIFT(1214),
  [2776] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [2778] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [2780] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2782] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2784] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2786] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2788] = {.count = 1, .reusable = false}, SHIFT(1219),
  [2790] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2792] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2794] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 4),
  [2796] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 4),
  [2798] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 4),
  [2800] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 4),
  [2802] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2804] = {.count = 1, .reusable = false}, SHIFT(1225),
  [2806] = {.count = 1, .reusable = false}, SHIFT(238),
  [2808] = {.count = 1, .reusable = false}, SHIFT(1230),
  [2810] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2812] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2814] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2816] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2818] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2820] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2822] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2824] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2826] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2828] = {.count = 1, .reusable = false}, SHIFT(1240),
  [2830] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2832] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2834] = {.count = 1, .reusable = false}, SHIFT(257),
  [2836] = {.count = 1, .reusable = false}, SHIFT(256),
  [2838] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2840] = {.count = 1, .reusable = false}, SHIFT(1243),
  [2842] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2844] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2846] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2848] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2850] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2852] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2854] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2856] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2858] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2860] = {.count = 1, .reusable = false}, SHIFT(1253),
  [2862] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2864] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2866] = {.count = 1, .reusable = false}, SHIFT(276),
  [2868] = {.count = 1, .reusable = false}, SHIFT(275),
  [2870] = {.count = 1, .reusable = false}, SHIFT(1255),
  [2872] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2874] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2876] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2878] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2880] = {.count = 1, .reusable = false}, SHIFT(1262),
  [2882] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2884] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2886] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2888] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2890] = {.count = 1, .reusable = false}, SHIFT(1265),
  [2892] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2894] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2896] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [2898] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [2900] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2902] = {.count = 1, .reusable = false}, SHIFT(1267),
  [2904] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(611),
  [2907] = {.count = 1, .reusable = false}, SHIFT(1270),
  [2909] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2911] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2913] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2919] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2921] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2923] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2927] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2929] = {.count = 1, .reusable = false}, SHIFT(1281),
  [2931] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2933] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2935] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2937] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1283),
  [2941] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2943] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2945] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [2947] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [2949] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2951] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2953] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2955] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2959] = {.count = 1, .reusable = false}, SHIFT(1289),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2963] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2965] = {.count = 1, .reusable = true}, SHIFT(1293),
  [2967] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2969] = {.count = 1, .reusable = false}, SHIFT(1296),
  [2971] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2973] = {.count = 1, .reusable = true}, SHIFT(1296),
  [2975] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2977] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2979] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2981] = {.count = 1, .reusable = false}, SHIFT(1297),
  [2983] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2985] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2987] = {.count = 1, .reusable = false}, SHIFT(1303),
  [2989] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2991] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2993] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [2995] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [2997] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(996),
  [3000] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [3002] = {.count = 1, .reusable = true}, SHIFT(1304),
  [3004] = {.count = 1, .reusable = true}, SHIFT(1305),
  [3006] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [3008] = {.count = 1, .reusable = true}, SHIFT(1306),
  [3010] = {.count = 1, .reusable = true}, SHIFT(1307),
  [3012] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [3014] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [3016] = {.count = 1, .reusable = true}, SHIFT(1308),
  [3018] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [3020] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [3022] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 2),
  [3024] = {.count = 1, .reusable = true}, SHIFT(1312),
  [3026] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3028] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3030] = {.count = 1, .reusable = true}, SHIFT(1313),
  [3032] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(682),
  [3035] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3037] = {.count = 1, .reusable = false}, SHIFT(1315),
  [3039] = {.count = 1, .reusable = true}, SHIFT(1319),
  [3041] = {.count = 1, .reusable = true}, SHIFT(1318),
  [3043] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [3045] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [3047] = {.count = 1, .reusable = true}, SHIFT(1322),
  [3049] = {.count = 1, .reusable = true}, SHIFT(1315),
  [3051] = {.count = 1, .reusable = false}, SHIFT(358),
  [3053] = {.count = 1, .reusable = false}, SHIFT(359),
  [3055] = {.count = 1, .reusable = false}, SHIFT(119),
  [3057] = {.count = 1, .reusable = false}, SHIFT(1327),
  [3059] = {.count = 1, .reusable = true}, SHIFT(1326),
  [3061] = {.count = 1, .reusable = true}, SHIFT(1327),
  [3063] = {.count = 1, .reusable = true}, SHIFT(1328),
  [3065] = {.count = 1, .reusable = true}, SHIFT(1329),
  [3067] = {.count = 1, .reusable = false}, SHIFT(1334),
  [3069] = {.count = 1, .reusable = true}, SHIFT(1332),
  [3071] = {.count = 1, .reusable = true}, SHIFT(1334),
  [3073] = {.count = 1, .reusable = true}, SHIFT(1333),
  [3075] = {.count = 1, .reusable = true}, SHIFT(1335),
  [3077] = {.count = 1, .reusable = false}, SHIFT(1337),
  [3079] = {.count = 1, .reusable = true}, SHIFT(1336),
  [3081] = {.count = 1, .reusable = true}, SHIFT(1337),
  [3083] = {.count = 1, .reusable = false}, SHIFT(1338),
  [3085] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [3087] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [3089] = {.count = 1, .reusable = true}, SHIFT(1338),
  [3091] = {.count = 1, .reusable = false}, SHIFT(385),
  [3093] = {.count = 1, .reusable = false}, SHIFT(1342),
  [3095] = {.count = 1, .reusable = true}, SHIFT(1341),
  [3097] = {.count = 1, .reusable = true}, SHIFT(1342),
  [3099] = {.count = 1, .reusable = true}, SHIFT(1343),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1344),
  [3103] = {.count = 1, .reusable = false}, SHIFT(1349),
  [3105] = {.count = 1, .reusable = true}, SHIFT(1347),
  [3107] = {.count = 1, .reusable = true}, SHIFT(1349),
  [3109] = {.count = 1, .reusable = true}, SHIFT(1348),
  [3111] = {.count = 1, .reusable = true}, SHIFT(1350),
  [3113] = {.count = 1, .reusable = false}, SHIFT(1352),
  [3115] = {.count = 1, .reusable = true}, SHIFT(1351),
  [3117] = {.count = 1, .reusable = true}, SHIFT(1352),
  [3119] = {.count = 1, .reusable = true}, SHIFT(1354),
  [3121] = {.count = 1, .reusable = false}, SHIFT(1354),
  [3123] = {.count = 1, .reusable = true}, SHIFT(1355),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1356),
  [3127] = {.count = 1, .reusable = true}, SHIFT(1357),
  [3129] = {.count = 1, .reusable = false}, SHIFT(1358),
  [3131] = {.count = 1, .reusable = true}, SHIFT(1359),
  [3133] = {.count = 1, .reusable = true}, SHIFT(1360),
  [3135] = {.count = 1, .reusable = true}, SHIFT(1362),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1363),
  [3139] = {.count = 1, .reusable = false}, SHIFT(1365),
  [3141] = {.count = 1, .reusable = true}, SHIFT(1364),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1365),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1366),
  [3147] = {.count = 1, .reusable = true}, SHIFT(1367),
  [3149] = {.count = 1, .reusable = true}, SHIFT(1368),
  [3151] = {.count = 1, .reusable = false}, SHIFT(1366),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1369),
  [3155] = {.count = 1, .reusable = true}, SHIFT(1370),
  [3157] = {.count = 1, .reusable = false}, SHIFT(1372),
  [3159] = {.count = 1, .reusable = true}, SHIFT(1371),
  [3161] = {.count = 1, .reusable = true}, SHIFT(1372),
  [3163] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1094),
  [3166] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3168] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3170] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(751),
  [3173] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(752),
  [3176] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(753),
  [3179] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(754),
  [3182] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(755),
  [3185] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3187] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(757),
  [3190] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(758),
  [3193] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(759),
  [3196] = {.count = 1, .reusable = true}, SHIFT(1373),
  [3198] = {.count = 1, .reusable = false}, SHIFT(1374),
  [3200] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(766),
  [3203] = {.count = 1, .reusable = false}, SHIFT(1377),
  [3205] = {.count = 1, .reusable = true}, SHIFT(1375),
  [3207] = {.count = 1, .reusable = true}, SHIFT(1377),
  [3209] = {.count = 1, .reusable = true}, SHIFT(1376),
  [3211] = {.count = 1, .reusable = true}, SHIFT(1378),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1379),
  [3215] = {.count = 1, .reusable = true}, SHIFT(1380),
  [3217] = {.count = 1, .reusable = false}, SHIFT(1382),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1381),
  [3221] = {.count = 1, .reusable = true}, SHIFT(1382),
  [3223] = {.count = 1, .reusable = true}, SHIFT(1383),
  [3225] = {.count = 1, .reusable = false}, SHIFT(1388),
  [3227] = {.count = 1, .reusable = true}, SHIFT(1386),
  [3229] = {.count = 1, .reusable = true}, SHIFT(1388),
  [3231] = {.count = 1, .reusable = true}, SHIFT(1387),
  [3233] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [3235] = {.count = 1, .reusable = true}, SHIFT(1389),
  [3237] = {.count = 1, .reusable = false}, SHIFT(1390),
  [3239] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [3241] = {.count = 1, .reusable = true}, SHIFT(1391),
  [3243] = {.count = 1, .reusable = false}, SHIFT(1393),
  [3245] = {.count = 1, .reusable = true}, SHIFT(1392),
  [3247] = {.count = 1, .reusable = true}, SHIFT(1393),
  [3249] = {.count = 1, .reusable = true}, SHIFT(1394),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1395),
  [3253] = {.count = 1, .reusable = false}, SHIFT(1400),
  [3255] = {.count = 1, .reusable = true}, SHIFT(1398),
  [3257] = {.count = 1, .reusable = true}, SHIFT(1400),
  [3259] = {.count = 1, .reusable = true}, SHIFT(1399),
  [3261] = {.count = 1, .reusable = true}, SHIFT(1401),
  [3263] = {.count = 1, .reusable = false}, SHIFT(1403),
  [3265] = {.count = 1, .reusable = true}, SHIFT(1402),
  [3267] = {.count = 1, .reusable = true}, SHIFT(1403),
  [3269] = {.count = 1, .reusable = true}, SHIFT(1404),
  [3271] = {.count = 1, .reusable = true}, SHIFT(1405),
  [3273] = {.count = 1, .reusable = false}, SHIFT(1406),
  [3275] = {.count = 1, .reusable = true}, SHIFT(1407),
  [3277] = {.count = 1, .reusable = true}, SHIFT(1408),
  [3279] = {.count = 1, .reusable = true}, SHIFT(1410),
  [3281] = {.count = 1, .reusable = true}, SHIFT(1411),
  [3283] = {.count = 1, .reusable = false}, SHIFT(1413),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1412),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1413),
  [3289] = {.count = 1, .reusable = true}, SHIFT(1414),
  [3291] = {.count = 1, .reusable = true}, SHIFT(1415),
  [3293] = {.count = 1, .reusable = true}, SHIFT(1416),
  [3295] = {.count = 1, .reusable = false}, SHIFT(1414),
  [3297] = {.count = 1, .reusable = true}, SHIFT(1417),
  [3299] = {.count = 1, .reusable = true}, SHIFT(1418),
  [3301] = {.count = 1, .reusable = false}, SHIFT(1420),
  [3303] = {.count = 1, .reusable = true}, SHIFT(1419),
  [3305] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3307] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1151),
  [3310] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(802),
  [3313] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(804),
  [3316] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3318] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(806),
  [3321] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(805),
  [3324] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(807),
  [3327] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(809),
  [3330] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(803),
  [3333] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(808),
  [3336] = {.count = 1, .reusable = false}, SHIFT(1422),
  [3338] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(816),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1423),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1425),
  [3345] = {.count = 1, .reusable = false}, SHIFT(1429),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3349] = {.count = 1, .reusable = true}, SHIFT(1429),
  [3351] = {.count = 1, .reusable = true}, SHIFT(1428),
  [3353] = {.count = 1, .reusable = true}, SHIFT(1430),
  [3355] = {.count = 1, .reusable = true}, SHIFT(1431),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3359] = {.count = 1, .reusable = false}, SHIFT(1434),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1433),
  [3363] = {.count = 1, .reusable = true}, SHIFT(1434),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1435),
  [3367] = {.count = 1, .reusable = false}, SHIFT(1440),
  [3369] = {.count = 1, .reusable = true}, SHIFT(1438),
  [3371] = {.count = 1, .reusable = true}, SHIFT(1440),
  [3373] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3375] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3377] = {.count = 1, .reusable = false}, SHIFT(1442),
  [3379] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [3381] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [3383] = {.count = 1, .reusable = false}, SHIFT(473),
  [3385] = {.count = 1, .reusable = false}, SHIFT(1444),
  [3387] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3389] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3391] = {.count = 1, .reusable = true}, SHIFT(1445),
  [3393] = {.count = 1, .reusable = true}, SHIFT(1446),
  [3395] = {.count = 1, .reusable = false}, SHIFT(1451),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3401] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3403] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3405] = {.count = 1, .reusable = false}, SHIFT(1454),
  [3407] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1454),
  [3411] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3413] = {.count = 1, .reusable = false}, SHIFT(1456),
  [3415] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(866),
  [3418] = {.count = 1, .reusable = false}, SHIFT(1459),
  [3420] = {.count = 1, .reusable = true}, SHIFT(1457),
  [3422] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3424] = {.count = 1, .reusable = true}, SHIFT(1458),
  [3426] = {.count = 1, .reusable = true}, SHIFT(1460),
  [3428] = {.count = 1, .reusable = true}, SHIFT(1461),
  [3430] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3432] = {.count = 1, .reusable = false}, SHIFT(1464),
  [3434] = {.count = 1, .reusable = true}, SHIFT(1463),
  [3436] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3438] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3440] = {.count = 1, .reusable = false}, SHIFT(1470),
  [3442] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3444] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3446] = {.count = 1, .reusable = true}, SHIFT(1469),
  [3448] = {.count = 1, .reusable = true}, SHIFT(1471),
  [3450] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3452] = {.count = 1, .reusable = false}, SHIFT(1474),
  [3454] = {.count = 1, .reusable = true}, SHIFT(1473),
  [3456] = {.count = 1, .reusable = true}, SHIFT(1474),
  [3458] = {.count = 1, .reusable = true}, SHIFT(1475),
  [3460] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3462] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3464] = {.count = 1, .reusable = false}, SHIFT(1475),
  [3466] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3468] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3470] = {.count = 1, .reusable = false}, SHIFT(1481),
  [3472] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3474] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3476] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [3478] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [3480] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(880),
  [3483] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(881),
  [3486] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(882),
  [3489] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [3491] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(884),
  [3494] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1224),
  [3497] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 5),
  [3499] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3501] = {.count = 1, .reusable = false}, SHIFT(1482),
  [3503] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3505] = {.count = 1, .reusable = false}, SHIFT(1484),
  [3507] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3509] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3511] = {.count = 1, .reusable = false}, SHIFT(1487),
  [3513] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3515] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3517] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3519] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3521] = {.count = 1, .reusable = false}, SHIFT(1490),
  [3523] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3525] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3527] = {.count = 1, .reusable = false}, SHIFT(1493),
  [3529] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3531] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3533] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3535] = {.count = 1, .reusable = true}, SHIFT(1495),
  [3537] = {.count = 1, .reusable = false}, SHIFT(1496),
  [3539] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3541] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3543] = {.count = 1, .reusable = false}, SHIFT(1499),
  [3545] = {.count = 1, .reusable = true}, SHIFT(1498),
  [3547] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3549] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3551] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [3553] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [3555] = {.count = 1, .reusable = false}, SHIFT(615),
  [3557] = {.count = 1, .reusable = false}, SHIFT(1502),
  [3559] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3561] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3565] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3567] = {.count = 1, .reusable = false}, SHIFT(1509),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3571] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3573] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1510),
  [3577] = {.count = 1, .reusable = false}, SHIFT(1512),
  [3579] = {.count = 1, .reusable = true}, SHIFT(1511),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3583] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3585] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [3587] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [3589] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [3591] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3597] = {.count = 1, .reusable = false}, SHIFT(1516),
  [3599] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(984),
  [3602] = {.count = 1, .reusable = false}, SHIFT(1519),
  [3604] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3606] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3608] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3610] = {.count = 1, .reusable = true}, SHIFT(1520),
  [3612] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3614] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3616] = {.count = 1, .reusable = false}, SHIFT(1524),
  [3618] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3620] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3622] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3624] = {.count = 1, .reusable = false}, SHIFT(1530),
  [3626] = {.count = 1, .reusable = true}, SHIFT(1528),
  [3628] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3630] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3632] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [3634] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3636] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [3638] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3640] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [3642] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [3644] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [3646] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [3648] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [3650] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3652] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [3654] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [3656] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3658] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3660] = {.count = 1, .reusable = false}, SHIFT(1540),
  [3662] = {.count = 1, .reusable = false}, SHIFT(1541),
  [3664] = {.count = 1, .reusable = false}, SHIFT(1542),
  [3666] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3668] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3670] = {.count = 1, .reusable = true}, SHIFT(1545),
  [3672] = {.count = 1, .reusable = false}, SHIFT(1546),
  [3674] = {.count = 1, .reusable = false}, SHIFT(1547),
  [3676] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3678] = {.count = 1, .reusable = true}, SHIFT(1549),
  [3680] = {.count = 1, .reusable = false}, SHIFT(1550),
  [3682] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3684] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3686] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [3688] = {.count = 1, .reusable = true}, SHIFT(1553),
  [3690] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3692] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [3694] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3696] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3698] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(132),
  [3701] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(130),
  [3704] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1569),
  [3707] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(133),
  [3710] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(134),
  [3713] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(135),
  [3716] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1029),
  [3719] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(137),
  [3722] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3724] = {.count = 1, .reusable = false}, SHIFT(1573),
  [3726] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3728] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3730] = {.count = 1, .reusable = false}, SHIFT(1576),
  [3732] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3734] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3736] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3738] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [3740] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [3742] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3744] = {.count = 1, .reusable = true}, SHIFT(1580),
  [3746] = {.count = 1, .reusable = false}, SHIFT(1581),
  [3748] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3750] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3752] = {.count = 1, .reusable = false}, SHIFT(1584),
  [3754] = {.count = 1, .reusable = true}, SHIFT(1583),
  [3756] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3758] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3760] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3762] = {.count = 1, .reusable = false}, SHIFT(1587),
  [3764] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1082),
  [3767] = {.count = 1, .reusable = false}, SHIFT(1590),
  [3769] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3771] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1589),
  [3775] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3777] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3779] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3781] = {.count = 1, .reusable = false}, SHIFT(1595),
  [3783] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3785] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3787] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3789] = {.count = 1, .reusable = false}, SHIFT(1601),
  [3791] = {.count = 1, .reusable = true}, SHIFT(1599),
  [3793] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3795] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3797] = {.count = 1, .reusable = false}, SHIFT(771),
  [3799] = {.count = 1, .reusable = false}, SHIFT(770),
  [3801] = {.count = 1, .reusable = false}, SHIFT(415),
  [3803] = {.count = 1, .reusable = false}, SHIFT(1603),
  [3805] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3807] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3811] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3813] = {.count = 1, .reusable = false}, SHIFT(1610),
  [3815] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3817] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3819] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3823] = {.count = 1, .reusable = false}, SHIFT(1613),
  [3825] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3827] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3829] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [3831] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [3833] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3835] = {.count = 1, .reusable = false}, SHIFT(1615),
  [3837] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3839] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3841] = {.count = 1, .reusable = false}, SHIFT(1618),
  [3843] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3845] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3847] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3849] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3851] = {.count = 1, .reusable = false}, SHIFT(1621),
  [3853] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1139),
  [3856] = {.count = 1, .reusable = false}, SHIFT(1624),
  [3858] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3860] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3862] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3864] = {.count = 1, .reusable = true}, SHIFT(1625),
  [3866] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3868] = {.count = 1, .reusable = true}, SHIFT(1627),
  [3870] = {.count = 1, .reusable = false}, SHIFT(1629),
  [3872] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3874] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3876] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3878] = {.count = 1, .reusable = false}, SHIFT(1635),
  [3880] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3882] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3884] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3886] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [3888] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [3890] = {.count = 1, .reusable = false}, SHIFT(822),
  [3892] = {.count = 1, .reusable = false}, SHIFT(821),
  [3894] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 6),
  [3896] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 6),
  [3898] = {.count = 1, .reusable = true}, SHIFT(1637),
  [3900] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3902] = {.count = 1, .reusable = false}, SHIFT(1640),
  [3904] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3906] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3908] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3910] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3912] = {.count = 1, .reusable = false}, SHIFT(1647),
  [3914] = {.count = 1, .reusable = true}, SHIFT(1645),
  [3916] = {.count = 1, .reusable = true}, SHIFT(1647),
  [3918] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3920] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3922] = {.count = 1, .reusable = false}, SHIFT(1650),
  [3924] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3926] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3928] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3930] = {.count = 1, .reusable = false}, SHIFT(1653),
  [3932] = {.count = 1, .reusable = true}, SHIFT(1653),
  [3934] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3936] = {.count = 1, .reusable = false}, SHIFT(1656),
  [3938] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3940] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3942] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3944] = {.count = 1, .reusable = false}, SHIFT(871),
  [3946] = {.count = 1, .reusable = false}, SHIFT(870),
  [3948] = {.count = 1, .reusable = false}, SHIFT(493),
  [3950] = {.count = 1, .reusable = false}, SHIFT(1659),
  [3952] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3954] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3956] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3958] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3960] = {.count = 1, .reusable = false}, SHIFT(1666),
  [3962] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3964] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3966] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3968] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3970] = {.count = 1, .reusable = false}, SHIFT(1669),
  [3972] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3974] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3976] = {.count = 1, .reusable = false}, SHIFT(1672),
  [3978] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3980] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3982] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3984] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3986] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3988] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3990] = {.count = 1, .reusable = false}, SHIFT(1677),
  [3992] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3994] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3996] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3998] = {.count = 1, .reusable = false}, SHIFT(1683),
  [4000] = {.count = 1, .reusable = true}, SHIFT(1681),
  [4002] = {.count = 1, .reusable = true}, SHIFT(1683),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1682),
  [4006] = {.count = 1, .reusable = true}, SHIFT(1684),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1685),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1686),
  [4012] = {.count = 1, .reusable = true}, SHIFT(1687),
  [4014] = {.count = 1, .reusable = true}, SHIFT(1688),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1689),
  [4018] = {.count = 1, .reusable = true}, SHIFT(1690),
  [4020] = {.count = 1, .reusable = false}, SHIFT(1691),
  [4022] = {.count = 1, .reusable = true}, SHIFT(1691),
  [4024] = {.count = 1, .reusable = true}, SHIFT(1692),
  [4026] = {.count = 1, .reusable = false}, SHIFT(1694),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1693),
  [4030] = {.count = 1, .reusable = true}, SHIFT(1694),
  [4032] = {.count = 1, .reusable = true}, SHIFT(1695),
  [4034] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7),
  [4036] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7),
  [4038] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [4040] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [4042] = {.count = 1, .reusable = false}, SHIFT(1697),
  [4044] = {.count = 1, .reusable = true}, SHIFT(1696),
  [4046] = {.count = 1, .reusable = true}, SHIFT(1697),
  [4048] = {.count = 1, .reusable = true}, SHIFT(1698),
  [4050] = {.count = 1, .reusable = true}, SHIFT(1699),
  [4052] = {.count = 1, .reusable = false}, SHIFT(1704),
  [4054] = {.count = 1, .reusable = true}, SHIFT(1702),
  [4056] = {.count = 1, .reusable = true}, SHIFT(1704),
  [4058] = {.count = 1, .reusable = true}, SHIFT(1703),
  [4060] = {.count = 1, .reusable = true}, SHIFT(1705),
  [4062] = {.count = 1, .reusable = false}, SHIFT(1707),
  [4064] = {.count = 1, .reusable = true}, SHIFT(1706),
  [4066] = {.count = 1, .reusable = true}, SHIFT(1707),
  [4068] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [4070] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [4072] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4),
  [4074] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [4076] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [4078] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7),
  [4080] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7),
  [4082] = {.count = 1, .reusable = true}, SHIFT(1708),
  [4084] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [4086] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 2),
  [4088] = {.count = 1, .reusable = false}, SHIFT(1714),
  [4090] = {.count = 1, .reusable = false}, SHIFT(1712),
  [4092] = {.count = 1, .reusable = false}, SHIFT(1715),
  [4094] = {.count = 1, .reusable = false}, SHIFT(1719),
  [4096] = {.count = 1, .reusable = false}, SHIFT(1717),
  [4098] = {.count = 1, .reusable = false}, SHIFT(1711),
  [4100] = {.count = 1, .reusable = false}, SHIFT(1716),
  [4102] = {.count = 1, .reusable = false}, SHIFT(1709),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1713),
  [4106] = {.count = 1, .reusable = false}, SHIFT(1710),
  [4108] = {.count = 1, .reusable = false}, SHIFT(1725),
  [4110] = {.count = 1, .reusable = false}, SHIFT(1724),
  [4112] = {.count = 1, .reusable = false}, SHIFT(1726),
  [4114] = {.count = 1, .reusable = false}, SHIFT(1730),
  [4116] = {.count = 1, .reusable = false}, SHIFT(1728),
  [4118] = {.count = 1, .reusable = false}, SHIFT(1723),
  [4120] = {.count = 1, .reusable = false}, SHIFT(1727),
  [4122] = {.count = 1, .reusable = false}, SHIFT(1721),
  [4124] = {.count = 1, .reusable = false}, SHIFT(1722),
  [4126] = {.count = 1, .reusable = true}, SHIFT(1731),
  [4128] = {.count = 1, .reusable = true}, SHIFT(1732),
  [4130] = {.count = 1, .reusable = true}, SHIFT(1733),
  [4132] = {.count = 1, .reusable = false}, SHIFT(1731),
  [4134] = {.count = 1, .reusable = true}, SHIFT(1737),
  [4136] = {.count = 1, .reusable = true}, SHIFT(1738),
  [4138] = {.count = 1, .reusable = true}, SHIFT(1739),
  [4140] = {.count = 1, .reusable = true}, SHIFT(1740),
  [4142] = {.count = 1, .reusable = false}, SHIFT(1737),
  [4144] = {.count = 1, .reusable = true}, SHIFT(1741),
  [4146] = {.count = 1, .reusable = true}, SHIFT(1744),
  [4148] = {.count = 1, .reusable = false}, SHIFT(1745),
  [4150] = {.count = 1, .reusable = true}, SHIFT(1746),
  [4152] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [4154] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [4156] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [4158] = {.count = 1, .reusable = false}, SHIFT(1748),
  [4160] = {.count = 1, .reusable = false}, SHIFT(1751),
  [4162] = {.count = 1, .reusable = true}, SHIFT(1752),
  [4164] = {.count = 1, .reusable = false}, SHIFT(1753),
  [4166] = {.count = 1, .reusable = true}, SHIFT(1754),
  [4168] = {.count = 1, .reusable = false}, SHIFT(1755),
  [4170] = {.count = 1, .reusable = false}, SHIFT(1756),
  [4172] = {.count = 1, .reusable = false}, SHIFT(1750),
  [4174] = {.count = 1, .reusable = true}, SHIFT(1547),
  [4176] = {.count = 1, .reusable = true}, SHIFT(1761),
  [4178] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3),
  [4180] = {.count = 1, .reusable = false}, SHIFT(1543),
  [4182] = {.count = 1, .reusable = false}, SHIFT(1544),
  [4184] = {.count = 1, .reusable = false}, SHIFT(1545),
  [4186] = {.count = 1, .reusable = false}, SHIFT(1762),
  [4188] = {.count = 1, .reusable = false}, SHIFT(1763),
  [4190] = {.count = 1, .reusable = false}, SHIFT(1549),
  [4192] = {.count = 1, .reusable = false}, SHIFT(1552),
  [4194] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(1318),
  [4197] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4199] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4201] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [4203] = {.count = 1, .reusable = true}, SHIFT(1767),
  [4205] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [4207] = {.count = 1, .reusable = true}, SHIFT(1769),
  [4209] = {.count = 1, .reusable = true}, SHIFT(1771),
  [4211] = {.count = 1, .reusable = true}, SHIFT(1773),
  [4213] = {.count = 1, .reusable = true}, SHIFT(1774),
  [4215] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [4217] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [4219] = {.count = 1, .reusable = true}, SHIFT(1775),
  [4221] = {.count = 1, .reusable = true}, SHIFT(1776),
  [4223] = {.count = 1, .reusable = true}, SHIFT(1777),
  [4225] = {.count = 1, .reusable = false}, SHIFT(1087),
  [4227] = {.count = 1, .reusable = false}, SHIFT(1779),
  [4229] = {.count = 1, .reusable = true}, SHIFT(1778),
  [4231] = {.count = 1, .reusable = true}, SHIFT(1779),
  [4233] = {.count = 1, .reusable = true}, SHIFT(1780),
  [4235] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4237] = {.count = 1, .reusable = false}, SHIFT(1786),
  [4239] = {.count = 1, .reusable = true}, SHIFT(1784),
  [4241] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4243] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4245] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4247] = {.count = 1, .reusable = false}, SHIFT(1789),
  [4249] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4251] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4253] = {.count = 1, .reusable = true}, SHIFT(1790),
  [4255] = {.count = 1, .reusable = false}, SHIFT(1791),
  [4257] = {.count = 1, .reusable = true}, SHIFT(1791),
  [4259] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4261] = {.count = 1, .reusable = false}, SHIFT(1794),
  [4263] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4265] = {.count = 1, .reusable = true}, SHIFT(1794),
  [4267] = {.count = 1, .reusable = true}, SHIFT(1795),
  [4269] = {.count = 1, .reusable = true}, SHIFT(1796),
  [4271] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4273] = {.count = 1, .reusable = false}, SHIFT(1143),
  [4275] = {.count = 1, .reusable = false}, SHIFT(1144),
  [4277] = {.count = 1, .reusable = false}, SHIFT(1799),
  [4279] = {.count = 1, .reusable = true}, SHIFT(1798),
  [4281] = {.count = 1, .reusable = true}, SHIFT(1799),
  [4283] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4285] = {.count = 1, .reusable = true}, SHIFT(1801),
  [4287] = {.count = 1, .reusable = false}, SHIFT(1806),
  [4289] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4291] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4293] = {.count = 1, .reusable = true}, SHIFT(1805),
  [4295] = {.count = 1, .reusable = true}, SHIFT(1807),
  [4297] = {.count = 1, .reusable = false}, SHIFT(1809),
  [4299] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4301] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4303] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 7),
  [4305] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 7),
  [4307] = {.count = 1, .reusable = true}, SHIFT(1811),
  [4309] = {.count = 1, .reusable = true}, SHIFT(1812),
  [4311] = {.count = 1, .reusable = false}, SHIFT(1813),
  [4313] = {.count = 1, .reusable = true}, SHIFT(1813),
  [4315] = {.count = 1, .reusable = true}, SHIFT(1814),
  [4317] = {.count = 1, .reusable = false}, SHIFT(1816),
  [4319] = {.count = 1, .reusable = true}, SHIFT(1815),
  [4321] = {.count = 1, .reusable = true}, SHIFT(1816),
  [4323] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4325] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4327] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4329] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4331] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4333] = {.count = 1, .reusable = false}, SHIFT(1822),
  [4335] = {.count = 1, .reusable = true}, SHIFT(1822),
  [4337] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4339] = {.count = 1, .reusable = false}, SHIFT(1825),
  [4341] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4343] = {.count = 1, .reusable = true}, SHIFT(1825),
  [4345] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4347] = {.count = 1, .reusable = false}, SHIFT(1828),
  [4349] = {.count = 1, .reusable = true}, SHIFT(1827),
  [4351] = {.count = 1, .reusable = true}, SHIFT(1828),
  [4353] = {.count = 1, .reusable = true}, SHIFT(1829),
  [4355] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4357] = {.count = 1, .reusable = false}, SHIFT(1835),
  [4359] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4361] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4363] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4365] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4367] = {.count = 1, .reusable = false}, SHIFT(1838),
  [4369] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4371] = {.count = 1, .reusable = true}, SHIFT(1838),
  [4373] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4375] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4377] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4379] = {.count = 1, .reusable = false}, SHIFT(1842),
  [4381] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4383] = {.count = 1, .reusable = true}, SHIFT(1843),
  [4385] = {.count = 1, .reusable = false}, SHIFT(1845),
  [4387] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4389] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4391] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4393] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8),
  [4395] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8),
  [4397] = {.count = 1, .reusable = false}, SHIFT(1848),
  [4399] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4401] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4403] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4405] = {.count = 1, .reusable = true}, SHIFT(1710),
  [4407] = {.count = 1, .reusable = true}, SHIFT(1855),
  [4409] = {.count = 1, .reusable = true}, SHIFT(1856),
  [4411] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4413] = {.count = 1, .reusable = false}, SHIFT(1855),
  [4415] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4417] = {.count = 1, .reusable = true}, SHIFT(1861),
  [4419] = {.count = 1, .reusable = true}, SHIFT(1862),
  [4421] = {.count = 1, .reusable = true}, SHIFT(1863),
  [4423] = {.count = 1, .reusable = false}, SHIFT(1860),
  [4425] = {.count = 1, .reusable = false}, SHIFT(1864),
  [4427] = {.count = 1, .reusable = false}, SHIFT(1866),
  [4429] = {.count = 1, .reusable = false}, SHIFT(1868),
  [4431] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4433] = {.count = 1, .reusable = true}, SHIFT(1871),
  [4435] = {.count = 1, .reusable = true}, SHIFT(1722),
  [4437] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4439] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4441] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4443] = {.count = 1, .reusable = false}, SHIFT(1874),
  [4445] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4447] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4449] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4451] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4453] = {.count = 1, .reusable = false}, SHIFT(1879),
  [4455] = {.count = 1, .reusable = false}, SHIFT(1883),
  [4457] = {.count = 1, .reusable = false}, SHIFT(1885),
  [4459] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4461] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4463] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4465] = {.count = 1, .reusable = false}, SHIFT(1890),
  [4467] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4469] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4471] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4473] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4475] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4477] = {.count = 1, .reusable = false}, SHIFT(1891),
  [4479] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4481] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4483] = {.count = 1, .reusable = false}, SHIFT(1897),
  [4485] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4487] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4489] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4491] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4493] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4495] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4497] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4499] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4501] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4503] = {.count = 1, .reusable = false}, SHIFT(1906),
  [4505] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4507] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4509] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4511] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4513] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4515] = {.count = 1, .reusable = false}, SHIFT(1913),
  [4517] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1748),
  [4520] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4522] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4524] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4526] = {.count = 1, .reusable = false}, SHIFT(1920),
  [4528] = {.count = 1, .reusable = true}, SHIFT(1923),
  [4530] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4532] = {.count = 1, .reusable = false}, SHIFT(1926),
  [4534] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [4536] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [4538] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [4540] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4542] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4544] = {.count = 1, .reusable = true}, SHIFT(1933),
  [4546] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4),
  [4548] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [4550] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [4552] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [4554] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4556] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [4558] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4560] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4562] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4564] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4566] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [4568] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [4570] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4572] = {.count = 1, .reusable = false}, SHIFT(1945),
  [4574] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4576] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4578] = {.count = 1, .reusable = false}, SHIFT(1948),
  [4580] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4582] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4584] = {.count = 1, .reusable = true}, SHIFT(1949),
  [4586] = {.count = 1, .reusable = true}, SHIFT(1950),
  [4588] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4590] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4592] = {.count = 1, .reusable = false}, SHIFT(1953),
  [4594] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4596] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4598] = {.count = 1, .reusable = false}, SHIFT(1956),
  [4600] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4602] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4604] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4606] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 8),
  [4608] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 8),
  [4610] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4612] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4614] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4616] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4618] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4620] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4622] = {.count = 1, .reusable = false}, SHIFT(1965),
  [4624] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4626] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4628] = {.count = 1, .reusable = false}, SHIFT(1968),
  [4630] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4632] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4634] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4636] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4638] = {.count = 1, .reusable = true}, SHIFT(1971),
  [4640] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4642] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4644] = {.count = 1, .reusable = false}, SHIFT(1974),
  [4646] = {.count = 1, .reusable = true}, SHIFT(1709),
  [4648] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4650] = {.count = 1, .reusable = true}, SHIFT(1712),
  [4652] = {.count = 1, .reusable = true}, SHIFT(1715),
  [4654] = {.count = 1, .reusable = true}, SHIFT(1717),
  [4656] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4658] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4660] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4662] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4664] = {.count = 1, .reusable = true}, SHIFT(1716),
  [4666] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4668] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4670] = {.count = 1, .reusable = false}, SHIFT(1985),
  [4672] = {.count = 1, .reusable = true}, SHIFT(1984),
  [4674] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4676] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4678] = {.count = 1, .reusable = true}, SHIFT(1987),
  [4680] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4682] = {.count = 1, .reusable = false}, SHIFT(1986),
  [4684] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4686] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4688] = {.count = 1, .reusable = false}, SHIFT(1992),
  [4690] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4692] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4694] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1864),
  [4697] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1714),
  [4700] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1712),
  [4703] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1715),
  [4706] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1866),
  [4709] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1717),
  [4712] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1711),
  [4715] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1716),
  [4718] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1709),
  [4721] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1713),
  [4724] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1710),
  [4727] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4729] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4731] = {.count = 1, .reusable = false}, SHIFT(1995),
  [4733] = {.count = 1, .reusable = true}, SHIFT(1721),
  [4735] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4737] = {.count = 1, .reusable = true}, SHIFT(1724),
  [4739] = {.count = 1, .reusable = true}, SHIFT(1726),
  [4741] = {.count = 1, .reusable = true}, SHIFT(1728),
  [4743] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4745] = {.count = 1, .reusable = true}, SHIFT(1999),
  [4747] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4749] = {.count = 1, .reusable = false}, SHIFT(2002),
  [4751] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4753] = {.count = 1, .reusable = true}, SHIFT(2002),
  [4755] = {.count = 1, .reusable = true}, SHIFT(2003),
  [4757] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4759] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4761] = {.count = 1, .reusable = false}, SHIFT(2003),
  [4763] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4765] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4767] = {.count = 1, .reusable = false}, SHIFT(2009),
  [4769] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4771] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4773] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1883),
  [4776] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1725),
  [4779] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1724),
  [4782] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1726),
  [4785] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1885),
  [4788] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1728),
  [4791] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1723),
  [4794] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1727),
  [4797] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1721),
  [4800] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1722),
  [4803] = {.count = 1, .reusable = false}, SHIFT(2012),
  [4805] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4807] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4809] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4811] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4813] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4815] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4817] = {.count = 1, .reusable = false}, SHIFT(2017),
  [4819] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4821] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4823] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4825] = {.count = 1, .reusable = false}, SHIFT(2023),
  [4827] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4829] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4831] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4833] = {.count = 1, .reusable = false}, SHIFT(2024),
  [4835] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1741),
  [4838] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4840] = {.count = 1, .reusable = false}, SHIFT(2028),
  [4842] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4844] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4846] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4848] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4850] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4852] = {.count = 1, .reusable = false}, SHIFT(2034),
  [4854] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4856] = {.count = 1, .reusable = true}, SHIFT(2040),
  [4858] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4860] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4862] = {.count = 1, .reusable = false}, SHIFT(2039),
  [4864] = {.count = 1, .reusable = false}, SHIFT(2043),
  [4866] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4868] = {.count = 1, .reusable = false}, SHIFT(2048),
  [4870] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4872] = {.count = 1, .reusable = true}, SHIFT(2049),
  [4874] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1751),
  [4877] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1754),
  [4880] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1756),
  [4883] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1542),
  [4886] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1543),
  [4889] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1544),
  [4892] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1545),
  [4895] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1762),
  [4898] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1763),
  [4901] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1547),
  [4904] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1549),
  [4907] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1552),
  [4910] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [4912] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [4914] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [4916] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [4918] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [4920] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [4922] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4924] = {.count = 1, .reusable = false}, SHIFT(2053),
  [4926] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4928] = {.count = 1, .reusable = true}, SHIFT(2058),
  [4930] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4932] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4934] = {.count = 1, .reusable = true}, SHIFT(2062),
  [4936] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4938] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 9),
  [4940] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 9),
  [4942] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4944] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4946] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4948] = {.count = 1, .reusable = false}, SHIFT(2068),
  [4950] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1851),
  [4953] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4955] = {.count = 1, .reusable = false}, SHIFT(2073),
  [4957] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4959] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4961] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4963] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4965] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4967] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4969] = {.count = 1, .reusable = false}, SHIFT(2078),
  [4971] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4973] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4975] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4977] = {.count = 1, .reusable = false}, SHIFT(2084),
  [4979] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4981] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4983] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4985] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4987] = {.count = 1, .reusable = false}, SHIFT(2086),
  [4989] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1871),
  [4992] = {.count = 1, .reusable = false}, SHIFT(2089),
  [4994] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4996] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4998] = {.count = 1, .reusable = true}, SHIFT(2088),
  [5000] = {.count = 1, .reusable = true}, SHIFT(2090),
  [5002] = {.count = 1, .reusable = true}, SHIFT(2091),
  [5004] = {.count = 1, .reusable = true}, SHIFT(2092),
  [5006] = {.count = 1, .reusable = false}, SHIFT(2094),
  [5008] = {.count = 1, .reusable = true}, SHIFT(2093),
  [5010] = {.count = 1, .reusable = true}, SHIFT(2094),
  [5012] = {.count = 1, .reusable = true}, SHIFT(2095),
  [5014] = {.count = 1, .reusable = false}, SHIFT(2100),
  [5016] = {.count = 1, .reusable = true}, SHIFT(2098),
  [5018] = {.count = 1, .reusable = true}, SHIFT(2100),
  [5020] = {.count = 1, .reusable = true}, SHIFT(2099),
  [5022] = {.count = 1, .reusable = false}, SHIFT(2102),
  [5024] = {.count = 1, .reusable = true}, SHIFT(2101),
  [5026] = {.count = 1, .reusable = true}, SHIFT(2102),
  [5028] = {.count = 1, .reusable = true}, SHIFT(2103),
  [5030] = {.count = 1, .reusable = true}, SHIFT(2104),
  [5032] = {.count = 1, .reusable = false}, SHIFT(2109),
  [5034] = {.count = 1, .reusable = true}, SHIFT(2107),
  [5036] = {.count = 1, .reusable = true}, SHIFT(2109),
  [5038] = {.count = 1, .reusable = true}, SHIFT(2108),
  [5040] = {.count = 1, .reusable = true}, SHIFT(2110),
  [5042] = {.count = 1, .reusable = false}, SHIFT(2112),
  [5044] = {.count = 1, .reusable = true}, SHIFT(2111),
  [5046] = {.count = 1, .reusable = true}, SHIFT(2112),
  [5048] = {.count = 1, .reusable = false}, SHIFT(1733),
  [5050] = {.count = 1, .reusable = false}, SHIFT(1732),
  [5052] = {.count = 1, .reusable = true}, SHIFT(2113),
  [5054] = {.count = 1, .reusable = true}, SHIFT(2114),
  [5056] = {.count = 1, .reusable = true}, SHIFT(2115),
  [5058] = {.count = 1, .reusable = false}, SHIFT(2116),
  [5060] = {.count = 1, .reusable = true}, SHIFT(2117),
  [5062] = {.count = 1, .reusable = true}, SHIFT(2118),
  [5064] = {.count = 1, .reusable = true}, SHIFT(2120),
  [5066] = {.count = 1, .reusable = true}, SHIFT(2121),
  [5068] = {.count = 1, .reusable = false}, SHIFT(2123),
  [5070] = {.count = 1, .reusable = true}, SHIFT(2122),
  [5072] = {.count = 1, .reusable = true}, SHIFT(2123),
  [5074] = {.count = 1, .reusable = true}, SHIFT(2124),
  [5076] = {.count = 1, .reusable = true}, SHIFT(2125),
  [5078] = {.count = 1, .reusable = true}, SHIFT(2126),
  [5080] = {.count = 1, .reusable = false}, SHIFT(2124),
  [5082] = {.count = 1, .reusable = true}, SHIFT(2127),
  [5084] = {.count = 1, .reusable = true}, SHIFT(2128),
  [5086] = {.count = 1, .reusable = false}, SHIFT(2130),
  [5088] = {.count = 1, .reusable = true}, SHIFT(2129),
  [5090] = {.count = 1, .reusable = true}, SHIFT(2130),
  [5092] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2043),
  [5095] = {.count = 1, .reusable = true}, SHIFT(2131),
  [5097] = {.count = 1, .reusable = false}, SHIFT(2133),
  [5099] = {.count = 1, .reusable = true}, SHIFT(2133),
  [5101] = {.count = 1, .reusable = true}, SHIFT(2136),
  [5103] = {.count = 1, .reusable = false}, SHIFT(2135),
  [5105] = {.count = 1, .reusable = true}, SHIFT(2137),
  [5107] = {.count = 1, .reusable = true}, SHIFT(2138),
  [5109] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 10),
  [5111] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 10),
  [5113] = {.count = 1, .reusable = false}, SHIFT(1857),
  [5115] = {.count = 1, .reusable = false}, SHIFT(1856),
  [5117] = {.count = 1, .reusable = true}, SHIFT(2139),
  [5119] = {.count = 1, .reusable = false}, SHIFT(2141),
  [5121] = {.count = 1, .reusable = true}, SHIFT(2140),
  [5123] = {.count = 1, .reusable = true}, SHIFT(2141),
  [5125] = {.count = 1, .reusable = true}, SHIFT(2142),
  [5127] = {.count = 1, .reusable = true}, SHIFT(2143),
  [5129] = {.count = 1, .reusable = false}, SHIFT(2148),
  [5131] = {.count = 1, .reusable = true}, SHIFT(2146),
  [5133] = {.count = 1, .reusable = true}, SHIFT(2148),
  [5135] = {.count = 1, .reusable = true}, SHIFT(2147),
  [5137] = {.count = 1, .reusable = true}, SHIFT(2149),
  [5139] = {.count = 1, .reusable = false}, SHIFT(2151),
  [5141] = {.count = 1, .reusable = true}, SHIFT(2150),
  [5143] = {.count = 1, .reusable = true}, SHIFT(2151),
  [5145] = {.count = 1, .reusable = false}, SHIFT(1876),
  [5147] = {.count = 1, .reusable = false}, SHIFT(1875),
  [5149] = {.count = 1, .reusable = false}, SHIFT(2153),
  [5151] = {.count = 1, .reusable = true}, SHIFT(2152),
  [5153] = {.count = 1, .reusable = true}, SHIFT(2153),
  [5155] = {.count = 1, .reusable = true}, SHIFT(2154),
  [5157] = {.count = 1, .reusable = true}, SHIFT(2155),
  [5159] = {.count = 1, .reusable = false}, SHIFT(2160),
  [5161] = {.count = 1, .reusable = true}, SHIFT(2158),
  [5163] = {.count = 1, .reusable = true}, SHIFT(2160),
  [5165] = {.count = 1, .reusable = true}, SHIFT(2159),
  [5167] = {.count = 1, .reusable = true}, SHIFT(2161),
  [5169] = {.count = 1, .reusable = false}, SHIFT(2163),
  [5171] = {.count = 1, .reusable = true}, SHIFT(2162),
  [5173] = {.count = 1, .reusable = true}, SHIFT(2163),
  [5175] = {.count = 1, .reusable = true}, SHIFT(2164),
  [5177] = {.count = 1, .reusable = false}, SHIFT(2165),
  [5179] = {.count = 1, .reusable = true}, SHIFT(2165),
  [5181] = {.count = 1, .reusable = true}, SHIFT(2166),
  [5183] = {.count = 1, .reusable = false}, SHIFT(2168),
  [5185] = {.count = 1, .reusable = true}, SHIFT(2167),
  [5187] = {.count = 1, .reusable = true}, SHIFT(2168),
  [5189] = {.count = 1, .reusable = true}, SHIFT(2169),
  [5191] = {.count = 1, .reusable = true}, SHIFT(2170),
  [5193] = {.count = 1, .reusable = false}, SHIFT(2171),
  [5195] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2031),
  [5198] = {.count = 1, .reusable = false}, SHIFT(2174),
  [5200] = {.count = 1, .reusable = true}, SHIFT(2172),
  [5202] = {.count = 1, .reusable = true}, SHIFT(2174),
  [5204] = {.count = 1, .reusable = true}, SHIFT(2173),
  [5206] = {.count = 1, .reusable = true}, SHIFT(2175),
  [5208] = {.count = 1, .reusable = true}, SHIFT(2176),
  [5210] = {.count = 1, .reusable = true}, SHIFT(2177),
  [5212] = {.count = 1, .reusable = false}, SHIFT(2179),
  [5214] = {.count = 1, .reusable = true}, SHIFT(2178),
  [5216] = {.count = 1, .reusable = true}, SHIFT(2179),
  [5218] = {.count = 1, .reusable = true}, SHIFT(2180),
  [5220] = {.count = 1, .reusable = false}, SHIFT(2185),
  [5222] = {.count = 1, .reusable = true}, SHIFT(2183),
  [5224] = {.count = 1, .reusable = true}, SHIFT(2185),
  [5226] = {.count = 1, .reusable = true}, SHIFT(2184),
  [5228] = {.count = 1, .reusable = false}, SHIFT(2186),
  [5230] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 5),
  [5232] = {.count = 1, .reusable = true}, SHIFT(2187),
  [5234] = {.count = 1, .reusable = false}, SHIFT(2187),
  [5236] = {.count = 1, .reusable = true}, SHIFT(2189),
  [5238] = {.count = 1, .reusable = false}, SHIFT(2190),
  [5240] = {.count = 1, .reusable = true}, SHIFT(2190),
  [5242] = {.count = 1, .reusable = true}, SHIFT(2191),
  [5244] = {.count = 1, .reusable = false}, SHIFT(2193),
  [5246] = {.count = 1, .reusable = true}, SHIFT(2192),
  [5248] = {.count = 1, .reusable = true}, SHIFT(2193),
  [5250] = {.count = 1, .reusable = true}, SHIFT(2194),
  [5252] = {.count = 1, .reusable = true}, SHIFT(2195),
  [5254] = {.count = 1, .reusable = false}, SHIFT(2196),
  [5256] = {.count = 1, .reusable = true}, SHIFT(2196),
  [5258] = {.count = 1, .reusable = true}, SHIFT(2197),
  [5260] = {.count = 1, .reusable = false}, SHIFT(2199),
  [5262] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5264] = {.count = 1, .reusable = true}, SHIFT(2199),
  [5266] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5268] = {.count = 1, .reusable = true}, SHIFT(2201),
  [5270] = {.count = 1, .reusable = true}, SHIFT(2202),
  [5272] = {.count = 1, .reusable = false}, SHIFT(2036),
  [5274] = {.count = 1, .reusable = false}, SHIFT(2035),
  [5276] = {.count = 1, .reusable = false}, SHIFT(1903),
  [5278] = {.count = 1, .reusable = false}, SHIFT(2204),
  [5280] = {.count = 1, .reusable = true}, SHIFT(2203),
  [5282] = {.count = 1, .reusable = true}, SHIFT(2204),
  [5284] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5286] = {.count = 1, .reusable = true}, SHIFT(2206),
  [5288] = {.count = 1, .reusable = false}, SHIFT(2211),
  [5290] = {.count = 1, .reusable = true}, SHIFT(2209),
  [5292] = {.count = 1, .reusable = true}, SHIFT(2211),
  [5294] = {.count = 1, .reusable = true}, SHIFT(2210),
  [5296] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5298] = {.count = 1, .reusable = false}, SHIFT(2214),
  [5300] = {.count = 1, .reusable = true}, SHIFT(2213),
  [5302] = {.count = 1, .reusable = true}, SHIFT(2214),
  [5304] = {.count = 1, .reusable = true}, SHIFT(2215),
  [5306] = {.count = 1, .reusable = false}, SHIFT(2215),
  [5308] = {.count = 1, .reusable = true}, SHIFT(2216),
  [5310] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5312] = {.count = 1, .reusable = true}, SHIFT(2218),
  [5314] = {.count = 1, .reusable = true}, SHIFT(2219),
  [5316] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5318] = {.count = 1, .reusable = false}, SHIFT(2221),
  [5320] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5322] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5324] = {.count = 1, .reusable = false}, SHIFT(2224),
  [5326] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5328] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5330] = {.count = 1, .reusable = true}, SHIFT(2225),
  [5332] = {.count = 1, .reusable = true}, SHIFT(2226),
  [5334] = {.count = 1, .reusable = true}, SHIFT(2227),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_word,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
